<?php

header('Content-Type: application/json');

include('../../php/conn.php');

// Actualizando zona horaria del servidor
  $q_timezone = "SET TIME_ZONE = 'America/Lima'";

  if ($res = mysqli_query($enlace, $q_timezone)) {
  }

  date_default_timezone_set('America/Lima');

// Permite obtener el nombde de casa mes
  function nombre_meses($num_mes){
    if ($num_mes == 1){
      return "ENERO";
    }
    if ($num_mes == 2){
      return "FEBRERO";
    }
    if ($num_mes == 3){
      return "MARZO";
    }
    if ($num_mes == 4){
      return "ABRIL";
    }
    if ($num_mes == 5){
      return "MAYO";
    }
    if ($num_mes == 6){
      return "JUNIO";
    }
    if ($num_mes == 7){
      return "JULIO";
    }
    if ($num_mes == 8){
      return "AGOSTO";
    }
    if ($num_mes == 9){
      return "SEPTIEMBRE";
    }
    if ($num_mes == 10){
      return "OCTUBRE";
    }
    if ($num_mes == 11){
      return "NOVIEMBRE";
    }
    if ($num_mes == 12){
      return "DICIEMBRE";
    }
  }

// Inicia el proceso condicional
  switch ($_GET["accion"]) {
    case 'get_ListaRacks':
      $r = array();
      $estado = 0;

      $fecha_inicio = $_GET["Fecha_Inicio"];
      $fecha_fin = $_GET["Fecha_Fin"];

      $q_Racks = "SELECT 0 AS ITEM,
                         CR.nom_rack,
                         CR.des_rack,
                         CR.fecha_rack,
                         CR.usuario_rack,
                         CR.Id,
                         (SELECT COUNT(DRP.Id) AS NUM_MUESTRAS
                            FROM  Detalle_Rack_Pesos DRP 
                           WHERE  DRP.Id_Detalle_Rack IN (SELECT Id
                                                            FROM Detalle_Rack
                                                           WHERE Id_Rack = CR.Id)) AS NUM_MUESTRAS,
                         CR.id_horno,
                         H.cod_horno,
                         H.capacidad_horno,
                         GS.observacion_confirmacion,
                         CR.solicitud_cierre
                    FROM Cabecera_Rack CR
                         INNER JOIN tbconfig_Hornos H ON CR.id_horno = H.Id
                         LEFT JOIN Gestion_Solicitudes GS ON CR.Id = GS.Id_Registro
                           AND GS.Id_Solicitud = 1
                   WHERE DATE(CR.fecha_rack) BETWEEN '".$fecha_inicio."' AND '".$fecha_fin."'
                  ORDER BY CR.fecha_rack DESC";

      if ($res_Racks = mysqli_query($enlace, $q_Racks)) {
        if (mysqli_num_rows($res_Racks) > 0) {
          while($row_Racks = mysqli_fetch_assoc($res_Racks)) {
            array_push($r, $row_Racks);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'guardar_Racks':
      $r = array();
      $estado = 0;

      $estado = $_GET["Estado"];
      $id_rack = $_GET["Id_Rack"];
      $nom_rack = $_GET["Nom_Rack"];
      $id_horno = $_GET["Id_Horno"];
      $des_rack = $_GET["Des_Rack"];
      $usuario_rack = $_GET["Usuario_Rack"];

      if ($estado == 'N'){
        $q_save = "INSERT INTO Cabecera_Rack(nom_rack, des_rack, id_horno, usuario_rack) VALUES(";
        $q_save .= "'".$nom_rack."', ";
        $q_save .= "'".$des_rack."', ";
        $q_save .= $id_horno.", ";
        $q_save .= "'".$usuario_rack."')";
      }

      if ($estado == 'M'){
        $q_save = "UPDATE  Cabecera_Rack SET ";
        $q_save .= "       nom_rack = '".$nom_rack."', ";
        $q_save .= "       des_rack = '".$des_rack."', ";
        $q_save .= "       id_horno = ".$id_horno;
        $q_save .= " WHERE Id = ".$id_rack;
      }

      if ($estado == 'E'){
        $q_save = "DELETE FROM Cabecera_Rack";
        $q_save .= " WHERE Id = ".$id_rack;
      }

      if ($res = mysqli_query($enlace, $q_save)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_ListaTipoBlancoFundente':
      $r = array();
      $estado = 0;

      $q_TipoBlanco = "SELECT Id,
                              nom_tipoblanco
                         FROM tbconfig_RackTipoBlancoFundente
                        WHERE estado_tipoblanco = 'A'";

      if ($res_TipoBlanco = mysqli_query($enlace, $q_TipoBlanco)) {
        if (mysqli_num_rows($res_TipoBlanco) > 0) {
          while($row_TipoBlanco = mysqli_fetch_assoc($res_TipoBlanco)) {
            array_push($r, $row_TipoBlanco);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaTipoBlancoFundente_Newmont':
      $r = array();
      $estado = 0;

      $nom_muestra = $_GET["nom_muestra"];

      // Averigua si hay un un Tipo de blanco registrado previamente
        $q_TipoBlancoBefore = "SELECT DR.Id_TipoBlancoFundente AS Id,
                                      TBF.nom_tipoblanco,
                                      DR.Dosificacion,
                                      DR.Dosificacion_Negativo
                                 FROM Detalle_Rack DR
                                      INNER JOIN tbconfig_RackTipoBlancoFundente TBF ON DR.Id_TipoBlancoFundente = TBF.Id
                                WHERE DR.ci_muestra = '".$nom_muestra."'
                               ORDER BY FechaRegistro_Muestra DESC
                               LIMIT 1";

        if ($res_TipoBlancoBefore = mysqli_query($enlace, $q_TipoBlancoBefore)) {
          if (mysqli_num_rows($res_TipoBlancoBefore) > 0) {
            while($row_TipoBlancoBefore = mysqli_fetch_assoc($res_TipoBlancoBefore)) {
              array_push($r, $row_TipoBlancoBefore);
            }

            $estado = 1;
          }

          // SE COMENTÓ DEBIDO A QUE SOLO SE DEBE BUSCAR EL ÚLTIMO GRUPO NEWMONT REGISTRADO - MAX 10/12/2020
          // else{
          //   $q_TipoBlanco = "SELECT Id,
          //                           nom_tipoblanco,
          //                           '' AS Dosificacion,
          //                           '' AS Dosificacion_Negativo
          //                      FROM tbconfig_RackTipoBlancoFundente
          //                     WHERE estado_tipoblanco = 'A'";

          //   if ($res_TipoBlanco = mysqli_query($enlace, $q_TipoBlanco)) {
          //     if (mysqli_num_rows($res_TipoBlanco) > 0) {
          //       while($row_TipoBlanco = mysqli_fetch_assoc($res_TipoBlanco)) {
          //         array_push($r, $row_TipoBlanco);
          //       }

          //       $estado = 1;
          //     }
          //   }
          // }
        }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_RackMuestra':
      $r = array();
      $estado = 0;
      $exists = 0;

      $nom_muestra = $_GET["nom_muestra"];
      $tipo_blanco = $_GET["tipo_blanco"];
      $dosificacion = $_GET["dosificacion"];
      $id_rack = $_GET["id_rack"];
      $usuario_muestra = $_GET["usuario_muestra"];

      // Busca la muestra en las tablas de ventas
        $q_RackMuestra = "SELECT  C.Id_Pedido,
                                  D.Id AS Id_Detalle,
                                  D.Cod_Interno,
                                  D.Nom_Muestra,
                                  LOWER(D.Elemento_Analisis) AS Elemento_Analisis,
                                  TA.Num_Replica,
                                  PV.Id_MedioPago
                            FROM  _max_labperu_DetallePedido D
                                  INNER JOIN _max_labperu_CabeceraPedido C ON D.Id_Pedido = C.Id_Pedido
                                  INNER JOIN _max_labperu_TipoAnalisis TA ON D.Tipo_Analisis = TA.Id
                                  INNER JOIN _max_labperu_PagoVenta PV ON C.Id_Pedido = PV.Id_Pedido
                                  INNER JOIN _max_labperu_MedioPago MP ON PV.Id_MedioPago = MP.Id
                           WHERE  D.Cod_Interno = '".$nom_muestra."'
                             AND  (LOWER(D.Elemento_Analisis) LIKE '%au%'
                             OR  LOWER(D.Elemento_Analisis) LIKE '%ag%')";

      if ($res_RackMuestra = sqlsrv_query($enlacehost, $q_RackMuestra)) {
        while($row_RackMuestra = sqlsrv_fetch_array($res_RackMuestra)) {
          $exists = 1;

          // Verificando si es un Reanálisis
            $is_reanalisis = 0;
            $id_reanalisis = 0;

            $q_reanalisis = "SELECT Id,
                                    tipo_ensayo
                               FROM Gestion_Solicitudes_Reanalisis
                              WHERE is_cargadoennuevorack = 0
                                AND tipo_ensayo <> 99
                                AND nom_muestra = '".$nom_muestra."'";

            if ($res_reanalisis = mysqli_query($enlace, $q_reanalisis)) {
              if (mysqli_num_rows($res_reanalisis) > 0) {
                while($row_reanalisis = mysqli_fetch_assoc($res_reanalisis)) {
                  $is_reanalisis = 1;

                  $id_reanalisis = $row_reanalisis["Id"];
                  $replica_reanalisis = $row_reanalisis["tipo_ensayo"];
                }
              }
              else{
                // Comprobando si es una muestra Newmont
                  $q_newmont = "SELECT  COUNT(Id) AS _EXISTS
                                  FROM  _max_labperu_DetallePedido
                                 WHERE  Cod_Interno = '".$nom_muestra."'
                                   AND  IdProductos_Combo LIKE '%43121%'";

                  if ($res_newmont = sqlsrv_query($enlacehost, $q_newmont)) {
                    while($row_newmont = sqlsrv_fetch_array($res_newmont)) {
                      if ($row_newmont["_EXISTS"] == 1){
                        $estado = 5;

                        echo json_encode(array('estado' => $estado));

                        return;
                      }
                    }
                  }

                // Comprobar que la muestra no exista en otro Rack
                  $q_exists = "SELECT  COUNT(Id) AS _COUNT
                                 FROM  Detalle_Rack
                                WHERE  ci_muestra = '".$nom_muestra."'
                                  AND  is_Reanalisis = 0
                                  AND  Id_Rack <> ".$id_rack;

                  if ($res_exists = mysqli_query($enlace, $q_exists)) {
                    if (mysqli_num_rows($res_exists) > 0) {
                      while($row_exists = mysqli_fetch_assoc($res_exists)) {
                        if ($row_exists["_COUNT"] > 0){
                          $estado = 3;

                          // PERO puede tener un reanálisis en curso (esto debido a que la pantalla de pesos se ceró antes de registrar los pesos)
                            // 1. Verificar que exista en el rack actual
                              $q_actual = "SELECT  Id
                                             FROM  Detalle_Rack
                                            WHERE  ci_muestra = '".$nom_muestra."'
                                              AND  Id_Rack = ".$id_rack;

                              if ($res_actual = mysqli_query($enlace, $q_actual)) {
                                if (mysqli_num_rows($res_actual) > 0) {
                                  while($row_actual = mysqli_fetch_assoc($res_actual)) {
                                    // 2. Busca en la tabla de Renálisis
                                      $q_isreanalisis = "SELECT Id,
                                                                tipo_ensayo
                                                           FROM Gestion_Solicitudes_Reanalisis
                                                          WHERE is_cargadoennuevorack = 1
                                                            AND newid_detalle_rack = ".$row_actual["Id"];

                                      if ($res_isreanalisis = mysqli_query($enlace, $q_isreanalisis)) {
                                        if (mysqli_num_rows($res_isreanalisis) > 0) {
                                          while($row_isreanalisis = mysqli_fetch_assoc($res_isreanalisis)) {
                                            $estado = 0; // Regresando el estado a la normalidad

                                            $is_reanalisis = 1;
                                            $id_reanalisis = $row_isreanalisis["Id"];
                                            $replica_reanalisis = $row_isreanalisis["tipo_ensayo"];
                                          }
                                        }
                                        else{
                                          echo json_encode(array('estado' => $estado));

                                          return;
                                        }
                                      }
                                  }
                                }
                              }
                        }
                      }
                    }
                  }
              }
            }

          // Si no existe en el Rack lo ingresa como nuevo
            $q_exists = "SELECT  COUNT(Id) AS _COUNT
                           FROM  Detalle_Rack
                          WHERE  ci_muestra = '".$nom_muestra."'
                            AND  is_Reanalisis = 0
                            AND  Id_Rack = ".$id_rack;

            if ($res_exists = mysqli_query($enlace, $q_exists)) {
              if (mysqli_num_rows($res_exists) > 0) {
                while ($row_exists = mysqli_fetch_assoc($res_exists)) {
                  if ($row_exists["_COUNT"] == 0){

                    // Grabando los datos en la tabla de Detalle de Rack
                      $q_InsertDetalle = "INSERT INTO Detalle_Rack(Id_Rack, Id_Pedido, Id_Detalle, Rack_TipoMuestra,
                                                                   ci_muestra, nom_muestra, is_Au, is_Ag,
                                                                   Id_TipoBlancoFundente, Dosificacion, Usuario_Muestra, num_replica, Id_MedioPago, is_Reanalisis) VALUES(";
                      $q_InsertDetalle .= $id_rack.", ";
                      $q_InsertDetalle .= $row_RackMuestra["Id_Pedido"].", ";
                      $q_InsertDetalle .= $row_RackMuestra["Id_Detalle"].", 1, ";
                      $q_InsertDetalle .= "'".$row_RackMuestra["Cod_Interno"]."', ";
                      $q_InsertDetalle .= "'".$row_RackMuestra["Nom_Muestra"]."', ";

                      $is_au = 0;
                      $pos = strpos($row_RackMuestra["Elemento_Analisis"], 'au');

                      if ($pos !== false){
                        $is_au = 1;
                      }

                      $is_ag = 0;
                      $pos = strpos($row_RackMuestra["Elemento_Analisis"], 'ag');

                      if ($pos !== false){
                        $is_ag = 1;
                      }

                      $q_InsertDetalle .= $is_au.", ";
                      $q_InsertDetalle .= $is_ag.", ";
                      $q_InsertDetalle .= $tipo_blanco.", ";
                      $q_InsertDetalle .= "'".$dosificacion."', ";
                      $q_InsertDetalle .= "'".$usuario_muestra."', ";
                      $q_InsertDetalle .= (($is_reanalisis == 1) ? $replica_reanalisis : $row_RackMuestra["Num_Replica"]).", ";
                      $q_InsertDetalle .= $row_RackMuestra["Id_MedioPago"].", 0)";

                      if ($res_InsertDetalle = mysqli_query($enlace, $q_InsertDetalle)) {
                        $id_detalle_rack = mysqli_insert_id($enlace);
                      }

                      // Si es creada por reanálisis debe guardar el Id generado
                        $q_updatereanalisis = "UPDATE Gestion_Solicitudes_Reanalisis
                                                  SET is_cargadoennuevorack = 1,
                                                      newid_detalle_rack = ".$id_detalle_rack."
                                                WHERE Id = ".$id_reanalisis;

                        if ($res_updatereanalisis = mysqli_query($enlace, $q_updatereanalisis)) {
                        }
                  }
                  else{
                    // Si la muestra fue registrada previamente y no tiene pesos, puede continuar, porque el sistema pudo caerse. Pero, si ya tiene pesos no debería permitir su registro
                    $q_detalle_rack = "SELECT  Id
                                         FROM  Detalle_Rack
                                        WHERE  ci_muestra = '".$nom_muestra."'
                                          AND  is_Reanalisis = 0
                                          AND  Id_Rack = ".$id_rack."
                                          AND  (SELECT COUNT(DRP.Id) FROM Detalle_Rack_Pesos DRP WHERE DRP.Id_Detalle_Rack = Detalle_Rack.Id) = 0";

                    if ($res_detalle_rack = mysqli_query($enlace, $q_detalle_rack)) {
                      if (mysqli_num_rows($res_detalle_rack) > 0) {
                        while ($row_detalle_rack = mysqli_fetch_assoc($res_detalle_rack)) {
                          $id_detalle_rack = $row_detalle_rack["Id"];
                        }
                      }
                      else{
                        // Si entra es porque tiene pesos registrados en este Rack y no debería continuar
                          $estado = 4;

                          echo json_encode(array('estado' => $estado));

                          return;
                      }
                    }
                  }
                }
              }
            }

          // Obteniendo el número de muestras registradas en el Rack, para obtener el correlativo de Crisol
            $num_crisol = 0;

            $q_numcrisol = "SELECT COUNT(Id) AS _COUNT
                              FROM  Detalle_Rack_Pesos
                             WHERE  Id_Detalle_Rack IN (SELECT Id
                                                          FROM Detalle_Rack
                                                         WHERE Id_Rack = ".$id_rack.")";

            if ($res_numcrisol = mysqli_query($enlace, $q_numcrisol)) {
              if (mysqli_num_rows($res_numcrisol) > 0) {
                while ($row_numcrisol = mysqli_fetch_assoc($res_numcrisol)) {
                  $num_crisol = $row_numcrisol["_COUNT"];
                }
              }
            }

          // Armando el Select para el DataGridView
            $w = 1;

            while ($w <= (($is_reanalisis == 1) ? $replica_reanalisis : $row_RackMuestra["Num_Replica"])){
              $q_select = "SELECT ".$id_detalle_rack." AS Id_Detalle_Rack,
                                  ".($num_crisol + 1)." AS Num_Crisol,
                                  '".$row_RackMuestra["Cod_Interno"]."' AS Nom_Muestra,
                                  '' AS Peso_Muestra,
                                  ".$is_reanalisis." AS is_reanalisis,
                                  ".$id_reanalisis." AS id_reanalisis";

              if ($res_select = mysqli_query($enlace, $q_select)) {
                if (mysqli_num_rows($res_select) > 0) {
                  while ($row_select = mysqli_fetch_assoc($res_select)) {
                    array_push($r, $row_select);
                  }
                }
              }

              // // Guardando ficticios en la tabla de Pesos
              //   $q_InsertPesos = "INSERT INTO Detalle_Rack_Pesos (Id_Detalle_Rack, Num_Crisol, Nom_Muestra, Peso_Muestra) VALUES(";
              //   $q_InsertPesos .= $id_detalle_rack.", ";
              //   $q_InsertPesos .= ($num_crisol + 1).", ";
              //   $q_InsertPesos .= "'".$nom_muestra."', 0)";

              //   if ($res_InsertPesos = mysqli_query($enlace, $q_InsertPesos)) {
              //   }

              $num_crisol += 1;
              $w += 1;
            }
        }

        $estado = (($exists == 1) ? 1 : 2);
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'eliminar_DetalleRack':
      $r = array();
      $estado = 0;

      $id_detallerack = $_GET["id_detallerack"];
      $is_reanalisis = $_GET["is_reanalisis"];
      $id_reanalisis = $_GET["id_reanalisis"];

      $q_delete = "DELETE FROM Detalle_Rack";
      $q_delete .= " WHERE Id = ".$id_detallerack;

      if ($res = mysqli_query($enlace, $q_delete)) {
        $estado = 1;

        // Si es una muestra por reanálisis restaurar su estado
          if ($is_reanalisis == 1){
            $q_update = "UPDATE Gestion_Solicitudes_Reanalisis
                            SET is_cargadoennuevorack = 0,
                                newid_detalle_rack = 0
                          WHERE Id = ".$id_reanalisis;

            if ($res_update = mysqli_query($enlace, $q_update)) {
            }
          }
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'guardar_PesosRack':
      $r = array();
      $estado = 0;

      $Tipo_Peso = $_GET["Tipo_Peso"];
      $Id_Detalle_Rack = $_GET["Id_Detalle_Rack"];
      $Num_Crisol = $_GET["Num_Crisol"];
      $Nom_Muestra = $_GET["Nom_Muestra"];
      $Peso_Muestra = $_GET["Peso_Muestra"];
      $Usuario_Peso = $_GET["Usuario_Peso"];
      $Tipo_InsertUpdate = $_GET["Tipo_InsertUpdate"];
      $Tipo_Blanco = $_GET["tipo_blanco"];
      $Dosificacion = $_GET["dosificacion"];

      // Para el peso de Muestras
        if ($Tipo_Peso == 'M'){
          $date = date('Y-m-d');
          $time = date('H:i:s');

          if ($Tipo_InsertUpdate == 'I'){
            $q_SavePeso = "INSERT INTO Detalle_Rack_Pesos(Id_Detalle_Rack, Num_Crisol, Id_TipoBlancoFundente, Dosificacion, Nom_Muestra, Peso_Muestra, UsuarioPeso_Muestra) VALUES(";
            $q_SavePeso .= $Id_Detalle_Rack.", ";
            $q_SavePeso .= $Num_Crisol.", ";
            $q_SavePeso .= $Tipo_Blanco.", ";
            $q_SavePeso .= "'".$Dosificacion."', ";
            $q_SavePeso .= "'".$Nom_Muestra."', ";
            $q_SavePeso .= $Peso_Muestra.", ";
            $q_SavePeso .= "'".$Usuario_Peso."')";
          }
          else{
            if ($Tipo_InsertUpdate == 'R'){
              $q_SavePeso =  "UPDATE  Detalle_Rack_Pesos SET ";
              $q_SavePeso .= "        FechaPeso_Muestra = '".$g_fecha."', ";
              $q_SavePeso .= "        Peso_Muestra = ".$Peso_Muestra.", ";
              $q_SavePeso .= "        UsuarioPeso_Muestra = '".$Usuario_Peso."' ";
              $q_SavePeso .= " WHERE  Id_Detalle_Rack = ".$Id_Detalle_Rack;
              $q_SavePeso .= "   AND  Num_Crisol = ".$Num_Crisol;
            }
            else{
              $q_SavePeso = "UPDATE Detalle_Rack_Pesos SET ";
              $q_SavePeso .= "FechaPeso_Muestra = '".$g_fecha."', ";
              $q_SavePeso .= "Peso_Muestra = ".$Peso_Muestra.", ";
              $q_SavePeso .= "UsuarioPeso_Muestra = '".$Usuario_Peso."' ";
              $q_SavePeso .= "WHERE Id = ".$Id_Detalle_Rack;
            }
          }
        }

      // Para el peso de Blanco Fundente
        if ($Tipo_Peso == 'BF'){
          $q_SavePeso = "INSERT INTO Detalle_Rack_Pesos(Id_Detalle_Rack, Num_Crisol, Id_TipoBlancoFundente, Dosificacion, Nom_Muestra, Peso_Muestra, UsuarioPeso_Muestra) VALUES(";
          $q_SavePeso .= $Id_Detalle_Rack.", ";
          $q_SavePeso .= $Num_Crisol.", ";
          $q_SavePeso .= $Tipo_Blanco.", ";
          $q_SavePeso .= "'".$Dosificacion."', ";
          $q_SavePeso .= "'".$Nom_Muestra."', ";
          $q_SavePeso .= $Peso_Muestra.", ";
          $q_SavePeso .= "'".$Usuario_Peso."')";
        }

      // Para el peso de Blanco Pulverizado
        if ($Tipo_Peso == 'BP'){
          $q_SavePeso = "INSERT INTO Detalle_Rack_Pesos(Id_Detalle_Rack, Num_Crisol, Id_TipoBlancoFundente, Dosificacion, Nom_Muestra, Peso_Muestra, UsuarioPeso_Muestra) VALUES(";
            $q_SavePeso .= $Id_Detalle_Rack.", ";
            $q_SavePeso .= $Num_Crisol.", ";
            $q_SavePeso .= $Tipo_Blanco.", ";
            $q_SavePeso .= "'".$Dosificacion."', ";
            $q_SavePeso .= "'".$Nom_Muestra."', ";
            $q_SavePeso .= $Peso_Muestra.", ";
            $q_SavePeso .= "'".$Usuario_Peso."')";
        }

      // Para el peso de Material de Referencia
        if ($Tipo_Peso == 'MR'){
          $q_SavePeso = "INSERT INTO Detalle_Rack_Pesos(Id_Detalle_Rack, Num_Crisol, Id_TipoBlancoFundente, Dosificacion, Nom_Muestra, Peso_Muestra, UsuarioPeso_Muestra) VALUES(";
            $q_SavePeso .= $Id_Detalle_Rack.", ";
            $q_SavePeso .= $Num_Crisol.", ";
            $q_SavePeso .= $Tipo_Blanco.", ";
            $q_SavePeso .= "'".$Dosificacion."', ";
            $q_SavePeso .= "'".$Nom_Muestra."', ";
            $q_SavePeso .= $Peso_Muestra.", ";
            $q_SavePeso .= "'".$Usuario_Peso."')";
        }

        if ($res = mysqli_query($enlace, $q_SavePeso)) {
          $estado = 1;

          // Obtiene el Id generado
            $id_detalle_rack_peso = mysqli_insert_id($enlace);

          // Asignando el Blanco Fundente correspondiente
            if (($Tipo_Peso == 'M' && $Tipo_InsertUpdate == 'I') || ($Tipo_Peso == 'BP') || ($Tipo_Peso == 'MR')){
              $q_idblancos = "SELECT  DR.Id,
                                      COUNT(DR.Id) AS _COUNT
                                FROM  Detalle_Rack_Pesos DRP
                                      INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                               WHERE  DRP.Id < ".$id_detalle_rack_peso."
                                 AND  DR.Rack_TipoMuestra = 2
                                 AND  DR.Id_TipoBlancoFundente = ".$Tipo_Blanco."
                                 AND  isNot_Regulo = 0
                                 AND  isNot_Dore = 0
                              GROUP BY DR.Id
                              HAVING COUNT(DR.Id) >= 2
                              ORDER BY DR.Id DESC
                              LIMIT 1";

              if ($res_idblancos = mysqli_query($enlace, $q_idblancos)) {
                if (mysqli_num_rows($res_idblancos) > 0) {
                  while($row_idblancos = mysqli_fetch_assoc($res_idblancos)) {
                    $id_idblanco = $row_idblancos["Id"];

                    // Asignando el Blanco correspondiente
                      $q_update = "UPDATE Detalle_Rack_Pesos
                                      SET Id_FactorBlanco_Ag = ".$id_idblanco."
                                    WHERE Id = ".$id_detalle_rack_peso;

                      if ($res_update = mysqli_query($enlace, $q_update)) {
                      }

                    // Si es M.R. cambia el flag de "solicitud_cierre"
                      if ($Tipo_Peso == 'MR'){
                        // Obteniendo Id de Rack
                          $q_idrack = "SELECT CR.Id
                                         FROM Cabecera_Rack CR
                                              INNER JOIN Detalle_Rack DR ON CR.Id = DR.Id_Rack
                                              INNER JOIN Detalle_Rack_Pesos DRP ON DR.Id = DRP.Id_Detalle_Rack
                                        WHERE DRP.Id = ".$id_detalle_rack_peso;

                          if ($res_idrack = mysqli_query($enlace, $q_idrack)) {
                            if (mysqli_num_rows($res_idrack) > 0) {
                              while($row_idrack = mysqli_fetch_assoc($res_idrack)) {
                                $idrack = $row_idrack["Id"];
                              }
                            }
                          }

                        $q_solicitudcierre = "UPDATE Cabecera_Rack
                                                 SET solicitud_cierre = 0
                                               WHERE Id = ".$idrack;

                        if ($res_solicitudcierre = mysqli_query($enlace, $q_solicitudcierre)) {
                        }
                      }
                  }
                }
              }
            }
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'guardar_DetalleMuestrasRack':
      $r = array();
      $id_detalle_rack = 0;

      $id_rack = $_GET["id_rack"];
      $tipo_muestra = $_GET["tipo_muestra"];
      $nom_muestra = $_GET["nom_muestra"];
      $tipo_blanco = $_GET["tipo_blanco"];
      $dosif = $_GET["dosif"];
      $replicas = $_GET["replicas"];
      $usuario_peso = $_GET["Usuario_Peso"];

      if ($tipo_muestra == "BF"){
        $tipo_muestra = 2;
      }

      if ($tipo_muestra == "BP"){
        $tipo_muestra = 3;
      }

      if ($tipo_muestra == "MR"){
        $tipo_muestra = 4;
      }

      $q_insert = "INSERT INTO Detalle_Rack(Id_Rack, Id_Pedido, Id_Detalle, Rack_TipoMuestra,
                                            ci_muestra, nom_muestra, is_Au, is_Ag,
                                            Id_TipoBlancoFundente, Dosificacion, num_replica, Id_MedioPago,
                                            is_Reanalisis, Usuario_Muestra) VALUES(
                  ".$id_rack.", 0, 0, ".$tipo_muestra.",
                  '".$nom_muestra."', '".$nom_muestra."', 0, 0,
                  ".$tipo_blanco.", '".$dosif."', ".$replicas.", 0, 0, '".$usuario_peso."')";

      if ($res_insert = mysqli_query($enlace, $q_insert)) {
        $max_id = "SELECT MAX(Id) AS _MAX
                     FROM Detalle_Rack";

        if ($res_max_id = mysqli_query($enlace, $max_id)) {
          if (mysqli_num_rows($res_max_id) > 0) {
            while ($row_max_id = mysqli_fetch_assoc($res_max_id)) {
              $id_detalle_rack = $row_max_id["_MAX"];
            }
          }
        }
      }
      else{
        $id_detalle_rack = 0;
      }

      echo json_encode(array('id_detalle_rack' => $id_detalle_rack));

      break;

    case 'update_DatosPesos':
      $r = array();
      $estado = 0;

      $Tipo_Peso = $_GET["Tipo_Peso"];
      $Id_DetalleRackPesos = $_GET["Id_DetalleRackPesos"];
      $Tipo_Blanco = $_GET["Tipo_Blanco"];
      $Dosificacion = $_GET["Dosificacion"];
      $Peso_Muestra = $_GET["Peso_Muestra"];
      $Usuario_Update = $_GET["Usuario_Update"];
      $Modulo_Update = $_GET["Modulo_Update"];

      // Si es una actualización de Pesos debe registrar los datos de Auditorías
        if ($Modulo_Update == 1){
          $q_audi = "INSERT INTO Auditoria_ActualizacionDatosMuestras (Id_Detalle_Rack_Pesos, Id_Detalle_Rack, Num_Crisol,
                                  Id_TipoBlancoFundente, Dosificacion, Nom_Muestra, FechaPeso_Muestra,
                                  Peso_Muestra, UsuarioPeso_Muestra, UpdateId_TipoBlancoFundente, Update_Dosificacion,
                                  UpdateFechaPeso_Muestra, UpdatePeso_Muestra, UpdateUsuarioPeso_Muestra)";
          $q_audi .= "SELECT  Id,
                              Id_Detalle_Rack,
                              Num_Crisol,
                              Id_TipoBlancoFundente,
                              Dosificacion,
                              Nom_Muestra,
                              FechaPeso_Muestra,
                              Peso_Muestra,
                              UsuarioPeso_Muestra, ";
          $q_audi .= "        ".$Tipo_Blanco.", ";
          $q_audi .= "        '".$Dosificacion."', ";
          $q_audi .= "        '".$g_fecha."', ";
          $q_audi .= "        ".$Peso_Muestra.", ";
          $q_audi .= "        '".$Usuario_Update."' ";
          $q_audi .= "  FROM  Detalle_Rack_Pesos
                       WHERE  Id = ".$Id_DetalleRackPesos;

          if ($res_audi = mysqli_query($enlace, $q_audi)) {
          }
        }

      // Para el peso de Muestras
        if ($Tipo_Peso == 'M'){
          $q_update = "UPDATE Detalle_Rack_Pesos SET 
                              Id_TipoBlancoFundente = ".$Tipo_Blanco.",
                              Dosificacion = '".$Dosificacion."',
                              Peso_Muestra = ".$Peso_Muestra.",
                              FechaPeso_Muestra = '".$g_fecha."',
                              UsuarioPeso_Muestra = '".$Usuario_Update."'
                        WHERE Id = ".$Id_DetalleRackPesos;
        }

      // Para el peso de Régulo
      if ($Tipo_Peso == 'R'){
        
      }

      // Para el peso de Doré
      if ($Tipo_Peso == 'D'){

      }

      // Para el peso de Au
      if ($Tipo_Peso == 'Au'){

      }

      if ($res = mysqli_query($enlace, $q_update)) {
        $estado = 1;

        // Asignando el Blanco Fundente correspondiente
          $q_idblancos = "SELECT  DR.Id,
                                  COUNT(DR.Id) AS _COUNT
                            FROM  Detalle_Rack_Pesos DRP
                                  INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                           WHERE  DRP.Id < ".$Id_DetalleRackPesos."
                             AND  DR.Rack_TipoMuestra = 2
                             AND  DR.Id_TipoBlancoFundente = ".$Tipo_Blanco."
                             AND  isNot_Regulo = 0
                             AND  isNot_Dore = 0
                          GROUP BY DR.Id
                          HAVING COUNT(DR.Id) >= 2
                          ORDER BY DR.Id DESC
                          LIMIT 1";

          if ($res_idblancos = mysqli_query($enlace, $q_idblancos)) {
            if (mysqli_num_rows($res_idblancos) > 0) {
              while($row_idblancos = mysqli_fetch_assoc($res_idblancos)) {
                $id_idblanco = $row_idblancos["Id"];

                // Asignando el Blanco correspondiente
                  $q_updateTB = "UPDATE Detalle_Rack_Pesos
                                    SET Id_FactorBlanco_Ag = ".$id_idblanco."
                                  WHERE Id = ".$Id_DetalleRackPesos;

                  if ($res_updateTB = mysqli_query($enlace, $q_updateTB)) {
                  }
              }
            }
          }
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_ListaRackMuestras':
      $r = array();
      $estado = 0;

      $Id_Rack = $_GET["Id_Rack"];

      // $q_RackMuestras = "SELECT DRP.Num_Crisol,
      //                           RTM.nom_tipo AS TIPO,
      //                           DRP.nom_muestra,
      //                           DRP.Peso_Muestra,
      //                           TB.nom_tipoblanco,
      //                           CASE WHEN is_Newmont = 0
      //                             THEN DR.Dosificacion
      //                           ELSE CASE WHEN DRP.is_Newmont_Positivo = 1
      //                               THEN DR.Dosificacion
      //                                ELSE CASE WHEN DRP.is_Newmont_Negativo = 1
      //                                   THEN DR.Dosificacion_Negativo END END END AS Dosificacion,
      //                           DR.Id,
      //                           CR.cierre_rack,
      //                           CR.solicitud_cierre,
      //                           DR.Id_TipoBlancoFundente,
      //                           DRP.Id AS Id_DetalleRackPesos
      //                     FROM  Detalle_Rack DR
      //                           INNER JOIN Detalle_Rack_Pesos DRP ON DR.Id = DRP.Id_Detalle_Rack
      //                           INNER JOIN tbconfig_RackTipoMuestras RTM ON DR.Rack_TipoMuestra = RTM.Id
      //                           INNER JOIN tbconfig_RackTipoBlancoFundente TB ON DRP.Id_TipoBlancoFundente = TB.Id
      //                           INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
      //                    WHERE  DR.Id_Rack = ".$Id_Rack;

      $q_RackMuestras = "SELECT DRP.Num_Crisol,
                                RTM.nom_tipo AS TIPO,
                                DRP.nom_muestra,
                                DRP.Peso_Muestra,
                                TB.nom_tipoblanco,
                                DRP.Dosificacion,
                                DR.Id,
                                CR.cierre_rack,
                                CR.solicitud_cierre,
                                DRP.Id_TipoBlancoFundente,
                                DRP.Id AS Id_DetalleRackPesos,
                                DRP.is_Newmont_Positivo,
                                
                                CASE WHEN isObservado_DoreFactorPlata = 1
                                  THEN 'Desviación de Plata de Blanco Fuera de Límite'
                                ELSE '' END AS Observacion

                          FROM  Detalle_Rack DR
                                INNER JOIN Detalle_Rack_Pesos DRP ON DR.Id = DRP.Id_Detalle_Rack
                                INNER JOIN tbconfig_RackTipoMuestras RTM ON DR.Rack_TipoMuestra = RTM.Id
                                INNER JOIN tbconfig_RackTipoBlancoFundente TB ON DRP.Id_TipoBlancoFundente = TB.Id
                                INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
                         WHERE  DR.Id_Rack = ".$Id_Rack;

      if ($res_RackMuestras = mysqli_query($enlace, $q_RackMuestras)) {
        if (mysqli_num_rows($res_RackMuestras) > 0) {
          while($row_RackMuestras = mysqli_fetch_assoc($res_RackMuestras)) {
            array_push($r, $row_RackMuestras);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_NumCrisol':
      $r = array();
      $estado = 0;
      $num_crisol = 0;

      $id_rack = $_GET["id_rack"];

      $q_numcrisol = "SELECT COUNT(Id) AS _COUNT
                        FROM  Detalle_Rack_Pesos
                       WHERE  Id_Detalle_Rack IN (SELECT Id
                                                    FROM Detalle_Rack
                                                   WHERE Id_Rack = ".$id_rack.")";

      if ($res_numcrisol = mysqli_query($enlace, $q_numcrisol)) {
        if (mysqli_num_rows($res_numcrisol) > 0) {
          $estado = 1;

          while ($row_numcrisol = mysqli_fetch_assoc($res_numcrisol)) {
            $num_crisol = $row_numcrisol["_COUNT"];
          }
        }
      }

      echo json_encode(array('estado' => $estado, 'num_crisol' => $num_crisol));

      break;

    case 'get_NumBlancoFundente':
      $r = array();
      $estado = 0;
      $num_blanco = 0;

      $id_rack = $_GET["id_rack"];
      $tipo_blanco = $_GET["tipo_blanco"];

      $q_numblanco = "SELECT COUNT(Id) AS _COUNT
                        FROM  Detalle_Rack_Pesos
                       WHERE  Id_Detalle_Rack IN (SELECT Id
                                                    FROM Detalle_Rack
                                                   WHERE Id_Rack = ".$id_rack."
                                                     AND Rack_TipoMuestra = 2
                                                     AND Id_TipoBlancoFundente = ".$tipo_blanco.")";

      if ($res_numblanco = mysqli_query($enlace, $q_numblanco)) {
        if (mysqli_num_rows($res_numblanco) > 0) {
          $estado = 1;

          while ($row_numblanco = mysqli_fetch_assoc($res_numblanco)) {
            $num_blanco = $row_numblanco["_COUNT"];
          }
        }
      }

      echo json_encode(array('estado' => $estado, 'num_blanco' => $num_blanco));

      break;

    case 'get_NumBlancoPulverizado':
      $r = array();
      $estado = 0;
      $num_blanco = 0;

      // Obteniendo la fecha de hoy
        date_default_timezone_set("America/Lima"); 
        $date = date('Y-m-d');

      // Obteniendo el correlativo
        $q_numblanco = "SELECT  COUNT(Id) AS _COUNT
                          FROM  Detalle_Rack
                         WHERE  DATE(FechaRegistro_Muestra) = '".$date."'
                           AND  Rack_TipoMuestra = 3";

        if ($res_numblanco = mysqli_query($enlace, $q_numblanco)) {
          if (mysqli_num_rows($res_numblanco) > 0) {
            $estado = 1;

            while ($row_numblanco = mysqli_fetch_assoc($res_numblanco)) {
              $num_blanco = $row_numblanco["_COUNT"];
            }
          }
        }

      echo json_encode(array('estado' => $estado, 'num_blanco' => $num_blanco));

      break;

    case 'get_NomBlancoPulverizado':
      $r = array();
      $estado = 0;

      $q_nomblanco = "SELECT  nom_nomenclatura
                        FROM  tbconfig_BlancoPulverizado_Nomenclatura
                       WHERE  en_ejecucion = 1";

      if ($res_nomblanco = mysqli_query($enlace, $q_nomblanco)) {
        if (mysqli_num_rows($res_nomblanco) > 0) {
          $estado = 1;

          while ($row_nomblanco = mysqli_fetch_assoc($res_nomblanco)) {
            $nom_blanco = $row_nomblanco["nom_nomenclatura"];
          }
        }
      }

      echo json_encode(array('estado' => $estado, 'nom_blanco' => $nom_blanco));

      break;

    case 'get_ListaMaterialR':
      $r = array();
      $estado = 0;

      $order = (($_GET["orden"] == 1) ? 'ASC' : 'DESC');

      $q_MaterialR = "SELECT CONCAT('(', TBF.abv_tipoblanco, ') - ', Nom_MaterialReferencia) AS Nom_MaterialReferencia
                        FROM tbconfig_MaterialReferencia MR
                             INNER JOIN tbconfig_RackTipoBlancoFundente TBF ON MR.Id_TipoBlancoFundente = TBF.Id
                       WHERE Estado_MaterialReferencia = 'A'
                      ORDER BY Id_TipoBlancoFundente ".$order.", Nom_MaterialReferencia";

      if ($res_MaterialR = mysqli_query($enlace, $q_MaterialR)) {
        if (mysqli_num_rows($res_MaterialR) > 0) {
          while($row_MaterialR = mysqli_fetch_assoc($res_MaterialR)) {
            array_push($r, $row_MaterialR);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaHornos':
      $r = array();
      $estado = 0;

      $q_Hornos = "SELECT Id,
                          CONCAT(cod_horno, ' | Capacidad: ', capacidad_horno, ' Crisoles') AS NOM_HORNO
                     FROM tbconfig_Hornos
                    WHERE estado_horno = 'A'";

      if ($res_Hornos = mysqli_query($enlace, $q_Hornos)) {
        if (mysqli_num_rows($res_Hornos) > 0) {
          while($row_Hornos = mysqli_fetch_assoc($res_Hornos)) {
            array_push($r, $row_Hornos);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaMuestrasNewmont':
      $r = array();
      $estado = 0;

      $fecha_inicio = $_GET["Fecha_Inicio"];
      $fecha_fin = $_GET["Fecha_Fin"];
      $ci_muestra = $_GET["CI_Muestra"];

      $q_Muestras = "SELECT 0 AS Item,
                            PNC.CI_Muestra,
                            M.num_malla,
                            CASE WHEN PNC.Cierre_Newmont = 0 THEN 'NO' ELSE 'SÍ' END AS Cierre_Newmont,
                            PNC.FechaHora_Recepcion,
                            PNC.UsuarioCierre_Newmont,
                            PNC.FechaCierre_Newmont,
                            PNC.Id,
                            PNC.ReOpen_Newmont,
                            PNC.is_NewGrupo,
                            PNC.num_newgrupos
                      FROM  Preparacion_Newmont_Cabecera PNC
                            LEFT JOIN tbconfig_Mallas M ON PNC.Id_NumMalla = M.Id
                     WHERE  1 = 1";

      if ($ci_muestra != "0"){
        $q_Muestras .= "   AND PNC.CI_Muestra = '".$ci_muestra."'";
      }
      else{
        $q_Muestras .= "   AND DATE(PNC.FechaHora_Recepcion) BETWEEN '".$fecha_inicio."' AND '".$fecha_fin."'";
      }

      $q_Muestras .= " ORDER BY FechaHora_Recepcion DESC, Id_Detalle DESC";

      if ($res_Muestras = mysqli_query($enlace, $q_Muestras)) {
        if (mysqli_num_rows($res_Muestras) > 0) {
          while($row_Muestras = mysqli_fetch_assoc($res_Muestras)) {
            array_push($r, $row_Muestras);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaMuestrasNewmont_Detalle':
      $r = array();
      $estado = 0;

      $Id_Cabecera = $_GET["Id_Cabecera"];

      $q_Detalle = "SELECT Num_Grupo,
                           Peso_muestra,
                           PesoPositivo_Muestra,
                           PesoNegativo_Muestra,
                           UsuarioPeso_Muestra,
                           FechaPeso_Muestra,
                           UsuarioPesoPositivo_Muestra,
                           FechaPesoPositivo_Muestra,
                           UsuarioPesoNegativo_Muestra,
                           FechaPesoNegativo_Muestra,
                           Id_Cabecera,
                           Id
                      FROM Preparacion_Newmont_Detalle
                     WHERE Id_Cabecera = ".$Id_Cabecera."
                    ORDER BY Num_Grupo";

      if ($res_Detalle = mysqli_query($enlace, $q_Detalle)) {
        if (mysqli_num_rows($res_Detalle) > 0) {
          while($row_Detalle = mysqli_fetch_assoc($res_Detalle)) {
            array_push($r, $row_Detalle);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaNumMallas':
      $r = array();
      $estado = 0;

      $q_NumMallas = "SELECT  Id,
                              num_malla
                        FROM  tbconfig_Mallas
                       WHERE  estado_malla = 'A'";

      if ($res_NumMallas = mysqli_query($enlace, $q_NumMallas)) {
        if (mysqli_num_rows($res_NumMallas) > 0) {
          while($row_NumMallas = mysqli_fetch_assoc($res_NumMallas)) {
            array_push($r, $row_NumMallas);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_LimitePesos':
      $r = array();
      $estado = 0;
      $limite_pesos = "";

      $id_limitepesos = $_GET["id_limitepesos"];
      $send_peso = $_GET["send_peso"];

      $q_LimitePesos = "SELECT  Peso_Aprox,
                                Limite_Min,
                                Limite_Max,
                                Limite_Porc
                          FROM  tbconfig_LimitePesos
                         WHERE  Id = ".$id_limitepesos;

      if ($res_LimitePesos = mysqli_query($enlace, $q_LimitePesos)) {
        if (mysqli_num_rows($res_LimitePesos) > 0) {
          while($row_LimitePesos = mysqli_fetch_assoc($res_LimitePesos)) {
            $peso_aprox = $row_LimitePesos["Peso_Aprox"];
            $limit_min = $row_LimitePesos["Limite_Min"];
            $limit_max = $row_LimitePesos["Limite_Max"];
            $limite_porc = $row_LimitePesos["Limite_Porc"];

            if ($limite_porc == 1){
              if ($id_limitepesos == 2){
                $limit_min = $send_peso - ($send_peso * ($limit_min / 100));
                $limit_max = $send_peso + ($send_peso * ($limit_max / 100));
              }
              else{
                $limit_min = $peso_aprox - ($peso_aprox * ($limit_min / 100));
                $limit_max = $peso_aprox + ($peso_aprox * ($limit_max / 100));
              }
            }
            else{
              $limit_min = $peso_aprox - $limit_min;
              $limit_max = $peso_aprox + $limit_max;
            }

            $limite_pesos = $peso_aprox."|".$limit_min."|".$limit_max;
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'limite_pesos' => $limite_pesos));

      break;

    case 'guardar_PesosMuestrasNewmont':
      $r = array();
      $estado = 0;

      $Tipo_Peso = $_GET["Tipo_Muestra"];
      $Id_Cabecera = $_GET["Id_Cabecera"];
      $Id_Detalle = $_GET["Id_Detalle"];
      $Num_Malla = $_GET["Num_Malla"];
      $Peso_Muestra = $_GET["Peso_Muestra"];
      $Usuario_Peso = $_GET["Usuario_Peso"];

      // Obteniendo la fecha de hoy
        date_default_timezone_set("America/Lima"); 
        $date = date('Y-m-d');
        $time = date('H:i:s');

      // Para el peso de Muestras
        if ($Tipo_Peso == 'M'){
          $q_SavePeso = "UPDATE Preparacion_Newmont_Detalle
                            SET Peso_Muestra = ".$Peso_Muestra.",
                                FechaPeso_Muestra = '".($date.' ' .$time)."',
                                UsuarioPeso_Muestra = '".$Usuario_Peso."'
                          WHERE Id = ".$Id_Detalle;
        }

      // Para el peso de Positivos
        if ($Tipo_Peso == 'P'){
          $q_SavePeso = "UPDATE Preparacion_Newmont_Detalle
                            SET PesoPositivo_Muestra = ".$Peso_Muestra.",
                                FechaPesoPositivo_Muestra = '".($date.' ' .$time)."',
                                UsuarioPesoPositivo_Muestra = '".$Usuario_Peso."',

                                PesoNegativo_Muestra = (Peso_Muestra - ".$Peso_Muestra."),
                                FechaPesoNegativo_Muestra = '".($date.' ' .$time)."',
                                UsuarioPesoNegativo_Muestra = '".$Usuario_Peso."',

                                Cierre_Grupo = 1
                          WHERE Id = ".$Id_Detalle;
        }

        if ($res = mysqli_query($enlace, $q_SavePeso)) {
          $estado = 1;

          // Actualiza el número de Malla
            $q_update = "UPDATE Preparacion_Newmont_Cabecera
                            SET Id_NumMalla = ".$Num_Malla."
                          WHERE Id = ".$Id_Cabecera;

            if ($res_update = mysqli_query($enlace, $q_update)) {
            }
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'cierre_Newmont':
      $r = array();
      $estado = 0;

      $id_cabecera = $_GET["Id_Cabecera"];
      $usuario_cierre = $_GET["Usuario_Cierre"];

      // Obteniendo la fecha de hoy
        date_default_timezone_set("America/Lima"); 
        $date = date('Y-m-d');
        $time = date('H:i:s');

      $q_CierreNewmont = "UPDATE Preparacion_Newmont_Cabecera
                             SET Cierre_Newmont = 1,
                                 FechaCierre_Newmont = '".($date.' ' .$time)."',
                                 UsuarioCierre_Newmont = '".$usuario_cierre."'
                           WHERE Id = ".$id_cabecera;

      if ($res = mysqli_query($enlace, $q_CierreNewmont)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'reopen_Newmont':
      $r = array();
      $estado = 0;

      $id_cabecera = $_GET["Id_Cabecera"];
      $usuario_cierre = $_GET["Usuario_Cierre"];

      // Obteniendo la fecha de hoy
        date_default_timezone_set("America/Lima"); 
        $date = date('Y-m-d');
        $time = date('H:i:s');

      $q_ReOpenNewmont = "UPDATE Preparacion_Newmont_Cabecera
                             SET Cierre_Newmont = 0,
                                 FechaCierre_Newmont = null,
                                 UsuarioCierre_Newmont = null,
                                 ReOpen_Newmont = 1,
                                 FechaReOpen_Newmont = '".($date.' ' .$time)."',
                                 UsuarioReOpen_Newmont = '".$usuario_cierre."'
                           WHERE Id = ".$id_cabecera;

      if ($res = mysqli_query($enlace, $q_ReOpenNewmont)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'reopen_EliminarPesos_Newmont':
      $r = array();
      $estado = 0;

      $id_detalle = $_GET["Id_Detalle"];
      $usuario_eliminarpesoslog = $_GET["Usuario_EliminarPesosLog"];

      // Inserta los datos a actualizar en la tabla de Log
      $q_SaveLog = "INSERT INTO Preparacion_Newmont_Detalle_ReOpenLog (Id_Detalle, Id_Cabecera, Num_Grupo, Peso_muestra,
                                FechaPeso_Muestra, UsuarioPeso_Muestra, PesoPositivo_muestra, FechaPesoPositivo_Muestra,
                                UsuarioPesoPositivo_Muestra, PesoNegativo_muestra, FechaPesoNegativo_Muestra, UsuarioPesoNegativo_Muestra,
                                Usuario_ReOpenLog)

                    SELECT  Id, Id_Cabecera, Num_Grupo, Peso_muestra,
                            FechaPeso_Muestra, UsuarioPeso_Muestra, PesoPositivo_muestra, FechaPesoPositivo_Muestra,
                            UsuarioPesoPositivo_Muestra, PesoNegativo_muestra, FechaPesoNegativo_Muestra, UsuarioPesoNegativo_Muestra,
                            '".$usuario_eliminarpesoslog."'
                      FROM  Preparacion_Newmont_Detalle
                     WHERE  Id = ".$id_detalle;

      if ($res_SaveLog = mysqli_query($enlace, $q_SaveLog)) {
        $estado = 1;

        // Limpia los datos de la tabla de detalles
          $q_update = "UPDATE Preparacion_Newmont_Detalle
                          SET Peso_muestra = 0,
                              FechaPeso_Muestra = null,
                              UsuarioPeso_Muestra = null,

                              PesoPositivo_muestra = 0,
                              FechaPesoPositivo_Muestra = null,
                              UsuarioPesoPositivo_Muestra = null,

                              PesoNegativo_muestra = 0,
                              FechaPesoNegativo_Muestra = null,
                              UsuarioPesoNegativo_Muestra = null
                        WHERE Id = ".$id_detalle;

          if ($res_update = mysqli_query($enlace, $q_update)) {
          }
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_VerificaMuestraNewmont':
      $r = array();
      $estado = 0;

      $ci_muestra = $_GET["CI_Muestra"];
      $id_rack = $_GET["Id_Rack"];

      // Comprobando si es una muestra Newmont
        $q_newmont = "SELECT  COUNT(Id) AS _EXISTS
                        FROM  _max_labperu_DetallePedido
                       WHERE  Cod_Interno = '".$ci_muestra."'
                         AND  CodProductos_Combo LIKE '%newmont%'";

        if ($res_newmont = sqlsrv_query($enlacehost, $q_newmont)) {
          while($row_newmont = sqlsrv_fetch_array($res_newmont)) {
            $estado = $row_newmont["_EXISTS"];

            if ($estado == 0){
              echo json_encode(array('estado' => $estado));

              return;
            }

            // Comprobando si se registraron todos los pesos para los Grupos Newmont
              $q_GruposNewmont = "SELECT  COUNT(D.Id) AS _COUNT
                                    FROM  Preparacion_Newmont_Detalle D
                                          INNER JOIN Preparacion_Newmont_Cabecera C ON D.Id_Cabecera = C.Id
                                   WHERE  D.Id_Cabecera IN (SELECT Id
                                                              FROM Preparacion_Newmont_Cabecera
                                                             WHERE CI_Muestra = '".$ci_muestra."')
                                     AND  D.Reanalisis_Por_Positivo = 0
                                     AND  C.Cierre_Newmont = 1";

              if ($res_GruposNewmont = mysqli_query($enlace, $q_GruposNewmont)) {
                if (mysqli_num_rows($res_GruposNewmont) > 0) {
                  while($row_GruposNewmont = mysqli_fetch_assoc($res_GruposNewmont)) {
                    $num_grupospreparacion = $row_GruposNewmont["_COUNT"];

                    // Verificando y comparando los grupos que hayan sido registrados hasta el momento
                      $q_PesosFundicion = "SELECT COUNT(Group_Newmont) AS _COUNT
                                             FROM Detalle_Rack
                                            WHERE ci_muestra = '".$ci_muestra."'
                                              AND is_Reanalisis = 0";

                      if ($res_PesosFundicion = mysqli_query($enlace, $q_PesosFundicion)) {
                        if (mysqli_num_rows($res_PesosFundicion) > 0) {
                          while($row_PesosFundicion = mysqli_fetch_assoc($res_PesosFundicion)) {
                            $num_gruposfundcion = $row_PesosFundicion["_COUNT"];

                            if ($num_grupospreparacion == $num_gruposfundcion){
                              $estado = 4;

                              echo json_encode(array('estado' => $estado));

                              return;
                            }
                            else{
                              // Valida si hay pesos pendientes
                                $q_NewmontPendientes = "SELECT  COUNT(Id) AS _COUNT
                                                          FROM  Preparacion_Newmont_Detalle
                                                         WHERE  Id_Cabecera IN (SELECT Id
                                                                      FROM Preparacion_Newmont_Cabecera
                                                                     WHERE CI_Muestra = '".$ci_muestra."')
                                                           AND  Reanalisis_Por_Positivo = 0
                                                           AND  PesoNegativo_muestra = 0";

                                if ($res_NewmontPendientes = mysqli_query($enlace, $q_NewmontPendientes)) {
                                  if (mysqli_num_rows($res_NewmontPendientes) > 0) {
                                    while($row_NewmontPendientes = mysqli_fetch_assoc($res_NewmontPendientes)) {
                                      if ($row_NewmontPendientes["_COUNT"] > 0){
                                        $estado = 5;

                                        echo json_encode(array('estado' => $estado));

                                        return;
                                      }
                                    }
                                  }
                                }
                            }
                          }
                        }
                      }
                  }
                }
              }

            // Comprueba que la muestra esté cerrada desde Preparación
              // $q_CierreNewmont = "SELECT  COUNT(Id) AS _COUNT
              //                       FROM  Preparacion_Newmont_Cabecera
              //                      WHERE  CI_Muestra = '".$ci_muestra."'
              //                        AND  Cierre_Newmont = 1";

              $q_CierreNewmont = "SELECT  COUNT(Id) AS _COUNT
                                    FROM  Preparacion_Newmont_Detalle
                                   WHERE  Id_Cabecera IN (SELECT  Id
                                                FROM  Preparacion_Newmont_Cabecera
                                               WHERE  CI_Muestra = '".$ci_muestra."')
                                     AND  Cierre_Grupo = 1";

              if ($res_CierreNewmont = mysqli_query($enlace, $q_CierreNewmont)) {
                if (mysqli_num_rows($res_CierreNewmont) > 0) {
                  while($row_CierreNewmont = mysqli_fetch_assoc($res_CierreNewmont)) {
                    if ($row_CierreNewmont["_COUNT"] == 0){
                      $estado = 2;

                      echo json_encode(array('estado' => $estado));

                      return;
                    }
                  }
                }
              }

            // // Comprobar que la muestra no exista en otro Rack
            //   $q_exists = "SELECT  COUNT(Id) AS _COUNT
            //                  FROM  Detalle_Rack
            //                 WHERE  ci_muestra = '".$ci_muestra."'
            //                   AND  is_Reanalisis = 0
            //                   AND  Id_Rack <> ".$id_rack;

            //   if ($res_exists = mysqli_query($enlace, $q_exists)) {
            //     if (mysqli_num_rows($res_exists) > 0) {
            //       while($row_exists = mysqli_fetch_assoc($res_exists)) {
            //         if ($row_exists["_COUNT"] > 0){
            //           $estado = 3;

            //           echo json_encode(array('estado' => $estado));

            //           return;
            //         }
            //       }
            //     }
            //   }
          }
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_ListaGruposNewmont':
      $r = array();
      $estado = 0;

      $ci_muestra = $_GET["CI_Muestra"];

      // Verificando los grupos que ya tengan peso en Fundición
        $in_gruponewmont = '';

        $q_PesosFundicion = "SELECT Group_Newmont
                               FROM Detalle_Rack
                              WHERE ci_muestra = '".$ci_muestra."'";

        if ($res_PesosFundicion = mysqli_query($enlace, $q_PesosFundicion)) {
          if (mysqli_num_rows($res_PesosFundicion) > 0) {
            while($row_PesosFundicion = mysqli_fetch_assoc($res_PesosFundicion)) {
              $in_gruponewmont .= $row_PesosFundicion["Group_Newmont"].", ";
            }

            $in_gruponewmont = substr($in_gruponewmont, 0, -2);
          }
        }

        if (strlen($in_gruponewmont) == 0){
          $in_gruponewmont = "''";
        }

      // Obtiene los grupos disponibles
        $q_GruposNewmont = "SELECT  Id,
                                    CONCAT('Grupo ', Num_Grupo) AS NUM_GRUPO
                              FROM  Preparacion_Newmont_Detalle
                             WHERE  Id_Cabecera IN (SELECT Id
                                                      FROM Preparacion_Newmont_Cabecera
                                                     WHERE CI_Muestra = '".$ci_muestra."')
                               AND  Reanalisis_Por_Positivo = 0
                               AND  Cierre_Grupo = 1
                               AND Id NOT IN (".$in_gruponewmont.")";

        if ($res_GruposNewmont = mysqli_query($enlace, $q_GruposNewmont)) {
          if (mysqli_num_rows($res_GruposNewmont) > 0) {
            while($row_GruposNewmont = mysqli_fetch_assoc($res_GruposNewmont)) {
              array_push($r, $row_GruposNewmont);
            }

            $estado = 1;
          }
        }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_PesoPositivoPreparacion':
      $r = array();
      $estado = 0;
      $peso_positivo = 0;

      $id_detalle_preparacion = $_GET["Id_Detalle_Preparacion"];

      $q_PesoPositivo = "SELECT  PesoPositivo_muestra
                           FROM  Preparacion_Newmont_Detalle
                          WHERE  Id = ".$id_detalle_preparacion;

      if ($res_PesoPositivo = mysqli_query($enlace, $q_PesoPositivo)) {
        if (mysqli_num_rows($res_PesoPositivo) > 0) {
          $estado = 1;

          while ($row_PesoPositivo = mysqli_fetch_assoc($res_PesoPositivo)) {
            $peso_positivo = $row_PesoPositivo["PesoPositivo_muestra"];
          }
        }
      }

      echo json_encode(array('estado' => $estado, 'peso_positivo' => $peso_positivo));

      break;

    case 'guardar_PesoMuestraNewmont_Rack':
      $r = array();
      $estado = 0;
      $exists = 0;

      $positivo_negativo = $_GET["Positivo_Negativo"];
      $ci_muestra = $_GET["CI_Muestra"];
      $id_rack = $_GET["Id_Rack"];
      $num_crisol = $_GET["Num_Crisol"];
      $id_gruponewmont = $_GET["Id_GrupoNewmont"];
      $nom_gruponewmont = $_GET["Nom_GrupoNewmont"];
      $tipo_blanco = $_GET["Tipo_Blanco"];
      $dosificacion = $_GET["Dosificacion"];
      $dosificacion_negativo = $_GET["Dosificacion_Negativo"];
      $peso_muestra = $_GET["Peso_Muestra"];
      $usuario_peso = $_GET["Usuario_Peso"];

      // Busca la muestra en las tablas de ventas
        $q_RackMuestra = "SELECT  C.Id_Pedido,
                                  D.Id AS Id_Detalle,
                                  D.Cod_Interno,
                                  D.Nom_Muestra,
                                  PV.Id_MedioPago
                            FROM  _max_labperu_DetallePedido D
                                  INNER JOIN _max_labperu_CabeceraPedido C ON D.Id_Pedido = C.Id_Pedido
                                  INNER JOIN _max_labperu_PagoVenta PV ON C.Id_Pedido = PV.Id_Pedido
                           WHERE  D.Cod_Interno = '".$ci_muestra."'";

        if ($res_RackMuestra = sqlsrv_query($enlacehost, $q_RackMuestra)) {
          while($row_RackMuestra = sqlsrv_fetch_array($res_RackMuestra)) {
            $nom_muestra = trim($row_RackMuestra["Nom_Muestra"]);

            if ($positivo_negativo == "P"){
              // Guardando en la tabla Detalle_Rack
                $q_InsertDetalle = "INSERT INTO Detalle_Rack(Id_Rack, Id_Pedido, Id_Detalle, Rack_TipoMuestra,
                                                             ci_muestra, nom_muestra, is_Au, is_Ag,
                                                             is_Newmont, Group_Newmont, Id_TipoBlancoFundente, Dosificacion,
                                                             num_replica, Id_MedioPago, is_Reanalisis, Usuario_Muestra) VALUES(";
                $q_InsertDetalle .= $id_rack.", ";
                $q_InsertDetalle .= $row_RackMuestra["Id_Pedido"].", ";
                $q_InsertDetalle .= $row_RackMuestra["Id_Detalle"].", 1, ";
                $q_InsertDetalle .= "'".$ci_muestra."', ";
                $q_InsertDetalle .= "'".$nom_muestra."', 0, 0, 1, ";
                $q_InsertDetalle .= $id_gruponewmont.", ";
                $q_InsertDetalle .= $tipo_blanco.", ";
                $q_InsertDetalle .= "'".$dosificacion."', 0, ";
                $q_InsertDetalle .= $row_RackMuestra["Id_MedioPago"].", 0, ";
                $q_InsertDetalle .= "'".$usuario_peso."')";

                if ($res_InsertDetalle = mysqli_query($enlace, $q_InsertDetalle)) {
                  // Obteniendo Id
                    $q_Id = "SELECT Id
                               FROM Detalle_Rack
                             ORDER BY Id DESC
                             LIMIT 1";
                }
            }
            else{
              // Actualiza dosificación del negativo
                $q_dosificacion = "UPDATE Detalle_Rack
                                      SET Dosificacion_Negativo = '".$dosificacion_negativo."'
                                    WHERE ci_muestra = '".$ci_muestra."'";

                if ($res_dosificacion = mysqli_query($enlace, $q_dosificacion)) {
                }

              $q_Id = "SELECT Id
                         FROM Detalle_Rack
                        WHERE ci_muestra = '".$ci_muestra."'";
            }

            // Obtiene el Id de la tabla Detalle_Rack
              if ($res_Id = mysqli_query($enlace, $q_Id)) {
                if (mysqli_num_rows($res_Id) > 0) {
                  while ($row_Id = mysqli_fetch_assoc($res_Id)) {
                    $id_detalle_rack = $row_Id["Id"];
                  }
                }
              }

            // Guardar Pesos
              $q_SavePeso = "INSERT INTO Detalle_Rack_Pesos(Id_Detalle_Rack, Num_Crisol, Id_TipoBlancoFundente, Dosificacion, Nom_Muestra, Peso_Muestra, UsuarioPeso_Muestra, ";
              $q_SavePeso .= (($positivo_negativo == 'P') ? "is_Newmont_Positivo" : "is_Newmont_Negativo").") VALUES(";
              $q_SavePeso .= $id_detalle_rack.", ";
              $q_SavePeso .= $num_crisol.", ";
              $q_SavePeso .= $tipo_blanco.", ";
              $q_SavePeso .= "'".(($positivo_negativo == 'P') ? $dosificacion : $dosificacion_negativo)."', ";
              $q_SavePeso .= "'".$ci_muestra.(($positivo_negativo == 'P') ? ' (+'.$nom_gruponewmont.')' : ' (-'.$nom_gruponewmont.')')."', ";
              $q_SavePeso .= $peso_muestra.", ";
              $q_SavePeso .= "'".$usuario_peso."', ";
              $q_SavePeso .= "1)";

              if ($res = mysqli_query($enlace, $q_SavePeso)) {
                $estado = 1;

                // Obtiene el Id generado
                  $id_detalle_rack_peso = mysqli_insert_id($enlace);

                // Asignando el Blanco Fundente correspondiente
                  $q_idblancos = "SELECT  DR.Id,
                                          COUNT(DR.Id) AS _COUNT
                                    FROM  Detalle_Rack_Pesos DRP
                                          INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                                   WHERE  DRP.Id < ".$id_detalle_rack_peso."
                                     AND  DR.Rack_TipoMuestra = 2
                                     AND  DR.Id_TipoBlancoFundente = ".$tipo_blanco."
                                     AND  isNot_Regulo = 0
                                     AND  isNot_Dore = 0
                                  GROUP BY DR.Id
                                  HAVING COUNT(DR.Id) >= 2
                                  ORDER BY DR.Id DESC
                                  LIMIT 1";

                  if ($res_idblancos = mysqli_query($enlace, $q_idblancos)) {
                    if (mysqli_num_rows($res_idblancos) > 0) {
                      while($row_idblancos = mysqli_fetch_assoc($res_idblancos)) {
                        $id_idblanco = $row_idblancos["Id"];

                        // Asignando el Blanco correspondiente
                          $q_update = "UPDATE Detalle_Rack_Pesos
                                          SET Id_FactorBlanco_Ag = ".$id_idblanco."
                                        WHERE Id = ".$id_detalle_rack_peso;

                          if ($res_update = mysqli_query($enlace, $q_update)) {
                          }
                      }
                    }
                  }
              }
              else{
                $estado = 0;
              }
          }
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'cierre_Rack':
      $r = array();
      $estado = 0;

      $id_rack = $_GET["Id_Rack"];
      $usuario_rack = $_GET["Usuario_Rack"];

      $q_save = "UPDATE  Cabecera_Rack SET ";
      $q_save .= "  cierre_rack = 1, ";
      $q_save .= "  usuario_cierrerack = '".$usuario_rack."', ";
      $q_save .= "  fecha_cierrerack = '".$g_fecha."'";
      $q_save .= " WHERE Id = ".$id_rack;

      if ($res = mysqli_query($enlace, $q_save)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_ListaRacks_PesoRegulos':
      $r = array();
      $estado = 0;

      $fecha_inicio = $_GET["Fecha_Inicio"];
      $fecha_fin = $_GET["Fecha_Fin"];

      $q_Racks = "SELECT 0 AS ITEM,
                         CR.nom_rack,
                         CR.des_rack,
                         CR.fecha_cierrerack AS fecha_rack,
                         CR.usuario_cierrerack AS usuario_rack,
                         CR.Id,
                         (SELECT COUNT(DRP.Id) AS NUM_MUESTRAS
                            FROM  Detalle_Rack_Pesos DRP 
                           WHERE  DRP.Id_Detalle_Rack IN (SELECT Id
                                                            FROM Detalle_Rack
                                                           WHERE Id_Rack = CR.Id)) AS NUM_MUESTRAS,
                         CR.id_horno,
                         H.cod_horno,
                         H.capacidad_horno,
                         CR.cierre_pesoregulo
                    FROM Cabecera_Rack CR
                         INNER JOIN tbconfig_Hornos H ON CR.id_horno = H.Id
                   WHERE DATE(CR.fecha_rack) BETWEEN '".$fecha_inicio."' AND '".$fecha_fin."'
                     AND cierre_Rack = 1
                  ORDER BY CR.fecha_rack DESC";

      if ($res_Racks = mysqli_query($enlace, $q_Racks)) {
        if (mysqli_num_rows($res_Racks) > 0) {
          while($row_Racks = mysqli_fetch_assoc($res_Racks)) {
            array_push($r, $row_Racks);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaRackMuestras_PesoRegulo':
      $r = array();
      $estado = 0;

      $Id_Rack = $_GET["Id_Rack"];

      // $q_RackMuestras = "SELECT DRP.Num_Crisol,
      //                           RTM.nom_tipo AS TIPO,
      //                           DRP.nom_muestra,
      //                           TB.nom_tipoblanco,
      //                           CASE WHEN is_Newmont = 0
      //                             THEN DR.Dosificacion
      //                           ELSE CASE WHEN DRP.is_Newmont_Positivo = 1
      //                               THEN DR.Dosificacion
      //                                ELSE CASE WHEN DRP.is_Newmont_Negativo = 1
      //                                   THEN DR.Dosificacion_Negativo END END END AS Dosificacion,
      //                           DRP.Peso_Muestra,
      //                           DRP.Peso_Regulo,
      //                           DRP.Id,
      //                           CR.cierre_pesoregulo,
      //                           DRP.UsuarioPeso_Muestra,
      //                           DRP.FechaPeso_Muestra,
      //                           DRP.FechaPeso_Regulo,
      //                           DRP.UsuarioPeso_Regulo,
      //                           DRP.isNot_Regulo
      //                     FROM  Detalle_Rack DR
      //                           INNER JOIN Detalle_Rack_Pesos DRP ON DR.Id = DRP.Id_Detalle_Rack
      //                           INNER JOIN tbconfig_RackTipoMuestras RTM ON DR.Rack_TipoMuestra = RTM.Id
      //                           INNER JOIN tbconfig_RackTipoBlancoFundente TB ON DR.Id_TipoBlancoFundente = TB.Id
      //                           INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
      //                    WHERE  DR.Id_Rack = ".$Id_Rack;

      $q_RackMuestras = "SELECT DRP.Num_Crisol,
                                RTM.nom_tipo AS TIPO,
                                DRP.nom_muestra,
                                TB.nom_tipoblanco,
                                DRP.Dosificacion,
                                DRP.Peso_Muestra,
                                DRP.Peso_Regulo,
                                DRP.Id,
                                CR.cierre_pesoregulo,
                                DRP.UsuarioPeso_Muestra,
                                DRP.FechaPeso_Muestra,
                                DRP.FechaPeso_Regulo,
                                DRP.UsuarioPeso_Regulo,
                                DRP.isNot_Regulo,
                                DRP.isDesactivado_EnRack,
                                DRP.isObservado_Regulo,
                                
                                CONCAT(CASE WHEN isNot_ReguloDesactivadoEnRack_PorPositivoNewmont = 1
                                              OR isObservado_ReguloDesactivadoEnRack_PorPositivoNewmont = 1
                                          THEN '(Grupo Newmont Desactivado)'
                                       ELSE '' END, CASE WHEN isNot_ReguloDesactivadoEnRack_PorPositivoNewmont = 1
                                                           OR isObservado_ReguloDesactivadoEnRack_PorPositivoNewmont = 1
                                                      THEN CHAR(10)
                                                    ELSE '' END, CASE WHEN DRP.isNot_Regulo = 1
                                                                    THEN DRP.isNot_ReguloObservacion
                                                                 ELSE CASE WHEN DRP.isObservado_Regulo = 1
                                                                          THEN DRP.isObservado_ReguloObservacion
                                                                      ELSE ''
                                                                 END END) AS isObservado_DoreObservacion
                          FROM  Detalle_Rack DR
                                INNER JOIN Detalle_Rack_Pesos DRP ON DR.Id = DRP.Id_Detalle_Rack
                                INNER JOIN tbconfig_RackTipoMuestras RTM ON DR.Rack_TipoMuestra = RTM.Id
                                INNER JOIN tbconfig_RackTipoBlancoFundente TB ON DRP.Id_TipoBlancoFundente = TB.Id
                                INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
                         WHERE  DR.Id_Rack = ".$Id_Rack;

      if ($res_RackMuestras = mysqli_query($enlace, $q_RackMuestras)) {
        if (mysqli_num_rows($res_RackMuestras) > 0) {
          while($row_RackMuestras = mysqli_fetch_assoc($res_RackMuestras)) {
            array_push($r, $row_RackMuestras);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'guardar_PesosRegulo':
      $r = array();
      $estado = 0;

      $Id_Detalle_Peso = $_GET["Id_Detalle_Peso"];
      $Peso_Regulo = $_GET["Peso_Regulo"];
      $Usuario_Peso = $_GET["Usuario_Peso"];
      $Is_Observado = $_GET["Is_Observado"];

      // Para el peso de Muestras
        $observacion = '';

        $q_SavePeso = "UPDATE Detalle_Rack_Pesos
                          SET FechaPeso_Regulo = '".$g_fecha."',
                              Peso_Regulo = ".$Peso_Regulo.",
                              UsuarioPeso_Regulo = '".$Usuario_Peso."',
                              isObservado_Regulo = ".$Is_Observado.",
                              isObservado_ReguloObservacion = '".(($Is_Observado == 1) ? 'Muestra fuera de límite.' : $observacion)."'
                        WHERE Id = ".$Id_Detalle_Peso;

        if ($res = mysqli_query($enlace, $q_SavePeso)) {
          $estado = 1;

          // Si es observada entonces se debe generar la solicitud para el encargado
            if ($Is_Observado == 1){
              // Obteniendo nombre de muestra
                $q_muestra = "SELECT Nom_Muestra
                                FROM Detalle_Rack_Pesos
                               WHERE Id = ".$Id_Detalle_Peso;

                if ($res_muestra = mysqli_query($enlace, $q_muestra)) {
                  if (mysqli_num_rows($res_muestra) > 0) {
                    while($row_muestra = mysqli_fetch_assoc($res_muestra)) {
                      $nom_muestra = $row_muestra["Nom_Muestra"];
                    }
                  }
                }

              $q_Insert = "INSERT INTO Gestion_Solicitudes(Id_Solicitud, Id_Registro, usuario_solicitud, fecha_solicitud, observacion_solicitud) VALUES(";
              $q_Insert .= "2, ";
              $q_Insert .= $Id_Detalle_Peso.", ";
              $q_Insert .= "'".$Usuario_Peso."', ";
              $q_Insert .= "'".$g_fecha."', ";
              $q_Insert .= "'".'Muestra fuera de límite: "'.$nom_muestra.'". Peso de muestra: '.$Peso_Regulo." g')";

              if ($res = mysqli_query($enlace, $q_Insert)) {
              }
            }
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'cierre_PesoRegulos':
      $r = array();
      $estado = 0;

      $id_rack = $_GET["Id_Rack"];
      $usuario_cierrepesorack = $_GET["Usuario_CierrePesoRack"];

      $q_save = "UPDATE  Cabecera_Rack SET ";
      $q_save .= "  cierre_pesoregulo = 1, ";
      $q_save .= "  usuario_cierrepesoregulo = '".$usuario_cierrepesorack."', ";
      $q_save .= "  fecha_cierrepesoregulo = '".$g_fecha."'";
      $q_save .= " WHERE Id = ".$id_rack;

      if ($res = mysqli_query($enlace, $q_save)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_ListaRacks_PesoDore':
      $r = array();
      $estado = 0;

      $fecha_inicio = $_GET["Fecha_Inicio"];
      $fecha_fin = $_GET["Fecha_Fin"];

      $q_Racks = "SELECT 0 AS ITEM, CR.nom_rack,
                         CR.des_rack, CR.fecha_cierrepesoregulo AS fecha_rack,
                         CR.usuario_cierrepesoregulo AS usuario_rack, CR.Id,
                         (SELECT COUNT(DRP.Id) AS NUM_MUESTRAS
                            FROM  Detalle_Rack_Pesos DRP 
                           WHERE  DRP.Id_Detalle_Rack IN (SELECT Id
                                                            FROM Detalle_Rack
                                                           WHERE Id_Rack = CR.Id)) AS NUM_MUESTRAS,
                         CR.id_horno,
                         H.cod_horno,
                         H.capacidad_horno
                    FROM Cabecera_Rack CR
                         INNER JOIN tbconfig_Hornos H ON CR.id_horno = H.Id
                   WHERE DATE(CR.fecha_rack) BETWEEN '".$fecha_inicio."' AND '".$fecha_fin."'
                     AND cierre_pesoregulo = 1
                  ORDER BY CR.fecha_rack DESC";

      if ($res_Racks = mysqli_query($enlace, $q_Racks)) {
        if (mysqli_num_rows($res_Racks) > 0) {
          while($row_Racks = mysqli_fetch_assoc($res_Racks)) {
            array_push($r, $row_Racks);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaRackMuestras_PesoDore':
      $r = array();
      $estado = 0;

      $Id_Rack = $_GET["Id_Rack"];

      $q_RackMuestras = "SELECT Num_Crisol,
                                TIPO,
                                CRISOL,
                                nom_muestra,
                                nom_tipoblanco,
                                Dosificacion,
                                Peso_Muestra,
                                Peso_Regulo,
                                Peso_Dore,
                                Id,
                                cierre_pesodore,
                                UsuarioPeso_Muestra,
                                FechaPeso_Muestra,
                                FechaPeso_Regulo,
                                UsuarioPeso_Regulo,
                                FechaPeso_Dore,
                                UsuarioPeso_Dore,
                                isNot_Regulo,
                                isNot_ReguloObservacion,
                                isDesactivado_EnRack,
                                isObservado_Regulo,
                                isObservado_ReguloObservacion,
                                isNot_Dore,
                                isObservado_Dore,
                                
                                CASE WHEN isObservado_DoreFactorPlata = 1
                                  THEN CASE WHEN LENGTH(isObservado_DoreObservacion) > 0
                                        THEN CONCAT('- ', isObservado_DoreObservacion, CHAR(10), '- Conf.Ag de Blanco Fuera de Límite')
                                       ELSE '- Conf.Ag de Blanco Fuera de Límite' END
                                ELSE isObservado_DoreObservacion END AS isObservado_DoreObservacion,

                                Conf_Ag_Dore,
                                Id_Detalle_Rack
                            
                          FROM  (SELECT DRP.Num_Crisol,
                                        RTM.nom_tipo AS TIPO,
                                        DRP.NumCrisol_Dore AS CRISOL,
                                        DRP.nom_muestra,
                                        TB.nom_tipoblanco,
                                        DRP.Dosificacion,
                                        DRP.Peso_Muestra,
                                        DRP.Peso_Regulo,
                                        DRP.Peso_Dore,
                                        DRP.Id,
                                        CR.cierre_pesodore,
                                        DRP.UsuarioPeso_Muestra,
                                        DRP.FechaPeso_Muestra,
                                        DRP.FechaPeso_Regulo,
                                        DRP.UsuarioPeso_Regulo,
                                        DRP.FechaPeso_Dore,
                                        DRP.UsuarioPeso_Dore,
                                        DRP.isNot_Regulo,
                                        DRP.isNot_ReguloObservacion,
                                        DRP.isDesactivado_EnRack,
                                        DRP.isObservado_Regulo,
                                        DRP.isObservado_ReguloObservacion,
                                        DRP.isNot_Dore,
                                        DRP.isObservado_Dore,
                                        DRP.isObservado_DoreFactorPlata,
                                        
                                        CONCAT(CASE WHEN isNot_DoreDesactivadoEnRack_PorPositivoNewmont = 1
                                                      OR isObservado_DoreDesactivadoEnRack_PorPositivoNewmont = 1
                                                      OR isNot_ReguloDesactivadoEnRack_PorPositivoNewmont = 1
                                                      OR isObservado_ReguloDesactivadoEnRack_PorPositivoNewmont = 1
                                                  THEN '(Grupo Newmont Desactivado)'
                                               ELSE '' END, CASE WHEN isNot_DoreDesactivadoEnRack_PorPositivoNewmont = 1
                                                                   OR isObservado_DoreDesactivadoEnRack_PorPositivoNewmont = 1
                                                                   OR isNot_ReguloDesactivadoEnRack_PorPositivoNewmont = 1
                                                                   OR isObservado_ReguloDesactivadoEnRack_PorPositivoNewmont = 1
                                                              THEN CHAR(10)
                                                            ELSE '' END, CASE WHEN DRP.isNot_Dore = 1
                                                                            THEN DRP.isNot_DoreObservacion
                                                                         ELSE CASE WHEN DRP.isObservado_Dore = 1
                                                                                  THEN DRP.isObservado_DoreObservacion
                                                                              ELSE ''
                                                                         END END) AS isObservado_DoreObservacion,

                                        ROUND(DRP.Conf_Ag_Dore, 2) AS Conf_Ag_Dore,
                                        DRP.Id_Detalle_Rack
                                  FROM  Detalle_Rack DR
                                        INNER JOIN Detalle_Rack_Pesos DRP ON DR.Id = DRP.Id_Detalle_Rack
                                        INNER JOIN tbconfig_RackTipoMuestras RTM ON DR.Rack_TipoMuestra = RTM.Id
                                        INNER JOIN tbconfig_RackTipoBlancoFundente TB ON DRP.Id_TipoBlancoFundente = TB.Id
                                        INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
                                 WHERE  DR.Id_Rack = ".$Id_Rack.") AS DATOS";

      if ($res_RackMuestras = mysqli_query($enlace, $q_RackMuestras)) {
        if (mysqli_num_rows($res_RackMuestras) > 0) {
          while($row_RackMuestras = mysqli_fetch_assoc($res_RackMuestras)) {
            array_push($r, $row_RackMuestras);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'guardar_PesosDore':
      $r = array();
      $estado = 0;

      $Id_Rack = $_GET["Id_Rack"];
      $Id_Detalle_Peso = $_GET["Id_Detalle_Peso"];
      $Peso_Dore = $_GET["Peso_Dore"];
      $Usuario_Peso = $_GET["Usuario_Peso"];

      // Guarda el peso de Doré
        $q_SavePeso = "UPDATE Detalle_Rack_Pesos
                          SET FechaPeso_Dore = '".$g_fecha."',
                              Peso_Dore = ".$Peso_Dore.",
                              UsuarioPeso_Dore = '".$Usuario_Peso."'
                        WHERE Id = ".$Id_Detalle_Peso;

        if ($res = mysqli_query($enlace, $q_SavePeso)) {
          $estado = 1;

          // Calculando la ley de Plata Sin Peso de Oro
            // 1. Identificando el Tipo de Blanco de la Muestra
              $q_tipoblanco = "SELECT DR.Rack_TipoMuestra,
                                      DRP.Id_TipoBlancoFundente,
                                      DRP.Peso_Muestra,
                                      DRP.Id_Detalle_Rack
                                FROM  Detalle_Rack_Pesos DRP
                                      INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                               WHERE  DRP.Id = ".$Id_Detalle_Peso;

              if ($res_tipoblanco = mysqli_query($enlace, $q_tipoblanco)) {
                if (mysqli_num_rows($res_tipoblanco) > 0) {
                  while($row_tipoblanco = mysqli_fetch_assoc($res_tipoblanco)) {
                    $id_tipoblancofundente = $row_tipoblanco["Id_TipoBlancoFundente"];
                    $peso_muestra = $row_tipoblanco["Peso_Muestra"];
                    $id_tipomuestra = $row_tipoblanco["Rack_TipoMuestra"];
                    $id_detalle_rack = $row_tipoblanco["Id_Detalle_Rack"];
                  }
                }
              }

            // Solo para el tipo de muestra: "Blanco Fundente"
              if ($id_tipomuestra == 2){
                // 1. Actualizando datos de leyes
                  $q_update = "UPDATE Detalle_Rack_Pesos
                                  SET Ley_Ag = ".(($Peso_Dore / $peso_muestra) * 1000000).",
                                      Ley_Ag_oz = ".((($Peso_Dore / $peso_muestra) * 1000000) / 34.285)."
                                WHERE Id = ".$Id_Detalle_Peso;

                  if ($res_update = mysqli_query($enlace, $q_update)) {
                  }

                // 2. Obteniendo el item a partir del cual se asignarán los datos
                  $q_id = "SELECT MAX(DRP.Id) AS ID,
                                  COUNT(Id) AS _COUNT
                             FROM Detalle_Rack_Pesos DRP
                            WHERE DRP.Id_Detalle_Rack IN (SELECT  _DRP.Id_Detalle_Rack
                                                            FROM  Detalle_Rack_Pesos _DRP
                                                           WHERE  _DRP.Id = ".$Id_Detalle_Peso.")";

                  if ($res_id = mysqli_query($enlace, $q_id)) {
                    if (mysqli_num_rows($res_id) > 0) {
                      while($row_id = mysqli_fetch_assoc($res_id)) {
                        $id_desde = $row_id["ID"];
                        $num_blancos = $row_id["_COUNT"];
                      }
                    }
                  }

                // 3. Verificando que los blancos tengan todos sus pesos de Doré registrados
                  $d = 0;
                  $total_dore = 0;
                  $is_completo = 0;

                  $q_blancodore = "SELECT  Peso_Dore
                                     FROM  Detalle_Rack_Pesos
                                    WHERE  Id_Detalle_Rack = ".$id_detalle_rack;

                  if ($res_blancodore = mysqli_query($enlace, $q_blancodore)) {
                    if (mysqli_num_rows($res_blancodore) > 0) {
                      while($row_blancodore = mysqli_fetch_assoc($res_blancodore)) {
                        $peso_dore = $row_blancodore["Peso_Dore"];

                        if ($peso_dore != null){
                          $total_dore += $peso_dore;

                          $d += 1;
                        }
                      }

                      // 4. Verifica que todos los pesos de Doré hayan sido pesados
                        if ($num_blancos == $d){
                          $factor = $total_dore / $num_blancos;

                          $is_completo = 1;
                        }
                    }
                  }

                // 5. Si los pesos de Dore están completos actualiza los datos de las muestras siguientes
                  if ($is_completo == 1){
                    // 6. Buscando el último Id de las muestras a actualizar
                      $q_idhasta_x = "SELECT  DRP.Id_Detalle_Rack
                                        FROM  Detalle_Rack_Pesos DRP
                                          INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                                              INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
                                       WHERE  DRP.Id > ".$id_desde."
                                         AND  DR.Rack_TipoMuestra = 2
                                         AND  DRP.Id_TipoBlancoFundente = ".$id_tipoblancofundente."
                                      GROUP BY DRP.Id_Detalle_Rack
                                      HAVING  COUNT(DRP.Id_Detalle_Rack) >= 2
                                      ORDER BY DRP.Id_Detalle_Rack LIMIT 1";

                      if ($res_idhasta_x = mysqli_query($enlace, $q_idhasta_x)) {
                        if (mysqli_num_rows($res_idhasta_x) > 0) {
                          while($row_idhasta_x = mysqli_fetch_assoc($res_idhasta_x)) {
                            // 7. Obtiene el Id final
                              $q_idhasta = "SELECT  Id
                                              FROM  Detalle_Rack_Pesos
                                             WHERE  Id_Detalle_Rack = ".$row_idhasta_x["Id_Detalle_Rack"]."
                                            ORDER BY Id LIMIT 1";

                              // if ($res_idhasta = mysqli_query($enlace, $q_idhasta)) {
                              //   if (mysqli_num_rows($res_idhasta) > 0) {
                              //     while($row_idhasta = mysqli_fetch_assoc($res_idhasta)) {
                              //       $id_hasta = $row_idhasta["Id"];
                              //     }
                              //   }
                              // }
                          }
                        }
                        else{
                          $q_idhasta = "SELECT  Id
                                          FROM  Detalle_Rack_Pesos
                                        ORDER BY Id DESC LIMIT 1";
                        }
                      }

                      if ($res_idhasta = mysqli_query($enlace, $q_idhasta)) {
                        if (mysqli_num_rows($res_idhasta) > 0) {
                          while($row_idhasta = mysqli_fetch_assoc($res_idhasta)) {
                            $id_hasta = $row_idhasta["Id"];
                          }
                        }
                      }

                    // 7. Obteniendo los Id's que serán actualizados
                      $id_in = '';
                      $id_detalle_rack_x = '';

                      $q_idin = "SELECT  DRP.Id,
                                         DRP.Id_Detalle_Rack
                                   FROM  Detalle_Rack_Pesos DRP
                                         INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                                  WHERE  DRP.Id > ".$id_desde."
                                    AND  DRP.Id < ".$id_hasta."
                                    AND  DRP.Id_TipoBlancoFundente = ".$id_tipoblancofundente."
                                    AND  DR.Rack_TipoMuestra <> 2";

                      if ($res_idin = mysqli_query($enlace, $q_idin)) {
                        if (mysqli_num_rows($res_idin) > 0) {
                          while($row_idin = mysqli_fetch_assoc($res_idin)) {
                            $id_in .= $row_idin["Id"].', ';

                            if (strpos($id_detalle_rack_x, $row_idin["Id_Detalle_Rack"]) === false){
                              $id_detalle_rack_x .= $row_idin["Id_Detalle_Rack"].'|';
                            }
                          }
                        }
                      }

                      $id_in = substr($id_in, 0, -2);

                      if (strlen($id_detalle_rack_x) > 0){
                        $id_detalle_rack_x = substr($id_detalle_rack_x, 0, -1);
                      }

                    // 8. Actualizando los datos
                      $q_update = "UPDATE Detalle_Rack_Pesos
                                      SET Id_FactorBlanco_Ag = ".$id_detalle_rack.",
                                          FactorBlanco_Ag = ".$factor.",
                                          Ley_Ag = ((Peso_Dore - ".$factor.") / Peso_Muestra) * 1000000,
                                          Ley_Ag_oz = (((Peso_Dore - ".$factor.") / Peso_Muestra) * 1000000) / 34.285
                                    WHERE Id IN (".$id_in.")";

                      if ($res_update = mysqli_query($enlace, $q_update)) {
                        // Recorre las muestras afectadas y actualiza el Config. Ag Doré
                          if (strlen($id_detalle_rack_x) > 0){
                            $a = 0;
                            $arr_iddetallerack = explode("|", $id_detalle_rack_x);

                            while ($a < count($arr_iddetallerack)){
                              $q_maxmin = "SELECT MAX(Ley_Ag_oz) AS _MAX,
                                                  MIN(Ley_Ag_oz) AS _MIN
                                             FROM Detalle_Rack_Pesos
                                            WHERE Id_Detalle_Rack = ".$arr_iddetallerack[$a];

                              if ($res_maxmin = mysqli_query($enlace, $q_maxmin)) {
                                if (mysqli_num_rows($res_maxmin) > 0) {
                                  while($row_maxmin = mysqli_fetch_assoc($res_maxmin)) {
                                    $max = $row_maxmin["_MAX"];
                                    $min = $row_maxmin["_MIN"];

                                    if (strlen($max) > 0 && strlen($min) > 0){
                                      $config_ag = $max - $min;
                                    }
                                    else{
                                      $config_ag = 'NULL';
                                    }

                                    $q_updateconfig = "UPDATE Detalle_Rack_Pesos
                                                          SET Conf_Ag_Dore = CASE WHEN is_Newmont_Positivo = 1 THEN 0 ELSE ".$config_ag." END
                                                        WHERE Id_Detalle_Rack = ".$arr_iddetallerack[$a];

                                    if ($res_updateconfig = mysqli_query($enlace, $q_updateconfig)) {
                                    }
                                  }
                                }
                              }

                              $a += 1;
                            }
                          }
                      }
                  }
              }
              else{
                // 2. Encontrando el grupo de Blancos en las muestras anteriores
                  $x = 1;

                  $q_idblancos = "SELECT  DR.Id,
                                          COUNT(DR.Id) AS _COUNT
                                    FROM  Detalle_Rack_Pesos DRP
                                          INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                                   WHERE  DRP.Id < ".$Id_Detalle_Peso."
                                     AND  DR.Rack_TipoMuestra = 2
                                     AND  DR.Id_TipoBlancoFundente = ".$id_tipoblancofundente."
                                     AND  isNot_Regulo = 0
                                     AND  isNot_Dore = 0
                                  GROUP BY DR.Id
                                  HAVING COUNT(DR.Id) >= 2
                                  ORDER BY DR.Id DESC";

                  if ($res_idblancos = mysqli_query($enlace, $q_idblancos)) {
                    if (mysqli_num_rows($res_idblancos) > 0) {
                      while($row_idblancos = mysqli_fetch_assoc($res_idblancos)) {
                        $id_idblancos = $row_idblancos["Id"];
                        $num_blancos = $row_idblancos["_COUNT"];

                        // 3. Actualiza el código de Blanco correspondiente a la muestra
                          if ($x == 1){
                            $q_updateidblanco = "UPDATE Detalle_Rack_Pesos
                                                    SET Id_FactorBlanco_Ag = ".$id_idblancos."
                                                  WHERE Id = ".$Id_Detalle_Peso;

                            if ($res_updateidblanco = mysqli_query($enlace, $q_updateidblanco)) {
                            }
                          }

                        // 4. Verificando que los blancos tengan todos sus peso de Doré registrados
                          $d = 0;
                          $total_dore = 0;

                          $q_blancodore = "SELECT  Peso_Dore
                                             FROM  Detalle_Rack_Pesos
                                            WHERE  Id_Detalle_Rack = ".$id_idblancos;

                          if ($res_blancodore = mysqli_query($enlace, $q_blancodore)) {
                            if (mysqli_num_rows($res_blancodore) > 0) {
                              while($row_blancodore = mysqli_fetch_assoc($res_blancodore)) {
                                $peso_dore = $row_blancodore["Peso_Dore"];

                                if ($peso_dore != null){
                                  $total_dore += $peso_dore;

                                  $d += 1;
                                }
                              }

                              // 5. Verifica que todos los pesos de Doré hayan sido pesados
                                if ($num_blancos == $d){
                                  $factor = $total_dore / $num_blancos;

                                  // 6. Actualizando factor y datos en la tabla de Pesos
                                    $q_update = "UPDATE Detalle_Rack_Pesos
                                                    SET FactorBlanco_Ag = ".$factor.",
                                                        Ley_Ag = ".((($Peso_Dore - $factor) / $peso_muestra) * 1000000).",
                                                        Ley_Ag_oz = ".(((($Peso_Dore - $factor) / $peso_muestra) * 1000000) / 34.285)."
                                                  WHERE Id = ".$Id_Detalle_Peso;

                                    if ($res_update = mysqli_query($enlace, $q_update)) {
                                      break;
                                    }
                                }
                            }
                          }

                        $x += 1;
                      }
                    }
                  }
              }
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_Diferencia_PesoDore_Old':
      $r = array();
      $estado = 0;
      $diferencias = "";

      $id_detallepeso = $_GET["id_detallepeso"];
      $nom_muestra = str_replace('*', '+', $_GET["nom_muestra"]);
      $tipo_muestra = $_GET["tipo_muestra"];

      // Identificando muestras Newmont Positivas y/o Negativas
        $positivo = strpos($nom_muestra, '(+');
        $negativo = strpos($nom_muestra, '(-');

      $q_diferencias = "SELECT  DRP.Num_Crisol,
                                DRP.Peso_Dore
                          FROM  Detalle_Rack_Pesos DRP
                         WHERE  1 = 1";

      if ($positivo === false && $negativo === false){
        $q_diferencias .= "   AND  DRP.Id_Detalle_Rack IN (SELECT  Id_Detalle_Rack
                                                            FROM  Detalle_Rack_Pesos
                                                           WHERE  Id = ".$id_detallepeso.")";
      }
      else{
        $q_diferencias .= "   AND  DRP.Nom_Muestra = '".$nom_muestra."'";
      }

      $q_diferencias .= "ORDER BY Num_Crisol";

      if ($res_diferencias = mysqli_query($enlace, $q_diferencias)) {
        if (mysqli_num_rows($res_diferencias) > 0) {
          while($row_diferencias = mysqli_fetch_assoc($res_diferencias)) {
            $diferencias .= $row_diferencias["Num_Crisol"].'*'.$row_diferencias["Peso_Dore"].'|';
          }

          $diferencias = substr($diferencias, 0, -1);

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'diferencia' => $diferencias));

      break;

    case 'get_Diferencia_PesoDore':
      $r = array();
      $estado = 0;

      $id_rack = $_GET["Id_Rack"];
      $id_detallepeso = $_GET["Id_Detalle_Peso"];

      // Identificando si es una muestra Newmont Negativa
        $is_negativo = '';

        $q_negativo = "SELECT is_Newmont_Negativo
                         FROM Detalle_Rack_Pesos
                        WHERE Id = ".$id_detallepeso;

        if ($res_negativo = mysqli_query($enlace, $q_negativo)) {
          if (mysqli_num_rows($res_negativo) > 0) {
            while($row_negativo = mysqli_fetch_assoc($res_negativo)) {
              $is_negativo = $row_negativo["is_Newmont_Negativo"];
            }
          }
        }

      // Verifica que no hayan muestras con Doré sin pesar
        $q_sindore = "SELECT  COUNT(Id) AS _COUNT
                        FROM  Detalle_Rack_Pesos
                       WHERE  Id_Detalle_Rack IN (SELECT  Id_Detalle_Rack
                                                    FROM  Detalle_Rack_Pesos
                                                   WHERE  Id = ".$id_detallepeso.")";

        if ($is_negativo == 1){
          $q_sindore .= "   AND is_Newmont_Negativo = 1";
        }

        $q_sindore .= "   AND  Ley_Ag_oz IS NULL";

        if ($res_sindore = mysqli_query($enlace, $q_sindore)) {
          if (mysqli_num_rows($res_sindore) > 0) {
            while($row_sindore = mysqli_fetch_assoc($res_sindore)) {
              if ($row_sindore["_COUNT"] > 0){
                $estado = 2;
              }
              else{
                // Identificando el Tipo de Muestra
                  $q_tipomuestra = "SELECT  DR.Rack_TipoMuestra
                                      FROM  Detalle_Rack_Pesos DRP
                                            INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                                     WHERE  DRP.Id = ".$id_detallepeso;

                  if ($res_tipomuestra = mysqli_query($enlace, $q_tipomuestra)) {
                    if (mysqli_num_rows($res_tipomuestra) > 0) {
                      while($row_tipomuestra = mysqli_fetch_assoc($res_tipomuestra)) {
                        $id_tipomuestra = $row_tipomuestra["Rack_TipoMuestra"];
                      }
                    }
                  }

                // Obtiene el factor Máximo de Plata
                  if ($id_tipomuestra == 2){
                    $q_getfactorplata = "SELECT MAX(Ley_Ag) AS _MAX,
                                                MIN(Ley_Ag) AS _MIN";
                  }
                  else{
                    $q_getfactorplata = "SELECT MAX(Ley_Ag_oz) AS _MAX,
                                                MIN(Ley_Ag_oz) AS _MIN";
                  }

                  $q_getfactorplata .= " FROM  Detalle_Rack_Pesos
                                        WHERE  Id_Detalle_Rack IN (SELECT  Id_Detalle_Rack
                                                                     FROM  Detalle_Rack_Pesos
                                                                    WHERE  Id = ".$id_detallepeso.")";

                  if ($is_negativo == 1){
                    $q_getfactorplata .= "   AND is_Newmont_Negativo = 1";
                  }

                if ($res_getfactorplata = mysqli_query($enlace, $q_getfactorplata)) {
                  if (mysqli_num_rows($res_getfactorplata) > 0) {
                    while($row_getfactorplata = mysqli_fetch_assoc($res_getfactorplata)) {
                      $getfactorplata = round($row_getfactorplata["_MAX"] - $row_getfactorplata["_MIN"], 2);

                      // Obtiene Id_Detalle_Rack
                        $q_iddetallerack = "SELECT  Id_Detalle_Rack
                                              FROM  Detalle_Rack_Pesos
                                             WHERE  Id = ".$id_detallepeso;

                        if ($res_iddetallerack = mysqli_query($enlace, $q_iddetallerack)) {
                          if (mysqli_num_rows($res_iddetallerack) > 0) {
                            while($row_iddetallerack = mysqli_fetch_assoc($res_iddetallerack)) {
                              $id_detallerack = $row_iddetallerack["Id_Detalle_Rack"];
                            }
                          }
                        }

                      // Actualizando Factor (Config Ag - Doré) en tabla de Pesos
                        $q_update = "UPDATE Detalle_Rack_Pesos
                                        SET Conf_Ag_Dore = CASE WHEN is_Newmont_Positivo = 1 THEN 0 ELSE ".$getfactorplata." END
                                      WHERE Id_Detalle_Rack = ".$id_detallerack."
                                        AND is_Newmont_Positivo = 0";

                        if ($res_update = mysqli_query($enlace, $q_update)) {
                          $estado = 1;
                        }
                    }
                  }
                }
              }
            }
          }
        }

      echo json_encode(array('estado' => $estado, 'factor' => $getfactorplata));

      break;

    case 'update_ObservadoDore':
      $r = array();
      $estado = 0;

      $id_detallepeso = $_GET["id_detallepeso"];
      $nom_muestra = $_GET["nom_muestra"];
      $factor_plata = $_GET["factor_plata"];
      $usuario_observacion = $_GET["usuario_observacion"];

      // Obtiene el código de Rack
        $q_iddetallerack = "SELECT  DR.Rack_TipoMuestra,
                                    DRP.Id_Detalle_Rack
                              FROM  Detalle_Rack_Pesos DRP
                                    INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                             WHERE  DRP.Id = ".$id_detallepeso;

        if ($res_iddetallerack = mysqli_query($enlace, $q_iddetallerack)) {
          if (mysqli_num_rows($res_iddetallerack) > 0) {
            while($row_iddetallerack = mysqli_fetch_assoc($res_iddetallerack)) {
              $id_tipomuestra = $row_iddetallerack["Rack_TipoMuestra"];
              $id_detallerack = $row_iddetallerack["Id_Detalle_Rack"];
            }
          }
        }

      // Para el peso de Muestras
        $q_update = "UPDATE Detalle_Rack_Pesos
                        SET isObservado_Dore = 1,
                            isObservado_DoreObservacion = '- ".(($id_tipomuestra == 2) ? 'Blanco Fundente' : 'Muestra')." Fuera de límite, desviación de Conf.Ag: ".$factor_plata."'
                      WHERE Id_Detalle_Rack = ".$id_detallerack;

        if ($res = mysqli_query($enlace, $q_update)) {
          $estado = 1;

          // Si la observación es para un blanco (Tipo 2) se deben afectar a todas sus muestras afectadas
            if ($id_tipomuestra == 2){
              $q_observados = "UPDATE Detalle_Rack_Pesos
                                  SET isObservado_DoreFactorPlata = 1
                                WHERE Id_FactorBlanco_Ag = ".$id_detallerack;

              if ($res_observados = mysqli_query($enlace, $q_observados)) {
              }
            }

          // Generando solicitud de Reanálisis
            $q_Insert = "INSERT INTO Gestion_Solicitudes(Id_Solicitud, Id_Registro, usuario_solicitud, fecha_solicitud, observacion_solicitud) VALUES(";
              $q_Insert .= (($id_tipomuestra == 2) ? "4, " : "3, ");
              $q_Insert .= $id_detallepeso.", ";
              $q_Insert .= "'".$usuario_observacion."', ";
              $q_Insert .= "'".$g_fecha."', ";
              $q_Insert .= "'".(($id_tipomuestra == 2) ? 'Blanco Fundente' : 'Muestra').' Fuera de límite, desviación de Conf.Ag: "'.$factor_plata.'"'."'".')';

              if ($res = mysqli_query($enlace, $q_Insert)) {
              }
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'guardar_PesosOro':
      $r = array();
      $estado = 0;

      $Id_Rack = $_GET["Id_Rack"];
      $Id_Detalle_Peso = $_GET["Id_Detalle_Peso"];
      $Peso_Au = $_GET["Peso_Oro"];
      $Usuario_Peso = $_GET["Usuario_Peso"];

      // Guarda el peso de Doré
        $q_SavePeso = "UPDATE Detalle_Rack_Pesos
                          SET FechaPeso_Au = '".$g_fecha."',
                              Peso_Au = ".$Peso_Au.",
                              UsuarioPeso_Au = '".$Usuario_Peso."'
                        WHERE Id = ".$Id_Detalle_Peso;

        if ($res = mysqli_query($enlace, $q_SavePeso)) {
          $estado = 1;

          // Calculando la ley de Oro
            // 1. Identificando el Tipo de Blanco de la Muestra
              $q_tipoblanco = "SELECT DR.Rack_TipoMuestra,
                                      DRP.Id_TipoBlancoFundente,
                                      DRP.Peso_Muestra,
                                      DRP.Id_Detalle_Rack
                                FROM  Detalle_Rack_Pesos DRP
                                      INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                               WHERE  DRP.Id = ".$Id_Detalle_Peso;

              if ($res_tipoblanco = mysqli_query($enlace, $q_tipoblanco)) {
                if (mysqli_num_rows($res_tipoblanco) > 0) {
                  while($row_tipoblanco = mysqli_fetch_assoc($res_tipoblanco)) {
                    $id_tipoblancofundente = $row_tipoblanco["Id_TipoBlancoFundente"];
                    $peso_muestra = $row_tipoblanco["Peso_Muestra"];
                    $id_tipomuestra = $row_tipoblanco["Rack_TipoMuestra"];
                    $id_detalle_rack = $row_tipoblanco["Id_Detalle_Rack"];
                  }
                }
              }

            // Solo para el tipo de muestra: "Blanco Fundente"
              if ($id_tipomuestra == 2){
                // 1. Actualizando datos de leyes
                  $q_update = "UPDATE Detalle_Rack_Pesos
                                  SET Ley_Au = ".(($Peso_Au / $peso_muestra) * 1000000).",
                                      Ley_Au_oz = ".((($Peso_Au / $peso_muestra) * 1000000) / 34.285).",
                                      Ley_Ag_New = ((Peso_Dore - Peso_Au) / Peso_Muestra) * 1000000,
                                      Ley_Ag_oz_New = (((Peso_Dore - Peso_Au) / Peso_Muestra) * 1000000) / 34.285
                                WHERE Id = ".$Id_Detalle_Peso;

                  if ($res_update = mysqli_query($enlace, $q_update)) {
                  }

                // 2. Obteniendo el item a partir del cual se asignarán los datos
                  $q_id = "SELECT MAX(DRP.Id) AS ID,
                                  COUNT(Id) AS _COUNT
                             FROM Detalle_Rack_Pesos DRP
                            WHERE DRP.Id_Detalle_Rack IN (SELECT  _DRP.Id_Detalle_Rack
                                                            FROM  Detalle_Rack_Pesos _DRP
                                                           WHERE  _DRP.Id = ".$Id_Detalle_Peso.")";

                  if ($res_id = mysqli_query($enlace, $q_id)) {
                    if (mysqli_num_rows($res_id) > 0) {
                      while($row_id = mysqli_fetch_assoc($res_id)) {
                        $id_desde = $row_id["ID"];
                        $num_blancos = $row_id["_COUNT"];
                      }
                    }
                  }

                // 3. Verificando que los blancos tengan todos sus pesos de Doré registrados
                  $d = 0;
                  $total_dore = 0;
                  $is_completo = 0;

                  $q_blancoau = "SELECT  Peso_Au
                                   FROM  Detalle_Rack_Pesos
                                  WHERE  Id_Detalle_Rack = ".$id_detalle_rack;

                  if ($res_blancoau = mysqli_query($enlace, $q_blancoau)) {
                    if (mysqli_num_rows($res_blancoau) > 0) {
                      while($row_blancoau = mysqli_fetch_assoc($res_blancoau)) {
                        $peso_au = $row_blancoau["Peso_Au"];

                        if ($peso_au != null){
                          $total_au += $peso_au;

                          $d += 1;
                        }
                      }

                      // 4. Verifica que todos los pesos de Doré hayan sido pesados
                        if ($num_blancos == $d){
                          $factor = $total_au / $num_blancos;
                          $factor = floatval($factor);

                          $is_completo = 1;
                        }
                    }
                  }

                // 5. Si los pesos de Dore están completos actualiza los datos de las muestras siguientes
                  if ($is_completo == 1){
                    // 6. Buscando el último Id de las muestras a actualizar
                      $q_idhasta_x = "SELECT  DRP.Id_Detalle_Rack
                                        FROM  Detalle_Rack_Pesos DRP
                                              INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                                              INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
                                       WHERE  DRP.Id > ".$id_desde."
                                         AND  DR.Rack_TipoMuestra = 2
                                         AND  DRP.Id_TipoBlancoFundente = ".$id_tipoblancofundente."
                                      GROUP BY DRP.Id_Detalle_Rack
                                      HAVING  COUNT(DRP.Id_Detalle_Rack) >= 2
                                      ORDER BY DRP.Id_Detalle_Rack LIMIT 1";

                      if ($res_idhasta_x = mysqli_query($enlace, $q_idhasta_x)) {
                        if (mysqli_num_rows($res_idhasta_x) > 0) {
                          while($row_idhasta_x = mysqli_fetch_assoc($res_idhasta_x)) {
                            // 7. Obtiene el Id final
                              $q_idhasta = "SELECT  Id
                                              FROM  Detalle_Rack_Pesos
                                             WHERE  Id_Detalle_Rack = ".$row_idhasta_x["Id_Detalle_Rack"]."
                                            ORDER BY Id LIMIT 1";

                              // if ($res_idhasta = mysqli_query($enlace, $q_idhasta)) {
                              //   if (mysqli_num_rows($res_idhasta) > 0) {
                              //     while($row_idhasta = mysqli_fetch_assoc($res_idhasta)) {
                              //       $id_hasta = $row_idhasta["Id"];
                              //     }
                              //   }
                              // }
                          }
                        }
                        else{
                          $q_idhasta = "SELECT  Id
                                          FROM  Detalle_Rack_Pesos
                                        ORDER BY Id DESC LIMIT 1";
                        }
                      }

                      if ($res_idhasta = mysqli_query($enlace, $q_idhasta)) {
                        if (mysqli_num_rows($res_idhasta) > 0) {
                          while($row_idhasta = mysqli_fetch_assoc($res_idhasta)) {
                            $id_hasta = $row_idhasta["Id"];
                          }
                        }
                      }

                    // 7. Obteniendo los Id's que serán actualizados
                      $id_in = '';
                      $id_detalle_rack_x = '';

                      $q_idin = "SELECT  DRP.Id,
                                         DRP.Id_Detalle_Rack
                                   FROM  Detalle_Rack_Pesos DRP
                                         INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                                  WHERE  DRP.Id > ".$id_desde."
                                    AND  DRP.Id < ".$id_hasta."
                                    AND  DRP.Id_TipoBlancoFundente = ".$id_tipoblancofundente."
                                    AND  DR.Rack_TipoMuestra <> 2";

                      if ($res_idin = mysqli_query($enlace, $q_idin)) {
                        if (mysqli_num_rows($res_idin) > 0) {
                          while($row_idin = mysqli_fetch_assoc($res_idin)) {
                            $id_in .= $row_idin["Id"].', ';

                            if (strpos($id_detalle_rack_x, $row_idin["Id_Detalle_Rack"]) === false){
                              $id_detalle_rack_x .= $row_idin["Id_Detalle_Rack"].'|';
                            }
                          }
                        }
                      }

                      $id_in = substr($id_in, 0, -2);

                      if (strlen($id_detalle_rack_x) > 0){
                        $id_detalle_rack_x = substr($id_detalle_rack_x, 0, -1);
                      }

                    // 8. Actualizando los datos
                      $q_update = "UPDATE Detalle_Rack_Pesos
                                      SET FactorBlanco_Au = ".$factor.",
                                          Ley_Au = ((Peso_Au - ".$factor.") / Peso_Muestra) * 1000000,
                                          Ley_Au_oz = (((Peso_Au - ".$factor.") / Peso_Muestra) * 1000000) / 34.285,
                                          Ley_Ag_New = ((Peso_Dore - (Peso_Au + FactorBlanco_Ag)) / Peso_Muestra) * 1000000,
                                          Ley_Ag_oz_New = (((Peso_Dore - (Peso_Au + FactorBlanco_Ag)) / Peso_Muestra) * 1000000) / 34.285
                                    WHERE Id IN (".$id_in.")";

                      if ($res_update = mysqli_query($enlace, $q_update)) {
                        // Recorre las muestras afectadas y actualiza el Config. Au y Ag
                          if (strlen($id_detalle_rack_x) > 0){
                            $a = 0;
                            $arr_iddetallerack = explode("|", $id_detalle_rack_x);

                            while ($a < count($arr_iddetallerack)){
                              // Config. Au
                                $q_maxmin = "SELECT MAX(Ley_Au) AS _MAX,
                                                    MIN(Ley_Au) AS _MIN
                                               FROM Detalle_Rack_Pesos
                                              WHERE Id_Detalle_Rack = ".$arr_iddetallerack[$a];

                                if ($res_maxmin = mysqli_query($enlace, $q_maxmin)) {
                                  if (mysqli_num_rows($res_maxmin) > 0) {
                                    while($row_maxmin = mysqli_fetch_assoc($res_maxmin)) {
                                      $max = $row_maxmin["_MAX"];
                                      $min = $row_maxmin["_MIN"];

                                      if (strlen($max) > 0 && strlen($min) > 0){
                                        $config_au = $max - $min;
                                      }
                                      else{
                                        $config_au = 'NULL';
                                      }

                                      $q_updateconfigAu = "UPDATE Detalle_Rack_Pesos
                                                            SET Conf_Au = CASE WHEN is_Newmont_Positivo = 1 THEN 0 ELSE ".$config_au." END
                                                          WHERE Id_Detalle_Rack = ".$arr_iddetallerack[$a];

                                      if ($res_updateconfigAu = mysqli_query($enlace, $q_updateconfigAu)) {
                                      }
                                    }
                                  }
                                }

                              // Config. Ag
                                $q_maxmin = "SELECT MAX(Ley_Ag_oz_New) AS _MAX,
                                                    MIN(Ley_Ag_oz_New) AS _MIN
                                               FROM Detalle_Rack_Pesos
                                              WHERE Id_Detalle_Rack = ".$arr_iddetallerack[$a];

                                if ($res_maxmin = mysqli_query($enlace, $q_maxmin)) {
                                  if (mysqli_num_rows($res_maxmin) > 0) {
                                    while($row_maxmin = mysqli_fetch_assoc($res_maxmin)) {
                                      $max = $row_maxmin["_MAX"];
                                      $min = $row_maxmin["_MIN"];

                                      if (strlen($max) > 0 && strlen($min) > 0){
                                        $config_au = $max - $min;
                                      }
                                      else{
                                        $config_au = 'NULL';
                                      }

                                      $q_updateconfigAg = "UPDATE Detalle_Rack_Pesos
                                                            SET Conf_Ag = CASE WHEN is_Newmont_Positivo = 1 THEN 0 ELSE ".$config_au." END
                                                          WHERE Id_Detalle_Rack = ".$arr_iddetallerack[$a];

                                      if ($res_updateconfigAg = mysqli_query($enlace, $q_updateconfigAg)) {
                                      }
                                    }
                                  }
                                }

                              $a += 1;
                            }
                          }
                      }
                  }
              }
              else{
                // 2. Encontrando el grupo de Blancos en las muestras anteriores
                  $x = 1;

                  $q_idblancos = "SELECT  DR.Id,
                                          COUNT(DR.Id) AS _COUNT
                                    FROM  Detalle_Rack_Pesos DRP
                                          INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                                   WHERE  DRP.Id < ".$Id_Detalle_Peso."
                                     AND  DR.Rack_TipoMuestra = 2
                                     AND  DR.Id_TipoBlancoFundente = ".$id_tipoblancofundente."
                                     AND  isNot_Regulo = 0
                                     AND  isNot_Dore = 0
                                  GROUP BY DR.Id
                                  HAVING COUNT(DR.Id) >= 2
                                  ORDER BY DR.Id DESC";

                  if ($res_idblancos = mysqli_query($enlace, $q_idblancos)) {
                    if (mysqli_num_rows($res_idblancos) > 0) {
                      while($row_idblancos = mysqli_fetch_assoc($res_idblancos)) {
                        $id_idblancos = $row_idblancos["Id"];
                        $num_blancos = $row_idblancos["_COUNT"];

                        // MAX (03/03/2021): ESTO YA NO ES NECESARIO PORQUE YA SE HACE EN EL DORÉ
                        // 3. Actualiza el código de Blanco correspondiente a la muestra
                          // if ($x == 1){
                          //   $q_updateidblanco = "UPDATE Detalle_Rack_Pesos
                          //                           SET Id_FactorBlanco_Ag = ".$id_idblancos."
                          //                         WHERE Id = ".$Id_Detalle_Peso;

                          //   if ($res_updateidblanco = mysqli_query($enlace, $q_updateidblanco)) {
                          //   }
                          // }

                        // 4. Verificando que los blancos tengan todos sus peso de Oro registrados
                          $d = 0;
                          $total_dore = 0;

                          $q_blancoau = "SELECT  Peso_Au
                                           FROM  Detalle_Rack_Pesos
                                          WHERE  Id_Detalle_Rack = ".$id_idblancos;

                          if ($res_blancoau = mysqli_query($enlace, $q_blancoau)) {
                            if (mysqli_num_rows($res_blancoau) > 0) {
                              while($row_blancoau = mysqli_fetch_assoc($res_blancoau)) {
                                $peso_au = $row_blancoau["Peso_Au"];

                                if ($peso_au != null){
                                  $total_au += $peso_au;

                                  $d += 1;
                                }
                              }

                              // 5. Verifica que todos los pesos de Doré hayan sido pesados
                                if ($num_blancos == $d){
                                  $factor = $total_au / $num_blancos;

                                  // 6. Actualizando factor y datos en la tabla de Pesos
                                    $q_update = "UPDATE Detalle_Rack_Pesos
                                                    SET FactorBlanco_Au = ".$factor.",
                                                        Ley_Au = ".((($Peso_Au - $factor) / $peso_muestra) * 1000000).",
                                                        Ley_Au_oz = ".(((($Peso_Au - $factor) / $peso_muestra) * 1000000) / 34.285).",
                                                        Ley_Ag_New = ((Peso_Dore - (Peso_Au + FactorBlanco_Ag)) / Peso_Muestra) * 1000000,
                                                        Ley_Ag_oz_New = (((Peso_Dore - (Peso_Au + FactorBlanco_Ag)) / Peso_Muestra) * 1000000) / 34.285
                                                  WHERE Id = ".$Id_Detalle_Peso;

                                    if ($res_update = mysqli_query($enlace, $q_update)) {
                                      break;
                                    }
                                }
                            }
                          }

                        $x += 1;
                      }
                    }
                  }
              }
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_Diferencia_PesoOro_Old':
      $r = array();
      $estado = 0;
      $diferencias = "";

      $id_detallepeso = $_GET["id_detallepeso"];
      $nom_muestra = str_replace('*', '+', $_GET["nom_muestra"]);
      $tipo_muestra = $_GET["tipo_muestra"];

      // Identificando muestras Newmont Positivas y/o Negativas
        $positivo = strpos($nom_muestra, '(+');
        $negativo = strpos($nom_muestra, '(-');

      $q_diferencias = "SELECT  DRP.Num_Crisol,
                                DRP.Peso_Au
                          FROM  Detalle_Rack_Pesos DRP
                         WHERE  1 = 1";

      if ($positivo === false && $negativo === false){
        $q_diferencias .= "   AND  DRP.Id_Detalle_Rack IN (SELECT  Id_Detalle_Rack
                                                            FROM  Detalle_Rack_Pesos
                                                           WHERE  Id = ".$id_detallepeso.")";
      }
      else{
        $q_diferencias .= "   AND  DRP.Nom_Muestra = '".$nom_muestra."'";
      }

      $q_diferencias .= "ORDER BY Num_Crisol";

      if ($res_diferencias = mysqli_query($enlace, $q_diferencias)) {
        if (mysqli_num_rows($res_diferencias) > 0) {
          while($row_diferencias = mysqli_fetch_assoc($res_diferencias)) {
            $diferencias .= $row_diferencias["Num_Crisol"].'*'.$row_diferencias["Peso_Au"].'|';
          }

          $diferencias = substr($diferencias, 0, -1);

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'diferencia' => $diferencias));

      break;

    case 'get_Diferencia_PesoOro':
      $r = array();
      $estado = 0;

      $id_rack = $_GET["Id_Rack"];
      $id_detallepeso = $_GET["Id_Detalle_Peso"];

      // Identificando si es una muestra Newmont Negativa
        $is_negativo = '';

        $q_negativo = "SELECT is_Newmont_Negativo
                         FROM Detalle_Rack_Pesos
                        WHERE Id = ".$id_detallepeso;

        if ($res_negativo = mysqli_query($enlace, $q_negativo)) {
          if (mysqli_num_rows($res_negativo) > 0) {
            while($row_negativo = mysqli_fetch_assoc($res_negativo)) {
              $is_negativo = $row_negativo["is_Newmont_Negativo"];
            }
          }
        }

      // Verifica que no hayan muestras con Oro sin pesar
        $q_sinau = "SELECT  COUNT(Id) AS _COUNT
                      FROM  Detalle_Rack_Pesos
                     WHERE  Id_Detalle_Rack IN (SELECT  Id_Detalle_Rack
                                                  FROM  Detalle_Rack_Pesos
                                                 WHERE  Id = ".$id_detallepeso.")";

        if ($is_negativo == 1){
          $q_sinau .= "   AND is_Newmont_Negativo = 1";
        }

        $q_sinau .= "   AND  Ley_Au_oz IS NULL";

        if ($res_sinau = mysqli_query($enlace, $q_sinau)) {
          if (mysqli_num_rows($res_sinau) > 0) {
            while($row_sinau = mysqli_fetch_assoc($res_sinau)) {
              if ($row_sinau["_COUNT"] > 0){
                $estado = 2;
              }
              else{
                // Identificando el Tipo de Muestra
                  $q_tipomuestra = "SELECT  DR.Rack_TipoMuestra
                                      FROM  Detalle_Rack_Pesos DRP
                                            INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                                     WHERE  DRP.Id = ".$id_detallepeso;

                  if ($res_tipomuestra = mysqli_query($enlace, $q_tipomuestra)) {
                    if (mysqli_num_rows($res_tipomuestra) > 0) {
                      while($row_tipomuestra = mysqli_fetch_assoc($res_tipomuestra)) {
                        $id_tipomuestra = $row_tipomuestra["Rack_TipoMuestra"];
                      }
                    }
                  }

                // Obtiene el factor Máximo de Oro
                  if ($id_tipomuestra == 2){
                    $q_getfactororo = "SELECT MAX(Ley_Au) AS _MAX,
                                              MIN(Ley_Au) AS _MIN";
                  }
                  else{
                    // MAX (14/04/2021): Por indicación de Abner, solo el Conf.Ag de muestras se calcula con las ONZAS
                    // $q_getfactororo = "SELECT MAX(Ley_Au_oz) AS _MAX,
                    //                           MIN(Ley_Au_oz) AS _MIN";
                    $q_getfactororo = "SELECT MAX(Ley_Au) AS _MAX,
                                              MIN(Ley_Au) AS _MIN";
                  }

                  $q_getfactororo .= "  FROM  Detalle_Rack_Pesos
                                       WHERE  Id_Detalle_Rack IN (SELECT  Id_Detalle_Rack
                                                                    FROM  Detalle_Rack_Pesos
                                                                   WHERE  Id = ".$id_detallepeso.")";

                  if ($is_negativo == 1){
                    $q_getfactororo .= "   AND is_Newmont_Negativo = 1";
                  }

                if ($res_getfactororo = mysqli_query($enlace, $q_getfactororo)) {
                  if (mysqli_num_rows($res_getfactororo) > 0) {
                    while($row_getfactororo = mysqli_fetch_assoc($res_getfactororo)) {
                      $getfactororo = round($row_getfactororo["_MAX"] - $row_getfactororo["_MIN"], 2);

                      // Obtiene Id_Detalle_Rack
                        $q_iddetallerack = "SELECT  Id_Detalle_Rack
                                              FROM  Detalle_Rack_Pesos
                                             WHERE  Id = ".$id_detallepeso;

                        if ($res_iddetallerack = mysqli_query($enlace, $q_iddetallerack)) {
                          if (mysqli_num_rows($res_iddetallerack) > 0) {
                            while($row_iddetallerack = mysqli_fetch_assoc($res_iddetallerack)) {
                              $id_detallerack = $row_iddetallerack["Id_Detalle_Rack"];
                            }
                          }
                        }

                      // Actualizando Factor (Config Au) en tabla de Pesos
                        $q_update = "UPDATE Detalle_Rack_Pesos
                                        SET Conf_Au = CASE WHEN is_Newmont_Positivo = 1 THEN 0 ELSE ".$getfactororo." END
                                      WHERE Id_Detalle_Rack = ".$id_detallerack."
                                        AND is_Newmont_Positivo = 0";

                        if ($res_update = mysqli_query($enlace, $q_update)) {
                          $estado = 1;
                        }
                    }
                  }
                }
              }
            }
          }
        }

      echo json_encode(array('estado' => $estado, 'factor' => $getfactororo));

      break;

    case 'get_Diferencia_PesoOro_ConfAg':
      $r = array();
      $estado = 0;

      $id_rack = $_GET["Id_Rack"];
      $id_detallepeso = $_GET["Id_Detalle_Peso"];

      // Identificando si es una muestra Newmont Negativa
        $is_negativo = '';

        $q_negativo = "SELECT is_Newmont_Negativo
                         FROM Detalle_Rack_Pesos
                        WHERE Id = ".$id_detallepeso;

        if ($res_negativo = mysqli_query($enlace, $q_negativo)) {
          if (mysqli_num_rows($res_negativo) > 0) {
            while($row_negativo = mysqli_fetch_assoc($res_negativo)) {
              $is_negativo = $row_negativo["is_Newmont_Negativo"];
            }
          }
        }

      // Verifica que no hayan muestras con Oro sin pesar
        $q_sinau = "SELECT  COUNT(Id) AS _COUNT
                      FROM  Detalle_Rack_Pesos
                     WHERE  Id_Detalle_Rack IN (SELECT  Id_Detalle_Rack
                                                  FROM  Detalle_Rack_Pesos
                                                 WHERE  Id = ".$id_detallepeso.")";

        if ($is_negativo == 1){
          $q_sinau .= "   AND is_Newmont_Negativo = 1";
        }

        $q_sinau .= "   AND  Ley_Au_oz IS NULL";

        if ($res_sinau = mysqli_query($enlace, $q_sinau)) {
          if (mysqli_num_rows($res_sinau) > 0) {
            while($row_sinau = mysqli_fetch_assoc($res_sinau)) {
              if ($row_sinau["_COUNT"] > 0){
                $estado = 2;
              }
              else{
                // Identificando el Tipo de Muestra
                  $q_tipomuestra = "SELECT  DR.Rack_TipoMuestra
                                      FROM  Detalle_Rack_Pesos DRP
                                            INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                                     WHERE  DRP.Id = ".$id_detallepeso;

                  if ($res_tipomuestra = mysqli_query($enlace, $q_tipomuestra)) {
                    if (mysqli_num_rows($res_tipomuestra) > 0) {
                      while($row_tipomuestra = mysqli_fetch_assoc($res_tipomuestra)) {
                        $id_tipomuestra = $row_tipomuestra["Rack_TipoMuestra"];
                      }
                    }
                  }

                // Obtiene el factor Máximo de las nuevas Leyes de Ag
                  if ($id_tipomuestra == 2){
                    $q_getfactorplata = "SELECT MAX(Ley_Ag_New) AS _MAX,
                                                MIN(Ley_Ag_New) AS _MIN";
                  }
                  else{
                    $q_getfactorplata = "SELECT MAX(Ley_Ag_oz_New) AS _MAX,
                                                MIN(Ley_Ag_oz_New) AS _MIN";
                  }

                  $q_getfactorplata .= "  FROM  Detalle_Rack_Pesos
                                         WHERE  Id_Detalle_Rack IN (SELECT  Id_Detalle_Rack
                                                                      FROM  Detalle_Rack_Pesos
                                                                     WHERE  Id = ".$id_detallepeso.")";

                  if ($is_negativo == 1){
                    $q_getfactorplata .= "   AND is_Newmont_Negativo = 1";
                  }

                if ($res_getfactorplata = mysqli_query($enlace, $q_getfactorplata)) {
                  if (mysqli_num_rows($res_getfactorplata) > 0) {
                    while($row_getfactorplata = mysqli_fetch_assoc($res_getfactorplata)) {
                      $getfactorplata = round($row_getfactorplata["_MAX"] - $row_getfactorplata["_MIN"], 2);

                      // Obtiene Id_Detalle_Rack
                        $q_iddetallerack = "SELECT  Id_Detalle_Rack
                                              FROM  Detalle_Rack_Pesos
                                             WHERE  Id = ".$id_detallepeso;

                        if ($res_iddetallerack = mysqli_query($enlace, $q_iddetallerack)) {
                          if (mysqli_num_rows($res_iddetallerack) > 0) {
                            while($row_iddetallerack = mysqli_fetch_assoc($res_iddetallerack)) {
                              $id_detallerack = $row_iddetallerack["Id_Detalle_Rack"];
                            }
                          }
                        }

                      // Actualizando Factor (Config Au) en tabla de Pesos
                        $q_update = "UPDATE Detalle_Rack_Pesos
                                        SET Conf_Ag = CASE WHEN is_Newmont_Positivo = 1 THEN 0 ELSE ".$getfactorplata." END
                                      WHERE Id_Detalle_Rack = ".$id_detallerack."
                                        AND is_Newmont_Positivo = 0";

                        if ($res_update = mysqli_query($enlace, $q_update)) {
                          $estado = 1;
                        }
                    }
                  }
                }
              }
            }
          }
        }

      echo json_encode(array('estado' => $estado, 'factor' => $getfactorplata));

      break;

    case 'update_ObservadoOro':
      $r = array();
      $estado = 0;

      $id_detallepeso = $_GET["id_detallepeso"];
      $nom_muestra = $_GET["nom_muestra"];
      $factor_oro = $_GET["factor_oro"];
      $usuario_observacion = $_GET["usuario_observacion"];

      // Obtiene el código de Rack
        $q_iddetallerack = "SELECT  DR.Rack_TipoMuestra,
                                    DRP.Id_Detalle_Rack
                              FROM  Detalle_Rack_Pesos DRP
                                    INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                             WHERE  DRP.Id = ".$id_detallepeso;

        if ($res_iddetallerack = mysqli_query($enlace, $q_iddetallerack)) {
          if (mysqli_num_rows($res_iddetallerack) > 0) {
            while($row_iddetallerack = mysqli_fetch_assoc($res_iddetallerack)) {
              $id_tipomuestra = $row_iddetallerack["Rack_TipoMuestra"];
              $id_detallerack = $row_iddetallerack["Id_Detalle_Rack"];
            }
          }
        }

      // Para el peso de Muestras
        $q_update = "UPDATE Detalle_Rack_Pesos
                        SET isObservado_Au = 1,
                            isObservado_AuObservacion = '- ".(($id_tipomuestra == 2) ? 'Blanco Fundente' : 'Muestra')." Fuera de límite, desviación de Conf. Au: ".$factor_oro."'
                      WHERE Id_Detalle_Rack = ".$id_detallerack;

        if ($res = mysqli_query($enlace, $q_update)) {
          $estado = 1;

          // Si la observación es para un blanco (Tipo 2) se deben afectar a todas sus muestras afectadas
            if ($id_tipomuestra == 2){
              $q_observados = "UPDATE Detalle_Rack_Pesos
                                  SET isObservado_AuFactorOro = 1
                                WHERE Id_FactorBlanco_Ag = ".$id_detallerack;

              if ($res_observados = mysqli_query($enlace, $q_observados)) {
              }
            }

          // Generando solicitud de Reanálisis
            $q_Insert = "INSERT INTO Gestion_Solicitudes(Id_Solicitud, Id_Registro, usuario_solicitud, fecha_solicitud, observacion_solicitud) VALUES(";
              $q_Insert .= (($id_tipomuestra == 2) ? "6, " : "5, ");
              $q_Insert .= $id_detallepeso.", ";
              $q_Insert .= "'".$usuario_observacion."', ";
              $q_Insert .= "'".$g_fecha."', ";
              $q_Insert .= "'".(($id_tipomuestra == 2) ? 'Blanco Fundente' : 'Muestra').' Fuera de límite, desviación de Conf. Au: "'.$factor_oro.'"'."'".')';

              if ($res = mysqli_query($enlace, $q_Insert)) {
              }
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'update_ObservadoOro_ConfAg':
      $r = array();
      $estado = 0;

      $id_detallepeso = $_GET["id_detallepeso"];
      $nom_muestra = $_GET["nom_muestra"];
      $factor_plata = $_GET["factor_plata"];
      $usuario_observacion = $_GET["usuario_observacion"];

      // Obtiene el código de Rack
        $q_iddetallerack = "SELECT  DR.Rack_TipoMuestra,
                                    DRP.Id_Detalle_Rack
                              FROM  Detalle_Rack_Pesos DRP
                                    INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                             WHERE  DRP.Id = ".$id_detallepeso;

        if ($res_iddetallerack = mysqli_query($enlace, $q_iddetallerack)) {
          if (mysqli_num_rows($res_iddetallerack) > 0) {
            while($row_iddetallerack = mysqli_fetch_assoc($res_iddetallerack)) {
              $id_tipomuestra = $row_iddetallerack["Rack_TipoMuestra"];
              $id_detallerack = $row_iddetallerack["Id_Detalle_Rack"];
            }
          }
        }

      // Para el peso de Muestras
        $q_update = "UPDATE Detalle_Rack_Pesos
                        SET isObservado_Au = 1,
                            isObservado_AuObservacion = '- ".(($id_tipomuestra == 2) ? 'Blanco Fundente' : 'Muestra')." Fuera de límite, desviación de Conf. Ag: ".$factor_plata."'
                      WHERE Id_Detalle_Rack = ".$id_detallerack;

        if ($res = mysqli_query($enlace, $q_update)) {
          $estado = 1;

          // Si la observación es para un blanco (Tipo 2) se deben afectar a todas sus muestras afectadas
            if ($id_tipomuestra == 2){
              $q_observados = "UPDATE Detalle_Rack_Pesos
                                  SET isObservado_AuFactorConfAg = 1
                                WHERE Id_FactorBlanco_Ag = ".$id_detallerack;

              if ($res_observados = mysqli_query($enlace, $q_observados)) {
              }
            }

          // Generando solicitud de Reanálisis
            $q_Insert = "INSERT INTO Gestion_Solicitudes(Id_Solicitud, Id_Registro, usuario_solicitud, fecha_solicitud, observacion_solicitud) VALUES(";
              $q_Insert .= (($id_tipomuestra == 2) ? "9, " : "8, ");
              $q_Insert .= $id_detallepeso.", ";
              $q_Insert .= "'".$usuario_observacion."', ";
              $q_Insert .= "'".$g_fecha."', ";
              $q_Insert .= "'".(($id_tipomuestra == 2) ? 'Blanco Fundente' : 'Muestra').' Muestra Fuera de límite, desviación de Conf. Ag: "'.$factor_plata.'"'."'".')';

              if ($res = mysqli_query($enlace, $q_Insert)) {
              }
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'update_SetNumCrisol':
      $r = array();
      $estado = 0;

      $id_rack = $_GET["id_rack"];
      $id_detallepeso = $_GET["id_detallepeso"];
      $num_crisol = $_GET["num_crisol"];
      $tipo = $_GET["tipo"];

      // Actualiza el Crisol de la muestra seleccionada
        $q_update = "UPDATE Detalle_Rack_Pesos
                        SET NumCrisol_Dore = ".$num_crisol."
                      WHERE Id = ".$id_detallepeso;

        if ($res = mysqli_query($enlace, $q_update)) {
          $estado = 1;
        }
        else{
          $estado = 0;
        }

      // Si es el tipo 2 asigna de forma correlativa los Crisoles
        if ($tipo == 2){
          $num_crisol += 1;

          $q_muestras = "SELECT  Id,
                                 NumCrisol_Dore
                           FROM  Detalle_Rack_Pesos
                          WHERE  Id_Detalle_Rack IN (SELECT  Id
                                                       FROM  Detalle_Rack
                                                      WHERE  Id_Rack = ".$id_rack.")
                           AND  Id > ".$id_detallepeso."
                           AND  isNot_Regulo = 0
                           AND  isNot_Dore = 0
                           AND  isDesactivado_EnRack = 0";

          if ($res_muestras = mysqli_query($enlace, $q_muestras)) {
            if (mysqli_num_rows($res_muestras) > 0) {
              while($row_muestras = mysqli_fetch_assoc($res_muestras)) {
                if ($row_muestras["NumCrisol_Dore"] == null){
                  $id_detallepeso = $row_muestras["Id"];

                  // Actualiza Número de Crisol por cada muestra
                    $q_update = "UPDATE Detalle_Rack_Pesos
                                    SET NumCrisol_Dore = ".$num_crisol."
                                  WHERE Id = ".$id_detallepeso;

                    if ($res = mysqli_query($enlace, $q_update)) {
                    }
                }
                else{
                  break;
                }

                $num_crisol += 1;
              }

              $estado = 1;
            }
          }
        }

      // Si es el tipo 2 asigna de forma correlativa los Crisoles
        if ($tipo == 3){
          $num_crisol += 1;

          $q_muestras = "SELECT  Id,
                                 NumCrisol_Dore
                           FROM  Detalle_Rack_Pesos
                          WHERE  Id_Detalle_Rack IN (SELECT  Id
                                                       FROM  Detalle_Rack
                                                      WHERE  Id_Rack = ".$id_rack.")
                           AND  Id > ".$id_detallepeso."
                           AND  isNot_Regulo = 0
                           AND  isNot_Dore = 0
                           AND  isDesactivado_EnRack = 0";

          if ($res_muestras = mysqli_query($enlace, $q_muestras)) {
            if (mysqli_num_rows($res_muestras) > 0) {
              while($row_muestras = mysqli_fetch_assoc($res_muestras)) {
                $id_detallepeso = $row_muestras["Id"];

                // Actualiza Número de Crisol por cada muestra
                  $q_update = "UPDATE Detalle_Rack_Pesos
                                  SET NumCrisol_Dore = ".$num_crisol."
                                WHERE Id = ".$id_detallepeso;

                  if ($res = mysqli_query($enlace, $q_update)) {
                  }

                $num_crisol += 1;
              }

              $estado = 1;
            }
          }
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'cierre_PesoDore':
      $r = array();
      $estado = 0;

      $id_rack = $_GET["Id_Rack"];
      $usuario_cierrepesorack = $_GET["Usuario_CierrePesoRack"];

      $q_save = "UPDATE  Cabecera_Rack SET ";
      $q_save .= "  cierre_pesodore = 1, ";
      $q_save .= "  usuario_cierrepesodore = '".$usuario_cierrepesorack."', ";
      $q_save .= "  fecha_cierrepesodore = '".$g_fecha."'";
      $q_save .= " WHERE Id = ".$id_rack;

      if ($res = mysqli_query($enlace, $q_save)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'cierre_PesoOro':
      $r = array();
      $estado = 0;

      $id_rack = $_GET["Id_Rack"];
      $usuario_cierrepesorack = $_GET["Usuario_CierrePesoRack"];

      $q_save = "UPDATE  Cabecera_Rack SET ";
      $q_save .= "  cierre_pesoau = 1, ";
      $q_save .= "  usuario_cierrepesoau = '".$usuario_cierrepesorack."', ";
      $q_save .= "  fecha_cierrepesoau = '".$g_fecha."'";
      $q_save .= " WHERE Id = ".$id_rack;

      if ($res = mysqli_query($enlace, $q_save)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_ListaRacks_PesoOro':
      $r = array();
      $estado = 0;

      $fecha_inicio = $_GET["Fecha_Inicio"];
      $fecha_fin = $_GET["Fecha_Fin"];

      $q_Racks = "SELECT 0 AS ITEM, CR.nom_rack,
                         CR.des_rack, CR.fecha_cierrepesodore AS fecha_rack,
                         CR.usuario_cierrepesodore AS usuario_rack, CR.Id,
                         (SELECT COUNT(DRP.Id) AS NUM_MUESTRAS
                            FROM  Detalle_Rack_Pesos DRP 
                           WHERE  DRP.Id_Detalle_Rack IN (SELECT Id
                                                            FROM Detalle_Rack
                                                           WHERE Id_Rack = CR.Id)) AS NUM_MUESTRAS,
                         CR.id_horno,
                         H.cod_horno,
                         H.capacidad_horno
                    FROM Cabecera_Rack CR
                         INNER JOIN tbconfig_Hornos H ON CR.id_horno = H.Id
                   WHERE DATE(CR.fecha_rack) BETWEEN '".$fecha_inicio."' AND '".$fecha_fin."'
                     AND cierre_pesodore = 1
                  ORDER BY CR.fecha_rack DESC";

      if ($res_Racks = mysqli_query($enlace, $q_Racks)) {
        if (mysqli_num_rows($res_Racks) > 0) {
          while($row_Racks = mysqli_fetch_assoc($res_Racks)) {
            array_push($r, $row_Racks);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaRackMuestras_PesoOro':
      $r = array();
      $estado = 0;

      $Id_Rack = $_GET["Id_Rack"];

      $q_RackMuestras = "SELECT Num_Crisol,
                                TIPO,
                                CRISOL,
                                nom_muestra,
                                nom_tipoblanco,
                                Dosificacion,
                                Peso_Muestra,
                                Peso_Regulo,
                                Peso_Dore,
                                Peso_Au,
                                Id,
                                cierre_pesoau,
                                UsuarioPeso_Muestra,
                                FechaPeso_Muestra,
                                FechaPeso_Regulo,
                                UsuarioPeso_Regulo,
                                FechaPeso_Dore,
                                UsuarioPeso_Dore,
                                FechaPeso_Au,
                                UsuarioPeso_Au,
                                isNot_Regulo,
                                isNot_ReguloObservacion,
                                isDesactivado_EnRack,
                                isObservado_Regulo,
                                isObservado_ReguloObservacion,
                                isNot_Dore,
                                isNot_DoreObservacion,
                                isObservado_Dore,
                                isObservado_DoreObservacion,
                                isObservado_DoreFactorPlata,
                                isNot_Au,
                                isObservado_Au,
                                
                                CASE WHEN isObservado_AuFactorOro = 1
                                  THEN CASE WHEN LENGTH(isObservado_AuObservacion) > 0
                                        THEN CONCAT('- ', isObservado_AuObservacion, CHAR(10), '- Conf.Ag de Blanco Fuera de Límite')
                                       ELSE '- Conf.Ag de Blanco Fuera de Límite' END
                                ELSE isObservado_AuObservacion END AS isObservado_AuObservacion,

                                Conf_Au,
                                Conf_Ag,
                                Id_Detalle_Rack
                            
                          FROM  (SELECT DRP.Num_Crisol,
                                        RTM.nom_tipo AS TIPO,
                                        DRP.NumCrisol_Dore AS CRISOL,
                                        DRP.nom_muestra,
                                        TB.nom_tipoblanco,
                                        DRP.Dosificacion,
                                        DRP.Peso_Muestra,
                                        DRP.Peso_Regulo,
                                        DRP.Peso_Dore,
                                        DRP.Peso_Au,
                                        DRP.Id,
                                        CR.cierre_pesoau,

                                        DRP.UsuarioPeso_Muestra,
                                        DRP.FechaPeso_Muestra,

                                        DRP.FechaPeso_Regulo,
                                        DRP.UsuarioPeso_Regulo,

                                        DRP.FechaPeso_Dore,
                                        DRP.UsuarioPeso_Dore,

                                        DRP.FechaPeso_Au,
                                        DRP.UsuarioPeso_Au,

                                        DRP.isNot_Regulo,
                                        DRP.isNot_ReguloObservacion,
                                        DRP.isDesactivado_EnRack,
                                        DRP.isObservado_Regulo,
                                        DRP.isObservado_ReguloObservacion,

                                        DRP.isNot_Dore,
                                        DRP.isNot_DoreObservacion,
                                        DRP.isObservado_Dore,
                                        DRP.isObservado_DoreObservacion,
                                        DRP.isObservado_DoreFactorPlata,

                                        DRP.isNot_Au,
                                        DRP.isObservado_Au,
                                        DRP.isObservado_AuFactorOro,
                                        
                                        CONCAT(CASE WHEN isNot_AuDesactivadoEnRack_PorPositivoNewmont = 1
                                                      OR isObservado_AuDesactivadoEnRack_PorPositivoNewmont = 1
                                                      OR isNot_DoreDesactivadoEnRack_PorPositivoNewmont = 1
                                                      OR isObservado_DoreDesactivadoEnRack_PorPositivoNewmont = 1
                                                      OR isNot_ReguloDesactivadoEnRack_PorPositivoNewmont = 1
                                                      OR isObservado_ReguloDesactivadoEnRack_PorPositivoNewmont = 1
                                                  THEN '(Grupo Newmont Desactivado)'
                                               ELSE '' END, CASE WHEN isNot_AuDesactivadoEnRack_PorPositivoNewmont = 1
                                                                   OR isObservado_AuDesactivadoEnRack_PorPositivoNewmont = 1
                                                                   OR isNot_DoreDesactivadoEnRack_PorPositivoNewmont = 1
                                                                   OR isObservado_DoreDesactivadoEnRack_PorPositivoNewmont = 1
                                                                   OR isNot_ReguloDesactivadoEnRack_PorPositivoNewmont = 1
                                                                   OR isObservado_ReguloDesactivadoEnRack_PorPositivoNewmont = 1
                                                              THEN CHAR(10)
                                                            ELSE '' END, CASE WHEN DRP.isNot_Au = 1
                                                                            THEN DRP.isNot_AuObservacion
                                                                         ELSE CASE WHEN DRP.isObservado_Au = 1
                                                                                  THEN DRP.isObservado_AuObservacion
                                                                              ELSE ''
                                                                         END END) AS isObservado_AuObservacion,

                                        ROUND(DRP.Conf_Au, 2) AS Conf_Au,
                                        CASE WHEN Conf_Ag IS NULL THEN ROUND(DRP.Conf_Ag_Dore, 2) ELSE ROUND(DRP.Conf_Ag, 2) END AS Conf_Ag,
                                        DRP.Id_Detalle_Rack
                                  FROM  Detalle_Rack DR
                                        INNER JOIN Detalle_Rack_Pesos DRP ON DR.Id = DRP.Id_Detalle_Rack
                                        INNER JOIN tbconfig_RackTipoMuestras RTM ON DR.Rack_TipoMuestra = RTM.Id
                                        INNER JOIN tbconfig_RackTipoBlancoFundente TB ON DRP.Id_TipoBlancoFundente = TB.Id
                                        INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
                                 WHERE  DR.Id_Rack = ".$Id_Rack.") AS DATOS";

      if ($res_RackMuestras = mysqli_query($enlace, $q_RackMuestras)) {
        if (mysqli_num_rows($res_RackMuestras) > 0) {
          while($row_RackMuestras = mysqli_fetch_assoc($res_RackMuestras)) {
            array_push($r, $row_RackMuestras);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'genera_Solicitud':
      $r = array();
      $estado = 0;

      $id_solicitud = $_GET["Id_Solicitud"];
      $id_registro = $_GET["Id_Registro"];
      $usuario_solicitud = $_GET["usuario_solicitud"];
      $observacion_solicitud = $_GET["observacion_solicitud"];

      $q_save = "INSERT INTO Gestion_Solicitudes(Id_Solicitud, Id_Registro, usuario_solicitud, fecha_solicitud, observacion_solicitud) VALUES(";
      $q_save .= $id_solicitud.", ";
      $q_save .= $id_registro.", ";
      $q_save .= "'".$usuario_solicitud."', ";
      $q_save .= "'".$g_fecha."', ";
      $q_save .= "'".$observacion_solicitud."')";

      if ($res = mysqli_query($enlace, $q_save)) {
        // Obtiene el Id de la solicitud generada
          $id_solicitud = mysqli_insert_id($enlace);

        // Actrualiza la tabla de Cabecera de Rack
          $q_update = "UPDATE Cabecera_Rack ";
          $q_update .= "   SET solicitud_cierre = 1, ";
          $q_update .= "       id_solicitudcierre = ".$id_solicitud;
          $q_update .= " WHERE Id = ".$id_registro;

        if ($res_update = mysqli_query($enlace, $q_update)) {
          $estado = 1;
        }
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'verificar_Solicitud':
      $r = array();
      $estado = 0;

      $Id_Rack = $_GET["Id_Rack"];

      $q_confirmacion = "SELECT solicitud_aceptada,
                                solicitud_rechazada,
                                CASE WHEN solicitud_aceptada = 0 AND solicitud_rechazada = 0
                                  THEN 0
                                ELSE CASE WHEN solicitud_aceptada = 1 THEN 1 ELSE 2 END END AS CONFIRMACION,
                                observacion_confirmacion
                           FROM Gestion_Solicitudes
                          WHERE Id_Solicitud = 1
                            AND Id_Registro = ".$Id_Rack."
                         ORDER BY fecha_solicitud DESC LIMIT 1";

      if ($res_confirmacion = mysqli_query($enlace, $q_confirmacion)) {
        if (mysqli_num_rows($res_confirmacion) > 0) {
          while($row_confirmacion = mysqli_fetch_assoc($res_confirmacion)) {
            // MAX - 08/12/2020 (ESTO NO SERÁ NECESARIO PORQUE NEN EL LIMS NECESITO SABER EL RESULTADO DE LA CONFIRMACIÓN DEL ENCARGADO)
            // if ($row_confirmacion["CONFIRMACION"] == 1 || $row_confirmacion["CONFIRMACION"] == 2){
            //   $q_update = "UPDATE Cabecera_Rack ";
            //   $q_update .= "   SET solicitud_cierre = 0 ";
            //   $q_update .= " WHERE Id = ".$Id_Rack;

            //   if ($res_update = mysqli_query($enlace, $q_update)) {
            //   }
            // }

            if ($row_confirmacion["CONFIRMACION"] == 1){
              $estado = 1;
            }

            if ($row_confirmacion["CONFIRMACION"] == 2){
              $estado = 2;
            }

            $observacion = $row_confirmacion["observacion_confirmacion"];
          }
        }
      }

      echo json_encode(array('estado' => $estado, 'observacion' => $observacion));

      break;

    case 'elimina_GrupoNewmont':
      $r = array();
      $estado = 0;

      $id_rack = $_GET["Id_Rack"];
      $id_detalle_rack = $_GET["Id_Detalle_Rack"];
      $usuario_eliminar = $_GET["Usuario_Eliminar"];

      // Guarda Auditoría
        $q_audi = "INSERT INTO Auditoria_EliminacionGruposNewmontRacks (Id_Detalle_Rack_Pesos, Id_Detalle_Rack, Num_Crisol,
                               Id_TipoBlancoFundente, Dosificacion, Nom_Muestra, FechaPeso_Muestra,
                               Peso_Muestra, UsuarioPeso_Muestra, Fecha_Eliminacion, Usuario_Eliminacion)";

        $q_audi .= "SELECT  Id,
                            Id_Detalle_Rack,
                            Num_Crisol,
                            Id_TipoBlancoFundente,
                            Dosificacion,
                            Nom_Muestra,
                            FechaPeso_Muestra,
                            Peso_Muestra,
                            UsuarioPeso_Muestra, ";
        $q_audi .= "        '".$g_fecha."', ";
        $q_audi .= "        '".$usuario_eliminar."' ";
        $q_audi .= "  FROM  Detalle_Rack_Pesos
                     WHERE  Id_Detalle_Rack = ". $id_detalle_rack;

        if ($res_audi = mysqli_query($enlace, $q_audi)) {
        }

      // Eliminando datos en la tabla de pesos
        $q_delete1 = "DELETE FROM Detalle_Rack_Pesos
                      WHERE Id_Detalle_Rack = ".$id_detalle_rack;

        if ($res_delete1 = mysqli_query($enlace, $q_delete1)) {
          // Eliminando datos en la tabla de detalles
            $q_delete2 = "DELETE FROM Detalle_Rack
                          WHERE Id = ".$id_detalle_rack;

            if ($res_delete2 = mysqli_query($enlace, $q_delete2)) {
              $estado = 1;

              // Reumerando los N° de orden
                $o = 1;

                $q_ids = "SELECT  Id
                            FROM  Detalle_Rack_Pesos
                           WHERE  Id_Detalle_Rack IN (SELECT  Id
                                                        FROM  Detalle_Rack
                                                       WHERE  Id_Rack = ".$id_rack.")";

                if ($res_ids = mysqli_query($enlace, $q_ids)) {
                  if (mysqli_num_rows($res_ids) > 0) {
                    while ($row_ids = mysqli_fetch_assoc($res_ids)) {
                      $id_detalle_rack = $row_ids["Id"];

                      // Actualizando N° orden
                        $q_update = "UPDATE Detalle_Rack_Pesos
                                        SET Num_Crisol = ".$o."
                                      WHERE Id = ".$id_detalle_rack;

                        if ($res_update = mysqli_query($enlace, $q_update)) {
                        }

                        $o += 1;
                    }
                  }
                }
            }
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'grabar_AusenciaMuestras':
      $r = array();
      $estado = 0;

      $id_modulo = $_GET["Id_Modulo"];
      $id_muestras = $_GET["Id_Muestra"];
      $observacion_ausencia = $_GET["Observacion_Ausencia"];
      $usuario_ausencia = $_GET["Usuario_Ausencia"];

      // Armando los inserts
        $a = 0;
        $arr_muestras = explode(",", $id_muestras);
        $observacion_ausencia = explode("|", $observacion_ausencia);

        while ($a < count($arr_muestras)){
          $q_SaveAusencia = "UPDATE Detalle_Rack_Pesos
                                SET isReanalisis_Regulo = 1,
                                    isNot_Regulo = 1,
                                    isNot_ReguloFecha = '".$g_fecha."',
                                    isNot_ReguloUsuario = '".$usuario_ausencia."',
                                    isNot_ReguloObservacion = '".$observacion_ausencia[$a]."',
                                    isDesactivado_EnRack = 1
                              WHERE Id IN (".$arr_muestras[$a].")";

          if ($res_SaveAusencia = mysqli_query($enlace, $q_SaveAusencia)) {
            // Seteando el Reanálisis en la tabla superior
            $q_update = "UPDATE Detalle_Rack
                            SET is_Reanalisis = 1
                          WHERE Id IN (SELECT Id_Detalle_Rack
                                         FROM Detalle_Rack_Pesos
                                        WHERE Id IN (".$arr_muestras[$a].")
                                       GROUP BY Id_Detalle_Rack)";

            if ($res_update = mysqli_query($enlace, $q_update)) {
              $estado = 1;

              // Buscando muestras Newmont
                $q_muestras = "SELECT Id,
                                      ci_muestra,
                                      Group_Newmont
                                 FROM Detalle_Rack
                                WHERE Id IN (SELECT Id_Detalle_Rack
                                               FROM Detalle_Rack_Pesos
                                              WHERE Id IN (".$arr_muestras[$a].")
                                             GROUP BY Id_Detalle_Rack)
                                  AND is_Newmont = 1";

                if ($res_muestras = mysqli_query($enlace, $q_muestras)) {
                  if (mysqli_num_rows($res_muestras) > 0) {
                    while($row_muestras = mysqli_fetch_assoc($res_muestras)) {
                      // Comprueba si es Muestra Positiva
                        $q_positivo = "SELECT is_Newmont_Positivo
                                         FROM Detalle_Rack_Pesos
                                        WHERE Id = ".$arr_muestras[$a];

                        if ($res_positivo = mysqli_query($enlace, $q_positivo)) {
                          if (mysqli_num_rows($res_positivo) > 0) {
                            while($row_positivo = mysqli_fetch_assoc($res_positivo)) {
                              if ($row_positivo["is_Newmont_Positivo"] == 1){
                                // Deshabilitando grupo en el Rack
                                  $q_desactivar = "UPDATE Detalle_Rack_Pesos
                                                      SET isDesactivado_EnRack = 1,
                                                          isNot_ReguloDesactivadoEnRack_PorPositivoNewmont = 1
                                                    WHERE Id_Detalle_Rack = ".$row_muestras["Id"];

                                  if ($res_desactivar = mysqli_query($enlace, $q_desactivar)) {
                                    // Habilitando el botón de nuevo grupo de Newmont (Módulo de Preparación)
                                      $q_newgrupo = "UPDATE Preparacion_Newmont_Cabecera
                                                        SET is_NewGrupo = 1
                                                      WHERE CI_Muestra = '".$row_muestras["ci_muestra"]."'";

                                      if ($res_newgrupo = mysqli_query($enlace, $q_newgrupo)) {
                                        // Indicando que es un reanálisis por positivo
                                          $q_reanalisis = "UPDATE Preparacion_Newmont_Detalle
                                                              SET Reanalisis_Por_Positivo = 1
                                                            WHERE Id = ".$row_muestras["Group_Newmont"];

                                          if ($res_reanalisis = mysqli_query($enlace, $q_reanalisis)) {
                                          }
                                      }
                                  }
                              }
                            }
                          }
                        }
                    }
                  }
                }
            }
            else{
              $estado = 0;
            }
          }

          $a += 1;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'grabar_EnvioAlertasMuestrasFueraLimite':
      $r = array();
      $estado = 0;

      $id_modulo = $_GET["Id_Modulo"];
      $id_muestras = $_GET["Id_Muestras"];
      $observacion_envio = $_GET["Observacion_Envio"];
      $usuario_envio = $_GET["Usuario_Envio"];

      // Armando los inserts
        $a = 0;
        $arr_muestras = explode(",", $id_muestras);
        $observacion_envio = explode("|", $observacion_envio);

        $insert = "INSERT INTO Auditoria_EnvioAlertasMuestrasFueraLimite (cod_modulopeso, id_detalle_rack_peso,
                                                                          usuario_envio, fecha_envio,
                                                                          observacion_envio) VALUES ";
        $insert .= "";

        while ($a < count($arr_muestras)){
          $insert .= "(".$id_modulo.", ";
          $insert .= $arr_muestras[$a].", ";
          $insert .= "'".$usuario_envio."', ";
          $insert .= "'".$g_fecha."', ";
          $insert .= "'".$observacion_envio[$a]."'), ";

          $a += 1;
        }

        $insert = substr($insert, 0, -2);

      // Guarda envío
        if ($res = mysqli_query($enlace, $insert)) {
          $estado = 1;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'create_NewGrupoNewmont':
      $r = array();
      $estado = 0;

      $id_cabecera = $_GET["Id_Cabecera"];
      $num_grupo = $_GET["Num_Grupo"];
      $usuario_grupo = $_GET["Usuario_Grupo"];

      $q_save = "INSERT INTO Preparacion_Newmont_Detalle(Id_Cabecera, Num_Grupo, Creado_Por_Reanalisis,
                                                         NewGrupo_Fecha, NewGrupo_Usuario) VALUES(";
      $q_save .= $id_cabecera.", ".$num_grupo.", 1, '".$g_fecha."', '".$usuario_grupo."')";

      if ($res = mysqli_query($enlace, $q_save)) {
        // Si el número de grupo es mayor a CERO lo debe restar en 1 hasta dejarlo en CERO
          // 1. Obteniendo el número de grupo actual
            $numgrupo_left = 0;

            $q_numgrupo = "SELECT num_newgrupos
                             FROM Preparacion_Newmont_Cabecera
                            WHERE Id = ".$id_cabecera;

            if ($res_numgrupo = mysqli_query($enlace, $q_numgrupo)) {
              if (mysqli_num_rows($res_numgrupo) > 0) {
                while($row_numgrupo = mysqli_fetch_assoc($res_numgrupo)) {
                  $numgrupo_left = $row_numgrupo["num_newgrupos"];
                }
              }
            }

          // 2. Si el número de grupo que queda es UNO cambia el flag de Nuevo Grupo y actualiza el número de grupo a CERO, de lo contrario resta el número de grupo en 1
            if ($numgrupo_left == 1){
              $q_update = "UPDATE Preparacion_Newmont_Cabecera
                              SET is_NewGrupo = 0,
                                  num_newgrupos = 0
                            WHERE Id = ".$id_cabecera;
            }
            else{
              $q_update = "UPDATE Preparacion_Newmont_Cabecera
                              SET num_newgrupos = ".($numgrupo_left - 1)."
                            WHERE Id = ".$id_cabecera;
            }

          if ($res_update = mysqli_query($enlace, $q_update)) {
            $estado = 1;
          }
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'update_EstadoSolicitudCierre':
      $r = array();
      $estado = 0;

      $id_rack = $_GET["Id_Rack"];

      $q_update = "UPDATE Cabecera_Rack
                      SET solicitud_cierre = 0
                    WHERE Id = ".$id_rack;

      if ($res = mysqli_query($enlace, $q_update)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'update_DosificacionNewmont':
      $r = array();
      $estado = 0;

      $Id_DetalleRackPesos = $_GET["Id_DetalleRackPesos"];
      $Dosificacion = $_GET["Dosificacion"];
      $Usuario_Update = $_GET["Usuario_Update"];

      // Si es una actualización de datos debe registrar los datos de Auditorías
        $q_audi = "INSERT INTO Auditoria_ActualizacionDatosMuestras (Id_Detalle_Rack_Pesos, Id_Detalle_Rack, Num_Crisol,
                                Id_TipoBlancoFundente, Dosificacion, Nom_Muestra, FechaPeso_Muestra,
                                Peso_Muestra, UsuarioPeso_Muestra, UpdateId_TipoBlancoFundente, Update_Dosificacion,
                                UpdateFechaPeso_Muestra, UpdatePeso_Muestra, UpdateUsuarioPeso_Muestra)";
        $q_audi .= "SELECT  Id,
                            Id_Detalle_Rack,
                            Num_Crisol,
                            Id_TipoBlancoFundente,
                            Dosificacion,
                            Nom_Muestra,
                            FechaPeso_Muestra,
                            Peso_Muestra,
                            UsuarioPeso_Muestra,
                            Id_TipoBlancoFundente, ";
        $q_audi .= "        '".$Dosificacion."', ";
        $q_audi .= "        '".$g_fecha."', ";
        $q_audi .= "        Peso_Muestra, ";
        $q_audi .= "        '".$Usuario_Update."' ";
        $q_audi .= "  FROM  Detalle_Rack_Pesos
                     WHERE  Id = ".$Id_DetalleRackPesos;

        if ($res_audi = mysqli_query($enlace, $q_audi)) {
        }

      // Actualiza datos
        $q_update = "UPDATE Detalle_Rack_Pesos SET 
                            Dosificacion = '".$Dosificacion."',
                            FechaPeso_Muestra = '".$g_fecha."'
                      WHERE Id = ".$Id_DetalleRackPesos;

        if ($res = mysqli_query($enlace, $q_update)) {
          $estado = 1;
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'grabar_AusenciaMuestras_Dore':
      $r = array();
      $estado = 0;

      $id_modulo = $_GET["Id_Modulo"];
      $id_muestras = $_GET["Id_Muestra"];
      $observacion_ausencia = $_GET["Observacion_Ausencia"];
      $usuario_ausencia = $_GET["Usuario_Ausencia"];

      // Armando los inserts
        $a = 0;
        $arr_muestras = explode(",", $id_muestras);
        $observacion_ausencia = explode("|", $observacion_ausencia);

        while ($a < count($arr_muestras)){
          $q_SaveAusencia = "UPDATE Detalle_Rack_Pesos
                                SET isReanalisis_Dore = 1,
                                    isNot_Dore = 1,
                                    isNot_DoreFecha = '".$g_fecha."',
                                    isNot_DoreUsuario = '".$usuario_ausencia."',
                                    isNot_DoreObservacion = '".$observacion_ausencia[$a]."',
                                    isDesactivado_EnRack = 1,
                                    NumCrisol_Dore = NULL
                              WHERE Id IN (".$arr_muestras[$a].")";

          if ($res_SaveAusencia = mysqli_query($enlace, $q_SaveAusencia)) {
            // Seteando el Reanálisis en la tabla superior
            $q_update = "UPDATE Detalle_Rack
                            SET is_Reanalisis = 1
                          WHERE Id IN (SELECT Id_Detalle_Rack
                                         FROM Detalle_Rack_Pesos
                                        WHERE Id IN (".$arr_muestras[$a].")
                                       GROUP BY Id_Detalle_Rack)";

            if ($res_update = mysqli_query($enlace, $q_update)) {
              $estado = 1;

              // Buscando muestras Newmont
                $q_muestras = "SELECT Id,
                                      ci_muestra,
                                      Group_Newmont
                                 FROM Detalle_Rack
                                WHERE Id IN (SELECT Id_Detalle_Rack
                                               FROM Detalle_Rack_Pesos
                                              WHERE Id IN (".$arr_muestras[$a].")
                                             GROUP BY Id_Detalle_Rack)
                                  AND is_Newmont = 1";

                if ($res_muestras = mysqli_query($enlace, $q_muestras)) {
                  if (mysqli_num_rows($res_muestras) > 0) {
                    while($row_muestras = mysqli_fetch_assoc($res_muestras)) {
                      // Comprueba si es Muestra Positiva
                        $q_positivo = "SELECT is_Newmont_Positivo
                                         FROM Detalle_Rack_Pesos
                                        WHERE Id = ".$arr_muestras[$a];

                        if ($res_positivo = mysqli_query($enlace, $q_positivo)) {
                          if (mysqli_num_rows($res_positivo) > 0) {
                            while($row_positivo = mysqli_fetch_assoc($res_positivo)) {
                              if ($row_positivo["is_Newmont_Positivo"] == 1){
                                // Deshabilitando grupo en el Rack Y agregando observaciones
                                  $q_desactivar = "UPDATE Detalle_Rack_Pesos
                                                      SET isDesactivado_EnRack = 1,
                                                          isNot_DoreDesactivadoEnRack_PorPositivoNewmont = 1
                                                    WHERE Id_Detalle_Rack = ".$row_muestras["Id"];

                                  if ($res_desactivar = mysqli_query($enlace, $q_desactivar)) {
                                    // Habilitando el botón de nuevo grupo de Newmont (Módulo de Preparación)
                                      $q_newgrupo = "UPDATE Preparacion_Newmont_Cabecera
                                                        SET is_NewGrupo = 1
                                                      WHERE CI_Muestra = '".$row_muestras["ci_muestra"]."'";

                                      if ($res_newgrupo = mysqli_query($enlace, $q_newgrupo)) {
                                        // Indicando que es un reanálisis por positivo
                                          $q_reanalisis = "UPDATE Preparacion_Newmont_Detalle
                                                              SET Reanalisis_Por_Positivo = 1
                                                            WHERE Id = ".$row_muestras["Group_Newmont"];

                                          if ($res_reanalisis = mysqli_query($enlace, $q_reanalisis)) {
                                          }
                                      }
                                  }
                              }
                            }
                          }
                        }
                    }
                  }
                }
            }
            else{
              $estado = 0;
            }
          }

          $a += 1;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'grabar_AusenciaMuestras_Oro':
      $r = array();
      $estado = 0;

      $id_modulo = $_GET["Id_Modulo"];
      $id_muestras = $_GET["Id_Muestra"];
      $observacion_ausencia = $_GET["Observacion_Ausencia"];
      $usuario_ausencia = $_GET["Usuario_Ausencia"];
// MAX (09/03/2021) - Falta registrar el reanálisis (Simple) para la muestra ausente
      // Armando los inserts
        $a = 0;
        $arr_muestras = explode(",", $id_muestras);
        $observacion_ausencia = explode("|", $observacion_ausencia);

        while ($a < count($arr_muestras)){
          $q_SaveAusencia = "UPDATE Detalle_Rack_Pesos
                                SET isReanalisis_Au = 1,
                                    isNot_Au = 1,
                                    isNot_AuFecha = '".$g_fecha."',
                                    isNot_AuUsuario = '".$usuario_ausencia."',
                                    isNot_AuObservacion = '".$observacion_ausencia[$a]."',
                                    isDesactivado_EnRack = 1
                              WHERE Id IN (".$arr_muestras[$a].")";

          if ($res_SaveAusencia = mysqli_query($enlace, $q_SaveAusencia)) {
            // Seteando el Reanálisis en la tabla superior
            $q_update = "UPDATE Detalle_Rack
                            SET is_Reanalisis = 1
                          WHERE Id IN (SELECT Id_Detalle_Rack
                                         FROM Detalle_Rack_Pesos
                                        WHERE Id IN (".$arr_muestras[$a].")
                                       GROUP BY Id_Detalle_Rack)";

            if ($res_update = mysqli_query($enlace, $q_update)) {
              $estado = 1;

              // Buscando muestras Newmont
                $q_muestras = "SELECT Id,
                                      ci_muestra,
                                      Group_Newmont
                                 FROM Detalle_Rack
                                WHERE Id IN (SELECT Id_Detalle_Rack
                                               FROM Detalle_Rack_Pesos
                                              WHERE Id IN (".$arr_muestras[$a].")
                                             GROUP BY Id_Detalle_Rack)
                                  AND is_Newmont = 1";

                if ($res_muestras = mysqli_query($enlace, $q_muestras)) {
                  if (mysqli_num_rows($res_muestras) > 0) {
                    while($row_muestras = mysqli_fetch_assoc($res_muestras)) {
                      // Comprueba si es Muestra Positiva
                        $q_positivo = "SELECT is_Newmont_Positivo
                                         FROM Detalle_Rack_Pesos
                                        WHERE Id = ".$arr_muestras[$a];

                        if ($res_positivo = mysqli_query($enlace, $q_positivo)) {
                          if (mysqli_num_rows($res_positivo) > 0) {
                            while($row_positivo = mysqli_fetch_assoc($res_positivo)) {
                              if ($row_positivo["is_Newmont_Positivo"] == 1){
                                // Deshabilitando grupo en el Rack Y agregando observaciones
                                  $q_desactivar = "UPDATE Detalle_Rack_Pesos
                                                      SET isDesactivado_EnRack = 1,
                                                          isNot_AuDesactivadoEnRack_PorPositivoNewmont = 1
                                                    WHERE Id_Detalle_Rack = ".$row_muestras["Id"];

                                  if ($res_desactivar = mysqli_query($enlace, $q_desactivar)) {
                                    // Habilitando el botón de nuevo grupo de Newmont (Módulo de Preparación)
                                      $q_newgrupo = "UPDATE Preparacion_Newmont_Cabecera
                                                        SET is_NewGrupo = 1,
                                                            num_newgrupos = 1
                                                      WHERE CI_Muestra = '".$row_muestras["ci_muestra"]."'";

                                      if ($res_newgrupo = mysqli_query($enlace, $q_newgrupo)) {
                                        // Indicando que es un reanálisis por positivo
                                          $q_reanalisis = "UPDATE Preparacion_Newmont_Detalle
                                                              SET Reanalisis_Por_Positivo = 1
                                                            WHERE Id = ".$row_muestras["Group_Newmont"];

                                          if ($res_reanalisis = mysqli_query($enlace, $q_reanalisis)) {
                                          }
                                      }
                                  }
                              }
                            }
                          }
                        }
                    }
                  }
                }
            }
            else{
              $estado = 0;
            }
          }

          $a += 1;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_Leyes_Plata':
      $r = array();
      $estado = 0;

      $id_detalle_peso = $_GET["Id_Detalle_Peso"];

      $q_leyes = "SELECT  ROUND(Ley_Ag) AS Ley_Ag,
                          ROUND(Ley_Ag_oz, 2) AS Ley_Ag_oz
                    FROM  Detalle_Rack_Pesos DRP
                   WHERE  Id = ".$id_detalle_peso;

      if ($res_leyes = mysqli_query($enlace, $q_leyes)) {
        if (mysqli_num_rows($res_leyes) > 0) {
          while($row_leyes = mysqli_fetch_assoc($res_leyes)) {
            $ley_Ag = $row_leyes["Ley_Ag"];
            $ley_Ag_oz = $row_leyes["Ley_Ag_oz"];
          }

          $estado = 1;
        }
      }

      echo json_encode(array('ley_Ag' => $ley_Ag, 'ley_Ag_oz' => $ley_Ag_oz));

      break;

    case 'get_Leyes_Oro':
      $r = array();
      $estado = 0;

      $id_detalle_peso = $_GET["Id_Detalle_Peso"];

      $q_leyes = "SELECT  ROUND(Ley_Au, 2) AS Ley_Au,
                          ROUND(Ley_Au_oz, 2) AS Ley_Au_oz,
                          ROUND(Ley_Ag_New) AS Ley_Ag,
                          ROUND(Ley_Ag_oz_New, 2) AS Ley_Ag_oz
                    FROM  Detalle_Rack_Pesos DRP
                   WHERE  Id = ".$id_detalle_peso;

      if ($res_leyes = mysqli_query($enlace, $q_leyes)) {
        if (mysqli_num_rows($res_leyes) > 0) {
          while($row_leyes = mysqli_fetch_assoc($res_leyes)) {
            $ley_Au = $row_leyes["Ley_Au"];
            $ley_Au_oz = $row_leyes["Ley_Au_oz"];
            $ley_Ag = $row_leyes["Ley_Ag"];
            $ley_Ag_oz = $row_leyes["Ley_Ag_oz"];
          }

          $estado = 1;
        }
      }

      echo json_encode(array('ley_Au' => $ley_Au, 'ley_Au_oz' => $ley_Au_oz, 'ley_Ag' => $ley_Ag, 'ley_Ag_oz' => $ley_Ag_oz));

      break;

    case 'verifica_ConfAg_PesoDore':
      $r = array();
      $estado = 0;

      $id_detallepeso = $_GET["id_detallepeso"];

      $q_ConfAg = "SELECT NULL AS Orden,
                          CR.nom_rack,
                          DRP.Num_Crisol,
                          DRP.NumCrisol_Dore,
                          DRP.Nom_Muestra,
                          DRP.Dosificacion,
                          DRP.Peso_Muestra,
                          DRP.Peso_Regulo,
                          DRP.Peso_Dore,
                          ROUND(DRP.Ley_Ag) AS Ley_Ag,
                          ROUND(DRP.Ley_Ag_oz, 2) AS Ley_Ag_oz,
                          ROUND(DRP.Conf_Ag_Dore, 2) AS Conf_Ag_Dore
                    FROM  Detalle_Rack_Pesos DRP
                          INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                          INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
                   WHERE  Id_FactorBlanco_Ag IN (SELECT DRP_x.Id_Detalle_Rack
                                                      FROM Detalle_Rack_Pesos DRP_x
                                                     WHERE DRP_x.Id = ".$id_detallepeso.")
                     AND  DRP.Conf_Ag_Dore > 1";

      if ($res_ConfAg = mysqli_query($enlace, $q_ConfAg)) {
        if (mysqli_num_rows($res_ConfAg) > 0) {
          while($row_ConfAg = mysqli_fetch_assoc($res_ConfAg)) {
            array_push($r, $row_ConfAg);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'update_ObservadoConfAg':
      $r = array();
      $estado = 0;

      $id_detallepeso = $_GET["id_detallepeso"];
      $nom_muestra = $_GET["nom_muestra"];
      $factor_plata = $_GET["factor_plata"];
      $usuario_observacion = $_GET["usuario_observacion"];

      // Generando solicitud de Reanálisis
      $q_Insert = "INSERT INTO Gestion_Solicitudes(Id_Solicitud, Id_Registro, usuario_solicitud, fecha_solicitud, observacion_solicitud) VALUES(";
      $q_Insert .= '7, ';
      $q_Insert .= $id_detallepeso.", ";
      $q_Insert .= "'".$usuario_observacion."', ";
      $q_Insert .= "'".$g_fecha."', ";
      $q_Insert .= "'Conf.Ag de Muestras desviado por Peso de Doré de Blanco Fundente')";

      if ($res = mysqli_query($enlace, $q_Insert)) {
        $estado = 1;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_ListaMuestrasHumedad':
      $r = array();
      $estado = 0;

      $fecha_inicio = $_GET["Fecha_Inicio"];
      $fecha_fin = $_GET["Fecha_Fin"];
      $ci_muestra = $_GET["CI_Muestra"];

      $q_Muestras = "SELECT 0 AS Item,
                            AHC.CI_Muestra,
                            CASE WHEN AHC.Cierre_Humedad = 0 THEN 'NO' ELSE 'SÍ' END AS Cierre_Humedad,
                            AHC.FechaHora_Recepcion,
                            AHC.UsuarioCierre_Humedad,
                            AHC.FechaCierre_Humedad,
                            AHC.Id
                      FROM  Analisis_Humedad_Cabecera AHC
                     WHERE  1 = 1";

      if ($ci_muestra != "0"){
        $q_Muestras .= "   AND AHC.CI_Muestra = '".$ci_muestra."'";
      }
      else{
        $q_Muestras .= "   AND DATE(AHC.FechaHora_Recepcion) BETWEEN '".$fecha_inicio."' AND '".$fecha_fin."'";
      }

      $q_Muestras .= " ORDER BY AHC.FechaHora_Recepcion DESC, AHC.Id_Detalle DESC";

      if ($res_Muestras = mysqli_query($enlace, $q_Muestras)) {
        if (mysqli_num_rows($res_Muestras) > 0) {
          while($row_Muestras = mysqli_fetch_assoc($res_Muestras)) {
            array_push($r, $row_Muestras);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'verifica_ConfAu_PesoOro':
      $r = array();
      $estado = 0;

      $id_detallepeso = $_GET["id_detallepeso"];

      $q_ConfAu = "SELECT NULL AS Orden,
                          CR.nom_rack,
                          DRP.Num_Crisol,
                          DRP.NumCrisol_Dore,
                          DRP.Nom_Muestra,
                          DRP.Dosificacion,
                          DRP.Peso_Muestra,
                          DRP.Peso_Regulo,
                          DRP.Peso_Dore,
                          DRP.Peso_Au,
                          ROUND(DRP.Ley_Ag_New) AS Ley_Ag,
                          ROUND(DRP.Ley_Au, 2) AS Ley_Au,
                          ROUND(DRP.Ley_Ag_oz_New, 2) AS Ley_Ag_oz,
                          ROUND(DRP.Ley_Au_oz, 2) AS Ley_Au_oz,
                          ROUND(DRP.Conf_Au, 2) AS Conf_Au,
                          ROUND(DRP.Conf_Ag, 2) AS Conf_Ag
                    FROM  Detalle_Rack_Pesos DRP
                          INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                          INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
                   WHERE  Id_FactorBlanco_Ag IN (SELECT DRP_x.Id_Detalle_Rack
                                                      FROM Detalle_Rack_Pesos DRP_x
                                                     WHERE DRP_x.Id = ".$id_detallepeso.")
                     AND  (DRP.Conf_Au > 1 OR DRP.Conf_Ag > 1)";

      if ($res_ConfAu = mysqli_query($enlace, $q_ConfAu)) {
        if (mysqli_num_rows($res_ConfAu) > 0) {
          while($row_ConfAu = mysqli_fetch_assoc($res_ConfAu)) {
            array_push($r, $row_ConfAu);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'update_ObservadoConfAu_PesoOro':
      $r = array();
      $estado = 0;

      $id_detallepeso = $_GET["id_detallepeso"];
      $nom_muestra = $_GET["nom_muestra"];
      $factor_plata = $_GET["factor_plata"];
      $usuario_observacion = $_GET["usuario_observacion"];

      // Generando solicitud de Reanálisis
      $q_Insert = "INSERT INTO Gestion_Solicitudes(Id_Solicitud, Id_Registro, usuario_solicitud, fecha_solicitud, observacion_solicitud) VALUES(";
      $q_Insert .= '10, ';
      $q_Insert .= $id_detallepeso.", ";
      $q_Insert .= "'".$usuario_observacion."', ";
      $q_Insert .= "'".$g_fecha."', ";
      $q_Insert .= "'Conf.Au / Conf.Ag de Muestras desviado por Peso de Oro de Blanco Fundente')";

      if ($res = mysqli_query($enlace, $q_Insert)) {
        $estado = 1;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'verifica_ConfAg_PesoOro':
      $r = array();
      $estado = 0;

      $id_detallepeso = $_GET["id_detallepeso"];

      $q_ConfAu = "SELECT NULL AS Orden,
                          CR.nom_rack,
                          DRP.Num_Crisol,
                          DRP.NumCrisol_Dore,
                          DRP.Nom_Muestra,
                          DRP.Dosificacion,
                          DRP.Peso_Muestra,
                          DRP.Peso_Regulo,
                          DRP.Peso_Dore,
                          DRP.Peso_Au,
                          ROUND(DRP.Ley_Ag_New) AS Ley_Ag,
                          ROUND(DRP.Ley_Au, 2) AS Ley_Au,
                          ROUND(DRP.Ley_Ag_oz_New, 2) AS Ley_Ag_oz,
                          ROUND(DRP.Ley_Au_oz, 2) AS Ley_Au_oz,
                          ROUND(DRP.Conf_Au, 2) AS Conf_Au,
                          ROUND(DRP.Conf_Ag, 2) AS Conf_Ag
                    FROM  Detalle_Rack_Pesos DRP
                          INNER JOIN Detalle_Rack DR ON DRP.Id_Detalle_Rack = DR.Id
                          INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
                   WHERE  Id_FactorBlanco_Ag IN (SELECT DRP_x.Id_Detalle_Rack
                                                      FROM Detalle_Rack_Pesos DRP_x
                                                     WHERE DRP_x.Id = ".$id_detallepeso.")
                     AND  DRP.Conf_Ag > 1";

      if ($res_ConfAu = mysqli_query($enlace, $q_ConfAu)) {
        if (mysqli_num_rows($res_ConfAu) > 0) {
          while($row_ConfAu = mysqli_fetch_assoc($res_ConfAu)) {
            array_push($r, $row_ConfAu);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'update_ObservadoConfAg_PesoOro':
      $r = array();
      $estado = 0;

      $id_detallepeso = $_GET["id_detallepeso"];
      $nom_muestra = $_GET["nom_muestra"];
      $factor_plata = $_GET["factor_plata"];
      $usuario_observacion = $_GET["usuario_observacion"];

      // Generando solicitud de Reanálisis
      $q_Insert = "INSERT INTO Gestion_Solicitudes(Id_Solicitud, Id_Registro, usuario_solicitud, fecha_solicitud, observacion_solicitud) VALUES(";
      $q_Insert .= '11, ';
      $q_Insert .= $id_detallepeso.", ";
      $q_Insert .= "'".$usuario_observacion."', ";
      $q_Insert .= "'".$g_fecha."', ";
      $q_Insert .= "'Conf.Ag de Muestras desviado por Peso de Oro de Blanco Fundente')";

      if ($res = mysqli_query($enlace, $q_Insert)) {
        $estado = 1;
      }

      echo json_encode(array('estado' => $estado));

      break;

    default:

      # code...

      break;

  }

?>