<?php
  
  session_start();

  include('../../php/conn.php');

  if(!isset($_SESSION["id"])){
    header('Location: index.php');
  }

  mysqli_query($enlace, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");
  mysqli_query($enlacehost, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");

?>

<!DOCTYPE html>
<html lang="es">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <!-- Meta, title, CSS, favicons, etc. -->
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <title>Conformidad y Reporte de Resultados</title>

        <!-- Bootstrap -->
        <link href="../vendors/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
        <!-- Font Awesome -->
        <link href="../vendors/font-awesome/css/font-awesome.min.css" rel="stylesheet">
        <!-- NProgress -->
        <link href="../vendors/nprogress/nprogress.css" rel="stylesheet">
        <!-- iCheck -->
        <link href="../vendors/iCheck/skins/flat/green.css" rel="stylesheet">
        <!-- bootstrap-progressbar -->
        <link href="../vendors/bootstrap-progressbar/css/bootstrap-progressbar-3.3.4.min.css" rel="stylesheet">
        <!-- JQVMap -->
        <link href="../vendors/jqvmap/dist/jqvmap.min.css" rel="stylesheet"/>
        <!-- bootstrap-daterangepicker -->
        <link href="../vendors/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
        <!-- Ion.RangeSlider -->
        <link href="../vendors/normalize-css/normalize.css" rel="stylesheet">
        <link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.css" rel="stylesheet">
        <link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.skinFlat.css" rel="stylesheet">
        <!-- Bootstrap Colorpicker -->
        <link href="../vendors/mjolnic-bootstrap-colorpicker/dist/css/bootstrap-colorpicker.min.css" rel="stylesheet">
        <link href="../vendors/cropper/dist/cropper.min.css" rel="stylesheet">
        <!-- Datatables -->
        <link href="../vendors/datatables.net-bs/css/dataTables.bootstrap.min.css" rel="stylesheet">
        <link href="../vendors/datatables.net-buttons-bs/css/buttons.bootstrap.min.css" rel="stylesheet">
        <link href="../vendors/datatables.net-fixedheader-bs/css/fixedHeader.bootstrap.min.css" rel="stylesheet">
        <link href="../vendors/datatables.net-responsive-bs/css/responsive.bootstrap.min.css" rel="stylesheet">
        <link href="../vendors/datatables.net-scroller-bs/css/scroller.bootstrap.min.css" rel="stylesheet">

        <!-- bootstrap-datetimepicker -->
        <link href="../vendors/bootstrap-datetimepicker/build/css/bootstrap-datetimepicker.css" rel="stylesheet">

        <!-- Switchery -->
        <link href="../vendors/switchery/dist/switchery.min.css" rel="stylesheet">

        <!-- Custom Theme Style -->
        <link href="../build/css/custom.min.css" rel="stylesheet">

        <script type="text/javascript">
            var Id_Pedido = 0;
            var Id_DetallePedido = 0;
            var Estado_Cierre = 0;
            var campos_evaluados = 0;
            var select_reanalisis = 1;
            var total_select = 0;
            var total_select_habilitados = 0;
            const arr_select = [];
        </script>

        <style type="text/css">
            th {
                position: sticky;
                top: 0px;
                background-color: #12537E;
            }
        </style>
    </head>

    <body class="nav-md" onload="f_LoadResultados()" style="zoom: 80%">
        <div class="container body">
            <div class="main_container">
                <?php include('partes/sidebar.php'); ?>

                <!-- page content -->
                <div class="right_col" role="main">
                    <div class="">
                        <div class="row">
                            <div class="col-md-12 col-sm-12 col-xs-12">
                                <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                    <div class="x_title">
                                        <h2>
                                            Revisión y Conformidad de Resultados
                                        </h2>
                                        <div class="clearfix">
                                        </div>
                                    </div>

                                    <div class="x_content">
                                        <!-- Filtros -->
                                        <div class="col-md-6 col-sm-6 col-xs-12">
                                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                                <div class="x_title">
                                                    <h2>
                                                        <font style="font-size: 14px"><b>Búsqueda por rango de fechas</b></font>
                                                    </h2>
                                                    <div class="clearfix">
                                                    </div>
                                                </div>
                                                <div class="x_content">
                                                    <div class="form-group col-md-6 col-sm-6 col-xs-12" style="margin-top: 9px;">
                                                        <label class="control-label col-md-5 col-sm-5 col-xs-12" style="margin-top: 6px; text-align: right;">
                                                            Desde
                                                        </label>
                                                        <div class="col-md-7 col-sm-7 col-xs-12">
                                                            <?php
                                                                date_default_timezone_set("America/Lima"); 
                                                                $time = date('Y-m-d');

                                                                echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_inicio" value="'.$time.'"/>';
                                                            ?>
                                                        </div>
                                                    </div>

                                                    <div class="form-group col-md-6 col-sm-6 col-xs-12" style="margin-top: 9px;">
                                                        <label class="control-label col-md-5 col-sm-5 col-xs-12" style="margin-top: 6px; text-align: right;">
                                                            Hasta
                                                        </label>
                                                        <div class="col-md-7 col-sm-7 col-xs-12">
                                                            <?php
                                                                echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_fin" value="'.$time.'"/>';
                                                            ?>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="col-md-3 col-sm-3 col-xs-12">
                                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                                <div class="x_title">
                                                    <h2>
                                                        <font style="font-size: 14px"><b>Búsqueda por Tipo de Solicitud</b></font>
                                                    </h2>
                                                    <div class="clearfix">
                                                    </div>
                                                </div>
                                                <div class="x_content">
                                                    <div class="form-group col-md-12 col-sm-12 col-xs-12" style="margin-top: 9px;">
                                                        <select id="lista_tipomuestra" class="form-control" required>
                                                            <option selected = "true" value="">Elija una opción...</option>

                                                            <?php
                                                                $q_Tipos = "SELECT  Id,
                                                                                    des_solicitud
                                                                              FROM  tbconfig_Solicitudes
                                                                            ORDER BY 2";

                                                                if ($res_Tipos = mysqli_query($enlace, $q_Tipos)) {
                                                                    if (mysqli_num_rows($res_Tipos) > 0) {
                                                                        while($row_Tipos = mysqli_fetch_assoc($res_Tipos)) {
                                                                            echo '<option value="'.$row_Tipos["Id"].'">'.$row_Tipos["des_solicitud"].'</option>';
                                                                        }
                                                                    }
                                                                }
                                                            ?>

                                                        </select>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="col-md-3 col-sm-3 col-xs-12">
                                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                                <div class="x_title">
                                                    <h2>
                                                        <font style="font-size: 14px"><b>Búsqueda por Solicitante</b></font>
                                                    </h2>
                                                    <div class="clearfix">
                                                    </div>
                                                </div>
                                                <div class="x_content">
                                                    <div class="form-group col-md-12 col-sm-12 col-xs-12" style="margin-top: 9px;">
                                                        <select id="lista_fundidor" class="form-control" style="text-align: left;">
                                                            <option value="">Elija una opción...</option>

                                                            <?php
                                                                $c = 1;

                                                                $q_Usuarios = "SELECT  usuario_solicitud
                                                                                 FROM  Gestion_Solicitudes
                                                                               ORDER BY 1";

                                                                if ($res_Usuarios = mysqli_query($enlace, $q_Usuarios)) {
                                                                    if (mysqli_num_rows($res_Usuarios) > 0) {
                                                                        while($row_Usuarios = mysqli_fetch_assoc($res_Usuarios)) {
                                                                            echo '<option value="'.$row_Usuarios["usuario_solicitud"].'">'.$row_Usuarios["usuario_solicitud"].'</option>';

                                                                            $c += 1;
                                                                        }
                                                                    }
                                                                }
                                                            ?>
                                                        </select>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-md-12 col-sm-12 col-xs-12">
                                <button class="btn btn-success" type="button" onclick="f_LoadResultados()" style="width: 100%; background-color: #26B99A">
                                     <b>Ejecutar Búsqueda</b>
                                </button>
                            </div>
                        </div>

                        <div class="row" style="margin-top: 10px">
                            <div class="col-md-12 col-sm-12 col-xs-12">
                                <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                    <div class="x_title">
                                        <div class="col-md-6 col-sm-6 col-xs-6">
                                            <h2>
                                                Lista de Resultados
                                            </h2>
                                        </div>

                                        <div class="clearfix">
                                        </div>
                                    </div>

                                    <div class="x_content">
                                        <div class="table-box" style="height: 1000px; width: 100%; overflow: scroll;">
                                            <table class="table table-striped jambo_table bulk_action">
                                                <thead>
                                                    <tr>
                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Item
                                                        </center></th>
                                                        <th colspan="5" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Datos de Solicitud
                                                        </center></th>
                                                        <th colspan="4" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Datos de Confirmación
                                                        </center></th>
                                                        <th rowspan="2" colspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Acciones
                                                        </center></th>
                                                    </tr>

                                                    <tr>
                                                        <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Fecha
                                                        </center></th>
                                                        <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Solicitante
                                                        </center></th>
                                                        <th style="border: solid; border-width: 1px; border-color: #ffffff;"><center>
                                                            Tipo
                                                        </center></th>
                                                        <th style="border: solid; border-width: 1px; border-color: #ffffff; background-color: #734432"><center>
                                                            Módulo
                                                        </center></th>
                                                        <th style="border: solid; border-width: 1px; border-color: #ffffff;"><center>
                                                            Observación
                                                        </center></th>
                                                        <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Fecha
                                                        </center></th>
                                                        <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Usuario
                                                        </center></th>
                                                        <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Observación
                                                        </center></th>
                                                        <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Resultado
                                                        </center></th>
                                                    </tr>
                                                </thead>

                                                <tbody id="tabla_resultados" style="overflow: scroll">
                                                    
                                                </tbody>
                                            </table>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- Ventanas Modal -->
        <div id="divmodal_Detalles" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false">
            <div class="modal-dialog" style="width: 70%; margin-top: 3%; margin-left: 15%">
                <!-- Modal content-->
                <div class="modal-content" style="min-width: 380px;">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal">
                            &times;
                        </button>

                        <h4 class="modal-title"><b>
                            Detalle de Solicitud
                        </b></h4>
                    </div>

                    <div class="modal-body">
                        <form class="form-horizontal form-label-left">
                            <div class="form-group col-md-12 col-sm-12 col-xs-12">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Módulo
                                </label>
                                <div class="col-md-7 col-sm-7 col-xs-12">
                                    <input type="text" class="form-control col-md-12 col-xs-12" id="txt_modulo" disabled/>
                                </div>
                            </div>
                            <div class="form-group col-md-12 col-sm-12 col-xs-12">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Tipo Solicitud
                                </label>
                                <div class="col-md-7 col-sm-7 col-xs-12">
                                    <input type="text" class="form-control col-md-12 col-xs-12" id="txt_tiposolicitud" disabled></input>
                                </div>
                            </div>
                            <div class="form-group col-md-12 col-sm-12 col-xs-12">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Fecha Solicitud
                                </label>
                                <div class="col-md-7 col-sm-7 col-xs-12">
                                    <input type="text" class="form-control col-md-12 col-xs-12" id="txt_fecha" disabled/>
                                </div>
                            </div>
                            <div class="form-group col-md-12 col-sm-12 col-xs-12">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Usuario Solicitud
                                </label>
                                <div class="col-md-7 col-sm-7 col-xs-12">
                                    <input type="text" class="form-control col-md-12 col-xs-12" id="txt_usuario" disabled/>
                                </div>
                            </div>
                            <div class="form-group col-md-12 col-sm-12 col-xs-12">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                    Observación
                                </label>
                                <div class="col-md-7 col-sm-7 col-xs-12">
                                    <textarea type="text" class="form-control col-md-12 col-xs-12" id="txt_observacion" disabled></textarea>
                                </div>
                            </div>

                            <div id="div_tipo3">
                                <br/>

                                <div class="form-group col-md-12 col-sm-12 col-xs-12">
                                    <div class="ln_solid"></div>
                                </div>

                                <div class="col-md-4 col-sm-4 col-xs-4">
                                    <div style="text-align: center; background-color: #404040; color: #ffffff; height: 30px; border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                        <label style="margin-top: 5px;">
                                            Datos Principales
                                        </label>
                                    </div>

                                    <div class="table-box" style="width: 100%">
                                        <table class="table table-striped jambo_table bulk_action">
                                            <tbody id="tabla_tipo3_datosprincipales">
                                                
                                            </tbody>
                                        </table>
                                    </div>
                                </div>

                                <div class="col-md-8 col-sm-8 col-xs-8">
                                    <div style="text-align: center; background-color: #404040; color: #ffffff; height: 30px; border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                        <label style="margin-top: 5px;">
                                            Datos de Muestras
                                        </label>
                                    </div>

                                    <div class="table-box" style="width: 100%;">
                                        <table class="table table-striped jambo_table bulk_action">
                                            <thead>
                                                <tr>
                                                    <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                        N° Orden en Rack
                                                    </center></th>
                                                    <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                        N° Crisol
                                                    </center></th>
                                                    <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                        Tipo Blanco Fundente
                                                    </center></th>
                                                    <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                        Dosifi.
                                                    </center></th>
                                                    <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                        Peso Muestra
                                                    </center></th>
                                                    <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                        Peso Régulo
                                                    </center></th>
                                                    <th style="background-color: #FF2F1E; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                        Peso Doré
                                                    </center></th>
                                                    <th id="th_dore_1" style="background-color: #FF2F1E; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                        Ley Ag (g/tm)
                                                    </center></th>
                                                    <th id="th_dore_2" style="background-color: #FF2F1E; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                        Ley Ag (oz/tc)
                                                    </center></th>
                                                    <th id="th_oro" style="background-color: #FF2F1E; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                        Peso Oro
                                                    </center></th>
                                                    <th id="th_oro_Ag1" style="background-color: #FF2F1E; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                        Ley Ag (g/tm)
                                                    </center></th>
                                                    <th id="th_oro_Au1" style="background-color: #FF2F1E; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                        Ley Au (g/tm)
                                                    </center></th>
                                                    <th id="th_oro_Ag2" style="background-color: #FF2F1E; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                        Ley Ag (oz/tc)
                                                    </center></th>
                                                    <th id="th_oro_Au2" style="background-color: #FF2F1E; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                        Ley Au (oz/tc)
                                                    </center></th>
                                                </tr>
                                            </thead>

                                            <tbody id="tabla_tipo3_detalle" style="overflow: scroll">
                                                
                                            </tbody>
                                        </table>
                                    </div>

                                    <div class="row" id="div_muestrasobservadas">
                                        <div id="div_muestrasseleccionadas" class="col-md-6 col-sm-6 col-xs-6">
                                            <label style="color: #12537E">
                                                Muestras seleccionadas para Reanálisis:
                                            </label>
                                            <label id="num_muestrasreanalisis" style="color: #12537E">
                                                0
                                            </label>
                                        </div>

                                        <div class="col-md-6 col-sm-6 col-xs-6" style="text-align: right;">
                                            <label style="cursor: pointer; color: #FF2F1E" onclick="f_OpenMuestrasObservadas();"><u>
                                                Ver Muestras Observadas
                                            </u></label>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <br/>

                            <!-- Campos usados al momento de la confirmación -->
                            <input id="id_confirmar" type="hidden">
                            <input id="id_solicitud" type="hidden">
                            <input id="id_modulo" type="hidden">
                            <input id="id_registro" type="hidden">
                            <input id="is_newmontpositivo" type="hidden">

                            <input id="update_aprobacion" type="hidden">
                            <input id="update_rechazo" type="hidden">
                            <input id="update_idgestion" type="hidden">
                            <input id="update_idreanalisis" type="hidden">

                            <div class="form-group col-md-12 col-sm-12 col-xs-12">
                                <div class="ln_solid"></div>
                            </div>

                            <div id="div_preview" class="form-group col-md-12 col-sm-12 col-xs-12" style="text-align: center;">
                                <button class="btn btn-dark" type="button" onclick="f_cerrarModal(1)">
                                    Cerrar
                                </button>
                            </div>

                            <div id="div_confirmar" class="form-group col-md-12 col-sm-12 col-xs-12" style="text-align: center;">
                                <div id="div_tituloconfirmar" class="form-group col-md-12 col-sm-12 col-xs-12" style="background-color: #3399CC; height: 30px; border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                    <label id="titulo_confirmar" style="color: #ffffff;margin-top: 6px;">
                                        USTED ESTÁ APROBANDO ESTA SOLICITUD
                                    </label>
                                </div>

                                <div id="div_tipoanalisis" class="form-group col-md-12 col-sm-12 col-xs-12">
                                    <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                        Tipo Ensayo
                                    </label>
                                    <div class="col-md-7 col-sm-7 col-xs-12">
                                        <select id="lista_tipoanalisis" class="form-control" required="">
                                            <option selected="true" value="">Elija una opción...</option>
                                            <option value="2">Lote (Duplicado)</option>
                                            <option value="3">Dirimencia (Triplicado)</option>
                                            <option value="1">Reconocimiento (Simple)</option>
                                        </select>
                                    </div>
                                </div>

                                <div class="form-group col-md-12 col-sm-12 col-xs-12">
                                    <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                        Observación
                                    </label>
                                    <div class="col-md-7 col-sm-7 col-xs-12">
                                        <textarea type="text" class="form-control col-md-12 col-xs-12" id="txt_newobservacion"></textarea>
                                    </div>
                                </div>

                                <br>

                                <div class="form-group col-md-12 col-sm-12 col-xs-12" style="margin-top: 20px;">
                                    <button class="btn btn-success" type="button" onclick="f_ConfirmarSolicitud()">
                                        Confirmar
                                    </button>
                                    <button class="btn btn-dark" type="button" onclick="f_cerrarModal(1)">
                                        Cancelar
                                    </button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>

        <div id="divmodal_MuestrasObservadas" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false">
            <div class="modal-dialog" style="width: 90%; margin-left: 4%">
                <!-- Modal content-->
                <div class="modal-content" style="min-width: 380px;">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal">
                            &times;
                        </button>

                        <h4 class="modal-title" style="color: #FF2F1E;"><b>
                            Lista de Muestras Observadas
                        </b></h4>
                    </div>

                    <div class="modal-body">
                        <form class="form-horizontal form-label-left">
                            <div class="table-box" style="height: 670px; width: 100%; overflow: scroll;">
                                <table class="table table-striped jambo_table bulk_action">
                                    <thead>
                                        <tr>
                                            <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                N° Item
                                            </center></th>
                                            <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #404040; min-width: 250px;"><center>
                                                Datos de Rack
                                            </center></th>
                                            <!-- <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #009494; min-width: 170px;"><center>
                                                Estado del Proceso
                                            </center></th> -->
                                            <th id="th_titulo" colspan="12" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                Datos de Muestras afectadas por la Desviación de Plata de Blanco Fundente
                                            </center></th>
                                            <th id="th_confau" rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                Conf.Au
                                            </center></th>
                                            <th id="th_confag" rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                Conf.Ag
                                            </center></th>
                                            <th id="th_reanalisis" rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #FF2F1E; min-width: 220px;"><center>
                                                Reanálisis
                                            </center></th>
                                        </tr>

                                        <tr>
                                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 80px;"><center>
                                                N° Orden en Rack
                                            </center></th>
                                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                Tipo
                                            </center></th>
                                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                N° Crisol
                                            </center></th>
                                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 150px;"><center>
                                                Muestra
                                            </center></th>
                                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 100px;"><center>
                                                Tipo Blanco Fundente
                                            </center></th>
                                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                Dosific.
                                            </center></th>
                                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                Peso Muestra
                                            </center></th>
                                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                Peso Régulo
                                            </center></th>
                                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                Peso Doré
                                            </center></th>
                                            <th id="th_pesooro" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                Peso Oro
                                            </center></th>
                                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 180px; background-color: #734432"><center>
                                                Observaciones en Régulo
                                            </center></th>
                                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 180px; background-color: #734432"><center>
                                                Observaciones en Doré
                                            </center></th>
                                        </tr>
                                    </thead>
                                        
                                    <tbody id="tabla_detallemuestrasobservadas">

                                    </tbody>
                                </table>
                            </div>

                            <div class="form-group col-md-12 col-sm-12 col-xs-12">
                                <div class="ln_solid"></div>
                            </div>

                            <div id="div_preview_muestrasobservadas" class="form-group col-md-12 col-sm-12 col-xs-12" style="text-align: center;">
                                <button class="btn btn-dark" type="button" onclick="f_cerrarModal(2)">
                                    Cerrar
                                </button>
                            </div>

                            <div id="div_confirmar_muestrasobservadas" class="form-group col-md-12 col-sm-12 col-xs-12" style="text-align: center;">
                                <button class="btn btn-success" type="button" onclick="f_ConfirmarMuestrasObservadas()">
                                    Confirmar
                                </button>
                                <button class="btn btn-dark" type="button" onclick="f_cerrarModal(2)">
                                    Cancelar
                                </button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>

        <div id="divmodal_Loading" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false" style="margin-top: 300px;">
            <div class="modal-dialog" style="height: 200px; opacity: 0.5;"><center>
                <img src="images/loading.gif" width="200px" style="border: solid; border-width: 1px; border-color: #D9D9D9;  border-radius: 15px;"></img>
            </center></div>
        </div>

        <!-- jQuery -->
        <script src="../vendors/jquery/dist/jquery.min.js"></script>
        <!-- Bootstrap -->
        <script src="../vendors/bootstrap/dist/js/bootstrap.min.js"></script>
        <!-- FastClick -->
        <script src="../vendors/fastclick/lib/fastclick.js"></script>
        <!-- NProgress -->
        <script src="../vendors/nprogress/nprogress.js"></script>
        <!-- Ion.RangeSlider -->
        <script src="../vendors/ion.rangeSlider/js/ion.rangeSlider.min.js"></script>
        <!-- Bootstrap Colorpicker -->
        <script src="../vendors/mjolnic-bootstrap-colorpicker/dist/js/bootstrap-colorpicker.min.js"></script>
        <!-- Custom Theme Scripts -->
        <script src="../build/js/custom.min.js"></script>

        <!-- bootstrap-daterangepicker -->
        <script src="../vendors/moment/min/moment.min.js"></script>
        <script src="../vendors/bootstrap-daterangepicker/daterangepicker.js"></script>
        <!-- Datatables -->
        <script src="../vendors/datatables.net/js/jquery.dataTables.min.js"></script>
        <script src="../vendors/datatables.net-bs/js/dataTables.bootstrap.min.js"></script>
        <script src="../vendors/datatables.net-buttons/js/dataTables.buttons.min.js"></script>
        <script src="../vendors/datatables.net-buttons-bs/js/buttons.bootstrap.min.js"></script>
        <script src="../vendors/datatables.net-buttons/js/buttons.flash.min.js"></script>
        <script src="../vendors/datatables.net-buttons/js/buttons.html5.min.js"></script>
        <script src="../vendors/datatables.net-buttons/js/buttons.print.min.js"></script>
        <script src="../vendors/datatables.net-fixedheader/js/dataTables.fixedHeader.min.js"></script>
        <script src="../vendors/datatables.net-keytable/js/dataTables.keyTable.min.js"></script>
        <script src="../vendors/datatables.net-responsive/js/dataTables.responsive.min.js"></script>
        <script src="../vendors/datatables.net-responsive-bs/js/responsive.bootstrap.js"></script>
        <script src="../vendors/datatables.net-scroller/js/dataTables.scroller.min.js"></script>
        <script src="../vendors/jszip/dist/jszip.min.js"></script>
        <script src="../vendors/pdfmake/build/pdfmake.min.js"></script>
        <script src="../vendors/pdfmake/build/vfs_fonts.js"></script>

        <!-- Funciones Principales -->
        <script type="text/javascript">

            function f_LoadResultados(){
                var htmlContenido = '';

                // Obteniendo filtros
                    var fecha_inicio = $("#fecha_inicio").val();
                    var fecha_fin = $("#fecha_fin").val();
                    var lista_tiposolicitud = $("#lista_tiposolicitud").val();
                    var lista_solicitante = $("#lista_solicitante").val();

                // Validando ingreso de filtros
                    if (fecha_inicio == null){
                        alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                        return;
                    }
                    if (fecha_inicio.length == 0){
                        alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                        return;
                    }

                    if (fecha_fin == null){
                        alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                        return;
                    }
                    if (fecha_fin.length == 0){
                        alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                        return;
                    }

                    if (fecha_fin < fecha_inicio){
                        alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

                        return;
                    }

                // Loading Modal
                    var modal_loading = $("#divmodal_Loading");
                    modal_loading.modal({backdrop: 'static', keyboard: false});

                // Carga resultados
                    var c = 1;
                    var _visible = 0;
                    var _campos = '';

                    $("#tabla_resultados").html(htmlContenido);

                    var n = 1;

                    $.post( "ajax/encuesta.php", { accion: "get_Solicitudes", fecha_inicio: fecha_inicio, fecha_fin: fecha_fin, id_tiposolicitud: lista_tiposolicitud, id_solicitante: lista_solicitante }, 
                        function( data ) {
                            if(data.estado == 1){
                                $.each( data.registros, function( key, val ) {
                                        htmlContenido += '<tr>';
                                        htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right;">' + n + '</td>';
                                    
                                        htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                                        htmlContenido += '      ' + val.fecha_solicitud;
                                        htmlContenido += '  </td>';

                                        htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                                        htmlContenido += '      ' + val.usuario_solicitud;
                                        htmlContenido += '  </td>';

                                        htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; color: #2AA4EB;" onclick="f_GestionSolicitud(0, ' + val.Id + ')" ><u>';
                                        htmlContenido += '      ' + val.des_solicitud;
                                        htmlContenido += '  </u></td>';

                                        htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                                        htmlContenido += '      ' + val.nom_modulo;
                                        htmlContenido += '  </td>';

                                        htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;">';
                                        htmlContenido += '      ' + val.observacion_solicitud;
                                        htmlContenido += '  </u></td>';
                                    
                                        htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                                        htmlContenido += '      ' + ((val.fecha_confirmacion == null) ? '' : val.fecha_confirmacion);
                                        htmlContenido += '  </td>';
                                    
                                        htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                                        htmlContenido += '      ' + ((val.usuario_confirmacion == null) ? '' : val.usuario_confirmacion);
                                        htmlContenido += '  </td>';
                                    
                                        htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                                        htmlContenido += '      ' + ((val.observacion_confirmacion == null) ? '' : val.observacion_confirmacion);
                                        htmlContenido += '  </td>';

                                        // Definiendo color de BG
                                            if (val.tiene_gestionprevia == 1 || val.atendido_gestionprevia == 1 || val.atendido_gestionposterior == 1){
                                                $color_bg = '#8C8C8C';
                                                $color = '#ffffff';
                                            }
                                            else{
                                                if (val.solicitud_aceptada == 0 && val.solicitud_rechazada == 0){
                                                    $color_bg = '#F2BE22';
                                                    $color = '#212226';
                                                }
                                                else{
                                                    if (val.solicitud_aceptada == 1){
                                                        $color_bg = '#26B99A';
                                                        $color = '#ffffff';   
                                                    }
                                                    else{
                                                        $color_bg = '#F25050';
                                                        $color = '#ffffff';
                                                    }
                                                    
                                                }
                                            }
                                    
                                        htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; background-color: ' + $color_bg + '; color: ' + $color + ';">';
                                        htmlContenido += '      ' + ((val.CONFIRMACION == null) ? '' : val.CONFIRMACION);
                                        htmlContenido += '  </td>';

                                        if (val.solicitud_aceptada == 0 && val.solicitud_rechazada == 0 && val.tiene_gestionprevia == 0 && val.atendido_gestionprevia == 0 && val.atendido_gestionposterior == 0){
                                            if (val.Id_Solicitud == 4 || val.Id_Solicitud == 6 || val.Id_Solicitud == 7 || val.Id_Solicitud == 9 || val.Id_Solicitud == 10){
                                                htmlContenido += '  <td colspan="2" style="text-align: center; vertical-align: middle;">';
                                                htmlContenido += '      <button class="btn btn-success" type="button" onclick="f_GestionSolicitud(1, ' + val.Id + ')" style="width: 100%; background-color: #3399CC">';
                                                htmlContenido += '          Gestionar Muestras';
                                                htmlContenido += '      </button>';
                                                htmlContenido += '  </td>';
                                            }
                                            else{
                                                htmlContenido += '  <td style="text-align: center; vertical-align: middle;">';
                                                htmlContenido += '      <button class="btn btn-success" type="button" onclick="f_GestionSolicitud(1, ' + val.Id + ')" style="width: 100%; background-color: #3399CC">';
                                                htmlContenido += '          Aprobar';
                                                htmlContenido += '      </button>';
                                                htmlContenido += '  </td>';

                                                htmlContenido += '  <td style="text-align: center; vertical-align: middle;">';
                                                htmlContenido += '      <button class="btn btn-success" type="button" onclick="f_GestionSolicitud(2, ' + val.Id + ')" style="width: 100%; background-color: #F25050">';
                                                htmlContenido += '          Rechazar';
                                                htmlContenido += '      </button>';
                                                htmlContenido += '  </td>';
                                            }
                                        }
                                        else{
                                            htmlContenido += '<td></td>';
                                            htmlContenido += '<td></td>';
                                        }

                                    htmlContenido += "</tr>";

                                    n += 1;
                                });

                            }
                            else{
                                alert("No se encontraron resultados para la búsqueda solicitada");
                            }

                            // Cerrando Modal
                                $('#divmodal_Loading').modal('hide');

                                $("#tabla_resultados").html(htmlContenido);
                        }, "json");
            };

            function f_GestionSolicitud(_Confirmacion, _Id){
                var modal = $("#divmodal_Detalles");

                // Reservando datos
                    $("#id_confirmar").val(_Confirmacion);
                    $("#id_solicitud").val(_Id);
                    $("#id_modulo").val('');
                    $("#id_registro").val('');
                    $("#is_newmontpositivo").val('');
                    $("update_aprobacion").val('');
                    $("update_rechazo").val('');
                    $("update_idgestion").val('');
                    $("update_idreanalisis").val('');

                $("#txt_modulo").val('');
                $("#txt_tiposolicitud").val('');
                $("#txt_fecha").val('');
                $("#txt_usuario").val('');
                $("#txt_observacion").val('');
                $("#txt_newobservacion").val('');
                $("#num_muestrasreanalisis").html('0')

                var _divTitulo = document.getElementById('div_tituloconfirmar');

                if (_Confirmacion == 0){
                    f_CerrarDiv('A', 'div_preview');
                    f_CerrarDiv('C', 'div_confirmar');
                }
                else{
                    f_CerrarDiv('C', 'div_preview');
                    f_CerrarDiv('A', 'div_confirmar');

                    // Personalizando el título
                        if (_Confirmacion == 1){
                            _divTitulo.style.backgroundColor = "#3399CC";

                            $("#titulo_confirmar").html('USTED ESTÁ APROBANDO ESTA SOLICITUD');
                        }
                        else{
                            _divTitulo.style.backgroundColor = "#F25050";

                            $("#titulo_confirmar").html('USTED ESTÁ RECHAZANDO ESTA SOLICITUD');
                        }
                }

                f_CerrarDiv('C', 'div_tipoanalisis');

                $("#tabla_tipo3_datosprincipales").html('');
                $("#tabla_tipo3_detalle").html('');

                // Loading Modal
                    var modal_loading = $("#divmodal_Loading");
                    modal_loading.modal({backdrop: 'static', keyboard: false});

                // Obtiene los datos para la gestión
                    $.post( "ajax/encuesta.php", { accion: "get_GestionSolicitud_Detalles", Id: _Id }, 
                        function( data ) {
                            if(data.estado == 1){
                                $.each( data.registros, function( key, val ) {
                                    $("#txt_modulo").val(val.nom_modulo);
                                    $("#txt_tiposolicitud").val(val.des_solicitud);
                                    $("#txt_fecha").val(val.fecha_solicitud);
                                    $("#txt_usuario").val(val.usuario_solicitud);
                                    $("#txt_observacion").val(val.observacion_solicitud);

                                    // Obteniendo el Factor de Plata para cuando sea tipo 3 (Doré)
                                        if (val.Id_Solicitud == 3 || val.Id_Solicitud == 4 || val.Id_Solicitud == 5 || val.Id_Solicitud == 6 || val.Id_Solicitud == 8 || val.Id_Solicitud == 9 || val.Id_Solicitud == 10){
                                            var factor_plata = val.observacion_solicitud.substr(val.observacion_solicitud.indexOf('"') + 1);
                                            factor_plata = factor_plata.substr(0, factor_plata.indexOf('"'));
                                        }

                                    // Oculta los campos dependiendo si es Doré u Oro
                                        f_CerrarDiv('A', 'th_oro');
                                        f_CerrarDiv('A', 'th_oro_Ag1');
                                        f_CerrarDiv('A', 'th_oro_Au1');
                                        f_CerrarDiv('A', 'th_oro_Ag2');
                                        f_CerrarDiv('A', 'th_oro_Au2');
                                        f_CerrarDiv('A', 'th_dore_1');
                                        f_CerrarDiv('A', 'th_dore_2');
                                        f_CerrarDiv('A', 'th_pesooro');

                                        if (val.Id_Solicitud < 5 || val.Id_Solicitud == 7){
                                            f_CerrarDiv('C', 'th_oro');
                                            f_CerrarDiv('C', 'th_oro_Ag1');
                                            f_CerrarDiv('C', 'th_oro_Au1');
                                            f_CerrarDiv('C', 'th_oro_Ag2');
                                            f_CerrarDiv('C', 'th_oro_Au2');
                                            f_CerrarDiv('C', 'th_pesooro');
                                        }

                                        if ((val.Id_Solicitud >= 5 && val.Id_Solicitud <= 6) || (val.Id_Solicitud >= 8 && val.Id_Solicitud <= 10)){
                                            f_CerrarDiv('C', 'th_dore_1');
                                            f_CerrarDiv('C', 'th_dore_2');
                                        }

                                    // Cambiando el título
                                        $("#titulo_confirmar").html('USTED ESTÁ POR CONFIRMAR LA GESTIÓN DE MUESTRAS AFECTADAS POR LA DESVIACIÓN DE BLANCO FUNDENTE');

                                    // Valida si hubo una gestión previa, permitirá confirmar la gestión anterior mientras el reanálisis no se haya concretado
                                        $.post( "ajax/encuesta.php", { accion: "get_GestionPrevia", Id: _Id },
                                            function( data2 ) {
                                                if(data2.estado == 1){
                                                    $.each( data2.registros, function( key, val2 ) {
                                                        if (val2.is_cargadoennuevorack == 1){
                                                            $.post( "ajax/encuesta.php", { accion: "update_GestionPrevia", id_gs: _Id, id_gestionprevia: val2.ID_GS },
                                                                function( data ) {
                                                                    if(data.estado == 1){
                                                                        f_cerrarModal(1);
                                                                    }
                                                                    else{
                                                                        alert("Ocurrió un error al momento de actualizar los datos de Gestión Previa.");
                                                                    }

                                                                    // Cerrando Modal
                                                                        $('#divmodal_Loading').modal('hide');

                                                                }, "json");

                                                            alert('El usuario "' + val2.usuario_confirmacion + '"' + " confirmó previamente un reanálisis para esta muestra, la cual se encuentra ya en proceso. Los datos son los siguientes:\n\n- Fecha de Confirmación: " + val2.fecha_confirmacion + "\n- Observación: " + val2.observacion_confirmacion + "\n- Tipo de Ensayo: " + ((val2.tipo_ensayo == 2) ? 'Lote (Duplicado)' : (val2.tipo_ensayo == 3) ? 'Dirimencia (Triplicado)' : 'Reconocimiento (Simple)'));

                                                            // update_aprobacion
                                                            // update_rechazo
                                                            // update_idgestion
                                                            // update_idreanalisis

                                                            f_LoadResultados();
                                                            f_cerrarModal(1);
                                                        }
                                                        else{
                                                            if (!confirm('El usuario "' + val2.usuario_confirmacion + '"' + " confirmó previamente un reanálisis para esta muestra, como aun no se encuentra en proceso puede modificar la gestión\n\n¿Desea continuar?")){

                                                                f_cerrarModal(1);

                                                                return;
                                                            }
                                                            else{
                                                                // Habilita el combo de Tipo de Ensayo para los tipos 2, 3 y 4
                                                                    $("#id_modulo").val(val.Id_Solicitud);
                                                                    $("#id_registro").val(val.Id_Registro);
                                                                    $("#is_newmontpositivo").val(val.is_Newmont_Positivo);

                                                                    $("#update_aprobacion").val((_Confirmacion == 1) ? 1 : 0);
                                                                    $("#update_rechazo").val((_Confirmacion == 2) ? 1 : 0);
                                                                    $("#update_idgestion").val(val2.ID_GS);
                                                                    $("#update_idreanalisis").val(val2.ID_GSR);
// MAX - ME QUEDÉ AQUÍ: FALTA LA FUNCIÓN DE GRABAR PARA ACTUALIZAR LOS DATOS DE LOS REANÁLISIS PARA AQUELLAS MUESTRAS CON GESTIONES PREVIAS.
//     1. Si se tienen dos muestras pendientes de gestión al actualizar cualquier de ellas actualiza automáticamente la otra.
//     2. Pero, si ya hay una gestión previa se debe aplicar la validación de si la muestra ya se encuentra o no en un rack.
//     - Si se determina que la muestra no se encuentra en un nuevo rack, se debe avisar con un mensaje que se podrían modificar los datos de reanálisis.
//     - Si se determina que la muestra ya se encuentra en un nuevo rack, se debe avisar al usuario con un mensaje que la muestra ya fue enviada a reanálisis y cambiará automáticamente el estado de la muestra en gestión.
//     - Si se rechaza la gestión más reciente, este rechazo debe cambiar también el estado de la gestión previa a: "Atendido en Gestión Posterior".
//     - Si se rechaza la gestión más antigua, este rechazo no afecta a la gestión más actual.
//     3. Para las muestras afectadas por Desviación de Blanco, en este caso se aplica algo similar a los puntos anteriore:
//     - Validar si hubo una gestión previa.
//     - Si no hubo una gestión previa, entonces se habilita el combo de reanálisis.
//     - Si hubo una gestión previa y la muestra aún no ha sido incluída en un nuevo Rack, se debe mostrar el combo de reanálisis.
//     - Si hubo una gestión previa y la muestra ya se encuentra incluída en un nuevo rack, se deberá verificar el blanco fundente con el que fue registrada.
//     - Si el blanco fundente es nuevo blanco entonces no se debe mostrar en la lista de muestras afectadas.
//     - Pero, si el blanco es el mismo blanco afectado entonces debería mostrar el combo de reanálisis y cambiar a reanálisis el estado de la muestra nueva (en nuevo rack) y solicitar un nuevo reanálisis. por lo tanto esta muestra debería existir en 3 racks diferentes.
//     - El estado de Aprobado o Rechazado deberá afectar a las muestras anteriores cambiandoles el estado a: "Atendido en Gestión Posterior".
                                                                    if (_Confirmacion == 1 && (val.Id_Solicitud == 2 || val.Id_Solicitud == 3 || val.Id_Solicitud == 5 || val.Id_Solicitud == 8)){
                                                                        f_CerrarDiv('A', 'div_tipoanalisis');

                                                                        // Si es Peso de Régulo y si es Newmont positivo cambiar el combo de Renálisis
                                                                            var _html = '<option selected="true" value="">Elija una opción...</option>';

                                                                            if (val.Id_Solicitud == 2 && val.is_Newmont_Positivo == 1){
                                                                                _html += '<option value="4">Desactivar grupo y crear nuevo</option>';
                                                                            }
                                                                            else{
                                                                                _html += '<option value="2">Lote (Duplicado)</option>';
                                                                                _html += '<option value="3">Dirimencia (Triplicado)</option>';
                                                                                _html += '<option value="1">Reconocimiento (Simple)</option>';
                                                                            }

                                                                            $("#lista_tipoanalisis").html(_html);
                                                                    }

                                                                    // Presentando datos de muestras para los Tipos 3 y 4
                                                                        if (val.Id_Solicitud == 3 || val.Id_Solicitud == 4 || val.Id_Solicitud == 5 || val.Id_Solicitud == 6 || val.Id_Solicitud == 7 || val.Id_Solicitud == 8 || val.Id_Solicitud == 9 || val.Id_Solicitud == 10){
                                                                            var d = 1;
                                                                            var _html_datosprincipales = '';
                                                                            var _html_datosmuestras = '';

                                                                            $.post( "ajax/encuesta.php", { accion: "get_GestionSolicitud_DatosTipo3", Id: _Id }, 
                                                                                function( data ) {
                                                                                    if(data.estado == 1){
                                                                                        $.each( data.registros, function( key, _val ) {
                                                                                            // Datos Principales
                                                                                                if (d == 1){
                                                                                                    _html_datosprincipales += ' <tr>';
                                                                                                    _html_datosprincipales += '     <td style="background-color: #12537E; color: #ffffff">';
                                                                                                    _html_datosprincipales += '         Rack';
                                                                                                    _html_datosprincipales += '     </td>';
                                                                                                    _html_datosprincipales += '     <td>';
                                                                                                    _html_datosprincipales += '         ' + _val.nom_rack;
                                                                                                    _html_datosprincipales += '     </td>';
                                                                                                    _html_datosprincipales += ' </tr>';

                                                                                                    _html_datosprincipales += ' <tr>';
                                                                                                    _html_datosprincipales += '     <td style="background-color: #12537E; color: #ffffff">';
                                                                                                    _html_datosprincipales += '         Muestra';
                                                                                                    _html_datosprincipales += '     </td>';
                                                                                                    _html_datosprincipales += '     <td>';
                                                                                                    _html_datosprincipales += '         ' + ((val.Id_Solicitud == 3 || val.Id_Solicitud == 5 || val.Id_Solicitud == 8) ? _val.Nom_Muestra : 'Nuevo Blanco Fundente');
                                                                                                    _html_datosprincipales += '     </td>';
                                                                                                    _html_datosprincipales += ' </tr>';

                                                                                                    if (val.Id_Solicitud != 7 && val.Id_Solicitud != 10){
                                                                                                        _html_datosprincipales += ' <tr>';
                                                                                                        _html_datosprincipales += '     <td style="background-color: #FF2F1E; color: #ffffff">';
                                                                                                        _html_datosprincipales += '         Desviación';
                                                                                                        _html_datosprincipales += '     </td>';
                                                                                                        _html_datosprincipales += '     <td style="text-align: center;">';
                                                                                                        _html_datosprincipales += '         <b>' + factor_plata + '</b>';
                                                                                                        _html_datosprincipales += '     </td>';
                                                                                                        _html_datosprincipales += ' </tr>';
                                                                                                    }
                                                                                                }

                                                                                            // Datos de Muestras
                                                                                                _html_datosmuestras += ' <tr>';
                                                                                                _html_datosmuestras += '     <td style="text-align: center;">';
                                                                                                _html_datosmuestras += '         ' + _val.Num_Crisol;
                                                                                                _html_datosmuestras += '     </td>';
                                                                                                _html_datosmuestras += '     <td style="text-align: center;">';
                                                                                                _html_datosmuestras += '         ' + _val.NumCrisol_Dore;
                                                                                                _html_datosmuestras += '     </td>';
                                                                                                _html_datosmuestras += '     <td>';
                                                                                                _html_datosmuestras += '         ' + _val.nom_tipoblanco;
                                                                                                _html_datosmuestras += '     </td>';
                                                                                                _html_datosmuestras += '     <td>';
                                                                                                _html_datosmuestras += '         ' + _val.Dosificacion;
                                                                                                _html_datosmuestras += '     </td>';
                                                                                                _html_datosmuestras += '     <td>';
                                                                                                _html_datosmuestras += '         ' + _val.Peso_Muestra;
                                                                                                _html_datosmuestras += '     </td>';
                                                                                                _html_datosmuestras += '     <td>';
                                                                                                _html_datosmuestras += '         ' + _val.Peso_Regulo;
                                                                                                _html_datosmuestras += '     </td>';
                                                                                                _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                                _html_datosmuestras += '         ' + _val.Peso_Dore;
                                                                                                _html_datosmuestras += '     </td>';

                                                                                                if (val.Id_Solicitud < 5 || val.Id_Solicitud == 7){
                                                                                                    _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                                    _html_datosmuestras += '         ' + _val.Ley_Ag;
                                                                                                    _html_datosmuestras += '     </td>';
                                                                                                    _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                                    _html_datosmuestras += '         ' + _val.Ley_Ag_oz;
                                                                                                    _html_datosmuestras += '     </td>';
                                                                                                    _html_datosmuestras += ' </tr>';
                                                                                                }

                                                                                                if ((val.Id_Solicitud >= 5 && val.Id_Solicitud <= 6) || (val.Id_Solicitud >= 8 && val.Id_Solicitud <= 10)){
                                                                                                    _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                                    _html_datosmuestras += '         ' + _val.Peso_Au;
                                                                                                    _html_datosmuestras += '     </td>';
                                                                                                     _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                                    _html_datosmuestras += '         ' + _val.Ley_Ag_New;
                                                                                                    _html_datosmuestras += '     </td>';
                                                                                                    _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                                    _html_datosmuestras += '         ' + _val.Ley_Au;
                                                                                                    _html_datosmuestras += '     </td>';
                                                                                                    _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                                    _html_datosmuestras += '         ' + _val.Ley_Ag_oz_New;
                                                                                                    _html_datosmuestras += '     </td>';
                                                                                                    _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                                    _html_datosmuestras += '         ' + _val.Ley_Au_oz;
                                                                                                    _html_datosmuestras += '     </td>';
                                                                                                }

                                                                                            d += 1;
                                                                                        });
                                                                                    }
                                                                                    else{
                                                                                        alert("Ocurrió un error al momento de mostrar el detalle de solicitud.");
                                                                                    }

                                                                                    // Cargando tablas
                                                                                        $("#tabla_tipo3_datosprincipales").html(_html_datosprincipales);
                                                                                        $("#tabla_tipo3_detalle").html(_html_datosmuestras);

                                                                                    // Mostrando el detalle
                                                                                        f_CerrarDiv('A', 'div_tipo3');

                                                                                    // Cerrando Modal
                                                                                        $('#divmodal_Loading').modal('hide');

                                                                                }, "json");

                                                                            // Muestras el total de muestras seleccionadas solo para la Aprobación
                                                                                if (_Confirmacion == 1 && (val.Id_Solicitud == 4 || val.Id_Solicitud == 6 || val.Id_Solicitud == 7 || val.Id_Solicitud == 9 || val.Id_Solicitud == 10)){
                                                                                    f_CerrarDiv('A', 'div_muestrasseleccionadas');
                                                                                }
                                                                                else{
                                                                                    f_CerrarDiv('C', 'div_muestrasseleccionadas');
                                                                                }
                                                                        }
                                                                        else{
                                                                            f_CerrarDiv('C', 'div_tipo3');

                                                                            // Cerrando Modal
                                                                                $('#divmodal_Loading').modal('hide');
                                                                        }

                                                                    // Visualizar lista de muestras observadas por Blanco Fundente
                                                                        if (val.Id_Solicitud == 4 || val.Id_Solicitud == 6 || val.Id_Solicitud == 7 || val.Id_Solicitud == 9 || val.Id_Solicitud == 10){
                                                                            f_CerrarDiv('A', 'div_muestrasobservadas');
                                                                        }
                                                                        else{
                                                                            f_CerrarDiv('C', 'div_muestrasobservadas');
                                                                        }
                                                            }
                                                        }
                                                    });
                                                }
                                                else{
                                                    // Habilita el combo de Tipo de Ensayo para los tipos 2, 3 y 4
                                                        $("#id_modulo").val(val.Id_Solicitud);
                                                        $("#id_registro").val(val.Id_Registro);
                                                        $("#is_newmontpositivo").val(val.is_Newmont_Positivo);

                                                        if (_Confirmacion == 1 && (val.Id_Solicitud == 2 || val.Id_Solicitud == 3 || val.Id_Solicitud == 5 || val.Id_Solicitud == 8)){
                                                            f_CerrarDiv('A', 'div_tipoanalisis');

                                                            // Si es Peso de Régulo y si es Newmont positivo cambiar el combo de Renálisis
                                                                var _html = '<option selected="true" value="">Elija una opción...</option>';

                                                                if (val.Id_Solicitud == 2 && val.is_Newmont_Positivo == 1){
                                                                    _html += '<option value="4">Desactivar grupo y crear nuevo</option>';
                                                                }
                                                                else{
                                                                    _html += '<option value="2">Lote (Duplicado)</option>';
                                                                    _html += '<option value="3">Dirimencia (Triplicado)</option>';
                                                                    _html += '<option value="1">Reconocimiento (Simple)</option>';
                                                                }

                                                                $("#lista_tipoanalisis").html(_html);
                                                        }

                                                        // Presentando datos de muestras para los Tipos 3 y 4
                                                            if (val.Id_Solicitud == 3 || val.Id_Solicitud == 4 || val.Id_Solicitud == 5 || val.Id_Solicitud == 6 || val.Id_Solicitud == 7 || val.Id_Solicitud == 8 || val.Id_Solicitud == 9 || val.Id_Solicitud == 10){
                                                                var d = 1;
                                                                var _html_datosprincipales = '';
                                                                var _html_datosmuestras = '';

                                                                $.post( "ajax/encuesta.php", { accion: "get_GestionSolicitud_DatosTipo3", Id: _Id }, 
                                                                    function( data ) {
                                                                        if(data.estado == 1){
                                                                            $.each( data.registros, function( key, _val ) {
                                                                                // Datos Principales
                                                                                    if (d == 1){
                                                                                        _html_datosprincipales += ' <tr>';
                                                                                        _html_datosprincipales += '     <td style="background-color: #12537E; color: #ffffff">';
                                                                                        _html_datosprincipales += '         Rack';
                                                                                        _html_datosprincipales += '     </td>';
                                                                                        _html_datosprincipales += '     <td>';
                                                                                        _html_datosprincipales += '         ' + _val.nom_rack;
                                                                                        _html_datosprincipales += '     </td>';
                                                                                        _html_datosprincipales += ' </tr>';

                                                                                        _html_datosprincipales += ' <tr>';
                                                                                        _html_datosprincipales += '     <td style="background-color: #12537E; color: #ffffff">';
                                                                                        _html_datosprincipales += '         Muestra';
                                                                                        _html_datosprincipales += '     </td>';
                                                                                        _html_datosprincipales += '     <td>';
                                                                                        _html_datosprincipales += '         ' + ((val.Id_Solicitud == 3 || val.Id_Solicitud == 5 || val.Id_Solicitud == 8) ? _val.Nom_Muestra : 'Nuevo Blanco Fundente');
                                                                                        _html_datosprincipales += '     </td>';
                                                                                        _html_datosprincipales += ' </tr>';

                                                                                        if (val.Id_Solicitud != 7 && val.Id_Solicitud != 10){
                                                                                            _html_datosprincipales += ' <tr>';
                                                                                            _html_datosprincipales += '     <td style="background-color: #FF2F1E; color: #ffffff">';
                                                                                            _html_datosprincipales += '         Desviación';
                                                                                            _html_datosprincipales += '     </td>';
                                                                                            _html_datosprincipales += '     <td style="text-align: center;">';
                                                                                            _html_datosprincipales += '         <b>' + factor_plata + '</b>';
                                                                                            _html_datosprincipales += '     </td>';
                                                                                            _html_datosprincipales += ' </tr>';
                                                                                        }

                                                                                    }

                                                                                // Datos de Muestras
                                                                                    _html_datosmuestras += ' <tr>';
                                                                                    _html_datosmuestras += '     <td style="text-align: center;">';
                                                                                    _html_datosmuestras += '         ' + _val.Num_Crisol;
                                                                                    _html_datosmuestras += '     </td>';
                                                                                    _html_datosmuestras += '     <td style="text-align: center;">';
                                                                                    _html_datosmuestras += '         ' + _val.NumCrisol_Dore;
                                                                                    _html_datosmuestras += '     </td>';
                                                                                    _html_datosmuestras += '     <td>';
                                                                                    _html_datosmuestras += '         ' + _val.nom_tipoblanco;
                                                                                    _html_datosmuestras += '     </td>';
                                                                                    _html_datosmuestras += '     <td>';
                                                                                    _html_datosmuestras += '         ' + _val.Dosificacion;
                                                                                    _html_datosmuestras += '     </td>';
                                                                                    _html_datosmuestras += '     <td>';
                                                                                    _html_datosmuestras += '         ' + _val.Peso_Muestra;
                                                                                    _html_datosmuestras += '     </td>';
                                                                                    _html_datosmuestras += '     <td>';
                                                                                    _html_datosmuestras += '         ' + _val.Peso_Regulo;
                                                                                    _html_datosmuestras += '     </td>';
                                                                                    _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                    _html_datosmuestras += '         ' + _val.Peso_Dore;
                                                                                    _html_datosmuestras += '     </td>';

                                                                                    // _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                    // _html_datosmuestras += '         ' + _val.Ley_Ag;
                                                                                    // _html_datosmuestras += '     </td>';
                                                                                    // _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                    // _html_datosmuestras += '         ' + _val.Ley_Ag_oz;
                                                                                    // _html_datosmuestras += '     </td>';
                                                                                    // _html_datosmuestras += ' </tr>';

                                                                                     if (val.Id_Solicitud < 5 || val.Id_Solicitud == 7){
                                                                                        _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                        _html_datosmuestras += '         ' + _val.Ley_Ag;
                                                                                        _html_datosmuestras += '     </td>';
                                                                                        _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                        _html_datosmuestras += '         ' + _val.Ley_Ag_oz;
                                                                                        _html_datosmuestras += '     </td>';
                                                                                        _html_datosmuestras += ' </tr>';
                                                                                    }

                                                                                    if ((val.Id_Solicitud >= 5 && val.Id_Solicitud <= 6) || (val.Id_Solicitud >= 8 && val.Id_Solicitud <= 10)){
                                                                                        _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                        _html_datosmuestras += '         ' + _val.Peso_Au;
                                                                                        _html_datosmuestras += '     </td>';
                                                                                         _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                        _html_datosmuestras += '         ' + _val.Ley_Ag_New;
                                                                                        _html_datosmuestras += '     </td>';
                                                                                        _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                        _html_datosmuestras += '         ' + _val.Ley_Au;
                                                                                        _html_datosmuestras += '     </td>';
                                                                                        _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                        _html_datosmuestras += '         ' + _val.Ley_Ag_oz_New;
                                                                                        _html_datosmuestras += '     </td>';
                                                                                        _html_datosmuestras += '     <td style="text-align: right;">';
                                                                                        _html_datosmuestras += '         ' + _val.Ley_Au_oz;
                                                                                        _html_datosmuestras += '     </td>';
                                                                                    }

                                                                                d += 1;
                                                                            });
                                                                        }
                                                                        else{
                                                                            alert("Ocurrió un error al momento de mostrar el detalle de solicitud.");
                                                                        }

                                                                        // Cargando tablas
                                                                            $("#tabla_tipo3_datosprincipales").html(_html_datosprincipales);
                                                                            $("#tabla_tipo3_detalle").html(_html_datosmuestras);

                                                                        // Mostrando el detalle
                                                                            f_CerrarDiv('A', 'div_tipo3');

                                                                        // Cerrando Modal
                                                                            $('#divmodal_Loading').modal('hide');

                                                                    }, "json");

                                                                // Muestras el total de muestras seleccionadas solo para la Aprobación
                                                                    if (_Confirmacion == 1 && (val.Id_Solicitud == 4 || val.Id_Solicitud == 6 || val.Id_Solicitud == 7 || val.Id_Solicitud == 9 || val.Id_Solicitud == 10)){
                                                                        f_CerrarDiv('A', 'div_muestrasseleccionadas');
                                                                    }
                                                                    else{
                                                                        f_CerrarDiv('C', 'div_muestrasseleccionadas');
                                                                    }
                                                            }
                                                            else{
                                                                f_CerrarDiv('C', 'div_tipo3');

                                                                // Cerrando Modal
                                                                    $('#divmodal_Loading').modal('hide');
                                                            }

                                                        // Visualizar lista de muestras observadas por Blanco Fundente
                                                            if (val.Id_Solicitud == 4 || val.Id_Solicitud == 6 || val.Id_Solicitud == 7 || val.Id_Solicitud == 9 || val.Id_Solicitud == 10){
                                                                f_CerrarDiv('A', 'div_muestrasobservadas');
                                                            }
                                                            else{
                                                                f_CerrarDiv('C', 'div_muestrasobservadas');
                                                            }
                                                }
                                            }, "json");
                                });
                            }
                            else{
                                alert("Ocurrió un error al momento de mostrar el detalle de solicitud.");
                            }

                            // Cerrando Modal
                                $('#divmodal_Loading').modal('hide');

                            // Mostrando la pantalla
                                modal.modal({backdrop: 'static', keyboard: false});

                        }, "json");
            };

            function f_ConfirmarSolicitud(){
                var _id_confirmacion = $("#id_confirmar").val();
                var _id_solicitud = $("#id_solicitud").val();
                var _id_modulo = $("#id_modulo").val();
                var _id_registro = $("#id_registro").val();
                var _is_newmontpositivo = $("#is_newmontpositivo").val();
                var _num_muestrasreanalisis = $("#num_muestrasreanalisis").html();

                // Obteniendo parámetros de actualización
                    var _update_aprobacion = $("#update_aprobacion").val();
                    var _update_rechazo = $("#update_rechazo").val();
                    var _update_idgestion = $("#update_idgestion").val();
                    var _update_idreanalisis = $("#update_idreanalisis").val();

                // Validando datos
                    var _tipo_ensayo = $("#lista_tipoanalisis").val();

                    if (_id_confirmacion == 1 && (_id_modulo == 2 || _id_modulo == 3 || _id_modulo == 5 || _id_modulo == 8)){
                        if (_tipo_ensayo == null){
                            alert("Debe ingresar el Tipo de Ensayo");

                            return;
                        }
                        if (_tipo_ensayo.length == 0){
                            alert("Debe ingresar el Tipo de Ensayo");

                            return;
                        }
                    }

                    var _observacion = $("#txt_newobservacion").val();

                    if (_observacion == null){
                        alert("Debe ingresar una observación");

                        return;
                    }
                    if (_observacion.length == 0){
                        alert("Debe ingresar una observación");

                        return;
                    }

                    if (_id_modulo == 4 || _id_modulo == 6 || _id_modulo == 7 || _id_modulo == 9 || _id_modulo == 10){
                        if (_num_muestrasreanalisis.trim() == "0"){
                            alert("No ha seleccionado ninguna muestra para reanálisis");

                            return;
                        }

                        if (!confirm('Esta a punto de enviar a reanálisis ' + _num_muestrasreanalisis.trim() + ' muestras\n\n¿Está seguro de continuar?')){

                            return;
                        }
                    }

                // Loading Modal
                    var modal_loading = $("#divmodal_Loading");
                    modal_loading.modal({backdrop: 'static', keyboard: false});

                // Grabar Confirmación
                // MAX - 13/04/2021: Se aprovechará el mismo método: "Confirmar_Solicitud_MuestrasObservadas_DesviacionBlanco" para grabar los reanálisis para cuando sean muestras con Conf.Ag desviado por Blanco Fundente.
                    if (_id_modulo == 4 || _id_modulo == 6 || _id_modulo == 7 || _id_modulo == 9 || _id_modulo == 10){
                        var r = 0;
                        var x = 0;
                        var select_val = '';

                        while (r < select_reanalisis - 1){
                            select_val = arr_select[r];

                            // Loading Modal
                                var modal_loading = $("#divmodal_Loading");
                                modal_loading.modal({backdrop: 'static', keyboard: false});

                            if (select_val != undefined){
                                $.post( "ajax/encuesta.php", { accion: "Confirmar_Solicitud_MuestrasObservadas_DesviacionBlanco", ind: x, id_solicitud: _id_solicitud, observacion: _observacion, datos: select_val, id_modulo: _id_modulo },
                                    function( data ) {
                                        if(data.estado == 1){
                                            
                                        }
                                        else{
                                            alert("Ocurrió un error al momento de grabar los datos: " + select_val);

                                            return;
                                        }

                                        // Cerrando Modal
                                            $('#divmodal_Loading').modal('hide');
                                    }, "json");

                                x += 1;
                            }
//                             // 1. Usar el método: "Confirmar_Solicitud"
//                                 a. Grabar los datos en: Gestion_Solicitudes (línea 4642)
//                                 b. Actualizar: $q_reanalisis = "UPDATE Detalle_Rack_Pesos
//                                               SET isReanalisis_Dore = 1
//                                             WHERE Id_Detalle_Rack = ".$row_id["Id"];" (línea 4660)
//                                 c. Actualizar las solicitudes de la misma muestra pero sin gestión (línea 4697)

//                             // 2. Usar el método: "get_GestionPrevia"
//                                 a. Buscar si la muestra está en un nuevo rack.
//                                 b. Actualizar y enviar a reanálisis esa muestra en la tabla Detalle_Rack_Pesos (similar al punto 1.b)
//                                 c. Volver a enviar la muestra a reanálisis (Hacer un nuevo INSERT en la tabla
//                                    Gestion_Solicitudes_Reanalisis)

//                             // 3. Regresar al método: "Confirmar_Solicitud"
//                                 a. Continuar con la línea 4744 en adelante
//                             --- POR FIN LO ACABÉ --- ;)

                            r += 1;
                        }
                        
                        // Refrescar la pantalla
                            f_cerrarModal(1);
                            f_LoadResultados();
                    }
                    else{
                        $.post( "ajax/encuesta.php", { accion: "Confirmar_Solicitud", id_confirmacion: _id_confirmacion, id_modulo: _id_modulo, id_solicitud: _id_solicitud, observacion: _observacion, tipo_ensayo: _tipo_ensayo, id_registro: _id_registro, is_newmontpositivo: _is_newmontpositivo, update_aprobacion: _update_aprobacion, update_rechazo: _update_rechazo, update_idgestion: _update_idgestion, update_idreanalisis: _update_idreanalisis },
                            function( data ) {
                                if(data.estado == 1){
                                    f_cerrarModal(1);
                                    f_LoadResultados();
                                }
                                else{
                                    alert("Ocurrió un error al momento de grabar los datos");
                                }

                                // Cerrando Modal
                                    $('#divmodal_Loading').modal('hide');

                            }, "json");
                    }
            };

            function f_OpenMuestrasObservadas(_Show){
                var id_registro = $("#id_registro").val();
                var id_confirmar = $("#id_confirmar").val();
                var id_solicitud = $("#id_solicitud").val();
                var id_modulo = $("#id_modulo").val();

                var htmlContenido = '';
                const arr_grupos = [];

                // Usados para verificar la existencia de una muestra previa
                    var muestras_x = '';
                    var exists = '';

                var modal = $("#divmodal_MuestrasObservadas");

                $("#tabla_detallemuestrasobservadas").html(htmlContenido);

                // Mostrando / Ocultando columna de reanálisis
                    if (id_confirmar == 1){
                        f_CerrarDiv('A', 'th_reanalisis');
                    }
                    else{
                        f_CerrarDiv('C', 'th_reanalisis');
                    }

                    if (id_modulo == 4 || id_modulo == 6 || id_modulo == 7 || id_modulo == 9 || id_modulo == 10){
                        f_CerrarDiv('A', 'th_confag');
                    }
                    else{
                        f_CerrarDiv('C', 'th_confag');
                    }

                    if (id_modulo == 6 || id_modulo == 9 || id_modulo == 10){
                        f_CerrarDiv('A', 'th_confau');
                    }
                    else{
                        f_CerrarDiv('C', 'th_confau');
                    }

                // Obtiene agrupaciones para obtener el total de registros por Rack
                    $.post( "ajax/encuesta.php", { accion: "get_GestionSolicitud_DetalleMuestrasObservadas_Registros", id_registro: id_registro, id_modulo: id_modulo }, 
                        function( data ) {
                            if(data.estado == 1){
                                $.each( data.registros, function( key, val ) {
                                    arr_grupos.push(val._COUNT);
                                });
                            }
                            else{
                                alert("Ocurrió un error al momento de obtener las agrupaciones de cada Rack.");
                            }

                            // Inserta los detalles
                                var m = 1;
                                select_reanalisis = 1;
                                total_select = 0;
                                total_select_habilitados = 0;

                                var i = 1; // Para contar en cada ciclo del Array
                                var a = 0; // Para acceder a los datos del Array
                                var id_detallerack = 0;
                                var id_detallerack_x = 0;

                                // Guarda el total de conteos
                                    c = arr_grupos[a];

                                $.post( "ajax/encuesta.php", { accion: "get_GestionSolicitud_DetalleMuestrasObservadas", id_registro: id_registro, id_solicitud: id_solicitud, id_modulo: id_modulo }, 
                                    function( data ) {
                                        if(data.estado == 1){
                                            $.each( data.registros, function( key, val ) {
                                                htmlContenido += '<tr>';

                                                // Valida agrupación
                                                    if (i > arr_grupos[a]){
                                                        i = 1;
                                                        a += 1;
                                                    }

                                                // Pintar las filas si hay observaciones
                                                    if (val.isObservado_ReguloObservacion.length > 0 || val.isObservado_DoreObservacion.length > 0){
                                                        var color = '; color: #FF2F1E';
                                                    }
                                                    else{
                                                        var color = '';
                                                    }

                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right;">' + m + '</td>';

                                                if (i == 1){
                                                    htmlContenido += '  <td rowspan="' + arr_grupos[a] + '" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #8C8C8C">';
                                                    htmlContenido += '      <b style="color: #F2D544">' + val.nom_rack + '</b>';
                                                    htmlContenido += '      <p style="color: #BBBDF2">Creado: <b>' + val.fecha_rack.substr(0, 16) + '</b></p>';
                                                    htmlContenido += '      <p style="color: #ffffff"><b>' + val.ESTADO_PROCESO + '</b></p>';
                                                    htmlContenido += '  </td>';

                                                    // htmlContenido += '  <td rowspan="' + arr_grupos[a] + '" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;">' + val.ESTADO_PROCESO  + '</td>';
                                                }

                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right' + color + '">' + val.Num_Crisol  + '</td>';

                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;' + color + '">' + val.TIPO  + '</td>';

                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right' + color + '">' + val.CRISOL  + '</td>';

                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;' + color + '">' + val.nom_muestra  + '</td>';

                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;' + color + '">' + val.nom_tipoblanco  + '</td>';

                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;' + color + '">' + val.Dosificacion  + '</td>';

                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right' + ((val.Peso_Muestra == 0 || val.Peso_Muestra.length == 0) ? '; background-color: #FF2F1E; color: #ffffff;' : '') + color + '">' + val.Peso_Muestra  + '</td>';

                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right' + ((val.Peso_Regulo == 0 || val.Peso_Regulo.length == 0) ? '; background-color: #FF2F1E' : '') + color + '">' + val.Peso_Regulo  + '</td>';

                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right' + ((val.Peso_Dore == 0 || val.Peso_Dore.length == 0) ? '; background-color: #FF2F1E' : '') + color + '">' + val.Peso_Dore  + '</td>';

                                                if (id_modulo == 6 || id_modulo == 9 || id_modulo == 10){
                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right' + ((val.Peso_Au == 0 || val.Peso_Au.length == 0) ? '; background-color: #FF2F1E' : '') + color + '">' + val.Peso_Au  + '</td>';
                                                }

                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;' + color + '">' + val.isObservado_ReguloObservacion  + '</td>';

                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;' + color + '">' + val.isObservado_DoreObservacion  + '</td>';

                                                if (id_confirmar == 1){
                                                    if (id_detallerack != val.ID_DETALLERACK){
                                                        id_select = arr_select[total_select];

                                                        // Conf.Au
                                                            // Deterimna el Color
                                                                var color_ConfAu = '';

                                                                if (val.Conf_Au <= 0.5){
                                                                    color_ConfAu = '#00C756';
                                                                }
                                                                if (val.Conf_Au > 0.5 && val.Conf_Au < 1){
                                                                    color_ConfAu = '#FEB71B';
                                                                }
                                                                if (val.Conf_Au >= 1){
                                                                    color_ConfAu = '#FF2F1E';
                                                                }

                                                            if (id_modulo == 6 || id_modulo == 9 || id_modulo == 10){
                                                                htmlContenido += '  <td rowspan="' + val.NUM_MUESTRAS + '"' + ' style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: ' + color_ConfAu + '; color: #ffffff; text-align: center;">' + val.Conf_Au + '</td>';
                                                            }

                                                        // Conf.Ag
                                                            if (id_modulo == 4 || id_modulo == 7){
                                                                // Deterimna el Color
                                                                    var color_ConfAg = '';

                                                                    if (val.Conf_Ag_Dore <= 0.5){
                                                                        color_ConfAg = '#00C756';
                                                                    }
                                                                    if (val.Conf_Ag_Dore > 0.5 && val.Conf_Ag_Dore < 1){
                                                                        color_ConfAg = '#FEB71B';
                                                                    }
                                                                    if (val.Conf_Ag_Dore >= 1){
                                                                        color_ConfAg = '#FF2F1E';
                                                                    }

                                                                htmlContenido += '  <td rowspan="' + val.NUM_MUESTRAS + '"' + ' style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: ' + color_ConfAg + '; color: #ffffff; text-align: center;">' + val.Conf_Ag_Dore + '</td>';
                                                            }
                                                            if (id_modulo == 6 || id_modulo == 9 || id_modulo == 10){
                                                                // Deterimna el Color
                                                                    var color_ConfAg = '';

                                                                    if (val.Conf_Ag <= 0.5){
                                                                        color_ConfAg = '#00C756';
                                                                    }
                                                                    if (val.Conf_Ag > 0.5 && val.Conf_Ag < 1){
                                                                        color_ConfAg = '#FEB71B';
                                                                    }
                                                                    if (val.Conf_Ag >= 1){
                                                                        color_ConfAg = '#FF2F1E';
                                                                    }

                                                                htmlContenido += '  <td rowspan="' + val.NUM_MUESTRAS + '"' + ' style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: ' + color_ConfAg + '; color: #ffffff; text-align: center;">' + val.Conf_Ag + '</td>';
                                                            }

                                                        // Reanálisis
                                                            // Obteniendo el color para los rechazados
                                                                var color_x = '#77C1CC';

                                                                if (id_select != undefined){
                                                                    id_select_x = id_select.substr(id_select.indexOf('|') + 1);

                                                                    if (id_select_x.substr(0, 1) == 0){
                                                                        color_x = '#DA7780';
                                                                    }
                                                                }

                                                            htmlContenido += '  <td id="row_' + select_reanalisis + '" ' + 'rowspan="' + val.NUM_MUESTRAS + '"' + ' style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: ';

                                                            // Verifica que la muestra no haya sido agregada previamente
                                                                exists = muestras_x.indexOf(val.nom_muestra);

                                                            if (val.IS_HABILITAR == 1 && exists < 0){
                                                                muestras_x += val.nom_muestra + '|';

                                                                htmlContenido += color_x + ';">';
                                                                htmlContenido += '     <select id="reanalisis_' + select_reanalisis + '" class="form-control" onblur="f_RowColor(' + select_reanalisis + ')">';
                                                                htmlContenido += '         <option value="99">Elija una opción...</option>';
                                                                htmlContenido += '         <option ' + ((id_select == val.ID_DETALLERACK + '|0|' + val.nom_muestra + '|' + val.is_Newmont_Positivo) ? 'selected' : '') + ' value="' + val.ID_DETALLERACK + '|0|' + val.nom_muestra + '|' + val.is_Newmont_Positivo + '">Reanálisis Rechazado</option>';

                                                                if (val.is_Newmont_Positivo == 0){
                                                                    htmlContenido += '         <option ' + ((id_select == val.ID_DETALLERACK + '|2|' + val.nom_muestra + '|' + val.is_Newmont_Positivo) ? 'selected' : '') + ' value="' + val.ID_DETALLERACK + '|2|' + val.nom_muestra + '|' + val.is_Newmont_Positivo + '">Lote (Duplicado)</option>';
                                                                    htmlContenido += '         <option ' + ((id_select == val.ID_DETALLERACK + '|3|' + val.nom_muestra + '|' + val.is_Newmont_Positivo) ? 'selected' : '') + ' value="' + val.ID_DETALLERACK + '|3|' + val.nom_muestra + '|' + val.is_Newmont_Positivo + '">Dirimencia (Triplicado)</option>';
                                                                    htmlContenido += '         <option ' + ((id_select == val.ID_DETALLERACK + '|1|' + val.nom_muestra + '|' + val.is_Newmont_Positivo) ? 'selected' : ((id_select == undefined) ? 'selected' : '')) + ' value="' + val.ID_DETALLERACK + '|1|' + val.nom_muestra + '|' + val.is_Newmont_Positivo + '">Reconocimiento (Simple)</option>';
                                                                }
                                                                else{
                                                                    htmlContenido += '         <option ' + ((id_select == val.ID_DETALLERACK + '|4|' + val.nom_muestra + '|' + val.is_Newmont_Positivo) ? 'selected' : ((id_select == undefined) ? 'selected' : '')) + ' value="' + val.ID_DETALLERACK + '|4|' + val.nom_muestra + '|' + val.is_Newmont_Positivo + '">Desactivar grupo y crear nuevo</option>';
                                                                }

                                                                htmlContenido += '     </select>';

                                                                total_select_habilitados += 1;
                                                            }
                                                            else{
                                                                htmlContenido += ' #8C8C8C; text-align: center; color: #ffffff;">';
                                                                htmlContenido += '  <label>';
                                                                htmlContenido += '      ' + ((
                                                                    val.isNot_DoreDesactivadoEnRack_PorPositivoNewmont == 1 || 
                                                                    val.isNot_ReguloDesactivadoEnRack_PorPositivoNewmont == 1) ? 'GRUPO NEWMONT DESACTIVADO' : ((exists >= 0) ? 'SERÁ ATENDIDO EN UNA GESTIÓN POSTERIOR' : 'ATENDIDO EN GESTIÓN PREVIA'));
                                                                htmlContenido += '  </label>';
                                                            }
                                                        
                                                        htmlContenido += ' </td>';

                                                        id_detallerack = val.ID_DETALLERACK
                                                        select_reanalisis += 1;
                                                        total_select += 1;
                                                    }
                                                }
                                                else{
                                                    if (id_detallerack_x != val.ID_DETALLERACK){
                                                        // Conf.Au
                                                            // Deterimna el Color
                                                                var color_ConfAu = '';

                                                                if (val.Conf_Au <= 0.5){
                                                                    color_ConfAu = '#00C756';
                                                                }
                                                                if (val.Conf_Au > 0.5 && val.Conf_Au < 1){
                                                                    color_ConfAu = '#FEB71B';
                                                                }
                                                                if (val.Conf_Au >= 1){
                                                                    color_ConfAu = '#FF2F1E';
                                                                }

                                                            if (id_modulo == 6 || id_modulo == 9 || id_modulo == 10){
                                                                htmlContenido += '  <td rowspan="' + val.NUM_MUESTRAS + '"' + ' style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: ' + color_ConfAu + '; color: #ffffff; text-align: center;">' + val.Conf_Au + '</td>';
                                                            }

                                                        // Conf. Ag
                                                            if (id_modulo == 4 || id_modulo == 7){
                                                            // Deterimna el Color
                                                                var color_ConfAg = '';

                                                                if (val.Conf_Ag_Dore <= 0.5){
                                                                    color_ConfAg = '#00C756';
                                                                }
                                                                if (val.Conf_Ag_Dore > 0.5 && val.Conf_Ag_Dore < 1){
                                                                    color_ConfAg = '#FEB71B';
                                                                }
                                                                if (val.Conf_Ag_Dore >= 1){
                                                                    color_ConfAg = '#FF2F1E';
                                                                }

                                                                htmlContenido += '  <td rowspan="' + val.NUM_MUESTRAS + '"' + ' style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: ' + color_ConfAg + '; color: #ffffff; text-align: center;">' + val.Conf_Ag_Dore + '</td>';
                                                            }
                                                            if (id_modulo == 10){
                                                            // Deterimna el Color
                                                                var color_ConfAg = '';

                                                                if (val.Conf_Ag <= 0.5){
                                                                    color_ConfAg = '#00C756';
                                                                }
                                                                if (val.Conf_Ag > 0.5 && val.Conf_Ag < 1){
                                                                    color_ConfAg = '#FEB71B';
                                                                }
                                                                if (val.Conf_Ag >= 1){
                                                                    color_ConfAg = '#FF2F1E';
                                                                }

                                                                htmlContenido += '  <td rowspan="' + val.NUM_MUESTRAS + '"' + ' style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: ' + color_ConfAg + '; color: #ffffff; text-align: center;">' + val.Conf_Ag + '</td>';
                                                            }

                                                        id_detallerack_x = val.ID_DETALLERACK
                                                    }
                                                }

                                                htmlContenido += '</tr>';

                                                m += 1;
                                                i += 1;
                                            });

                                            // Visualizar lista de muestras observadas por Blanco Fundente
                                                if (_Show == 0){
                                                    f_CerrarDiv('A', 'div_preview_muestrasobservadas');
                                                    f_CerrarDiv('C', 'div_confirmar_muestrasobservadas');
                                                }
                                                else{
                                                    f_CerrarDiv('C', 'div_preview_muestrasobservadas');
                                                    f_CerrarDiv('A', 'div_confirmar_muestrasobservadas');
                                                }
                                        }
                                        else{
                                            alert("Ocurrió un error al momento de mostrar el detalle de solicitud.");
                                        }

                                        // Cerrando Modal
                                            $('#divmodal_Loading').modal('hide');

                                        $("#tabla_detallemuestrasobservadas").html(htmlContenido);

                                        modal.modal({backdrop: 'static', keyboard: false});

                                    }, "json");


                        }, "json");

                modal.modal({backdrop: 'static', keyboard: false});
            };

            function f_ConfirmarMuestrasObservadas(){
                var x = 1;
                var a = 0;
                var reanalisis = 99;
                var total = 0;

                while (x < select_reanalisis){
                    reanalisis = $("#reanalisis_" + x).val();

                    // Validando datos
                        if (reanalisis == 99){
                            alert('Hay registros que no tienen una acción seleccionada');

                            return;
                        }

                    // Contando las muestras para reanálisis
                        if (reanalisis != undefined){
                            reanalisis_x = reanalisis.substr(reanalisis.indexOf('|') + 1);

                            if (reanalisis_x.substr(0, reanalisis_x.indexOf('|')) != 0){
                                total += 1;
                            }

                            arr_select[a] = reanalisis;
                        }

                    x += 1;
                    a += 1;
                }

                // Pintando reanálisis seleccionados
                    $("#num_muestrasreanalisis").html(total + ' de ' + (total_select_habilitados));

                f_cerrarModal(2);
            };

            function f_RowColor(_row_id){
                var id_valor = $("#reanalisis_" + _row_id).val();
                var color = '';

                id_valor = id_valor.substr(id_valor.indexOf('|') + 1);

                if (id_valor.substr(0, 2) == 99){
                    color = '#ffffff';
                }
                else{
                    if (id_valor.substr(0, 1) == 0){
                        color = '#DA7780';
                    }
                    else{
                        color = '#77C1CC';
                    }
                }
                
                document.getElementById('row_' + _row_id).style.background = color;
            };

        </script>

        <!-- Funciones para Grabar -->
        <script type="text/javascript">
            
        </script>

        <!-- Otras Funciones -->
        <script type="text/javascript">
            function f_cerrarModal(pantalla_modal){
                if (pantalla_modal == 1){
                    $('#divmodal_Detalles').modal('hide');
                }

                if (pantalla_modal == 2){
                    $('#divmodal_MuestrasObservadas').modal('hide');
                }
            };

            function f_ImagenCierre(_Estado_Cierre){
                var image_orden = $("#cierre_imageorden").val();
            };

            function f_CerrarDiv(accion, nom_div){
                var _div = document.getElementById(nom_div);

                if (accion == 'A'){
                    if (nom_div == 'th_reanalisis' || nom_div == 'th_confag' || nom_div == 'th_confau' || nom_div == 'th_oro' || nom_div == 'th_oro_Ag1' || nom_div == 'th_oro_Au1' || nom_div == 'th_oro_Ag2' || nom_div == 'th_oro_Au2' || nom_div == 'th_dore_1' || nom_div == 'th_dore_2' || nom_div == 'th_pesooro'){
                        $('#' + nom_div).css('display', '')

                        if (nom_div == 'th_pesooro'){
                            $("#th_titulo").attr('colspan', 12);
                        }
                    }
                    else{
                        _div.style.display = 'block';
                    }
                }
                else{
                     _div.style.display = 'none';

                     if (nom_div == 'th_pesooro'){
                        $("#th_titulo").attr('colspan', 11);
                    }
                }
            };
        </script>

    </body>
</html>

<?php
    cerrarSesion($enlace);
?>