<?php

  header('Content-Type: application/json');
  session_start();

  include('../../php/conn.php');

  // Seteando librería para importar Excel
    require 'vendor/autoload.php';

  // Para obtener el valor de las columnas de Excel
    use PhpOffice\PhpSpreadsheet\Cell\Coordinate;

// Actualizando zona horaria del servidor
  $q_timezone = "SET TIME_ZONE = 'America/Lima'";

  if ($res = mysqli_query($enlace, $q_timezone)) {
  }

  date_default_timezone_set('America/Lima');

// Inicia el proceso condicional
  switch ($_POST["accion"]) {
    case 'import_ResultadosXRF_ExcelToBD':
      $estado = 1;

      $id_importacion = $_POST["id_importacion"];
      $usuario_registro = $_SESSION["usu_usuario"];

      // Seteando los datos de origen
        $nombre_file = $_FILES["file"]["name"];
        $nombre_file_x = $_FILES["file"]["name"];
        $tmp_file = $_FILES["file"]["tmp_name"];
        $ext_file = substr($nombre_file, strrpos($nombre_file, '.') + 1);

      // Setea los datos de destino
        $nombre_file = 'file_'.$id_importacion.'.'.$ext_file;
        $destino_file = '../files/'.$nombre_file;

      // Uploading archivo
        if (strlen($nombre_file_x) > 0){
          if (!move_uploaded_file($tmp_file, $destino_file)){
            echo 0;
          }
          else{
            // echo 'Ok';

            // Seteando librería y preparando archivo
              $inputFileType = \PhpOffice\PhpSpreadsheet\IOFactory::identify($destino_file);
              $reader = \PhpOffice\PhpSpreadsheet\IOFactory::createReader($inputFileType);
              $spreadsheet = $reader->load($destino_file);

              $fila_inicio = 0;

            // Recorre las filas del archivo desde la Fila de Inicio configurada
              $r = 0;
              $in_codinterno = '';
              $rows = $spreadsheet->getActiveSheet()->toArray();

              foreach ($rows as $row){
                if ($r >= $fila_inicio){
                  // Valida si es el éltimo registro
                    if (strlen($row[0]) == 0){
                      break;
                    }

                  // Verifica si es cabecera, si es así guarda un array
                    if (trim($row[0]) == 'File #'){
                      $c = 1;
                      $item = 1;
                      $arr_cabecera = array();
                      $arr_cabecera[0] = trim($row[0]);

                      while ($c <= 150){
                        if (strlen(trim($row[$c])) > 0){
                          $arr_cabecera[$c] = trim($row[$c]);
                        }

                        $c ++;
                      }
                    }
                    else{
                      // Setea los datos de cabecera
                        $q_insert = "INSERT INTO import_resultadosxrf_detalle (id_importacion,
                                     item, fechahora_registro, operator, name, id_detalle,
                                     application, method, elapsed_time, alloy_1, match_qual_1,
                                     alloy_2, match_qual_2, alloy_3, match_qual_3, resultados)
                                     VALUES (";
                        $q_insert .= $id_importacion.', ';
                        $q_insert .= "'".$row[0]."', ";
                        $q_insert .= "'".(explode('/', explode(' ', $row[1])[0])[2].'-'.str_pad(explode('/', explode(' ', $row[1])[0])[1], 2, '0', STR_PAD_LEFT).'-'.str_pad(explode('/', explode(' ', $row[1])[0])[0], 2, '0', STR_PAD_LEFT)).' '.explode(' ', $row[1])[1]."', ";
                        $q_insert .= "'".$row[2]."', ";
                        $q_insert .= "'".$row[3]."', ";
                        $q_insert .= "'".$row[4]."', ";
                        $q_insert .= "'".$row[5]."', ";
                        $q_insert .= "'".$row[6]."', ";
                        $q_insert .= "'".$row[7]."', ";
                        $q_insert .= "'".$row[8]."', ";
                        $q_insert .= "'".$row[9]."', ";
                        $q_insert .= "'".$row[10]."', ";
                        $q_insert .= "'".$row[11]."', ";
                        $q_insert .= "'".$row[12]."', ";
                        $q_insert .= "'".$row[13]."', ";
                        $q_insert .= "'";

                      // Setea los resultados
                        $a = 14;
                        $titulo = '';
                        $valor = '';

                        while ($a < count($arr_cabecera)){
                          // Obtiene el título
                            $titulo = trim($arr_cabecera[$a]);

                          // Valor
                            $valor = trim($row[$a]);

                          // Setea cadena
                            $q_insert .= "[".$titulo."]-[".$valor."]&";

                          $a ++;
                        }

                      // Insertando registro
                        $q_insert = substr($q_insert, 0, -1);
                        $q_insert .= "')";

                        if ($res_insert = mysqli_query($enlace, $q_insert)){
                        }
                        else{
                          $estado = 0;
                        }

                      $item ++;
                    }
                }

                $r ++;
              }
          }
        }

      echo json_encode(array('estado' => $estado));

      break;

    default:

      # code...

      break;

  }

?>