<?php
  
  session_start();

  include('../../php/conn.php');

  if(!isset($_SESSION["id"])){
    header('Location: index.php');
  }

  mysqli_query($enlace, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");
  mysqli_query($enlacehost, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");

?>

<!DOCTYPE html>
<html lang="es">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <!-- Meta, title, CSS, favicons, etc. -->
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <title>LIMS | Pre Cierre de Humedad</title>

        <!-- Bootstrap -->
        <link href="../vendors/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
        <!-- Font Awesome -->
        <link href="../vendors/font-awesome/css/font-awesome.min.css" rel="stylesheet">
        <!-- NProgress -->
        <link href="../vendors/nprogress/nprogress.css" rel="stylesheet">
        <!-- iCheck -->
        <link href="../vendors/iCheck/skins/flat/green.css" rel="stylesheet">
        <!-- bootstrap-progressbar -->
        <link href="../vendors/bootstrap-progressbar/css/bootstrap-progressbar-3.3.4.min.css" rel="stylesheet">
        <!-- JQVMap -->
        <link href="../vendors/jqvmap/dist/jqvmap.min.css" rel="stylesheet"/>
        <!-- bootstrap-daterangepicker -->
        <link href="../vendors/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
        <!-- Ion.RangeSlider -->
        <link href="../vendors/normalize-css/normalize.css" rel="stylesheet">
        <link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.css" rel="stylesheet">
        <link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.skinFlat.css" rel="stylesheet">
        <!-- Bootstrap Colorpicker -->
        <link href="../vendors/mjolnic-bootstrap-colorpicker/dist/css/bootstrap-colorpicker.min.css" rel="stylesheet">
        <link href="../vendors/cropper/dist/cropper.min.css" rel="stylesheet">
        <!-- Datatables -->
        <link href="../vendors/datatables.net-bs/css/dataTables.bootstrap.min.css" rel="stylesheet">
        <link href="../vendors/datatables.net-buttons-bs/css/buttons.bootstrap.min.css" rel="stylesheet">
        <link href="../vendors/datatables.net-fixedheader-bs/css/fixedHeader.bootstrap.min.css" rel="stylesheet">
        <link href="../vendors/datatables.net-responsive-bs/css/responsive.bootstrap.min.css" rel="stylesheet">
        <link href="../vendors/datatables.net-scroller-bs/css/scroller.bootstrap.min.css" rel="stylesheet">

        <!-- bootstrap-datetimepicker -->
        <link href="../vendors/bootstrap-datetimepicker/build/css/bootstrap-datetimepicker.css" rel="stylesheet">

        <!-- Switchery -->
        <link href="../vendors/switchery/dist/switchery.min.css" rel="stylesheet">

        <!-- Toggle Switch -->
        <link rel="stylesheet" type="text/css" href="bootstrap/css/bootstrap4-toggle.min.css">

        <!-- Custom Theme Style -->
        <link href="../build/css/custom.min.css" rel="stylesheet">

        <script type="text/javascript">
            let Rack_TotalRows = 0;
            let chkRack_Selected = '';
        </script>

        <style type="text/css">
            th {
                position: sticky;
                top: 0px;
                background-color: #12537E;
            }
        </style>
    </head>

    <body class="nav-md" onload="f_LoadResultados(1)" style="zoom: 80%">
        <div class="container body">
            <div class="main_container">
                <?php include('partes/sidebar.php'); ?>

                <!-- page content -->
                <div class="right_col" role="main">
                    <div class="">
                        <div id="row_Titulo" class="row">
                            <div class="col-md-12 col-sm-12 col-xs-12">
                                <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                    <div class="x_title">
                                        <h2>
                                            Pre Cierre de Muestras
                                        </h2>
                                        <div class="clearfix">
                                        </div>
                                    </div>

                                    <div class="x_content" style="margin-bottom: -10px;">
                                        <!-- Filtros -->
                                        <div class="col-md-12 col-sm-12 col-xs-12">
                                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                                <div class="x_title">
                                                    <h2>
                                                        <font style="font-size: 14px"><b>Búsqueda por rango de fechas</b></font>
                                                    </h2>
                                                    <div class="clearfix">
                                                    </div>
                                                </div>
                                                <div class="x_content" style="margin-bottom: -10px;">
                                                    <div class="form-group col-md-6 col-sm-6 col-xs-12">
                                                        <label class="control-label col-md-5 col-sm-5 col-xs-12" style="margin-top: 6px; text-align: right;">
                                                            Desde
                                                        </label>
                                                        <div class="col-md-7 col-sm-7 col-xs-12">
                                                            <?php
                                                                date_default_timezone_set("America/Lima"); 
                                                                $time = date('Y-m-d');

                                                                echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_inicio" value="'.$time.'"/>';
                                                            ?>
                                                        </div>
                                                    </div>

                                                    <div class="form-group col-md-6 col-sm-6 col-xs-12">
                                                        <label class="control-label col-md-3 col-sm-3 col-xs-12" style="margin-top: 6px; text-align: right;">
                                                            Hasta
                                                        </label>
                                                        <div class="col-md-7 col-sm-7 col-xs-12">
                                                            <?php
                                                                echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_fin" value="'.$time.'"/>';
                                                            ?>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div id="row_Buscar" class="row">
                            <div class="col-md-12 col-sm-12 col-xs-12">
                                <button class="btn btn-success" type="button" onclick="f_LoadResultados(0)" style="width: 100%; background-color: #26B99A">
                                     <b>Ejecutar Búsqueda</b>
                                </button>
                            </div>
                        </div>

                        <div class="row" style="margin-top: 10px">
                            <div class="col-md-12 col-sm-12 col-xs-12">
                                <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                    <div class="x_title">
                                        <div class="col-md-4 col-sm-4 col-xs-4">
                                            <h2 id="titulo_detalle" style="margin-top: 11px;">
                                                <b>Humedad</b> - Visualizando Muestras Pendientes de Pre Cierre
                                            </h2>
                                        </div>

                                        <div class="col-md-8 col-sm-8 col-xs-8">
                                            <input id="_SwitchEstado" name="_SwitchEstado" type="checkbox" checked data-toggle="toggle" data-on="Pendientes de Pre Cierre" data-off="Pre Cerradas" data-onstyle="primary" data-offstyle="warning" data-width="170">

                                            <div id="chk_filtros" class="col-md-6 col-sm-6 col-xs-6" style="margin-top: 15px;" onchange="f_LoadResultados();">
                                                <input id="chk_x" type="checkbox" value="chk_filtros" class="chk_filtros">
                                                <label for="chk_x">Mostrar todas las muestras</label>
                                            </div>
                                        </div>

                                        <div class="clearfix">
                                        </div>
                                    </div>

                                    <div class="x_content">
                                        <div class="col-md-8 col-sm-8 col-xs-8" style="margin-top: 15px;">
                                            <label>
                                                Total de Muestras:
                                            </label>
                                            <label id="lbl_TotalMuestras" style="color: #FF0005; font-size: 14px;">
                                                0
                                            </label>
                                        </div>
                                        <div class="col-md-2 col-sm-2 col-xs-2" style="margin-top: -5px;">
                                            <button class="btn btn-success exportToExcel" type="button" style="width: 100%;" onclick="f_ExportToExcel()">
                                                 <b>Descargar a Excel</b>
                                            </button>
                                        </div>
                                        <div class="col-md-2 col-sm-2 col-xs-2" style="margin-top: -5px;">
                                            <button class="btn btn-success" type="button" onclick="f_PreCierre()" style="width: 100%; background-color: #F25050">
                                                 <b>Pre Cierre</b>
                                            </button>
                                        </div>

                                        <div class="table-box" style="height: 850px; width: 100%; overflow: scroll;">
                                            <table class="table table-striped jambo_table bulk_action">
                                                <thead>
                                                    <tr>
                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 30px; border-top-left-radius: 15px;"><center>
                                                            Item
                                                        </center></th>
                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 140px;"><center>
                                                            Muestra
                                                        </center></th>
                                                        <th colspan="2" style="background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Datos Bandeja
                                                        </center></th>
                                                        <th colspan="4" style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Pesos Muestra (g)
                                                        </center></th>
                                                        <th colspan="3" style="background-color: #3EB595; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Cálculo % Humedad
                                                        </center></th>
                                                        <!-- <th rowspan="2" style="background-color: #404040; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 100px; display: none;"><center>
                                                            Reanálisis
                                                        </center></th> -->
                                                        <!-- <th rowspan="2" style="background-color: #A6341B; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 60px;"><center>
                                                            Reanálisis durante proceso
                                                        </center></th> -->
                                                        <!-- <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Observación
                                                        </center></th> -->
                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 100px;"><center>
                                                            Comentarios
                                                        </center></th>
                                                        <th colspan="3" style="border: solid; border-width: 1px; border-color: #ffffff; background-color: #F25050; vertical-align: middle; border-top-right-radius: 15px;"><center>
                                                            Pre Cierre
                                                        </center></th>
                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 30px; border-top-left-radius: 15px;" hidden><center>
                                                            Id Detalles
                                                        </center></th>
                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 30px; border-top-left-radius: 15px;" hidden><center>
                                                            Is Reabrir
                                                        </center></th>
                                                    </tr>

                                                    <tr>
                                                        <th style=" background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Descripción
                                                        </center></th>
                                                        <th style="background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Peso (g)
                                                        </center></th>

                                                        <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Peso Húmedo
                                                        </center></th>
                                                        <th style="background-color: #A3A1A8; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Peso Muestra Húmeda
                                                        </center></th>
                                                        <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Peso Seco
                                                        </center></th>
                                                        <th style="background-color: #A3A1A8; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Peso Muestra Seca
                                                        </center></th>

                                                        <th style="background-color: #3EB595; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            % Humedad
                                                        </center></th>
                                                        <th style="background-color: #8A75AA; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Sel
                                                        </center></th>
                                                        <th style="background-color: #3EB595; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 100px;"><center>
                                                            Promedio % Humedad
                                                        </center></th>

                                                        <th style="background-color: #F25050; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Acción
                                                        </center></th>
                                                        <th style="background-color: #F25050; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Usuario
                                                        </center></th>
                                                        <th style="background-color: #F25050; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 80px;"><center>
                                                            Fecha y Hora
                                                        </center></th>

                                                    </tr>
                                                </thead>

                                                <tbody id="tbl_MuestrasPreCierre" style="overflow: scroll">
                                                    
                                                </tbody>
                                            </table>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div id="divmodal_DetallesMuestra" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false">
            <div class="modal-dialog" style="width: 50%; margin-top: 5%; text-align: center;">
                <!-- Modal content-->
                <div class="modal-content" style="border: solid; border-width: 1px; border-color: #E6E9ED; border-radius: 7px;">
                    <div class="modal-header" style="background-color: #282828; color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; border-radius: 7px;">
                        <button type="button" class="close" data-dismiss="modal" style="color: #ffffff;">
                            ×
                        </button>

                        <h4 class="modal-title" id="titulomodal_ClaveClientes"><b>
                            <div class="col-md-5 col-sm-5 col-xs-5" style="width: 200px;">
                                Información de Muestra: 
                            </div>
                            <div class="col-md-7 col-sm-7 col-xs-7" style="text-align: left; margin-left: -15px;">
                                <label id="lbl_TituloMuestra" style="color: #FAF566"> XXXXXX</label>
                            </div>
                        </b></h4>
                    </div>

                    <div class="modal-body">
                        <form class="form-horizontal form-label-left" style="font-size: 14px;">
                            <div class="col-md-6 col-sm-6 col-xs-6">
                                <table class="table table-striped jambo_table bulk_action">
                                    <thead>
                                        <tr>
                                            <th colspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; border-top-left-radius: 15px; border-top-right-radius: 15px;">
                                                Información del Rack
                                            </th>
                                        </tr>
                                    </thead>

                                    <tbody>
                                        <tr>
                                            <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: left; background-color: #12537e; color: #ffffff;">
                                                Nombre Rack
                                            </td>

                                            <td id="td_campo1" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #ffffff; color:  #12537E;">
                                                
                                            </td>
                                        </tr>

                                        <tr>
                                            <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: left; background-color: #12537e; color: #ffffff;">
                                                Estufa
                                            </td>

                                            <td id="td_campo2" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #ffffff; color:  #12537E;">
                                                
                                            </td>
                                        </tr>

                                        <tr>
                                            <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: left; background-color: #12537e; color: #ffffff;">
                                                Estado Muestra
                                            </td>

                                            <td id="td_campo3" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #ffffff; color:  #12537E;">
                                                
                                            </td>
                                        </tr>

                                        <tr>
                                            <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: left; background-color: #12537e; color: #ffffff;">
                                                Horas Secado
                                            </td>

                                            <td id="td_campo4" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #ffffff; color:  #12537E;">
                                                
                                            </td>
                                        </tr>

                                        <tr>
                                            <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: left; background-color: #12537e; color: #ffffff;">
                                                N° Ensayos
                                            </td>

                                            <td id="td_campo5" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #ffffff; color:  #12537E;">
                                                
                                            </td>
                                        </tr>

                                        <tr>
                                            <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: left; background-color: #12537e; color: #ffffff;">
                                                Observaciones
                                            </td>

                                            <td id="td_campo6" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #ffffff; color:  #12537E;">
                                                
                                            </td>
                                        </tr>

                                        <tr>
                                            <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: left; background-color: #d9534f; color: #ffffff;">
                                                Fecha Hora Cierre Rack
                                            </td>

                                            <td id="td_campo7" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #ffffff; color:  #12537E;">
                                                
                                            </td>
                                        </tr>

                                        <tr>
                                            <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: left; background-color: #d9534f; color: #ffffff;">
                                                Usuario Cierre Rack
                                            </td>

                                            <td id="td_campo8" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #ffffff; color:  #12537E;">
                                                
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>

                            <div class="col-md-6 col-sm-6 col-xs-6">
                                <table class="table table-striped jambo_table bulk_action">
                                    <thead>
                                        <tr>
                                            <th colspan="3" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; border-top-left-radius: 15px; border-top-right-radius: 15px; background-color: #049DBF;">
                                                Información de Pesos
                                            </th>
                                        </tr>
                                    </thead>

                                    <tbody>
                                        <tr>
                                            <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #049DBF; color: #ffffff;">
                                                
                                            </td>

                                            <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #049DBF; color:  #ffffff;">
                                                Fecha y Hora
                                            </td>

                                            <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #049DBF; color:  #ffffff;">
                                                Usuario
                                            </td>
                                        </tr>

                                        <tr>
                                            <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #049DBF; color: #ffffff; text-align: left;">
                                                Peso Húmedo
                                            </td>

                                            <td id="td_pesohumedo_fecha" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #ffffff; color:  #049DBF;">
                                                
                                            </td>

                                            <td id="td_pesohumedo_usuario" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #ffffff; color:  #049DBF;">
                                                
                                            </td>
                                        </tr>

                                        <tr>
                                            <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #049DBF; color: #ffffff; text-align: left;">
                                                Peso Seco
                                            </td>

                                            <td id="td_pesoseco_fecha" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #ffffff; color:  #049DBF;">
                                                
                                            </td>

                                            <td id="td_pesoseco_usuario" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #ffffff; color:  #049DBF;">
                                                
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>

                                <table class="table table-striped jambo_table bulk_action">
                                    <thead>
                                        <tr>
                                            <th colspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; border-top-left-radius: 15px; border-top-right-radius: 15px; background-color: #049DBF;">
                                                Información de Secado
                                            </th>
                                        </tr>
                                    </thead>

                                    <tbody>
                                        <tr>
                                            <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #049DBF; color:  #ffffff;">
                                                Inicio
                                            </td>

                                            <td id="td_InicioSecado" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #ffffff; color: #049DBF;">
                                                
                                            </td>
                                        </tr>

                                        <tr>
                                            <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #049DBF; color:  #ffffff;">
                                                Fin
                                            </td>

                                            <td id="td_FinSecado" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; background-color: #ffffff; color: #049DBF;">
                                                
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        </form>
                    </div>

                    <div class="modal-footer" style="padding-bottom: 5px; padding-top: 10px; text-align: center; background-color: #565759; border: solid; border-width: 1px; border-color: #E6E9ED; border-radius: 7px;">
                        <div class="col-md-12 col-sm-12 col-xs-12">
                            <button class="btn btn-dark" type="button" onclick="f_cerrarModal(3)" style="background-color: #337ab7">
                                Cerrar
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- Ventanas Modal -->
        <div id="divmodal_Loading" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false" style="margin-top: 300px;">
            <div class="modal-dialog" style="height: 200px; opacity: 0.5;"><center>
                <img src="images/loading.gif" width="200px" style="border: solid; border-width: 1px; border-color: #D9D9D9;  border-radius: 15px;"></img>
            </center></div>
        </div>

        <!-- jQuery -->
        <!-- <script src="../vendors/jquery/dist/jquery.min.js"></script> -->
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/2.2.4/jquery.min.js"></script>
        <!-- Bootstrap -->
        <script src="../vendors/bootstrap/dist/js/bootstrap.min.js"></script>
        <!-- Export 2 Excel -->
        <script src="libs/table2excel/jquery.table2excel.js"></script>
        <!-- FastClick -->
        <script src="../vendors/fastclick/lib/fastclick.js"></script>
        <!-- NProgress -->
        <script src="../vendors/nprogress/nprogress.js"></script>
        <!-- Ion.RangeSlider -->
        <script src="../vendors/ion.rangeSlider/js/ion.rangeSlider.min.js"></script>
        <!-- Bootstrap Colorpicker -->
        <script src="../vendors/mjolnic-bootstrap-colorpicker/dist/js/bootstrap-colorpicker.min.js"></script>
        <!-- Toggle Switch -->
        <script src="bootstrap/js/bootstrap4-toggle.min.js"></script>
        <!-- Custom Theme Scripts -->
        <script src="../build/js/custom.min.js"></script>

        <!-- bootstrap-daterangepicker -->
        <script src="../vendors/moment/min/moment.min.js"></script>
        <script src="../vendors/bootstrap-daterangepicker/daterangepicker.js"></script><!-- Datatables -->
        <script src="../vendors/datatables.net/js/jquery.dataTables.min.js"></script>
        <script src="../vendors/datatables.net-bs/js/dataTables.bootstrap.min.js"></script>
        <script src="../vendors/datatables.net-buttons/js/dataTables.buttons.min.js"></script>
        <script src="../vendors/datatables.net-buttons-bs/js/buttons.bootstrap.min.js"></script>
        <script src="../vendors/datatables.net-buttons/js/buttons.flash.min.js"></script>
        <script src="../vendors/datatables.net-buttons/js/buttons.html5.min.js"></script>
        <script src="../vendors/datatables.net-buttons/js/buttons.print.min.js"></script>
        <script src="../vendors/datatables.net-fixedheader/js/dataTables.fixedHeader.min.js"></script>
        <script src="../vendors/datatables.net-keytable/js/dataTables.keyTable.min.js"></script>
        <script src="../vendors/datatables.net-responsive/js/dataTables.responsive.min.js"></script>
        <script src="../vendors/datatables.net-responsive-bs/js/responsive.bootstrap.js"></script>
        <script src="../vendors/datatables.net-scroller/js/dataTables.scroller.min.js"></script>
        <script src="../vendors/jszip/dist/jszip.min.js"></script>
        <script src="../vendors/pdfmake/build/pdfmake.min.js"></script>
        <script src="../vendors/pdfmake/build/vfs_fonts.js"></script>

        <!-- Funciones Principales -->
        <script type="text/javascript">
            function f_LoadResultados(){
                let htmlContenido = '';
                let i = 1;
                let x = 1; // Ayudará a llevar el Id de inicio de cada grupo de muestras
                let t = 0; // Ayudará a llevar el Total de Muestras por cada grupo de muestras
                let is_PreCierreAg = 0; // Ayudará a reservar si es Pre Cierre Ag
                let is_PreCierreAu = 0; // Ayudará a reservar si es Pre Cierre Au
                let rowspan_analisis = 0;

                // Obteniendo parámetros
                    var _estado = (($("#_SwitchEstado").prop('checked')) ? 1 : 0);
                    var _all = (($("#chk_x").prop('checked')) ? 1 : 0);
                    let fecha_inicio = $("#fecha_inicio").val();
                    let fecha_fin = $("#fecha_fin").val();

                    if (_estado == 0){
                        // Validando ingreso de fechas
                            if (fecha_inicio == null){
                                alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                                return;
                            }
                            if (fecha_inicio.length == 0){
                                alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                                return;
                            }

                            if (fecha_fin == null){
                                alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                                return;
                            }
                            if (fecha_fin.length == 0){
                                alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                                return;
                            }

                            if (fecha_fin < fecha_inicio){
                                alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

                                return;
                            }

                        _all = 1;
                    }

                // Cargando detalle de Análisis
                    $("#tbl_MuestrasPreCierre").html(htmlContenido);

                // Loading Modal
                    let modal_loading = $("#divmodal_Loading");
                    modal_loading.modal({backdrop: 'static', keyboard: false});

                // Carga datos
                    $.get( "../lims_api/index.php", { accion: "get_MuestrasPreCierre_Humedad", estado: _estado, show_all: _all, fecha_inicio: fecha_inicio, fecha_fin: fecha_fin },
                        function( data ) {
                            if(data.estado == 1){
                                $.each( data.registros, function( key, val ) {
                                    htmlContenido += '<tr id="' + val.Id + '" style="font-size: 16px;">';

                                    htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                                    htmlContenido += '      ' + i;
                                    htmlContenido += '  </td>';

                                    htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer;">';
                                    htmlContenido += '      <u onclick="f_ShowDatos(' + val.ID_DETALLE + ", '" + val.CI_Muestra + "'" +');">' + val.CI_Muestra + '</u>';

                                    if (val.is_reanalisis_1 == 1 || val.is_reanalisis_2 == 1 || val.is_reanalisis_precierre == 1){
                                        htmlContenido += '<img src="images/R.png" width="16px;"></img>';
                                    }

                                    htmlContenido += '  </td>';

                                    htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                                    htmlContenido += '      ' + ((val.nom_bandeja == null) ? '' : val.nom_bandeja);
                                    htmlContenido += '  </td>';
                                    
                                    htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                                    htmlContenido += '      ' + ((val.peso_bandeja == null) ? '' : val.peso_bandeja);
                                    htmlContenido += '  </td>';
                                    
                                    htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; ' + ((val.Peso_Humedo == null) ? 'font-size: 13px !important; color: #FF0005;' : '') + '">';
                                    htmlContenido += '      ' + ((val.Peso_Humedo == null) ? 'PENDIENTE' : val.Peso_Humedo);
                                    htmlContenido += '  </td>';
                                    
                                    htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                                    htmlContenido += '      ' + ((val.Peso_MuestraHumeda == null) ? '' : val.Peso_MuestraHumeda);
                                    htmlContenido += '  </td>';
                                    
                                    htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; ' + ((val.Peso_Seco == null) ? 'font-size: 13px !important; color: #FF0005;' : '') + '">';
                                    htmlContenido += '      ' + ((val.Peso_Seco == null) ? 'PENDIENTE' : val.Peso_Seco);
                                    htmlContenido += '  </td>';
                                    
                                    htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                                    htmlContenido += '      ' + ((val.Peso_MuestraSeca == null) ? '' : val.Peso_MuestraSeca);
                                    htmlContenido += '  </td>';

                                    htmlContenido += '  <td id="chkRow_Humedad_' + val.Id + '_' + i + '" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; font-size: 16px; background-color: #DCEDC8; ' + ((val.Porc_Humedad == null) ? 'font-size: 13px !important; color: #FF0005;' : '') + '">';
                                    htmlContenido += '      ' + ((val.Porc_Humedad == null) ? 'PENDIENTE' : val.Porc_Humedad);
                                    htmlContenido += '  </td>';

                                    // Determina si el Check de Precierre estará activo
                                        var _is_enabled = 1;

                                        if (val.tiene_gestion == 1 && val.gestion_atendida == 0){
                                            _is_enabled = 0;
                                        }

                                    // Realiza el promedio para Humedad
                                        if (rowspan_analisis != val.Id){
                                            x = i;
                                            t = val._COUNT;
                                            is_PreCierre = val.is_PreCierre;
                                        }

                                        htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center;">';

                                        // Si el % de Humedad es negativo no debe haber Checkbox
                                            if (((val.Porc_Humedad == null) ? -1 : val.Porc_Humedad) < 0){
                                                _is_enabled = 0;
                                            }

                                        htmlContenido += '      <input type="checkbox" id="chkRow_Selected_' + i + '" onchange="f_RowSelected(1, ' + x + ', ' + t + ', ' + val.Id + ', ' + _is_enabled + ')" ' + ((is_PreCierre == 1) ? ((val.isPreCierre_Selected == 1) ? ' checked ' : '') : ((val.Porc_Humedad < 0 || val.Porc_Humedad == null) || t >= 3 ? ' unchecked ' : ' checked ')) + ((_is_enabled == 0) ? 'disabled' : ((is_PreCierre == 1) ? 'disabled' : '')) + '>';
                                        htmlContenido += '  </td>';

                                        if (rowspan_analisis != val.Id){
                                            htmlContenido += '  <td rowspan="' + t + '" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; background-color: #DCEDC8; font-size: 16px;">';
                                            htmlContenido += '      <b id="rowPromedio_Humedad_' + val.Id + '" style="color: #8C8C8C;">';
                                            htmlContenido += '              ' + ((is_PreCierre == 1) ? val.precierre_Prom : '');
                                            htmlContenido += '      </b>';
                                            htmlContenido += '  </td>';
                                        }

                                    // Agrega la columna de reanálisis y adicionales
                                        if (rowspan_analisis != val.Id){
                                            // htmlContenido += '  <td rowspan="' + t + '"' + ' style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; display: none;">';
                                            // htmlContenido += '     <select id="reanalisis_' + i + '" class="form-control" onblur="f_SendReanalisis(' + i + ', ' + val.Id + ')" ' + ((_is_enabled == 0) ? 'disabled' : '') + '>';
                                            // htmlContenido += '         <option value="99" selected> Elija una opción...</option>';
                                            // htmlContenido += '         <option value="1"> Realizar Reanálisis</option>';
                                            // htmlContenido += '     </select>';
                                            // htmlContenido += '  </td>';

                                            // // Columna que indica si la muestra tuvo un reanálisis durante el proceso
                                            //     if (val.tiene_gestion == 1 && val.gestion_atendida != null){
                                            //         htmlContenido += '  <td rowspan="' + t + '"' + ' rowspan style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center;">';
                                            //         htmlContenido += '      SÍ';
                                            //         htmlContenido += '  </td>';
                                            //     }
                                            //     else{
                                            //          htmlContenido += '  <td rowspan="' + t + '">';
                                            //          htmlContenido += '  </td>';
                                            //     }

                                            // // Agregando Observaciones
                                            //     let _observacion = '';

                                            //     if (val.tiene_gestion == 1 && val.gestion_atendida == 0){
                                            //         _observacion = 'Solicitud de Reanálisis pendiente de atender.';
                                            //     }

                                            //     if (val.tiene_gestion == 1 && val.gestion_atendida == 1 && val.is_rechazo == 1){
                                            //         _observacion = 'Solicitud de Reanálisis Rechazada.';
                                            //     }

                                            //     htmlContenido += '  <td rowspan="' + t + '"' + ' style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center; color: #FF2F1E;">';
                                            //     htmlContenido += '      ' + _observacion;
                                            //     htmlContenido += '  </td>';

                                            // Agregando Comentarios
                                                htmlContenido += '  <td rowspan="' + t + '"' + ' style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center; color: #FF2F1E;">';
                                                htmlContenido += '      <input id="row_Comentario_' + val.Id + '" type="text" class="form-control" style="text-transform: uppercase;" ' + ((val.precierre_Comentario == null) ? '' : 'value="' + val.precierre_Comentario + '"') + ((_is_enabled == 1) ? '' : 'disabled') + ((is_PreCierre == 1) ? 'disabled' : '') + '>';
                                                htmlContenido += '  </td>';

                                            // Colocando las columnas del Pre Cierre
                                                htmlContenido += '  <td rowspan="' + t + '"' + ' style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center;">';

                                                if (is_PreCierre == 1){
                                                    htmlContenido += '      <u style="color: #FF2F1E;" onclick="f_Reabrir(' + val.Id + ', ' + val.Id_Pedido + ', ' + val.Id_Detalle + ')">Reabrir</u>';
                                                }
                                                else{
                                                    htmlContenido += '      <input type="checkbox" id="chkRow_PreCierre_' + val.Id + '" ' + ((_is_enabled == 1) ? ((t >= 3) ? '' : 'checked') : 'disabled') + '>';
                                                }

                                                htmlContenido += '      <input id="txt_idpedido_' + i + '" type="hidden" value="' + val.Id_Pedido + '">';
                                                htmlContenido += '      <input id="txt_iddetalle_' + i + '" type="hidden" value="' + val.Id_Detalle + '">';

                                                htmlContenido += '  </td>';

                                            // Colocando los datos del Pre Cierre
                                                htmlContenido += '  <td rowspan="' + t + '"' + ' style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;">';

                                                if (is_PreCierre == 1){
                                                    htmlContenido += '      ' + val.precierre_Usuario;
                                                }

                                                htmlContenido += '  </td>';

                                                htmlContenido += '  <td rowspan="' + t + '"' + ' style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';

                                                if (is_PreCierre == 1){
                                                    htmlContenido += '      ' + val.precierre_FechaHora;
                                                }

                                                htmlContenido += '  </td>';

                                        }

                                    htmlContenido += '  <td id="td_iddetalle_' + i + '" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;" hidden>';
                                    htmlContenido += '      ' + val.ID_DETALLE;
                                    htmlContenido += '  </td>';

                                    htmlContenido += '  <td id="td_reabrir_' + i + '" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;" hidden>';
                                    htmlContenido += '      ' + val.is_reabrir;
                                    htmlContenido += '  </td>';

                                    htmlContenido += "</tr>";

                                    rowspan_analisis = val.Id;

                                    i += 1;
                                });
                            }
                            else{
                                alert("No se encontraron resultados para la búsqueda solicitada");

                                // Cerrando Modal
                                    $('#divmodal_Loading').modal('hide');
                            }

                            $("#tbl_MuestrasPreCierre").html(htmlContenido);
                            $("#lbl_TotalMuestras").html(i - 1);

                            // Obteniendo el promedio general por cada grupo de muestras
                                f_CalculaAllPromedios();

                            // Cerrando Modal
                                $('#divmodal_Loading').modal('hide');

                        }, "json");
            };

            function f_ExportToExcel(){
                // Obteniendo parámetros
                    var _estado = (($("#_SwitchEstado").prop('checked')) ? 1 : 0);
                    let fecha_inicio = $("#fecha_inicio").val();
                    let fecha_fin = $("#fecha_fin").val();

                    if (_estado == 0){
                        // Validando ingreso de fechas
                            if (fecha_inicio == null){
                                alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                                return;
                            }
                            if (fecha_inicio.length == 0){
                                alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                                return;
                            }

                            if (fecha_fin == null){
                                alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                                return;
                            }
                            if (fecha_fin.length == 0){
                                alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                                return;
                            }

                            if (fecha_fin < fecha_inicio){
                                alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

                                return;
                            }
                    }

                window.location.href = "send_to_excel/export_to_excel_analisishumedad.php?e=" + _estado + "&fi="+fecha_inicio+"&ff="+fecha_fin;
            };

            function f_ShowDatos(_id_detalle, _nom_muestra){
                var modal_loading = $("#divmodal_DetallesMuestra");

                // Seteando el Título
                    $("#lbl_TituloMuestra").html(_nom_muestra);

                $.get( "../lims_api/index.php", { accion: "get_DetalleMuestrasPreCierre_Humedad", id_detalle: _id_detalle },
                    function( data ) {
                        if(data.estado == 1){
                            $.each( data.registros, function( key, val ) {
                                $("#td_campo1").html(val.nom_rack);
                                $("#td_campo2").html(val.cod_estufa);
                                $("#td_campo3").html(val.des_estadosmuestra);
                                $("#td_campo4").html(val.num_horassecado);
                                $("#td_campo5").html(val.num_ensayos);
                                $("#td_campo6").html(val.des_rack);
                                $("#td_campo7").html(val.fechahora_cierrerack);
                                $("#td_campo8").html(val.usuario_cierrerack);

                                $("#td_pesohumedo_fecha").html(val.Fecha_PesoHumedo);
                                $("#td_pesohumedo_usuario").html(val.Usuario_PesoHumedo);
                                $("#td_pesoseco_fecha").html(val.Fecha_PesoSeco);
                                $("#td_pesoseco_usuario").html(val.Usuario_PesoSeco);

                                $("#td_InicioSecado").html(val.fechahora_iniciosecado);
                                $("#td_FinSecado").html(val.fechahora_finsecado_real);
                            });

                            modal_loading.modal();
                        }

                    }, "json");
            };
        </script>

        <!-- Funciones Secundarias -->
        <script type="text/javascript">
            $(function() {
                $('#_SwitchEstado').change(function() {
                    $("#chk_x").prop('checked', false);

                    if ($(this).prop('checked')){
                        // f_CerrarDiv('C', 'row_Titulo');
                        // f_CerrarDiv('C', 'row_Buscar');
                        f_CerrarDiv('A', 'chk_filtros');

                        $("#titulo_detalle").html('<b>Humedad</b> - Visualizando Muestras Pendientes de Pre Cierre');

                        f_LoadResultados(1);
                    }
                    else{
                        // f_CerrarDiv('A', 'row_Titulo');
                        // f_CerrarDiv('A', 'row_Buscar');
                        f_CerrarDiv('C', 'chk_filtros');

                        $("#titulo_detalle").html('<b>Humedad</b> - Visualizando Muestras Pre Cerradas');

                        f_LoadResultados(0);
                    }
                });
            });

            function f_OpenDetalleMuestra(_nom_muestra, _tipo_blanco, _factor_ag, _factor_au){
                var modal_loading = $("#divmodal_DetallesMuestra");

                // Coloca el Título
                    $("#lbl_TituloMuestra").html(_nom_muestra);

                // Agredando información al modal
                    $("#th_InfoTipoBlanco").html(_tipo_blanco);
                    $("#th_InfoFactorAg").html(_factor_ag);
                    $("#th_InfoFactorAu").html(_factor_au);

                modal_loading.modal();
            };

            function f_RowSelected(_tipo, _idrow_inicio, _idrow_total, _id_cabecera, _is_enabled){
                let nomcampo_Humedad = 'chkRow_Humedad_';
                let nomcampo_chk = 'chkRow_Selected_';
                let nomcampo_Prom = 'rowPromedio_Humedad_';
                let nomcampo_PreCierre = 'chkRow_PreCierre_';
                let promedio = 0;
                let total = 0;
                let conteo = 0;

                // Setea el prefijo de los campos a usar
                    nomcampo_Humedad = nomcampo_Humedad + _id_cabecera + '_';
                    nomcampo_chk = nomcampo_chk;
                    nomcampo_Prom = nomcampo_Prom;
                    nomcampo_PreCierre = nomcampo_PreCierre + _id_cabecera;

                // Realiza el bucle de búsqueda
                    let x = 1;
                    let nomcampo_Humedad_x = '';
                    let nomcampo_chk_x = '';

                    while (x <= _idrow_total){
                        nomcampo_Humedad_x = nomcampo_Humedad + _idrow_inicio;
                        nomcampo_chk_x = nomcampo_chk + _idrow_inicio;

                        // Buscando campos con Check
                            if (document.getElementById(nomcampo_chk_x).checked){
                                total += parseFloat($('#' + nomcampo_Humedad_x).html());

                                conteo += 1;
                            }

                        x += 1;
                        _idrow_inicio += 1;
                    }

                // Calcula el promedio
                    promedio = ((conteo == 0) ? '' : total / conteo);

                    if (conteo > 0){
                        promedio = parseFloat(promedio).toFixed(2);
                    }

                    $("#" + nomcampo_Prom + _id_cabecera).html(promedio);

                // Inhabilitando Check de Cierre
                    if (_is_enabled == 1){
                        if (conteo == 0){
                            $("#" + nomcampo_PreCierre).prop('checked', false);
                            $("#" + nomcampo_PreCierre).prop('disabled', 'true');
                        }
                        else{
                            $("#" + nomcampo_PreCierre).prop('disabled', '');
                        }
                    }
            };

            function f_CalculaAllPromedios(){
                let r = 1;
                let _id_cabecera = '';
                let _id_cabecera_r = '';
                let tiene_pendiente = 0;
                var is_reabrir = 0;

                let _sum = 0;
                let _count = 0;
                let _countx = 0;
                let _prom = 0;

                $('#tbl_MuestrasPreCierre tr').each(function () {
                    _id_cabecera_r = $(this).attr('id');
                    is_reabrir = $("#td_reabrir_" + r).html().trim();

                    // Comprueba si trae Promedio por Pre Cierre
                        if ($("#rowPromedio_Humedad_" + _id_cabecera_r).html().trim().length == 0){
                            if (_id_cabecera != _id_cabecera_r){
                                // if (r != 1){
                                    _prom = parseFloat(_sum / _count).toFixed(2);

                                    if (!isNaN(_prom)){
                                        $("#rowPromedio_Humedad_" + _id_cabecera).html(_prom);
                                        
                                        $("#reanalisis_" + (r - _countx)).prop('disabled', false);
                                        $("#row_Comentario_" + _id_cabecera).prop('disabled', false);
                                        $("#chkRow_PreCierre_" + _id_cabecera).prop('disabled', false);
                                        $("#chkRow_PreCierre_" + _id_cabecera).prop('checked', true);

                                        if (_count >= 3 || tiene_pendiente == 1 || is_reabrir == 1){
                                            $("#chkRow_PreCierre_" + _id_cabecera).prop('checked', false);
                                        }

                                        tiene_pendiente = 0;
                                    }
                                    else{
                                        $("#chkRow_PreCierre_" + _id_cabecera).prop('checked', false);
                                    }

                                    // if (_count >= 2){
                                    //     $("#chkRow_PreCierre_" + _id_cabecera).prop('checked', false);
                                    // }
                                // }

                                if ($(this).find("td").eq(8).html().trim() == 'PENDIENTE' || parseFloat($(this).find("td").eq(8).html()) <= 0 || $(this).find("td").eq(8).html().trim().length == 0){

                                    $("#chkRow_Selected_" + r).prop('checked', false);
                                    $("#chkRow_Selected_" + r).prop('disabled', true);

                                    _sum = 0;
                                    _count = 0;
                                    _countx = 1;

                                    tiene_pendiente = 1;
                                }
                                else{
                                    _sum = parseFloat($(this).find("td").eq(8).html());

                                    _count = 1;
                                    _countx = 1;
                                }

                                _id_cabecera = _id_cabecera_r;
                            }
                            else{
                                if ($(this).find("td").eq(8).html().trim() == 'PENDIENTE' || parseFloat($(this).find("td").eq(8).html()) <= 0 || $(this).find("td").eq(8).html().trim().length == 0){

                                    $("#chkRow_Selected_" + r).prop('checked', false);
                                    $("#chkRow_Selected_" + r).prop('disabled', true);

                                    tiene_pendiente = 1;
                                }
                                else{

                                    _sum += parseFloat($(this).find("td").eq(8).html());

                                    _count += 1;
                                }

                                _countx += 1;
                            }
                        }
                        else{
                            _prom = parseFloat(_sum / _count).toFixed(2);

                            if (!isNaN(_prom)){
                                $("#rowPromedio_Humedad_" + _id_cabecera).html(_prom);
                            }

                            if (_count >= 2 || tiene_pendiente == 1 || is_reabrir == 1){
                                $("#chkRow_PreCierre_" + _id_cabecera).prop('checked', false);
                            }

                            tiene_pendiente = 0;
                        }

                    r += 1;
                });

                // Pinta el último promedio
                    if ($("#rowPromedio_Humedad_" + _id_cabecera_r).html().trim().length == 0){
                        _prom = parseFloat(_sum / _count).toFixed(2);
                        _prom = ((isNaN(_prom)) ? '' : _prom);

                        $("#rowPromedio_Humedad_" + (r - _countx)).html(_prom);

                        $("#reanalisis_" + (r - _countx)).prop('disabled', false);
                        $("#row_Comentario_" + (r - _countx)).prop('disabled', false);
                        $("#chkRow_PreCierre_" + (r - _countx)).prop('disabled', false);
                        $("#chkRow_PreCierre_" + (r - _countx)).prop('checked', true);

                        if (_count == 0 || _count >= 2 || tiene_pendiente == 1 || is_reabrir == 1){
                            $("#chkRow_PreCierre_" + (r - _countx)).prop('checked', false);
                        }
                    }
            };
        </script>

        <!-- Funciones para Grabar -->
        <script type="text/javascript">
            function f_PreCierre(){
                let i = 1;
                let nomcampo_PreCierreProm = 'rowPromedio_Humedad_';
                let nomcampo_PreCierre = 'chkRow_PreCierre_';
                let nomcampo_Selected = 'chkRow_Selected_';
                let nomcampo_PreCierreProm_x = '';
                let nomcampo_PreCierre_x = '';
                let nomcampo_Selected_x = '';
                var _id_cabecera = '';
                var _id_cabecera_x = '';
                let Promedio = 0;
                var Comentario = '';
                var id_pedido = 0;
                let finish = 0;
                let finish_x = 1;
                let arr_PreCierre = [];

                if (!confirm("¿Está seguro de iniciar con el Pre Cierre de las muestras seleccionadas?")){
                    return;
                }

                // Obtiene el total de filas
                    finish = $('#tbl_MuestrasPreCierre tr').length;
                    // finish = finish * 2;

                $('#tbl_MuestrasPreCierre tr').each(function () {
                    _id_cabecera = $(this).attr('id');

                    // // Loading Modal
                    //     let modal_loading = $("#divmodal_Loading");
                    //     modal_loading.modal({backdrop: 'static', keyboard: false});

                    // Busca los Checks de Pre Cierres
                        if (_id_cabecera_x != _id_cabecera){
                            nomcampo_PreCierre_x = nomcampo_PreCierre + _id_cabecera;
                            nomcampo_PreCierreProm_x = nomcampo_PreCierreProm + _id_cabecera;

                            Promedio = $("#" + nomcampo_PreCierreProm_x).html().trim();
                            Comentario = $("#row_Comentario_" + _id_cabecera).val().trim();
                            Id_Pedido = $("#txt_idpedido_" + i).val();
                            Id_Detalle = $("#txt_iddetalle_" + i).val();

                            if ($("#" + nomcampo_PreCierre_x).prop('checked')){
                                arr_PreCierre.push($("#td_iddetalle_" + i).html().trim());

                                // Guarda los datos de Pre Cierre
                                    $.get( "../lims_api/index.php", { accion: "grabar_PreCierre_Humedad", id_cabecera: _id_cabecera, promedio: Promedio, comentario: Comentario, id_pedido: Id_Pedido, id_detalle: Id_Detalle},
                                        function( data ) {
                                            if(data.estado != 1){
                                                alert("Ocurrió un error al momento de grabar el Pre Cierre.\n\nCódigo de error: " + _id_cabecera);
                                            }
                                            else{
                                                // // Cerrando Modal
                                                //     $('#divmodal_Loading').modal('hide');
                                            }

                                        }, "json");
                            }
                        }

                        _id_cabecera_x = _id_cabecera;

                    i += 1;
                });

                // Valida que haya al menos un Check de Pre Cierre
                    if (arr_PreCierre.length == 0){
                        alert('No se encontraron registros con Check de Pre Cierre');

                        // Cerrando Modal
                            $('#divmodal_Loading').modal('hide');

                        return;
                    }

                // Busca los Checks para el cálculo de Promedios y Conf.
                    i = 1;

                    $('#tbl_MuestrasPreCierre tr').each(function () {
                        var r = 1;
                        var is_Checked = 0;
                        let _id_detalle = $("#td_iddetalle_" + i).html().trim();

                        is_Checked = 0;
                        nomcampo_Selected_x = nomcampo_Selected + i;

                        if ($("#" + nomcampo_Selected_x).prop('checked')){
                            is_Checked = 1;
                        }

                        // Guarda los datos de Checks
                            $.get( "../lims_api/index.php", { accion: "grabar_PreCierreItemSelected_Humedad", id_detalle: _id_detalle, is_checked: is_Checked },
                                function( data ) {
                                    if(data.estado != 1){
                                        alert("Ocurrió un error al momento de grabar el estado de Checks de los Item.\n\nCódigo de error: " + i + '|' + _id_detalle);
                                    }
                                    else{
                                        if (finish == finish_x){
                                            f_LoadResultados(1);
                                        }

                                        finish_x += 1;
                                    }

                                    // // Cerrando Modal
                                    //     $('#divmodal_Loading').modal('hide');

                                }, "json");

                        // _id_cabecera_x = _id_cabecera;

                        i += 1;
                    });
            };

            function f_Reabrir( _id_detalle, _Id_Pedido, _Id_DetallePedido){
                if (!confirm("¿Está seguro de reabrir el Pre Cierre de la muestra seleccionada?")){
                    return;
                }

                $.get( "../lims_api/index.php", { accion: "reabrir_PreCierre_Humedad", id_detalle: _id_detalle, id_pedido: _Id_Pedido, id_detallepedido: _Id_DetallePedido },
                    function( data ) {
                        if(data.estado != 1){
                            alert("Ocurrió un error al momento de grabar el Reabrir el Pre Cierre.\n\nCódigo de error: " + _id_detalle);
                        }
                        else{
                            f_LoadResultados(1);
                        }

                    }, "json");
            };
        </script>

        <!-- Otras Funciones -->
        <script type="text/javascript">
            $(document).ajaxStart(function() {
                // Loading Modal
                var modal_loading = $("#divmodal_Loading");
                modal_loading.modal({backdrop: 'static', keyboard: false});
            });

            $(document).ajaxStop(function() {
                // Cerrando Modal
                $('#divmodal_Loading').modal('hide');
            });

            function f_cerrarModal(pantalla_modal){
                if (pantalla_modal == 1){
                    $('#divmodal_DetallesMuestra').modal('hide');
                }
                if (pantalla_modal == 2){
                    $('#divmodal_DetallesRack').modal('hide');
                }
                if (pantalla_modal == 3){
                    $('#divmodal_DetallesMuestra').modal('hide');
                }
            };

            function f_CerrarDiv(accion, nom_div){
                var _div = document.getElementById(nom_div);

                if (accion == 'A'){
                    _div.style.display = 'block'
                }
                else{
                     _div.style.display = 'none';
                }
            };

            // Limpia los datos al momento de Realizar la búsqueda de resultados
            function f_Limpiar(){
                // // Detalles del Rack
                //     $("#lblRack_totalmuestras").html('');
                //     $("#lblRack_usuario").html('');
                //     $("#lblRack_fechahora").html('');
                //     $("#lblRack_horno").html('');
                //     $("#lblRack_observacion").html('');
                //     document.getElementById('lblRack_observacion').title = '';

                // Grilla de Detalles de Rack
                    $("#tbl_DetalleMuestras").html('');
            }

            // Permite obtener el nombre de cada mes
            function nombre_meses(_num_mes){
                if (_num_mes == 1){
                    return "ENERO";
                }
                if (_num_mes == 2){
                    return "FEBRERO";
                }
                if (_num_mes == 3){
                    return "MARZO";
                }
                if (_num_mes == 4){
                    return "ABRIL";
                }
                if (_num_mes == 5){
                    return "MAYO";
                }
                if (_num_mes == 6){
                    return "JUNIO";
                }
                if (_num_mes == 7){
                    return "JULIO";
                }
                if (_num_mes == 8){
                    return "AGOSTO";
                }
                if (_num_mes == 9){
                    return "SEPTIEMBRE";
                }
                if (_num_mes == 10){
                    return "OCTUBRE";
                }
                if (_num_mes == 11){
                    return "NOVIEMBRE";
                }
                if (_num_mes == 12){
                    return "DICIEMBRE";
                }
            }

            // Detecta la tecla ESCAPE
            document.addEventListener('keyup', function(e) {
                if (e.keyCode == 27) {
                    f_cerrarModal(1);
                    f_cerrarModal(2);
                    f_cerrarModal(3);
                }
            });
        </script>

    </body>
</html>

<?php
    cerrarSesion($enlace);
?>