<?php

	include('../../php/conn.php');

	require_once 'dompdf/autoload.inc.php';
	use Dompdf\Dompdf;

	$IdPedido = $_GET["Id"];

	function nombre_numeros($_numero){
		// Determinando la cantidad de dígitos
			$digitos = strlen($_numero);

		// Descomponiendo números
			$entero = substr($_numero, 0, strpos($_numero, '.'));
			$decimal = substr($_numero, strpos($_numero, '.') + 1);

			$digitos = strlen($entero);

			// Unidad
				if ($digitos >= 1){
					$unidad = substr($entero, -1);

					$unidad = (($unidad == 0) ? '' : $unidad);

					if ($unidad == 1){
						$unidad = 'uno';
					}
					if ($unidad == 2){
						$unidad = 'dos';
					}
					if ($unidad == 3){
						$unidad = 'tres';
					}
					if ($unidad == 4){
						$unidad = 'cuatro';
					}
					if ($unidad == 5){
						$unidad = 'cinco';
					}
					if ($unidad == 6){
						$unidad = 'seis';
					}
					if ($unidad == 7){
						$unidad = 'siete';
					}
					if ($unidad == 8){
						$unidad = 'ocho';
					}
					if ($unidad == 9){
						$unidad = 'nueve';
					}
				}

			// Decena entre 11 y 19
				if ($digitos >= 2){
					$decena = substr($entero, -2);

					if ($decena >= 10 && $decena <= 19){
						$unidad = '';

						if ($decena == 10){
							$decena = 'Diez';
						}
						if ($decena == 11){
							$decena = 'Once';
						}
						if ($decena == 12){
							$decena = 'Doce';
						}
						if ($decena == 13){
							$decena = 'Trece';
						}
						if ($decena == 14){
							$decena = 'Catorce';
						}
						if ($decena == 15){
							$decena = 'Quince';
						}
						if ($decena == 16){
							$decena = 'Dieciseis';
						}
						if ($decena == 17){
							$decena = 'Diecisiete';
						}
						if ($decena == 18){
							$decena = 'Dieciocho';
						}
						if ($decena == 19){
							$decena = 'Diecinueve';
						}
					}
					else{ // Decenas
						$decena = substr(substr($entero, -2), 0, 1);

						$decena = (($decena == 0) ? '' : $decena);

						if ($decena == 2){
							if (strlen($unidad) == 0){
								$decena = 'Veinte';
							}
							else{
								$decena = 'Veinti';
							}
						}
						if ($decena == 3){
							if (strlen($unidad) == 0){
								$decena = 'Treinta';
							}
							else{
								$decena = 'Treinta y ';
							}
						}
						if ($decena == 4){
							if (strlen($unidad) == 0){
								$decena = 'Cuarenta';
							}
							else{
								$decena = 'Cuarenta y ';
							}
						}
						if ($decena == 5){
							if (strlen($unidad) == 0){
								$decena = 'Cincuenta';
							}
							else{
								$decena = 'Cincuenta y ';
							}
						}
						if ($decena == 6){
							if (strlen($unidad) == 0){
								$decena = 'Sesenta';
							}
							else{
								$decena = 'Sesenta y ';
							}
						}
						if ($decena == 7){
							if (strlen($unidad) == 0){
								$decena = 'Setenta';
							}
							else{
								$decena = 'Setenta y ';
							}
						}
						if ($decena == 8){
							if (strlen($unidad) == 0){
								$decena = 'Ochenta';
							}
							else{
								$decena = 'Ochenta y ';
							}
						}
						if ($decena == 9){
							if (strlen($unidad) == 0){
								$decena = 'Noventa';
							}
							else{
								$decena = 'Noventa y ';
							}
						}
					}
				}

			// Centenas
				if ($digitos >= 3){
					$centena = substr(substr($entero, -3), 0, 1);

					$centena = (($centena == 0) ? '' : $centena);

					if ($centena == 1){
						if ($entero == 100){
							$centena = 'Cien ';
						}
						else{
							$centena = 'Ciento ';
						}
					}
					if ($centena == 2){
						$centena = 'Doscientos ';
					}
					if ($centena == 3){
						$centena = 'Trescientos ';
					}
					if ($centena == 4){
						$centena = 'Cuatrocientos ';
					}
					if ($centena == 5){
						$centena = 'Quinientos ';
					}
					if ($centena == 6){
						$centena = 'Seiscientos ';
					}
					if ($centena == 7){
						$centena = 'Setecientos ';
					}
					if ($centena == 8){
						$centena = 'Ochocientos ';
					}
					if ($centena == 9){
						$centena = 'Novecientos ';
					}
				}

			// Millares
				if ($digitos >= 5){
					$millar = substr(substr($entero, -5), 0, 1);

					$millar = (($millar == 0) ? '' : $millar);

					if ($millar == 1){
						$millar = 'Mil ';
					}
					if ($millar == 2){
						$millar = 'Dos mil ';
					}
					if ($millar == 3){
						$millar = 'Tres mil ';
					}
					if ($millar == 4){
						$millar = 'Cuatro mil ';
					}
					if ($millar == 5){
						$millar = 'Cinco mil ';
					}
					if ($millar == 6){
						$millar = 'Seis mil ';
					}
					if ($millar == 7){
						$millar = 'Siete mil ';
					}
					if ($millar == 8){
						$millar = 'Ocho mil ';
					}
					if ($millar == 9){
						$millar = 'Nueve mil ';
					}
				}

		$entero = $millar.$centena.$decena.$unidad.' y '.$decimal.'/100 Soles';

		return $entero;
	}

	// Obteniendo el Correlativo del recibo
		$des_comprobante = '';
		$is_factura = 0;

		$q_correlativo = "SELECT Id_Comprobante,
								 Serie_Comprobante,
								 Correlativo_Comprobante
							FROM _max_labperu_ComprobantesVenta
						   WHERE Id_Pedido = ".$_GET["Id"];

		if ($res_correlativo = sqlsrv_query($enlacehost, $q_correlativo)) {
			while($row_correlativo = sqlsrv_fetch_array($res_correlativo)) {
				$des_comprobante = (($row_correlativo["Id_Comprobante"] == 1001) ? 'FACTURA' : 'BOLETA');
				$correlativo = $row_correlativo["Serie_Comprobante"].'-'.str_pad($row_correlativo["Correlativo_Comprobante"], 8, '0', STR_PAD_LEFT);

				$is_factura = (($row_correlativo["Id_Comprobante"] == 1001) ? 1 : 0);
			}
		}

	$html = '<!DOCTYPE html>
			<html lang="es">
				<head>
			        <title>Comprobante: '.$correlativo.'</title>

					<style type="text/css">
				        html {
							margin: 0;
						}
						body {
							font-family: "Times New Roman", Times, serif;
						}
					</style>
			    </head>

				<body class="nav-md" style="background-color: #ffffff" onload="print_document(); zoom: 200%">
					<div class="container body" style="font-size: 3.5px; color: #000000">
						<br/>
						<div class="row" style="text-align: center;">
							<img src="images/logos/logo_nuevo.png" width="45mm"/>
						</div>
						<div class="row">
							<center>
								LAB PERU MINERALS S.R.L.
							</center>
						</div>
						<div class="row">
							<center>
								R.U.C.: 20603214456
							</center>
						</div>
						<div class="row">
							<center>
								CAL. LAS TURMALINAS NRO. 969 URB. LOS
							</center>
						</div>
						<div class="row">
							<center>
								CEDROS, TRUJILLO, TRUJILLO, LA LIBERTAD
							</center>
						</div>
						<div class="row">
							<center>
								TELF.: 044 - 755106 / 992760302
							</center>
						</div>
						<div class="row">
							<center>
								Email: atencionalcliente@labperuminerals.com.pe
							</center>
						</div>

						<div class="row" style="margin-top: 1.2mm">
							<center>
								'.$des_comprobante.'
							</center>
						</div>';

		$html .= '		<div class="row">
							<center>
								'.$correlativo.'
							</center>
						</div>';

	// Recuperando los datos del recibo (Cabecera)
		$q_cabecera = "SELECT CONVERT(VARCHAR, FechaHora_Recepcion, 120) AS FechaHora_Recepcion,
							  CONVERT(VARCHAR, FechaHora_Entrega, 120) AS FechaHora_Entrega,
							  CL.cRazonSocial,
							  CL.cNumeroTelefono + ' / ' + CL.cSegundoNumeroTelefono AS TELEFONO,
							  CL.cDireccion,
							  CL.cEmail,
							  S.des_sucursal,
							  MP.des_mediopago,
							  C.Mostrar_Precio,
							  C.Incluir_IGV,
							  P.Observacion_Recibo,
							  C.reporte_fisico,
							  C.reporte_wsp,
							  C.reporte_mail,
							  CL.cNumeroRuc,
							  CONVERT(VARCHAR, CV.Fecha_Generacion, 103) + ' ' + CONVERT(VARCHAR, CV.Fecha_Generacion, 108) AS Fecha_Generacion,
							  _CV.iId_Forma_pago,
							  TFP.cDescripcion_FormaPago,
							  _CV.iId_Cabecera_Venta
						 FROM _max_labperu_CabeceraPedido C
							  LEFT JOIN maestroCliente CL ON CL.iIdCliente = C.iIdCliente
							  LEFT JOIN _max_labperu_Sucursales S ON S.Id = C.Sucursal
							  LEFT JOIN _max_labperu_PagoVenta P ON P.Id_Pedido = C.Id_Pedido
							  LEFT JOIN _max_labperu_MedioPago MP ON MP.Id = P.Id_MedioPago
							  LEFT JOIN _max_labperu_ComprobantesVenta CV ON CV.Id_Pedido = C.Id_Pedido
							  LEFT JOIN Cabecera_Venta _CV ON _CV.iId_Cabecera_Pedido = C.Id_Pedido
							  LEFT JOIN Tipo_FormaPago TFP ON TFP.iId_forma_pago = _CV.iId_Forma_pago
						WHERE C.Id_Pedido = ".$_GET["Id"];

		if ($res_cabecera = sqlsrv_query($enlacehost, $q_cabecera)) {
			while($row_cabecera = sqlsrv_fetch_array($res_cabecera)) {
				$fecha_recepcion = $row_cabecera["FechaHora_Recepcion"];
				$fecha_entrega = $row_cabecera["FechaHora_Entrega"];
				$cliente = $row_cabecera["cRazonSocial"];
				$telefono = $row_cabecera["TELEFONO"];
				$direccion = $row_cabecera["cDireccion"];
				$mail = $row_cabecera["cEmail"];
				$sucursal = $row_cabecera["des_sucursal"];
				$medio_pago = $row_cabecera["des_mediopago"];
				$mostrar_precio = $row_cabecera["Mostrar_Precio"];
				$incluir_igv = $row_cabecera["Incluir_IGV"];
				$observacion_recibo = $row_cabecera["Observacion_Recibo"];
				$reporte_fisico = $row_cabecera["reporte_fisico"];
				$reporte_wsp = $row_cabecera["reporte_wsp"];
				$reporte_mail = $row_cabecera["reporte_mail"];
				$ruc_cliente = $row_cabecera["cNumeroRuc"];
				$fecha_generacion = $row_cabecera["Fecha_Generacion"];
				$cod_formapago = $row_cabecera["iId_Forma_pago"];
				$des_formapago = $row_cabecera["cDescripcion_FormaPago"];
				$id_cabeceraventa = $row_cabecera["iId_Cabecera_Venta"];
			}
		}

		// MAX (11/08/2021 14:07): Johnnie Peralta solicitó cambiar el formato de cabecera
			// $html .= '		<div style="margin-left: 1.5mm; margin-top: 1.2mm">
			// 					<div class="row">
			// 						F. Ingreso  : '.$fecha_recepcion.'
			// 					</div>
			// 					<div class="row">
			// 						Cliente     : '.strtoupper($cliente).'
			// 					</div>
			// 					<div class="row">
			// 						RUC     : '.$ruc_cliente.'
			// 					</div>
			// 					<div class="row">
			// 						Direccion     : '.$direccion.'
			// 					</div>
			// 					<div class="row">
			// 						Sucursal   : '.strtoupper($sucursal).'
			// 					</div>';

			$html .= '		<div style="margin-left: 1.5mm; margin-top: 1.2mm">
								<div class="row">
									F. Emisión  : '.$fecha_generacion.'
								</div>
								<div class="row">
									Cliente     : '.strtoupper($cliente).'
								</div>
								<div class="row">
									RUC     : '.$ruc_cliente.'
								</div>
								<div class="row">
									Direccion     : '.$direccion.'
								</div>
								<div class="row">
									Sucursal   : '.strtoupper($sucursal).'
								</div>';

		if ($is_factura == 1){
			$html .= '			<div class="row">
									Tipo Pago   : '.strtoupper($des_formapago).'
								</div>';

			// MAX (19/10/2021 00:26): Obteniendo la fecha de Vencimiento
				$q_fechavencimiento = "SELECT CONVERT(VARCHAR, dFecha_vencimiento, 103) AS dFecha_vencimiento
										 FROM Cabecera_Venta
                                        WHERE iId_Cabecera_Pedido = ".$_GET["Id"];

                if ($res_fechavencimiento = sqlsrv_query($enlacehost, $q_fechavencimiento)) {
					while($row_fechavencimiento = sqlsrv_fetch_array($res_fechavencimiento)) {
						$html .= '			<div class="row">
												Fecha Vto.   : '.$row_fechavencimiento["dFecha_vencimiento"].'
											</div>';
					}
				}
		}

		if (strlen($observacion_recibo) > 0){
			$html .= '			<div class="row">
									Observación   : '.strtoupper($observacion_recibo).'
								</div>';
		}

		$html .= '		</div>';

	// Recuperando los datos del recibo (Detalle)
		$html .= '		<div style="margin-left: 1.5mm; margin-top: 1.2mm">';

		$q_detalle = "	SELECT	dTotal_Gravado,
								dTotal_Igv,
								dTotal_Bruto_Venta,
								iNum_Item,
								cProductName,
								dPrecio_Neto
						  FROM	Cabecera_Venta CV
								INNER JOIN Detalle_Venta DV ON CV.iId_Cabecera_Venta = DV.iIdCabecera_Venta
						 WHERE	CV.iId_Cabecera_Pedido = ".$_GET["Id"]."
						   AND 	CV.permitir_anular = 0";

		if ($res_detalle = sqlsrv_query($enlacehost, $q_detalle)) {
			$html .= '			<table style="width: 95%; border-spacing: -0.5px -0.5px;">
		                            <tr style="border: solid; border-width: 0.1mm; border-color: #000000;">
		                                <th style="border: solid; border-width: 0.1mm; border-color: #000000; width: 3%"><center>
		                                    Item
		                                </center></th>
		                                <th style="border: solid; border-width: 0.1mm; border-color: #000000;"><center>
		                                    Descripción
		                                </center></th>
		                                <th style="border: solid; border-width: 0.1mm; border-color: #000000; width: 10%"><center>
		                                    Importe (S/)
		                                </center></th>
		                     		</tr>';

			while($row_detalle = sqlsrv_fetch_array($res_detalle)) {
				$html .= '				<tr>';
				$html .= '					<td style="border: dotted; border-width: 0.1mm; border-color: #000000;"><center>';
				$html .= '						'.$row_detalle["iNum_Item"];
				$html .= '					</center></td>';
				$html .= '					<td style="border: dotted; border-width: 0.1mm; border-color: #000000;">';
				$html .= '						'.$row_detalle["cProductName"];
				$html .= '					</td>';
				$html .= '					<td style="text-align: right; border: dotted; border-width: 0.1mm; border-color: #000000;">';
				$html .= '						'.number_format($row_detalle["dPrecio_Neto"], 2, '.', ',');
				$html .= '					</td>';
				$html .= '				</tr>';

				$gravada = number_format($row_detalle["dTotal_Gravado"], 2, '.', ',');
				$igv = number_format($row_detalle["dTotal_Igv"], 2, '.', ',');
				$total = number_format($row_detalle["dTotal_Bruto_Venta"], 2, '.', ',');
			}

			$html .= '			</table>';
		}

		$html .= '		</div>';

	// Agregando el total de la venta
		$son = nombre_numeros($total);
		$cero = number_format(0, 2, '.', ',');

		$html .= '		<div style="margin-left: 1mm; margin-top: 3px; padding-right: 0.5mm">';
		$html .= '			<table style="width: 98%; border-spacing: 0px 0px;">
								<tr>
									<th style="width: 90%">
										Sub Total (S/):
									</th>
									<th style="text-align: right">'.$gravada.'
									</th>
								</tr>
								<tr>
									<th style="width: 90%">
										Gravada (S/):
									</th>
									<th style="text-align: right">'.$gravada.'
									</th>
								</tr>
								<tr>
									<th style="width: 90%">
										Inafecta (S/):
									</th>
									<th style="text-align: right">'.$cero.'
									</th>
								</tr>
								<tr>
									<th style="width: 90%">
										Exonerada (S/):
									</th>
									<th style="text-align: right">'.$cero.'
									</th>
								</tr>
								<tr>
									<th style="width: 90%">
										Gratuita (S/):
									</th>
									<th style="text-align: right">'.$cero.'
									</th>
								</tr>
								<tr>
									<th style="width: 90%">
										Descuento (S/):
									</th>
									<th style="text-align: right">'.$cero.'
									</th>
								</tr>
								<tr>
									<th style="width: 90%">
										ISC (S/):
									</th>
									<th style="text-align: right">'.$cero.'
									</th>
								</tr>
								<tr>
									<th style="width: 90%">
										I.G.V. 18% (S/):
									</th>
									<th style="text-align: right">'.$igv.'
									</th>
								</tr>
								<tr>
									<th style="width: 90%">
										Importe Total (S/):
									</th>
									<th style="text-align: right">'.$total.'
									</th>
								</tr>
								<tr colspan = "2">
									<th style="vertical-align: bottom;">
										Son: '.$son.'

									</th>
								</tr>
							</table>
						</div>';

	// si es Crédito se deben mostrar las cuotas
		if ($cod_formapago == 2){
			$html .= '			<div style="margin-left: 0.5mm"><center>
									..............................................................................................
								</center></div>
								<div style="margin-top: 0.5mm; margin-left: 0.6mm"><center>
									DETALLE DE CUOTAS
								</center></div>';

			$html .= '			<div style="margin-left: 1.5mm; margin-top: 0.8mm">
									<table style="width: 95%; border-spacing: -0.5px -0.5px;">
			                            <tr style="border: solid; border-width: 0.1mm; border-color: #000000;">
			                                <th style="border: solid; border-width: 0.1mm; border-color: #000000; width: 3%"><center>
			                                    N°
			                                </center></th>
			                                <th style="border: solid; border-width: 0.1mm; border-color: #000000; width: 40%"><center>
			                                    Fecha Vto.
			                                </center></th>
			                                <th style="border: solid; border-width: 0.1mm; border-color: #000000; width: 48%"><center>
			                                    Monto (S/)
			                                </center></th>
			                     		</tr>';

			// Armando el detalle de Cuotas
				$q_cuotas = "SELECT iNumero_Couta, CONVERT(VARCHAR, dFecha_Pago, 103) as dFecha_Pago, dMonto
							   FROM Detalle_VentaCoutas
							  WHERE iId_Cabecera_Venta = ".$id_cabeceraventa;

				if ($res_cuotas = sqlsrv_query($enlacehost, $q_cuotas)) {
					while($row_cuotas = sqlsrv_fetch_array($res_cuotas)) {
						$html .= '				<tr>';
						$html .= '					<td style="border: dotted; border-width: 0.1mm; border-color: #000000; text-align: center;">';
						$html .= '						'.$row_cuotas["iNumero_Couta"];
						$html .= '					</td>';
						$html .= '					<td style="border: dotted; border-width: 0.1mm; border-color: #000000; text-align: center;">';
						$html .= '						'.$row_cuotas["dFecha_Pago"];
						$html .= '					</td>';
						$html .= '					<td style="text-align: right; border: dotted; border-width: 0.1mm; border-color: #000000; text-align: center;">';
						$html .= '						'.number_format($row_cuotas["dMonto"], 2, '.', ',');
						$html .= '					</td>';
						$html .= '				</tr>';
					}

					$html .= '			</table>';
				}

			$html .= '			</div>';
		}

		// Finalizando html
			$html .= '			<div style="margin-left: 0.5mm"><center>
									..............................................................................................
								</center></div>
								<div style="margin-top: 0.5mm; margin-left: 0.6mm"><center>
									"LA CUSTODIA DE LAS CONTRAMUESTRAS ES DE 20 DÍAS CALENDARIO"
								</center></div>
						</div>
					</body>
				  </html>';

	// $options = new Options();
	// $options -> set('enable-javascript', TRUE);

	// $document = new Dompdf($options);
	$document = new Dompdf();

	$document -> loadHtml($html,'UTF-8');
	$document -> setPaper(array(0, 0, 80, 297));
	$document -> render();
	$document -> stream("Comprobante ".$correlativo, array('Attachment' => 0));

?>
