<?php

	include('../../php/conn.php');
  	include('libs/barcode.php');

	require_once 'dompdf/autoload.inc.php';

	use Dompdf\Dompdf;
	use Dompdf\Options;

	// Ruta para imágenes
	  $ruta = 'http://localhost/lims.labperu/panel/usuario/';

	$cod_interno = $_GET["CI"];
	$fecha_recepcion = $_GET["FR"];
	$elemento_analisis = $_GET["EA"];
	$tipo_analisis = $_GET["TA"];

	// Gnera ls códigos de barra
		// barcode( 'images/bc/'.$cod_interno.'.png', $cod_interno, 20, 'horizontal', 'code39', false );
	// barcode( 'images/bc/'.$cod_interno.'.png', substr($cod_interno, 6), 20, 'horizontal', 'code39', false );
	barcode( 'images/bc/'.$cod_interno.'.png', substr($cod_interno, 6), 20, 'horizontal', 'code128', false );
	// barcode( 'images/bc/'.$cod_interno.'.png', "*´+}{,.-*", 20, 'horizontal', 'code39', false );
	// barcode( 'images/bc/'.$cod_interno.'.png', "*".'?¡][;:_'."*", 20, 'horizontal', 'code39', false );
	// barcode( 'images/bc/'.$cod_interno.'.png', str_replace('-', '', $cod_interno), 20, 'horizontal', 'code128', false );

// echo substr($cod_interno, 6);

	$html = '<!DOCTYPE html>
			<html lang="es">
				<head>
			        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
			        <meta charset="utf-8">
			        <meta http-equiv="X-UA-Compatible" content="IE=edge">
			        <meta name="viewport" content="width=device-width, initial-scale=1">

			        <title>Impresión de Etiquetas</title>

			        <!-- Bootstrap -->
			        <link href="../vendors/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">

					<style type="text/css">
				        html {
							margin: 0;
						}
						body {
							font-family: "Times New Roman", Times, serif;
						}
					</style>
			    </head>

				<body class="nav-md" style="background-color: #ffffff" onload="print_document();">
					<div class="container body" style="font-size: 8.2px; color: #000000">
						<table style="width: 100%; border-spacing: 0px;">
							<tr>
								<td style="text-align: center; width: 100%;">
									<b style="font-size: 18px;">'.$cod_interno.'</b>
								</td>

								<td style="text-align: center; width: 100%;">
									<b style="font-size: 18px;">'.$cod_interno.'</b>
								</td>
							</tr>

							<tr>
								<td style="text-align: center; width: 100%;">
									<label style="font-size: 12px;">'.$fecha_recepcion.'</label>
								</td>

								<td style="text-align: center; width: 100%;">
									<label style="font-size: 12px;">'.$fecha_recepcion.'</label>
								</td>
							</tr>

							<tr>
								<td style="text-align: center; width: 100%;">
									<b><label style="font-size: 13px;">'.$elemento_analisis.'</label></b>
								</td>

								<td style="text-align: center; width: 100%;">
									<b><label style="font-size: 13px;">'.$elemento_analisis.'</label></b>
								</td>
							</tr>

							<tr>
								<td style="text-align: center; width: 100%;">
									<img src="'.$ruta.'images/bc/'.$cod_interno.'.png" style="width: 180px;"/>
								</td>

								<td style="text-align: center; width: 100%;">
									<img src="'.$ruta.'images/bc/'.$cod_interno.'.png" style="width: 180px;"/>
								</td>
							</tr>

							<tr>
								<td style="text-align: center; width: 100%;">
									<label style="font-size: 10px;">'.$tipo_analisis.'</label>
								</td>

								<td style="text-align: center; width: 100%;">
									<label style="font-size: 10px;">'.$tipo_analisis.'</label>
								</td>
							</tr>
						</table>
					</div>
				</body>
			  </html>';

	//Inicializando PDF
		$options = new Options();
		$options->set('isRemoteEnabled', TRUE);
		$document = new Dompdf($options);

	$document -> loadHtml($html,'UTF-8');
	$document -> setPaper(array(0, 0,340, 75), 'portrait');
	$document -> render();
	$document -> stream("Recibo", array('Attachment' => 0));


?>
