<?php
	
	session_start();

	include('../../php/conn.php');

	if(!isset($_SESSION["id"])){
		header('Location: index.php');
	}

	mysqli_query($enlace, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");
	mysqli_query($enlacehost, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");

?>

<!DOCTYPE html>
<html lang="es">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<!-- Meta, title, CSS, favicons, etc. -->
		<meta charset="utf-8">
		<meta http-equiv="X-UA-Compatible" content="IE=edge">
		<meta name="viewport" content="width=device-width, initial-scale=1">

		<title>LIMS | Resumen de Pesos AAS</title>

		<!-- Bootstrap -->
		<link href="../vendors/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
		<!-- Font Awesome -->
		<link href="../vendors/font-awesome/css/font-awesome.min.css" rel="stylesheet">
		<!-- NProgress -->
		<link href="../vendors/nprogress/nprogress.css" rel="stylesheet">
		<!-- iCheck -->
		<link href="../vendors/iCheck/skins/flat/green.css" rel="stylesheet">
		<!-- bootstrap-progressbar -->
		<link href="../vendors/bootstrap-progressbar/css/bootstrap-progressbar-3.3.4.min.css" rel="stylesheet">
		<!-- JQVMap -->
		<link href="../vendors/jqvmap/dist/jqvmap.min.css" rel="stylesheet"/>
		<!-- bootstrap-daterangepicker -->
		<link href="../vendors/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
		<!-- Ion.RangeSlider -->
		<link href="../vendors/normalize-css/normalize.css" rel="stylesheet">
		<link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.css" rel="stylesheet">
		<link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.skinFlat.css" rel="stylesheet">
		<!-- Bootstrap Colorpicker -->
		<link href="../vendors/mjolnic-bootstrap-colorpicker/dist/css/bootstrap-colorpicker.min.css" rel="stylesheet">
		<link href="../vendors/cropper/dist/cropper.min.css" rel="stylesheet">
		<!-- Datatables -->
		<link href="../vendors/datatables.net-bs/css/dataTables.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-buttons-bs/css/buttons.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-fixedheader-bs/css/fixedHeader.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-responsive-bs/css/responsive.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-scroller-bs/css/scroller.bootstrap.min.css" rel="stylesheet">

		<!-- bootstrap-datetimepicker -->
		<link href="../vendors/bootstrap-datetimepicker/build/css/bootstrap-datetimepicker.css" rel="stylesheet">

		<!-- Switchery -->
		<link href="../vendors/switchery/dist/switchery.min.css" rel="stylesheet">

		<!-- Toggle Switch -->
		<link rel="stylesheet" type="text/css" href="bootstrap/css/bootstrap4-toggle.min.css">

		<!-- Custom Theme Style -->
		<link href="../build/css/custom.min.css" rel="stylesheet">

		<script type="text/javascript">
			let Rack_TotalRows = 0;
			let chkRack_Selected = '';
		</script>

		<style type="text/css">
			th {
				position: sticky;
				top: 0px;
				background-color: #12537E;
			}
		</style>
	</head>

	<body class="nav-md" onload="f_LoadResultados(); f_LoadFiltroElementos();" style="zoom: 80%">
		<div class="container body">
			<div class="main_container">
				<?php include('partes/sidebar.php'); ?>

				<!-- page content -->
				<div class="right_col" role="main">
					<div class="">
						<div id="row_Titulo" class="row">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
										<div class="x_title">
											<div class="col-md-7 col-sm-7 col-xs-12">
												<h2 style="font-weight: bold;">
													Resumen de Resultados XRF
												</h2>
											</div>

											<div class="col-md-5 col-sm-5 col-xs-12">
												<div class="col-md-2 col-sm-2 col-xs-2" style="font-size: 14px; padding-top: 5px;">
													Fechas:
												</div>

												<div class="col-md-10 col-sm-10 col-xs-10">
													<div class="col-md-6 col-sm-6 col-xs-6" style="padding: 0px;">
														<?php
															date_default_timezone_set("America/Lima"); 
															$time = date('Y-m-d');

															echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_inicio" style="width: 95%;" value="'.$time.'"/>';
														?>
													</div>

													<div class="col-md-6 col-sm-6 col-xs-6" style="padding: 0px;">
														<?php
															echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_fin" style="width: 95%;" value="'.$time.'"/>';
														?>
													</div>
												</div>
											</div>

											<div class="clearfix">
											</div>
										</div>

										<div class="x_content" style="margin-bottom: -10px;">
												<!-- Filtros -->
												<div class="col-md-12 col-sm-12 col-xs-12">
													<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
														<div class="x_title">
															<h2>
																	<font style="font-size: 14px"><b>Por Elementos</b></font>
															</h2>

															<div class="clearfix">
															</div>
														</div>
														<div class="x_content" style="margin-bottom: -10px; overflow-x: scroll;">
															<table id="tbl_elementos">

															</table>
														</div>
													</div>
												</div>
										</div>
								</div>
							</div>
						</div>

						<div class="row">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<button class="btn btn-success" type="button" onclick="f_LoadResultados(0)" style="width: 100%; background-color: #26B99A">
										 <b>Ejecutar Búsqueda</b>
								</button>
							</div>
						</div>

						<div class="row" style="margin-top: 10px">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
									<div class="x_title">
											<h2 id="titulo_detalle" style="margin-top: 11px;">
													<b>Resumen</b>
											</h2>

											<div class="clearfix">
											</div>
									</div>

									<div class="x_content">
										<div class="col-md-10 col-sm-10 col-xs-10" style="margin-top: 15px;">
											<label>
												Total de Muestras:
											</label>
											<label id="lbl_TotalMuestras" style="color: #FF0005; font-size: 14px;">
												0
											</label>
										</div>

										<div class="table-box" style="width: 100%; overflow: scroll;">
											<table class="table table-striped jambo_table bulk_action">
												<thead>
			                    <tr style="font-size: 14px;">
			                      <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; border-top-left-radius: 15px; text-align: center;">
			                        N°
			                      </th>

			                      <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; min-width: 150px; font-weight: bold;">
			                        Muestra
			                      </th>

			                      <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center;">
			                        Análisis
			                      </th>

			                      <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; min-width: 150px;">
			                        Fecha Hora Lectura
			                      </th>

			                      <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #2A2B24; color: #ffffff; border-top-right-radius: 15px; text-align: center; min-width: 1050px; max-width: 1050px; width: 1050px;">
			                        Resultados
			                      </th>
			                    </tr>
			                  </thead>

												<tbody id="tbl_detalle" style="overflow: scroll">
														
												</tbody>
											</table>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>

  	<!-- Waiting Loading -->
    <div id="divmodal_Loading" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false" style="margin-top: 300px;">
      <div class="modal-dialog" style="height: 200px; opacity: 0.5;"><center>
        <img src="images/loading.gif" width="200px" style="border: solid; border-width: 1px; border-color: #D9D9D9;  border-radius: 15px;"></img>
        </center>
      </div>
    </div>

		<!-- jQuery -->
		<!-- <script src="../vendors/jquery/dist/jquery.min.js"></script> -->
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/2.2.4/jquery.min.js"></script>
		<!-- Bootstrap -->
		<script src="../vendors/bootstrap/dist/js/bootstrap.min.js"></script>
		<!-- Export 2 Excel -->
		<script src="libs/table2excel/jquery.table2excel.js"></script>
		<!-- FastClick -->
		<script src="../vendors/fastclick/lib/fastclick.js"></script>
		<!-- NProgress -->
		<script src="../vendors/nprogress/nprogress.js"></script>
		<!-- Ion.RangeSlider -->
		<script src="../vendors/ion.rangeSlider/js/ion.rangeSlider.min.js"></script>
		<!-- Bootstrap Colorpicker -->
		<script src="../vendors/mjolnic-bootstrap-colorpicker/dist/js/bootstrap-colorpicker.min.js"></script>
		<!-- Toggle Switch -->
		<script src="bootstrap/js/bootstrap4-toggle.min.js"></script>
		<!-- Custom Theme Scripts -->
		<script src="../build/js/custom.min.js"></script>

		<!-- bootstrap-daterangepicker -->
		<script src="../vendors/moment/min/moment.min.js"></script>
		<script src="../vendors/bootstrap-daterangepicker/daterangepicker.js"></script><!-- Datatables -->
		<script src="../vendors/datatables.net/js/jquery.dataTables.min.js"></script>
		<script src="../vendors/datatables.net-bs/js/dataTables.bootstrap.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/dataTables.buttons.min.js"></script>
		<script src="../vendors/datatables.net-buttons-bs/js/buttons.bootstrap.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/buttons.flash.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/buttons.html5.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/buttons.print.min.js"></script>
		<script src="../vendors/datatables.net-fixedheader/js/dataTables.fixedHeader.min.js"></script>
		<script src="../vendors/datatables.net-keytable/js/dataTables.keyTable.min.js"></script>
		<script src="../vendors/datatables.net-responsive/js/dataTables.responsive.min.js"></script>
		<script src="../vendors/datatables.net-responsive-bs/js/responsive.bootstrap.js"></script>
		<script src="../vendors/datatables.net-scroller/js/dataTables.scroller.min.js"></script>
		<script src="../vendors/jszip/dist/jszip.min.js"></script>
		<script src="../vendors/pdfmake/build/pdfmake.min.js"></script>
		<script src="../vendors/pdfmake/build/vfs_fonts.js"></script>

		<!-- Funciones Principales -->
		<script type="text/javascript">
			function f_LoadResultados(){
				var fecha_inicio = $("#fecha_inicio").val();
				var fecha_fin = $("#fecha_fin").val();

				// Cargando detalle de Análisis
					$("#tbl_detalle").html('');

				// Carga datos
					$.get( "../lims_api/index.php", { accion: "get_ResultadosXRF_DetalleImportacion_Resumen", fecha_inicio: fecha_inicio, fecha_fin: fecha_fin },
						function( data ) {
							if(data.estado == 1){
								// Setea la tabla de detalle
									$("#tbl_detalle").html(data.html);

								// Actualiza el contador muestras
									$("#lbl_TotalMuestras").html(data.r);

								// Llamar al filtro por elementos
									f_LoadResumenxElementos();
							}

						}, "json");
			};

			function f_LoadFiltroElementos(){
				// Carga Filtros
					$.get( "../lims_api/index.php", { accion: "get_ResultadosXRF_FiltroElementos" },
						function( data ) {
							if(data.estado == 1){
								$("#tbl_elementos").html(data.html);
							}

						}, "json");
			}

			function f_LoadResumenxElementos(){
				// Arma un array de los filtros seleccionados
					var nom_columna = '';
					var valor_x = '';
					var intervalo_x = '';
					var desde = 0;
					var hasta = 0;
					var arr_elementos = [];

					$("#tbl_elementos th").each(function(index) {
					  nom_columna = $(this).text().trim();

					  // Obtiene el valor e intervalo
					  	if (nom_columna.length > 0){
					  		valor_x = $("#" + nom_columna + '_desde').val();
						  	intervalo_x = $("#" + nom_columna + '_hasta').val();

								if (valor_x == undefined || intervalo_x == undefined){
						  		nom_columna = '';
						  	}
						  	else{
						  		if (valor_x.toString().length == 0 || intervalo_x.toString().length == 0){
							  		nom_columna = '';
							  	}
						  	}
					  	}

					  // Verifica si tiene un intervalo válido
						  if (nom_columna.length > 0){
						  	// Setea intervalos
						  		desde = parseFloat(valor_x) - parseFloat(intervalo_x);
						  		hasta = parseFloat(valor_x) + parseFloat(intervalo_x);

						  	// Si ambos son números agrega el elemento al array
						  		if ($.isNumeric(desde) && $.isNumeric(hasta)){
						  			arr_elementos.push(nom_columna + '%' + desde + '|' + hasta);
						  		}
						  }
					});

				// Hace visible las filas del detalle
					$("#tbl_detalle tr").each(function () {
						$(this).show();
					});

				// Recorre el array de los Intervalos válidos
					var e = 0;
					var muestra;
					var elemento;
					var valor_desde;
					var valor_hasta;

					while (e < arr_elementos.length){
						muestra = '';
						elemento = arr_elementos[e].split('%')[0];
						valor_desde = arr_elementos[e].split('%')[1].split('|')[0];
						valor_hasta = arr_elementos[e].split('%')[1].split('|')[1];

						// Recorremos todas las filas de tbl_detalle
							var d = 1;
							var idTr = '';
							var idLabel = '';
							var valor_elemento = '';
							var this_tr = '';
							var muestra = '';
							var is_found = 0;

							$("#tbl_detalle tr:visible").each(function () {
								this_tr = $(this);
								idTr = this_tr.attr('id');
								muestra = $(this).find("td").eq(1).html().trim();

								is_found = 0;

								// Obtiene el Id del Tr
									idTr = idTr.substring(3);

								$(this).find('label').each(function () {
							    idLabel = $(this).attr('id');

							    // Verifica si los elementos coinciden
							    	if (idLabel.includes(elemento + "_2")){
							    		is_found = 1;

							    		// Evalua si entra en el intervalo
							    			valor_elemento = $("#det_" + idTr + '_' + elemento + "_2").html();

												if ($.isNumeric(valor_elemento)){
													valor_elemento = parseFloat(valor_elemento);

													if (valor_elemento >= valor_desde && valor_elemento <= valor_hasta){
								    			}
								    			else{
								    				this_tr.hide();
								    			}
												}
												else{
													this_tr.hide();
												}
							    	}
							  });

							  // Verifico si no encontré el elemento
							  	if (is_found == 0){
							  		this_tr.hide();
							  	}

								d ++;
							});

						e ++;
					}

				// Actualiza el contador muestras
					var count_x = 0;

					$("#tbl_detalle tr:visible").each(function () {
						count_x ++;
					});

					$("#lbl_TotalMuestras").html(count_x);
			}

			function f_BuscarRango(_id_obj, _cod_elemento){
				// Obteniendo el valor del campo buscado
					var valor = $("#" + _id_obj).html().trim();

				// Valida valor
					if (valor.length == 0){
						alert("No tiene valor para buscar");
					}

				// Setea el valor a buscar
					$("#" + _cod_elemento + "_desde").val(valor);

				// Ir a la búsqueda
					var elemento = document.getElementById('tbl_elementos');
			    elemento.scrollIntoView({ behavior: 'smooth' });
			    window.scrollTo({left: elemento.offsetLeft, behavior: 'smooth'});

				// Obtiene el rango
					$.post( "ajax/encuesta.php", { accion: "get_conformidadresultados_buscarrangos", cod_elemento: _cod_elemento.toLowerCase(), valor: valor }, 
						function( data ) {
							if(data.estado == 1){
								if (data.rango.trim().length == 0){
									$("#" + _cod_elemento + "_hasta").val('');

									alert("No se tiene un rango configurado para este valor.");
								}
								else{
									$("#" + _cod_elemento + "_hasta").val(data.rango);
								}
							}

						}, "json");
			}

			function f_LimpiarFiltros(){
				$("#tbl_elementos th").each(function(index) {
				  nom_columna = $(this).text().trim();

				  // Limpia los objetos
				  	$("#" + nom_columna + '_desde').val('');
				  	$("#" + nom_columna + '_hasta').val('');
				});

				f_LoadResultados();
			}
		</script>

		<!-- Funciones Secundarias -->
		<script type="text/javascript">

		</script>

		<!-- Funciones para Grabar -->
		<script type="text/javascript">

		</script>

		<!-- Otras Funciones -->
		<script type="text/javascript">
			$(document).ajaxStart(function() {
				// Loading Modal
				var modal_loading = $("#divmodal_Loading");
				modal_loading.modal({backdrop: 'static', keyboard: false});
			});

			$(document).ajaxStop(function() {
				// Cerrando Modal
				$('#divmodal_Loading').modal('hide');
			});

			function f_cerrarModal(pantalla_modal){
				if (pantalla_modal == 1){
					$('#divmodal_DetallesMuestra').modal('hide');
				}
				if (pantalla_modal == 2){
					$('#divmodal_DetallesRack').modal('hide');
				}
				if (pantalla_modal == 3){
					$('#divmodal_DetallesMuestra').modal('hide');
				}
			};

			function f_CerrarDiv(accion, nom_div){
				var _div = document.getElementById(nom_div);

				if (accion == 'A'){
						_div.style.display = 'block'
				}
				else{
						 _div.style.display = 'none';
				}
			};

			// Limpia los datos al momento de Realizar la búsqueda de resultados
			function f_Limpiar(){
				// // Detalles del Rack
				//     $("#lblRack_totalmuestras").html('');
				//     $("#lblRack_usuario").html('');
				//     $("#lblRack_fechahora").html('');
				//     $("#lblRack_horno").html('');
				//     $("#lblRack_observacion").html('');
				//     document.getElementById('lblRack_observacion').title = '';

				// Grilla de Detalles de Rack
					$("#tbl_DetalleMuestras").html('');
			}

			// Permite obtener el nombre de cada mes
			function nombre_meses(_num_mes){
				if (_num_mes == 1){
						return "ENERO";
				}
				if (_num_mes == 2){
						return "FEBRERO";
				}
				if (_num_mes == 3){
						return "MARZO";
				}
				if (_num_mes == 4){
						return "ABRIL";
				}
				if (_num_mes == 5){
						return "MAYO";
				}
				if (_num_mes == 6){
						return "JUNIO";
				}
				if (_num_mes == 7){
						return "JULIO";
				}
				if (_num_mes == 8){
						return "AGOSTO";
				}
				if (_num_mes == 9){
						return "SEPTIEMBRE";
				}
				if (_num_mes == 10){
						return "OCTUBRE";
				}
				if (_num_mes == 11){
						return "NOVIEMBRE";
				}
				if (_num_mes == 12){
						return "DICIEMBRE";
				}
			}

			// Detecta la tecla ESCAPE
			document.addEventListener('keyup', function(e) {
				if (e.keyCode == 27) {
					f_cerrarModal(1);
					f_cerrarModal(2);
					f_cerrarModal(3);
				}
			});
		</script>

	</body>
</html>

<?php
		cerrarSesion($enlace);
?>