<?php
	header('Content-type: application/vnd.ms-excel; charset=UTF-8');
	header('Content-Disposition: attachment;filename=Resumen - Preparación Newmont.xls');
	header('Pragma: no-cache');
	header('Expires: 0');

	// session_start();
	include('../../../php/conn.php');

	// if(!isset($_SESSION["id"])){
	// 	header('Location: index.php');
	// }

	mysqli_query($enlace, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");
	mysqli_query($enlacehost, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");
	mysqli_query($enlace, "SET NAMES 'utf8'");
?>

<!DOCTYPE html>
<html lang="es">
	<head>
		<meta charset="utf-8">
	</head>

	<body class="nav-md footer_fixed">
 		<div class="container body">
			<div class="main_container">
				<?php
					// Recuperando las variables enviadas
						$fecha_inicio = $_GET["fi"];
						$fecha_fin = $_GET["ff"];
				?>

				<font size = "3"><b>
					RESUMEN DE PESOS - AAS
				</b></font>

				<br/>

				<font size = "2">
					Fecha de inicio: <?php echo $fecha_inicio; ?>
				</font>
				<br/>
				<font size = "2">
					Fecha de fin: <?php echo $fecha_fin; ?>
				</font>

				<br/>
				<br/>

        <?php
          // Armando Cabecera
            $html = ' <table class="table table-striped jambo_table bulk_action">
                        <thead>
                          <tr>
                            <th style="background-color: #12537e; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 30px; border-top-left-radius: 15px; text-align: center; color: #ffffff;">
                              Item
                            </th>

                            <th style="background-color: #12537e; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 140px; text-align: center; color: #ffffff;">
                              Muestra
                            </th>

                            <th style="background-color: #12537e; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 140px; text-align: center; color: #ffffff;">
                              Num. Malla
                            </th>

                            <th style="background-color: #12537e; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 140px; text-align: center; color: #ffffff;">
                              Muestra Cerrada
                            </th>

                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 140px; text-align: center; background-color: #049DBF; color: #ffffff;">
                              Num. Grupo
                            </th>

                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 140px; text-align: center; background-color: #049DBF; color: #ffffff;">
                              Peso Muestra
                            </th>

                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 140px; text-align: center; background-color: #049DBF; color: #ffffff;">
                              Peso Positivo (+)
                            </th>

                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 140px; border-top-right-radius: 15px; text-align: center; background-color: #049DBF; color: #ffffff;">
                              Peso Negativo (-)
                            </th>
                          </tr>
                        </thead>

                        <tbody id="tbl_resumen">';

          // Armando Detalle
            $p = 1;
            $t = 0;
            $id_cabecera = '';

            $q_resumen = "SELECT C.Id AS Cabecera_Id,
                                 C.CI_Muestra,
                                 M.num_malla,

                                 CASE WHEN C.Cierre_Newmont = 0 THEN '' ELSE 'SÍ' END AS Cierre_Newmont,

                                 D.Id AS Detalle_Id,

                                 (SELECT COUNT(X.Id) AS _COUNT
                                    FROM preparacion_newmont_detalle X
                                   WHERE X.Id_Cabecera = D.Id_Cabecera) AS COUNT_DETALLE,

                                 D.Num_Grupo,
                                 D.Peso_muestra,
                                 D.PesoPositivo_muestra,
                                 D.PesoNegativo_muestra,
                                 C.Id_Pedido,
                                 C.Id_Detalle
                            FROM preparacion_newmont_detalle D
                                 INNER JOIN preparacion_newmont_cabecera C ON D.Id_Cabecera = C.Id
                                 LEFT JOIN tbconfig_mallas M ON C.Id_NumMalla = M.Id
                           WHERE DATE(C.FechaHora_Recepcion) BETWEEN '".$fecha_inicio."' AND '".$fecha_fin."'
                          ORDER BY C.FechaHora_Recepcion DESC, C.Id_Detalle DESC, D.Id";

            if ($res_resumen = mysqli_query($enlace, $q_resumen)) {
              if (mysqli_num_rows($res_resumen) > 0) {
                $estado = 1;

                while($row_resumen = mysqli_fetch_assoc($res_resumen)) {
                  // Valida que no sea una muestra Anulada
                    $continuar = 1;

                    $q_anulada = "SELECT COUNT(D.Id) AS _COUNT
                                    FROM _max_labperu_DetallePedido D
                                         INNER JOIN _max_labperu_CabeceraPedido C ON D.Id_Pedido = C.Id_Pedido
                                   WHERE D.Cod_Interno = '".$row_resumen["CI_Muestra"]."'
                                     AND  C.es_anulada = 1";

                    if ($res_anulada = sqlsrv_query($enlacehost, $q_anulada)) {
                      while($row_anulada = sqlsrv_fetch_array($res_anulada)) {
                        if ($row_anulada["_COUNT"] > 0){
                          $continuar = 0;
                        }
                        else{
                          // Valida que la muestra no se haya cambiado por otro elemento
                            $q_change = "SELECT COUNT(Id) AS _COUNT
                                           FROM _max_labperu_DetallePedido
                                          WHERE Id_Pedido = ".$row_resumen["Id_Pedido"]."
                                            AND Id = ".$row_resumen["Id_Detalle"];

                            if ($res_change = sqlsrv_query($enlacehost, $q_change)) {
                              while($row_change = sqlsrv_fetch_array($res_change)) {
                                if ($row_change["_COUNT"] == 0){
                                  $continuar = 0;
                                }
                              }
                            }
                        }
                      }
                    }

                  // Continua pintando datos
                    if ($continuar == 1){
                      $html .= '<tr>';

                      $html .= '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                      $html .= "    ".$p;
                      $html .= "  </td>";

                      if ($id_cabecera != $row_resumen["Cabecera_Id"]){
                        $html .= '  <td rowspan="'.$row_resumen["COUNT_DETALLE"].'" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: 900;">';
                        $html .= "    ".$row_resumen["CI_Muestra"];
                        $html .= "  </td>";

                        $html .= '  <td rowspan="'.$row_resumen["COUNT_DETALLE"].'" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                        $html .= "    ".$row_resumen["num_malla"];
                        $html .= "  </td>";

                        $html .= '  <td rowspan="'.$row_resumen["COUNT_DETALLE"].'" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                        $html .= "    ".$row_resumen["Cierre_Newmont"];
                        $html .= "  </td>";

                        $t += 1;
                      }

                      $html .= '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: 900;">';
                      $html .= "    ".$row_resumen["Num_Grupo"];
                      $html .= "  </td>";

                      $html .= '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                      $html .= "    ".$row_resumen["Peso_muestra"];
                      $html .= "  </td>";

                      $html .= '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                      $html .= "    ".$row_resumen["PesoPositivo_muestra"];
                      $html .= "  </td>";

                      $html .= '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                      $html .= "    ".$row_resumen["PesoNegativo_muestra"];
                      $html .= "  </td>";

                      $p += 1;

                      $id_cabecera = $row_resumen["Cabecera_Id"];

                      $html .= '</tr>';
                    }
                }

                $html .= '</tbody>';
              }
            }

          echo $html;
        ?>

			</div>
		</div>
	</div>
</html>