<?php

	header('Content-Type: application/json');
  session_start();

  include('../../../php/conn.php');

	// Ruta del archivo local
		$ruta_local = 'C:\LecturasXRF/Results.csv';

	// Ruta donde deseas copiar el archivo en tu hosting
		$ruta_destino = '../../files/results.csv';

	// Actualizando zona horaria del servidor
	  $q_timezone = "SET TIME_ZONE = 'America/Lima'";

	  if ($res = mysqli_query($enlace, $q_timezone)) {
	  }

	  date_default_timezone_set('America/Lima');

	// Copiar el archivo
		if (copy($ruta_local, $ruta_destino)) {
			echo 'El archivo se ha copiado exitosamente.';
			echo "\n";
		} else {
			echo 'Hubo un error al copiar el archivo.';
			echo "\n";
		}

	// Recorre el archivo csv
		if (($gestor = fopen($ruta_destino, 'r')) !== FALSE) {
			$r = 0;
			$fila_inicio = 0;
      $in_codinterno = '';
      $count_insert = 0;

	    // Leer el contenido del archivo línea por línea
	    while (($fila = fgetcsv($gestor, 1000, ',')) !== FALSE) {
	      if ($r >= $fila_inicio){
          // Valida si es el éltimo registro
            if (strlen($fila[0]) == 0){
              break;
            }

          // Verifica si es cabecera, si es así guarda un array
            if (trim($fila[0]) == 'File #'){
              $c = 1;
              $item = 1;
              $arr_cabecera = array();
              $arr_cabecera[0] = trim($fila[0]);

              while ($c <= 150){
                if (strlen(trim($fila[$c])) > 0){
                  $arr_cabecera[$c] = trim($fila[$c]);
                }

                $c ++;
              }
            }
            else{
              // Setea los datos de cabecera
                $q_insert = "INSERT INTO import_resultadosxrf_detalle (id_importacion,
                             item, fechahora_registro, operator, name, id_detalle,
                             application, method, elapsed_time, alloy_1, match_qual_1,
                             alloy_2, match_qual_2, alloy_3, match_qual_3, resultados)
                             VALUES (";
                $q_insert .= '999, ';
                $q_insert .= "'".$fila[0]."', ";
                $q_insert .= "'".(explode('-', explode(' ', $fila[1])[0])[2].'-'.str_pad(explode('-', explode(' ', $fila[1])[0])[0], 2, '0', STR_PAD_LEFT).'-'.str_pad(explode('-', explode(' ', $fila[1])[0])[1], 2, '0', STR_PAD_LEFT)).' '.explode(' ', $fila[1])[1]."', ";
                $q_insert .= "'".$fila[2]."', ";
                $q_insert .= "'".$fila[3]."', ";
                $q_insert .= "'".$fila[4]."', ";
                $q_insert .= "'".$fila[5]."', ";
                $q_insert .= "'".$fila[6]."', ";
                $q_insert .= "'".$fila[7]."', ";
                $q_insert .= "'".$fila[8]."', ";
                $q_insert .= "'".$fila[9]."', ";
                $q_insert .= "'".$fila[10]."', ";
                $q_insert .= "'".$fila[11]."', ";
                $q_insert .= "'".$fila[12]."', ";
                $q_insert .= "'".$fila[13]."', ";
                $q_insert .= "'";

              // Setea los resultados
                $a = 14;
                $titulo = '';
                $valor = '';

                while ($a < count($arr_cabecera)){
                  // Obtiene el título
                    $titulo = trim($arr_cabecera[$a]);

                  // Valor
                    $valor = trim($fila[$a]);

                  // Setea cadena
                    $q_insert .= "[".$titulo."]-[".$valor."]&";

                  $a ++;
                }

              // Insertando registro
                $q_insert = substr($q_insert, 0, -1);
                $q_insert .= "')";

                if ($res_insert = mysqli_query($enlace, $q_insert)){
                	$count_insert ++;
                }
                else{
                  $estado = 0;
                  echo 'Error: '.$q_insert;
                  echo "\n";
                  echo "\n";
                }

              $item ++;
            }
        }
	    }

	    fclose($gestor);

	    echo 'Registros importados: '.$count_insert;
		}
		else {
		  echo 'No se pudo abrir el archivo.';
		}

?>
