<?php
  
  session_start();

  include('../../php/conn.php');

  if(!isset($_SESSION["id"])){
    header('Location: index.php');
  }

  mysqli_query($enlace, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");
  mysqli_query($enlacehost, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");

?>

<!DOCTYPE html>
<html lang="es">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	    <!-- Meta, title, CSS, favicons, etc. -->
	    <meta charset="utf-8">
	    <meta http-equiv="X-UA-Compatible" content="IE=edge">
	    <meta name="viewport" content="width=device-width, initial-scale=1">

	    <title>Informes Agrupados</title>

	    <!-- Bootstrap -->
	    <link href="../vendors/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
	    <!-- Font Awesome -->
	    <link href="../vendors/font-awesome/css/font-awesome.min.css" rel="stylesheet">
	    <!-- NProgress -->
	    <link href="../vendors/nprogress/nprogress.css" rel="stylesheet">
	    <!-- iCheck -->
	    <link href="../vendors/iCheck/skins/flat/green.css" rel="stylesheet">
	    <!-- bootstrap-progressbar -->
	    <link href="../vendors/bootstrap-progressbar/css/bootstrap-progressbar-3.3.4.min.css" rel="stylesheet">
	    <!-- JQVMap -->
	    <link href="../vendors/jqvmap/dist/jqvmap.min.css" rel="stylesheet"/>
	    <!-- bootstrap-daterangepicker -->
	    <link href="../vendors/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
	    <!-- Ion.RangeSlider -->
	    <link href="../vendors/normalize-css/normalize.css" rel="stylesheet">
	    <link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.css" rel="stylesheet">
	    <link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.skinFlat.css" rel="stylesheet">
	    <!-- Bootstrap Colorpicker -->
	    <link href="../vendors/mjolnic-bootstrap-colorpicker/dist/css/bootstrap-colorpicker.min.css" rel="stylesheet">
	    <link href="../vendors/cropper/dist/cropper.min.css" rel="stylesheet">
	    <!-- Datatables -->
	    <link href="../vendors/datatables.net-bs/css/dataTables.bootstrap.min.css" rel="stylesheet">
	    <link href="../vendors/datatables.net-buttons-bs/css/buttons.bootstrap.min.css" rel="stylesheet">
	    <link href="../vendors/datatables.net-fixedheader-bs/css/fixedHeader.bootstrap.min.css" rel="stylesheet">
	    <link href="../vendors/datatables.net-responsive-bs/css/responsive.bootstrap.min.css" rel="stylesheet">
	    <link href="../vendors/datatables.net-scroller-bs/css/scroller.bootstrap.min.css" rel="stylesheet">

	    <!-- bootstrap-datetimepicker -->
    	<link href="../vendors/bootstrap-datetimepicker/build/css/bootstrap-datetimepicker.css" rel="stylesheet">

	    <!-- Custom Theme Style -->
    	<link href="../build/css/custom.min.css" rel="stylesheet">

    	<script type="text/javascript">
    		var Id_Pedido = 0;
    		var Id_DetallePedido = 0;
    		var Estado_Cierre = 0;
            var campos_evaluados = 0;
            var total_resultados = 0;

            var modal_lv = 0;
    	</script>

        <style type="text/css">
            th {
                position: sticky;
                top: 0px;
                background-color: #12537E;
            }
        </style>
	</head>

	<body class="nav-md" onload="f_LoadResultados()" style="zoom: 80%">
		<div class="container body">
      		<div class="main_container">
      			<?php include('partes/sidebar.php'); ?>

      			<!-- page content -->
        		<div class="right_col" role="main">
        			<div class="">
        				<div class="row">
        					<div class="col-md-12 col-sm-12 col-xs-12">
        						<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
        							<div class="x_title">
                                        <h2>
                                            Módulo para la agrupación de resultado en un solo informe
                                        </h2>
        								
        								<div class="clearfix">
        								</div>
        							</div>

        							<div class="x_content">
        								<!-- Filtros -->
        								<div class="col-md-6 col-sm-6 col-xs-12">
	        								<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
												<div class="x_title">
													<h2>
														<font style="font-size: 14px"><b>Búsqueda por rango de fechas</b></font>
													</h2>
													<div class="clearfix">
													</div>
												</div>
												<div class="x_content">
													<div class="form-group col-md-6 col-sm-6 col-xs-12" style="margin-top: 9px;">
                                                        <label class="control-label col-md-5 col-sm-5 col-xs-12" style="margin-top: 6px; text-align: right;">
                                                            Desde
                                                        </label>
                                                        <div class="col-md-7 col-sm-7 col-xs-12">
                                                            <?php
	                                                            date_default_timezone_set("America/Lima"); 
	                                            				$time = date('Y-m-d');

                                                                echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_inicio" value="'.$time.'"/>';
                                                            ?>
                                                        </div>
                                                    </div>

                                                    <div class="form-group col-md-6 col-sm-6 col-xs-12" style="margin-top: 9px;">
                                                        <label class="control-label col-md-5 col-sm-5 col-xs-12" style="margin-top: 6px; text-align: right;">
                                                            Hasta
                                                        </label>
                                                        <div class="col-md-7 col-sm-7 col-xs-12">
                                                            <?php
                                                                echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_fin" value="'.$time.'"/>';
                                                            ?>
                                                        </div>
                                                    </div>
												</div>
											</div>
										</div>

										<div class="col-md-3 col-sm-3 col-xs-12">
											<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
												<div class="x_title">
													<h2>
														<font style="font-size: 14px"><b>Búsqueda por Racks</b></font>
													</h2>
													<div class="clearfix">
													</div>
												</div>
												<div class="x_content">
													<div class="form-group col-md-12 col-sm-12 col-xs-12" style="margin-top: 9px;">
				                                        <select id="lista_racks" class="form-control" style="text-align: left;">
															<option value="">Elija una opción...</option>
														</select>
					                                </div>
												</div>
											</div>
										</div>

										<div class="col-md-3 col-sm-3 col-xs-12">
											<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
												<div class="x_title">
													<h2>
														<font style="font-size: 14px"><b>Búsqueda por Fundidor</b></font>
													</h2>
													<div class="clearfix">
													</div>
												</div>
												<div class="x_content">
													<div class="form-group col-md-12 col-sm-12 col-xs-12" style="margin-top: 9px;">
				                                        <select id="lista_fundidor" class="form-control" style="text-align: left;">
															<option value="">Elija una opción...</option>
														</select>
					                                </div>
												</div>
											</div>
										</div>
        							</div>
        						</div>
        					</div>
        				</div>

						<div class="row">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<button class="btn btn-success" type="button" onclick="f_LoadResultados()" style="width: 100%; background-color: #26B99A">
	                                 <b>Ejecutar Búsqueda</b>
	                            </button>
							</div>
						</div>

        				<div class="row" style="margin-top: 10px">
        					<div class="col-md-12 col-sm-12 col-xs-12">
        						<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
        							<div class="x_title">
                                        <div class="col-md-6 col-sm-6 col-xs-6">
                                            <h2>
                                                Lista de Resultados
                                            </h2>
                                        </div>

                                        <div class="col-md-6 col-sm-6 col-xs-6" style="text-align: right; display: none;">
                                            <input id="sel_ALL" class="sel_ALL" type="checkbox" style="cursor: pointer;"><label for="sel_ALL" style="cursor: pointer; color: #A63D33; margin-left: 5px"><b> Seleccionar todo</b></label>
                                        </div>
        								
        								<div class="clearfix">
        								</div>
        							</div>

        							<div class="x_content">
                                        <div class="row" style="margin-left: 10px; color: #2574A9">
                                            Registros seleccionados: <label id="lbl_seleccionados"><b>0</b></label>
                                        </div>

                                        <div class="row" style="margin-left: 10px; color: #2574A9">
                                            Códigos seleccionados: <label id="lbl_codigos" style="color: #3F403D"><b> </b></label>
                                        </div>

                                        <div class="row" style="color: #2574A9; text-align: right; margin-right: 25px">
                                            <button class="btn btn-info" type="button" onclick="f_GenerarInformes()" style="width: 15%;">
                                                <i class="fa fa-check-square"></i> Generar Informes
                                            </button>
                                        </div>

                                        <!-- </br> -->

                                        <div class="table-box" style="height: 1000px; overflow-y: scroll;">
            								<table class="table table-striped jambo_table bulk_action">
                                                <thead>
                                                    <tr>
                                                        <th style="width: 1%; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Item
                                                        </center></th>
                                                        <th style="width: 1%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Acción
                                                        </center></th>
                                                        <th style="width: 1%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Oficina
                                                        </center></th>
                                                        <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; background: #734432"><center>
                                                            Fecha Hora Recepción
                                                        </center></th>
                                                        <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; background-color: #8C6354"><center>
                                                            Fecha Hora Entrega
                                                        </center></th>
                                                        <th style="width: 5%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Observación
                                                        </center></th>
                                                        <th style="width: 6%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #A63D33"><center>
                                                            Código Muestra
                                                        </center></th>
                                                        <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #F29F05"><center>
                                                            Fecha Inicio Ensayo
                                                        </center></th>
                                                        <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>
                                                            AG (g/tm)
                                                        </center></th>
                                                        <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>
                                                            AU (g/tm)
                                                        </center></th>
                                                        <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>
                                                            AG (oz/tc)
                                                        </center></th>
                                                        <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>
                                                            AU (oz/tc)
                                                        </center></th>
                                                        <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>
                                                            % CU
                                                        </center></th>
                                                        <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>
                                                            % PB
                                                        </center></th>
                                                        <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>
                                                            % ZN
                                                        </center></th>
                                                        <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>
                                                            % AS
                                                        </center></th>
                                                        <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>
                                                            % SB
                                                        </center></th>
                                                        <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>
                                                            % S
                                                        </center></th>
                                                        <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>
                                                            % FE
                                                        </center></th>
                                                        <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>
                                                            % H2O
                                                        </center></th>
                                                        <th style="width: 5%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Observación Reporte
                                                        </center></th>
                                                        <th colspan="2" style="width: 7%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                            Informe de Ensayos
                                                        </center></th>
                                                    </tr>
                                                </thead>

                                                <tbody id="tabla_analisisresultados">
                                                    
                                                </tbody>
                                            </table>
                                        </div>
        							</div>
        						</div>
        					</div>
        				</div>
        			</div>
        		</div>
      		</div>
      	</div>

      	<!-- Ventanas Modal -->
      	<div id="divmodal_Cierre" class="modal fade" role="dialog" data-backdrop="static" data-keyboard="false">
            <div class="modal-dialog" style="width: 40%; margin-top: 12%; margin-left: 30%">
                <!-- Modal content-->
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal">
                            &times;
                        </button>

                        <h4 class="modal-title"><b>
                        	Cierre de Análisis
                        </b></h4>
                    </div>

                    <div class="modal-body">
                    	<div class="row"><center>
                    		<label id="cierre_mensaje" style="margin-left: 10px; margin-right: 10px; color: #A63D33; font-size: 14px;"><b>
                    			Prueba de mensaje
                    		</b></label>
                    	</center></div>

                    	<div class="ln_solid"></div>

                    	<div class="row" >
                    		<div class="col-md-4 col-sm-4 col-xs-4"><center>
                    			<button class="btn btn-success" type="button" onclick="f_ModalRevertirCierre()" style="width: 150px; background-color: #A63D33">
                                    Revertir
								</button>
                    		</center></div>

                    		<div class="col-md-4 col-sm-4 col-xs-4"><center>
                    			<button id="btn_cerrar" class="btn btn-success" type="button" onclick="f_ModalUpdateCierre()" style="width: 150px; background-color: #26B99A">
                                    Cerrar
								</button>
                    		</center></div>

                    		<div class="col-md-4 col-sm-4 col-xs-4"><center>
                    			<button class="btn btn-success" type="button" onclick="f_cerrarModal(1)" style="width: 150px; background-color: #807D80">
                                    Cancelar
								</button>
                    		</center></div>
                    	</div>

                    	<input id="id_pedido" type="hidden">
                    	<input id="id_detallepedido" type="hidden">
                    	<input id="estado_cierre" type="hidden">
                    	<input id="cierre_imageorden" type="hidden">
                    </div>
                </div>
            </div>
        </div>

      	<!-- Ventanas modal -->
        <div id="divmodal_qr" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false">
            <div class="modal-dialog" style="width: 50%; margin-top: 12%; margin-left: 25%">
                <!-- Modal content-->
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal">
                            &times;
                        </button>

                        <h4 class="modal-title"><b>
                            Código QR - Informe de Ensayos
                        </b></h4>
                    </div>

                    <div class="modal-body">
                        <div class="row">
                            <div class="form-group col-md-5 col-sm-5 col-xs-12">
                                <label class="control-label col-md-6 col-sm-6 col-xs-12" style="margin-top: 6px">
                                    Nombre de Muestra
                                </label>
                                <div class="col-md-6 col-sm-6 col-xs-12"><b>
                                    <input type="text" class="form-control col-md-12 col-xs-12" id="qr_muestra" style="text-align: center; background-color: #F2A71B" disabled/>
                                </b></div>
                            </div>

                            <div class="form-group col-md-7 col-sm-7 col-xs-12">
                                <label class="control-label col-md-3 col-sm-3 col-xs-12" style="text-align: right; margin-top: 6px">
                                    Análisis
                                </label>
                                <div class="col-md-8 col-sm-8 col-xs-12"><b>
                                    <input type="text" class="form-control col-md-12 col-xs-12" id="qr_analisis" style="text-align: center; background-color: #0455BF; color: #ffffff" disabled/>
                                </b></div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="ln_solid"></div>
                        </div>

                        <input id="qr_id_pedido" type="hidden">
                        <input id="qr_id_detallepedido" type="hidden">

                        <div class="row"><center>
                            <img id="img_qr" width="350px" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px; cursor: pointer;" onclick="f_DownloadImg(1)"/>
                        </center></div>

                        <div class="row">
                            <div class="form-group col-md-12 col-sm-12 col-xs-12" style="text-align: center;">
                                <label style="cursor: pointer;" onclick="f_DownloadImg(1)"><u>
                                    Descargar Imagen QR
                                </u></label>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div id="divmodal_qr_agrupado" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false">
            <div class="modal-dialog" style="width: 50%; margin-top: 12%; margin-left: 25%">
                <!-- Modal content-->
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal">
                            &times;
                        </button>

                        <h4 class="modal-title"><b>
                            Código QR - Informe de Ensayos (Agrupado)
                        </b></h4>
                    </div>

                    <div class="modal-body">
                        <div class="row">
                            <div class="form-group col-md-4 col-sm-4 col-xs-12">
                                <label class="control-label col-md-5 col-sm-5 col-xs-12" style="margin-top: 6px">
                                    N° de Informe
                                </label>
                                <div class="col-md-7 col-sm-7 col-xs-12"><b>
                                    <input type="text" class="form-control col-md-12 col-xs-12" id="qr_informe" style="text-align: center; background-color: #F2A71B" disabled/>
                                </b></div>
                            </div>

                            <div class="form-group col-md-8 col-sm-8 col-xs-12">
                                <label class="control-label col-md-2 col-sm-2 col-xs-12" style="text-align: right; margin-top: 6px">
                                    Muestras
                                </label>
                                <div class="col-md-9 col-sm-9 col-xs-12"><b>
                                    <input type="text" class="form-control col-md-12 col-xs-12" id="qr_muestras_ci" style="text-align: center; background-color: #0455BF; color: #ffffff" disabled/>
                                </b></div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="ln_solid"></div>
                        </div>

                        <input id="qr_id_pedido_agrupado" type="hidden">
                        <input id="qr_ci" type="hidden">

                        <div class="row"><center>
                            <img id="img_qr_agrupado" width="350px" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px; cursor: pointer;" onclick="f_DownloadImg(2)"/>
                        </center></div>

                        <div class="row">
                            <div class="form-group col-md-12 col-sm-12 col-xs-12" style="text-align: center;">
                                <label style="cursor: pointer;" onclick="f_DownloadImg(2)"><u>
                                    Descargar Imagen QR
                                </u></label>
                            </div>
                        </div>

                        <div class="ln_solid"></div>

                        <div class="row"><center>
                            <button class="btn btn-dark" type="button" onclick="f_cerrarModal(2)">
                                Cancelar
                            </button>
                        </center></div>
                    </div>
                </div>
            </div>
        </div>

        <div id="divmodal_InformesAgrupados" class="modal fade" role="dialog" data-backdrop="static" data-keyboard="false">
            <div class="modal-dialog" style="width: 90%; margin-top: 1%;">
                <!-- Modal content-->
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal">
                            &times;
                        </button>

                        <h4 class="modal-title" id="titulo_AddProducto"><b>
                            Emisión de Informes Agrupados
                        </b></h4>
                    </div>

                    <div class="modal-body">
                        <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                            <div class="x_title">
                                <h2>
                                    <font style="font-size: 14px"><b>Lista de Informes Agrupados</b></font>
                                </h2>
                                <div class="clearfix">
                                </div>
                            </div>
                            <div class="x_content">
                                <div class="table-box" style="height: 650px; overflow-y: scroll;"><center>
                                    <table style="width: 100%">
                                        <thead>
                                            <tr style="color: #ffffff; height: 45px">
                                                <th style="background-color: #12537E; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; width: 3%">
                                                    Item
                                                </th><th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #A63D33; width: 10%;"><center>
                                                    Código Muestra
                                                </center></th>
                                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86; width: 5%"><center>
                                                    AG (g/tm)
                                                </center></th>
                                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86; width: 5%"><center>
                                                    AU (g/tm)
                                                </center></th>
                                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86; width: 5%"><center>
                                                    AG (oz/tc)
                                                </center></th>
                                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86; width: 5%"><center>
                                                    AU (oz/tc)
                                                </center></th>
                                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86; width: 5%"><center>
                                                    % CU
                                                </center></th>
                                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86; width: 5%"><center>
                                                    % PB
                                                </center></th>
                                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86; width: 5%"><center>
                                                    % ZN
                                                </center></th>
                                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86; width: 5%"><center>
                                                    % AS
                                                </center></th>
                                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86; width: 5%"><center>
                                                    % SB
                                                </center></th>
                                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86; width: 5%"><center>
                                                    % S
                                                </center></th>
                                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86; width: 5%"><center>
                                                    % FE
                                                </center></th>
                                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86; width: 5%"><center>
                                                    % H2O
                                                </center></th>
                                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 17%;"><center>
                                                    Observación Reporte
                                                </center></th>
                                                <th colspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 10%;"><center>
                                                    Informe de Ensayos
                                                </center></th>
                                            </tr>
                                        </thead>

                                        <tbody id="table_agrupados">
                                            
                                        </tbody>
                                    </table>
                                </center></div>

                                <div class="ln_solid"></div>

                                <div class="form-group"><center>
                                    <div class="col-md-12 col-sm-12 col-xs-12">
                                        <button class="btn btn-dark" type="button" onclick="f_cerrarModal(1)">
                                            Cancelar
                                        </button>
                                    </div>
                                </center></div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

      	<div id="divmodal_Loading" class="modal fade" role="dialog" data-backdrop="static" data-keyboard="false" style="margin-top: 300px;">
            <div class="modal-dialog" style="height: 200px; opacity: 0.5;"><center>
                <img src="images/loading.gif" width="200px" style="border: solid; border-width: 1px; border-color: #D9D9D9;  border-radius: 15px;"></img>
            </center></div>
        </div>

      	<!-- jQuery -->
	    <script src="../vendors/jquery/dist/jquery.min.js"></script>
	    <!-- Bootstrap -->
	    <script src="../vendors/bootstrap/dist/js/bootstrap.min.js"></script>
	    <!-- FastClick -->
	    <script src="../vendors/fastclick/lib/fastclick.js"></script>
	    <!-- NProgress -->
	    <script src="../vendors/nprogress/nprogress.js"></script>
	    <!-- Ion.RangeSlider -->
    	<script src="../vendors/ion.rangeSlider/js/ion.rangeSlider.min.js"></script>
    	<!-- Bootstrap Colorpicker -->
    	<script src="../vendors/mjolnic-bootstrap-colorpicker/dist/js/bootstrap-colorpicker.min.js"></script>
        <!-- iCheck -->
        <script src="../vendors/iCheck/icheck.min.js"></script>
	    <!-- Custom Theme Scripts -->
	    <script src="../build/js/custom.min.js"></script>

	    <!-- bootstrap-daterangepicker -->
	    <script src="../vendors/moment/min/moment.min.js"></script>
	    <script src="../vendors/bootstrap-daterangepicker/daterangepicker.js"></script><!-- Datatables -->
	    <script src="../vendors/datatables.net/js/jquery.dataTables.min.js"></script>
	    <script src="../vendors/datatables.net-bs/js/dataTables.bootstrap.min.js"></script>
	    <script src="../vendors/datatables.net-buttons/js/dataTables.buttons.min.js"></script>
	    <script src="../vendors/datatables.net-buttons-bs/js/buttons.bootstrap.min.js"></script>
	    <script src="../vendors/datatables.net-buttons/js/buttons.flash.min.js"></script>
	    <script src="../vendors/datatables.net-buttons/js/buttons.html5.min.js"></script>
	    <script src="../vendors/datatables.net-buttons/js/buttons.print.min.js"></script>
	    <script src="../vendors/datatables.net-fixedheader/js/dataTables.fixedHeader.min.js"></script>
	    <script src="../vendors/datatables.net-keytable/js/dataTables.keyTable.min.js"></script>
	    <script src="../vendors/datatables.net-responsive/js/dataTables.responsive.min.js"></script>
	    <script src="../vendors/datatables.net-responsive-bs/js/responsive.bootstrap.js"></script>
	    <script src="../vendors/datatables.net-scroller/js/dataTables.scroller.min.js"></script>
	    <script src="../vendors/jszip/dist/jszip.min.js"></script>
	    <script src="../vendors/pdfmake/build/pdfmake.min.js"></script>
	    <script src="../vendors/pdfmake/build/vfs_fonts.js"></script>

	    <!-- Funciones Principales -->
	    <script type="text/javascript">
	    	function f_LoadResultados(){
	    		var htmlContenido = '';
                var htmlContenido_2 = '';
                var htmlContenido_3 = '';
                var htmlContenido_4 = '';

	    		// Obteniendo filtros
	    			var fecha_inicio = $("#fecha_inicio").val();
	    			var fecha_fin = $("#fecha_fin").val();
	    			var lista_rack = $("#lista_rack").val();
	    			var lista_fundidor = $("#lista_fundidor").val();

	    		// Validando ingreso de filtros
	    			if (fecha_inicio == null){
                        alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                        return;
                    }
                    if (fecha_inicio.length == 0){
                        alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                        return;
                    }

                    if (fecha_fin == null){
                        alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                        return;
                    }
                    if (fecha_fin.length == 0){
                        alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                        return;
                    }

                    if (fecha_fin < fecha_inicio){
                    	alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

                        return;
                    }

            	// Loading Modal
                    var modal_loading = $("#divmodal_Loading");
                    modal_loading.modal({backdrop: 'static', keyboard: false});

            	// Carga resultados
            		var c = 1;
            		var _visible = 0;
                    var _campos = '';

                    $("#tabla_analisisresultados").html(htmlContenido);

                    $.post( "ajax/encuesta.php", { accion: "Get_AnalisisResultados", fecha_inicio: fecha_inicio, fecha_fin: fecha_fin, id_rack: lista_rack, id_fundidor: lista_fundidor, agrupados: 1 }, 
                        function( data ) {
                            if(data.estado == 1){
                                $.each( data.registros, function( key, val ) {
                                    htmlContenido_2 = '';
                                    htmlContenido_3 = '';
                                    htmlContenido_4 = '';
                                    _campos = '';

                                    htmlContenido += '<tr>';

                                    htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right">' + c + '</td>';
                                    
                                    htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>';

                                    htmlContenido_3 += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; color: #3F4242; background-color: ' + ((val.Sucursal == 1) ? '#D1DBBD' : '#D89196') + ' "><center><b>' + val.des_sucursal + '</b></center></td>';
                                    htmlContenido_3 += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.FechaHora_Recepcion + '</center></td>';
                                    htmlContenido_3 += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.FechaHora_Entrega + '</center></td>';
                                    htmlContenido_3 += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;">' + val.Observacion + '</td>';
                                    htmlContenido_3 += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; font-size: 14px; color: #A63D33"><b><label id="sp_CI_' + c + '" style="text-align: center;">' + val.Cod_Interno + '</label></b></td>';
                                    htmlContenido_3 += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-size: 14px; color: #A63D33;"><center><b>';

                                    htmlContenido_3 += '    <input type="date" id="fie_' + c + '" style="text-align: left; width: 150px" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'fie_" + c + "', " + "'Fecha_InicioEnsayo'" + ')" value="' + val.Fecha_InicioEnsayo.substr(0, 10) + '"' + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

                                    htmlContenido_3 += '  </b></td>';

                                    // Ag (g/tm)
                                    	_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('ag') >= 0) ? 1 : 0 );

	                                    htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

	                                    if (_visible == 1){
                                            // Verifica que se una resulado con datos
                                                if (val.Ley_Ag_gt != null){
                                                    simbolo_1 = 0;
                                                    simbolo_2 = 0;
                                                    resultado = '';

                                                    // Verifica si es: "-"
                                                        if (f_VerificaSimbolo(1, val.Ley_Ag_gt) == 1){
                                                            simbolo_1 = 1;
                                                        }

                                                    // Verifica si es: "<" ó ">"
                                                        var total_CEROS = f_VerificaSimbolo(2, val.Ley_Ag_gt)

                                                        if (total_CEROS >= 7){
                                                            simbolo_2 = 1;

                                                            resultado = f_GetResultadoSimbolo(total_CEROS, val.Ley_Ag_gt);
                                                        }

                                                    if (simbolo_1 == 0 && simbolo_2 == 0){
                                                        resultado = parseFloat(val.Ley_Ag_gt).toFixed(2);
                                                    }
                                                }
                                                else{
                                                    resultado = null;
                                                }

                                                var resultado_ag = ((simbolo_1 == 1) ? '-' : resultado);

	                                    	htmlContenido_4 += '		<input type="text" id="ag_1_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'ag_1_" + c + "', " + "'Ley_Ag_gt'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

                                            _campos += 'CASE WHEN ISNULL(Ley_Ag_gt, 0) = 0 THEN 1 ELSE 0 END + ';
	                                    }

	                                    htmlContenido_4 += '	</b></td>';

	                              	// Au (g/tm)
                                    	_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('au') >= 0) ? 1 : 0 );

	                                    htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

	                                    if (_visible == 1){
                                            // Verifica que se una resulado con datos
                                                if (val.Ley_Au_gt != null){
                                                    simbolo_1 = 0;
                                                    simbolo_2 = 0;
                                                    resultado = '';

                                                    // Verifica si es: "-"
                                                        if (f_VerificaSimbolo(1, val.Ley_Au_gt) == 1){
                                                            simbolo_1 = 1;
                                                        }

                                                    // Verifica si es: "<" ó ">"
                                                        var total_CEROS = f_VerificaSimbolo(2, val.Ley_Au_gt)

                                                        if (total_CEROS >= 7){
                                                            simbolo_2 = 1;

                                                            resultado = f_GetResultadoSimbolo(total_CEROS, val.Ley_Au_gt);
                                                        }

                                                    if (simbolo_1 == 0 && simbolo_2 == 0){
                                                        resultado = parseFloat(val.Ley_Au_gt).toFixed(2);
                                                    }
                                                }
                                                else{
                                                    resultado = null;
                                                }

                                                var resultado_au = ((simbolo_1 == 1) ? '-' : resultado);

	                                    	htmlContenido_4 += '        <input type="text" id="au_1_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'au_1_" + c + "', " + "'Ley_Au_gt'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

                                            _campos += 'CASE WHEN ISNULL(Ley_Au_gt, 0) = 0 THEN 1 ELSE 0 END + ';
	                                    }

	                                    htmlContenido_4 += '	</b></td>';

	                               	// Ag (oz/tc)
                                        _visible = ((val.Elemento_Analisis.toLowerCase().indexOf('ag') >= 0) ? 1 : 0 );

                                        htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

                                        if (_visible == 1){
                                            var _resultado = ((resultado_ag == null) ? '' : f_GetResultadoOnzas(resultado_ag, 'ag', c));

                                            // htmlContenido_4 += '     <input type="text" id="ag_2_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'ag_2_" + c + "', " + "'Ley_Ag_ot'" + ')" ' + ((val.Ley_Ag_ot == null) ? '' : ((val.Ley_Ag_gt == '-') ? 'value="-' : 'value="' + parseFloat(val.Ley_Ag_ot).toFixed(2)) + '"') + ' disabled>';

                                            htmlContenido_4 += '        <input type="text" id="ag_2_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'ag_2_" + c + "', " + "'Ley_Ag_ot'" + ')" ' + ((_resultado == '-') ? 'value="-' : 'value="' + _resultado) + '"' + ' disabled>';

                                            _campos += 'CASE WHEN ISNULL(Ley_Ag_ot, 0) = 0 THEN 1 ELSE 0 END + ';
                                        }

                                        htmlContenido_4 += '    </b></td>';

                                    // Au (oz/tc)
                                        _visible = ((val.Elemento_Analisis.toLowerCase().indexOf('au') >= 0) ? 1 : 0 );

                                        htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

                                        if (_visible == 1){
                                            var _resultado = ((resultado_au == null) ? '' : f_GetResultadoOnzas(resultado_au, 'au', c));

                                            htmlContenido_4 += '        <input type="text" id="au_2_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'au_2_" + c + "', " + "'Ley_Au_ot'" + ')" ' + ((_resultado == '-') ? 'value="-' : 'value="' + _resultado) + '"' + ' disabled>';

                                            _campos += 'CASE WHEN ISNULL(Ley_Au_ot, 0) = 0 THEN 1 ELSE 0 END + ';
                                        }

                                        htmlContenido_4 += '    </b></td>';

                                    // % cu
                                        _visible = ((val.Elemento_Analisis.toLowerCase().indexOf('cu') >= 0) ? 1 : 0 );

                                        htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

                                        if (_visible == 1){
                                            // Verifica que se una resulado con datos
                                                if (val.Porc_CU != null){
                                                    simbolo_1 = 0;
                                                    simbolo_2 = 0;
                                                    resultado = '';

                                                    // Verifica si es: "-"
                                                        if (f_VerificaSimbolo(1, val.Porc_CU) == 1){
                                                            simbolo_1 = 1;
                                                        }

                                                    // Verifica si es: "<" ó ">"
                                                        var total_CEROS = f_VerificaSimbolo(2, val.Porc_CU)

                                                        if (total_CEROS >= 7){
                                                            simbolo_2 = 1;

                                                            resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_CU);
                                                        }

                                                    if (simbolo_1 == 0 && simbolo_2 == 0){
                                                        resultado = parseFloat(val.Porc_CU).toFixed(2);
                                                    }
                                                }
                                                else{
                                                    resultado = null;
                                                }

                                                resultado = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido_4 += '        <input type="text" id="cu_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'cu_" + c + "', " + "'Porc_CU'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

                                            // htmlContenido_4 += '        <input type="text" id="au_1_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'au_1_" + c + "', " + "'Ley_Au_gt'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

                                            _campos += 'CASE WHEN ISNULL(Porc_CU, 0) = 0 THEN 1 ELSE 0 END + ';
                                        }

                                        htmlContenido_4 += '    </b></td>';

                                    // % pb
                                        _visible = ((val.Elemento_Analisis.toLowerCase().indexOf('pb') >= 0) ? 1 : 0 );

                                        htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

                                        if (_visible == 1){
                                            // Verifica que se una resulado con datos
                                                if (val.Porc_PB != null){
                                                    simbolo_1 = 0;
                                                    simbolo_2 = 0;
                                                    resultado = '';

                                                    // Verifica si es: "-"
                                                        if (f_VerificaSimbolo(1, val.Porc_PB) == 1){
                                                            simbolo_1 = 1;
                                                        }

                                                    // Verifica si es: "<" ó ">"
                                                        var total_CEROS = f_VerificaSimbolo(2, val.Porc_PB)

                                                        if (total_CEROS >= 7){
                                                            simbolo_2 = 1;

                                                            resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_PB);
                                                        }

                                                    if (simbolo_1 == 0 && simbolo_2 == 0){
                                                        resultado = parseFloat(val.Porc_PB).toFixed(2);
                                                    }
                                                }
                                                else{
                                                    resultado = null;
                                                }

                                                resultado = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido_4 += '        <input type="text" id="pb_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'pb_" + c + "', " + "'Porc_PB'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

                                            _campos += 'CASE WHEN ISNULL(Porc_PB, 0) = 0 THEN 1 ELSE 0 END + ';
                                        }

                                        htmlContenido_4 += '    </b></td>';

                                    // % zn
                                        _visible = ((val.Elemento_Analisis.toLowerCase().indexOf('zn') >= 0) ? 1 : 0 );

                                        htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

                                        if (_visible == 1){
                                            // Verifica que se una resulado con datos
                                                if (val.Porc_ZN != null){
                                                    simbolo_1 = 0;
                                                    simbolo_2 = 0;
                                                    resultado = '';

                                                    // Verifica si es: "-"
                                                        if (f_VerificaSimbolo(1, val.Porc_ZN) == 1){
                                                            simbolo_1 = 1;
                                                        }

                                                    // Verifica si es: "<" ó ">"
                                                        var total_CEROS = f_VerificaSimbolo(2, val.Porc_ZN)

                                                        if (total_CEROS >= 7){
                                                            simbolo_2 = 1;

                                                            resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_ZN);
                                                        }

                                                    if (simbolo_1 == 0 && simbolo_2 == 0){
                                                        resultado = parseFloat(val.Porc_ZN).toFixed(2);
                                                    }
                                                }
                                                else{
                                                    resultado = null;
                                                }

                                                resultado = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido_4 += '        <input type="text" id="zn_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'zn_" + c + "', " + "'Porc_ZN'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

                                            _campos += 'CASE WHEN ISNULL(Porc_ZN, 0) = 0 THEN 1 ELSE 0 END + ';
                                        }

                                        htmlContenido_4 += '    </b></td>';

                                    // % as
                                        _visible = ((val.Elemento_Analisis.toLowerCase().indexOf('as') >= 0) ? 1 : 0 );

                                        htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

                                        if (_visible == 1){
                                            // Verifica que se una resulado con datos
                                                if (val.Porc_AS != null){
                                                    simbolo_1 = 0;
                                                    simbolo_2 = 0;
                                                    resultado = '';

                                                    // Verifica si es: "-"
                                                        if (f_VerificaSimbolo(1, val.Porc_AS) == 1){
                                                            simbolo_1 = 1;
                                                        }

                                                    // Verifica si es: "<" ó ">"
                                                        var total_CEROS = f_VerificaSimbolo(2, val.Porc_AS)

                                                        if (total_CEROS >= 7){
                                                            simbolo_2 = 1;

                                                            resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_AS);
                                                        }

                                                    if (simbolo_1 == 0 && simbolo_2 == 0){
                                                        resultado = parseFloat(val.Porc_AS).toFixed(2);
                                                    }
                                                }
                                                else{
                                                    resultado = null;
                                                }

                                                resultado = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido_4 += '        <input type="text" id="as_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'as_" + c + "', " + "'Porc_AS'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

                                            _campos += 'CASE WHEN ISNULL(Porc_AS, 0) = 0 THEN 1 ELSE 0 END + ';
                                        }

                                        htmlContenido_4 += '    </b></td>';

                                    // % sb
                                        _visible = ((val.Elemento_Analisis.toLowerCase().indexOf('sb') >= 0) ? 1 : 0 );

                                        htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

                                        if (_visible == 1){
                                            // Verifica que se una resulado con datos
                                                if (val.Porc_SB != null){
                                                    simbolo_1 = 0;
                                                    simbolo_2 = 0;
                                                    resultado = '';

                                                    // Verifica si es: "-"
                                                        if (f_VerificaSimbolo(1, val.Porc_SB) == 1){
                                                            simbolo_1 = 1;
                                                        }

                                                    // Verifica si es: "<" ó ">"
                                                        var total_CEROS = f_VerificaSimbolo(2, val.Porc_SB)

                                                        if (total_CEROS >= 7){
                                                            simbolo_2 = 1;

                                                            resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_SB);
                                                        }

                                                    if (simbolo_1 == 0 && simbolo_2 == 0){
                                                        resultado = parseFloat(val.Porc_SB).toFixed(2);
                                                    }
                                                }
                                                else{
                                                    resultado = null;
                                                }

                                                resultado = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido_4 += '        <input type="text" id="sb_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'sb_" + c + "', " + "'Porc_SB'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

                                            _campos += 'CASE WHEN ISNULL(Porc_SB, 0) = 0 THEN 1 ELSE 0 END + ';
                                        }

                                        htmlContenido_4 += '    </b></td>';

                                    // % s
                                        _visible = ((('|' + val.Elemento_Analisis).toLowerCase().indexOf('|s') >= 0) ? 1 : 0 );

                                        htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

                                        if (_visible == 1){
                                            // Verifica que se una resulado con datos
                                                if (val.Porc_S != null){
                                                    simbolo_1 = 0;
                                                    simbolo_2 = 0;
                                                    resultado = '';

                                                    // Verifica si es: "-"
                                                        if (f_VerificaSimbolo(1, val.Porc_S) == 1){
                                                            simbolo_1 = 1;
                                                        }

                                                    // Verifica si es: "<" ó ">"
                                                        var total_CEROS = f_VerificaSimbolo(2, val.Porc_S)

                                                        if (total_CEROS >= 7){
                                                            simbolo_2 = 1;

                                                            resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_S);
                                                        }

                                                    if (simbolo_1 == 0 && simbolo_2 == 0){
                                                        resultado = parseFloat(val.Porc_S).toFixed(2);
                                                    }
                                                }
                                                else{
                                                    resultado = null;
                                                }

                                                resultado = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido_4 += '        <input type="text" id="s_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 's_" + c + "', " + "'Porc_S'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

                                            _campos += 'CASE WHEN ISNULL(Porc_S, 0) = 0 THEN 1 ELSE 0 END + ';
                                        }

                                        htmlContenido_4 += '    </b></td>';

                                    // % fe
                                        _visible = ((val.Elemento_Analisis.toLowerCase().indexOf('fe') >= 0) ? 1 : 0 );

                                        htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

                                        if (_visible == 1){
                                            // Verifica que se una resulado con datos
                                                if (val.Porc_FE != null){
                                                    simbolo_1 = 0;
                                                    simbolo_2 = 0;
                                                    resultado = '';

                                                    // Verifica si es: "-"
                                                        if (f_VerificaSimbolo(1, val.Porc_FE) == 1){
                                                            simbolo_1 = 1;
                                                        }

                                                    // Verifica si es: "<" ó ">"
                                                        var total_CEROS = f_VerificaSimbolo(2, val.Porc_FE)

                                                        if (total_CEROS >= 7){
                                                            simbolo_2 = 1;

                                                            resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_FE);
                                                        }

                                                    if (simbolo_1 == 0 && simbolo_2 == 0){
                                                        resultado = parseFloat(val.Porc_FE).toFixed(2);
                                                    }
                                                }
                                                else{
                                                    resultado = null;
                                                }

                                                resultado = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido_4 += '        <input type="text" id="fe_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'fe_" + c + "', " + "'Porc_FE'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

                                            _campos += 'CASE WHEN ISNULL(Porc_FE, 0) = 0 THEN 1 ELSE 0 END + ';
                                        }

                                        htmlContenido_4 += '    </b></td>';

                                    // % h2o
                                        _visible = ((val.Elemento_Analisis.toLowerCase().indexOf('h2o') >= 0) ? 1 : 0 );

                                        htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

                                        if (_visible == 1){
                                            // Verifica que se una resulado con datos
                                                if (val.Porc_H2O != null){
                                                    simbolo_1 = 0;
                                                    simbolo_2 = 0;
                                                    resultado = '';

                                                    // Verifica si es: "-"
                                                        if (f_VerificaSimbolo(1, val.Porc_H2O) == 1){
                                                            simbolo_1 = 1;
                                                        }

                                                    // Verifica si es: "<" ó ">"
                                                        var total_CEROS = f_VerificaSimbolo(2, val.Porc_H2O)

                                                        if (total_CEROS >= 7){
                                                            simbolo_2 = 1;

                                                            resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_H2O);
                                                        }

                                                    if (simbolo_1 == 0 && simbolo_2 == 0){
                                                        resultado = parseFloat(val.Porc_H2O).toFixed(2);
                                                    }
                                                }
                                                else{
                                                    resultado = null;
                                                }

                                                resultado = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido_4 += '        <input type="text" id="h2o_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'h2o_" + c + "', " + "'Porc_H2O'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

                                            _campos += 'CASE WHEN ISNULL(Porc_H2O, 0) = 0 THEN 1 ELSE 0 END + ';
                                        }

                                        htmlContenido_4 += '    </b></td>';

                                    // Arma el botón de cierre de resultados
                                        htmlContenido_2 += '    <input id="sel_' + c + '" type="checkbox" onchange="f_SeleccionaResultados(' + "'sel_" + c + "'" + ')">';
                                        htmlContenido_2 += '</center></td>';

                                    // Se continua armando el html de la tabla
                                        htmlContenido = htmlContenido + htmlContenido_2 + htmlContenido_3 + htmlContenido_4;

	                              	// Observación Reporte
	                                    htmlContenido += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

	                                    htmlContenido += '		<input type="text" id="observacion_reporte_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'observacion_reporte_" + c + "', " + "'Observacion_Reporte'" + ')" ' + ((val.Observacion_Reporte == null) ? '' : 'value="' + val.Observacion_Reporte) + '"' + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

	                                    htmlContenido += '	</b></td>';

	                              	if (val.Cod_EstadoResultadosCliente == 2){
                                    	htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;" onclick="f_PrintDocumentosCliente(1, ' + val.Id_Pedido + ', ' + val.Id_Detalle + ", '" + val.cRazonSocial + "', '" + val.Nombre_TipoMuestra + "', '" + val.Nom_Muestra + "', " + val.Peso_Muestra + ", '" + val.Nombre_DetalleEnvase + "', '" + val.FechaHora_Recepcion2 + "', '" + val.FechaHora_Entrega2 + "', '" + val.Elemento_Analisis + "', " + ((val.Ley_Au_gt == '-') ? 'null' : val.Ley_Au_gt) + ', ' + ((val.Ley_Au_gt == '-') ? 'null' : val.Ley_Au_ot) + ', ' + ((val.Ley_Ag_gt == '-') ? 'null' : val.Ley_Ag_gt) + ', ' + ((val.Ley_Ag_gt == '-') ? 'null' : val.Ley_Ag_ot) + ', ' + ((val.Porc_CU == '-') ? 'null' : val.Porc_CU) + ', ' + ((val.Porc_PB == '-') ? 'null' : val.Porc_PB) + ', ' + ((val.Porc_ZN == '-') ? 'null' : val.Porc_ZN) + ', ' + ((val.Porc_AS == '-') ? 'null' : val.Porc_AS) + ', ' + ((val.Porc_SB == '-') ? 'null' : val.Porc_SB) + ', ' + ((val.Porc_S == '-') ? 'null' : val.Porc_S) + ', ' + ((val.Porc_FE == '-') ? 'null' : val.Porc_FE) + ', ' + ((val.Porc_H2O == '-') ? 'null' : val.Porc_H2O) + ", '" + val.Fecha_Informe + "', '" + ((val.Observacion_Reporte == null) ? '' : val.Observacion_Reporte) + "', " + val.Documento_Cliente + ", '" + val.TELEFONO_CLIENTE + "', '" + val.cEmail + "', " + val.Sucursal + ", '" + val.NOMBRE_EMPRESA + "', " + val.Tipo_Muestra + ", '" + val.Des_TipoAnalisis + "', '" + val.Fecha_CierreInforme + "', '" + val.Referencia_Cliente + "', '" + val.Fecha_InicioEnsayo.substr(0, 10) + "', '" + val.Cod_Interno + "', " + val.Mostrar_Contacto + ')"><center>';
	                                    htmlContenido += '  	<img src="images/qr.png" width="30px"></img>';
	                                    htmlContenido += '  	<label style="cursor: pointer">QR</label>';
	                                    htmlContenido += '</center></td>';

	                                    htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;" onclick="f_PrintDocumentosCliente(2, ' + val.Id_Pedido + ', ' + val.Id_Detalle + ", '" + val.cRazonSocial + "', '" + val.Nombre_TipoMuestra + "', '" + val.Nom_Muestra + "', " + val.Peso_Muestra + ", '" + val.Nombre_DetalleEnvase + "', '" + val.FechaHora_Recepcion2 + "', '" + val.FechaHora_Entrega2 + "', '" + val.Elemento_Analisis + "', " + ((val.Ley_Au_gt == '-') ? 'null' : val.Ley_Au_gt) + ', ' + ((val.Ley_Au_gt == '-') ? 'null' : val.Ley_Au_ot) + ', ' + ((val.Ley_Ag_gt == '-') ? 'null' : val.Ley_Ag_gt) + ', ' + ((val.Ley_Ag_gt == '-') ? 'null' : val.Ley_Ag_ot) + ', ' + ((val.Porc_CU == '-') ? 'null' : val.Porc_CU) + ', ' + ((val.Porc_PB == '-') ? 'null' : val.Porc_PB) + ', ' + ((val.Porc_ZN == '-') ? 'null' : val.Porc_ZN) + ', ' + ((val.Porc_AS == '-') ? 'null' : val.Porc_AS) + ', ' + ((val.Porc_SB == '-') ? 'null' : val.Porc_SB) + ', ' + ((val.Porc_S == '-') ? 'null' : val.Porc_S) + ', ' + ((val.Porc_FE == '-') ? 'null' : val.Porc_FE) + ', ' + ((val.Porc_H2O == '-') ? 'null' : val.Porc_H2O) + ", '" + val.Fecha_Informe + "', '" + ((val.Observacion_Reporte == null) ? '' : val.Observacion_Reporte) + "', " + val.Documento_Cliente + ", '" + val.TELEFONO_CLIENTE + "', '" + val.cEmail + "', " + val.Sucursal + ", '" + val.NOMBRE_EMPRESA + "', " + val.Tipo_Muestra + ", '" + val.Des_TipoAnalisis + "', '" + val.Fecha_CierreInforme + "', '" + val.Referencia_Cliente + "', '" + val.Fecha_InicioEnsayo.substr(0, 10) + "', '" + val.Cod_Interno + "', " + val.Mostrar_Contacto + ')"><center>';
	                                    htmlContenido += '  	<img src="images/certificacion.png" width="25px"></img>';
	                                    htmlContenido += '  	<label style="cursor: pointer">Informe</label>';
										htmlContenido += '</center></td>';
                                    }
                                    else{
                                    	htmlContenido += '<td></td>';
                                    	htmlContenido += '<td></td>';
                                    }

                                    htmlContenido += "</tr>";

                                    c += 1;
                                });

                            }
                            else{
                            	alert("No se encontraron resultados para la búsqueda solicitada");
                            }

                            total_resultados = c - 1;
                            $("#lbl_seleccionados").html(0);
                            $("#lbl_codigos").html('');

                            // Cerrando Modal
								$('#divmodal_Loading').modal('hide');

                            $("#tabla_analisisresultados").html(htmlContenido);
                        }, "json");
	    	};

	    	function f_PrintDocumentosCliente(_TipoDocumento, _Id_Pedido, _Id_DetallePedido, _Cliente, _TipoMuestra, _NomMuestra, _PesoMuestra, _Detalle_Envase, _Fecha_Recepcion, _Fecha_Entrega, _Elemento_Analisis, _Ley_Au_gt, _Ley_Au_ot, _Ley_Ag_gt, _Ley_Ag_ot, _Porc_CU, _Porc_PB, _Porc_ZN, _Porc_AS, _Porc_SB, _Porc_S, _Porc_FE, _Porc_H2O, _Fecha_Informe, _Obs_Reporte, _Documento_Cliente, _Telefono_Cliente, _Cliente_Email, _Sucursal, _Nombre_Empresa, _Cod_TipoMuestra, _Tipo_Ensayo, _Fecha_CierreInforme, _Referencia_Cliente, _Fecha_InicioEnsayo, _Codigo_Interno, _Mostrar_Contacto){

                var url = 'print_informeensayos_new.php?Id=' + _Id_Pedido + '&Id_Detalle=' + _Id_DetallePedido + '&Cli=' + _Cliente.replace(/[*]/g, '').replace(/[&]/g, 'y') + '&TM=' + _TipoMuestra + '&M=' + _NomMuestra + '&PM=' + _PesoMuestra + '&DE=' + _Detalle_Envase + '&FR=' + _Fecha_Recepcion + '&FE=' + _Fecha_Entrega + '&EA=' + _Elemento_Analisis + "&augt=" + _Ley_Au_gt + "&auot=" + _Ley_Au_ot + "&aggt=" + _Ley_Ag_gt + "&agot=" + _Ley_Ag_ot + "&cu=" + _Porc_CU + "&pb=" + _Porc_PB + "&zn=" + _Porc_ZN + "&as=" + _Porc_AS + "&sb=" + _Porc_SB + "&s=" + _Porc_S + "&fe=" + _Porc_FE + "&ho=" + _Porc_H2O + "&FI=" + _Fecha_Informe + "&Obs=" + _Obs_Reporte + "&DC=" + _Documento_Cliente + "&TC=" + _Telefono_Cliente + "&CEM=" + _Cliente_Email + "&S=" + _Sucursal + "&NE=" + _Nombre_Empresa.replace(/[*]/g, '').replace(/[&]/g, 'y') + "&CTM=" + _Cod_TipoMuestra + "&TE=" + _Tipo_Ensayo + "&FCI=" + _Fecha_CierreInforme + "&RC=" + _Referencia_Cliente + "&FIE=" + _Fecha_InicioEnsayo + "&CI=" + _Codigo_Interno + "&MC=" + _Mostrar_Contacto;

	    		if (_TipoDocumento == 2){
                	window.open(url, '_blank');
	    		}
	    		else{
	    			$("#qr_id_pedido").val(_Id_Pedido);
					$("#qr_id_detallepedido").val(_Id_DetallePedido);

	    			// Generando la ruta de la imagen QR
                        var ruta = String(window.location);
                        ruta = ruta.substr(0, ruta.indexOf('usuario/'));
                        ruta = ruta + 'usuario/' + url.replace(/[ ]/g, '*');

                    var modal = $("#divmodal_qr");

	    			$("#qr_muestra").val(_NomMuestra.trim());
	    			$("#qr_analisis").val(_Elemento_Analisis.trim());

	    			// Generando Código QR
	    				$.post( "ajax/encuesta.php", { accion: "Generate_QR", url: ruta, Id_Pedido: _Id_Pedido, Id_DetallePedido: _Id_DetallePedido },
	                        function( data ) {
	                            if(data.estado == 1){
	                                var qr_name = 'tmp_qr_' + _Id_Pedido + _Id_DetallePedido + '.png';

	                                document.getElementById('img_qr').src='tmp_files/' + qr_name;
	                            }
	                        }, "json");

	    			modal.modal({backdrop: 'static', keyboard: false});
	    		}
	    	};

	    	function f_DownloadImg(_Ind){
                var a = document.createElement('a');

                if (_Ind == 1){
                    var QR_Id_Pedido = $("#qr_id_pedido").val();
                    var QR_Id_DetallePedido = $("#qr_id_detallepedido").val();
                    var ruta = 'http://labperuminerals.intelli-apps.com/panel/usuario/tmp_files/tmp_qr_' + QR_Id_Pedido + QR_Id_DetallePedido + '.png';

                    a.download = 'QR - ' + $("#qr_muestra").val();
                }
                else{
                    var num_informe = $("#qr_informe").val();
                    var ruta = 'http://labperuminerals.intelli-apps.com/panel/usuario/tmp_files/tmp_qr_' + num_informe.replace(/ /g, '') + '.png';

                    a.download = 'QR - ' + num_informe.replace(/ /g, '');
                }

				
				a.target = '_blank';
				a.href= ruta;

				a.click();	    		
	    	};

            function f_VerificaSimbolo(_Tipo, _Resultado){
                var resultado = 0;

                // Verifica si es: "-"
                    if (_Tipo == 1){
                        if (_Resultado == 99999.99999){
                            resultado = 1;
                        }
                    }

                // Verifica si es: "<" ó ">"
                    if (_Tipo == 2){
                        var num_ceros = 0;

                        // Comprobando el total de nueves
                            num_ceros = _Resultado.toString().substr(_Resultado.toString().length - 10);

                            if (num_ceros != '9999999999'){
                                num_ceros = _Resultado.toString().substr(_Resultado.toString().length - 9);

                                if (num_ceros != '999999999'){
                                    num_ceros = _Resultado.toString().substr(_Resultado.toString().length - 8);

                                    if (num_ceros != '99999999'){
                                        num_ceros = _Resultado.toString().substr(_Resultado.toString().length - 7);

                                        if (num_ceros != '9999999'){
                                            num_ceros = 0;
                                        }
                                    }
                                }
                            }

                        resultado = num_ceros.length;
                    }

                return resultado;
            };

            function f_GetResultadoSimbolo(_Num_Ceros, _Resultado){
                var simbolo = '';
                var is_entero = 0;
                var num_left = '';
                var decimal = '';
                var num_entero = '';
                var c = 0;
                var num_ceros = '';

                // Determinando el símbolo
                    if (_Num_Ceros >= 7 && _Num_Ceros <= 8){
                        simbolo = '<';
                        is_entero = ((_Num_Ceros == 7) ? 1 : 0);
                    }

                    if (_Num_Ceros >= 9 && _Num_Ceros <= 10){
                        simbolo = '>';
                        is_entero = ((_Num_Ceros == 9) ? 1 : 0);
                    }

                // Obteniendo resultados
                    num_left = _Resultado.toString().substr(0, _Resultado.toString().indexOf('.'));

                    if (is_entero == 1){
                        _Resultado = simbolo + ' ' + (parseInt(num_left) + 1);
                    }
                    else{
                        // Obtiene la parte decimal
                            decimal = _Resultado.toString().substr(_Resultado.toString().indexOf('.') + 1);

                        // Obteniene el número entero de los decimales
                            var menos_un_cero = 0;

                            num_entero = decimal.substr(0, decimal.length - _Num_Ceros);
                            menos_un_cero = ((parseInt(num_entero) == 0) ? 1 : 0);

                            num_entero = parseInt(num_entero) + 1;

                        // 2. Obteniendo la cantidad de CEROS de la parte decimal
                            while (c < (decimal.substr(0, decimal.length - _Num_Ceros).length - menos_un_cero)){
                              if (decimal.substr(c, 1) == 0){
                                num_ceros += '0';
                              }

                              c += 1;
                            }

                        _Resultado = simbolo + ' ' + num_left + '.' + num_ceros + num_entero;
                    }

                return _Resultado;
            };

            // Actualiza a Onzas si es Au y/o Ag
            function f_GetResultadoOnzas(_Resultado, _Elemento, _Id){
                var resultado = _Resultado;
                var elemento = _Elemento;
                var id = _Id;

                var _resultado = '';
                var factor = 34.285;

                if (elemento == 'au' || elemento == 'ag'){
                    if (resultado.trim() == '-'){
                        _resultado = '-';
                    }
                    else{
                        var simbolo = resultado.trim().substr(0, 1);

                        if (simbolo == '<' || simbolo == '>'){
                            if (simbolo == '<'){
                                _resultado = '-';
                            }
                            else{
                                _resultado = resultado.trim().substr(1);

                                _resultado = '> ' + parseFloat(_resultado / factor).toFixed(2);
                            }
                        }
                        else{
                            if (resultado.trim().length == 0){
                                _resultado = '';
                            }
                            else{
                                _resultado = parseFloat(resultado / factor).toFixed(2);
                            }
                        }
                    }

                    return _resultado;
                }
            };

            function f_GenerarInformes(){
                var CI = $("#lbl_codigos").html().replace(/ /g, '');

                if (CI.length == 0){
                    alert('Debe seleccionar al menos una muestra para continuar');

                    return;
                }

                var modal = $("#divmodal_InformesAgrupados");

                // Loading Modal
                    var modal_loading = $("#divmodal_Loading");
                    modal_loading.modal({backdrop: 'static', keyboard: false});

                // Pintando datos
                    var htmlContenido = '';
                    var d = 1;

                    $("#table_agrupados").html(htmlContenido);

                    $.post( "ajax/encuesta.php", { accion: "Get_InformesAgrupados", lista_CI: CI }, 
                        function( data ) {
                            if(data.estado == 1){
                                $.each( data.registros, function( key, val ) {
                                    htmlContenido += '<tr style="font-size: 14px;">';

                                    if (val.TIPO == 1){
                                        htmlContenido += '   <td colspan="15" style="border: solid; border-width: 1px; border-color: #BDBFB8; background-color: #737373; color: #ffffff; height: 35px">'
                                        htmlContenido += '       &nbsp;&nbsp; Informe de Ensayo N°: <b>' + ((val.Sucursal == 2) ? 'SU ' : '') + val.CORRELATIVO + '</b>&nbsp;&nbsp;&nbsp; | &nbsp;&nbsp;&nbsp; Fecha de Recepción: <b>' + val.FechaHora_Recepcion + '</b>&nbsp;&nbsp;&nbsp; | &nbsp;&nbsp;&nbsp; Fecha de Entrega: <b>' + val.FechaHora_Entrega + '</b>&nbsp;&nbsp;&nbsp; | &nbsp;&nbsp;&nbsp; Cantidad de Muestras: <b>' + val.TOTAL_MUESTRAS + '</b>';
                                        htmlContenido += '   </td>'

                                        htmlContenido += '  <td rowspan="' + (val.TOTAL_MUESTRAS + 1) + '" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;" onclick="f_PrintInformesAgrupados(1, ' + val.Id_Pedido + ", '" + CI + "', '" + ((val.Sucursal == 2) ? 'SU ' : '') + val.CORRELATIVO + "'" + ')"><center>';
                                        htmlContenido += '      <img src="images/qr.png" width="30px"></img>';
                                        htmlContenido += '      <label style="cursor: pointer">QR</label>';
                                        htmlContenido += '</center></td>';

                                        htmlContenido += '  <td rowspan=' + (val.TOTAL_MUESTRAS + 1) + '" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;" onclick="f_PrintInformesAgrupados(2, ' + val.Id_Pedido + ", '" + CI + "', '" + ((val.Sucursal == 2) ? 'SU ' : '') + val.CORRELATIVO + "'" + ')"><center>';
                                        htmlContenido += '      <img src="images/certificacion.png" width="25px"></img>';
                                        htmlContenido += '      <label style="cursor: pointer">Informe</label>';
                                        htmlContenido += '</center></td>';

                                        d = 0;
                                    }
                                    else{
                                        htmlContenido += '   <td style="border: solid; border-width: 1px; border-color: #BDBFB8; text-align: right; background-color: #91C9E8; color: #ffffff; text-align: center; height: 35px">'
                                        htmlContenido += '       ' + d.toString();
                                        htmlContenido += '   </td>'
                                        htmlContenido += '   <td style="border: solid; border-width: 1px; border-color: #BDBFB8; text-align: center; background-color: #FC585C; color: #ffffff"><b>'
                                        htmlContenido += '       ' + val.Cod_Interno;
                                        htmlContenido += '   </b></td>'

                                        // Au (g/tm): Verifica que se una resulado con datos
                                            if (val.Ley_Ag_gt != null){
                                                simbolo_1 = 0;
                                                simbolo_2 = 0;
                                                resultado = '';

                                                // Verifica si es: "-"
                                                    if (f_VerificaSimbolo(1, val.Ley_Ag_gt) == 1){
                                                        simbolo_1 = 1;
                                                    }

                                                // Verifica si es: "<" ó ">"
                                                    var total_CEROS = f_VerificaSimbolo(2, val.Ley_Ag_gt)

                                                    if (total_CEROS >= 7){
                                                        simbolo_2 = 1;

                                                        resultado = f_GetResultadoSimbolo(total_CEROS, val.Ley_Ag_gt);
                                                    }

                                                if (simbolo_1 == 0 && simbolo_2 == 0){
                                                    resultado = parseFloat(val.Ley_Ag_gt).toFixed(2);
                                                }
                                            }
                                            else{
                                                resultado = null;
                                            }

                                            var resultado_ag = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido += '   <td style="border: solid; border-width: 1px; border-color: #BDBFB8; text-align: center; background-color: #8EA651; color: #ffffff">'
                                            // htmlContenido += '       ' + ((val.Ley_Ag_gt == null) ? '' : parseFloat(val.Ley_Ag_gt).toFixed(2));
                                            htmlContenido += '       ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? '-' : resultado));
                                            htmlContenido += '   </td>'

                                        // Au (g/tm): Verifica que se una resulado con datos
                                            if (val.Ley_Au_gt != null){
                                                simbolo_1 = 0;
                                                simbolo_2 = 0;
                                                resultado = '';

                                                // Verifica si es: "-"
                                                    if (f_VerificaSimbolo(1, val.Ley_Au_gt) == 1){
                                                        simbolo_1 = 1;
                                                    }

                                                // Verifica si es: "<" ó ">"
                                                    var total_CEROS = f_VerificaSimbolo(2, val.Ley_Au_gt)

                                                    if (total_CEROS >= 7){
                                                        simbolo_2 = 1;

                                                        resultado = f_GetResultadoSimbolo(total_CEROS, val.Ley_Au_gt);
                                                    }

                                                if (simbolo_1 == 0 && simbolo_2 == 0){
                                                    resultado = parseFloat(val.Ley_Au_gt).toFixed(2);
                                                }
                                            }
                                            else{
                                                resultado = null;
                                            }

                                            var resultado_au = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido += '   <td style="border: solid; border-width: 1px; border-color: #BDBFB8; text-align: center; background-color: #8EA651; color: #ffffff">'
                                            // htmlContenido += '       ' + ((val.Ley_Au_gt == null) ? '' : parseFloat(val.Ley_Au_gt).toFixed(2));
                                            htmlContenido += '       ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? '-' : resultado));
                                            htmlContenido += '   </td>'

                                        // Ag (oz/tc)
                                            var _resultado = ((resultado_ag == null) ? '' : f_GetResultadoOnzas(resultado_ag, 'ag', d));

                                            htmlContenido += '   <td style="border: solid; border-width: 1px; border-color: #BDBFB8; text-align: center; background-color: #8EA651; color: #ffffff">'
                                            // htmlContenido += '       ' + ((val.Ley_Ag_ot == null) ? '' : parseFloat(val.Ley_Ag_ot).toFixed(2));
                                            htmlContenido += '       ' + ((_resultado == '-') ? '-' : _resultado);
                                            htmlContenido += '   </td>'

                                        // Au (oz/tc)
                                            var _resultado = ((resultado_au == null) ? '' : f_GetResultadoOnzas(resultado_au, 'au', d));

                                            htmlContenido += '   <td style="border: solid; border-width: 1px; border-color: #BDBFB8; text-align: center; background-color: #8EA651; color: #ffffff">'
                                            // htmlContenido += '       ' + ((val.Ley_Au_ot == null) ? '' : parseFloat(val.Ley_Au_ot).toFixed(2));
                                            htmlContenido += '       ' + ((_resultado == '-') ? '-' : _resultado);
                                            htmlContenido += '   </td>'

                                        // % cu: Verifica que se una resulado con datos
                                            if (val.Porc_CU != null){
                                                simbolo_1 = 0;
                                                simbolo_2 = 0;
                                                resultado = '';

                                                // Verifica si es: "-"
                                                    if (f_VerificaSimbolo(1, val.Porc_CU) == 1){
                                                        simbolo_1 = 1;
                                                    }

                                                // Verifica si es: "<" ó ">"
                                                    var total_CEROS = f_VerificaSimbolo(2, val.Porc_CU)

                                                    if (total_CEROS >= 7){
                                                        simbolo_2 = 1;

                                                        resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_CU);
                                                    }

                                                if (simbolo_1 == 0 && simbolo_2 == 0){
                                                    resultado = parseFloat(val.Porc_CU).toFixed(2);
                                                }
                                            }
                                            else{
                                                resultado = null;
                                            }

                                            resultado = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido += '   <td style="border: solid; border-width: 1px; border-color: #BDBFB8; text-align: center; background-color: #8EA651; color: #ffffff">'
                                            // htmlContenido += '       ' + ((val.Porc_CU == null) ? '' : parseFloat(val.Porc_CU).toFixed(2));
                                            htmlContenido += '       ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? '-' : resultado));
                                            htmlContenido += '   </td>'

                                        // % pb: Verifica que se una resulado con datos
                                            if (val.Porc_PB != null){
                                                simbolo_1 = 0;
                                                simbolo_2 = 0;
                                                resultado = '';

                                                // Verifica si es: "-"
                                                    if (f_VerificaSimbolo(1, val.Porc_PB) == 1){
                                                        simbolo_1 = 1;
                                                    }

                                                // Verifica si es: "<" ó ">"
                                                    var total_CEROS = f_VerificaSimbolo(2, val.Porc_PB)

                                                    if (total_CEROS >= 7){
                                                        simbolo_2 = 1;

                                                        resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_PB);
                                                    }

                                                if (simbolo_1 == 0 && simbolo_2 == 0){
                                                    resultado = parseFloat(val.Porc_PB).toFixed(2);
                                                }
                                            }
                                            else{
                                                resultado = null;
                                            }

                                            resultado = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido += '   <td style="border: solid; border-width: 1px; border-color: #BDBFB8; text-align: center; background-color: #8EA651; color: #ffffff">'
                                            // htmlContenido += '       ' + ((val.Porc_PB == null) ? '' : parseFloat(val.Porc_PB).toFixed(2));
                                            htmlContenido += '       ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? '-' : resultado));
                                            htmlContenido += '   </td>'

                                        // % zn: Verifica que se una resulado con datos
                                            if (val.Porc_ZN != null){
                                                simbolo_1 = 0;
                                                simbolo_2 = 0;
                                                resultado = '';

                                                // Verifica si es: "-"
                                                    if (f_VerificaSimbolo(1, val.Porc_ZN) == 1){
                                                        simbolo_1 = 1;
                                                    }

                                                // Verifica si es: "<" ó ">"
                                                    var total_CEROS = f_VerificaSimbolo(2, val.Porc_ZN)

                                                    if (total_CEROS >= 7){
                                                        simbolo_2 = 1;

                                                        resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_ZN);
                                                    }

                                                if (simbolo_1 == 0 && simbolo_2 == 0){
                                                    resultado = parseFloat(val.Porc_ZN).toFixed(2);
                                                }
                                            }
                                            else{
                                                resultado = null;
                                            }

                                            resultado = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido += '   <td style="border: solid; border-width: 1px; border-color: #BDBFB8; text-align: center; background-color: #8EA651; color: #ffffff">'
                                            // htmlContenido += '       ' + ((val.Porc_ZN == null) ? '' : parseFloat(val.Porc_ZN).toFixed(2));
                                            htmlContenido += '       ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? '-' : resultado));
                                            htmlContenido += '   </td>'

                                        // % as: Verifica que se una resulado con datos
                                            if (val.Porc_AS != null){
                                                simbolo_1 = 0;
                                                simbolo_2 = 0;
                                                resultado = '';

                                                // Verifica si es: "-"
                                                    if (f_VerificaSimbolo(1, val.Porc_AS) == 1){
                                                        simbolo_1 = 1;
                                                    }

                                                // Verifica si es: "<" ó ">"
                                                    var total_CEROS = f_VerificaSimbolo(2, val.Porc_AS)

                                                    if (total_CEROS >= 7){
                                                        simbolo_2 = 1;

                                                        resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_AS);
                                                    }

                                                if (simbolo_1 == 0 && simbolo_2 == 0){
                                                    resultado = parseFloat(val.Porc_AS).toFixed(2);
                                                }
                                            }
                                            else{
                                                resultado = null;
                                            }

                                            resultado = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido += '   <td style="border: solid; border-width: 1px; border-color: #BDBFB8; text-align: center; background-color: #8EA651; color: #ffffff">'
                                            // htmlContenido += '       ' + ((val.Porc_AS == null) ? '' : parseFloat(val.Porc_AS).toFixed(2));
                                            htmlContenido += '       ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? '-' : resultado));
                                            htmlContenido += '   </td>'

                                        // % sb: Verifica que se una resulado con datos
                                            if (val.Porc_SB != null){
                                                simbolo_1 = 0;
                                                simbolo_2 = 0;
                                                resultado = '';

                                                // Verifica si es: "-"
                                                    if (f_VerificaSimbolo(1, val.Porc_SB) == 1){
                                                        simbolo_1 = 1;
                                                    }

                                                // Verifica si es: "<" ó ">"
                                                    var total_CEROS = f_VerificaSimbolo(2, val.Porc_SB)

                                                    if (total_CEROS >= 7){
                                                        simbolo_2 = 1;

                                                        resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_SB);
                                                    }

                                                if (simbolo_1 == 0 && simbolo_2 == 0){
                                                    resultado = parseFloat(val.Porc_SB).toFixed(2);
                                                }
                                            }
                                            else{
                                                resultado = null;
                                            }

                                            resultado = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido += '   <td style="border: solid; border-width: 1px; border-color: #BDBFB8; text-align: center; background-color: #8EA651; color: #ffffff">'
                                            // htmlContenido += '       ' + ((val.Porc_SB == null) ? '' : parseFloat(val.Porc_SB).toFixed(2));
                                            htmlContenido += '       ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? '-' : resultado));
                                            htmlContenido += '   </td>'

                                        // % s: Verifica que se una resulado con datos
                                            if (val.Porc_S != null){
                                                simbolo_1 = 0;
                                                simbolo_2 = 0;
                                                resultado = '';

                                                // Verifica si es: "-"
                                                    if (f_VerificaSimbolo(1, val.Porc_S) == 1){
                                                        simbolo_1 = 1;
                                                    }

                                                // Verifica si es: "<" ó ">"
                                                    var total_CEROS = f_VerificaSimbolo(2, val.Porc_S)

                                                    if (total_CEROS >= 7){
                                                        simbolo_2 = 1;

                                                        resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_S);
                                                    }

                                                if (simbolo_1 == 0 && simbolo_2 == 0){
                                                    resultado = parseFloat(val.Porc_S).toFixed(2);
                                                }
                                            }
                                            else{
                                                resultado = null;
                                            }

                                            resultado = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido += '   <td style="border: solid; border-width: 1px; border-color: #BDBFB8; text-align: center; background-color: #8EA651; color: #ffffff">'
                                            // htmlContenido += '       ' + ((val.Porc_S == null) ? '' : parseFloat(val.Porc_S).toFixed(2));
                                            htmlContenido += '       ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? '-' : resultado));
                                            htmlContenido += '   </td>'

                                        // % fe: Verifica que se una resulado con datos
                                            if (val.Porc_FE != null){
                                                simbolo_1 = 0;
                                                simbolo_2 = 0;
                                                resultado = '';

                                                // Verifica si es: "-"
                                                    if (f_VerificaSimbolo(1, val.Porc_FE) == 1){
                                                        simbolo_1 = 1;
                                                    }

                                                // Verifica si es: "<" ó ">"
                                                    var total_CEROS = f_VerificaSimbolo(2, val.Porc_FE)

                                                    if (total_CEROS >= 7){
                                                        simbolo_2 = 1;

                                                        resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_FE);
                                                    }

                                                if (simbolo_1 == 0 && simbolo_2 == 0){
                                                    resultado = parseFloat(val.Porc_FE).toFixed(2);
                                                }
                                            }
                                            else{
                                                resultado = null;
                                            }

                                            resultado = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido += '   <td style="border: solid; border-width: 1px; border-color: #BDBFB8; text-align: center; background-color: #8EA651; color: #ffffff">'
                                            // htmlContenido += '       ' + ((val.Porc_FE == null) ? '' : parseFloat(val.Porc_FE).toFixed(2));
                                            htmlContenido += '       ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? '-' : resultado));
                                            htmlContenido += '   </td>'

                                        // % h2o: Verifica que se una resulado con datos
                                            if (val.Porc_H2O != null){
                                                simbolo_1 = 0;
                                                simbolo_2 = 0;
                                                resultado = '';

                                                // Verifica si es: "-"
                                                    if (f_VerificaSimbolo(1, val.Porc_H2O) == 1){
                                                        simbolo_1 = 1;
                                                    }

                                                // Verifica si es: "<" ó ">"
                                                    var total_CEROS = f_VerificaSimbolo(2, val.Porc_H2O)

                                                    if (total_CEROS >= 7){
                                                        simbolo_2 = 1;

                                                        resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_H2O);
                                                    }

                                                if (simbolo_1 == 0 && simbolo_2 == 0){
                                                    resultado = parseFloat(val.Porc_H2O).toFixed(2);
                                                }
                                            }
                                            else{
                                                resultado = null;
                                            }

                                            resultado = ((simbolo_1 == 1) ? '-' : resultado);

                                            htmlContenido += '   <td style="border: solid; border-width: 1px; border-color: #BDBFB8; text-align: center; background-color: #8EA651; color: #ffffff">'
                                            // htmlContenido += '       ' + ((val.Porc_H2O == null) ? '' : parseFloat(val.Porc_H2O).toFixed(2));
                                            htmlContenido += '       ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? '-' : resultado));
                                            htmlContenido += '   </td>'

                                        htmlContenido += '   <td style="border: solid; border-width: 1px; border-color: #BDBFB8; text-align: center; background-color: #91C9E8; color: #ffffff">'
                                        htmlContenido += '       ' + ((val.Observacion_Reporte == null) ? '' : val.Observacion_Reporte);
                                        htmlContenido += '   </td>'
                                    }

                                    htmlContenido += '</tr>';

                                    d += 1;
                                });
                            }

                            // Cerrando Modal
                                $('#divmodal_Loading').modal('hide');

                            $("#table_agrupados").html(htmlContenido);
                        }, "json");

                modal.modal({backdrop: 'static', keyboard: false});
            };

            function f_PrintInformesAgrupados(_TipoDocumento, _Id_Pedido, _Codigos_Internos, _Num_Informe){
                var url = 'print_informeensayos_agrupados.php?Id=' + _Id_Pedido + '&CI=' + _Codigos_Internos.replace(/ /g, '');

                if (_TipoDocumento == 1){
                    $("#qr_id_pedido_agrupado").val(_Id_Pedido);
                    $("#qr_ci").val(_Codigos_Internos);

                    // Generando la ruta de la imagen QR
                        var ruta = String(window.location);
                        ruta = ruta.substr(0, ruta.indexOf('usuario/'));
                        ruta = ruta + 'usuario/' + url;

                    var modal = $("#divmodal_qr_agrupado");

                    $("#qr_informe").val(_Num_Informe.trim());
                    // $("#qr_muestras_ci").val(_Elemento_Analisis.trim());

                    // Generando Código QR
                        var _CI = '';

                        $.post( "ajax/encuesta.php", { accion: "Generate_QR_Agrupado", url: ruta, Id_Pedido: _Id_Pedido, CI: _Codigos_Internos, Num_Informe: _Num_Informe },
                            function( data ) {
                                if(data.estado == 1){
                                    $.each( data.registros, function( key, val ) {
                                        _CI += val.Cod_Interno + ' | ';
                                    });
                                }

                                $("#qr_muestras_ci").val(_CI.substring(0, _CI.length - 3));

                                var qr_name = 'tmp_qr_' + _Num_Informe.replace(/ /g, '') + '.png';

                                document.getElementById('img_qr_agrupado').src='tmp_files/' + qr_name;
                            }, "json");


                    modal.modal({backdrop: 'static', keyboard: false});

                    $('#divmodal_InformesAgrupados').modal('hide');
                }
                else{
                    window.open(url, '_blank');
                }
            };
	    </script>

	    <!-- Funciones para Grabar -->
	    <script type="text/javascript">
	    	function f_GrabarResultados(_Id_Pedido, _Id_DetallePedido, _Objeto, _Campo){
	    		var resultado = $("#" + _Objeto).val();

	    		// if (resultado.length > 0){
	    			$.post( "ajax/encuesta.php", { accion: "Grabar_AnalisisResultados", Id_Pedido: _Id_Pedido, Id_DetallePedido: _Id_DetallePedido, Resultado: ((resultado.length > 0) ? resultado : 'NULL'), Campo: _Campo }, 
	                    function( data ) {
	                        if(data.estado != 1){
	                            alert("Ocurrió un error al momento de grabar los datos");
	                        }
	                    }, "json");

	    			// Actualiza a Onzas si es Au y/o Ag
		    			var factor = 34.285;
		    			var elemento = _Objeto.substr(0, 2);

		    			if (elemento == 'au' || elemento == 'ag'){
		    				var id = _Objeto.substr(_Objeto.length - 1, 1);

		    				$("#" + elemento + '_2_' + id).val(parseFloat($("#" + _Objeto).val() / factor).toFixed(2));
		    			}
	    		// }
	    	};

	    	function f_UpdateCierre(_Id_Pedido, _Id_DetallePedido, _Orden, _Estado_Cierre, _Campos_Evaluados){
                // Loading Modal
                    var modal_loading = $("#divmodal_Loading");
                    modal_loading.modal({backdrop: 'static', keyboard: false});

                campos_evaluados = _Campos_Evaluados;

	    		// Validar que se haya igresado al menos un valor
	    			$.post( "ajax/encuesta.php", { accion: "Valida_IngresoResultados", Id_Pedido: _Id_Pedido, Id_DetallePedido: _Id_DetallePedido }, 
                        function( data ) {
                            if(data.estado == 1){
                                $.each( data.registros, function( key, val ) {
                                	if (val.TOTAL == 0){
                                		alert("No puede realizar el Pre Cierre de la muestra seleccionada hasta que por lo menos ingrese una ley.\n\nPor favor, verificar.");

                                        // Cerrando Modal
                                            $('#divmodal_Loading').modal('hide');
                                	}
                                	else{
                                		if (_Estado_Cierre == 0){
							    			if (confirm("Al aceptar este mensaje habilitará la visualización de los resultados ingresados para el Cliente.\n\n¿Está seguro de continuar?")){
								    			$("#img_" + _Orden).attr("src","images/check_b.png");

								    			$.post( "ajax/encuesta.php", { accion: "Grabar_CierreClientes", Id_Pedido: _Id_Pedido, Id_DetallePedido: _Id_DetallePedido, Estado_Cierre: 1 }, 
								                    function( data ) {
								                        if(data.estado == 1){
								                            // alert("El Pre Cierre fue realizado satisfactoriamente");

								                            f_LoadResultados();
								                        }
								                    }, "json");
								    		}
                                            else{
                                                // Cerrando Modal
                                                    $('#divmodal_Loading').modal('hide');
                                            }
							    		}
							    		else{
							    			var modal = $("#divmodal_Cierre");

							    			if (_Estado_Cierre == 1){
							    				$("#cierre_mensaje").html("<b>Al aceptar este mensaje está cerrando completamente el Análisis y el Cliente podrá descargar el Informe de Ensayos\n\n¿Está seguro de continuar?</b>");

							    				$("#btn_cerrar").prop("disabled", false);
							    			}

							    			if (_Estado_Cierre == 2){
							    				$("#cierre_mensaje").html("<b>Esta muestra se encuentra cerrada</b>");

							    				$("#btn_cerrar").prop("disabled", true);
							    			}

							    			$("#id_pedido").val(_Id_Pedido);
							    			$("#id_detallepedido").val(_Id_DetallePedido);
							    			$("#estado_cierre").val(_Estado_Cierre);
							    			$("#cierre_imageorden").val(_Orden);

											modal.modal({backdrop: 'static', keyboard: false});

                                            // Cerrando Modal
                                                $('#divmodal_Loading').modal('hide');
							    		}
                                	}
                                });

                            }
                            else{
                            	alert("No se encontraron resultados para la búsqueda solicitada");

                                // Cerrando Modal
                                    $('#divmodal_Loading').modal('hide');
                            }
                        }, "json");
	    	};

	    	function f_ModalRevertirCierre(){
	    		var id_pedido = $("#id_pedido").val();
	    		var id_detallepedido = $("#id_detallepedido").val();
	    		var estado_cierre = $("#estado_cierre").val();
	    		var cierre_imageorden = $("#cierre_imageorden").val();

	    		// if (!confirm("¿Está seguro de revertir el Cierre de la muestra seleccionada?")){
	    		// 	return;
	    		// }

	    		// Loading Modal
                    var modal_loading = $("#divmodal_Loading");
                    modal_loading.modal({backdrop: 'static', keyboard: false});

	    		$.post( "ajax/encuesta.php", { accion: "Grabar_CierreClientes", Id_Pedido: id_pedido, Id_DetallePedido: id_detallepedido, Estado_Cierre: ((estado_cierre == 1) ?  0 : 1) }, 
                    function( data ) {
                        if(data.estado == 1){
                            // alert("El Cierre ha sido revertido satisfactoriamente");

                            $("#img_" + cierre_imageorden).attr("src","images/" + ((estado_cierre == 1) ?  'check_a.png' : 'check_b.png'));

                            f_LoadResultados();

                            f_cerrarModal(1);
                        }
                        else{
                            // Cerrando Modal
                                $('#divmodal_Loading').modal('hide');
                        }

                    }, "json");
	    	};

	    	function f_ModalUpdateCierre(){
	    		var id_pedido = $("#id_pedido").val();
	    		var id_detallepedido = $("#id_detallepedido").val();
	    		var estado_cierre = $("#estado_cierre").val();
	    		var cierre_imageorden = $("#cierre_imageorden").val();

	    		// if (!confirm("¿Está seguro de realizar el Cierre de la muestra seleccionada?")){
	    		// 	return;
	    		// }

	    		// Loading Modal
                    var modal_loading = $("#divmodal_Loading");
                    modal_loading.modal({backdrop: 'static', keyboard: false});

                // Valida que se hayan ingresado resultados para todos los elementos
                    $.post( "ajax/encuesta.php", { accion: "Valida_IngresoResultados_All", Id_Pedido: id_pedido, Id_DetallePedido: id_detallepedido, campos: campos_evaluados }, 
                        function( data ) {
                            if(data.estado == 1){
                                $.each( data.registros, function( key, val ) {
                                    if (val.TOTAL > 0){
                                        alert("Hay elementos con resultados pendientes.\n\nPor favor, verificar.")

                                        // Cerrando Modal
                                            $('#divmodal_Loading').modal('hide');

                                        return;
                                    }
                                    else{
                                        $.post( "ajax/encuesta.php", { accion: "Grabar_CierreClientes", Id_Pedido: id_pedido, Id_DetallePedido: id_detallepedido, Estado_Cierre: 2 }, 
                                            function( data ) {
                                                if(data.estado == 1){
                                                    // alert("El Cierre ha sido realizado satisfactoriamente.\n\nA partir de este momento el Cliente podrá descargar el Informe de Ensayos.");

                                                    $("#img_" + cierre_imageorden).attr("src","images/check_c.png");

                                                    f_LoadResultados();

                                                    f_cerrarModal(1);
                                                }
                                                else{
                                                    // Cerrando Modal
                                                        $('#divmodal_Loading').modal('hide');
                                                }

                                            }, "json");
                                    }
                                });

                            }
                        }, "json");
	    	};
	    </script>

	    <!-- Otras Funciones -->
	    <script type="text/javascript">
            function f_cerrarModal(pantalla_modal){
                if (pantalla_modal == 1){
                    $('#divmodal_InformesAgrupados').modal('hide');
                    $('#divmodal_qr_agrupado').modal('hide');
                }

                if (pantalla_modal == 2){
                    var modal = $("#divmodal_InformesAgrupados");
                    modal.modal({backdrop: 'static', keyboard: false});
                }
            };

            function f_ImagenCierre(_Estado_Cierre){
	    		var image_orden = $("#cierre_imageorden").val();
	    	};

            $(".sel_ALL").on( 'change', function() {
                if( $(this).is(':checked') ) {
                    f_SeleccionaResultados('', 1);
                } else {
                    // Hacer algo si el checkbox ha sido deseleccionado
                    f_SeleccionaResultados('', 0);
                }
            });

            function f_SeleccionaResultados(_Objeto, _All){
                var x = 1;
                var sel = 0;
                var objeto_id = 0;
                var total_seleccionados = parseInt($("#lbl_seleccionados").html());
                var codigos_seleccionados = $("#lbl_codigos").html();

                if (_Objeto.length == 0){
                    while (x <= total_resultados){
                        document.getElementById('sel_' + x).checked = _All;

                        x += 1;
                    }

                    total_seleccionados = ((_All == 0) ? 0 : x - 1);

                    $("#lbl_codigos").html(((_All == 0) ? '' : '[TODOS]'));
                }
                else{
                    sel = document.getElementById(_Objeto).checked;
                    objeto_id = _Objeto.substring(_Objeto.indexOf('_') + 1).trim();

                    if (sel == 0){
                        total_seleccionados -= 1;

                        codigos_seleccionados = codigos_seleccionados.replace('[' + $("#sp_CI_" + objeto_id).html() + ']', '').trim();

                        if (codigos_seleccionados.substring(codigos_seleccionados.length - 2) == ' -'){
                            codigos_seleccionados = codigos_seleccionados.substring(0, codigos_seleccionados.length - 2);
                        }

                        if (codigos_seleccionados.substring(0, 2).trim() == '-'){
                            codigos_seleccionados = codigos_seleccionados.substring(2);
                        }

                        codigos_seleccionados = codigos_seleccionados.replace(' -  - ', ' - ');
                    }
                    else{
                        total_seleccionados += 1;

                        codigos_seleccionados = codigos_seleccionados + ((codigos_seleccionados.length == 0) ? '[' : ' - [') + $("#sp_CI_" + objeto_id).html() + ']';
                    }

                    $("#lbl_codigos").html(codigos_seleccionados);
                }

                $("#lbl_seleccionados").html(total_seleccionados);
            };
	    </script>

	</body>
</html>

<?php
	cerrarSesion($enlace);
?>