<?php

header('Content-Type: application/json');

include('../../php/conn.php');

// Actualizando zona horaria del servidor
  $q_timezone = "SET TIME_ZONE = 'America/Lima'";

  if ($res = mysqli_query($enlace, $q_timezone)) {
  }

  date_default_timezone_set('America/Lima');

// Permite obtener el nombde de casa mes
  function nombre_meses($num_mes){
    if ($num_mes == 1){
      return "ENERO";
    }
    if ($num_mes == 2){
      return "FEBRERO";
    }
    if ($num_mes == 3){
      return "MARZO";
    }
    if ($num_mes == 4){
      return "ABRIL";
    }
    if ($num_mes == 5){
      return "MAYO";
    }
    if ($num_mes == 6){
      return "JUNIO";
    }
    if ($num_mes == 7){
      return "JULIO";
    }
    if ($num_mes == 8){
      return "AGOSTO";
    }
    if ($num_mes == 9){
      return "SEPTIEMBRE";
    }
    if ($num_mes == 10){
      return "OCTUBRE";
    }
    if ($num_mes == 11){
      return "NOVIEMBRE";
    }
    if ($num_mes == 12){
      return "DICIEMBRE";
    }
  }

// Inicia el proceso condicional
  switch ($_GET["accion"]) {
    case 'get_ListaRacks':
      $r = array();
      $estado = 0;

      $fecha_inicio = $_GET["Fecha_Inicio"];
      $fecha_fin = $_GET["Fecha_Fin"];

      $q_Racks = "SELECT 0 AS ITEM, CR.nom_rack,
                         CR.des_rack, CR.fecha_rack,
                         CR.usuario_rack, CR.Id,
                         (SELECT COUNT(DRP.Id) AS NUM_MUESTRAS
                            FROM  Detalle_Rack_Pesos DRP 
                           WHERE  DRP.Id_Detalle_Rack IN (SELECT Id
                                                            FROM Detalle_Rack
                                                           WHERE Id_Rack = CR.Id)) AS NUM_MUESTRAS,
                         CR.id_horno,
                         H.cod_horno,
                         H.capacidad_horno,
                         GS.observacion_confirmacion,
                         CR.solicitud_cierre
                    FROM Cabecera_Rack CR
                         INNER JOIN tbconfig_Hornos H ON CR.id_horno = H.Id
                         LEFT JOIN Gestion_Solicitudes GS ON CR.Id = GS.Id_Registro
                           AND GS.Id_Solicitud = 1
                   WHERE DATE(CR.fecha_rack) BETWEEN '".$fecha_inicio."' AND '".$fecha_fin."'";

      if ($res_Racks = mysqli_query($enlace, $q_Racks)) {
        if (mysqli_num_rows($res_Racks) > 0) {
          while($row_Racks = mysqli_fetch_assoc($res_Racks)) {
            array_push($r, $row_Racks);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'guardar_Racks':
      $r = array();
      $estado = 0;

      $estado = $_GET["Estado"];
      $id_rack = $_GET["Id_Rack"];
      $nom_rack = $_GET["Nom_Rack"];
      $id_horno = $_GET["Id_Horno"];
      $des_rack = $_GET["Des_Rack"];
      $usuario_rack = $_GET["Usuario_Rack"];

      if ($estado == 'N'){
        $q_save = "INSERT INTO Cabecera_Rack(nom_rack, des_rack, id_horno, usuario_rack) VALUES(";
        $q_save .= "'".$nom_rack."', ";
        $q_save .= "'".$des_rack."', ";
        $q_save .= $id_horno.", ";
        $q_save .= "'".$usuario_rack."')";
      }

      if ($estado == 'M'){
        $q_save = "UPDATE  Cabecera_Rack SET ";
        $q_save .= "       nom_rack = '".$nom_rack."', ";
        $q_save .= "       des_rack = '".$des_rack."', ";
        $q_save .= "       id_horno = ".$id_horno;
        $q_save .= " WHERE Id = ".$id_rack;
      }

      if ($estado == 'E'){
        $q_save = "DELETE FROM Cabecera_Rack";
        $q_save .= " WHERE Id = ".$id_rack;
      }

      if ($res = mysqli_query($enlace, $q_save)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_ListaTipoBlancoFundente':
      $r = array();
      $estado = 0;

      $q_TipoBlanco = "SELECT Id,
                              nom_tipoblanco
                         FROM tbconfig_RackTipoBlancoFundente
                        WHERE estado_tipoblanco = 'A'";

      if ($res_TipoBlanco = mysqli_query($enlace, $q_TipoBlanco)) {
        if (mysqli_num_rows($res_TipoBlanco) > 0) {
          while($row_TipoBlanco = mysqli_fetch_assoc($res_TipoBlanco)) {
            array_push($r, $row_TipoBlanco);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaTipoBlancoFundente_Newmont':
      $r = array();
      $estado = 0;

      $nom_muestra = $_GET["nom_muestra"];

      // Averigua si hay un un Tipo de blanco registrado previamente
        $q_TipoBlancoBefore = "SELECT DR.Id_TipoBlancoFundente AS Id,
                                      TBF.nom_tipoblanco,
                                      DR.Dosificacion,
                                      DR.Dosificacion_Negativo
                                 FROM Detalle_Rack DR
                                      INNER JOIN tbconfig_RackTipoBlancoFundente TBF ON DR.Id_TipoBlancoFundente = TBF.Id
                                WHERE DR.ci_muestra = '".$nom_muestra."'
                               ORDER BY FechaRegistro_Muestra DESC
                               LIMIT 1";

        if ($res_TipoBlancoBefore = mysqli_query($enlace, $q_TipoBlancoBefore)) {
          if (mysqli_num_rows($res_TipoBlancoBefore) > 0) {
            while($row_TipoBlancoBefore = mysqli_fetch_assoc($res_TipoBlancoBefore)) {
              array_push($r, $row_TipoBlancoBefore);
            }

            $estado = 1;
          }

          // SE COMENTÓ DEBIDO A QUE SOLO SE DEBE BUSCAR EL ÚLTIMO GRUPO NEWMONT REGISTRADO - MAX 10/12/2020
          // else{
          //   $q_TipoBlanco = "SELECT Id,
          //                           nom_tipoblanco,
          //                           '' AS Dosificacion,
          //                           '' AS Dosificacion_Negativo
          //                      FROM tbconfig_RackTipoBlancoFundente
          //                     WHERE estado_tipoblanco = 'A'";

          //   if ($res_TipoBlanco = mysqli_query($enlace, $q_TipoBlanco)) {
          //     if (mysqli_num_rows($res_TipoBlanco) > 0) {
          //       while($row_TipoBlanco = mysqli_fetch_assoc($res_TipoBlanco)) {
          //         array_push($r, $row_TipoBlanco);
          //       }

          //       $estado = 1;
          //     }
          //   }
          // }
        }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_RackMuestra':
      $r = array();
      $estado = 0;
      $exists = 0;

      $nom_muestra = $_GET["nom_muestra"];
      $tipo_blanco = $_GET["tipo_blanco"];
      $dosificacion = $_GET["dosificacion"];
      $id_rack = $_GET["id_rack"];
      $usuario_muestra = $_GET["usuario_muestra"];

      // Busca la muestra en las tablas de ventas
        $q_RackMuestra = "SELECT  C.Id_Pedido,
                                  D.Id AS Id_Detalle,
                                  D.Cod_Interno,
                                  D.Nom_Muestra,
                                  LOWER(D.Elemento_Analisis) AS Elemento_Analisis,
                                  TA.Num_Replica,
                                  PV.Id_MedioPago
                            FROM  _max_labperu_DetallePedido D
                                  INNER JOIN _max_labperu_CabeceraPedido C ON D.Id_Pedido = C.Id_Pedido
                                  INNER JOIN _max_labperu_TipoAnalisis TA ON D.Tipo_Analisis = TA.Id
                                  INNER JOIN _max_labperu_PagoVenta PV ON C.Id_Pedido = PV.Id_Pedido
                                  INNER JOIN _max_labperu_MedioPago MP ON PV.Id_MedioPago = MP.Id
                           WHERE  D.Cod_Interno = '".$nom_muestra."'
                             AND  (LOWER(D.Elemento_Analisis) LIKE '%au%'
                             OR  LOWER(D.Elemento_Analisis) LIKE '%ag%')";

      if ($res_RackMuestra = sqlsrv_query($enlacehost, $q_RackMuestra)) {
        while($row_RackMuestra = sqlsrv_fetch_array($res_RackMuestra)) {
          $exists = 1;

          // Comprobando si es una muestra Newmont
            $q_newmont = "SELECT  COUNT(Id) AS _EXISTS
                            FROM  _max_labperu_DetallePedido
                           WHERE  Cod_Interno = '".$nom_muestra."'
                             AND  IdProductos_Combo LIKE '%43121%'";

            if ($res_newmont = sqlsrv_query($enlacehost, $q_newmont)) {
              while($row_newmont = sqlsrv_fetch_array($res_newmont)) {
                if ($row_newmont["_EXISTS"] == 1){
                  $estado = 5;

                  echo json_encode(array('estado' => $estado));

                  return;
                }
              }
            }

          // Comprobar que la muestra no exista en otro Rack
            $q_exists = "SELECT  COUNT(Id) AS _COUNT
                           FROM  Detalle_Rack
                          WHERE  ci_muestra = '".$nom_muestra."'
                            AND  is_Reanalisis = 0
                            AND  Id_Rack <> ".$id_rack;

            if ($res_exists = mysqli_query($enlace, $q_exists)) {
              if (mysqli_num_rows($res_exists) > 0) {
                while($row_exists = mysqli_fetch_assoc($res_exists)) {
                  if ($row_exists["_COUNT"] > 0){
                    $estado = 3;

                    echo json_encode(array('estado' => $estado));

                    return;
                  }
                }
              }
            }

          // Si no existe en el Rack lo ingresa como nuevo
            $q_exists = "SELECT  COUNT(Id) AS _COUNT
                           FROM  Detalle_Rack
                          WHERE  ci_muestra = '".$nom_muestra."'
                            AND  is_Reanalisis = 0
                            AND  Id_Rack = ".$id_rack;

            if ($res_exists = mysqli_query($enlace, $q_exists)) {
              if (mysqli_num_rows($res_exists) > 0) {
                while ($row_exists = mysqli_fetch_assoc($res_exists)) {
                  if ($row_exists["_COUNT"] == 0){
                    // Grabando los datos en la tabla de Detalle de Rack
                      $q_InsertDetalle = "INSERT INTO Detalle_Rack(Id_Rack, Id_Pedido, Id_Detalle, Rack_TipoMuestra,
                                                                   ci_muestra, nom_muestra, is_Au, is_Ag,
                                                                   Id_TipoBlancoFundente, Dosificacion, Usuario_Muestra, num_replica, Id_MedioPago, is_Reanalisis) VALUES(";
                      $q_InsertDetalle .= $id_rack.", ";
                      $q_InsertDetalle .= $row_RackMuestra["Id_Pedido"].", ";
                      $q_InsertDetalle .= $row_RackMuestra["Id_Detalle"].", 1, ";
                      $q_InsertDetalle .= "'".$row_RackMuestra["Cod_Interno"]."', ";
                      $q_InsertDetalle .= "'".$row_RackMuestra["Nom_Muestra"]."', ";

                      $is_au = 0;
                      $pos = strpos($row_RackMuestra["Elemento_Analisis"], 'au');

                      if ($pos !== false){
                        $is_au = 1;
                      }

                      $is_ag = 0;
                      $pos = strpos($row_RackMuestra["Elemento_Analisis"], 'ag');

                      if ($pos !== false){
                        $is_ag = 1;
                      }

                      $q_InsertDetalle .= $is_au.", ";
                      $q_InsertDetalle .= $is_ag.", ";
                      $q_InsertDetalle .= $tipo_blanco.", ";
                      $q_InsertDetalle .= "'".$dosificacion."', ";
                      $q_InsertDetalle .= "'".$usuario_muestra."', ";
                      $q_InsertDetalle .= $row_RackMuestra["Num_Replica"].", ";
                      $q_InsertDetalle .= $row_RackMuestra["Id_MedioPago"].", 0)";

                      if ($res_InsertDetalle = mysqli_query($enlace, $q_InsertDetalle)) {
                        $id_detalle_rack = mysql_insert_id();
                      }
                  }
                  else{
                    // Si la muestra fue registrada previamente y no tiene pesos, puede continuar, porque el sistema pudo caerse. Pero, si ya tiene pesos no debería permitir su registro
                    $q_detalle_rack = "SELECT  Id
                                         FROM  Detalle_Rack
                                        WHERE  ci_muestra = '".$nom_muestra."'
                                          AND  is_Reanalisis = 0
                                          AND  Id_Rack = ".$id_rack."
                                          AND  (SELECT COUNT(DRP.Id) FROM Detalle_Rack_Pesos DRP WHERE DRP.Id_Detalle_Rack = Detalle_Rack.Id) = 0";

                    if ($res_detalle_rack = mysqli_query($enlace, $q_detalle_rack)) {
                      if (mysqli_num_rows($res_detalle_rack) > 0) {
                        while ($row_detalle_rack = mysqli_fetch_assoc($res_detalle_rack)) {
                          $id_detalle_rack = $row_detalle_rack["Id"];
                        }
                      }
                      else{
                        // Si entra es porque tiene pesos registrados en este Rack y no debería continuar
                          $estado = 4;

                          echo json_encode(array('estado' => $estado));

                          return;
                      }
                    }
                  }
                }
              }
            }

          // Obteniendo el número de muestras registradas en el Rack, para obtener el correlativo de Crisol
            $num_crisol = 0;

            $q_numcrisol = "SELECT COUNT(Id) AS _COUNT
                              FROM  Detalle_Rack_Pesos
                             WHERE  Id_Detalle_Rack IN (SELECT Id
                                                          FROM Detalle_Rack
                                                         WHERE Id_Rack = ".$id_rack.")";

            if ($res_numcrisol = mysqli_query($enlace, $q_numcrisol)) {
              if (mysqli_num_rows($res_numcrisol) > 0) {
                while ($row_numcrisol = mysqli_fetch_assoc($res_numcrisol)) {
                  $num_crisol = $row_numcrisol["_COUNT"];
                }
              }
            }

          // Armando el Select para el DataGridView
            $w = 1;

            while ($w <= $row_RackMuestra["Num_Replica"]){
              $q_select = "SELECT ".$id_detalle_rack." AS Id_Detalle_Rack,
                                  ".($num_crisol + 1)." AS Num_Crisol,
                                  '".$row_RackMuestra["Cod_Interno"]."' AS Nom_Muestra,
                                  '' AS Peso_Muestra";

              if ($res_select = mysqli_query($enlace, $q_select)) {
                if (mysqli_num_rows($res_select) > 0) {
                  while ($row_select = mysqli_fetch_assoc($res_select)) {
                    array_push($r, $row_select);
                  }
                }
              }

              // // Guardando ficticios en la tabla de Pesos
              //   $q_InsertPesos = "INSERT INTO Detalle_Rack_Pesos (Id_Detalle_Rack, Num_Crisol, Nom_Muestra, Peso_Muestra) VALUES(";
              //   $q_InsertPesos .= $id_detalle_rack.", ";
              //   $q_InsertPesos .= ($num_crisol + 1).", ";
              //   $q_InsertPesos .= "'".$nom_muestra."', 0)";

              //   if ($res_InsertPesos = mysqli_query($enlace, $q_InsertPesos)) {
              //   }

              $num_crisol += 1;
              $w += 1;
            }
        }

        $estado = (($exists == 1) ? 1 : 2);
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'eliminar_DetalleRack':
      $r = array();
      $estado = 0;

      $id_detallerack = $_GET["id_detallerack"];

      $q_delete = "DELETE FROM Detalle_Rack";
      $q_delete .= " WHERE Id = ".$id_detallerack;

      if ($res = mysqli_query($enlace, $q_delete)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'guardar_PesosRack':
      $r = array();
      $estado = 0;

      $Tipo_Peso = $_GET["Tipo_Peso"];
      $Id_Detalle_Rack = $_GET["Id_Detalle_Rack"];
      $Num_Crisol = $_GET["Num_Crisol"];
      $Nom_Muestra = $_GET["Nom_Muestra"];
      $Peso_Muestra = $_GET["Peso_Muestra"];
      $Usuario_Peso = $_GET["Usuario_Peso"];
      $Tipo_InsertUpdate = $_GET["Tipo_InsertUpdate"];
      $Tipo_Blanco = $_GET["tipo_blanco"];
      $Dosificacion = $_GET["dosificacion"];

      // Para el peso de Muestras
        if ($Tipo_Peso == 'M'){
          $date = date('Y-m-d');
          $time = date('H:i:s');

          if ($Tipo_InsertUpdate == 'I'){
            $q_SavePeso = "INSERT INTO Detalle_Rack_Pesos(Id_Detalle_Rack, Num_Crisol, Id_TipoBlancoFundente, Dosificacion, Nom_Muestra, Peso_Muestra, UsuarioPeso_Muestra) VALUES(";
            $q_SavePeso .= $Id_Detalle_Rack.", ";
            $q_SavePeso .= $Num_Crisol.", ";
            $q_SavePeso .= $Tipo_Blanco.", ";
            $q_SavePeso .= "'".$Dosificacion."', ";
            $q_SavePeso .= "'".$Nom_Muestra."', ";
            $q_SavePeso .= $Peso_Muestra.", ";
            $q_SavePeso .= "'".$Usuario_Peso."')";
          }
          else{
            if ($Tipo_InsertUpdate == 'R'){
              $q_SavePeso =  "UPDATE  Detalle_Rack_Pesos SET ";
              $q_SavePeso .= "        FechaPeso_Muestra = '".$g_fecha."', ";
              $q_SavePeso .= "        Peso_Muestra = ".$Peso_Muestra.", ";
              $q_SavePeso .= "        UsuarioPeso_Muestra = '".$Usuario_Peso."' ";
              $q_SavePeso .= " WHERE  Id_Detalle_Rack = ".$Id_Detalle_Rack;
              $q_SavePeso .= "   AND  Num_Crisol = ".$Num_Crisol;
            }
            else{
              $q_SavePeso = "UPDATE Detalle_Rack_Pesos SET ";
              $q_SavePeso .= "FechaPeso_Muestra = '".$g_fecha."', ";
              $q_SavePeso .= "Peso_Muestra = ".$Peso_Muestra.", ";
              $q_SavePeso .= "UsuarioPeso_Muestra = '".$Usuario_Peso."' ";
              $q_SavePeso .= "WHERE Id = ".$Id_Detalle_Rack;
            }
          }
        }

      // Para el peso de Blanco Fundente
        if ($Tipo_Peso == 'BF'){
          $q_SavePeso = "INSERT INTO Detalle_Rack_Pesos(Id_Detalle_Rack, Num_Crisol, Id_TipoBlancoFundente, Dosificacion, Nom_Muestra, Peso_Muestra, UsuarioPeso_Muestra) VALUES(";
          $q_SavePeso .= $Id_Detalle_Rack.", ";
          $q_SavePeso .= $Num_Crisol.", ";
          $q_SavePeso .= $Tipo_Blanco.", ";
          $q_SavePeso .= "'".$Dosificacion."', ";
          $q_SavePeso .= "'".$Nom_Muestra."', ";
          $q_SavePeso .= $Peso_Muestra.", ";
          $q_SavePeso .= "'".$Usuario_Peso."')";
        }

      // Para el peso de Blanco Pulverizado
        if ($Tipo_Peso == 'BP'){
          $q_SavePeso = "INSERT INTO Detalle_Rack_Pesos(Id_Detalle_Rack, Num_Crisol, Id_TipoBlancoFundente, Dosificacion, Nom_Muestra, Peso_Muestra, UsuarioPeso_Muestra) VALUES(";
            $q_SavePeso .= $Id_Detalle_Rack.", ";
            $q_SavePeso .= $Num_Crisol.", ";
            $q_SavePeso .= $Tipo_Blanco.", ";
            $q_SavePeso .= "'".$Dosificacion."', ";
            $q_SavePeso .= "'".$Nom_Muestra."', ";
            $q_SavePeso .= $Peso_Muestra.", ";
            $q_SavePeso .= "'".$Usuario_Peso."')";
        }

      // Para el peso de Material de Referencia
        if ($Tipo_Peso == 'MR'){
          $q_SavePeso = "INSERT INTO Detalle_Rack_Pesos(Id_Detalle_Rack, Num_Crisol, Id_TipoBlancoFundente, Dosificacion, Nom_Muestra, Peso_Muestra, UsuarioPeso_Muestra) VALUES(";
            $q_SavePeso .= $Id_Detalle_Rack.", ";
            $q_SavePeso .= $Num_Crisol.", ";
            $q_SavePeso .= $Tipo_Blanco.", ";
            $q_SavePeso .= "'".$Dosificacion."', ";
            $q_SavePeso .= "'".$Nom_Muestra."', ";
            $q_SavePeso .= $Peso_Muestra.", ";
            $q_SavePeso .= "'".$Usuario_Peso."')";
        }

        if ($res = mysqli_query($enlace, $q_SavePeso)) {
          $estado = 1;
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'guardar_DetalleMuestrasRack':
      $r = array();
      $id_detalle_rack = 0;

      $id_rack = $_GET["id_rack"];
      $tipo_muestra = $_GET["tipo_muestra"];
      $nom_muestra = $_GET["nom_muestra"];
      $tipo_blanco = $_GET["tipo_blanco"];
      $dosif = $_GET["dosif"];
      $replicas = $_GET["replicas"];
      $usuario_peso = $_GET["Usuario_Peso"];

      if ($tipo_muestra == "BF"){
        $tipo_muestra = 2;
      }

      if ($tipo_muestra == "BP"){
        $tipo_muestra = 3;
      }

      if ($tipo_muestra == "MR"){
        $tipo_muestra = 4;
      }

      $q_insert = "INSERT INTO Detalle_Rack(Id_Rack, Id_Pedido, Id_Detalle, Rack_TipoMuestra,
                                            ci_muestra, nom_muestra, is_Au, is_Ag,
                                            Id_TipoBlancoFundente, Dosificacion, num_replica, Id_MedioPago,
                                            is_Reanalisis, Usuario_Muestra) VALUES(
                  ".$id_rack.", 0, 0, ".$tipo_muestra.",
                  '".$nom_muestra."', '".$nom_muestra."', 0, 0,
                  ".$tipo_blanco.", '".$dosif."', ".$replicas.", 0, 0, '".$usuario_peso."')";

      if ($res_insert = mysqli_query($enlace, $q_insert)) {
        $max_id = "SELECT MAX(Id) AS _MAX
                     FROM Detalle_Rack";

        if ($res_max_id = mysqli_query($enlace, $max_id)) {
          if (mysqli_num_rows($res_max_id) > 0) {
            while ($row_max_id = mysqli_fetch_assoc($res_max_id)) {
              $id_detalle_rack = $row_max_id["_MAX"];
            }
          }
        }
      }
      else{
        $id_detalle_rack = 0;
      }

      echo json_encode(array('id_detalle_rack' => $id_detalle_rack));

      break;

    case 'update_DatosPesos':
      $r = array();
      $estado = 0;

      $Tipo_Peso = $_GET["Tipo_Peso"];
      $Id_DetalleRackPesos = $_GET["Id_DetalleRackPesos"];
      $Tipo_Blanco = $_GET["Tipo_Blanco"];
      $Dosificacion = $_GET["Dosificacion"];
      $Peso_Muestra = $_GET["Peso_Muestra"];
      $Usuario_Update = $_GET["Usuario_Update"];
      $Modulo_Update = $_GET["Modulo_Update"];

      // Si es una actualización de Pesos debe registrar los datos de Auditorías
        if ($Modulo_Update == 1){
          $q_audi = "INSERT INTO Auditoria_ActualizacionDatosMuestras (Id_Detalle_Rack_Pesos, Id_Detalle_Rack, Num_Crisol,
                                  Id_TipoBlancoFundente, Dosificacion, Nom_Muestra, FechaPeso_Muestra,
                                  Peso_Muestra, UsuarioPeso_Muestra, UpdateId_TipoBlancoFundente, Update_Dosificacion,
                                  UpdateFechaPeso_Muestra, UpdatePeso_Muestra, UpdateUsuarioPeso_Muestra)";
          $q_audi .= "SELECT  Id,
                              Id_Detalle_Rack,
                              Num_Crisol,
                              Id_TipoBlancoFundente,
                              Dosificacion,
                              Nom_Muestra,
                              FechaPeso_Muestra,
                              Peso_Muestra,
                              UsuarioPeso_Muestra, ";
          $q_audi .= "        ".$Tipo_Blanco.", ";
          $q_audi .= "        '".$Dosificacion."', ";
          $q_audi .= "        '".$g_fecha."', ";
          $q_audi .= "        ".$Peso_Muestra.", ";
          $q_audi .= "        '".$Usuario_Update."' ";
          $q_audi .= "  FROM  Detalle_Rack_Pesos
                       WHERE  Id = ".$Id_DetalleRackPesos;

          if ($res_audi = mysqli_query($enlace, $q_audi)) {
          }
        }

      // Para el peso de Muestras
        if ($Tipo_Peso == 'M'){
          $q_update = "UPDATE Detalle_Rack_Pesos SET 
                              Id_TipoBlancoFundente = ".$Tipo_Blanco.",
                              Dosificacion = '".$Dosificacion."',
                              Peso_Muestra = ".$Peso_Muestra.",
                              FechaPeso_Muestra = '".$g_fecha."',
                              UsuarioPeso_Muestra = '".$Usuario_Update."'
                        WHERE Id = ".$Id_DetalleRackPesos;
        }

      // Para el peso de Régulo
      if ($Tipo_Peso == 'R'){
        
      }

      // Para el peso de Doré
      if ($Tipo_Peso == 'D'){

      }

      // Para el peso de Au
      if ($Tipo_Peso == 'Au'){

      }

      if ($res = mysqli_query($enlace, $q_update)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_ListaRackMuestras':
      $r = array();
      $estado = 0;

      $Id_Rack = $_GET["Id_Rack"];

      // $q_RackMuestras = "SELECT DRP.Num_Crisol,
      //                           RTM.nom_tipo AS TIPO,
      //                           DRP.nom_muestra,
      //                           DRP.Peso_Muestra,
      //                           TB.nom_tipoblanco,
      //                           CASE WHEN is_Newmont = 0
      //                             THEN DR.Dosificacion
      //                           ELSE CASE WHEN DRP.is_Newmont_Positivo = 1
      //                               THEN DR.Dosificacion
      //                                ELSE CASE WHEN DRP.is_Newmont_Negativo = 1
      //                                   THEN DR.Dosificacion_Negativo END END END AS Dosificacion,
      //                           DR.Id,
      //                           CR.cierre_rack,
      //                           CR.solicitud_cierre,
      //                           DR.Id_TipoBlancoFundente,
      //                           DRP.Id AS Id_DetalleRackPesos
      //                     FROM  Detalle_Rack DR
      //                           INNER JOIN Detalle_Rack_Pesos DRP ON DR.Id = DRP.Id_Detalle_Rack
      //                           INNER JOIN tbconfig_RackTipoMuestras RTM ON DR.Rack_TipoMuestra = RTM.Id
      //                           INNER JOIN tbconfig_RackTipoBlancoFundente TB ON DRP.Id_TipoBlancoFundente = TB.Id
      //                           INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
      //                    WHERE  DR.Id_Rack = ".$Id_Rack;

      $q_RackMuestras = "SELECT DRP.Num_Crisol,
                                RTM.nom_tipo AS TIPO,
                                DRP.nom_muestra,
                                DRP.Peso_Muestra,
                                TB.nom_tipoblanco,
                                DRP.Dosificacion,
                                DR.Id,
                                CR.cierre_rack,
                                CR.solicitud_cierre,
                                DRP.Id_TipoBlancoFundente,
                                DRP.Id AS Id_DetalleRackPesos,
                                DRP.is_Newmont_Positivo
                          FROM  Detalle_Rack DR
                                INNER JOIN Detalle_Rack_Pesos DRP ON DR.Id = DRP.Id_Detalle_Rack
                                INNER JOIN tbconfig_RackTipoMuestras RTM ON DR.Rack_TipoMuestra = RTM.Id
                                INNER JOIN tbconfig_RackTipoBlancoFundente TB ON DRP.Id_TipoBlancoFundente = TB.Id
                                INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
                         WHERE  DR.Id_Rack = ".$Id_Rack;

      if ($res_RackMuestras = mysqli_query($enlace, $q_RackMuestras)) {
        if (mysqli_num_rows($res_RackMuestras) > 0) {
          while($row_RackMuestras = mysqli_fetch_assoc($res_RackMuestras)) {
            array_push($r, $row_RackMuestras);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_NumCrisol':
      $r = array();
      $estado = 0;
      $num_crisol = 0;

      $id_rack = $_GET["id_rack"];

      $q_numcrisol = "SELECT COUNT(Id) AS _COUNT
                        FROM  Detalle_Rack_Pesos
                       WHERE  Id_Detalle_Rack IN (SELECT Id
                                                    FROM Detalle_Rack
                                                   WHERE Id_Rack = ".$id_rack.")";

      if ($res_numcrisol = mysqli_query($enlace, $q_numcrisol)) {
        if (mysqli_num_rows($res_numcrisol) > 0) {
          $estado = 1;

          while ($row_numcrisol = mysqli_fetch_assoc($res_numcrisol)) {
            $num_crisol = $row_numcrisol["_COUNT"];
          }
        }
      }

      echo json_encode(array('estado' => $estado, 'num_crisol' => $num_crisol));

      break;

    case 'get_NumBlancoFundente':
      $r = array();
      $estado = 0;
      $num_blanco = 0;

      $id_rack = $_GET["id_rack"];
      $tipo_blanco = $_GET["tipo_blanco"];

      $q_numblanco = "SELECT COUNT(Id) AS _COUNT
                        FROM  Detalle_Rack_Pesos
                       WHERE  Id_Detalle_Rack IN (SELECT Id
                                                    FROM Detalle_Rack
                                                   WHERE Id_Rack = ".$id_rack."
                                                     AND Rack_TipoMuestra = 2
                                                     AND Id_TipoBlancoFundente = ".$tipo_blanco.")";

      if ($res_numblanco = mysqli_query($enlace, $q_numblanco)) {
        if (mysqli_num_rows($res_numblanco) > 0) {
          $estado = 1;

          while ($row_numblanco = mysqli_fetch_assoc($res_numblanco)) {
            $num_blanco = $row_numblanco["_COUNT"];
          }
        }
      }

      echo json_encode(array('estado' => $estado, 'num_blanco' => $num_blanco));

      break;

    case 'get_NumBlancoPulverizado':
      $r = array();
      $estado = 0;
      $num_blanco = 0;

      // Obteniendo la fecha de hoy
        date_default_timezone_set("America/Lima"); 
        $date = date('Y-m-d');

      // Obteniendo el correlativo
        $q_numblanco = "SELECT  COUNT(Id) AS _COUNT
                          FROM  Detalle_Rack
                         WHERE  DATE(FechaRegistro_Muestra) = '".$date."'
                           AND  Rack_TipoMuestra = 3";

        if ($res_numblanco = mysqli_query($enlace, $q_numblanco)) {
          if (mysqli_num_rows($res_numblanco) > 0) {
            $estado = 1;

            while ($row_numblanco = mysqli_fetch_assoc($res_numblanco)) {
              $num_blanco = $row_numblanco["_COUNT"];
            }
          }
        }

      echo json_encode(array('estado' => $estado, 'num_blanco' => $num_blanco));

      break;

    case 'get_NomBlancoPulverizado':
      $r = array();
      $estado = 0;

      $q_nomblanco = "SELECT  nom_nomenclatura
                        FROM  tbconfig_BlancoPulverizado_Nomenclatura
                       WHERE  en_ejecucion = 1";

      if ($res_nomblanco = mysqli_query($enlace, $q_nomblanco)) {
        if (mysqli_num_rows($res_nomblanco) > 0) {
          $estado = 1;

          while ($row_nomblanco = mysqli_fetch_assoc($res_nomblanco)) {
            $nom_blanco = $row_nomblanco["nom_nomenclatura"];
          }
        }
      }

      echo json_encode(array('estado' => $estado, 'nom_blanco' => $nom_blanco));

      break;

    case 'get_ListaMaterialR':
      $r = array();
      $estado = 0;

      $order = (($_GET["orden"] == 1) ? 'ASC' : 'DESC');

      $q_MaterialR = "SELECT CONCAT('(', TBF.abv_tipoblanco, ') - ', Nom_MaterialReferencia) AS Nom_MaterialReferencia
                        FROM tbconfig_MaterialReferencia MR
                             INNER JOIN tbconfig_RackTipoBlancoFundente TBF ON MR.Id_TipoBlancoFundente = TBF.Id
                       WHERE Estado_MaterialReferencia = 'A'
                      ORDER BY Id_TipoBlancoFundente ".$order.", Nom_MaterialReferencia";

      if ($res_MaterialR = mysqli_query($enlace, $q_MaterialR)) {
        if (mysqli_num_rows($res_MaterialR) > 0) {
          while($row_MaterialR = mysqli_fetch_assoc($res_MaterialR)) {
            array_push($r, $row_MaterialR);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaHornos':
      $r = array();
      $estado = 0;

      $q_Hornos = "SELECT Id,
                          CONCAT(cod_horno, ' | Capacidad: ', capacidad_horno, ' Crisoles') AS NOM_HORNO
                     FROM tbconfig_Hornos
                    WHERE estado_horno = 'A'";

      if ($res_Hornos = mysqli_query($enlace, $q_Hornos)) {
        if (mysqli_num_rows($res_Hornos) > 0) {
          while($row_Hornos = mysqli_fetch_assoc($res_Hornos)) {
            array_push($r, $row_Hornos);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaMuestrasNewmont':
      $r = array();
      $estado = 0;

      $fecha_inicio = $_GET["Fecha_Inicio"];
      $fecha_fin = $_GET["Fecha_Fin"];
      $ci_muestra = $_GET["CI_Muestra"];

      $q_Muestras = "SELECT 0 AS Item,
                            PNC.CI_Muestra,
                            M.num_malla,
                            CASE WHEN PNC.Cierre_Newmont = 0 THEN 'NO' ELSE 'SÍ' END AS Cierre_Newmont,
                            PNC.FechaHora_Recepcion,
                            PNC.UsuarioCierre_Newmont,
                            PNC.FechaCierre_Newmont,
                            PNC.Id,
                            PNC.ReOpen_Newmont,
                            PNC.is_NewGrupo
                      FROM  Preparacion_Newmont_Cabecera PNC
                            LEFT JOIN tbconfig_Mallas M ON PNC.Id_NumMalla = M.Id
                     WHERE  1 = 1";

      if ($ci_muestra != "0"){
        $q_Muestras .= "   AND PNC.CI_Muestra = '".$ci_muestra."'";
      }
      else{
        $q_Muestras .= "   AND DATE(PNC.FechaHora_Recepcion) BETWEEN '".$fecha_inicio."' AND '".$fecha_fin."'";
      }

      $q_Muestras .= " ORDER BY FechaHora_Recepcion DESC, Id_Detalle DESC";

      if ($res_Muestras = mysqli_query($enlace, $q_Muestras)) {
        if (mysqli_num_rows($res_Muestras) > 0) {
          while($row_Muestras = mysqli_fetch_assoc($res_Muestras)) {
            array_push($r, $row_Muestras);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaMuestrasNewmont_Detalle':
      $r = array();
      $estado = 0;

      $Id_Cabecera = $_GET["Id_Cabecera"];

      $q_Detalle = "SELECT Num_Grupo,
                           Peso_muestra,
                           PesoPositivo_Muestra,
                           PesoNegativo_Muestra,
                           UsuarioPeso_Muestra,
                           FechaPeso_Muestra,
                           UsuarioPesoPositivo_Muestra,
                           FechaPesoPositivo_Muestra,
                           UsuarioPesoNegativo_Muestra,
                           FechaPesoNegativo_Muestra,
                           Id_Cabecera,
                           Id
                      FROM Preparacion_Newmont_Detalle
                     WHERE Id_Cabecera = ".$Id_Cabecera."
                    ORDER BY Num_Grupo";

      if ($res_Detalle = mysqli_query($enlace, $q_Detalle)) {
        if (mysqli_num_rows($res_Detalle) > 0) {
          while($row_Detalle = mysqli_fetch_assoc($res_Detalle)) {
            array_push($r, $row_Detalle);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaNumMallas':
      $r = array();
      $estado = 0;

      $q_NumMallas = "SELECT  Id,
                              num_malla
                        FROM  tbconfig_Mallas
                       WHERE  estado_malla = 'A'";

      if ($res_NumMallas = mysqli_query($enlace, $q_NumMallas)) {
        if (mysqli_num_rows($res_NumMallas) > 0) {
          while($row_NumMallas = mysqli_fetch_assoc($res_NumMallas)) {
            array_push($r, $row_NumMallas);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_LimitePesos':
      $r = array();
      $estado = 0;
      $limite_pesos = "";

      $id_limitepesos = $_GET["id_limitepesos"];
      $send_peso = $_GET["send_peso"];

      $q_LimitePesos = "SELECT  Peso_Aprox,
                                Limite_Min,
                                Limite_Max,
                                Limite_Porc
                          FROM  tbconfig_LimitePesos
                         WHERE  Id = ".$id_limitepesos;

      if ($res_LimitePesos = mysqli_query($enlace, $q_LimitePesos)) {
        if (mysqli_num_rows($res_LimitePesos) > 0) {
          while($row_LimitePesos = mysqli_fetch_assoc($res_LimitePesos)) {
            $peso_aprox = $row_LimitePesos["Peso_Aprox"];
            $limit_min = $row_LimitePesos["Limite_Min"];
            $limit_max = $row_LimitePesos["Limite_Max"];
            $limite_porc = $row_LimitePesos["Limite_Porc"];

            if ($limite_porc == 1){
              if ($id_limitepesos == 2){
                $limit_min = $send_peso - ($send_peso * ($limit_min / 100));
                $limit_max = $send_peso + ($send_peso * ($limit_max / 100));
              }
              else{
                $limit_min = $peso_aprox - ($peso_aprox * ($limit_min / 100));
                $limit_max = $peso_aprox + ($peso_aprox * ($limit_max / 100));
              }
            }
            else{
              $limit_min = $peso_aprox - $limit_min;
              $limit_max = $peso_aprox + $limit_max;
            }

            $limite_pesos = $peso_aprox."|".$limit_min."|".$limit_max;
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'limite_pesos' => $limite_pesos));

      break;

    case 'guardar_PesosMuestrasNewmont':
      $r = array();
      $estado = 0;

      $Tipo_Peso = $_GET["Tipo_Muestra"];
      $Id_Cabecera = $_GET["Id_Cabecera"];
      $Id_Detalle = $_GET["Id_Detalle"];
      $Num_Malla = $_GET["Num_Malla"];
      $Peso_Muestra = $_GET["Peso_Muestra"];
      $Usuario_Peso = $_GET["Usuario_Peso"];

      // Obteniendo la fecha de hoy
        date_default_timezone_set("America/Lima"); 
        $date = date('Y-m-d');
        $time = date('H:i:s');

      // Para el peso de Muestras
        if ($Tipo_Peso == 'M'){
          $q_SavePeso = "UPDATE Preparacion_Newmont_Detalle
                            SET Peso_Muestra = ".$Peso_Muestra.",
                                FechaPeso_Muestra = '".($date.' ' .$time)."',
                                UsuarioPeso_Muestra = '".$Usuario_Peso."'
                          WHERE Id = ".$Id_Detalle;
        }

      // Para el peso de Positivos
        if ($Tipo_Peso == 'P'){
          $q_SavePeso = "UPDATE Preparacion_Newmont_Detalle
                            SET PesoPositivo_Muestra = ".$Peso_Muestra.",
                                FechaPesoPositivo_Muestra = '".($date.' ' .$time)."',
                                UsuarioPesoPositivo_Muestra = '".$Usuario_Peso."',

                                PesoNegativo_Muestra = (Peso_Muestra - ".$Peso_Muestra."),
                                FechaPesoNegativo_Muestra = '".($date.' ' .$time)."',
                                UsuarioPesoNegativo_Muestra = '".$Usuario_Peso."',

                                Cierre_Grupo = 1
                          WHERE Id = ".$Id_Detalle;
        }

        if ($res = mysqli_query($enlace, $q_SavePeso)) {
          $estado = 1;

          // Actualiza el número de Malla
            $q_update = "UPDATE Preparacion_Newmont_Cabecera
                            SET Id_NumMalla = ".$Num_Malla."
                          WHERE Id = ".$Id_Cabecera;

            if ($res_update = mysqli_query($enlace, $q_update)) {
            }
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'cierre_Newmont':
      $r = array();
      $estado = 0;

      $id_cabecera = $_GET["Id_Cabecera"];
      $usuario_cierre = $_GET["Usuario_Cierre"];

      // Obteniendo la fecha de hoy
        date_default_timezone_set("America/Lima"); 
        $date = date('Y-m-d');
        $time = date('H:i:s');

      $q_CierreNewmont = "UPDATE Preparacion_Newmont_Cabecera
                             SET Cierre_Newmont = 1,
                                 FechaCierre_Newmont = '".($date.' ' .$time)."',
                                 UsuarioCierre_Newmont = '".$usuario_cierre."'
                           WHERE Id = ".$id_cabecera;

      if ($res = mysqli_query($enlace, $q_CierreNewmont)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'reopen_Newmont':
      $r = array();
      $estado = 0;

      $id_cabecera = $_GET["Id_Cabecera"];
      $usuario_cierre = $_GET["Usuario_Cierre"];

      // Obteniendo la fecha de hoy
        date_default_timezone_set("America/Lima"); 
        $date = date('Y-m-d');
        $time = date('H:i:s');

      $q_ReOpenNewmont = "UPDATE Preparacion_Newmont_Cabecera
                             SET Cierre_Newmont = 0,
                                 FechaCierre_Newmont = null,
                                 UsuarioCierre_Newmont = null,
                                 ReOpen_Newmont = 1,
                                 FechaReOpen_Newmont = '".($date.' ' .$time)."',
                                 UsuarioReOpen_Newmont = '".$usuario_cierre."'
                           WHERE Id = ".$id_cabecera;

      if ($res = mysqli_query($enlace, $q_ReOpenNewmont)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'reopen_EliminarPesos_Newmont':
      $r = array();
      $estado = 0;

      $id_detalle = $_GET["Id_Detalle"];
      $usuario_eliminarpesoslog = $_GET["Usuario_EliminarPesosLog"];

      // Inserta los datos a actualizar en la tabla de Log
      $q_SaveLog = "INSERT INTO Preparacion_Newmont_Detalle_ReOpenLog (Id_Detalle, Id_Cabecera, Num_Grupo, Peso_muestra,
                                FechaPeso_Muestra, UsuarioPeso_Muestra, PesoPositivo_muestra, FechaPesoPositivo_Muestra,
                                UsuarioPesoPositivo_Muestra, PesoNegativo_muestra, FechaPesoNegativo_Muestra, UsuarioPesoNegativo_Muestra,
                                Usuario_ReOpenLog)

                    SELECT  Id, Id_Cabecera, Num_Grupo, Peso_muestra,
                            FechaPeso_Muestra, UsuarioPeso_Muestra, PesoPositivo_muestra, FechaPesoPositivo_Muestra,
                            UsuarioPesoPositivo_Muestra, PesoNegativo_muestra, FechaPesoNegativo_Muestra, UsuarioPesoNegativo_Muestra,
                            '".$usuario_eliminarpesoslog."'
                      FROM  Preparacion_Newmont_Detalle
                     WHERE  Id = ".$id_detalle;

      if ($res_SaveLog = mysqli_query($enlace, $q_SaveLog)) {
        $estado = 1;

        // Limpia los datos de la tabla de detalles
          $q_update = "UPDATE Preparacion_Newmont_Detalle
                          SET Peso_muestra = 0,
                              FechaPeso_Muestra = null,
                              UsuarioPeso_Muestra = null,

                              PesoPositivo_muestra = 0,
                              FechaPesoPositivo_Muestra = null,
                              UsuarioPesoPositivo_Muestra = null,

                              PesoNegativo_muestra = 0,
                              FechaPesoNegativo_Muestra = null,
                              UsuarioPesoNegativo_Muestra = null
                        WHERE Id = ".$id_detalle;

          if ($res_update = mysqli_query($enlace, $q_update)) {
          }
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_VerificaMuestraNewmont':
      $r = array();
      $estado = 0;

      $ci_muestra = $_GET["CI_Muestra"];
      $id_rack = $_GET["Id_Rack"];

      // Comprobando si es una muestra Newmont
        $q_newmont = "SELECT  COUNT(Id) AS _EXISTS
                        FROM  _max_labperu_DetallePedido
                       WHERE  Cod_Interno = '".$ci_muestra."'
                         AND  CodProductos_Combo LIKE '%newmont%'";

        if ($res_newmont = sqlsrv_query($enlacehost, $q_newmont)) {
          while($row_newmont = sqlsrv_fetch_array($res_newmont)) {
            $estado = $row_newmont["_EXISTS"];

            if ($estado == 0){
              echo json_encode(array('estado' => $estado));

              return;
            }

            // Comprobando si se registraron todos los pesos para los Grupos Newmont
              $q_GruposNewmont = "SELECT  COUNT(D.Id) AS _COUNT
                                    FROM  Preparacion_Newmont_Detalle D
                                          INNER JOIN Preparacion_Newmont_Cabecera C ON D.Id_Cabecera = C.Id
                                   WHERE  D.Id_Cabecera IN (SELECT Id
                                                              FROM Preparacion_Newmont_Cabecera
                                                             WHERE CI_Muestra = '".$ci_muestra."')
                                     AND  D.Reanalisis_Por_Positivo = 0
                                     AND  C.Cierre_Newmont = 1";

              if ($res_GruposNewmont = mysqli_query($enlace, $q_GruposNewmont)) {
                if (mysqli_num_rows($res_GruposNewmont) > 0) {
                  while($row_GruposNewmont = mysqli_fetch_assoc($res_GruposNewmont)) {
                    $num_grupospreparacion = $row_GruposNewmont["_COUNT"];

                    // Verificando y comparando los grupos que hayan sido registrados hasta el momento
                      $q_PesosFundicion = "SELECT COUNT(Group_Newmont) AS _COUNT
                                             FROM Detalle_Rack
                                            WHERE ci_muestra = '".$ci_muestra."'
                                              AND is_Reanalisis = 0";

                      if ($res_PesosFundicion = mysqli_query($enlace, $q_PesosFundicion)) {
                        if (mysqli_num_rows($res_PesosFundicion) > 0) {
                          while($row_PesosFundicion = mysqli_fetch_assoc($res_PesosFundicion)) {
                            $num_gruposfundcion = $row_PesosFundicion["_COUNT"];

                            if ($num_grupospreparacion == $num_gruposfundcion){
                              $estado = 4;

                              echo json_encode(array('estado' => $estado));

                              return;
                            }
                            else{
                              // Valida si hay pesos pendientes
                                $q_NewmontPendientes = "SELECT  COUNT(Id) AS _COUNT
                                                          FROM  Preparacion_Newmont_Detalle
                                                         WHERE  Id_Cabecera IN (SELECT Id
                                                                      FROM Preparacion_Newmont_Cabecera
                                                                     WHERE CI_Muestra = '".$ci_muestra."')
                                                           AND  Reanalisis_Por_Positivo = 0
                                                           AND  PesoNegativo_muestra = 0";

                                if ($res_NewmontPendientes = mysqli_query($enlace, $q_NewmontPendientes)) {
                                  if (mysqli_num_rows($res_NewmontPendientes) > 0) {
                                    while($row_NewmontPendientes = mysqli_fetch_assoc($res_NewmontPendientes)) {
                                      if ($row_NewmontPendientes["_COUNT"] > 0){
                                        $estado = 5;

                                        echo json_encode(array('estado' => $estado));

                                        return;
                                      }
                                    }
                                  }
                                }
                            }
                          }
                        }
                      }
                  }
                }
              }

            // Comprueba que la muestra esté cerrada desde Preparación
              // $q_CierreNewmont = "SELECT  COUNT(Id) AS _COUNT
              //                       FROM  Preparacion_Newmont_Cabecera
              //                      WHERE  CI_Muestra = '".$ci_muestra."'
              //                        AND  Cierre_Newmont = 1";

              $q_CierreNewmont = "SELECT  COUNT(Id) AS _COUNT
                                    FROM  Preparacion_Newmont_Detalle
                                   WHERE  Id_Cabecera IN (SELECT  Id
                                                FROM  Preparacion_Newmont_Cabecera
                                               WHERE  CI_Muestra = '".$ci_muestra."')
                                     AND  Cierre_Grupo = 1";

              if ($res_CierreNewmont = mysqli_query($enlace, $q_CierreNewmont)) {
                if (mysqli_num_rows($res_CierreNewmont) > 0) {
                  while($row_CierreNewmont = mysqli_fetch_assoc($res_CierreNewmont)) {
                    if ($row_CierreNewmont["_COUNT"] == 0){
                      $estado = 2;

                      echo json_encode(array('estado' => $estado));

                      return;
                    }
                  }
                }
              }

            // // Comprobar que la muestra no exista en otro Rack
            //   $q_exists = "SELECT  COUNT(Id) AS _COUNT
            //                  FROM  Detalle_Rack
            //                 WHERE  ci_muestra = '".$ci_muestra."'
            //                   AND  is_Reanalisis = 0
            //                   AND  Id_Rack <> ".$id_rack;

            //   if ($res_exists = mysqli_query($enlace, $q_exists)) {
            //     if (mysqli_num_rows($res_exists) > 0) {
            //       while($row_exists = mysqli_fetch_assoc($res_exists)) {
            //         if ($row_exists["_COUNT"] > 0){
            //           $estado = 3;

            //           echo json_encode(array('estado' => $estado));

            //           return;
            //         }
            //       }
            //     }
            //   }
          }
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_ListaGruposNewmont':
      $r = array();
      $estado = 0;

      $ci_muestra = $_GET["CI_Muestra"];

      // Verificando los grupos que ya tengan peso en Fundición
        $in_gruponewmont = '';

        $q_PesosFundicion = "SELECT Group_Newmont
                               FROM Detalle_Rack
                              WHERE ci_muestra = '".$ci_muestra."'";

        if ($res_PesosFundicion = mysqli_query($enlace, $q_PesosFundicion)) {
          if (mysqli_num_rows($res_PesosFundicion) > 0) {
            while($row_PesosFundicion = mysqli_fetch_assoc($res_PesosFundicion)) {
              $in_gruponewmont .= $row_PesosFundicion["Group_Newmont"].", ";
            }

            $in_gruponewmont = substr($in_gruponewmont, 0, -2);
          }
        }

        if (strlen($in_gruponewmont) == 0){
          $in_gruponewmont = "''";
        }

      // Obtiene los grupos disponibles
        $q_GruposNewmont = "SELECT  Id,
                                    CONCAT('Grupo ', Num_Grupo) AS NUM_GRUPO
                              FROM  Preparacion_Newmont_Detalle
                             WHERE  Id_Cabecera IN (SELECT Id
                                                      FROM Preparacion_Newmont_Cabecera
                                                     WHERE CI_Muestra = '".$ci_muestra."')
                               AND  Reanalisis_Por_Positivo = 0
                               AND  Cierre_Grupo = 1
                               AND Id NOT IN (".$in_gruponewmont.")";

        if ($res_GruposNewmont = mysqli_query($enlace, $q_GruposNewmont)) {
          if (mysqli_num_rows($res_GruposNewmont) > 0) {
            while($row_GruposNewmont = mysqli_fetch_assoc($res_GruposNewmont)) {
              array_push($r, $row_GruposNewmont);
            }

            $estado = 1;
          }
        }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_PesoPositivoPreparacion':
      $r = array();
      $estado = 0;
      $peso_positivo = 0;

      $id_detalle_preparacion = $_GET["Id_Detalle_Preparacion"];

      $q_PesoPositivo = "SELECT  PesoPositivo_muestra
                           FROM  Preparacion_Newmont_Detalle
                          WHERE  Id = ".$id_detalle_preparacion;

      if ($res_PesoPositivo = mysqli_query($enlace, $q_PesoPositivo)) {
        if (mysqli_num_rows($res_PesoPositivo) > 0) {
          $estado = 1;

          while ($row_PesoPositivo = mysqli_fetch_assoc($res_PesoPositivo)) {
            $peso_positivo = $row_PesoPositivo["PesoPositivo_muestra"];
          }
        }
      }

      echo json_encode(array('estado' => $estado, 'peso_positivo' => $peso_positivo));

      break;

    case 'guardar_PesoMuestraNewmont_Rack':
      $r = array();
      $estado = 0;
      $exists = 0;

      $positivo_negativo = $_GET["Positivo_Negativo"];
      $ci_muestra = $_GET["CI_Muestra"];
      $id_rack = $_GET["Id_Rack"];
      $num_crisol = $_GET["Num_Crisol"];
      $id_gruponewmont = $_GET["Id_GrupoNewmont"];
      $nom_gruponewmont = $_GET["Nom_GrupoNewmont"];
      $tipo_blanco = $_GET["Tipo_Blanco"];
      $dosificacion = $_GET["Dosificacion"];
      $dosificacion_negativo = $_GET["Dosificacion_Negativo"];
      $peso_muestra = $_GET["Peso_Muestra"];
      $usuario_peso = $_GET["Usuario_Peso"];

      // Busca la muestra en las tablas de ventas
        $q_RackMuestra = "SELECT  C.Id_Pedido,
                                  D.Id AS Id_Detalle,
                                  D.Cod_Interno,
                                  D.Nom_Muestra,
                                  PV.Id_MedioPago
                            FROM  _max_labperu_DetallePedido D
                                  INNER JOIN _max_labperu_CabeceraPedido C ON D.Id_Pedido = C.Id_Pedido
                                  INNER JOIN _max_labperu_PagoVenta PV ON C.Id_Pedido = PV.Id_Pedido
                           WHERE  D.Cod_Interno = '".$ci_muestra."'";

        if ($res_RackMuestra = sqlsrv_query($enlacehost, $q_RackMuestra)) {
          while($row_RackMuestra = sqlsrv_fetch_array($res_RackMuestra)) {
            $nom_muestra = trim($row_RackMuestra["Nom_Muestra"]);

            if ($positivo_negativo == "P"){
              // Guardando en la tabla Detalle_Rack
                $q_InsertDetalle = "INSERT INTO Detalle_Rack(Id_Rack, Id_Pedido, Id_Detalle, Rack_TipoMuestra,
                                                             ci_muestra, nom_muestra, is_Au, is_Ag,
                                                             is_Newmont, Group_Newmont, Id_TipoBlancoFundente, Dosificacion,
                                                             num_replica, Id_MedioPago, is_Reanalisis, Usuario_Muestra) VALUES(";
                $q_InsertDetalle .= $id_rack.", ";
                $q_InsertDetalle .= $row_RackMuestra["Id_Pedido"].", ";
                $q_InsertDetalle .= $row_RackMuestra["Id_Detalle"].", 1, ";
                $q_InsertDetalle .= "'".$ci_muestra."', ";
                $q_InsertDetalle .= "'".$nom_muestra."', 0, 0, 1, ";
                $q_InsertDetalle .= $id_gruponewmont.", ";
                $q_InsertDetalle .= $tipo_blanco.", ";
                $q_InsertDetalle .= "'".$dosificacion."', 0, ";
                $q_InsertDetalle .= $row_RackMuestra["Id_MedioPago"].", 0, ";
                $q_InsertDetalle .= "'".$usuario_peso."')";

                if ($res_InsertDetalle = mysqli_query($enlace, $q_InsertDetalle)) {
                  // Obteniendo Id
                    $q_Id = "SELECT Id
                               FROM Detalle_Rack
                             ORDER BY Id DESC
                             LIMIT 1";
                }
            }
            else{
              // Actualiza dosificación del negativo
                $q_dosificacion = "UPDATE Detalle_Rack
                                      SET Dosificacion_Negativo = '".$dosificacion_negativo."'
                                    WHERE ci_muestra = '".$ci_muestra."'";

                if ($res_dosificacion = mysqli_query($enlace, $q_dosificacion)) {
                }

              $q_Id = "SELECT Id
                         FROM Detalle_Rack
                        WHERE ci_muestra = '".$ci_muestra."'";
            }

            // Obtiene el Id de la tabla Detalle_Rack
              if ($res_Id = mysqli_query($enlace, $q_Id)) {
                if (mysqli_num_rows($res_Id) > 0) {
                  while ($row_Id = mysqli_fetch_assoc($res_Id)) {
                    $id_detalle_rack = $row_Id["Id"];
                  }
                }
              }

            // Guardar Pesos
              $q_SavePeso = "INSERT INTO Detalle_Rack_Pesos(Id_Detalle_Rack, Num_Crisol, Id_TipoBlancoFundente, Dosificacion, Nom_Muestra, Peso_Muestra, UsuarioPeso_Muestra, ";
              $q_SavePeso .= (($positivo_negativo == 'P') ? "is_Newmont_Positivo" : "is_Newmont_Negativo").") VALUES(";
              $q_SavePeso .= $id_detalle_rack.", ";
              $q_SavePeso .= $num_crisol.", ";
              $q_SavePeso .= $tipo_blanco.", ";
              $q_SavePeso .= "'".(($positivo_negativo == 'P') ? $dosificacion : $dosificacion_negativo)."', ";
              $q_SavePeso .= "'".$ci_muestra.(($positivo_negativo == 'P') ? ' (+'.$nom_gruponewmont.')' : ' (-'.$nom_gruponewmont.')')."', ";
              $q_SavePeso .= $peso_muestra.", ";
              $q_SavePeso .= "'".$usuario_peso."', ";
              $q_SavePeso .= "1)";

              if ($res = mysqli_query($enlace, $q_SavePeso)) {
                $estado = 1;
              }
              else{
                $estado = 0;
              }
          }
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'cierre_Rack':
      $r = array();
      $estado = 0;

      $id_rack = $_GET["Id_Rack"];
      $usuario_rack = $_GET["Usuario_Rack"];

      $q_save = "UPDATE  Cabecera_Rack SET ";
      $q_save .= "  cierre_rack = 1, ";
      $q_save .= "  usuario_cierrerack = '".$usuario_rack."', ";
      $q_save .= "  fecha_cierrerack = '".$g_fecha."'";
      $q_save .= " WHERE Id = ".$id_rack;

      if ($res = mysqli_query($enlace, $q_save)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_ListaRacks_PesoRegulos':
      $r = array();
      $estado = 0;

      $fecha_inicio = $_GET["Fecha_Inicio"];
      $fecha_fin = $_GET["Fecha_Fin"];

      $q_Racks = "SELECT 0 AS ITEM,
                         CR.nom_rack,
                         CR.des_rack,
                         CR.fecha_cierrerack AS fecha_rack,
                         CR.usuario_cierrerack AS usuario_rack,
                         CR.Id,
                         (SELECT COUNT(DRP.Id) AS NUM_MUESTRAS
                            FROM  Detalle_Rack_Pesos DRP 
                           WHERE  DRP.Id_Detalle_Rack IN (SELECT Id
                                                            FROM Detalle_Rack
                                                           WHERE Id_Rack = CR.Id)) AS NUM_MUESTRAS,
                         CR.id_horno,
                         H.cod_horno,
                         H.capacidad_horno,
                         CR.cierre_pesoregulo
                    FROM Cabecera_Rack CR
                         INNER JOIN tbconfig_Hornos H ON CR.id_horno = H.Id
                   WHERE DATE(CR.fecha_rack) BETWEEN '".$fecha_inicio."' AND '".$fecha_fin."'
                     AND cierre_Rack = 1";

      if ($res_Racks = mysqli_query($enlace, $q_Racks)) {
        if (mysqli_num_rows($res_Racks) > 0) {
          while($row_Racks = mysqli_fetch_assoc($res_Racks)) {
            array_push($r, $row_Racks);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaRackMuestras_PesoRegulo':
      $r = array();
      $estado = 0;

      $Id_Rack = $_GET["Id_Rack"];

      // $q_RackMuestras = "SELECT DRP.Num_Crisol,
      //                           RTM.nom_tipo AS TIPO,
      //                           DRP.nom_muestra,
      //                           TB.nom_tipoblanco,
      //                           CASE WHEN is_Newmont = 0
      //                             THEN DR.Dosificacion
      //                           ELSE CASE WHEN DRP.is_Newmont_Positivo = 1
      //                               THEN DR.Dosificacion
      //                                ELSE CASE WHEN DRP.is_Newmont_Negativo = 1
      //                                   THEN DR.Dosificacion_Negativo END END END AS Dosificacion,
      //                           DRP.Peso_Muestra,
      //                           DRP.Peso_Regulo,
      //                           DRP.Id,
      //                           CR.cierre_pesoregulo,
      //                           DRP.UsuarioPeso_Muestra,
      //                           DRP.FechaPeso_Muestra,
      //                           DRP.FechaPeso_Regulo,
      //                           DRP.UsuarioPeso_Regulo,
      //                           DRP.isNot_Regulo
      //                     FROM  Detalle_Rack DR
      //                           INNER JOIN Detalle_Rack_Pesos DRP ON DR.Id = DRP.Id_Detalle_Rack
      //                           INNER JOIN tbconfig_RackTipoMuestras RTM ON DR.Rack_TipoMuestra = RTM.Id
      //                           INNER JOIN tbconfig_RackTipoBlancoFundente TB ON DR.Id_TipoBlancoFundente = TB.Id
      //                           INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
      //                    WHERE  DR.Id_Rack = ".$Id_Rack;

      $q_RackMuestras = "SELECT DRP.Num_Crisol,
                                RTM.nom_tipo AS TIPO,
                                DRP.nom_muestra,
                                TB.nom_tipoblanco,
                                DRP.Dosificacion,
                                DRP.Peso_Muestra,
                                DRP.Peso_Regulo,
                                DRP.Id,
                                CR.cierre_pesoregulo,
                                DRP.UsuarioPeso_Muestra,
                                DRP.FechaPeso_Muestra,
                                DRP.FechaPeso_Regulo,
                                DRP.UsuarioPeso_Regulo,
                                DRP.isNot_Regulo,
                                DRP.isDesactivado_EnRack,
                                DRP.isObservado_Regulo,
                                DRP.isObservado_ReguloObservacion
                          FROM  Detalle_Rack DR
                                INNER JOIN Detalle_Rack_Pesos DRP ON DR.Id = DRP.Id_Detalle_Rack
                                INNER JOIN tbconfig_RackTipoMuestras RTM ON DR.Rack_TipoMuestra = RTM.Id
                                INNER JOIN tbconfig_RackTipoBlancoFundente TB ON DR.Id_TipoBlancoFundente = TB.Id
                                INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
                         WHERE  DR.Id_Rack = ".$Id_Rack;

      if ($res_RackMuestras = mysqli_query($enlace, $q_RackMuestras)) {
        if (mysqli_num_rows($res_RackMuestras) > 0) {
          while($row_RackMuestras = mysqli_fetch_assoc($res_RackMuestras)) {
            array_push($r, $row_RackMuestras);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'guardar_PesosRegulo':
      $r = array();
      $estado = 0;

      $Id_Detalle_Peso = $_GET["Id_Detalle_Peso"];
      $Peso_Regulo = $_GET["Peso_Regulo"];
      $Usuario_Peso = $_GET["Usuario_Peso"];
      $Is_Observado = $_GET["Is_Observado"];

      // Para el peso de Muestras
        $observacion = '';

        $q_SavePeso = "UPDATE Detalle_Rack_Pesos
                          SET FechaPeso_Regulo = '".$g_fecha."',
                              Peso_Regulo = ".$Peso_Regulo.",
                              UsuarioPeso_Regulo = '".$Usuario_Peso."',
                              isObservado_Regulo = ".$Is_Observado.",
                              isObservado_ReguloObservacion = '".(($Is_Observado == 1) ? 'Muestra fuera de límite.' : $observacion)."'
                        WHERE Id = ".$Id_Detalle_Peso;

        if ($res = mysqli_query($enlace, $q_SavePeso)) {
          $estado = 1;
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'cierre_PesoRegulos':
      $r = array();
      $estado = 0;

      $id_rack = $_GET["Id_Rack"];
      $usuario_cierrepesorack = $_GET["Usuario_CierrePesoRack"];

      $q_save = "UPDATE  Cabecera_Rack SET ";
      $q_save .= "  cierre_pesoregulo = 1, ";
      $q_save .= "  usuario_cierrepesoregulo = '".$usuario_cierrepesorack."', ";
      $q_save .= "  fecha_cierrepesoregulo = '".$g_fecha."'";
      $q_save .= " WHERE Id = ".$id_rack;

      if ($res = mysqli_query($enlace, $q_save)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_ListaRacks_PesoDore':
      $r = array();
      $estado = 0;

      $fecha_inicio = $_GET["Fecha_Inicio"];
      $fecha_fin = $_GET["Fecha_Fin"];

      $q_Racks = "SELECT 0 AS ITEM, CR.nom_rack,
                         CR.des_rack, CR.fecha_cierrepesoregulo AS fecha_rack,
                         CR.usuario_cierrepesoregulo AS usuario_rack, CR.Id,
                         (SELECT COUNT(DRP.Id) AS NUM_MUESTRAS
                            FROM  Detalle_Rack_Pesos DRP 
                           WHERE  DRP.Id_Detalle_Rack IN (SELECT Id
                                                            FROM Detalle_Rack
                                                           WHERE Id_Rack = CR.Id)) AS NUM_MUESTRAS,
                         CR.id_horno,
                         H.cod_horno,
                         H.capacidad_horno
                    FROM Cabecera_Rack CR
                         INNER JOIN tbconfig_Hornos H ON CR.id_horno = H.Id
                   WHERE DATE(CR.fecha_rack) BETWEEN '".$fecha_inicio."' AND '".$fecha_fin."'
                     AND cierre_pesoregulo = 1";

      if ($res_Racks = mysqli_query($enlace, $q_Racks)) {
        if (mysqli_num_rows($res_Racks) > 0) {
          while($row_Racks = mysqli_fetch_assoc($res_Racks)) {
            array_push($r, $row_Racks);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaRackMuestras_PesoDore':
      $r = array();
      $estado = 0;

      $Id_Rack = $_GET["Id_Rack"];

      $q_RackMuestras = "SELECT DRP.Num_Crisol,
                                RTM.nom_tipo AS TIPO,
                                DRP.NumCrisol_Dore AS CRISOL,
                                DRP.nom_muestra,
                                TB.nom_tipoblanco,
                                DRP.Dosificacion,
                                DRP.Peso_Muestra,
                                DRP.Peso_Regulo,
                                DRP.Peso_Dore,
                                DRP.Id,
                                CR.cierre_pesodore,
                                DRP.UsuarioPeso_Muestra,
                                DRP.FechaPeso_Muestra,
                                DRP.FechaPeso_Regulo,
                                DRP.UsuarioPeso_Regulo,
                                DRP.FechaPeso_Dore,
                                DRP.UsuarioPeso_Dore,
                                DRP.isNot_Regulo,
                                DRP.isDesactivado_EnRack,
                                DRP.isObservado_Regulo,
                                DRP.isObservado_ReguloObservacion,
                                DRP.isNot_Dore,
                                DRP.isObservado_Dore,
                                DRP.isObservado_DoreObservacion
                          FROM  Detalle_Rack DR
                                INNER JOIN Detalle_Rack_Pesos DRP ON DR.Id = DRP.Id_Detalle_Rack
                                INNER JOIN tbconfig_RackTipoMuestras RTM ON DR.Rack_TipoMuestra = RTM.Id
                                INNER JOIN tbconfig_RackTipoBlancoFundente TB ON DR.Id_TipoBlancoFundente = TB.Id
                                INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
                         WHERE  DR.Id_Rack = ".$Id_Rack;

      if ($res_RackMuestras = mysqli_query($enlace, $q_RackMuestras)) {
        if (mysqli_num_rows($res_RackMuestras) > 0) {
          while($row_RackMuestras = mysqli_fetch_assoc($res_RackMuestras)) {
            array_push($r, $row_RackMuestras);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'guardar_PesosDore':
      $r = array();
      $estado = 0;

      $Id_Detalle_Peso = $_GET["Id_Detalle_Peso"];
      $Peso_Dore = $_GET["Peso_Dore"];
      $Usuario_Peso = $_GET["Usuario_Peso"];

      // Para el peso de Muestras
        $q_SavePeso = "UPDATE Detalle_Rack_Pesos
                          SET FechaPeso_Dore = '".$g_fecha."',
                              Peso_Dore = ".$Peso_Dore.",
                              UsuarioPeso_Dore = '".$Usuario_Peso."'
                        WHERE Id = ".$Id_Detalle_Peso;

        if ($res = mysqli_query($enlace, $q_SavePeso)) {
          $estado = 1;
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_Diferencia_PesoDore':
      $r = array();
      $estado = 0;
      $diferencias = "";

      $id_detallepeso = $_GET["id_detallepeso"];
      $nom_muestra = str_replace('*', '+', $_GET["nom_muestra"]);

      $q_diferencias = "SELECT  DRP.Num_Crisol,
                                DRP.Peso_Dore
                          FROM  Detalle_Rack_Pesos DRP
                         WHERE  DRP.Id_Detalle_Rack IN (SELECT  Id_Detalle_Rack
                                                          FROM  Detalle_Rack_Pesos
                                                         WHERE  Id = ".$id_detallepeso.")
                           AND  DRP.Nom_Muestra = '".$nom_muestra."'
                        ORDER BY Num_Crisol";

      if ($res_diferencias = mysqli_query($enlace, $q_diferencias)) {
        if (mysqli_num_rows($res_diferencias) > 0) {
          while($row_diferencias = mysqli_fetch_assoc($res_diferencias)) {
            $diferencias .= $row_diferencias["Num_Crisol"].'*'.$row_diferencias["Peso_Dore"].'|';
          }

          $diferencias = substr($diferencias, 0, -1);

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'diferencia' => $diferencias));

      break;

    case 'update_ObservadoDore':
      $r = array();
      $estado = 0;

      $id_detallepeso = $_GET["id_detallepeso"];
      $nom_muestra = $_GET["nom_muestra"];

      // Obtiene el código de Rack
        $q_iddetallerack = "SELECT  Id_Detalle_Rack
                              FROM  Detalle_Rack_Pesos
                             WHERE  Id = ".$id_detallepeso;

        if ($res_iddetallerack = mysqli_query($enlace, $q_iddetallerack)) {
          if (mysqli_num_rows($res_iddetallerack) > 0) {
            while($row_iddetallerack = mysqli_fetch_assoc($res_iddetallerack)) {
              $id_detallerack .= $row_iddetallerack["Id_Detalle_Rack"];
            }
          }
        }

      // Para el peso de Muestras
        $q_update = "UPDATE Detalle_Rack_Pesos
                        SET isObservado_Dore = 1,
                            isObservado_DoreObservacion = 'Diferencia entre Dorés mayor a: 0.00036'
                      WHERE Nom_Muestra = '".$nom_muestra."'
                        AND Id_Detalle_Rack = ".$id_detallerack;

        if ($res = mysqli_query($enlace, $q_update)) {
          $estado = 1;
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'update_SetNumCrisol':
      $r = array();
      $estado = 0;

      $id_rack = $_GET["id_rack"];
      $id_detallepeso = $_GET["id_detallepeso"];
      $num_crisol = $_GET["num_crisol"];
      $tipo = $_GET["tipo"];

      // Actualiza el Crisol de la muestra seleccionada
        $q_update = "UPDATE Detalle_Rack_Pesos
                        SET NumCrisol_Dore = ".$num_crisol."
                      WHERE Id = ".$id_detallepeso;

        if ($res = mysqli_query($enlace, $q_update)) {
          $estado = 1;
        }
        else{
          $estado = 0;
        }

      // Si es el tipo 2 asigna de forma correlatica los Crisoles
        if ($tipo == 2){
          $num_crisol += 1;

          $q_muestras = "SELECT  Id
                           FROM  Detalle_Rack_Pesos
                          WHERE  Id_Detalle_Rack IN (SELECT  Id
                                                       FROM  Detalle_Rack
                                                      WHERE  Id_Rack = ".$id_rack.")
                           AND  Id > ".$id_detallepeso;

          if ($res_muestras = mysqli_query($enlace, $q_muestras)) {
            if (mysqli_num_rows($res_muestras) > 0) {
              while($row_muestras = mysqli_fetch_assoc($res_muestras)) {
                $id_detallepeso = $row_muestras["Id"];

                // Actualiza Número de Crisol por cada muestra
                  $q_update = "UPDATE Detalle_Rack_Pesos
                                  SET NumCrisol_Dore = ".$num_crisol."
                                WHERE Id = ".$id_detallepeso;

                  if ($res = mysqli_query($enlace, $q_update)) {
                  }

                $num_crisol += 1;
              }

              $estado = 1;
            }
          }
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'cierre_PesoDore':
      $r = array();
      $estado = 0;

      $id_rack = $_GET["Id_Rack"];
      $usuario_cierrepesorack = $_GET["Usuario_CierrePesoRack"];

      $q_save = "UPDATE  Cabecera_Rack SET ";
      $q_save .= "  cierre_pesodore = 1, ";
      $q_save .= "  usuario_cierrepesodore = '".$usuario_cierrepesorack."', ";
      $q_save .= "  fecha_cierrepesodore = '".$g_fecha."'";
      $q_save .= " WHERE Id = ".$id_rack;

      if ($res = mysqli_query($enlace, $q_save)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'get_ListaRacks_PesoOro':
      $r = array();
      $estado = 0;

      $fecha_inicio = $_GET["Fecha_Inicio"];
      $fecha_fin = $_GET["Fecha_Fin"];

      $q_Racks = "SELECT 0 AS ITEM, CR.nom_rack,
                         CR.des_rack, CR.fecha_cierrepesodore AS fecha_rack,
                         CR.usuario_cierrepesodore AS usuario_rack, CR.Id,
                         (SELECT COUNT(DRP.Id) AS NUM_MUESTRAS
                            FROM  Detalle_Rack_Pesos DRP 
                           WHERE  DRP.Id_Detalle_Rack IN (SELECT Id
                                                            FROM Detalle_Rack
                                                           WHERE Id_Rack = CR.Id)) AS NUM_MUESTRAS,
                         CR.id_horno,
                         H.cod_horno,
                         H.capacidad_horno
                    FROM Cabecera_Rack CR
                         INNER JOIN tbconfig_Hornos H ON CR.id_horno = H.Id
                   WHERE DATE(CR.fecha_rack) BETWEEN '".$fecha_inicio."' AND '".$fecha_fin."'
                     AND cierre_pesodore = 1";

      if ($res_Racks = mysqli_query($enlace, $q_Racks)) {
        if (mysqli_num_rows($res_Racks) > 0) {
          while($row_Racks = mysqli_fetch_assoc($res_Racks)) {
            array_push($r, $row_Racks);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'get_ListaRackMuestras_PesoOro':
      $r = array();
      $estado = 0;

      $Id_Rack = $_GET["Id_Rack"];

      $q_RackMuestras = "SELECT DRP.Num_Crisol,
                                RTM.nom_tipo AS TIPO,
                                DRP.NumCrisol_Dore AS CRISOL,
                                DRP.nom_muestra,
                                TB.nom_tipoblanco,
                                CASE WHEN is_Newmont = 0
                                  THEN DR.Dosificacion
                                ELSE CASE WHEN DRP.is_Newmont_Positivo = 1
                                    THEN DR.Dosificacion
                                     ELSE CASE WHEN DRP.is_Newmont_Negativo = 1
                                        THEN DR.Dosificacion_Negativo END END END AS Dosificacion,
                                DRP.Peso_Muestra,
                                DRP.Peso_Regulo,
                                DRP.Peso_Dore,
                                DRP.Peso_Au,
                                DRP.Id,
                                CR.cierre_pesoau,
                                DRP.UsuarioPeso_Muestra,
                                DRP.FechaPeso_Muestra,
                                DRP.FechaPeso_Regulo,
                                DRP.UsuarioPeso_Regulo,
                                DRP.FechaPeso_Dore,
                                DRP.UsuarioPeso_Dore,
                                DRP.FechaPeso_Au,
                                DRP.UsuarioPeso_Au,
                                CASE WHEN DRP.isObservado_Au = 1 THEN 'SÍ' ELSE '' END AS isObservado_Au,
                                DRP.isNot_Au
                          FROM  Detalle_Rack DR
                                INNER JOIN Detalle_Rack_Pesos DRP ON DR.Id = DRP.Id_Detalle_Rack
                                INNER JOIN tbconfig_RackTipoMuestras RTM ON DR.Rack_TipoMuestra = RTM.Id
                                INNER JOIN tbconfig_RackTipoBlancoFundente TB ON DR.Id_TipoBlancoFundente = TB.Id
                                INNER JOIN Cabecera_Rack CR ON DR.Id_Rack = CR.Id
                         WHERE  DR.Id_Rack = ".$Id_Rack;

      if ($res_RackMuestras = mysqli_query($enlace, $q_RackMuestras)) {
        if (mysqli_num_rows($res_RackMuestras) > 0) {
          while($row_RackMuestras = mysqli_fetch_assoc($res_RackMuestras)) {
            array_push($r, $row_RackMuestras);
          }

          $estado = 1;
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'genera_Solicitud':
      $r = array();
      $estado = 0;

      $id_solicitud = $_GET["Id_Solicitud"];
      $id_registro = $_GET["Id_Registro"];
      $usuario_solicitud = $_GET["usuario_solicitud"];
      $observacion_solicitud = $_GET["observacion_solicitud"];

      $q_save = "INSERT INTO Gestion_Solicitudes(Id_Solicitud, Id_Registro, usuario_solicitud, fecha_solicitud, observacion_solicitud) VALUES(";
      $q_save .= $id_solicitud.", ";
      $q_save .= $id_registro.", ";
      $q_save .= "'".$usuario_solicitud."', ";
      $q_save .= "'".$g_fecha."', ";
      $q_save .= "'".$observacion_solicitud."')";

      if ($res = mysqli_query($enlace, $q_save)) {
        // Obtiene el Id de la solicitud generada
          $id_solicitud = mysqli_insert_id($enlace);

        // Actrualiza la tabla de Cabecera de Rack
          $q_update = "UPDATE Cabecera_Rack ";
          $q_update .= "   SET solicitud_cierre = 1, ";
          $q_update .= "       id_solicitudcierre = ".$id_solicitud;
          $q_update .= " WHERE Id = ".$id_registro;

        if ($res_update = mysqli_query($enlace, $q_update)) {
          $estado = 1;
        }
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'verificar_Solicitud':
      $r = array();
      $estado = 0;

      $Id_Rack = $_GET["Id_Rack"];
      $usuario_rack = $_GET["Usuario_Rack"];

      $q_confirmacion = "SELECT solicitud_aceptada,
                                solicitud_rechazada,
                                CASE WHEN solicitud_aceptada = 0 AND solicitud_rechazada = 0
                                  THEN 0
                                ELSE CASE WHEN solicitud_aceptada = 1 THEN 1 ELSE 2 END END AS CONFIRMACION
                           FROM Gestion_Solicitudes
                          WHERE Id_Solicitud = 1
                            AND Id_Registro = ".$Id_Rack."
                         ORDER BY fecha_solicitud DESC LIMIT 1";

      if ($res_confirmacion = mysqli_query($enlace, $q_confirmacion)) {
        if (mysqli_num_rows($res_confirmacion) > 0) {
          while($row_confirmacion = mysqli_fetch_assoc($res_confirmacion)) {
            // MAX - 08/12/2020 (ESTO NO SERÁ NECESARIO PORQUE NEN EL LIMS NECESITO SABER EL RESULTADO DE LA CONFIRMACIÓN DEL ENCARGADO)
            // if ($row_confirmacion["CONFIRMACION"] == 1 || $row_confirmacion["CONFIRMACION"] == 2){
            //   $q_update = "UPDATE Cabecera_Rack ";
            //   $q_update .= "   SET solicitud_cierre = 0 ";
            //   $q_update .= " WHERE Id = ".$Id_Rack;

            //   if ($res_update = mysqli_query($enlace, $q_update)) {
            //   }
            // }

            if ($row_confirmacion["CONFIRMACION"] == 1){
              $estado = 1;
            }

            if ($row_confirmacion["CONFIRMACION"] == 2){
              $estado = 2;
            }
          }
        }
      }

      echo json_encode(array('estado' => $estado, 'registros' => $r));

      break;

    case 'elimina_GrupoNewmont':
      $r = array();
      $estado = 0;

      $id_rack = $_GET["Id_Rack"];
      $id_detalle_rack = $_GET["Id_Detalle_Rack"];
      $usuario_eliminar = $_GET["Usuario_Eliminar"];

      // Guarda Auditoría
        $q_audi = "INSERT INTO Auditoria_EliminacionGruposNewmontRacks (Id_Detalle_Rack_Pesos, Id_Detalle_Rack, Num_Crisol,
                               Id_TipoBlancoFundente, Dosificacion, Nom_Muestra, FechaPeso_Muestra,
                               Peso_Muestra, UsuarioPeso_Muestra, Fecha_Eliminacion, Usuario_Eliminacion)";

        $q_audi .= "SELECT  Id,
                            Id_Detalle_Rack,
                            Num_Crisol,
                            Id_TipoBlancoFundente,
                            Dosificacion,
                            Nom_Muestra,
                            FechaPeso_Muestra,
                            Peso_Muestra,
                            UsuarioPeso_Muestra, ";
        $q_audi .= "        '".$g_fecha."', ";
        $q_audi .= "        '".$usuario_eliminar."' ";
        $q_audi .= "  FROM  Detalle_Rack_Pesos
                     WHERE  Id_Detalle_Rack = ". $id_detalle_rack;

        if ($res_audi = mysqli_query($enlace, $q_audi)) {
        }

      // Eliminando datos en la tabla de pesos
        $q_delete1 = "DELETE FROM Detalle_Rack_Pesos
                      WHERE Id_Detalle_Rack = ".$id_detalle_rack;

        if ($res_delete1 = mysqli_query($enlace, $q_delete1)) {
          // Eliminando datos en la tabla de detalles
            $q_delete2 = "DELETE FROM Detalle_Rack
                          WHERE Id = ".$id_detalle_rack;

            if ($res_delete2 = mysqli_query($enlace, $q_delete2)) {
              $estado = 1;

              // Reumerando los N° de orden
                $o = 1;

                $q_ids = "SELECT  Id
                            FROM  Detalle_Rack_Pesos
                           WHERE  Id_Detalle_Rack IN (SELECT  Id
                                                        FROM  Detalle_Rack
                                                       WHERE  Id_Rack = ".$id_rack.")";

                if ($res_ids = mysqli_query($enlace, $q_ids)) {
                  if (mysqli_num_rows($res_ids) > 0) {
                    while ($row_ids = mysqli_fetch_assoc($res_ids)) {
                      $id_detalle_rack = $row_ids["Id"];

                      // Actualizando N° orden
                        $q_update = "UPDATE Detalle_Rack_Pesos
                                        SET Num_Crisol = ".$o."
                                      WHERE Id = ".$id_detalle_rack;

                        if ($res_update = mysqli_query($enlace, $q_update)) {
                        }

                        $o += 1;
                    }
                  }
                }
            }
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'grabar_AusenciaMuestras':
      $r = array();
      $estado = 0;

      $id_modulo = $_GET["Id_Modulo"];
      $id_muestra = $_GET["Id_Muestra"];
      $usuario_ausencia = $_GET["Usuario_Ausencia"];

      // Para el peso de Muestras
        if ($id_modulo == 1){
          $q_SaveAusencia = "UPDATE Detalle_Rack_Pesos
                                SET isReanalisis_Regulo = 1,
                                    isNot_Regulo = 1,
                                    isNot_ReguloFecha = '".$g_fecha."',
                                    isNot_ReguloUsuario = '".$usuario_ausencia."',
                                    isDesactivado_EnRack = 1
                              WHERE Id IN (".$id_muestra.")";
        }

        if ($res = mysqli_query($enlace, $q_SaveAusencia)) {
          // Seteando el Reanálisis en la tabla superior
            $q_update = "UPDATE Detalle_Rack
                            SET is_Reanalisis = 1
                          WHERE Id IN (SELECT Id_Detalle_Rack
                                         FROM Detalle_Rack_Pesos
                                        WHERE Id IN (".$id_muestra.")
                                       GROUP BY Id_Detalle_Rack)";

            if ($res_update = mysqli_query($enlace, $q_update)) {
              $estado = 1;

              // Buscando muestras Newmont
                $q_muestras = "SELECT Id,
                                      ci_muestra,
                                      Group_Newmont
                                 FROM Detalle_Rack
                                WHERE Id IN (SELECT Id_Detalle_Rack
                                               FROM Detalle_Rack_Pesos
                                              WHERE Id IN (".$id_muestra.")
                                             GROUP BY Id_Detalle_Rack)
                                  AND is_Newmont = 1";

                if ($res_muestras = mysqli_query($enlace, $q_muestras)) {
                  if (mysqli_num_rows($res_muestras) > 0) {
                    while($row_muestras = mysqli_fetch_assoc($res_muestras)) {
                      // Deshabilitando grupo en el Rack
                        $q_desactivar = "UPDATE Detalle_Rack_Pesos
                                            SET isDesactivado_EnRack = 1
                                          WHERE Id_Detalle_Rack = ".$row_muestras["Id"];

                        if ($res_desactivar = mysqli_query($enlace, $q_desactivar)) {
                          // Habilitando el botón de nuevo grupo de Newmont (Módulo de Preparación)
                            $q_newgrupo = "UPDATE Preparacion_Newmont_Cabecera
                                              SET is_NewGrupo = 1
                                            WHERE CI_Muestra = '".$row_muestras["ci_muestra"]."'";

                            if ($res_newgrupo = mysqli_query($enlace, $q_newgrupo)) {
                              // Indicando que es un reanálisis por positivo
                                $q_reanalisis = "UPDATE Preparacion_Newmont_Detalle
                                                    SET Reanalisis_Por_Positivo = 1
                                                  WHERE Id = ".$row_muestras["Group_Newmont"];

                                if ($res_reanalisis = mysqli_query($enlace, $q_reanalisis)) {
                                }
                            }
                        }
                    }
                  }
                }
            }
            else{
              $estado = 0;
            }
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'grabar_EnvioAlertasMuestrasFueraLimite':
      $r = array();
      $estado = 0;

      $id_modulo = $_GET["Id_Modulo"];
      $id_muestras = $_GET["Id_Muestras"];
      $observacion_envio = $_GET["Observacion_Envio"];
      $usuario_envio = $_GET["Usuario_Envio"];

      // Armando los inserts
        $a = 0;
        $arr_muestras = explode(",", $id_muestras);
        $observacion_envio = explode("|", $observacion_envio);

        $insert = "INSERT INTO Auditoria_EnvioAlertasMuestrasFueraLimite (cod_modulopeso, id_detalle_rack_peso,
                                                                          usuario_envio, fecha_envio,
                                                                          observacion_envio) VALUES ";
        $insert .= "";

        while ($a < count($arr_muestras)){
          $insert .= "(".$id_modulo.", ";
          $insert .= $arr_muestras[$a].", ";
          $insert .= "'".$usuario_envio."', ";
          $insert .= "'".$g_fecha."', ";
          $insert .= "'".$observacion_envio[$a]."'), ";

          $a += 1;
        }

        $insert = substr($insert, 0, -2);

      // Guarda envío
        if ($res = mysqli_query($enlace, $insert)) {
          $estado = 1;
        }

      echo json_encode(array('estado' => $estado));

      break;

    case 'create_NewGrupoNewmont':
      $r = array();
      $estado = 0;

      $id_cabecera = $_GET["Id_Cabecera"];
      $num_grupo = $_GET["Num_Grupo"];
      $usuario_grupo = $_GET["Usuario_Grupo"];

      $q_save = "INSERT INTO Preparacion_Newmont_Detalle(Id_Cabecera, Num_Grupo, Creado_Por_Reanalisis,
                                                         NewGrupo_Fecha, NewGrupo_Usuario) VALUES(";
      $q_save .= $id_cabecera.", ".$num_grupo.", 1, '".$g_fecha."', '".$usuario_grupo."')";

      if ($res = mysqli_query($enlace, $q_save)) {
        // Quitando el flag de New Grupo
          $q_update = "UPDATE Preparacion_Newmont_Cabecera
                          SET is_NewGrupo = 0
                        WHERE Id = ".$id_cabecera;

          if ($res_update = mysqli_query($enlace, $q_update)) {
            $estado = 1;
          }
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'update_EstadoSolicitudCierre':
      $r = array();
      $estado = 0;

      $id_rack = $_GET["Id_Rack"];

      $q_update = "UPDATE Cabecera_Rack
                      SET solicitud_cierre = 0
                    WHERE Id = ".$id_rack;

      if ($res = mysqli_query($enlace, $q_update)) {
        $estado = 1;
      }
      else{
        $estado = 0;
      }

      echo json_encode(array('estado' => $estado));

      break;

    case 'update_DosificacionNewmont':
      $r = array();
      $estado = 0;

      $Id_DetalleRackPesos = $_GET["Id_DetalleRackPesos"];
      $Dosificacion = $_GET["Dosificacion"];
      $Usuario_Update = $_GET["Usuario_Update"];

      // Si es una actualización de datos debe registrar los datos de Auditorías
        $q_audi = "INSERT INTO Auditoria_ActualizacionDatosMuestras (Id_Detalle_Rack_Pesos, Id_Detalle_Rack, Num_Crisol,
                                Id_TipoBlancoFundente, Dosificacion, Nom_Muestra, FechaPeso_Muestra,
                                Peso_Muestra, UsuarioPeso_Muestra, UpdateId_TipoBlancoFundente, Update_Dosificacion,
                                UpdateFechaPeso_Muestra, UpdatePeso_Muestra, UpdateUsuarioPeso_Muestra)";
        $q_audi .= "SELECT  Id,
                            Id_Detalle_Rack,
                            Num_Crisol,
                            Id_TipoBlancoFundente,
                            Dosificacion,
                            Nom_Muestra,
                            FechaPeso_Muestra,
                            Peso_Muestra,
                            UsuarioPeso_Muestra,
                            Id_TipoBlancoFundente, ";
        $q_audi .= "        '".$Dosificacion."', ";
        $q_audi .= "        '".$g_fecha."', ";
        $q_audi .= "        Peso_Muestra, ";
        $q_audi .= "        '".$Usuario_Update."' ";
        $q_audi .= "  FROM  Detalle_Rack_Pesos
                     WHERE  Id = ".$Id_DetalleRackPesos;

        if ($res_audi = mysqli_query($enlace, $q_audi)) {
        }

      // Actualiza datos
        $q_update = "UPDATE Detalle_Rack_Pesos SET 
                            Dosificacion = '".$Dosificacion."',
                            FechaPeso_Muestra = '".$g_fecha."'
                      WHERE Id = ".$Id_DetalleRackPesos;

        if ($res = mysqli_query($enlace, $q_update)) {
          $estado = 1;
        }
        else{
          $estado = 0;
        }

      echo json_encode(array('estado' => $estado));

      break;

    default:

      # code...

      break;

  }

?>