<?php
	
	session_start();

	include('../../php/conn.php');

	if(!isset($_SESSION["id"])){
		header('Location: index.php');
	}

	mysqli_query($enlace, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");

?>

<!DOCTYPE html>
<html lang="es">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<!-- Meta, title, CSS, favicons, etc. -->
		<meta charset="utf-8">
		<meta http-equiv="X-UA-Compatible" content="IE=edge">
		<meta name="viewport" content="width=device-width, initial-scale=1">

		<title>Conformidad y Reporte de Resultados</title>

		<!-- Bootstrap -->
		<link href="../vendors/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
		<!-- Font Awesome -->
		<link href="../vendors/font-awesome/css/font-awesome.min.css" rel="stylesheet">
		<!-- NProgress -->
		<link href="../vendors/nprogress/nprogress.css" rel="stylesheet">
		<!-- iCheck -->
		<link href="../vendors/iCheck/skins/flat/green.css" rel="stylesheet">
		<!-- bootstrap-progressbar -->
		<link href="../vendors/bootstrap-progressbar/css/bootstrap-progressbar-3.3.4.min.css" rel="stylesheet">
		<!-- JQVMap -->
		<link href="../vendors/jqvmap/dist/jqvmap.min.css" rel="stylesheet"/>
		<!-- bootstrap-daterangepicker -->
		<link href="../vendors/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
		<!-- Ion.RangeSlider -->
		<link href="../vendors/normalize-css/normalize.css" rel="stylesheet">
		<link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.css" rel="stylesheet">
		<link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.skinFlat.css" rel="stylesheet">
		<!-- Bootstrap Colorpicker -->
		<link href="../vendors/mjolnic-bootstrap-colorpicker/dist/css/bootstrap-colorpicker.min.css" rel="stylesheet">
		<link href="../vendors/cropper/dist/cropper.min.css" rel="stylesheet">
		<!-- Datatables -->
		<link href="../vendors/datatables.net-bs/css/dataTables.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-buttons-bs/css/buttons.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-fixedheader-bs/css/fixedHeader.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-responsive-bs/css/responsive.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-scroller-bs/css/scroller.bootstrap.min.css" rel="stylesheet">

		<!-- bootstrap-datetimepicker -->
		<link href="../vendors/bootstrap-datetimepicker/build/css/bootstrap-datetimepicker.css" rel="stylesheet">

		<!-- Switchery -->
		<link href="../vendors/switchery/dist/switchery.min.css" rel="stylesheet">

		<!-- Custom Theme Style -->
		<link href="../build/css/custom.min.css" rel="stylesheet">

		<script type="text/javascript">
			var Id_Pedido = 0;
			var Id_DetallePedido = 0;
			var Estado_Cierre = 0;
			var campos_evaluados = 0;
			let resultado_prev = 0;
		</script>

		<style type="text/css">
			th {
				position: sticky;
				top: 0px;
				background-color: #12537E;
			}
		</style>
	</head>

	<body class="nav-md" onload="f_LoadResultados()" style="zoom: 80%">
		<div class="container body">
			<div class="main_container">
				<?php include('partes/sidebar.php'); ?>

				<!-- page content -->
				<div class="right_col" role="main">
					<div class="">
						<div class="row">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
									<div class="x_title">
										<h2>
											Revisión y Conformidad de Resultados
										</h2>
										<div class="clearfix">
										</div>
									</div>

									<div class="x_content">
										<!-- Filtros -->
										<div class="col-md-6 col-sm-6 col-xs-12">
											<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
												<div class="x_title">
													<h2>
														<font style="font-size: 14px"><b>Búsqueda por rango de fechas</b></font>
													</h2>

													<div class="clearfix">
													</div>
												</div>

												<div class="x_content">
													<div class="form-group col-md-6 col-sm-6 col-xs-12" style="margin-top: 9px;">
														<label class="control-label col-md-5 col-sm-5 col-xs-12" style="margin-top: 6px; text-align: right;">
															Desde
														</label>
														<div class="col-md-7 col-sm-7 col-xs-12">
															<?php
																date_default_timezone_set("America/Lima"); 
																$time = date('Y-m-d');

																echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_inicio" value="'.$time.'"/>';
															?>
														</div>
													</div>

													<div class="form-group col-md-6 col-sm-6 col-xs-12" style="margin-top: 9px;">
														<label class="control-label col-md-5 col-sm-5 col-xs-12" style="margin-top: 6px; text-align: right;">
															Hasta
														</label>
														<div class="col-md-7 col-sm-7 col-xs-12">
															<?php
																echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_fin" value="'.$time.'"/>';
															?>
														</div>
													</div>
												</div>
											</div>
										</div>

										<div class="col-md-3 col-sm-3 col-xs-12">
											<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
												<div class="x_title">
													<h2>
														<font style="font-size: 14px"><b>Búsqueda por Tipo de Muestra</b></font>
													</h2>

													<div class="clearfix">
													</div>
												</div>

												<div class="x_content">
													<div class="form-group col-md-12 col-sm-12 col-xs-12" style="margin-top: 9px;">
														<select id="lista_tipomuestra" class="form-control" required>
															<!-- <option selected = "true" value="">Elija una opción...</option> -->

															<option value="0">Newmont</option>
															<option disabled value="">------------------------------------------</option>

															<?php
																$c = 1;

																$q_Tipos = "SELECT Id,
																									 Nombre_TipoMuestra
																							FROM _max_labperu_TiposMuestra
																						 WHERE Estado_TipoMuestra = 'A'
																						ORDER BY 2";

																if ($res_Tipos = sqlsrv_query($enlacehost, $q_Tipos)) {
																	while($row_Tipos = sqlsrv_fetch_array($res_Tipos)) {
																		echo '<option '.(($row_Tipos["Id"] == 5) ? 'Selected' : '').' value="'.$row_Tipos["Id"].'">'.$row_Tipos["Nombre_TipoMuestra"].'</option>';

																		$c += 1;
																	}
																}
															?>

														</select>
													</div>
												</div>
											</div>
										</div>

										<div class="col-md-3 col-sm-3 col-xs-12">
											<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
												<div class="x_title">
													<h2>
														<font style="font-size: 14px"><b>Búsqueda por Fundidor</b></font>
													</h2>
													<div class="clearfix">
													</div>
												</div>

												<div class="x_content">
													<div class="form-group col-md-12 col-sm-12 col-xs-12" style="margin-top: 9px;">
														<select id="lista_fundidor" class="form-control" style="text-align: left;">
															<option value="">Elija una opción...</option>
														</select>
													</div>
												</div>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>

						<div class="row">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<button id="btn_buscar" class="btn btn-success" type="button" onclick="f_LoadResultados()" style="width: 100%; background-color: #26B99A">
									<b>Ejecutar Búsqueda</b>
								</button>
							</div>
						</div>

						<div class="row" style="margin-top: 10px">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
									<div class="x_title">
										<div class="col-md-8 col-sm-8 col-xs-12">
											<h2>
												Lista de Resultados

												<input id="total_resultados" type="hidden">
											</h2>
										</div>

										<div class="col-md-4 col-sm-4 col-xs-12" style="text-align: right;">
											<div class="col-md-6 col-sm-6 col-xs-6">
												<button class="btn btn-success" type="button" onclick="f_Cierre(1)" style="width: 100%; background-color: #3399CC">
													<b>Pre Cierre</b>
												</button>
											</div>

											<div class="col-md-6 col-sm-6 col-xs-6">
												<button class="btn btn-success" type="button" onclick="f_Cierre(2)" style="width: 100%; background-color: #F25050">
													<b>Cierre</b>
												</button>
											</div>
										</div>

										<div class="clearfix">
										</div>
									</div>

									<div class="x_content" style="overflow-x: scroll;">
										<div class="col-md-12 col-sm-12 col-xs-12;" style="margin-bottom: 5px;" hidden>
											<table id="tbl_elementos">
												<tr style="font-size: 14px;">
													<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 60px; background-color: #cccccc; color: #2A2B24; border-top-left-radius: 15px; padding: 3px;">
														<img src="../usuario/images/delete.png" style="width: 25px;" onclick="f_LimpiarFiltros();">
													</th>

													<th style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 60px; background-color: #2A2B24; color: #ffffff;">
														Ag (oz/tc)
														</th>

													<th style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 60px; background-color: #2A2B24; color: #ffffff;">
														Au (g/t)
													</th>

													<th style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 60px; background-color: #2A2B24; color: #ffffff;">
														Cu (%)
													</th>

													<th style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 60px; background-color: #2A2B24; color: #ffffff;">
														Pb (%)
													</th>

													<th style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 60px; background-color: #2A2B24; color: #ffffff;">
														Zn (%)
													</th>

													<th style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 60px; background-color: #2A2B24; color: #ffffff;">
														CuSac (%)
													</th>

													<th style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 60px; background-color: #2A2B24; color: #ffffff;">
														PbOx (%)
													</th>

													<th style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 60px; background-color: #2A2B24; color: #ffffff;">
														ZnOx (%)
													</th>

													<th style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 60px; background-color: #2A2B24; color: #ffffff;">
														As
													</th>

													<th style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 60px; background-color: #2A2B24; color: #ffffff;">
														Sb
													</th>

													<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 60px; background-color: #2A2B24; color: #ffffff; border-top-right-radius: 15px;">
														Fe
													</th>
												</tr>

												<tr style="font-size: 14px;">
													<td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 60px; background-color: #cccccc; color: #2A2B24;">
														<label style="margin-top: 5px;">
															Desde
														</label>

														<label style="margin-top: 5px;">
															+/-
														</label>
													</td>

													<td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 80px;">
														<input id="Ag_valor" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
														<input id="Ag_intervalo" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
													</td>

													<td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 80px;">    	<input id="Au_valor" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
														<input id="Au_intervalo" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
													</td>

													<td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 80px;">    	<input id="Cu_valor" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
														<input id="Cu_intervalo" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
													</td>

													<td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 80px;">    	<input id="Pb_valor" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
														<input id="Pb_intervalo" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
													</td>

													<td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 80px;">    	<input id="Zn_valor" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
														<input id="Zn_intervalo" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
													</td>

													<td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 80px;">    	<input id="CuSac_valor" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
														<input id="CuSac_intervalo" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
													</td>

													<td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 80px;">    	<input id="PbOx_valor" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
														<input id="PbOx_intervalo" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
													</td>

													<td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 80px;">    	<input id="ZnOx_valor" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
														<input id="ZnOx_intervalo" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
													</td>

													<td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 80px;">    	<input id="As_valor" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
														<input id="As_intervalo" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
													</td>

													<td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 80px;">    	<input id="Sb_valor" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
														<input id="Sb_intervalo" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
													</td>

													<td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold; cursor: pointer; min-width: 80px;">    	<input id="Fe_valor" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
														<input id="Fe_intervalo" type="number" class="form-control col-md-12 col-xs-12" style="text-align: center; font-weight: bold;">
													</td>
												</tr>
											</table>
										</div>

										<div id="tabla_analisisresultados" class="table-box" style="width: 100%; padding-top: 10px;">
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Ventanas Modal -->
		<div id="divmodal_Cierre" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false">
			<div class="modal-dialog" style="width: 40%; margin-top: 12%; margin-left: 30%">
				<!-- Modal content-->
				<div class="modal-content">
					<div class="modal-header">
						<button type="button" class="close" data-dismiss="modal">
							&times;
						</button>

						<h4 class="modal-title"><b>
							Cierre de Análisis
						</b></h4>
					</div>

					<div class="modal-body">
						<div class="row"><center>
							<label id="cierre_mensaje" style="margin-left: 10px; margin-right: 10px; color: #A63D33; font-size: 14px;"><b>
								Prueba de mensaje
							</b></label>
						</center></div>

						<div class="ln_solid"></div>

						<div class="row">
							<div class="col-md-4 col-sm-4 col-xs-4"><center>
								<button class="btn btn-success" type="button" onclick="f_ModalRevertirCierre()" style="width: 150px; background-color: #A63D33">
									Revertir
								</button>
							</center></div>

							<div class="col-md-4 col-sm-4 col-xs-4"><center>
								<button id="btn_cerrar" class="btn btn-success" type="button" onclick="f_ModalUpdateCierre()" style="width: 150px; background-color: #26B99A">
									Cerrar
								</button>
							</center></div>

							<div class="col-md-4 col-sm-4 col-xs-4"><center>
								<button class="btn btn-success" type="button" onclick="f_cerrarModal(1)" style="width: 150px; background-color: #807D80">
									Cancelar
								</button>
							</center></div>
						</div>

						<input id="id_pedido" type="hidden">
						<input id="id_detallepedido" type="hidden">
						<input id="estado_cierre" type="hidden">
						<input id="cierre_imageorden" type="hidden">
					</div>
				</div>
			</div>
		</div>

		<div id="divmodal_qr" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false">
			<div class="modal-dialog" style="width: 50%; margin-top: 12%; margin-left: 25%">
					<!-- Modal content-->
				<div class="modal-content">
					<div class="modal-header">
						<button type="button" class="close" data-dismiss="modal">
							&times;
						</button>

						<h4 class="modal-title">
							<b> Código QR - Informe de Ensayos </b>
						</h4>
					</div>

					<div class="modal-body">
						<div class="row">
							<div class="form-group col-md-5 col-sm-5 col-xs-12">
								<label class="control-label col-md-6 col-sm-6 col-xs-12" style="margin-top: 6px">
									Nombre de Muestra
								</label>

								<div class="col-md-6 col-sm-6 col-xs-12"><b>
									<input type="text" class="form-control col-md-12 col-xs-12" id="qr_muestra" style="text-align: center; background-color: #F2A71B" disabled/>
								</b></div>
							</div>

							<div class="form-group col-md-7 col-sm-7 col-xs-12">
								<label class="control-label col-md-3 col-sm-3 col-xs-12" style="text-align: right; margin-top: 6px">
									Análisis
								</label>

								<div class="col-md-8 col-sm-8 col-xs-12">
									<b>
										<input type="text" class="form-control col-md-12 col-xs-12" id="qr_analisis" style="text-align: center; background-color: #0455BF; color: #ffffff" disabled/>
									</b>
								</div>
							</div>
						</div>

						<div class="row">
							<div class="ln_solid"></div>
						</div>

						<input id="qr_id_pedido" type="hidden">
						<input id="qr_id_detallepedido" type="hidden">

						<div class="row">
							<center>
								<img id="img_qr" width="350px" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px; cursor: pointer;" onclick="f_DownloadImg()"/>
							</center>
						</div>

						<div class="row">
							<div class="form-group col-md-12 col-sm-12 col-xs-12" style="text-align: center;">
								<label style="cursor: pointer;" onclick="f_DownloadImg()">
									<u> Descargar Imagen QR </u>
								</label>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>

		<div id="divmodal_Loading" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false" style="margin-top: 300px;">
			<div class="modal-dialog" style="height: 200px; opacity: 0.5;"><center>
				<img src="images/loading.gif" width="200px" style="border: solid; border-width: 1px; border-color: #D9D9D9;  border-radius: 15px;"></img>
			</center></div>
		</div>

		<!-- jQuery -->
		<script src="../vendors/jquery/dist/jquery.min.js"></script>
		<!-- Bootstrap -->
		<script src="../vendors/bootstrap/dist/js/bootstrap.min.js"></script>
		<!-- FastClick -->
		<script src="../vendors/fastclick/lib/fastclick.js"></script>
		<!-- NProgress -->
		<script src="../vendors/nprogress/nprogress.js"></script>
		<!-- Ion.RangeSlider -->
		<script src="../vendors/ion.rangeSlider/js/ion.rangeSlider.min.js"></script>
		<!-- Bootstrap Colorpicker -->
		<script src="../vendors/mjolnic-bootstrap-colorpicker/dist/js/bootstrap-colorpicker.min.js"></script>
		<!-- Custom Theme Scripts -->
		<script src="../build/js/custom.min.js"></script>

		<!-- bootstrap-daterangepicker -->
		<script src="../vendors/moment/min/moment.min.js"></script>
		<script src="../vendors/bootstrap-daterangepicker/daterangepicker.js"></script><!-- Datatables -->
		<script src="../vendors/datatables.net/js/jquery.dataTables.min.js"></script>
		<script src="../vendors/datatables.net-bs/js/dataTables.bootstrap.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/dataTables.buttons.min.js"></script>
		<script src="../vendors/datatables.net-buttons-bs/js/buttons.bootstrap.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/buttons.flash.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/buttons.html5.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/buttons.print.min.js"></script>
		<script src="../vendors/datatables.net-fixedheader/js/dataTables.fixedHeader.min.js"></script>
		<script src="../vendors/datatables.net-keytable/js/dataTables.keyTable.min.js"></script>
		<script src="../vendors/datatables.net-responsive/js/dataTables.responsive.min.js"></script>
		<script src="../vendors/datatables.net-responsive-bs/js/responsive.bootstrap.js"></script>
		<script src="../vendors/datatables.net-scroller/js/dataTables.scroller.min.js"></script>
		<script src="../vendors/jszip/dist/jszip.min.js"></script>
		<script src="../vendors/pdfmake/build/pdfmake.min.js"></script>
		<script src="../vendors/pdfmake/build/vfs_fonts.js"></script>

		<!-- Funciones Principales -->
		<script type="text/javascript">
			function f_LoadResultados(){
				var htmlContenido = '';
				var htmlContenido_2 = '';
				var htmlContenido_3 = '';
				var htmlContenido_4 = '';

				// Obteniendo filtros
					var fecha_inicio = $("#fecha_inicio").val();
					var fecha_fin = $("#fecha_fin").val();
					var lista_tipomuestra = $("#lista_tipomuestra").val();
					lista_tipomuestra = ((lista_tipomuestra.length == '') ? 5 : lista_tipomuestra);

					var lista_fundidor = $("#lista_fundidor").val();

				// Validando ingreso de filtros
					if (fecha_inicio == null){
						alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

						return;
					}
					if (fecha_inicio.length == 0){
						alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

						return;
					}

					if (fecha_fin == null){
						alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

						return;
					}
					if (fecha_fin.length == 0){
						alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

						return;
					}

					if (fecha_fin < fecha_inicio){
						alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

							return;
					}

				// Loading Modal
					var modal_loading = $("#divmodal_Loading");
					modal_loading.modal({backdrop: 'static', keyboard: false});

				// Obteniendo el símbolo para las cabeceras
					var _simbolo_auag = 'g/tm';
					var _simbolo = '%';

					if (lista_tipomuestra == 3){
						var _simbolo_auag = 'g/Kg';
						_simbolo = '%';
					}

					if (lista_tipomuestra == 6){
						var _simbolo_auag = 'ppm';
						_simbolo = 'ppm';
					}

					// Arma la estructura de la tabla
						htmlContenido = '<table class="table table-striped jambo_table bulk_action" style="border-width: 0;">';
						htmlContenido += '  <thead>';

						if (lista_tipomuestra == 0){
							htmlContenido += '      <tr>';
							htmlContenido += '          <th colspan="8" style="background-color: #ffffff;">';
							htmlContenido += '          </th>';
							htmlContenido += '          <th colspan="7" style="text-align: center;">';
							htmlContenido += '              DATOS NEWMONT';
							htmlContenido += '          </th>';
							htmlContenido += '      </tr>';
						}

						htmlContenido += '      <tr>';
						htmlContenido += '          <th style="width: 1%; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>';
						htmlContenido += '              Item';
						htmlContenido += '          </center></th>';
						htmlContenido += '          <th style="width: 1%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>';
						htmlContenido += '              Acción';
						htmlContenido += '          </center></th>';
						htmlContenido += '          <th style="width: 1%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>';
						htmlContenido += '              Oficina';
						htmlContenido += '          </center></th>';
						htmlContenido += '          <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; background: #734432"><center>';
						htmlContenido += '              Fecha Hora Recepción';
						htmlContenido += '          </center></th>';
						htmlContenido += '          <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; background-color: #8C6354"><center>';
						htmlContenido += '              Fecha Hora Entrega';
						htmlContenido += '          </center></th>';
						htmlContenido += '          <th style="width: 5%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>';
						htmlContenido += '              Observación';
						htmlContenido += '          </center></th>';
						htmlContenido += '          <th style="width: 6%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #A63D33; min-width: 120px;"><center>';
						htmlContenido += '              Código Muestra';
						htmlContenido += '          </center></th>';
						htmlContenido += '          <th style="width: 6%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;" hidden><center>';
						htmlContenido += '              Tipo Muestra';
						htmlContenido += '          </center></th>';
						htmlContenido += '          <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #F29F05"><center>';
						htmlContenido += '              Fecha Inicio Ensayo';
						htmlContenido += '          </center></th>';

						if (lista_tipomuestra == 0){
							htmlContenido += '          <th colspan="2" style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #168039"><center>';
							htmlContenido += '              Pesos (g)';
							htmlContenido += '          </center></th>';
							htmlContenido += '          <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #168039"><center>';
							htmlContenido += '              Malla';
							htmlContenido += '          </center></th>';
							htmlContenido += '          <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #168039"><center>';
							htmlContenido += '              Ag (g/tm)';
							htmlContenido += '          </center></th>';
							htmlContenido += '          <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #168039"><center>';
							htmlContenido += '              Au (g/tm)';
							htmlContenido += '          </center></th>';
							htmlContenido += '          <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #168039"><center>';
							htmlContenido += '              Ag (oz/tc)';
							htmlContenido += '          </center></th>';
							htmlContenido += '          <th style="width: 3%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #168039"><center>';
							htmlContenido += '              Au (oz/tc)';
							htmlContenido += '          </center></th>';
						}
						else{
							htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
							htmlContenido += '              AG (' + ((lista_tipomuestra == 8) ? '%' : _simbolo_auag) + ')';
							htmlContenido += '          </center></th>';
							htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
							htmlContenido += '              AU (' + ((lista_tipomuestra == 8) ? '%' : _simbolo_auag) + ')';
							htmlContenido += '          </center></th>';

							if (lista_tipomuestra == 4 || lista_tipomuestra == 5 || lista_tipomuestra == 7){
								htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
								htmlContenido += '              AG (oz/tc)';
								htmlContenido += '          </center></th>';
								htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
								htmlContenido += '              AU (oz/tc)';
								htmlContenido += '          </center></th>';
							}
						}
						
						htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
						htmlContenido += '              CU (' + _simbolo + ')';
						htmlContenido += '          </center></th>';
						htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
						htmlContenido += '              PB (' + _simbolo + ')';
						htmlContenido += '          </center></th>';
						htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
						htmlContenido += '              ZN (' + _simbolo + ')';
						htmlContenido += '          </center></th>';
						htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
						htmlContenido += '              AS (' + _simbolo + ')';
						htmlContenido += '          </center></th>';
						htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
						htmlContenido += '              FE (' + _simbolo + ')';
						htmlContenido += '          </center></th>';
						htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
						htmlContenido += '              SB (' + _simbolo + ')';
						htmlContenido += '          </center></th>';

						if (lista_tipomuestra == 0 || lista_tipomuestra == 3 || lista_tipomuestra == 4 || lista_tipomuestra == 5 || lista_tipomuestra == 7){
							htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
							htmlContenido += '              H2O (' + _simbolo + ')';
							htmlContenido += '          </center></th>';
						}

						htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
						htmlContenido += '              CUSAC (' + _simbolo + ')';
						htmlContenido += '          </center></th>';

						htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
						htmlContenido += '              PBO (' + _simbolo + ')';
						htmlContenido += '          </center></th>';

						htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
						htmlContenido += '              ZNO (' + _simbolo + ')';
						htmlContenido += '          </center></th>';

						htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
						htmlContenido += '              MN (' + _simbolo + ')';
						htmlContenido += '          </center></th>';

						htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
						htmlContenido += '              MO (' + _simbolo + ')';
						htmlContenido += '          </center></th>';

						htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
						htmlContenido += '              INS (' + _simbolo + ')';
						htmlContenido += '          </center></th>';

						htmlContenido += '          <th style="min-width: 120px; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #518C86"><center>';
						htmlContenido += '              S (' + _simbolo + ')';
						htmlContenido += '          </center></th>';

						htmlContenido += '          <th style="width: 5%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>';
						htmlContenido += '              Observación Reporte';
						htmlContenido += '          </center></th>';
						htmlContenido += '          <th colspan="2" style="width: 7%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>';
						htmlContenido += '              Informe de Ensayos';
						htmlContenido += '          </center></th>';
						htmlContenido += '      </tr>';
						htmlContenido += '  </thead>';

						htmlContenido += '  <tbody style="overflow: scroll">';

					// Carga resultados
						var c = 1;
						var r = 1;
						var _visible = 0;
						var _campos = '';

					// Armando el array de filtro por rangos
						var rg = 1;
						var valor = 0;
						var rango = 0;
						var campo = '';
						var arr_filtrosrangos = '';

						while (rg <= 11){
							var valor = '';
							var rango = '';

							// Busca en cada grupo de elementos
								if (rg == 1){
									valor = $("#Ag_valor").val();
									rango = $("#Ag_intervalo").val();

									if (lista_tipomuestra == 0){
										campo = 'DPN.Ley_Ag_ot';
									}
									else{
										campo = 'DAR.Ley_Ag_ot';
									}
								}

								if (rg == 2){
									valor = $("#Au_valor").val();
									rango = $("#Au_intervalo").val();
									campo = 'DAR.Ley_Au_gt';

									if (lista_tipomuestra == 0){
										campo = 'DPN.Ley_Au_gt';
									}
									else{
										campo = 'DAR.Ley_Au_gt';
									}
								}

								if (rg == 3){
									valor = $("#Cu_valor").val();
									rango = $("#Cu_intervalo").val();
									campo = 'DAR.Porc_CU';
								}

								if (rg == 4){
									valor = $("#Pb_valor").val();
									rango = $("#Pb_intervalo").val();
									campo = 'DAR.Porc_PB';
								}

								if (rg == 5){
									valor = $("#Zn_valor").val();
									rango = $("#Zn_intervalo").val();
									campo = 'DAR.Porc_ZN';
								}

								if (rg == 6){
									valor = $("#CuSac_valor").val();
									rango = $("#CuSac_intervalo").val();
									campo = 'DAR.Porc_CUSAC';
								}

								if (rg == 7){
									valor = $("#PbOx_valor").val();
									rango = $("#PbOx_intervalo").val();
									campo = 'DAR.Porc_PBO';
								}

								if (rg == 8){
									valor = $("#ZnOx_valor").val();
									rango = $("#ZnOx_intervalo").val();
									campo = 'DAR.Porc_ZNO';
								}

								if (rg == 9){
									valor = $("#As_valor").val();
									rango = $("#As_intervalo").val();
									campo = 'DAR.Porc_AS';
								}

								if (rg == 10){
									valor = $("#Sb_valor").val();
									rango = $("#Sb_intervalo").val();
									campo = 'DAR.Porc_SB';
								}

								if (rg == 11){
									valor = $("#Fe_valor").val();
									rango = $("#Fe_intervalo").val();
									campo = 'DAR.Porc_FE';
								}

							// Verifica si el rango es válido
								if (valor.length > 0 && rango.length > 0){
									arr_filtrosrangos += campo + ' BETWEEN ' + (parseFloat(valor) - parseFloat(rango)) + ' AND ' + (parseFloat(valor) + parseFloat(rango)) + ' AND ';
								}

							rg ++;
						}

						if (arr_filtrosrangos.length > 0){
							arr_filtrosrangos = arr_filtrosrangos.substring(0, arr_filtrosrangos.length - 5);
						}

					// Si es Newmont
					if (lista_tipomuestra == 0){
							var n = 1;

							$.post( "ajax/encuesta.php", { accion: "Get_AnalisisResultados_Newmont", fecha_inicio: fecha_inicio, fecha_fin: fecha_fin, id_tipomuestra: lista_tipomuestra, id_fundidor: lista_fundidor, cliente: '', agrupados: '', arr_filtrosrangos: arr_filtrosrangos }, 
								function( data ) {
									if(data.estado == 1){
										$.each( data.registros, function( key, val ) {
											htmlContenido_2 = '';
											htmlContenido_3 = '';
											htmlContenido_4 = '';
											_campos = '';

											if (n == 1){
													htmlContenido += '<tr>';
													htmlContenido += '  <td rowspan="4" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right">' + c + '</td>';
											
													htmlContenido += '  <td rowspan="4" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>';

													if (val.Cod_EstadoResultadosCliente == 0){
															$image = 'check_a.png';
													}

													if (val.Cod_EstadoResultadosCliente == 1){
															$image = 'check_b.png';
													}

													if (val.Cod_EstadoResultadosCliente == 2){
															$image = 'check_c.png';
													}

													htmlContenido_3 += '  <td rowspan="4" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; color: #3F4242; background-color: ' + ((val.Sucursal == 1) ? '#D1DBBD' : '#D89196') + ' "><center><b>' + val.des_sucursal + '</b></center></td>';

													htmlContenido_3 += '  <td rowspan="4" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.FechaHora_Recepcion + '</center></td>';

													htmlContenido_3 += '  <td rowspan="4" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.FechaHora_Entrega + '</center></td>';

													htmlContenido_3 += '  <td rowspan="4" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;">' + val.Observacion + '</td>';

													htmlContenido_3 += '  <td rowspan="4" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; font-size: 14px; color: #A63D33"><center><b>' + val.Cod_Interno + '</b></center></td>';

													htmlContenido_3 += '  <td rowspan="4" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; font-size: 14px; color: #A63D33" hidden><center><b>' + val.Nombre_EstadoMuestra + '</b></center></td>';

													htmlContenido_3 += '  <td rowspan="4" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; font-size: 14px; color: #A63D33;"><center><b>';

													htmlContenido_3 += '    <input type="date" id="fie_' + c + '" style="text-align: left; width: 150px" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'fie_" + c + "', " + "'Fecha_InicioEnsayo'" + ')" value="' + val.Fecha_InicioEnsayo.substr(0, 10) + '"' + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

													htmlContenido_3 += '  </b></td>';

													// Iniciando los datos de Newmont
															htmlContenido_3 += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; font-size: 14px; color: #A63D33;"><center><b>' + val.PesosTitulo_Newmont + '</b></center></td>';

															htmlContenido_3 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

															htmlContenido_3 += '    <input type="text" id="peso_newmont' + n + '_' + c + '" style="text-align: right; width: 70px;" class="form-control" onblur="f_GrabarResultados_Newmont(' + val.Id_Pedido + ', ' + val.Id_Detalle + ', ' + val.Id_DetallePedido_Newmont + ", 'peso_newmont" + n + "_" + c + "', " + "'pesos'" + ', ' + c + ')" value="' + ((val.Pesos_Newmont == null) ? '' : val.Pesos_Newmont) + '"' + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';
															htmlContenido_3 += '    </b></td>';

															htmlContenido_3 += '  <td colspan="5"></td>';

													// % cu
															_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('cu') >= 0) ? 1 : 0 );

															htmlContenido_4 += '  <td rowspan="4" style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

															if (_visible == 1){
																	// Verifica que se una resulado con datos
																			if (val.Porc_CU != null){
																					simbolo_1 = 0;
																					simbolo_2 = 0;
																					resultado = '';

																					// Verifica si es: "-"
																							if (f_VerificaSimbolo(1, val.Porc_CU) == 1){
																									simbolo_1 = 1;
																							}

																					// Verifica si es: "<" ó ">"
																							var total_CEROS = f_VerificaSimbolo(2, val.Porc_CU)

																							if (total_CEROS >= 7){
																									simbolo_2 = 1;

																									resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_CU);
																							}

																					if (simbolo_1 == 0 && simbolo_2 == 0){
																							resultado = parseFloat(val.Porc_CU).toFixed(2);
																					}
																			}
																			else{
																					resultado = null;
																					simbolo_1 = 0;
																					simbolo_2 = 0;
																			}

																			resultado = ((simbolo_1 == 1) ? '-' : resultado);

																	htmlContenido_4 += '        <input type="text" id="cu_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'cu_" + c + "', " + "'Porc_CU'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

																	// htmlContenido_4 += '        <input type="text" id="au_1_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'au_1_" + c + "', " + "'Ley_Au_gt'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

																	_campos += 'CASE WHEN ISNULL(Porc_CU, 0) = 0 THEN 1 ELSE 0 END + ';
															}

															htmlContenido_4 += '    </b></td>';

													// % pb
															_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('pb') >= 0) ? 1 : 0 );

															htmlContenido_4 += '  <td rowspan="4" style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

															if (_visible == 1){
																	// Verifica que se una resulado con datos
																			if (val.Porc_PB != null){
																					simbolo_1 = 0;
																					simbolo_2 = 0;
																					resultado = '';

																					// Verifica si es: "-"
																							if (f_VerificaSimbolo(1, val.Porc_PB) == 1){
																									simbolo_1 = 1;
																							}

																					// Verifica si es: "<" ó ">"
																							var total_CEROS = f_VerificaSimbolo(2, val.Porc_PB)

																							if (total_CEROS >= 7){
																									simbolo_2 = 1;

																									resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_PB);
																							}

																					if (simbolo_1 == 0 && simbolo_2 == 0){
																							resultado = parseFloat(val.Porc_PB).toFixed(2);
																					}
																			}
																			else{
																					resultado = null;
																					simbolo_1 = 0;
																					simbolo_2 = 0;
																			}

																			resultado = ((simbolo_1 == 1) ? '-' : resultado);

																	htmlContenido_4 += '        <input type="text" id="pb_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'pb_" + c + "', " + "'Porc_PB'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

																	_campos += 'CASE WHEN ISNULL(Porc_PB, 0) = 0 THEN 1 ELSE 0 END + ';
															}

															htmlContenido_4 += '    </b></td>';

													// % zn
															_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('zn') >= 0) ? 1 : 0 );

															htmlContenido_4 += '  <td rowspan="4" style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

															if (_visible == 1){
																	// Verifica que se una resulado con datos
																			if (val.Porc_ZN != null){
																					simbolo_1 = 0;
																					simbolo_2 = 0;
																					resultado = '';

																					// Verifica si es: "-"
																							if (f_VerificaSimbolo(1, val.Porc_ZN) == 1){
																									simbolo_1 = 1;
																							}

																					// Verifica si es: "<" ó ">"
																							var total_CEROS = f_VerificaSimbolo(2, val.Porc_ZN)

																							if (total_CEROS >= 7){
																									simbolo_2 = 1;

																									resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_ZN);
																							}

																					if (simbolo_1 == 0 && simbolo_2 == 0){
																							resultado = parseFloat(val.Porc_ZN).toFixed(2);
																					}
																			}
																			else{
																					resultado = null;
																					simbolo_1 = 0;
																					simbolo_2 = 0;
																			}

																			resultado = ((simbolo_1 == 1) ? '-' : resultado);

																	htmlContenido_4 += '        <input type="text" id="zn_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'zn_" + c + "', " + "'Porc_ZN'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

																	_campos += 'CASE WHEN ISNULL(Porc_ZN, 0) = 0 THEN 1 ELSE 0 END + ';
															}

															htmlContenido_4 += '    </b></td>';

													// % as
															_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('as') >= 0) ? 1 : 0 );

															htmlContenido_4 += '  <td rowspan="4" style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

															if (_visible == 1){
																	// Verifica que se una resulado con datos
																			if (val.Porc_AS != null){
																					simbolo_1 = 0;
																					simbolo_2 = 0;
																					resultado = '';

																					// Verifica si es: "-"
																							if (f_VerificaSimbolo(1, val.Porc_AS) == 1){
																									simbolo_1 = 1;
																							}

																					// Verifica si es: "<" ó ">"
																							var total_CEROS = f_VerificaSimbolo(2, val.Porc_AS)

																							if (total_CEROS >= 7){
																									simbolo_2 = 1;

																									resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_AS);
																							}

																					if (simbolo_1 == 0 && simbolo_2 == 0){
																							resultado = parseFloat(val.Porc_AS).toFixed(2);
																					}
																			}
																			else{
																					resultado = null;
																					simbolo_1 = 0;
																					simbolo_2 = 0;
																			}

																			resultado = ((simbolo_1 == 1) ? '-' : resultado);

																	htmlContenido_4 += '        <input type="text" id="as_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'as_" + c + "', " + "'Porc_AS'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

																	_campos += 'CASE WHEN ISNULL(Porc_AS, 0) = 0 THEN 1 ELSE 0 END + ';
															}

															htmlContenido_4 += '    </b></td>';

													// % sb
															_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('sb') >= 0) ? 1 : 0 );

															htmlContenido_4 += '  <td rowspan="4" style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

															if (_visible == 1){
																	// Verifica que se una resulado con datos
																			if (val.Porc_SB != null){
																					simbolo_1 = 0;
																					simbolo_2 = 0;
																					resultado = '';

																					// Verifica si es: "-"
																							if (f_VerificaSimbolo(1, val.Porc_SB) == 1){
																									simbolo_1 = 1;
																							}

																					// Verifica si es: "<" ó ">"
																							var total_CEROS = f_VerificaSimbolo(2, val.Porc_SB)

																							if (total_CEROS >= 7){
																									simbolo_2 = 1;

																									resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_SB);
																							}

																					if (simbolo_1 == 0 && simbolo_2 == 0){
																							resultado = parseFloat(val.Porc_SB).toFixed(2);
																					}
																			}
																			else{
																					resultado = null;
																					simbolo_1 = 0;
																					simbolo_2 = 0;
																			}

																			resultado = ((simbolo_1 == 1) ? '-' : resultado);

																	htmlContenido_4 += '        <input type="text" id="sb_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'sb_" + c + "', " + "'Porc_SB'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

																	_campos += 'CASE WHEN ISNULL(Porc_SB, 0) = 0 THEN 1 ELSE 0 END + ';
															}

															htmlContenido_4 += '    </b></td>';

													// % s
															_visible = ((('|' + val.Elemento_Analisis + '|').toLowerCase().indexOf('|s|') >= 0) ? 1 : 0 );

															htmlContenido_4 += '  <td rowspan="4" style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

															if (_visible == 1){
																	// Verifica que se una resulado con datos
																			if (val.Porc_S != null){
																					simbolo_1 = 0;
																					simbolo_2 = 0;
																					resultado = '';

																					// Verifica si es: "-"
																							if (f_VerificaSimbolo(1, val.Porc_S) == 1){
																									simbolo_1 = 1;
																							}

																					// Verifica si es: "<" ó ">"
																							var total_CEROS = f_VerificaSimbolo(2, val.Porc_S)

																							if (total_CEROS >= 7){
																									simbolo_2 = 1;

																									resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_S);
																							}

																					if (simbolo_1 == 0 && simbolo_2 == 0){
																							resultado = parseFloat(val.Porc_S).toFixed(2);
																					}
																			}
																			else{
																					resultado = null;
																					simbolo_1 = 0;
																					simbolo_2 = 0;
																			}

																			resultado = ((simbolo_1 == 1) ? '-' : resultado);

																	htmlContenido_4 += '        <input type="text" id="s_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 's_" + c + "', " + "'Porc_S'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

																	_campos += 'CASE WHEN ISNULL(Porc_S, 0) = 0 THEN 1 ELSE 0 END + ';
															}

															htmlContenido_4 += '    </b></td>';

													// % fe
															_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('fe') >= 0) ? 1 : 0 );

															htmlContenido_4 += '  <td rowspan="4" style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

															if (_visible == 1){
																	// Verifica que se una resulado con datos
																			if (val.Porc_FE != null){
																					simbolo_1 = 0;
																					simbolo_2 = 0;
																					resultado = '';

																					// Verifica si es: "-"
																							if (f_VerificaSimbolo(1, val.Porc_FE) == 1){
																									simbolo_1 = 1;
																							}

																					// Verifica si es: "<" ó ">"
																							var total_CEROS = f_VerificaSimbolo(2, val.Porc_FE)

																							if (total_CEROS >= 7){
																									simbolo_2 = 1;

																									resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_FE);
																							}

																					if (simbolo_1 == 0 && simbolo_2 == 0){
																							resultado = parseFloat(val.Porc_FE).toFixed(2);
																					}
																			}
																			else{
																					resultado = null;
																					simbolo_1 = 0;
																					simbolo_2 = 0;
																			}

																			resultado = ((simbolo_1 == 1) ? '-' : resultado);

																	htmlContenido_4 += '        <input type="text" id="fe_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'fe_" + c + "', " + "'Porc_FE'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

																	_campos += 'CASE WHEN ISNULL(Porc_FE, 0) = 0 THEN 1 ELSE 0 END + ';
															}

															htmlContenido_4 += '    </b></td>';

													// % h2o
															if (lista_tipomuestra == 0 || lista_tipomuestra == 3 || lista_tipomuestra == 4 || lista_tipomuestra == 5 || lista_tipomuestra == 7){
																_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('h2o') >= 0) ? 1 : 0 );

																htmlContenido_4 += '  <td rowspan="4" style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

																if (_visible == 1){
																	simbolo_1 = 0;
																	simbolo_2 = 0;
																	resultado = '';

																	// Verifica que se una resulado con datos
																		if (val.Porc_H2O != null){
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																			resultado = '';

																			// Verifica si es: "-"
																				if (f_VerificaSimbolo(1, val.Porc_H2O) == 1){
																					simbolo_1 = 1;
																				}

																			// Verifica si es: "<" ó ">"
																				var total_CEROS = f_VerificaSimbolo(2, val.Porc_H2O)

																				if (total_CEROS >= 7){
																					simbolo_2 = 1;

																					resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_H2O);
																				}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																				resultado = parseFloat(val.Porc_H2O).toFixed(2);
																			}
																		}
																		else{
																			resultado = null;
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																		}

																		resultado = ((simbolo_1 == 1) ? '-' : resultado);

																	htmlContenido_4 += '        <input type="text" id="h2o_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'h2o_" + c + "', " + "'Porc_H2O'" + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

																	_campos += 'CASE WHEN ISNULL(Porc_H2O, 0) = 0 THEN 1 ELSE 0 END + ';
																}

																htmlContenido_4 += '    </b></td>';
															}

													// Arma el botón de cierre de resultados
														htmlContenido_2 += '        <img id="img_' + c + '" src="images/' + $image + '" width="50px" style="cursor: pointer" onclick="f_UpdateCierre(' + val.Id_Pedido + ', ' + val.Id_Detalle + ', ' + c + ', ' + val.Cod_EstadoResultadosCliente + ", '" + _campos + "'" + ')">';
														htmlContenido_2 += '</center></td>';

													// Se continua armando el html de la tabla
														htmlContenido = htmlContenido + htmlContenido_2 + htmlContenido_3 + htmlContenido_4;

													// Observación Reporte
														htmlContenido += '  <td rowspan="4" style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

														htmlContenido += '      <input type="text" id="observacion_reporte_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'observacion_reporte_" + c + "', " + "'Observacion_Reporte'" + ')" ' + ((val.Observacion_Reporte == null) ? '' : 'value="' + val.Observacion_Reporte) + '"' + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

														htmlContenido += '  </b></td>';

														if (val.Cod_EstadoResultadosCliente == 2){
															htmlContenido += '  <td rowspan="4" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;" onclick="f_PrintDocumentosCliente(1, ' + val.Id_Pedido + ', ' + val.Id_Detalle + ", '" + val.cRazonSocial + "', '" + val.Nombre_TipoMuestra + "', '" + val.Nom_Muestra + "', " + val.Peso_Muestra + ", '" + val.Nombre_DetalleEnvase + "', '" + val.FechaHora_Recepcion2 + "', '" + val.FechaHora_Entrega2 + "', '" + val.Elemento_Analisis + "', " + ((val.Ley_Au_gt == '-') ? 'null' : val.Ley_Au_gt) + ', ' + ((val.Ley_Au_gt == '-') ? 'null' : val.Ley_Au_ot) + ', ' + ((val.Ley_Ag_gt == '-') ? 'null' : val.Ley_Ag_gt) + ', ' + ((val.Ley_Ag_gt == '-') ? 'null' : val.Ley_Ag_ot) + ', ' + ((val.Porc_CU == '-') ? 'null' : val.Porc_CU) + ', ' + ((val.Porc_PB == '-') ? 'null' : val.Porc_PB) + ', ' + ((val.Porc_ZN == '-') ? 'null' : val.Porc_ZN) + ', ' + ((val.Porc_AS == '-') ? 'null' : val.Porc_AS) + ', ' + ((val.Porc_SB == '-') ? 'null' : val.Porc_SB) + ', ' + ((val.Porc_S == '-') ? 'null' : val.Porc_S) + ', ' + ((val.Porc_FE == '-') ? 'null' : val.Porc_FE) + ', ' + ((val.Porc_H2O == '-') ? 'null' : val.Porc_H2O) + ", '" + val.Fecha_Informe + "', '" + ((val.Observacion_Reporte == null) ? '' : val.Observacion_Reporte) + "', " + val.Documento_Cliente + ", '" + val.TELEFONO_CLIENTE + "', '" + val.cEmail + "', " + val.Sucursal + ", '" + val.NOMBRE_EMPRESA + "', " + val.Tipo_Muestra + ", '" + val.Des_TipoAnalisis + "', '" + val.Fecha_CierreInforme + "', '" + val.Referencia_Cliente + "', '" + val.Fecha_InicioEnsayo.substr(0, 10) + "', '" + val.Cod_Interno + "', " + val.Mostrar_Contacto + ", '" + val.X_PEDIDO + "'" + ')"><center>';
															htmlContenido += '      <img src="images/qr.png" width="30px"></img>';
															htmlContenido += '      <label style="cursor: pointer">QR</label>';
															htmlContenido += '</center></td>';

															htmlContenido += '  <td rowspan="4" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;" onclick="f_PrintDocumentosCliente(2, ' + val.Id_Pedido + ', ' + val.Id_Detalle + ", '" + val.cRazonSocial + "', '" + val.Nombre_TipoMuestra + "', '" + val.Nom_Muestra + "', " + val.Peso_Muestra + ", '" + val.Nombre_DetalleEnvase + "', '" + val.FechaHora_Recepcion2 + "', '" + val.FechaHora_Entrega2 + "', '" + val.Elemento_Analisis + "', " + ((val.Ley_Au_gt == '-') ? 'null' : val.Ley_Au_gt) + ', ' + ((val.Ley_Au_gt == '-') ? 'null' : val.Ley_Au_ot) + ', ' + ((val.Ley_Ag_gt == '-') ? 'null' : val.Ley_Ag_gt) + ', ' + ((val.Ley_Ag_gt == '-') ? 'null' : val.Ley_Ag_ot) + ', ' + ((val.Porc_CU == '-') ? 'null' : val.Porc_CU) + ', ' + ((val.Porc_PB == '-') ? 'null' : val.Porc_PB) + ', ' + ((val.Porc_ZN == '-') ? 'null' : val.Porc_ZN) + ', ' + ((val.Porc_AS == '-') ? 'null' : val.Porc_AS) + ', ' + ((val.Porc_SB == '-') ? 'null' : val.Porc_SB) + ', ' + ((val.Porc_S == '-') ? 'null' : val.Porc_S) + ', ' + ((val.Porc_FE == '-') ? 'null' : val.Porc_FE) + ', ' + ((val.Porc_H2O == '-') ? 'null' : val.Porc_H2O) + ", '" + val.Fecha_Informe + "', '" + ((val.Observacion_Reporte == null) ? '' : val.Observacion_Reporte) + "', " + val.Documento_Cliente + ", '" + val.TELEFONO_CLIENTE + "', '" + val.cEmail + "', " + val.Sucursal + ", '" + val.NOMBRE_EMPRESA + "', " + val.Tipo_Muestra + ", '" + val.Des_TipoAnalisis + "', '" + val.Fecha_CierreInforme + "', '" + val.Referencia_Cliente + "', '" + val.Fecha_InicioEnsayo.substr(0, 10) + "', '" + val.Cod_Interno + "', " + val.Mostrar_Contacto + ", '" + val.X_PEDIDO + "'" + ')"><center>';
															htmlContenido += '      <img src="images/certificacion.png" width="25px"></img>';
															htmlContenido += '      <label style="cursor: pointer">' + val.Correlativo + '</label>';
															htmlContenido += '</center></td>';
														}
														else{
															htmlContenido += '<td rowspan="4"></td>';
															htmlContenido += '<td rowspan="4"></td>';
														}
											}
											else{
												// Agregando datos Newmont
													htmlContenido += "<tr>";
													htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; font-size: 14px; color: #A63D33; text-align: center; ' + ((n == 4) ? 'background-color: #168039; color: #ffffff;' : '') + '" ' + ((n == 4) ? ' colspan="3"' : '') + '><center style="width: 100%;"><b>' + val.PesosTitulo_Newmont + '</b></center></td>';

													if (n < 4){
														htmlContenido += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';
														htmlContenido += '    <input type="text" id="peso_newmont' + n + '_' + c + '" style="text-align: right; width: 70px;" class="form-control" onblur="f_GrabarResultados_Newmont(' + val.Id_Pedido + ', ' + val.Id_Detalle + ', ' + val.Id_DetallePedido_Newmont + ", 'peso_newmont" + n + "_" + c + "', " + "'pesos'" + ', ' + c + ')" value="' + ((val.Pesos_Newmont == null) ? '' : val.Pesos_Newmont) + '"' + ((val.Cod_EstadoResultadosCliente != 0 || n == 3) ? ' disabled': '') + '>';
														htmlContenido += '  </b></td>';
													}

													if (n >= 2 && n <= 4 ){
														if (n  == 2 ){
															htmlContenido += '  <td rowspan="2" style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

															// if (n == 2){
															htmlContenido += '    <select id="malla_newmont' + n + '_' + c + '" style="width: 75px;" class="form-control" onblur="f_GrabarResultados_Newmont(' + val.Id_Pedido + ', ' + val.Id_Detalle + ', ' + val.Id_DetallePedido_Newmont + ", 'malla_newmont" + n + '_' + c + "', " + "'cod_malla'" + ', ' + c + ')"' + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															// Cargando Mallas
																<?php
																	$q_mallas = "SELECT Id,
																											num_malla
																								 FROM _max_labperu_Mallas";
																	if ($res_mallas = sqlsrv_query($enlacehost, $q_mallas)) {
																		while($row_mallas = sqlsrv_fetch_array($res_mallas)) {
																			?>

																			htmlContenido += '      <option value="<?php echo $row_mallas["Id"]; ?>" ' + ((<?php echo $row_mallas["Id"] ?> == val.CodMalla_Newmont) ? 'selected' : '') + '><?php echo $row_mallas["num_malla"]; ?></option>';

																			<?php
																		}
																	}
																?>

															htmlContenido += '    </select>';
															// }

															// if (n == 3){
															//     htmlContenido += '    <input type="text" id="malla_newmont' + n + '_' + c + '" style="text-align: right; width: 70px;" class="form-control" disabled value="140">';
															// }

															htmlContenido += '  </b></td>';
														}

														
													// }


													// if (n >= 2 && n <= 4 ){
															// Ag (g/tm)
																_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('ag') >= 0) ? 1 : 0 );

																htmlContenido += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

																if (_visible == 1){
																	// Verifica que se una resulado con datos
																		simbolo_1 = 0;
																		simbolo_2 = 0;
																		resultado = '';

																		if (val.Ley_Ag_gt_Newmont != null){
																			// Verifica si es: "-"
																				if (f_VerificaSimbolo(1, val.Ley_Ag_gt_Newmont) == 1){
																						simbolo_1 = 1;
																				}

																			// Verifica si es: "<" ó ">"
																				var total_CEROS = f_VerificaSimbolo(2, val.Ley_Ag_gt_Newmont);

																				if (total_CEROS >= 7){
																					simbolo_2 = 1;

																					resultado = f_GetResultadoSimbolo(total_CEROS, val.Ley_Ag_gt_Newmont);
																				}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																				resultado = parseFloat(val.Ley_Ag_gt_Newmont).toFixed(2);
																			}
																		}
																		else{
																			resultado = null;
																		}

																		var resultado_ag = ((simbolo_1 == 1) ? '-' : resultado);

																	htmlContenido += '        <input type="text" id="ag_1_newmont' + n + '_' + c + '" style="text-align: right; width: 70px;" class="form-control" onblur="f_GrabarResultados_Newmont(' + val.Id_Pedido + ', ' + val.Id_Detalle + ', ' + val.Id_DetallePedido_Newmont + ", 'ag_1_newmont" + n + "_" + c + "', " + "'Ley_Ag_gt'" + ', ' + c + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0 || n == 4) ? ' disabled': '') + '>';

																	_campos += 'CASE WHEN ISNULL(Ley_Ag_gt_Newmont, 0) = 0 THEN 1 ELSE 0 END + ';
																}

																htmlContenido += '    </b></td>';

															// Au (g/tm)
																_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('au') >= 0) ? 1 : 0 );

																htmlContenido += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

																if (_visible == 1){
																	// Verifica que se una resulado con datos
																		simbolo_1 = 0;
																		simbolo_2 = 0;
																		resultado = '';

																		if (val.Ley_Au_gt_Newmont != null){
																			// Verifica si es: "-"
																				if (f_VerificaSimbolo(1, val.Ley_Au_gt_Newmont) == 1){
																					simbolo_1 = 1;
																				}

																			// Verifica si es: "<" ó ">"
																				var total_CEROS = f_VerificaSimbolo(2, val.Ley_Au_gt_Newmont)

																				if (total_CEROS >= 7){
																					simbolo_2 = 1;

																					resultado = f_GetResultadoSimbolo(total_CEROS, val.Ley_Au_gt_Newmont);
																				}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																				resultado = parseFloat(val.Ley_Au_gt_Newmont).toFixed(2);
																			}
																		}
																		else{
																			resultado = null;
																		}

																		var resultado_au = ((simbolo_1 == 1) ? '-' : resultado);

																	// if (n == 4){
																	// 	htmlContenido += '      <table><tr><td><img src="images/play.png" style="width: 20px; margin-right: 5px; cursor: pointer;" onclick="f_BuscarRango(' + "'" + 'au_1_newmont' + n + '_' + c + "'" + ", 'Au'" + ')"></td><td>';
																	// }

																	htmlContenido += '        <input type="text" id="au_1_newmont' + n + '_' + c + '" style="text-align: right; width: 70px;" class="form-control" onblur="f_GrabarResultados_Newmont(' + val.Id_Pedido + ', ' + val.Id_Detalle + ', ' + val.Id_DetallePedido_Newmont + ", 'au_1_newmont" + n + "_" + c + "', " + "'Ley_Au_gt'" + ', ' + c + ')" ' + ((resultado == null) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0 || n == 4) ? ' disabled': '') + '>';

																	// if (n == 4){
																	// 	htmlContenido += '      </td></tr></table>';
																	// }

																	_campos += 'CASE WHEN ISNULL(Ley_Au_gt_Newmont, 0) = 0 THEN 1 ELSE 0 END + ';
																}

																htmlContenido += '    </b></td>';

															// Ag (oz/tc)
																_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('ag') >= 0) ? 1 : 0 );

																htmlContenido += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

																if (_visible == 1){
																	var _resultado = ((resultado_ag == null) ? '' : f_GetResultadoOnzas(resultado_ag, 'ag', c));

																	// if (n == 4){
																	// 	htmlContenido += '      <table><tr><td><img src="images/play.png" style="width: 20px; margin-right: 5px; cursor: pointer;" onclick="f_BuscarRango(' + "'" + 'ag_2_newmont' + n + '_' + c + "'" + ", 'Ag'" + ')"></td><td>';
																	// }

																	htmlContenido += '        <input type="text" id="ag_2_newmont' + n + '_' + c + '" style="text-align: right; width: 70px;" class="form-control"' + ((_resultado == '-') ? 'value="-' : 'value="' + _resultado) + '"' + ' disabled>';

																	// if (n == 4){
																	// 	htmlContenido += '      </td></tr></table>';
																	// }

																	_campos += 'CASE WHEN ISNULL(Ley_Ag_ot, 0) = 0 THEN 1 ELSE 0 END + ';
																}

																htmlContenido += '    </b></td>';

															// Au (oz/tc)
																_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('au') >= 0) ? 1 : 0 );

																htmlContenido += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

																if (_visible == 1){
																	var _resultado = ((resultado_au == null) ? '' : f_GetResultadoOnzas(resultado_au, 'au', c));

																	htmlContenido += '        <input type="text" id="au_2_newmont' + n + '_' + c + '" style="text-align: right; width: 70px;" class="form-control"' + ((_resultado == '-') ? 'value="-' : 'value="' + _resultado) + '"' + ' disabled>';

																	_campos += 'CASE WHEN ISNULL(Ley_Au_ot, 0) = 0 THEN 1 ELSE 0 END + ';
																}

																htmlContenido += '    </b></td>';
													}
											}

											htmlContenido += "</tr>";

											// c += 1;
											n += 1;

											if (n == 5){
												c += 1;
												n = 1;
											}
										});
									}
									else{
										alert("No se encontraron resultados para la búsqueda solicitada");
									}

									// Cerrando Modal
										$('#divmodal_Loading').modal('hide');

									// Cerrando la tabla
										htmlContenido += '  <tbody>';
										htmlContenido += '<table>';

										$("#tabla_analisisresultados").html(htmlContenido);

								}, "json");
					}
					else{
						$.post( "ajax/encuesta.php", { accion: "Get_AnalisisResultados_New", fecha_inicio: fecha_inicio, fecha_fin: fecha_fin, id_tipomuestra: lista_tipomuestra, id_fundidor: lista_fundidor, cliente: '', agrupados: '', arr_filtrosrangos: arr_filtrosrangos }, 
							function( data ) {
								if(data.estado == 1){
									$.each( data.registros, function( key, val ) {
											htmlContenido_2 = '';
											htmlContenido_3 = '';
											htmlContenido_4 = '';
											_campos = '';

											htmlContenido += '<tr>';

											htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right">' + c + '</td>';
											
											htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>';

											if (val.Cod_EstadoResultadosCliente == 0){
													$image = 'check_a.png';
											}

											if (val.Cod_EstadoResultadosCliente == 1){
													$image = 'check_b.png';
											}

											if (val.Cod_EstadoResultadosCliente == 2){
													$image = 'check_c.png';
											}

											htmlContenido_3 += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; color: #3F4242; background-color: ' + ((val.Sucursal == 1) ? '#D1DBBD' : '#D89196') + ' "><center><b>' + val.des_sucursal + '</b></center></td>';
											htmlContenido_3 += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.FechaHora_Recepcion + '</center></td>';
											htmlContenido_3 += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.FechaHora_Entrega + '</center></td>';
											htmlContenido_3 += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;">' + val.Observacion + '</td>';
											htmlContenido_3 += '  <td id="td_cimuestra_' + c + '" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; font-size: 14px; color: #A63D33; font-weight: bold; text-align: center;">' + val.Cod_Interno + '</td>';
											htmlContenido_3 += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; font-size: 14px;" hidden><center><b>' + val.Nombre_EstadoMuestra + '</b></center></td>';
											htmlContenido_3 += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; font-size: 14px; color: #A63D33;"><center><b>';

											htmlContenido_3 += '    <input type="date" id="fie_' + c + '" style="text-align: left; width: 150px" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'fie_" + c + "', " + "'Fecha_InicioEnsayo'" + ')" value="' + val.Fecha_InicioEnsayo.substr(0, 10) + '"' + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

											htmlContenido_3 += '  </b></td>';

											// Ag (g/tm)
													_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('ag') >= 0) ? 1 : 0 );

													htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

													if (_visible == 1){
															// Verifica que se una resulado con datos
																	simbolo_1 = 0;
																	simbolo_2 = 0;
																	resultado = '';

																	if (val.Ley_Ag_gt != null){
																			// Verifica si es: "-"
																					if (f_VerificaSimbolo(1, val.Ley_Ag_gt) == 1){
																							simbolo_1 = 1;
																					}

																			// Verifica si es: "<" ó ">"
																					var total_CEROS = f_VerificaSimbolo(2, val.Ley_Ag_gt);

																					if (total_CEROS >= 7){
																							simbolo_2 = 1;

																							resultado = f_GetResultadoSimbolo(total_CEROS, val.Ley_Ag_gt);
																					}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																					resultado = parseFloat(val.Ley_Ag_gt).toFixed(2);
																			}
																	}
																	else{
																			resultado = null;
																	}

																	var resultado_ag = ((simbolo_1 == 1) ? '-' : resultado);

															htmlContenido_4 += '        <input type="text" id="ag_1_' + c + '" style="text-align: right" class="form-control res_' + r + '" onfocus="f_GetOldValue(' + "'ag_1_" + c + "'" + ');" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'ag_1_" + c + "', " + "'Ley_Ag_gt'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															_campos += 'CASE WHEN ISNULL(Ley_Ag_gt, 0) = 0 THEN 1 ELSE 0 END + ';

															htmlContenido_4 += '<input id="item_input_' + r + '" value="' + c + '|ag_1_" type="hidden">';

															r += 1;
													}

													htmlContenido_4 += '    </b></td>';

											// Au (g/tm)
													_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('au') >= 0) ? 1 : 0 );

													htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

													if (_visible == 1){
															// Verifica que se una resulado con datos
																	simbolo_1 = 0;
																	simbolo_2 = 0;
																	resultado = '';

																	if (val.Ley_Au_gt != null){
																			// Verifica si es: "-"
																					if (f_VerificaSimbolo(1, val.Ley_Au_gt) == 1){
																							simbolo_1 = 1;
																					}

																			// Verifica si es: "<" ó ">"
																					var total_CEROS = f_VerificaSimbolo(2, val.Ley_Au_gt)

																					if (total_CEROS >= 7){
																							simbolo_2 = 1;

																							resultado = f_GetResultadoSimbolo(total_CEROS, val.Ley_Au_gt);
																					}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																					resultado = parseFloat(val.Ley_Au_gt).toFixed(2);
																			}
																	}
																	else{
																			resultado = null;
																	}

																	var resultado_au = ((simbolo_1 == 1) ? '-' : resultado);

															// htmlContenido_4 += '      <table><tr><td><img src="images/play.png" style="width: 20px; margin-right: 5px; cursor: pointer;" onclick="f_BuscarRango(' + "'" + 'au_1_' + c + "', 'Au'" + ')"></td><td>';

															htmlContenido_4 += '        <input type="text" id="au_1_' + c + '" style="text-align: right" class="form-control res_' + r + '" onfocus="f_GetOldValue(' + "'au_1_" + c + "'" + ');" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'au_1_" + c + "', " + "'Ley_Au_gt'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															_campos += 'CASE WHEN ISNULL(Ley_Au_gt, 0) = 0 THEN 1 ELSE 0 END + ';

															htmlContenido_4 += '<input id="item_input_' + r + '" value="' + c + '|au_1_" type="hidden">';

															// htmlContenido_4 += '      </td></tr></table>';

															r += 1;
													}

													htmlContenido_4 += '    </b></td>';

											// Ag (oz/tc)
													if (lista_tipomuestra == 4 || lista_tipomuestra == 5 || lista_tipomuestra == 7){
															_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('ag') >= 0) ? 1 : 0 );

															htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

															if (_visible == 1){
																	var _resultado = ((resultado_ag == null || resultado_ag == 0) ? '' : f_GetResultadoOnzas(resultado_ag, 'ag', c));

																	// htmlContenido_4 += '     <input type="text" id="ag_2_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'ag_2_" + c + "', " + "'Ley_Ag_ot'" + ')" ' + ((val.Ley_Ag_ot == null) ? '' : ((val.Ley_Ag_gt == '-') ? 'value="-' : 'value="' + parseFloat(val.Ley_Ag_ot).toFixed(2)) + '"') + ' disabled>';

																// htmlContenido_4 += '      <table><tr><td><img src="images/play.png" style="width: 20px; margin-right: 5px; cursor: pointer;" onclick="f_BuscarRango(' + "'" + 'ag_2_' + c + "', 'Ag'" + ')"></td><td>';

																	htmlContenido_4 += '        <input type="text" id="ag_2_' + c + '" style="text-align: right" class="form-control" onfocus="f_GetOldValue(' + "'ag_2_" + c + "'" + ');" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'ag_2_" + c + "', " + "'Ley_Ag_ot'" + ')" ' + ((_resultado == '-') ? 'value="-' : 'value="' + _resultado) + '"' + ' disabled>';

																// htmlContenido_4 += '      </td></tr></table>';

																	_campos += 'CASE WHEN ISNULL(Ley_Ag_ot, 0) = 0 THEN 1 ELSE 0 END + ';
															}

															htmlContenido_4 += '    </b></td>';
													}

											// Au (oz/tc)
													if (lista_tipomuestra == 4 || lista_tipomuestra == 5 || lista_tipomuestra == 7){
															_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('au') >= 0) ? 1 : 0 );

															htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

															if (_visible == 1){
																	var _resultado = ((resultado_au == null || resultado_au == 0) ? '' : f_GetResultadoOnzas(resultado_au, 'au', c));

																	htmlContenido_4 += '        <input type="text" id="au_2_' + c + '" style="text-align: right" class="form-control" onfocus="f_GetOldValue(' + "'au_2_" + c + "'" + ');" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'au_2_" + c + "', " + "'Ley_Au_ot'" + ')" ' + ((_resultado == '-') ? 'value="-' : 'value="' + _resultado) + '"' + ' disabled>';

																	_campos += 'CASE WHEN ISNULL(Ley_Au_ot, 0) = 0 THEN 1 ELSE 0 END + ';
															}

															htmlContenido_4 += '    </b></td>';
													}

											// % cu
												$analisis_x = '-' + val.Elemento_Analisis.toLowerCase() + '-';
												$analisis_x = $analisis_x.replace(/ /g, '');

													_visible = (($analisis_x.indexOf('-cu-') >= 0) ? 1 : 0 );

													htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

													if (_visible == 1){
															// Verifica que se una resulado con datos
																	if (val.Porc_CU != null){
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																			resultado = '';

																			// Verifica si es: "-"
																					if (f_VerificaSimbolo(1, val.Porc_CU) == 1){
																							simbolo_1 = 1;
																					}

																			// Verifica si es: "<" ó ">"
																					var total_CEROS = f_VerificaSimbolo(2, val.Porc_CU)

																					if (total_CEROS >= 7){
																							simbolo_2 = 1;

																							resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_CU);
																					}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																					resultado = parseFloat(val.Porc_CU).toFixed(2);
																			}
																	}
																	else{
																			resultado = null;
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																	}

																	resultado = ((simbolo_1 == 1) ? '-' : resultado);

															// htmlContenido_4 += '      <table><tr><td><img src="images/play.png" style="width: 20px; margin-right: 5px; cursor: pointer;" onclick="f_BuscarRango(' + "'" + 'cu_' + c + "', 'Cu'" + ')"></td><td>';

															htmlContenido_4 += '        <input type="text" id="cu_' + c + '" style="text-align: right" class="form-control res_' + r + '" onfocus="f_GetOldValue(' + "'cu_" + c + "'" + ');" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'cu_" + c + "', " + "'Porc_CU'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															// htmlContenido_4 += '        <input type="text" id="au_1_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'au_1_" + c + "', " + "'Ley_Au_gt'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															_campos += 'CASE WHEN ISNULL(Porc_CU, 0) = 0 THEN 1 ELSE 0 END + ';

															htmlContenido_4 += '<input id="item_input_' + r + '" value="' + c + '|cu_" type="hidden">';

															// htmlContenido_4 += '      </td></tr></table>';

															r += 1;
													}

													htmlContenido_4 += '    </b></td>';

											// % pb
													_visible = ((('-' + val.Elemento_Analisis.toLowerCase().replace(/ /g, '') + '-').indexOf('-pb-') >= 0) ? 1 : 0 );

													htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

													if (_visible == 1){
															// Verifica que se una resulado con datos
																	if (val.Porc_PB != null){
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																			resultado = '';

																			// Verifica si es: "-"
																					if (f_VerificaSimbolo(1, val.Porc_PB) == 1){
																							simbolo_1 = 1;
																					}

																			// Verifica si es: "<" ó ">"
																					var total_CEROS = f_VerificaSimbolo(2, val.Porc_PB)

																					if (total_CEROS >= 7){
																							simbolo_2 = 1;

																							resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_PB);
																					}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																					resultado = parseFloat(val.Porc_PB).toFixed(2);
																			}
																	}
																	else{
																			resultado = null;
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																	}

																	resultado = ((simbolo_1 == 1) ? '-' : resultado);

															// htmlContenido_4 += '      <table><tr><td><img src="images/play.png" style="width: 20px; margin-right: 5px; cursor: pointer;" onclick="f_BuscarRango(' + "'" + 'pb_' + c + "', 'Pb'" + ')"></td><td>';

															htmlContenido_4 += '        <input type="text" id="pb_' + c + '" style="text-align: right" class="form-control res_' + r + '" onfocus="f_GetOldValue(' + "'pb_" + c + "'" + ');" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'pb_" + c + "', " + "'Porc_PB'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															_campos += 'CASE WHEN ISNULL(Porc_PB, 0) = 0 THEN 1 ELSE 0 END + ';

															htmlContenido_4 += '<input id="item_input_' + r + '" value="' + c + '|pb_" type="hidden">';

															// htmlContenido_4 += '      </td></tr></table>';

															r += 1;
													}

													htmlContenido_4 += '    </b></td>';

											// % zn
													_visible = ((('-' + val.Elemento_Analisis.toLowerCase().replace(/ /g, '') + '-').indexOf('-zn-') >= 0) ? 1 : 0 );

													htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

													if (_visible == 1){
															// Verifica que se una resulado con datos
																	if (val.Porc_ZN != null){
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																			resultado = '';

																			// Verifica si es: "-"
																					if (f_VerificaSimbolo(1, val.Porc_ZN) == 1){
																							simbolo_1 = 1;
																					}

																			// Verifica si es: "<" ó ">"
																					var total_CEROS = f_VerificaSimbolo(2, val.Porc_ZN)

																					if (total_CEROS >= 7){
																							simbolo_2 = 1;

																							resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_ZN);
																					}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																					resultado = parseFloat(val.Porc_ZN).toFixed(2);
																			}
																	}
																	else{
																			resultado = null;
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																	}

																	resultado = ((simbolo_1 == 1) ? '-' : resultado);

															// htmlContenido_4 += '      <table><tr><td><img src="images/play.png" style="width: 20px; margin-right: 5px; cursor: pointer;" onclick="f_BuscarRango(' + "'" + 'zn_' + c + "', 'Zn'" + ')"></td><td>';

															htmlContenido_4 += '        <input type="text" id="zn_' + c + '" style="text-align: right" class="form-control res_' + r + '" onfocus="f_GetOldValue(' + "'zn_" + c + "'" + ');" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'zn_" + c + "', " + "'Porc_ZN'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															_campos += 'CASE WHEN ISNULL(Porc_ZN, 0) = 0 THEN 1 ELSE 0 END + ';

															htmlContenido_4 += '<input id="item_input_' + r + '" value="' + c + '|zn_" type="hidden">';

															// htmlContenido_4 += '      </td></tr></table>';

															r += 1;
													}

													htmlContenido_4 += '    </b></td>';

											// % as
													_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('as') >= 0) ? 1 : 0 );

													htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

													if (_visible == 1){
															// Verifica que se una resulado con datos
																	if (val.Porc_AS != null){
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																			resultado = '';

																			// Verifica si es: "-"
																					if (f_VerificaSimbolo(1, val.Porc_AS) == 1){
																							simbolo_1 = 1;
																					}

																			// Verifica si es: "<" ó ">"
																					var total_CEROS = f_VerificaSimbolo(2, val.Porc_AS)

																					if (total_CEROS >= 7){
																							simbolo_2 = 1;

																							resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_AS);
																					}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																					resultado = parseFloat(val.Porc_AS).toFixed(2);
																			}
																	}
																	else{
																			resultado = null;
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																	}

																	resultado = ((simbolo_1 == 1) ? '-' : resultado);

															// htmlContenido_4 += '      <table><tr><td><img src="images/play.png" style="width: 20px; margin-right: 5px; cursor: pointer;" onclick="f_BuscarRango(' + "'" + 'as_' + c + "', 'As'" + ')"></td><td>';

															htmlContenido_4 += '        <input type="text" id="as_' + c + '" style="text-align: right" class="form-control res_' + r + '" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'as_" + c + "', " + "'Porc_AS'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															_campos += 'CASE WHEN ISNULL(Porc_AS, 0) = 0 THEN 1 ELSE 0 END + ';

															htmlContenido_4 += '<input id="item_input_' + r + '" value="' + c + '|as_" type="hidden">';

															// htmlContenido_4 += '      </td></tr></table>';

															r += 1;
													}

													htmlContenido_4 += '    </b></td>';

											// % fe
													_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('fe') >= 0) ? 1 : 0 );

													htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

													if (_visible == 1){
															// Verifica que se una resulado con datos
																	if (val.Porc_FE != null){
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																			resultado = '';

																			// Verifica si es: "-"
																					if (f_VerificaSimbolo(1, val.Porc_FE) == 1){
																							simbolo_1 = 1;
																					}

																			// Verifica si es: "<" ó ">"
																					var total_CEROS = f_VerificaSimbolo(2, val.Porc_FE)

																					if (total_CEROS >= 7){
																							simbolo_2 = 1;

																							resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_FE);
																					}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																					resultado = parseFloat(val.Porc_FE).toFixed(2);
																			}
																	}
																	else{
																			resultado = null;
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																	}

																	resultado = ((simbolo_1 == 1) ? '-' : resultado);

															// htmlContenido_4 += '      <table><tr><td><img src="images/play.png" style="width: 20px; margin-right: 5px; cursor: pointer;" onclick="f_BuscarRango(' + "'" + 'fe_' + c + "', 'Fe'" + ')"></td><td>';

															htmlContenido_4 += '        <input type="text" id="fe_' + c + '" style="text-align: right" class="form-control res_' + r + '" onfocus="f_GetOldValue(' + "'fe_" + c + "'" + ');" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'fe_" + c + "', " + "'Porc_FE'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															_campos += 'CASE WHEN ISNULL(Porc_FE, 0) = 0 THEN 1 ELSE 0 END + ';

															htmlContenido_4 += '<input id="item_input_' + r + '" value="' + c + '|fe_" type="hidden">';

															// htmlContenido_4 += '      </td></tr></table>';

															r += 1;
													}

													htmlContenido_4 += '    </b></td>';

											// % sb
													_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('sb') >= 0) ? 1 : 0 );

													htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

													if (_visible == 1){
															// Verifica que se una resulado con datos
																	if (val.Porc_SB != null){
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																			resultado = '';

																			// Verifica si es: "-"
																					if (f_VerificaSimbolo(1, val.Porc_SB) == 1){
																							simbolo_1 = 1;
																					}

																			// Verifica si es: "<" ó ">"
																					var total_CEROS = f_VerificaSimbolo(2, val.Porc_SB)

																					if (total_CEROS >= 7){
																							simbolo_2 = 1;

																							resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_SB);
																					}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																					resultado = parseFloat(val.Porc_SB).toFixed(2);
																			}
																	}
																	else{
																			resultado = null;
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																	}

																	resultado = ((simbolo_1 == 1) ? '-' : resultado);

															// htmlContenido_4 += '      <table><tr><td><img src="images/play.png" style="width: 20px; margin-right: 5px; cursor: pointer;" onclick="f_BuscarRango(' + "'" + 'sb_' + c + "', 'Sb'" + ')"></td><td>';

															htmlContenido_4 += '        <input type="text" id="sb_' + c + '" style="text-align: right" class="form-control res_' + r + '" onfocus="f_GetOldValue(' + "'sb_" + c + "'" + ');" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'sb_" + c + "', " + "'Porc_SB'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															_campos += 'CASE WHEN ISNULL(Porc_SB, 0) = 0 THEN 1 ELSE 0 END + ';

															htmlContenido_4 += '<input id="item_input_' + r + '" value="' + c + '|sb_" type="hidden">';

															// htmlContenido_4 += '      </td></tr></table>';

															r += 1;
													}

													htmlContenido_4 += '    </b></td>';

											// % h2o
													if (lista_tipomuestra == 3 || lista_tipomuestra == 4 || lista_tipomuestra == 5 || lista_tipomuestra == 7){
															_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('h2o') >= 0) ? 1 : 0 );

															htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

															if (_visible == 1){
																	simbolo_1 = 0;
																	simbolo_2 = 0;
																	resultado = '';

																	// Verifica que se una resulado con datos
																			if (val.Porc_H2O != null){
																					simbolo_1 = 0;
																					simbolo_2 = 0;
																					resultado = '';

																					// Verifica si es: "-"
																							if (f_VerificaSimbolo(1, val.Porc_H2O) == 1){
																									simbolo_1 = 1;
																							}

																					// Verifica si es: "<" ó ">"
																							var total_CEROS = f_VerificaSimbolo(2, val.Porc_H2O)

																							if (total_CEROS >= 7){
																									simbolo_2 = 1;

																									resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_H2O);
																							}

																					if (simbolo_1 == 0 && simbolo_2 == 0){
																							resultado = parseFloat(val.Porc_H2O).toFixed(2);
																					}
																			}
																			else{
																					resultado = null;
																					simbolo_1 = 0;
																					simbolo_2 = 0;
																			}

																			resultado = ((simbolo_1 == 1) ? '-' : resultado);

																	htmlContenido_4 += '        <input type="text" id="h2o_' + c + '" style="text-align: right" class="form-control res_' + r + '" onfocus="f_GetOldValue(' + "'h2o_" + c + "'" + ');" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'h2o_" + c + "', " + "'Porc_H2O'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

																	_campos += 'CASE WHEN ISNULL(Porc_H2O, 0) = 0 THEN 1 ELSE 0 END + ';

																htmlContenido_4 += '<input id="item_input_' + r + '" value="' + c + '|h2o_" type="hidden">';

																	r += 1;
															}

															htmlContenido_4 += '    </b></td>';
													}

											// % CuSac
													_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('cusac') >= 0) ? 1 : 0 );

													htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

													if (_visible == 1){
															// Verifica que se una resulado con datos
																	if (val.Porc_CUSAC != null){
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																			resultado = '';

																			// Verifica si es: "-"
																					if (f_VerificaSimbolo(1, val.Porc_CUSAC) == 1){
																							simbolo_1 = 1;
																					}

																			// Verifica si es: "<" ó ">"
																					var total_CEROS = f_VerificaSimbolo(2, val.Porc_CUSAC)

																					if (total_CEROS >= 7){
																							simbolo_2 = 1;

																							resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_CUSAC);
																					}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																					resultado = parseFloat(val.Porc_CUSAC).toFixed(2);
																			}
																	}
																	else{
																			resultado = null;
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																	}

																	resultado = ((simbolo_1 == 1) ? '-' : resultado);

															// htmlContenido_4 += '      <table><tr><td><img src="images/play.png" style="width: 20px; margin-right: 5px; cursor: pointer;" onclick="f_BuscarRango(' + "'" + 'cusac_' + c + "', 'CuSac'" + ')"></td><td>';

															htmlContenido_4 += '        <input type="text" id="cusac_' + c + '" style="text-align: right" class="form-control res_' + r + '" onfocus="f_GetOldValue(' + "'cusac_" + c + "'" + ');" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'cusac_" + c + "', " + "'Porc_CUSAC'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															_campos += 'CASE WHEN ISNULL(Porc_CUSAC, 0) = 0 THEN 1 ELSE 0 END + ';

															htmlContenido_4 += '<input id="item_input_' + r + '" value="' + c + '|cusac_" type="hidden">';

															// htmlContenido_4 += '      </td></tr></table>';

															r += 1;
													}

													htmlContenido_4 += '    </b></td>';

											// % PbO
													_visible = ((('-' + val.Elemento_Analisis.toLowerCase().replace(/ /g, '') + '-').indexOf('-pbo-') >= 0) ? 1 : 0 );

													htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

													if (_visible == 1){
															// Verifica que se una resulado con datos
																	if (val.Porc_PBO != null){
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																			resultado = '';

																			// Verifica si es: "-"
																					if (f_VerificaSimbolo(1, val.Porc_PBO) == 1){
																							simbolo_1 = 1;
																					}

																			// Verifica si es: "<" ó ">"
																					var total_CEROS = f_VerificaSimbolo(2, val.Porc_PBO)

																					if (total_CEROS >= 7){
																							simbolo_2 = 1;

																							resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_PBO);
																					}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																					resultado = parseFloat(val.Porc_PBO).toFixed(2);
																			}
																	}
																	else{
																			resultado = null;
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																	}

																	resultado = ((simbolo_1 == 1) ? '-' : resultado);

															// htmlContenido_4 += '      <table><tr><td><img src="images/play.png" style="width: 20px; margin-right: 5px; cursor: pointer;" onclick="f_BuscarRango(' + "'" + 'pbo_' + c + "', 'PbOx'" + ')"></td><td>';

															htmlContenido_4 += '        <input type="text" id="pbo_' + c + '" style="text-align: right" class="form-control res_' + r + '" onfocus="f_GetOldValue(' + "'pbo_" + c + "'" + ');" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'pbo_" + c + "', " + "'Porc_PBO'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															_campos += 'CASE WHEN ISNULL(Porc_PBO, 0) = 0 THEN 1 ELSE 0 END + ';

															htmlContenido_4 += '<input id="item_input_' + r + '" value="' + c + '|pbo_" type="hidden">';

															// htmlContenido_4 += '      </td></tr></table>';

															r += 1;
													}

													htmlContenido_4 += '    </b></td>';

											// % ZnO
													_visible = ((('-' + val.Elemento_Analisis.toLowerCase().replace(/ /g, '') + '-').indexOf('-zno-') >= 0) ? 1 : 0 );

													htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

													if (_visible == 1){
															// Verifica que se una resulado con datos
																	if (val.Porc_ZNO != null){
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																			resultado = '';

																			// Verifica si es: "-"
																					if (f_VerificaSimbolo(1, val.Porc_ZNO) == 1){
																							simbolo_1 = 1;
																					}

																			// Verifica si es: "<" ó ">"
																					var total_CEROS = f_VerificaSimbolo(2, val.Porc_ZNO)

																					if (total_CEROS >= 7){
																							simbolo_2 = 1;

																							resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_ZNO);
																					}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																					resultado = parseFloat(val.Porc_ZNO).toFixed(2);
																			}
																	}
																	else{
																			resultado = null;
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																	}

																	resultado = ((simbolo_1 == 1) ? '-' : resultado);

															// htmlContenido_4 += '      <table><tr><td><img src="images/play.png" style="width: 20px; margin-right: 5px; cursor: pointer;" onclick="f_BuscarRango(' + "'" + 'zno_' + c + "', 'ZnOx'" + ')"></td><td>';

															htmlContenido_4 += '        <input type="text" id="zno_' + c + '" style="text-align: right" class="form-control res_' + r + '" onfocus="f_GetOldValue(' + "'zno_" + c + "'" + ');" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'zno_" + c + "', " + "'Porc_ZNO'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															_campos += 'CASE WHEN ISNULL(Porc_ZNO, 0) = 0 THEN 1 ELSE 0 END + ';

															htmlContenido_4 += '<input id="item_input_' + r + '" value="' + c + '|zno_" type="hidden">';

															// htmlContenido_4 += '      </td></tr></table>';

															r += 1;
													}

													htmlContenido_4 += '    </b></td>';

											// % mn
													_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('mn') >= 0) ? 1 : 0 );

													htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

													if (_visible == 1){
															// Verifica que se una resulado con datos
																	if (val.Porc_MN != null){
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																			resultado = '';

																			// Verifica si es: "-"
																					if (f_VerificaSimbolo(1, val.Porc_MN) == 1){
																							simbolo_1 = 1;
																					}

																			// Verifica si es: "<" ó ">"
																					var total_CEROS = f_VerificaSimbolo(2, val.Porc_MN)

																					if (total_CEROS >= 7){
																							simbolo_2 = 1;

																							resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_MN);
																					}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																					resultado = parseFloat(val.Porc_MN).toFixed(2);
																			}
																	}
																	else{
																			resultado = null;
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																	}

																	resultado = ((simbolo_1 == 1) ? '-' : resultado);

															htmlContenido_4 += '        <input type="text" id="mn_' + c + '" style="text-align: right" class="form-control res_' + r + '" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'mn_" + c + "', " + "'Porc_MN'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															_campos += 'CASE WHEN ISNULL(Porc_MN, 0) = 0 THEN 1 ELSE 0 END + ';

															htmlContenido_4 += '<input id="item_input_' + r + '" value="' + c + '|mn_" type="hidden">';

															r += 1;
													}

													htmlContenido_4 += '    </b></td>';

											// % mo
													_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('mo') >= 0) ? 1 : 0 );

													htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

													if (_visible == 1){
															// Verifica que se una resulado con datos
																	if (val.Porc_MO != null){
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																			resultado = '';

																			// Verifica si es: "-"
																					if (f_VerificaSimbolo(1, val.Porc_MO) == 1){
																							simbolo_1 = 1;
																					}

																			// Verifica si es: "<" ó ">"
																					var total_CEROS = f_VerificaSimbolo(2, val.Porc_MO)

																					if (total_CEROS >= 7){
																							simbolo_2 = 1;

																							resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_MO);
																					}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																					resultado = parseFloat(val.Porc_MO).toFixed(2);
																			}
																	}
																	else{
																			resultado = null;
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																	}

																	resultado = ((simbolo_1 == 1) ? '-' : resultado);

															htmlContenido_4 += '        <input type="text" id="mo_' + c + '" style="text-align: right" class="form-control res_' + r + '" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'mo_" + c + "', " + "'Porc_MO'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															_campos += 'CASE WHEN ISNULL(Porc_MO, 0) = 0 THEN 1 ELSE 0 END + ';

															htmlContenido_4 += '<input id="item_input_' + r + '" value="' + c + '|mo_" type="hidden">';

															r += 1;
													}

													htmlContenido_4 += '    </b></td>';

											// % Ins
													_visible = ((val.Elemento_Analisis.toLowerCase().indexOf('ins') >= 0) ? 1 : 0 );

													htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

													if (_visible == 1){
															// Verifica que se una resulado con datos
																	if (val.Porc_INS != null){
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																			resultado = '';

																			// Verifica si es: "-"
																					if (f_VerificaSimbolo(1, val.Porc_INS) == 1){
																							simbolo_1 = 1;
																					}

																			// Verifica si es: "<" ó ">"
																					var total_CEROS = f_VerificaSimbolo(2, val.Porc_INS)

																					if (total_CEROS >= 7){
																							simbolo_2 = 1;

																							resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_INS);
																					}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																					resultado = parseFloat(val.Porc_INS).toFixed(2);
																			}
																	}
																	else{
																			resultado = null;
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																	}

																	resultado = ((simbolo_1 == 1) ? '-' : resultado);

															htmlContenido_4 += '        <input type="text" id="ins_' + c + '" style="text-align: right" class="form-control res_' + r + '" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'ins_" + c + "', " + "'Porc_INS'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															_campos += 'CASE WHEN ISNULL(Porc_INS, 0) = 0 THEN 1 ELSE 0 END + ';

															htmlContenido_4 += '<input id="item_input_' + r + '" value="' + c + '|ins_" type="hidden">';

															r += 1;
													}

													htmlContenido_4 += '    </b></td>';

											// % s
													_visible = 0;

													var s = 0;
													var _arr_visible = val.Elemento_Analisis.replace(/ /g, '').split('-');													

													while (s < _arr_visible.length){
														if ('|' + _arr_visible[s].toLowerCase() + '|' == '|s|'){
															_visible = 1;
														}

														s ++;
													}

													htmlContenido_4 += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

													if (_visible == 1){
															// Verifica que se una resulado con datos
																	if (val.Porc_S != null){
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																			resultado = '';

																			// Verifica si es: "-"
																					if (f_VerificaSimbolo(1, val.Porc_S) == 1){
																							simbolo_1 = 1;
																					}

																			// Verifica si es: "<" ó ">"
																					var total_CEROS = f_VerificaSimbolo(2, val.Porc_S)

																					if (total_CEROS >= 7){
																							simbolo_2 = 1;

																							resultado = f_GetResultadoSimbolo(total_CEROS, val.Porc_S);
																					}

																			if (simbolo_1 == 0 && simbolo_2 == 0){
																					resultado = parseFloat(val.Porc_S).toFixed(2);
																			}
																	}
																	else{
																			resultado = null;
																			simbolo_1 = 0;
																			simbolo_2 = 0;
																	}

																	resultado = ((simbolo_1 == 1) ? '-' : resultado);

															htmlContenido_4 += '        <input type="text" id="s_' + c + '" style="text-align: right" class="form-control res_' + r + '" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 's_" + c + "', " + "'Porc_S'" + ')" ' + ((resultado == null || resultado == 0) ? '' : ((simbolo_1 == 1) ? 'value="-"' : ((simbolo_2 == 1) ? 'value="' + resultado : 'value="' + resultado) + '"')) + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

															_campos += 'CASE WHEN ISNULL(Porc_S, 0) = 0 THEN 1 ELSE 0 END + ';

															htmlContenido_4 += '<input id="item_input_' + r + '" value="' + c + '|s_" type="hidden">';

															r += 1;
													}

													htmlContenido_4 += '    </b></td>';

											// Arma el botón de cierre de resultados
													htmlContenido_2 += '        <img id="img_' + c + '" src="images/' + $image + '" width="50px" style="cursor: pointer" onclick="f_UpdateCierre(' + val.Id_Pedido + ', ' + val.Id_Detalle + ', ' + c + ', ' + val.Cod_EstadoResultadosCliente + ", '" + _campos + "'" + ')">';
													htmlContenido_2 += '</center></td>';

											// Se continua armando el html de la tabla
													htmlContenido = htmlContenido + htmlContenido_2 + htmlContenido_3 + htmlContenido_4;

											// Observación Reporte
													htmlContenido += '  <td style="vertical-align: middle; border: solid; border-width: 1px; border-color: #D9D9D9;"><b>';

													htmlContenido += '      <input type="text" id="observacion_reporte_' + c + '" style="text-align: right" class="form-control" onblur="f_GrabarResultados(' + val.Id_Pedido + ', ' + val.Id_Detalle + ", 'observacion_reporte_" + c + "', " + "'Observacion_Reporte'" + ')" ' + ((val.Observacion_Reporte == null) ? '' : 'value="' + val.Observacion_Reporte) + '"' + ((val.Cod_EstadoResultadosCliente != 0) ? ' disabled': '') + '>';

													htmlContenido += '  </b></td>';

											if (val.Cod_EstadoResultadosCliente == 2){
													htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;" onclick="f_PrintDocumentosCliente(1, ' + val.Id_Pedido + ', ' + val.Id_Detalle + ", '" + val.cRazonSocial + "', '" + val.Nombre_TipoMuestra + "', '" + val.Nom_Muestra + "', " + val.Peso_Muestra + ", '" + val.Nombre_DetalleEnvase + "', '" + val.FechaHora_Recepcion2 + "', '" + val.FechaHora_Entrega2 + "', '" + val.Elemento_Analisis + "', " + ((val.Ley_Au_gt == '-') ? 'null' : val.Ley_Au_gt) + ', ' + ((val.Ley_Au_gt == '-') ? 'null' : val.Ley_Au_ot) + ', ' + ((val.Ley_Ag_gt == '-') ? 'null' : val.Ley_Ag_gt) + ', ' + ((val.Ley_Ag_gt == '-') ? 'null' : val.Ley_Ag_ot) + ', ' + ((val.Porc_CU == '-') ? 'null' : val.Porc_CU) + ', ' + ((val.Porc_PB == '-') ? 'null' : val.Porc_PB) + ', ' + ((val.Porc_ZN == '-') ? 'null' : val.Porc_ZN) + ', ' + ((val.Porc_AS == '-') ? 'null' : val.Porc_AS) + ', ' + ((val.Porc_SB == '-') ? 'null' : val.Porc_SB) + ', ' + ((val.Porc_S == '-') ? 'null' : val.Porc_S) + ', ' + ((val.Porc_FE == '-') ? 'null' : val.Porc_FE) + ', ' + ((val.Porc_H2O == '-') ? 'null' : val.Porc_H2O) + ", '" + val.Fecha_Informe + "', '" + ((val.Observacion_Reporte == null) ? '' : val.Observacion_Reporte) + "', " + val.Documento_Cliente + ", '" + val.TELEFONO_CLIENTE + "', '" + val.cEmail + "', " + val.Sucursal + ", '" + val.NOMBRE_EMPRESA + "', " + val.Tipo_Muestra + ", '" + val.Des_TipoAnalisis + "', '" + val.Fecha_CierreInforme + "', '" + val.Referencia_Cliente + "', '" + val.Fecha_InicioEnsayo.substr(0, 10) + "', '" + val.Cod_Interno + "', " + val.Mostrar_Contacto + ", '" + val.X_PEDIDO + "'" + ')"><center>';
													htmlContenido += '      <img src="images/qr.png" width="30px"></img>';
													htmlContenido += '      <label style="cursor: pointer">QR</label>';
													htmlContenido += '</center></td>';

													htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;" onclick="f_PrintDocumentosCliente(2, ' + val.Id_Pedido + ', ' + val.Id_Detalle + ", '" + val.cRazonSocial + "', '" + val.Nombre_TipoMuestra + "', '" + val.Nom_Muestra + "', " + val.Peso_Muestra + ", '" + val.Nombre_DetalleEnvase + "', '" + val.FechaHora_Recepcion2 + "', '" + val.FechaHora_Entrega2 + "', '" + val.Elemento_Analisis + "', " + ((val.Ley_Au_gt == '-') ? 'null' : val.Ley_Au_gt) + ', ' + ((val.Ley_Au_gt == '-') ? 'null' : val.Ley_Au_ot) + ', ' + ((val.Ley_Ag_gt == '-') ? 'null' : val.Ley_Ag_gt) + ', ' + ((val.Ley_Ag_gt == '-') ? 'null' : val.Ley_Ag_ot) + ', ' + ((val.Porc_CU == '-') ? 'null' : val.Porc_CU) + ', ' + ((val.Porc_PB == '-') ? 'null' : val.Porc_PB) + ', ' + ((val.Porc_ZN == '-') ? 'null' : val.Porc_ZN) + ', ' + ((val.Porc_AS == '-') ? 'null' : val.Porc_AS) + ', ' + ((val.Porc_SB == '-') ? 'null' : val.Porc_SB) + ', ' + ((val.Porc_S == '-') ? 'null' : val.Porc_S) + ', ' + ((val.Porc_FE == '-') ? 'null' : val.Porc_FE) + ', ' + ((val.Porc_H2O == '-') ? 'null' : val.Porc_H2O) + ", '" + val.Fecha_Informe + "', '" + ((val.Observacion_Reporte == null) ? '' : val.Observacion_Reporte) + "', " + val.Documento_Cliente + ", '" + val.TELEFONO_CLIENTE + "', '" + val.cEmail + "', " + val.Sucursal + ", '" + val.NOMBRE_EMPRESA + "', " + val.Tipo_Muestra + ", '" + val.Des_TipoAnalisis + "', '" + val.Fecha_CierreInforme + "', '" + val.Referencia_Cliente + "', '" + val.Fecha_InicioEnsayo.substr(0, 10) + "', '" + val.Cod_Interno + "', " + val.Mostrar_Contacto + ", '" + val.X_PEDIDO + "'" + ')"><center>';
													htmlContenido += '      <img src="images/certificacion.png" width="25px"></img>';
													htmlContenido += '      <label style="cursor: pointer">' + val.Correlativo + '</label>';
													htmlContenido += '</center></td>';
											}
											else{
													htmlContenido += '<td></td>';
													htmlContenido += '<td></td>';
											}

											htmlContenido += "</tr>";

											c += 1;
									});

								}
								else{
									r = 0;

									alert("No se encontraron resultados para la búsqueda solicitada");
								}

								// Cerrando Modal
									$('#divmodal_Loading').modal('hide');

								// Cerrando la tabla
									htmlContenido += '  <tbody>';
									htmlContenido += '<table>';

									$("#tabla_analisisresultados").html(htmlContenido);

								// Obtiene el total de resultados disponibles
									$("#total_resultados").val(r);

							}, "json");
					}
			};

			function f_PrintDocumentosCliente(_TipoDocumento, _Id_Pedido, _Id_DetallePedido, _Cliente, _TipoMuestra, _NomMuestra, _PesoMuestra, _Detalle_Envase, _Fecha_Recepcion, _Fecha_Entrega, _Elemento_Analisis, _Ley_Au_gt, _Ley_Au_ot, _Ley_Ag_gt, _Ley_Ag_ot, _Porc_CU, _Porc_PB, _Porc_ZN, _Porc_AS, _Porc_SB, _Porc_S, _Porc_FE, _Porc_H2O, _Fecha_Informe, _Obs_Reporte, _Documento_Cliente, _Telefono_Cliente, _Cliente_Email, _Sucursal, _Nombre_Empresa, _Cod_TipoMuestra, _Tipo_Ensayo, _Fecha_CierreInforme, _Referencia_Cliente, _Fecha_InicioEnsayo, _Codigo_Interno, _Mostrar_Contacto, _X_Pedido){

				// var url = 'print_informeensayos_new.php?x=' + _X_Pedido;
					var url = 'print_informeensayos_new.php?x=' + _Id_DetallePedido + '.' + _X_Pedido;

				// Generando la ruta de la imagen QR
					// var ruta = String(window.location);
					// ruta = ruta.substr(0, ruta.indexOf('usuario/'));

					var ruta = 'https://labperuminerals.intelli-apps.com/panel/';
					ruta = ruta + 'usuario/' + url.replace(/[ ]/g, '*');

				if (_TipoDocumento == 2){
					// Agrega el QR en el informe en el PDF
						$.post( "ajax/encuesta.php", { accion: "Generate_QR", url: ruta, Id_Pedido: _Id_Pedido, Id_DetallePedido: _Id_DetallePedido },
							function( data ) {
								if(data.estado == 1){
									// window.open(url, '_blank');
									window.open(ruta, '_blank');
								}
								else{
									alert("Ocurrió un error al momento de generar el código QR");

									return;
								}

							}, "json");
				}
				else{
					$("#qr_id_pedido").val(_Id_Pedido);
					$("#qr_id_detallepedido").val(_Id_DetallePedido);

					var modal = $("#divmodal_qr");

					$("#qr_muestra").val(_NomMuestra.trim());
					$("#qr_analisis").val(_Elemento_Analisis.trim());

					// Generando Código QR
						$.post( "ajax/encuesta.php", { accion: "Generate_QR", url: ruta, Id_Pedido: _Id_Pedido, Id_DetallePedido: _Id_DetallePedido },
							function( data ) {
									if(data.estado == 1){
										var qr_name = 'tmp_qr_' + _Id_Pedido + _Id_DetallePedido + '.png';

										document.getElementById('img_qr').src='tmp_files/' + qr_name;
									}

							}, "json");

					modal.modal({backdrop: 'static', keyboard: false});
				}
			};

			function f_DownloadImg(){
				var QR_Id_Pedido = $("#qr_id_pedido").val();
				var QR_Id_DetallePedido = $("#qr_id_detallepedido").val();
				var ruta = 'http://labperuminerals.intelli-apps.com/panel/usuario/tmp_files/tmp_qr_' + QR_Id_Pedido + QR_Id_DetallePedido + '.png';

				var a = document.createElement('a');

				a.download = 'QR - ' + $("#qr_muestra").val();
				a.target = '_blank';
				a.href= ruta;

				a.click();	    		
			};

			function f_VerificaSimbolo(_Tipo, _Resultado){
				var resultado = 0;

				// Verifica si es: "-"
					if (_Tipo == 1){
						if (_Resultado == 99999.99999){
							resultado = 1;
						}
					}

				// Verifica si es: "<" ó ">"
					if (_Tipo == 2){
						var num_ceros = 0;

						// Comprobando el total de nueves
							num_ceros = _Resultado.toString().substr(_Resultado.toString().length - 10);

							if (num_ceros != '9999999999'){
								num_ceros = _Resultado.toString().substr(_Resultado.toString().length - 9);

								if (num_ceros != '999999999'){
									num_ceros = _Resultado.toString().substr(_Resultado.toString().length - 8);

									if (num_ceros != '99999999'){
										num_ceros = _Resultado.toString().substr(_Resultado.toString().length - 7);

										if (num_ceros != '9999999'){
											num_ceros = 0;
										}
									}
								}
							}

						resultado = num_ceros.length;
					}

				return resultado;
			};

			function f_GetResultadoSimbolo(_Num_Ceros, _Resultado){
				var simbolo = '';
				var is_entero = 0;
				var num_left = '';
				var decimal = '';
				var num_entero = '';
				var c = 0;
				var num_ceros = '';

				// Determinando el símbolo
					if (_Num_Ceros >= 7 && _Num_Ceros <= 8){
						simbolo = '<';
						is_entero = ((_Num_Ceros == 7) ? 1 : 0);
					}

					if (_Num_Ceros >= 9 && _Num_Ceros <= 10){
						simbolo = '>';
						is_entero = ((_Num_Ceros == 9) ? 1 : 0);
					}

				// Obteniendo resultados
					num_left = _Resultado.toString().substr(0, _Resultado.toString().indexOf('.'));

					if (is_entero == 1){
						_Resultado = simbolo + ' ' + (parseInt(num_left) + 1);
					}
					else{
						// Obtiene la parte decimal
							decimal = _Resultado.toString().substr(_Resultado.toString().indexOf('.') + 1);

						// Obteniene el número entero de los decimales
							var menos_un_cero = 0;

							num_entero = decimal.substr(0, decimal.length - _Num_Ceros);
							menos_un_cero = ((parseInt(num_entero) == 0) ? 1 : 0);

							num_entero = parseInt(num_entero) + 1;

						// 2. Obteniendo la cantidad de CEROS de la parte decimal
							while (c < (decimal.substr(0, decimal.length - _Num_Ceros).length - menos_un_cero)){
								if (decimal.substr(c, 1) == 0){
									num_ceros += '0';
								}

								c += 1;
							}

						_Resultado = simbolo + ' ' + num_left + '.' + num_ceros + num_entero;
					}

				return _Resultado;
			};

			// Actualiza a Onzas si es Au y/o Ag
			function f_GetResultadoOnzas(_Resultado, _Elemento, _Id){
				var resultado = _Resultado;
				var elemento = _Elemento;
				var id = _Id;

				var _resultado = '';
				var factor = 34.285;

				if (elemento == 'au' || elemento == 'ag'){
					if (resultado.trim() == '-'){
						_resultado = '-';
					}
					else{
						var simbolo = resultado.trim().substr(0, 1);

						if (simbolo == '<' || simbolo == '>'){
							if (simbolo == '<'){
								_resultado = '-';
							}
							else{
								_resultado = resultado.trim().substr(1);

								_resultado = '> ' + parseFloat(_resultado / factor).toFixed(2);
							}
						}
						else{
							if (resultado.trim().length == 0){
								_resultado = '';
							}
							else{
								_resultado = parseFloat(resultado / factor).toFixed(2);
							}
						}
					}

					return _resultado;
				}
			};

			// Obtiene Resultados Newmont
			function f_GetResultadoNewmont(_Pos){
				// Obtiene Parámetros de Pesos
					var peso_total = $("#peso_newmont1_" + _Pos).val();  
					var peso_positivo = $("#peso_newmont2_" + _Pos).val();
					var peso_negativo = (peso_total - peso_positivo);

					var ag_positivo = 0;
					var ag_negativo = 0;
					var au_positivo = 0;
					var au_negativo = 0;

					var resultado = 0;
					var factor = 34.285;

				// Verificando si alguno de los pesos no tiene valor
					if (peso_total.length == 0 || peso_total == 0){
						$("#ag_1_newmont4_" + _Pos).val('');
					}

					if (peso_positivo.length == 0 || peso_positivo == 0){
						$("#ag_1_newmont4_" + _Pos).val('');
					}

					if (peso_negativo.length == 0 || peso_negativo == 0){
						$("#ag_1_newmont4_" + _Pos).val('');
					}

				// Verifica las Leyes existentes
					if ( $("#ag_1_newmont2_" + _Pos).length > 0 ) {
						ag_positivo = $("#ag_1_newmont2_" + _Pos).val();
						ag_negativo = $("#ag_1_newmont3_" + _Pos).val();

						// Verificando si alguna de las leyes no tiene valor
							if (ag_positivo.length == 0 || ag_positivo == 0){
								$("#ag_1_newmont4_" + _Pos).val('');
							}

							if (ag_negativo.length == 0 || ag_negativo == 0){
								$("#ag_1_newmont4_" + _Pos).val('');
							}

						// Calcula Newmont
							resultado = ((peso_positivo * ag_positivo) + (peso_negativo * ag_negativo)) / peso_total;
							$("#ag_1_newmont4_" + _Pos).val(parseFloat(resultado).toFixed(0));
							$("#ag_2_newmont4_" + _Pos).val(parseFloat(resultado / factor).toFixed(2));
					}

					if ( $("#au_1_newmont2_" + _Pos).length > 0 ) {
						au_positivo = $("#au_1_newmont2_" + _Pos).val();
						au_negativo = $("#au_1_newmont3_" + _Pos).val();

						// Verificando si alguna de las leyes no tiene valor
							if (au_positivo.length == 0 || au_positivo == 0){
								$("#au_1_newmont4_" + _Pos).val('');
							}

							if (au_negativo.length == 0 || au_negativo == 0){
								$("#au_1_newmont4_" + _Pos).val('');
							}

						// Calcula Newmont
							resultado = ((peso_positivo * au_positivo) + (peso_negativo * au_negativo)) / peso_total;
							$("#au_1_newmont4_" + _Pos).val(parseFloat(resultado).toFixed(2));
							$("#au_2_newmont4_" + _Pos).val(parseFloat(resultado / factor).toFixed(2));
					}
			};

			// Pre cierre
			function f_Cierre(_tipo_cierre){
				// Obteniendo filtros
					var fecha_inicio = $("#fecha_inicio").val();
					var fecha_fin = $("#fecha_fin").val();
					var lista_tipomuestra = $("#lista_tipomuestra").val();
					lista_tipomuestra = ((lista_tipomuestra.length == '') ? 5 : lista_tipomuestra);

					var lista_fundidor = $("#lista_fundidor").val();

				// Validando ingreso de filtros
					if (fecha_inicio == null){
						alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

						return;
					}
					if (fecha_inicio.length == 0){
						alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

						return;
					}

					if (fecha_fin == null){
						alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

						return;
					}
					if (fecha_fin.length == 0){
						alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

						return;
					}

					if (fecha_fin < fecha_inicio){
						alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

						return;
					}

				// Conformidad
					var mensaje = '';

					if (_tipo_cierre == 1){
						mensaje = "Está a punto de realizar el Pre Cierre para todas las muestras que al menos tienen una Ley.\n\n¿Está seguro de continuar?"
					}
					else{
						mensaje = "Está a punto de realizar el Cierre para todas las muestras que tenga todas sus leyes publicadas.\n\n¿Está seguro de continuar?";
					}

					if (!confirm(mensaje)){
						return;
					}

				// Loading Modal
					var modal_loading = $("#divmodal_Loading");
					modal_loading.modal({backdrop: 'static', keyboard: false});

				// Ejecuta Pre Cierre
					$.post( "ajax/encuesta.php", { accion: "Exec_CierreResultados", tipo_cierre: _tipo_cierre, fecha_inicio: fecha_inicio, fecha_fin: fecha_fin, id_tipomuestra: lista_tipomuestra, id_fundidor: lista_fundidor }, 
						function( data ) {
							if(data.estado == 1){
								f_LoadResultados();

								alert("El Cierre fue realizado satisfactoriamente.");
							}
							else{
								alert("No se encontraron resultados para la búsqueda solicitada");
							}

							// Cerrando Modal
								$('#divmodal_Loading').modal('hide');

						}, "json");
			};

			function f_ValorRepetido(_resultado, _objeto){
				var total_resultados = $("#total_resultados").val();
				var r = 1;
				var _mensaje = '';

				if (_resultado == '-'){
					return _mensaje;
				}

				while (r < total_resultados){
					if ($(".res_" + r).val().trim().length > 0){
						if (_objeto != $("#item_input_" + r).val().split('|')[1] +
										 $("#item_input_" + r).val().split('|')[0]){
							if (_resultado == $(".res_" + r).val().trim()){
								_mensaje = "Este resultado ya existe:\n\n- Item: " +
										$("#item_input_" + r).val().split('|')[0] +
										"\n" + "- Muestra: " + $("#td_cimuestra_" + $("#item_input_" + r).val().split('|')[0]).html() +
										"\n" + "- Elemento: " + $("#item_input_" + r).val().split('|')[1].substr(0, $("#item_input_" + r).val().split('|')[1].length - 1);

								break;
							}
						}
					}

					r += 1;
				}

				return _mensaje;
			}

			function f_BuscarRango(_id_obj, _cod_elemento){
				// Obteniendo el valor del campo buscado
					var valor = $("#" + _id_obj).val();

				// Valida valor
					if (valor.trim().length == 0){
						alert("No tiene valor para buscar");
					}

				// Setea el valor a buscar
					$("#" + _cod_elemento + "_valor").val(valor);

				// Ir a la búsqueda
					var elemento = document.getElementById('btn_buscar');
					elemento.scrollIntoView({ behavior: 'smooth' });
					window.scrollTo({left: elemento.offsetLeft, behavior: 'smooth'});

				// Obtiene el rango
					$.post( "ajax/encuesta.php", { accion: "get_conformidadresultados_buscarrangos", cod_elemento: _cod_elemento.toLowerCase(), valor: valor }, 
						function( data ) {
							if(data.estado == 1){
								if (data.rango.trim().length == 0){
									$("#" + _cod_elemento + "_intervalo").val('');

									alert("No se tiene un rango configurado para este valor.");
								}
								else{
									$("#" + _cod_elemento + "_intervalo").val(data.rango);
								}
							}

						}, "json");
			}

			function f_LimpiarFiltros(){
				$("#tbl_elementos th").each(function(index) {
					nom_columna = $(this).text().trim();

					// Seteando cabeceras
						nom_columna = nom_columna.replace(/\(oz\/tc\)/g, '').replace(/\(g\/t\)/g, '').replace(/\(%\)/g, '').trim();

					// Limpia los objetos
						$("#" + nom_columna + '_valor').val('');
						$("#" + nom_columna + '_intervalo').val('');
				});

				f_LoadResultados();
			}
		</script>

		<!-- Funciones para Grabar -->
		<script type="text/javascript">
			function f_GrabarResultados(_Id_Pedido, _Id_DetallePedido, _Objeto, _Campo){
				var resultado = $("#" + _Objeto).val();

				// Validar valor repetido
					if ($("#lista_tipomuestra").val() != 0){
						var _mensaje = f_ValorRepetido(resultado, _Objeto);

						if (_mensaje.length > 0){
							if (!confirm(_mensaje + "\n\n¿Desea confirmar este valor?")){
								$("#" + _Objeto).val('-');

								resultado = '-';
							}
						}
					}

				// Validar diferencia
					var _dif = 10000;

					if (_Objeto.includes('ag_')){
						_dif = 34;
					}
					if (_Objeto.includes('au_')){
						_dif = 1;
					}
					if (_Objeto.includes('cu_')){
						_dif = 0.5;
					}
					if (_Objeto.includes('h2o_')){
						_dif = 1;
					}
					if (_Objeto.includes('pb_')){
						_dif = 1;
					}
					if (_Objeto.includes('zn_')){
						_dif = 1;
					}
					if (_Objeto.includes('sb_')){
						_dif = 0.2;
					}
					if (_Objeto.includes('fe_')){
						_dif = 2;
					}
					if (_Objeto.includes('cusac_')){
						_dif = 0.2;
					}

				if (resultado_prev.toString().trim().length > 0){
					if (Math.abs(resultado_prev - resultado) > _dif){
						if(!confirm("Ha ingresado un valor que supera el valor de: " + _dif + ".\n\n¿Desea continuar?")){
							$("#" + _Objeto).val(resultado_prev);

							return;
						}
					}
				}

				$.post( "ajax/encuesta.php", { accion: "Grabar_AnalisisResultados", Id_Pedido: _Id_Pedido, Id_DetallePedido: _Id_DetallePedido, Resultado: ((resultado.length > 0) ? resultado : 'NULL'), Campo: _Campo }, 
					function( data ) {
						if(data.estado == 0){
							alert("Ocurrió un error al momento de grabar los datos. Verifica el valor ingresado.");

							return;
						}

						if(data.estado == 1){
							// alert("El resultado fue grabado satisfactoriamente");

							// return;

							if (_Campo == 'Ley_Ag_gt'){
								if (resultado.trim().length == 0){
									$("#Ley_Ag_ot").val('');
								}
							}

							if (_Campo == 'Ley_Au_gt'){
								if (resultado.trim().length == 0){
									$("#Ley_Au_ot").val('');
								}
							}
						}

						if(data.estado == 2){
							alert("El valor ingresado no es numérico. Por favor, verificar");

							return;
						}

					}, "json");

				// Actualiza a Onzas si es Au y/o Ag
					var elemento = _Objeto.substr(0, 2);
					var id = _Objeto.substr(5, 2);

					_resultado = f_GetResultadoOnzas(resultado, elemento, id);

					$("#" + elemento + '_2_' + id).val(_resultado);
			};

			function f_GrabarResultados_Newmont(_Id_Pedido, _Id_DetallePedido, _Id_DetallePedido_Newmont, _Objeto, _Campo, _Pos){
					var resultado = $("#" + _Objeto).val();

				$.post( "ajax/encuesta.php", { accion: "Grabar_AnalisisResultados_Newmont", Id_Pedido: _Id_Pedido, Id_DetallePedido: _Id_DetallePedido, Id_DetallePedido_Newmont: _Id_DetallePedido_Newmont, Resultado: ((resultado.length > 0) ? resultado : 'NULL'), Campo: _Campo }, 
					function( data ) {
						if(data.estado == 0){
							alert("Ocurrió un error al momento de grabar los datos. Verifica el valor ingresado.");

							return;
						}

						if(data.estado == 1){
							// Obtiene los Pesos
								if (_Campo == 'pesos'){
									peso_total = $("#peso_newmont1_" + _Pos ).val();
									peso_1 = $("#peso_newmont2_" + _Pos ).val();
									peso_2 = $("#peso_newmont3_" + _Pos ).val();

									if (peso_total.length > 0 && peso_1.length > 0){
										peso_2 = peso_total - peso_1;

										$("#peso_newmont3_" + _Pos ).val(peso_2);
									}
									else{
										$("#peso_newmont3_" + _Pos ).val('');
									}
								}
						}

						if(data.estado == 2){
							alert("El valor ingresado no es numérico. Por favor, verificar");

							return;
						}

					}, "json");

				// Actualiza a Onzas si es Au y/o Ag
					if (_Campo.substr(0, 3) == 'Ley'){
						var elemento = _Objeto.substr(0, 2);
						var id = _Objeto.substr(_Objeto.length - 1, 1);
						var pos_n = _Objeto.substr(12, 1);

						_resultado = f_GetResultadoOnzas(resultado, elemento, id);

						$("#" + elemento + '_2_newmont' + pos_n + '_' + id).val(_resultado);
					}

				// Obtiene Ley Newmont
					_resultado_newmont = f_GetResultadoNewmont(_Pos);
			};

			function f_UpdateCierre(_Id_Pedido, _Id_DetallePedido, _Orden, _Estado_Cierre, _Campos_Evaluados){
				// Loading Modal
					var modal_loading = $("#divmodal_Loading");
					modal_loading.modal({backdrop: 'static', keyboard: false});

				campos_evaluados = _Campos_Evaluados;

				var cod_tipomuestra = $("#lista_tipomuestra").val();

				// Validar que se haya igresado al menos un valor
					$.post( "ajax/encuesta.php", { accion: "Valida_IngresoResultados", Id_Pedido: _Id_Pedido, Id_DetallePedido: _Id_DetallePedido, id_tipomuestra: cod_tipomuestra }, 
						function( data ) {
							if(data.estado == 1){
								$.each( data.registros, function( key, val ) {
									if (val.TOTAL == 0 && _Estado_Cierre == 0){
										alert("No puede realizar el Pre Cierre de la muestra seleccionada hasta que por lo menos ingrese una ley.\n\nPor favor, verificar.");

										// Cerrando Modal
											$('#divmodal_Loading').modal('hide');
									}
									else{
										if (_Estado_Cierre == 0){
											$("#img_" + _Orden).attr("src","images/check_b.png");

											$.post( "ajax/encuesta.php", { accion: "Grabar_CierreClientes", Id_Pedido: _Id_Pedido, Id_DetallePedido: _Id_DetallePedido, Estado_Cierre: 1 }, 
												function( data ) {
													if(data.estado == 1){
														// alert("El Pre Cierre fue realizado satisfactoriamente");

														f_LoadResultados();
													}

												}, "json");
										}
										else{
											var modal = $("#divmodal_Cierre");

											if (_Estado_Cierre == 1){
												$("#cierre_mensaje").html("<b>Al aceptar este mensaje está cerrando completamente el Análisis y el Cliente podrá descargar el Informe de Ensayos\n\n¿Está seguro de continuar?</b>");

												$("#btn_cerrar").prop("disabled", false);
											}

											if (_Estado_Cierre == 2){
												$("#cierre_mensaje").html("<b>Esta muestra se encuentra cerrada</b>");

												$("#btn_cerrar").prop("disabled", true);
											}

											$("#id_pedido").val(_Id_Pedido);
											$("#id_detallepedido").val(_Id_DetallePedido);
											$("#estado_cierre").val(_Estado_Cierre);
											$("#cierre_imageorden").val(_Orden);

											modal.modal({backdrop: 'static', keyboard: false});

											// Cerrando Modal
												$('#divmodal_Loading').modal('hide');
										}
									}
								});
							}
							else{
								alert("No se encontraron resultados para la búsqueda solicitada");

								// Cerrando Modal
									$('#divmodal_Loading').modal('hide');
							}

						}, "json");
			};

			function f_ModalRevertirCierre(){
				var id_pedido = $("#id_pedido").val();
				var id_detallepedido = $("#id_detallepedido").val();
				var estado_cierre = $("#estado_cierre").val();
				var cierre_imageorden = $("#cierre_imageorden").val();

				// if (!confirm("¿Está seguro de revertir el Cierre de la muestra seleccionada?")){
				// 	return;
				// }

				// Loading Modal
					var modal_loading = $("#divmodal_Loading");
					modal_loading.modal({backdrop: 'static', keyboard: false});

				$.post( "ajax/encuesta.php", { accion: "Grabar_CierreClientes", Id_Pedido: id_pedido, Id_DetallePedido: id_detallepedido, Estado_Cierre: ((estado_cierre == 1) ?  0 : 1) }, 
					function( data ) {
						if(data.estado == 1){
							// alert("El Cierre ha sido revertido satisfactoriamente");

							$("#img_" + cierre_imageorden).attr("src","images/" + ((estado_cierre == 1) ?  'check_a.png' : 'check_b.png'));

							f_LoadResultados();

							f_cerrarModal(1);
						}
						else{
							// Cerrando Modal
								$('#divmodal_Loading').modal('hide');
						}

					}, "json");
			};

			function f_ModalUpdateCierre(){
				var id_pedido = $("#id_pedido").val();
				var id_detallepedido = $("#id_detallepedido").val();
				var estado_cierre = $("#estado_cierre").val();
				var cierre_imageorden = $("#cierre_imageorden").val();

				// if (!confirm("¿Está seguro de realizar el Cierre de la muestra seleccionada?")){
				// 	return;
				// }

				// Loading Modal
					var modal_loading = $("#divmodal_Loading");
					modal_loading.modal({backdrop: 'static', keyboard: false});

				// Obtiene el Tipo de Muestra
					var cod_tipomuestra = $("#lista_tipomuestra").val();

				// Valida que se hayan ingresado resultados para todos los elementos
					$.post( "ajax/encuesta.php", { accion: "Valida_IngresoResultados_All", Id_Pedido: id_pedido, Id_DetallePedido: id_detallepedido, campos: campos_evaluados, id_tipomuestra: cod_tipomuestra }, 
						function( data ) {
							if(data.estado == 1){
								$.each( data.registros, function( key, val ) {
									if (val.TOTAL > 0){
										alert("Hay elementos con resultados pendientes.\n\nPor favor, verificar.")

										// Cerrando Modal
											$('#divmodal_Loading').modal('hide');

										return;
									}
									else{
										$.post( "ajax/encuesta.php", { accion: "Grabar_CierreClientes", Id_Pedido: id_pedido, Id_DetallePedido: id_detallepedido, Estado_Cierre: 2 }, 
											function( data ) {
												if(data.estado == 1){
													// alert("El Cierre ha sido realizado satisfactoriamente.\n\nA partir de este momento el Cliente podrá descargar el Informe de Ensayos.");

													$("#img_" + cierre_imageorden).attr("src","images/check_c.png");

													f_LoadResultados();

													f_cerrarModal(1);
												}
												else{
													// Cerrando Modal
														$('#divmodal_Loading').modal('hide');
												}

											}, "json");
									}
								});
							}

						}, "json");
			};

			function f_GetOldValue(_id_obj){
				resultado_prev = $("#" + _id_obj).val().trim();
			}
		</script>

		<!-- Otras Funciones -->
		<script type="text/javascript">
			function f_cerrarModal(pantalla_modal){
				if (pantalla_modal == 1){
					$('#divmodal_Cierre').modal('hide');
				}

				if (pantalla_modal == 2){
					$('#divmodal_AddNewCliente').modal('hide');
				}
			};

			function f_ImagenCierre(_Estado_Cierre){
				var image_orden = $("#cierre_imageorden").val();
			};
		</script>

	</body>
</html>

<?php
	cerrarSesion($enlace);
?>