<?php
	
	session_start();

	include('../../php/conn.php');

	if(!isset($_SESSION["id"])){
		header('Location: index.php');
	}

	mysqli_query($enlace, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");

?>

<!DOCTYPE html>
<html lang="es">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
			<!-- Meta, title, CSS, favicons, etc. -->
			<meta charset="utf-8">
			<meta http-equiv="X-UA-Compatible" content="IE=edge">
			<meta name="viewport" content="width=device-width, initial-scale=1">

			<title>Resumen de Análisis de Muestras</title>

			<!-- Bootstrap -->
			<link href="../vendors/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
			<!-- Font Awesome -->
			<link href="../vendors/font-awesome/css/font-awesome.min.css" rel="stylesheet">
			<!-- NProgress -->
			<link href="../vendors/nprogress/nprogress.css" rel="stylesheet">
			<!-- iCheck -->
			<link href="../vendors/iCheck/skins/flat/green.css" rel="stylesheet">
			<!-- bootstrap-progressbar -->
			<link href="../vendors/bootstrap-progressbar/css/bootstrap-progressbar-3.3.4.min.css" rel="stylesheet">
			<!-- JQVMap -->
			<link href="../vendors/jqvmap/dist/jqvmap.min.css" rel="stylesheet"/>
			<!-- bootstrap-daterangepicker -->
			<link href="../vendors/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
			<!-- Ion.RangeSlider -->
			<link href="../vendors/normalize-css/normalize.css" rel="stylesheet">
			<link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.css" rel="stylesheet">
			<link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.skinFlat.css" rel="stylesheet">
			<!-- Bootstrap Colorpicker -->
			<link href="../vendors/mjolnic-bootstrap-colorpicker/dist/css/bootstrap-colorpicker.min.css" rel="stylesheet">
			<link href="../vendors/cropper/dist/cropper.min.css" rel="stylesheet">
			<!-- Datatables -->
			<link href="../vendors/datatables.net-bs/css/dataTables.bootstrap.min.css" rel="stylesheet">
			<link href="../vendors/datatables.net-buttons-bs/css/buttons.bootstrap.min.css" rel="stylesheet">
			<link href="../vendors/datatables.net-fixedheader-bs/css/fixedHeader.bootstrap.min.css" rel="stylesheet">
			<link href="../vendors/datatables.net-responsive-bs/css/responsive.bootstrap.min.css" rel="stylesheet">
			<link href="../vendors/datatables.net-scroller-bs/css/scroller.bootstrap.min.css" rel="stylesheet">

			<!-- bootstrap-datetimepicker -->
			<link href="../vendors/bootstrap-datetimepicker/build/css/bootstrap-datetimepicker.css" rel="stylesheet">

			<!-- Switchery -->
			<link href="../vendors/switchery/dist/switchery.min.css" rel="stylesheet">

			<!-- Custom Theme Style -->
			<link href="../build/css/custom.min.css" rel="stylesheet">

			<script type="text/javascript">
				let Rack_TotalRows = 0;
						let chkRack_Selected = '';
			</script>

				<style type="text/css">
						th {
								position: sticky;
								top: 0px;
								background-color: #12537E;
						}
				</style>
	</head>

	<body class="nav-md" onload="f_LoadResultados()" style="zoom: 80%">
		<div class="container body">
					<div class="main_container">
						<?php include('partes/sidebar.php'); ?>

						<!-- page content -->
						<div class="right_col" role="main">
							<div class="">
								<div class="row">
									<div class="col-md-12 col-sm-12 col-xs-12">
										<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
											<div class="x_title">
												<h2>
													Resumen de Análisis de Muestras
												</h2>
												<div class="clearfix">
												</div>
											</div>

											<div class="x_content" style="margin-bottom: -10px;">
												<!-- Filtros -->
												<div class="col-md-6 col-sm-6 col-xs-12">
													<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
												<div class="x_title">
													<h2>
														<font style="font-size: 14px"><b>Búsqueda por rango de fechas</b></font>
													</h2>
													<div class="clearfix">
													</div>
												</div>
												<div class="x_content" style="margin-bottom: -10px;">
													<div class="form-group col-md-6 col-sm-6 col-xs-12">
																												<label class="control-label col-md-5 col-sm-5 col-xs-12" style="margin-top: 6px; text-align: right;">
																														Desde
																												</label>
																												<div class="col-md-7 col-sm-7 col-xs-12">
																														<?php
																															date_default_timezone_set("America/Lima"); 
																											$time = date('Y-m-d');

																																echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_inicio" value="'.$time.'"/>';
																														?>
																												</div>
																										</div>

																										<div class="form-group col-md-6 col-sm-6 col-xs-12">
																												<label class="control-label col-md-3 col-sm-3 col-xs-12" style="margin-top: 6px; text-align: right;">
																														Hasta
																												</label>
																												<div class="col-md-7 col-sm-7 col-xs-12">
																														<?php
																																echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_fin" value="'.$time.'"/>';
																														?>
																												</div>
																										</div>
												</div>
											</div>
										</div>

										<div class="col-md-3 col-sm-3 col-xs-12">
											<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
												<div class="x_title">
													<h2>
														<font style="font-size: 14px"><b>Búsqueda por Fundidor</b></font>
													</h2>
													<div class="clearfix">
													</div>
												</div>
												<div class="x_content" style="margin-bottom: -10px;">
													<div class="form-group col-md-12 col-sm-12 col-xs-12">
																								<select id="lista_fundidor" class="form-control" style="text-align: left;">
															<option value="">Elija una opción...</option>

														</select>
																					</div>
												</div>
											</div>
										</div>

																				<div class="col-md-3 col-sm-3 col-xs-12">
																						<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
																								<div class="x_title">
																										<h2>
																												<font style="font-size: 14px"><b>Búsqueda por Muestra</b></font>
																										</h2>
																										<div class="clearfix">
																										</div>
																								</div>
																								<div class="x_content" style="margin-bottom: -10px;">
																										<div class="form-group col-md-12 col-sm-12 col-xs-12">
																												<div class="col-md-5 col-sm-5 col-xs-12">
																														<select id="lista_CI" class="form-control col-md-3 col-xs-12" style="text-align: left;">

																														</select>
																												</div>

																												<div class="col-md-7 col-sm-7 col-xs-7">
																														<input type="text" id="filtro_muestra" placeholder="Formato: 0001-001" class="form-control col-md-9 col-xs-9" style="text-align: center;">
																												</div>
																										</div>
																								</div>
																						</div>
																				</div>
											</div>
										</div>
									</div>
								</div>

						<div class="row">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<button class="btn btn-success" type="button" onclick="f_LoadResultados()" style="width: 100%; background-color: #26B99A">
																	 <b>Ejecutar Búsqueda</b>
															</button>
							</div>
						</div>

								<div class="row" style="margin-top: 10px">
									<div id="div_listaracks" class="col-md-3 col-sm-3 col-xs-12">
										<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
											<div class="x_title">
																				<div id="div_TituloListaRacks" class="col-md-10 col-sm-10 col-xs-10">
																						<h2>
																								Lista de Racks
																						</h2>
																				</div>

																				<div id="div_ShowListaRacks" class="col-md-2 col-sm-2 col-xs-2" style="text-align: right; background-color: #FF0005; color: #ffffff; border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px; vertical-align: middle; text-align: center; height: 27px; cursor: pointer;" onclick="f_HideListaRacks(1);">
																						<i class="fa fa-chevron-left" style="margin-top: 6px;">
																								
																						</i>
																				</div>

																				<div id="div_HideListaRacks" class="col-md-2 col-sm-2 col-xs-2" style="text-align: right; background-color: #FF0005; color: #ffffff; border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px; vertical-align: middle; text-align: center; height: 27px; cursor: pointer; margin-left: -13px; display: none;" onclick="f_HideListaRacks(0);">
																						<i class="fa fa-chevron-right" style="margin-top: 6px; margin-left: -4px;">
																								
																						</i>
																				</div>

												<div class="clearfix">
												</div>
											</div>

											<div id="div_ContentListaRacks" class="x_content">
																				<div>
																						<input type="checkbox" id="chk_Deseleccionar" onchange="f_DeseleccionarTodo();"> <label for="chk_Deseleccionar"> Deseleccionar todo</label>
																				</div>
																				<div class="table-box" style="height: 850px; width: 100%; overflow: scroll;">
																						<table class="table table-striped jambo_table bulk_action">
																								<thead>
																										<tr>
																												<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; border-top-left-radius: 15px; width: 20px;"><center>
																														Sel.
																												</center></th>
																												<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 50px;"><center>
																														Item
																												</center></th>
																												<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; border-top-right-radius: 15px;"><center>
																														Rack
																												</center></th>
																										</tr>
																								</thead>

																								<tbody id="tbl_Racks" style="overflow: scroll">
																										
																								</tbody>
																						</table>
																				</div>
											</div>
										</div>
									</div>

														<div id="div_detalleanalisis" class="col-md-9 col-sm-9 col-xs-12">
																<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
																		<!-- <div class="x_title">
																				<div class="col-md-2 col-sm-2 col-xs-2">
																						<div class="col-md-6 col-sm-6 col-xs-6" style="border: solid; border-width: 1px; border-color: #127899; border-radius: 7px; background-color: #67B8DE; color: #ffffff; text-align: center; z-index: 1; height: 40px;">
																								<label style="margin-left: -10px;">
																										Total Muestras
																								</label>
																						</div>
																						<div class="col-md-6 col-sm-6 col-xs-6" style="border-radius: 7px; background-color: #AFD7DB; height: 40px; text-align: center;">
																								<label id="lblRack_totalmuestras" style="margin-top: 10px; color: #4C5661">10</label>
																						</div>
																				</div>
																				<div class="col-md-2 col-sm-3 col-xs-3">
																						<div class="col-md-6 col-sm-6 col-xs-6" style="border: solid; border-width: 1px; border-color: #127899; border-radius: 7px; background-color: #67B8DE; color: #ffffff;text-align: center; z-index: 1;">
																								Usuario Creación
																						</div>
																						<div class="col-md-6 col-sm-6 col-xs-6" style="border-radius: 7px; background-color: #AFD7DB; height: 40px; text-align: center;">
																								<label id="lblRack_usuario" style="margin-top: 10px; color: #4C5661">apaz</label>
																						</div>
																				</div>
																				<div class="col-md-2 col-sm-3 col-xs-3">
																						<div class="col-md-5 col-sm-5 col-xs-5" style="border: solid; border-width: 1px;border-color: #127899; border-radius: 7px; background-color: #67B8DE; color: #ffffff;text-align: center; z-index: 1;">
																								Fecha Creación
																						</div>
																						<div class="col-md-7 col-sm-7 col-xs-7" style="border-radius: 7px; background-color: #AFD7DB; height: 40px; text-align: center;">
																								<label id="lblRack_fechahora" style="margin-top: 2px; color: #4C5661">2021-04-23 16:00:44</label>
																						</div>
																				</div>
																				<div class="col-md-2 col-sm-2 col-xs-2">
																						<div class="col-md-6 col-sm-6 col-xs-6" style="border: solid; border-width: 1px; border-color: #127899; border-radius: 7px; background-color: #67B8DE; color: #ffffff; text-align: center; z-index: 1; height: 40px;">
																								<label style="margin-left: -10px;">
																										Horno
																								</label>
																						</div>
																						<div class="col-md-6 col-sm-6 col-xs-6" style="border-radius: 7px; background-color: #AFD7DB; height: 40px;">
																								<label id="lblRack_horno" style="margin-top: 10px; color: #4C5661">
																										
																								</label>
																						</div>
																				</div>
																				<div class="col-md-4 col-sm-4 col-xs-4">
																						<div class="col-md-3 col-sm-3 col-xs-3" style="border: solid; border-width: 1px;border-color: #127899; border-radius: 7px; background-color: #67B8DE; color: #ffffff;text-align: center; z-index: 1; height: 40px;">
																								<label style="margin-top: 8px; margin-left: -10px;">
																										Observación
																								</label>
																						</div>
																						<div class="col-md-9 col-sm-9 col-xs-9" style="border-radius: 7px; background-color: #AFD7DB; height: 40px; text-align: center;">
																								<label id="lblRack_observacion" style="margin-top: 2px; color: #4C5661" title="ANALISIS AG">ANALISIS AG</label>
																						</div>
																				</div>

																				<div class="clearfix">
																				</div>
																		</div> -->

																		<div class="x_content">
																				<div class="col-md-12 col-sm-12 col-xs-12" style="font-size: 12px;">
																						<img src="images/dot_muestra.png" style="width: 15px; margin-top: -5px;" />
																						<label style="color: #76777B;">
																								Muestra
																						</label>
																						<img src="images/dot_blancof.png" style="width: 15px; margin-left: 10px; margin-top: -5px;"/>
																						<label style="color: #76777B;">
																								Blanco Fundente
																						</label>
																						<img src="images/dot_blancop.png" style="width: 15px; margin-left: 10px; margin-top: -5px;"/>
																						<label style="color: #76777B;">
																								Blanco Pulverizado
																						</label>
																						<img src="images/dot_mr.png" style="width: 15px; margin-left: 10px; margin-top: -5px;"/>
																						<label style="color: #76777B;">
																								Material de Referencia
																						</label>
																				</div>

																				<div class="table-box" style="height: 905px; width: 100%; overflow: scroll;">
																						<table class="table table-striped jambo_table bulk_action">
																								<thead>
																										<tr>
																												<th rowspan="2" style="background-color: #404040; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; border-top-left-radius: 15px; width: 150px;"><center>
																														Rack
																												</center></th>
																												<th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 60px;"><center>
																														N° Orden en Fundición
																												</center></th>
																												<th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
																														N° Crisol
																												</center></th>
																												<th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 150px;"><center>
																														Muestra
																												</center></th>
																												<th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
																														Análisis
																												</center></th>
																												<th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
																														Dosifi.
																												</center></th>
																												
																												<th colspan="4" style="background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
																														Pesos
																												</center></th>
																												<th colspan="4" style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
																														Leyes
																												</center></th>
																												<th colspan="2" style="background-color: #D97373; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; border-top-right-radius: 15px;"><center>
																														Conf.
																												</center></th>
																										</tr>

																										<tr>
																												<th style=" background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
																														Peso Muestra
																												</center></th>
																												<th style=" background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
																														Peso Régulo
																												</center></th>
																												<th style="background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
																														Peso Doré
																												</center></th>
																												<th style="background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
																														Peso Oro
																												</center></th>

																												<th id="th_oro_Ag1" style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
																														Ley Ag (g/tm)
																												</center></th>
																												<th id="th_oro_Au1" style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
																														Ley Au (g/tm)
																												</center></th>
																												<th id="th_oro_Ag2" style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
																														Ley Ag (oz/tc)
																												</center></th>
																												<th id="th_oro_Au2" style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
																														Ley Au (oz/tc)
																												</center></th>

																												
																												<th id="th_oro_Au2" style="background-color: #D97373; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
																														Ag
																												</center></th>
																												<th id="th_oro_Ag2" style="background-color: #D97373; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
																														Au
																												</center></th>
																										</tr>
																								</thead>

																								<tbody id="tbl_DetalleAnalisis" style="overflow: scroll">
																										
																								</tbody>
																						</table>
																				</div>
																		</div>
																</div>
														</div>
								</div>
							</div>
						</div>
					</div>
				</div>

				<!-- Ventanas Modal -->
				<div id="divmodal_Loading" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false" style="margin-top: 300px;">
						<div class="modal-dialog" style="height: 200px; opacity: 0.5;"><center>
								<img src="images/loading.gif" width="200px" style="border: solid; border-width: 1px; border-color: #D9D9D9;  border-radius: 15px;"></img>
						</center></div>
				</div>

				<div id="divmodal_DetallesRack" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false">
						<div class="modal-dialog" style="width: 25%; margin-top: 15%; margin-left: 33%">
								<!-- Modal content-->
								<div class="modal-content" style="border: solid; border-width: 1px; border-color: #E6E9ED; border-radius: 7px;">
										<div class="modal-header" style="background-color: #282828; color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; border-radius: 7px;">
												<button type="button" class="close" data-dismiss="modal" style="color: #ffffff;">
														×
												</button>

												<h4 class="modal-title" id="titulomodal_ClaveClientes"><b>
														<div class="col-md-5 col-sm-5 col-xs-5" style="width: 180px;">
																Información del Rack: 
														</div>
														<div class="col-md-6 col-sm-6 col-xs-6" style="margin-left: -15px;">
																<label id="lbl_TituloRack" style="color: #FAF566"> XXXXXX</label>
														</div>
												</b></h4>
										</div>

										<div class="modal-body">
												<table class="table table-striped jambo_table bulk_action">
														<thead>
																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661; width: 150px;">
																				Total Muestras
																		</th>
																		<th id="th_InfoRackTotalMuestras" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																</tr>
																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661; width: 150px;">
																				Usuario Creación
																		</th>
																		<th id="th_InfoRackUsuarioCreacion" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																</tr>
																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661; width: 150px;">
																				Fecha Hora Creación
																		</th>
																		<th id="th_InfoRackFechaCreacion" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																</tr>
																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661; width: 150px;">
																				Usuario Cierre
																		</th>
																		<th id="th_InfoRackUsuarioCierre" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																</tr>
																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661; width: 150px;">
																				Fecha Hora Cierre
																		</th>
																		<th id="th_InfoRackFechaCierre" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																</tr>
																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661; width: 150px;">
																				Horno
																		</th>
																		<th id="th_InfoRackHorno" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																</tr>
																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661; width: 150px;">
																				Observación
																		</th>
																		<th id="th_InfoRackObservacion" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																</tr>
														</thead>
												</table>
										</div>

										<div class="modal-footer" style="padding-bottom: 5px; padding-top: 10px; text-align: center; background-color: #565759; border: solid; border-width: 1px; border-color: #E6E9ED; border-radius: 7px;">
												<div class="col-md-12 col-sm-12 col-xs-12">
														<button class="btn btn-dark" type="button" onclick="f_cerrarModal(2)" style="background-color: #337ab7">
																Cerrar
														</button>
												</div>
										</div>
								</div>
						</div>
				</div>

				<div id="divmodal_DetallesMuestra" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false">
						<div class="modal-dialog" style="width: 35%; margin-top: 5%; margin-left: 1%">
								<!-- Modal content-->
								<div class="modal-content" style="border: solid; border-width: 1px; border-color: #E6E9ED; border-radius: 7px;">
										<div class="modal-header" style="background-color: #282828; color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; border-radius: 7px;">
												<button type="button" class="close" data-dismiss="modal" style="color: #ffffff;">
														×
												</button>

												<h4 class="modal-title" id="titulomodal_ClaveClientes"><b>
														<div class="col-md-5 col-sm-5 col-xs-5" style="width: 200px;">
																Información de Muestra: 
														</div>
														<div class="col-md-7 col-sm-7 col-xs-7" style="margin-left: -15px;">
																<label id="lbl_TituloMuestra" style="color: #FAF566"> XXXXXX</label>
																<label style="font-size: 13px; color: #9FA3A6;"> ( N° Orden en Rack: </label>
																<label id="lbl_OrdenRack" style="font-size: 15px; color: #FAF566"><b> 0</b>b></label> )
														</div>
												</b></h4>
										</div>

										<div class="modal-body">
												<table class="table table-striped jambo_table bulk_action">
														<thead>
																<tr>
																		<th colspan="3" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; border-top-left-radius: 15px; border-top-right-radius: 15px;">
																				Información de Pesos
																		</th>
																</tr>

																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; width: 100px;">
																				Tipo
																		</th>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center;">
																				Fecha y Hora
																		</th>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center;">
																				Usuario
																		</th>
																</tr>
																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661;">
																				Muestra
																		</th>
																		<th id="th_InfoMuestraFecha" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																		<th id="th_InfoMuestraUsuario" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																</tr>
																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661;">
																				Régulo
																		</th>
																		<th id="th_InfoReguloFecha" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																		<th id="th_InfoReguloUsuario" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																</tr>
																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661;">
																				Doré
																		</th>
																		<th id="th_InfoDoreFecha" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																		<th id="th_InfoDoreUsuario" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																</tr>
																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661;">
																				Oro
																		</th>
																		<th id="th_InfoOroFecha" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																		<th id="th_InfoOroUsuario" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																</tr>
														</thead>
												</table>

												<!-- <table class="table table-striped jambo_table bulk_action">
														<thead>
																<tr>
																		<th colspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; border-top-left-radius: 15px; border-top-right-radius: 15px; background-color: #D97373;">
																				Observaciones
																		</th>
																</tr>

																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; background-color: #D97373; width: 100px;">
																				Tipo
																		</th>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; background-color: #D97373;">
																				Descripción
																		</th>
																</tr>
																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661;">
																				Muestra
																		</th>
																		<th id="th_ObservacionMuestra" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																</tr>
																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661;">
																				Régulo
																		</th>
																		<th id="th_ObservacionRegulo" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																</tr>
																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661;">
																				Doré
																		</th>
																		<th id="th_ObservacionDore" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																</tr>
																<tr>
																		<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661;">
																				Oro
																		</th>
																		<th id="th_ObservacionOro" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
																				
																		</th>
																</tr>
														</thead>
												</table> -->
										</div>

										<div class="modal-footer" style="padding-bottom: 5px; padding-top: 10px; text-align: center; background-color: #565759; border: solid; border-width: 1px; border-color: #E6E9ED; border-radius: 7px;">
												<div class="col-md-12 col-sm-12 col-xs-12">
														<button class="btn btn-dark" type="button" onclick="f_cerrarModal(1)" style="background-color: #337ab7">
																Cerrar
														</button>
												</div>
										</div>
								</div>
						</div>
				</div>

				<!-- jQuery -->
			<script src="../vendors/jquery/dist/jquery.min.js"></script>
			<!-- Bootstrap -->
			<script src="../vendors/bootstrap/dist/js/bootstrap.min.js"></script>
			<!-- FastClick -->
			<script src="../vendors/fastclick/lib/fastclick.js"></script>
			<!-- NProgress -->
			<script src="../vendors/nprogress/nprogress.js"></script>
			<!-- Ion.RangeSlider -->
			<script src="../vendors/ion.rangeSlider/js/ion.rangeSlider.min.js"></script>
			<!-- Bootstrap Colorpicker -->
			<script src="../vendors/mjolnic-bootstrap-colorpicker/dist/js/bootstrap-colorpicker.min.js"></script>
			<!-- Custom Theme Scripts -->
			<script src="../build/js/custom.min.js"></script>

			<!-- bootstrap-daterangepicker -->
			<script src="../vendors/moment/min/moment.min.js"></script>
			<script src="../vendors/bootstrap-daterangepicker/daterangepicker.js"></script><!-- Datatables -->
			<script src="../vendors/datatables.net/js/jquery.dataTables.min.js"></script>
			<script src="../vendors/datatables.net-bs/js/dataTables.bootstrap.min.js"></script>
			<script src="../vendors/datatables.net-buttons/js/dataTables.buttons.min.js"></script>
			<script src="../vendors/datatables.net-buttons-bs/js/buttons.bootstrap.min.js"></script>
			<script src="../vendors/datatables.net-buttons/js/buttons.flash.min.js"></script>
			<script src="../vendors/datatables.net-buttons/js/buttons.html5.min.js"></script>
			<script src="../vendors/datatables.net-buttons/js/buttons.print.min.js"></script>
			<script src="../vendors/datatables.net-fixedheader/js/dataTables.fixedHeader.min.js"></script>
			<script src="../vendors/datatables.net-keytable/js/dataTables.keyTable.min.js"></script>
			<script src="../vendors/datatables.net-responsive/js/dataTables.responsive.min.js"></script>
			<script src="../vendors/datatables.net-responsive-bs/js/responsive.bootstrap.js"></script>
			<script src="../vendors/datatables.net-scroller/js/dataTables.scroller.min.js"></script>
			<script src="../vendors/jszip/dist/jszip.min.js"></script>
			<script src="../vendors/pdfmake/build/pdfmake.min.js"></script>
			<script src="../vendors/pdfmake/build/vfs_fonts.js"></script>

			<!-- Funciones Principales -->
			<script type="text/javascript">
				function f_LoadResultados(){
					var htmlContenido = '';
								var i = 1;
								chkRack_Selected = '';

					// Obteniendo filtros
						var fecha_inicio = $("#fecha_inicio").val();
						var fecha_fin = $("#fecha_fin").val();
						var lista_fundidor = $("#lista_fundidor").val();
										var filtro_muestra = $("#filtro_muestra").val();

								// Obteniendo el filtro por Muestra
										var lista_CI = $("#lista_CI").val();
										var filtro_muestra = $("#filtro_muestra").val().trim();
										
										// Formatea la búsqueda por C.I.
												if (filtro_muestra.length > 0){
														filtro_muestra = lista_CI + '-' + filtro_muestra;
												}
												else{
														filtro_muestra = '';
												}

					// Validando ingreso de filtros
						if (fecha_inicio == null){
												alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

												return;
										}
										if (fecha_inicio.length == 0){
												alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

												return;
										}

										if (fecha_fin == null){
												alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

												return;
										}
										if (fecha_fin.length == 0){
												alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

												return;
										}

										if (fecha_fin < fecha_inicio){
											alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

												return;
										}

								// Carga combo de fundidores
										f_CargaFundidores();

								// Carga lista de Prefijos de Códigos Internos
										if (filtro_muestra.trim() == 0){
												f_CargaPrefijosCI();
										}

								// Limpia Objetos
										f_Limpiar();

								// Loading Modal
										var modal_loading = $("#divmodal_Loading");
										modal_loading.modal({backdrop: 'static', keyboard: false});

							$("#tbl_Racks").html(htmlContenido);

								$.get( "../lims_api/index.php", { accion: "get_ListaRacks", Fecha_Inicio: fecha_inicio, Fecha_Fin: fecha_fin, fundidor: lista_fundidor, ci_muestra: filtro_muestra },
										function( data ) {
												if(data.estado == 1){
														$.each( data.registros, function( key, val ) {
																htmlContenido += '<tr id="trRack_selected_' + i + '" style="background-color: #FFF587;">';

																htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right; cursor: pointer; text-align: center;">';
																htmlContenido += '      <input type="checkbox" id="chkRack_Selected_' + i + '" onchange="f_RackSelected(' + i + ", " + val.Id + ')" checked>';
																htmlContenido += '  </td>';

																htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right; cursor: pointer;">' + i + '</td>';

																htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer;" onclick="f_OpenDetalleRack(' + "'" + val.nom_rack + "', " + val.NUM_MUESTRAS + ", '" + val.usuario_rack + "', '" + val.fecha_rack + "', '" + val.usuario_cierrerack + "', '" + val.fecha_cierrerack + "', '" + val.cod_horno + "', '" + val.des_rack.replace(/"/g, '%') + "'" + ');">';
																htmlContenido += '      <u>' + val.nom_rack + '</u>';
																htmlContenido += '  </td>';

																htmlContenido += "</tr>";

																i += 1;

																// Guarda el Id de los Racks seleccionados
																		chkRack_Selected += val.Id + ',';
														});

														// Carga la información de los Análisis
																if (chkRack_Selected.length > 0){
																		chkRack_Selected = chkRack_Selected.substring(0, chkRack_Selected.length - 1);

																		f_CargaInformacionRack(chkRack_Selected);
																}

														Rack_TotalRows = i;
												}
												else{
														alert("No se encontraron resultados para la búsqueda solicitada");
												}

												$("#tbl_Racks").html(htmlContenido);

												// Cerrando Modal
														$('#divmodal_Loading').modal('hide');

										}, "json");
				};

						function f_CargaFundidores(){
								var fecha_inicio = $("#fecha_inicio").val();
								var fecha_fin = $("#fecha_fin").val();
								var old_fundidor = '';
								var selected ='';

								// Si está seleccionado no lo recarga
										if ($("#lista_fundidor").val() != null){
												if ($("#lista_fundidor").val().length > 0){
														old_fundidor = $("#lista_fundidor").val();
												}
										}

								var htmlContenido = "";

								$("#lista_fundidor").html(htmlContenido);

								$.get( "../lims_api/index.php", { accion: "get_ListaRacks_Fundidores", Fecha_Inicio: fecha_inicio, Fecha_Fin: fecha_fin },
										function( data ) {
												if(data.estado == 1){
														htmlContenido = '<option value="">Elija una opción...</option>';

														$.each( data.registros, function( key, val ) {
																selected ='';

																if (old_fundidor == val.usuario_rack){
																		selected = 'selected';
																}

																htmlContenido += '<option ' + selected + ' value="'+val.usuario_rack+'">'+val.USUARIO+'</option>';
														});
												}
												// else{
												//     alert("No se encontraron resultados para la búsqueda solicitada");
												// }

												$("#lista_fundidor").html(htmlContenido);

										}, "json");
						};

						function f_CargaPrefijosCI(){
								var fecha_inicio = $("#fecha_inicio").val();
								var fecha_fin = $("#fecha_fin").val();

								var htmlContenido = "";

								$("#lista_CI").html(htmlContenido);

								$.get( "../lims_api/index.php", { accion: "get_PrefijosCI", Fecha_Inicio: fecha_inicio, Fecha_Fin: fecha_fin },
										function( data ) {
												if(data.estado == 1){
														$.each( data.registros, function( key, val ) {
																selected = '';

																if (val.MES == <?php echo $g_mes; ?> && val.ANHO == <?php echo $g_anho; ?>){
																		selected = 'selected';
																}

																// Arma el Prefijo
																		let prefijo = nombre_meses(val.MES).substring(0, 3) + val.ANHO.substring(2);

																htmlContenido += '<option ' + selected + ' value="' + prefijo + '">' + prefijo + '</option>';
														});
												}

												$("#lista_CI").html(htmlContenido);

										}, "json");
						};

						function f_CargaInformacionRack(_ids_rack){
								let rowspan_analisis = 0;

								// Obteniendo el filtro por Muestra
										var lista_CI = $("#lista_CI").val();
										var filtro_muestra = $("#filtro_muestra").val().trim();
										
										// Formatea la búsqueda por C.I.
												if (filtro_muestra.length > 0){
														filtro_muestra = lista_CI + '-' + filtro_muestra;
												}
												else{
														filtro_muestra = '';
												}

								// Cargando detalle de Análisis
										var htmlContenido = '';

										$("#tbl_DetalleAnalisis").html(htmlContenido);

								// Loading Modal
										var modal_loading = $("#divmodal_Loading");
										modal_loading.modal({backdrop: 'static', keyboard: false});

								// Carga datos
										$.get( "../lims_api/index.php", { accion: "get_AnalisisMuestras", ids_rack: _ids_rack, ci_muestra: filtro_muestra },
												function( data ) {
														if(data.estado == 1){
																$.each( data.registros, function( key, val ) {
																		htmlContenido += '<tr>';

																		// Realiza la agrupación de muestras
																				if (rowspan_analisis != val.ID_RACK){
																						htmlContenido += '  <td rowspan="' + val.TOTAL_MUESTRAS + '" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: left; background-color: #8C8C8C;">';
																						htmlContenido += '          <b style="color: #FAF566;">' + val.nom_rack + '</b>';
																						htmlContenido += '  </td>';
																				}

																				rowspan_analisis = val.ID_RACK;

																		// Determinando el Color para los Blancos Óxidos
																				var color_bf = '';

																				if (val.Id_TipoBlancoFundente == 1){
																						color_bf = 'background-color: #F2B705; color: #ffffff;';
																				}

																		htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right; ' + color_bf + '">';
																		htmlContenido += '      <div class="col-md-6 col-sm-6 col-xs-6" title="' + val.nom_tipo + '">';
																		htmlContenido += '          <img src="images/' + ((val.Rack_TipoMuestra == 1) ? 'dot_muestra.png' : ((val.Rack_TipoMuestra == 2) ? 'dot_blancof.png' : ((val.Rack_TipoMuestra == 3) ? 'dot_blancop.png' : 'dot_mr.png'))) + '" style="width: 15px;"/>';
																		htmlContenido += '      </div>';
																		htmlContenido += '      <div class="col-md-6 col-sm-6 col-xs-6" style="text-align: right;">';
																		htmlContenido += '          ' + val.Num_Crisol;
																		htmlContenido += '      </div>';
																		htmlContenido += '  </td>';
																		
																		htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; ' + color_bf + '">';
																		htmlContenido += '      ' + val.CRISOL;
																		htmlContenido += '  </td>';
																		
																		htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; ' + color_bf + '" onclick="f_OpenDetalleMuestra(' + val.Num_Crisol + ", '" + val.nom_muestra + "', '" + val.FechaPeso_Muestra + "', '" + val.UsuarioPeso_Muestra + "', '" + val.FechaPeso_Regulo + "', '" + val.UsuarioPeso_Regulo + "', '" + val.FechaPeso_Dore + "', '" + val.UsuarioPeso_Dore + "', '" + val.FechaPeso_Au + "', '" + val.UsuarioPeso_Au + "'" + ');">';
																		htmlContenido += '      <u>' + val.nom_muestra + '</u>';
																		htmlContenido += '  </td>';
																		
																		htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; ' + color_bf + '">';
																		// htmlContenido += '      ' + ((val.is_Au == 1 && val.is_Ag == 1) ? 'Au - Ag' : ((val.isAu == 1) ? 'Au' : 'Ag'));
																		htmlContenido += '      ' + val.ELEMENTO_ANALISIS;
																		htmlContenido += '  </td>';

																		htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; ' + color_bf + '">';
																		htmlContenido += '      ' + val.Dosificacion;
																		htmlContenido += '  </td>';
																		
																		htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
																		htmlContenido += '      ' + val.Peso_Muestra;
																		htmlContenido += '  </td>';
																		
																		htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
																		htmlContenido += '      ' + val.Peso_Regulo;
																		htmlContenido += '  </td>';
																		
																		htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
																		htmlContenido += '      ' + val.Peso_Dore;
																		htmlContenido += '  </td>';
																		
																		htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
																		htmlContenido += '      ' + val.Peso_Au;
																		htmlContenido += '  </td>';
																		
																		htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
																		htmlContenido += '      ' + val.Ley_Ag;
																		htmlContenido += '  </td>';
																		
																		htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
																		htmlContenido += '      ' + val.Ley_Au;
																		htmlContenido += '  </td>';
																		
																		htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
																		htmlContenido += '      ' + val.Ley_Ag_oz;
																		htmlContenido += '  </td>';
																		
																		htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
																		htmlContenido += '      ' + val.Ley_Au_oz;

																		// Determina el Color para Conf.Ag
																				var color_confag = '';

																		if (val.Conf_Ag.length > 0){
																				if (val.Rack_TipoMuestra == 2){
																						if (val.Conf_Ag <= 0.5){
																								color_confag = '#00C756';
																						}
																						else{
																								color_confag = '#FF2F1E';
																						}
																				}
																				else{
																						if (val.Conf_Ag <= 0.5){
																								color_confag = '#00C756';
																						}

																						if (val.Conf_Ag > 0.5 && val.Conf_Ag < 1){
																								color_confag = '#FEB71B';
																						}
																						if (val.Conf_Ag >= 1){
																								color_confag = '#FF2F1E';
																						}
																				}
																		}
																		
																		htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center; color: #ffffff; background-color: ' + color_confag + ';">';
																		htmlContenido += '      ' + val.Conf_Ag;
																		htmlContenido += '  </td>';
																		htmlContenido += '  </td>';

																		// Determina el Color para Conf.Au
																				var color_confau = '';

																		if (val.Conf_Au.length > 0){
																				if (val.Rack_TipoMuestra == 2){
																						if (val.Conf_Au <= 0.5){
																								color_confau = '#00C756';
																						}
																						else{
																								color_confau = '#FF2F1E';
																						}
																				}
																				else{
																						if (val.Conf_Au <= 0.5){
																								color_confau = '#00C756';
																						}

																						if (val.Conf_Au > 0.5 && val.Conf_Au < 1){
																								color_confau = '#FEB71B';
																						}
																						if (val.Conf_Au >= 1){
																								color_confau = '#FF2F1E';
																						}
																				}
																		}

																		htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center; color: #ffffff; background-color: ' + color_confau + ';">';
																		htmlContenido += '      ' + val.Conf_Au;
																		htmlContenido += '  </td>';

																		htmlContenido += "</tr>";
																});
														}
														else{
																alert("No se encontraron resultados para la búsqueda solicitada");
														}

														$("#tbl_DetalleAnalisis").html(htmlContenido);

														// Cerrando Modal
																$('#divmodal_Loading').modal('hide');

												}, "json");
						};
			</script>

				<!-- Funciones Secundarias -->
				<script type="text/javascript">
						function f_OpenDetalleMuestra(_orden_rack, _nom_muestra, _FechaPeso_Muestra, _UsuarioPeso_Muestra, _FechaPeso_Regulo, _UsuarioPeso_Regulo, _FechaPeso_Dore, _UsuarioPeso_Dore, _FechaPeso_Au, _UsuarioPeso_Au){
								var modal_loading = $("#divmodal_DetallesMuestra");

								// Coloca el Título
										$("#lbl_TituloMuestra").html(_nom_muestra);
										$("#lbl_OrdenRack").html(_orden_rack);

								// Agredando información al modal
										$("#th_InfoMuestraFecha").html(_FechaPeso_Muestra);
										$("#th_InfoMuestraUsuario").html(_UsuarioPeso_Muestra);
										$("#th_InfoReguloFecha").html(_FechaPeso_Regulo);
										$("#th_InfoReguloUsuario").html(_UsuarioPeso_Regulo);
										$("#th_InfoDoreFecha").html(_FechaPeso_Dore);
										$("#th_InfoDoreUsuario").html(_UsuarioPeso_Dore);
										$("#th_InfoOroFecha").html(_FechaPeso_Au);
										$("#th_InfoOroUsuario").html(_UsuarioPeso_Au);

								// Pintando de rojo los pendientes
										$("#th_InfoMuestraFecha").css("color", "#12537E");
										$("#th_InfoMuestraUsuario").css("color", "#12537E");
										$("#th_InfoReguloFecha").css("color", "#12537E");
										$("#th_InfoReguloUsuario").css("color", "#12537E");
										$("#th_InfoDoreFecha").css("color", "#12537E");
										$("#th_InfoDoreUsuario").css("color", "#12537E");
										$("#th_InfoOroFecha").css("color", "#12537E");
										$("#th_InfoOroUsuario").css("color", "#12537E");

										if (_FechaPeso_Muestra == 'PENDIENTE'){
												$("#th_InfoMuestraFecha").css("color", "#FF2F1E");
												$("#th_InfoMuestraUsuario").css("color", "#FF2F1E");
										}
										 if (_FechaPeso_Regulo == 'PENDIENTE'){
												$("#th_InfoReguloFecha").css("color", "#FF2F1E");
												$("#th_InfoReguloUsuario").css("color", "#FF2F1E");
										}
										 if (_FechaPeso_Dore == 'PENDIENTE'){
												$("#th_InfoDoreFecha").css("color", "#FF2F1E");
												$("#th_InfoDoreUsuario").css("color", "#FF2F1E");
										}
										 if (_FechaPeso_Au == 'PENDIENTE'){
												$("#th_InfoOroFecha").css("color", "#FF2F1E");
												$("#th_InfoOroUsuario").css("color", "#FF2F1E");
										}

								modal_loading.modal();
						};
						
						function f_OpenDetalleRack(_nom_rack, _rack_totalmuestras, _rack_usuario_creacion, _rack_fechahora_creacion, _rack_usuario_cierre, _rack_fechahora_cierre, _rack_horno, _rack_observacion){
								var modal_loading = $("#divmodal_DetallesRack");

								// Coloca el Título
										$("#lbl_TituloRack").html(_nom_rack);

								// Agrega datos complementarios del Rack
										$("#th_InfoRackTotalMuestras").html(_rack_totalmuestras);
										$("#th_InfoRackUsuarioCreacion").html(_rack_usuario_creacion);
										$("#th_InfoRackFechaCreacion").html(_rack_fechahora_creacion);
										$("#th_InfoRackUsuarioCierre").html(_rack_usuario_cierre);
										$("#th_InfoRackFechaCierre").html(_rack_fechahora_cierre);
										$("#th_InfoRackHorno").html(_rack_horno);
										$("#th_InfoRackObservacion").html(_rack_observacion.trim().replace(/%/g, '"'));

								// Pintando de rojo los pendientes
										$("#th_InfoRackUsuarioCierre").css("color", "#12537E");
										$("#th_InfoRackFechaCierre").css("color", "#12537E");

										if (_rack_usuario_cierre == 'PENDIENTE'){
												$("#th_InfoRackUsuarioCierre").css("color", "#FF2F1E");
												$("#th_InfoRackFechaCierre").css("color", "#FF2F1E");
										}

								modal_loading.modal();
						};

						function f_RackSelected(_item_rack, _id_rack){
								let is_removed = 0;

								// Setea colores
										if ($("#chkRack_Selected_" + _item_rack).is(':checked')){
												f_ColorSelectedRack(_item_rack);
										}
										else{
												f_UnColorSelectedRack(_item_rack);

												is_removed = 1;
										}

								// Add o Remove Id de Racks
										if (is_removed == 1){
												// 1. Buscar entre la cadena
														if (chkRack_Selected.indexOf(_id_rack) >= 0){
																chkRack_Selected = chkRack_Selected.replace(_id_rack + ',', '');
																chkRack_Selected = chkRack_Selected.replace(',' + _id_rack, '');
																chkRack_Selected = chkRack_Selected.replace(_id_rack, '');
														}
										}
										else{
												chkRack_Selected += ((chkRack_Selected.length > 0) ? ',' : '') + _id_rack;
										}

								// Carga los datos de Análisis en Racks
										f_CargaInformacionRack(chkRack_Selected);
						}
				</script>

			<!-- Funciones para Grabar -->
			<script type="text/javascript">
				
			</script>

			<!-- Otras Funciones -->
			<script type="text/javascript">
						function f_cerrarModal(pantalla_modal){
								if (pantalla_modal == 1){
										$('#divmodal_DetallesMuestra').modal('hide');
								}
								if (pantalla_modal == 2){
										$('#divmodal_DetallesRack').modal('hide');
								}
						};

						function f_CerrarDiv(accion, nom_div){
								var _div = document.getElementById(nom_div);

								if (accion == 'A'){
										_div.style.display = 'block'
								}
								else{
										 _div.style.display = 'none';
								}
						};

						// Despinta las celdas seleccionadas del Rack
						function f_UnColorSelectedRack(_item){
								$('#trRack_selected_' + _item).css('background-color', '');
						}

						// Pinta la fila del Rack seleccionada
						function f_ColorSelectedRack(_item){
								$('#trRack_selected_' + _item).css('background-color', '#FFF587');
						}

						// Limpia los datos al momento de Realizar la búsqueda de resultados
						function f_Limpiar(){
								// // Detalles del Rack
								//     $("#lblRack_totalmuestras").html('');
								//     $("#lblRack_usuario").html('');
								//     $("#lblRack_fechahora").html('');
								//     $("#lblRack_horno").html('');
								//     $("#lblRack_observacion").html('');
								//     document.getElementById('lblRack_observacion').title = '';

								// Quita los Checks de la lista de Racks
										let c = 1;

										while(c < Rack_TotalRows){
												f_UnColorSelectedRack(c);

												c +=1;
										}

										chkRack_Selected = '';

								// Grilla de Detalles de Rack
										$("#tbl_DetalleAnalisis").html('');
						}

						function f_HideListaRacks(_x){
								if (_x == 1){
										$("#div_listaracks").width(43);
										$("#div_detalleanalisis").width('99%');
										f_CerrarDiv('C', 'div_TituloListaRacks');
										f_CerrarDiv('C', 'div_ContentListaRacks');
										f_CerrarDiv('C', 'div_ShowListaRacks');
										f_CerrarDiv('A', 'div_HideListaRacks');
								}
								else{
										$("#div_listaracks").width('');
										$("#div_detalleanalisis").width('');
										f_CerrarDiv('A', 'div_TituloListaRacks');
										f_CerrarDiv('A', 'div_ContentListaRacks');
										f_CerrarDiv('A', 'div_ShowListaRacks');
										f_CerrarDiv('C', 'div_HideListaRacks');
								}
						}

						function f_DeseleccionarTodo(){
								let c = 1;

								while(c < Rack_TotalRows){
										document.getElementById('chkRack_Selected_' + c).checked = 0;

										c +=1;
								}

								f_Limpiar();
						}

						// Permite obtener el nombre de cada mes
						function nombre_meses(_num_mes){
								if (_num_mes == 1){
										return "ENERO";
								}
								if (_num_mes == 2){
										return "FEBRERO";
								}
								if (_num_mes == 3){
										return "MARZO";
								}
								if (_num_mes == 4){
										return "ABRIL";
								}
								if (_num_mes == 5){
										return "MAYO";
								}
								if (_num_mes == 6){
										return "JUNIO";
								}
								if (_num_mes == 7){
										return "JULIO";
								}
								if (_num_mes == 8){
										return "AGOSTO";
								}
								if (_num_mes == 9){
										return "SEPTIEMBRE";
								}
								if (_num_mes == 10){
										return "OCTUBRE";
								}
								if (_num_mes == 11){
										return "NOVIEMBRE";
								}
								if (_num_mes == 12){
										return "DICIEMBRE";
								}
						}

						// Detecta la tecla ESCAPE
						document.addEventListener('keyup', function(e) {
								if (e.keyCode == 27) {
										f_cerrarModal(1);
										f_cerrarModal(2);
								}
						});
			</script>

	</body>
</html>

<?php
	cerrarSesion($enlace);
?>