<?php
  
  session_start();

  include('../../php/conn.php');

  if(!isset($_SESSION["id"])){
	header('Location: index.php');
  }

  mysqli_query($enlace, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");

?>

<!DOCTYPE html>
<html lang="es">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<!-- Meta, title, CSS, favicons, etc. -->
		<meta charset="utf-8">
		<meta http-equiv="X-UA-Compatible" content="IE=edge">
		<meta name="viewport" content="width=device-width, initial-scale=1">

		<title>Importación de Resultados XRF</title>

		<!-- Bootstrap -->
		<link href="../vendors/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
		<!-- Font Awesome -->
		<link href="../vendors/font-awesome/css/font-awesome.min.css" rel="stylesheet">
		<!-- NProgress -->
		<link href="../vendors/nprogress/nprogress.css" rel="stylesheet">
		<!-- iCheck -->
		<link href="../vendors/iCheck/skins/flat/green.css" rel="stylesheet">
		<!-- bootstrap-progressbar -->
		<link href="../vendors/bootstrap-progressbar/css/bootstrap-progressbar-3.3.4.min.css" rel="stylesheet">
		<!-- JQVMap -->
		<link href="../vendors/jqvmap/dist/jqvmap.min.css" rel="stylesheet"/>
		<!-- bootstrap-daterangepicker -->
		<link href="../vendors/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
		<!-- Ion.RangeSlider -->
		<link href="../vendors/normalize-css/normalize.css" rel="stylesheet">
		<link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.css" rel="stylesheet">
		<link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.skinFlat.css" rel="stylesheet">
		<!-- Bootstrap Colorpicker -->
		<link href="../vendors/mjolnic-bootstrap-colorpicker/dist/css/bootstrap-colorpicker.min.css" rel="stylesheet">
		<link href="../vendors/cropper/dist/cropper.min.css" rel="stylesheet">
		<!-- Datatables -->
		<link href="../vendors/datatables.net-bs/css/dataTables.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-buttons-bs/css/buttons.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-fixedheader-bs/css/fixedHeader.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-responsive-bs/css/responsive.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-scroller-bs/css/scroller.bootstrap.min.css" rel="stylesheet">

		<!-- bootstrap-datetimepicker -->
		<link href="../vendors/bootstrap-datetimepicker/build/css/bootstrap-datetimepicker.css" rel="stylesheet">

		<!-- Switchery -->
		<link href="../vendors/switchery/dist/switchery.min.css" rel="stylesheet">

		<!-- Custom Theme Style -->
		<link href="../build/css/custom.min.css" rel="stylesheet">

		<script type="text/javascript">
			let itemimportacion_Selected = 0;
      let idimportacion_Selected = 0;
		</script>

		<style type="text/css">
			th {
				position: sticky;
				top: 0px;
				background-color: #12537E;
			}
		</style>
	</head>

	<body class="nav-md" onload="f_LoadImportaciones()" style="zoom: 80%">
		<div class="container body">
			<div class="main_container">
				<?php include('partes/sidebar.php'); ?>

				<!-- page content -->
				<div class="right_col" role="main">
					<div class="">
						<div class="row">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
									<div class="x_title">
										<h2>
											Filtros
										</h2>
										<div class="clearfix">
										</div>
									</div>

									<div class="x_content" style="margin-bottom: -10px;">
										<!-- Filtros -->
										<div class="col-md-5 col-sm-5 col-xs-12">
											<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
												<div class="x_title">
													<h2>
														<font style="font-size: 14px"><b>Fecha de Importación</b></font>
													</h2>
													<div class="clearfix">
													</div>
												</div>
												<div class="x_content" style="margin-bottom: -10px;">
													<div class="form-group col-md-6 col-sm-6 col-xs-12">
														<div class="col-md-12 col-sm-7 col-xs-12">
															<?php
																date_default_timezone_set("America/Lima"); 
																$_date = date('Y-m-d');

																echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_inicio" value="'.$_date.'"/>';
															?>
														</div>
													</div>

													<div class="form-group col-md-6 col-sm-6 col-xs-12">
														<div class="col-md-12 col-sm-7 col-xs-12">
															<?php
																echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_fin" value="'.$_date.'"/>';
															?>
														</div>
													</div>
												</div>
											</div>
										</div>
										<!-- 
										<div class="col-md-3 col-sm-3 col-xs-12">
											<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
												<div class="x_title">
													<h2>
														<font style="font-size: 14px"><b>Búsqueda por Fundidor</b></font>
													</h2>
													<div class="clearfix">
													</div>
												</div>
												<div class="x_content" style="margin-bottom: -10px;">
													<div class="form-group col-md-12 col-sm-12 col-xs-12">
														<select id="lista_fundidor" class="form-control" style="text-align: left;">
															<option value="">Elija una opción...</option>

														</select>
													</div>
												</div>
											</div>
										</div>

										<div class="col-md-3 col-sm-3 col-xs-12">
											<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
												<div class="x_title">
													<h2>
														<font style="font-size: 14px"><b>Búsqueda por Muestra</b></font>
													</h2>
													<div class="clearfix">
													</div>
												</div>
												<div class="x_content" style="margin-bottom: -10px;">
													<div class="form-group col-md-12 col-sm-12 col-xs-12">
														<div class="col-md-5 col-sm-5 col-xs-12">
															<select id="lista_CI" class="form-control col-md-3 col-xs-12" style="text-align: left;">

															</select>
														</div>

														<div class="col-md-7 col-sm-7 col-xs-7">
															<input type="text" id="filtro_muestra" placeholder="Formato: 0001-001" class="form-control col-md-9 col-xs-9" style="text-align: center;">
														</div>
													</div>
												</div>
											</div>
										</div> -->
									</div>
								</div>
							</div>
						</div>

						<div class="row">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<button class="btn btn-success" type="button" onclick="f_LoadImportaciones()" style="width: 100%; background-color: #26B99A">
									 <b>Ejecutar Búsqueda</b>
								</button>
							</div>
						</div>

						<div class="row" style="margin-top: 10px">
							<div id="div_listaracks" class="col-md-4 col-sm-4 col-xs-12">
								<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
									<div class="x_title">
										<div id="div_TituloListaRacks" class="col-md-6 col-sm-6 col-xs-6">
											<label style="font-size: 14px; margin-top: 5px;">
												Historial Importaciones
											</label>
										</div>

										<div class="col-md-6 col-sm-6 col-xs-6">
											<button class="btn btn-info" type="button" onclick="f_AdminImportacion('N');" style="width: 100%; color: #ffffff; font-size: 14px; margin-top: -5px; margin-bottom: 4px;">
					              <b>+ Nueva Importación</b>
					            </button>
										</div>

										<div class="clearfix">
										</div>
									</div>

									<div id="div_ContentListaRacks" class="x_content">
										<div class="table-box" style="height: 850px; width: 100%; overflow: scroll;">
											<table class="table table-striped jambo_table bulk_action">
												<thead>
													<tr style="font-size: 13px;">
														<th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; border-top-left-radius: 15px; width: 20px;"><center>
															Item
														</center></th>
														<th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
															Fecha Hora Importación
														</center></th>
														<th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
															Observación
														</center></th>
														<th colspan="2" style="border: solid; /**/border-width: 1px; border-color: #ffffff; vertical-align: middle; border-top-right-radius: 15px;"><center>
															Acción
														</center></th>
													</tr>

													<tr style="font-size: 13px;">
														<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
															Descargar
														</center></th>
														<th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
															Ver
														</center></th>
													</tr>
												</thead>

												<tbody id="tbl_importaciones" style="overflow: scroll">
													
												</tbody>
											</table>
										</div>
									</div>
								</div>
							</div>

							<div id="div_detalleanalisis" class="col-md-8 col-sm-8 col-xs-12">
								<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
									<div class="x_title">
										<div id="div_ShowListaRacks" class="col-md-1 col-sm-1 col-xs-1" style="text-align: right; background-color: #FF0005; color: #ffffff; border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px; vertical-align: middle; text-align: center; height: 27px; width: 50px; cursor: pointer;" onclick="f_HideListaRacks(1);">
											<i class="fa fa-chevron-left" style="margin-top: 6px;">
												
											</i>
										</div>

										<div id="div_HideListaRacks" class="col-md-1 col-sm-1 col-xs-1" style="text-align: right; background-color: #FF0005; color: #ffffff; border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px; vertical-align: middle; text-align: center; height: 27px; width: 50px; cursor: pointer; margin-left: -13px; display: none;" onclick="f_HideListaRacks(0);">
											<i class="fa fa-chevron-right" style="margin-top: 6px; margin-left: -4px;">
												
											</i>
										</div>

										<div class="col-md-11 col-sm-11 col-xs-11">
											<label style="font-size: 14px; margin-top: 5px;">
												Registros de la Importación seleccionada
											</label>
										</div>

										<div class="clearfix">
										</div>
									</div>

									<div class="x_content" style="overflow-x: scroll;">
										<table id="tbl_detalle" class="table table-striped jambo_table bulk_action">
											
										</table>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Ventanas Modal -->
		<div id="modal_adminimportaciones" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false">
		  <div class="modal-dialog">
		    <div class="modal-content">
		      <div class="modal-header">
		      	<button type="button" class="close" data-dismiss="modal">
							×
            </button>

		        <h2 class="modal-title fs-5" id="modal_adminimportacionesLabel">
		        	Nueva Importación
		        </h2>
		      </div>
		      <div class="modal-body">
		      	<div class="row" style="padding-left: 15px; padding-right: 15px;">
						  <input class="form-control" id="file_upload" type="file" style="padding: 5px;">
						</div>

						<div class="row" style="margin-top: -5px; margin-bottom: 5px; padding: 5px; margin-left: 5px;">
							<div class="col-md-2 col-sm-2 col-xs-2" style="padding: 5px; text-align: left;">
								Observación:
							</div>

							<div class="col-md-10 col-sm-10 col-xs-10">
								<textarea id="observacion" type="text" class="form-control obj_cab col-md-12 col-xs-12" style="margin-top: 5px; text-transform: uppercase;" rows="2"></textarea>
							</div>
						</div>
		      </div>

		      <div class="modal-footer">
		        <button id="btn_cerrarimportacion" type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cerrar</button>
		        <button id="btn_grabarimportacion" type="button" class="btn btn-primary" onclick="f_ConfirmarImportacion();">Importar</button>
		      </div>
		    </div>
		  </div>
		</div>

		<div id="divmodal_Loading" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false" style="margin-top: 300px;">
			<div class="modal-dialog" style="height: 200px; opacity: 0.5;"><center>
				<img src="images/loading.gif" width="200px" style="border: solid; border-width: 1px; border-color: #D9D9D9;  border-radius: 15px;"></img>
			</center></div>
		</div>

		<!-- jQuery -->
		<script src="../vendors/jquery/dist/jquery.min.js"></script>
		<!-- Bootstrap -->
		<script src="../vendors/bootstrap/dist/js/bootstrap.min.js"></script>
		<!-- FastClick -->
		<script src="../vendors/fastclick/lib/fastclick.js"></script>
		<!-- NProgress -->
		<script src="../vendors/nprogress/nprogress.js"></script>
		<!-- Ion.RangeSlider -->
		<script src="../vendors/ion.rangeSlider/js/ion.rangeSlider.min.js"></script>
		<!-- Bootstrap Colorpicker -->
		<script src="../vendors/mjolnic-bootstrap-colorpicker/dist/js/bootstrap-colorpicker.min.js"></script>
		<!-- Custom Theme Scripts -->
		<script src="../build/js/custom.min.js"></script>

		<!-- bootstrap-daterangepicker -->
		<script src="../vendors/moment/min/moment.min.js"></script>
		<script src="../vendors/bootstrap-daterangepicker/daterangepicker.js"></script><!-- Datatables -->
		<script src="../vendors/datatables.net/js/jquery.dataTables.min.js"></script>
		<script src="../vendors/datatables.net-bs/js/dataTables.bootstrap.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/dataTables.buttons.min.js"></script>
		<script src="../vendors/datatables.net-buttons-bs/js/buttons.bootstrap.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/buttons.flash.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/buttons.html5.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/buttons.print.min.js"></script>
		<script src="../vendors/datatables.net-fixedheader/js/dataTables.fixedHeader.min.js"></script>
		<script src="../vendors/datatables.net-keytable/js/dataTables.keyTable.min.js"></script>
		<script src="../vendors/datatables.net-responsive/js/dataTables.responsive.min.js"></script>
		<script src="../vendors/datatables.net-responsive-bs/js/responsive.bootstrap.js"></script>
		<script src="../vendors/datatables.net-scroller/js/dataTables.scroller.min.js"></script>
		<script src="../vendors/jszip/dist/jszip.min.js"></script>
		<script src="../vendors/pdfmake/build/pdfmake.min.js"></script>
		<script src="../vendors/pdfmake/build/vfs_fonts.js"></script>

		<!-- Funciones Principales -->
		<script type="text/javascript">
			function f_LoadImportaciones(){
        var _html = '';
        var d = 1;

        // Obteniendo filtros
        	var fecha_inicio = $("#fecha_inicio").val();
        	var fecha_fin = $("#fecha_fin").val();

        // Validando datos
      		if (fecha_inicio == null){
            alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

            return;
	        }
	        if (fecha_inicio.length == 0){
            alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

            return;
	        }

	        if (fecha_fin == null){
            alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

            return;
	        }
	        if (fecha_fin.length == 0){
            alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

            return;
	        }

	        if (fecha_fin < fecha_inicio){
            alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

            return;
        	}

				// Cargando Lista de Racks
	        $("#tbl_importaciones").html('');
	        $("#tbl_detalle").html('');

	        f_LoadingImportaciones(1);

	        $.get( "../lims_api/index.php", { accion: "get_ResultadosXRF_ListaImportacion", fecha_inicio: fecha_inicio, fecha_fin: fecha_fin }, 
	          function( data ) {
	            if(data.estado == 1){
	            	$("#tbl_importaciones").html(data.html);

	            	itemimportacion_Selected = 1;
								idimportacion_Selected = data.id_importacion;
	            }
	            else{
	              // alert("No se encontraron resultados.");
	            }

	            f_LoadingImportaciones(0);

	          }, "json");

    	};

      function f_AdminImportacion(){
        var modal = $("#modal_adminimportaciones");

        // Seteando datos
          $("#file_upload").val('');
					$("#observacion").val('');

        // Abre modal
					modal.modal({backdrop: 'static', keyboard: false});
      };

      function f_LoadItemImportacion(_item, _id_importacion){
        var _html = '';

        // Pinta selección
          f_ColorSelected(_item);

        // Cargando datos
          f_LoadingDetalle(1);

          $("#tbl_detalle").html(_html);

          $.get( "../lims_api/index.php", { accion: "get_ResultadosXRF_DetalleImportacion", id_importacion: _id_importacion }, 
            function( data ) {
              if(data.estado == 1){
                // Actualiza la tabla de Muestras
                  $("#tbl_detalle").html(data.html);

                // Actualiza el número de registros
                  $("#num_registros").html(data.r);
              }

              f_LoadingDetalle(0);

            }, "json");

        itemimportacion_Selected = _item;
        idimportacion_Selected = _id_importacion;
      };

      function f_ColorSelected(_item){
        var i = 1;

        // Recorre los Tr de la tabla y los limpia
        $("#tbl_importaciones tr").each(function () {
          $("#tr_item_" + i).css('background-color', '');

          i += 1;
        });

        // Seteando item seleccionado
          $("#tr_item_" + _item).css('background-color', '#FFF587');
      };

      function f_DownloadFile(_file_name){
        window.open('../files/' + _file_name);
      };
		</script>

		<!-- Funciones Secundarias -->
		<script type="text/javascript">
			function f_LoadingImportaciones(_is_show){
				if (_is_show == 1){
					$("#wt_importacion").show();
				}
				else{
					$("#wt_importacion").hide();
				}
			}

			function f_LoadingConfirmarImportacion(_is_show){
				if (_is_show == 1){
					$("#wt_adminmimportaciones").show();

					$("#btn_cerrarimportacion").prop('disabled', true);
					$("#btn_cerrarimportacion").css('background-color', '#C2C0A6');
					$("#btn_grabarimportacion").prop('disabled', true);
					$("#btn_grabarimportacion").css('background-color', '#C2C0A6');
				}
				else{
					$("#wt_adminmimportaciones").hide();

					$("#btn_cerrarimportacion").prop('disabled', false);
					$("#btn_cerrarimportacion").css('background-color', '');
					$("#btn_grabarimportacion").prop('disabled', false);
					$("#btn_grabarimportacion").css('background-color', '');
				}
			}

			function f_LoadingDetalle(_is_show){
				if (_is_show == 1){
					$("#wt_detalle").show();
				}
				else{
					$("#wt_detalle").hide();
				}
			}

      function f_HideListaDetalle(_x){
        if (_x == 1){
          $("#div_importacion").hide();
          $("#div_detalle").width('100%');

          f_CerrarDiv('C', 'div_ShowListaDetalle');
          f_CerrarDiv('A', 'div_HideListaDetalle');
          }
        else{
          $("#div_importacion").show();
          $("#div_detalle").width('');

          f_CerrarDiv('A', 'div_ShowListaDetalle');
          f_CerrarDiv('C', 'div_HideListaDetalle');
        }
      };
		</script>

		<!-- Funciones de Grabación -->
		<script type="text/javascript">
			function f_ConfirmarImportacion(){
				var _file = $("#file_upload").val();
				var _observacion = $("#observacion").val().replace(/'/g, '').replace(/"/g, '').trim().toUpperCase();

				// Validando datos
					if (_file == null){
	          alert("Debe seleccionar un Archivo.");

	          return;
	        }
	        if (_file.length == 0){
	          alert("Debe seleccionar un Archivo.");

	          return;
	        }

        // Loading Modal
          var modal_loading = $("#divmodal_Loading");
          modal_loading.modal({backdrop: 'static', keyboard: false});

	      // Guardando datos
	        var _html = '';

          $.get( "../lims_api/index.php", { accion: "import_ResultadosXRF", nombre_archivo: $("#file_upload")[0].files[0]["name"], observacion: _observacion },
              function( data ) {
                if(data.estado == 1){
                	var _id_importacion = data.id_importacion;
                	var _fechahoraregistro = data.g_fecha;

                  // Obtiene el total de Importaciones
                    var item_importacion = 1;

                    $("#tbl_importaciones tr").each(function () {
                      item_importacion += 1;
                    });

                  // Obtiene los registros actuales de Racks
                    _html = $("#tbl_importaciones").html();

                  // Agregando el nuevo Rack
                    _html += '<tr id="tr_item_' + item_importacion + '" style="cursor: pointer; font-size: 13px;">';

                    _html += '  <td id="td_item_1_' + item_importacion + '" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; width: 30px;">';
                    _html += '    ' + item_importacion;
                    _html += '  </td>';

                    _html += '  <td id="td_item_2_' + item_importacion + '" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; width: 30px;">';
                    _html += '    ' + _fechahoraregistro;
                    _html += '  </td>';

                    _html += '  <td id="td_item_3_' + item_importacion + '" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;">';
                    _html += '    ' + _observacion;
                    _html += '  </td>';

                    _html += '  <td id="td_item_4_' + item_importacion + '" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; width: 30px;">';
                    _html += '  	<label style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px; padding-top: 3px; padding-bottom: 3px; padding-left: 4px; padding-right: 4px; background-color: #F29F05; color: #ffffff; cursor: pointer;" onclick="f_DownloadFile(' + "'file_" + _id_importacion + ".xls'" + ');">';
										_html += '    	<i class="fa fa-download" style="padding-left: 3px; padding-right: 3px;"></i>';
										_html += '    </label>';
                    _html += '  </td>';

										_html += '  <td id="td_item_5_' + item_importacion + '" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-size: 14px; width: 30px;">';
										_html += '      <label style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px; padding-top: 3px; padding-bottom: 3px; padding-left: 4px; padding-right: 4px; background-color: #4C8B44; color: #ffffff; cursor: pointer;" onclick="f_LoadItemImportacion(' + item_importacion + ', ' + _id_importacion + ');">';
										_html += '    	<i class="fa fa-search-plus" style="padding-left: 3px; padding-right: 3px;"></i>';
										_html += '      </label>';
										_html += '  </td>';

                    _html += '</tr>';

                  $("#tbl_importaciones").html(_html);

                	// Actualiza variables
                		itemimportacion_Selected = item_importacion;
                		idimportacion_Selected = _id_importacion;

	                // Cargando Archivo
                    var formData = new FormData();
                    var files = $('#file_upload')[0].files[0];

                    formData.append('file', files);
                    formData.append('id_importacion', _id_importacion);
                    formData.append('accion', 'import_ResultadosXRF_ExcelToBD');

                    $.ajax({
                      url: '../lims_api/index_post.php',
                      type: 'POST',
                      data: formData,
                      contentType: false,
                      processData: false,
                      success: function(response) {
                        if (response == 0) {
                          alert('Ocurrió un error al momento de grabar el archivo.');
                        }
                        else{
                          // f_LoadImportaciones();
                        }
                      }
                    });
                }
                else{
                  alert("Ocurrió un error al momento de confirmar la importación.");

                  // Cerrando Modal
                  	$('#divmodal_Loading').modal('hide');

                  return;
                }

	              // Cerrando Modal
                	$('#divmodal_Loading').modal('hide');

                // Cerrando pantalla
                	$('#modal_adminimportaciones').modal('hide');

              }, "json");
			}
		</script>

		<!-- Otras Funciones -->
		<script type="text/javascript">
			function f_cerrarModal(pantalla_modal){
				if (pantalla_modal == 1){
					$('#divmodal_DetallesMuestra').modal('hide');
				}
				if (pantalla_modal == 2){
					$('#divmodal_DetallesRack').modal('hide');
				}
			};

			function f_CerrarDiv(accion, nom_div){
				var _div = document.getElementById(nom_div);

				if (accion == 'A'){
					_div.style.display = 'block'
				}
				else{
					 _div.style.display = 'none';
				}
			};

			// Despinta las celdas seleccionadas del Rack
			function f_UnColorSelectedRack(_item){
				$('#trRack_selected_' + _item).css('background-color', '');
			}

			// Pinta la fila del Rack seleccionada
			function f_ColorSelectedRack(_item){
				$('#trRack_selected_' + _item).css('background-color', '#FFF587');
			}

			// Limpia los datos al momento de Realizar la búsqueda de resultados
			function f_Limpiar(){
				// // Detalles del Rack
				//     $("#lblRack_totalmuestras").html('');
				//     $("#lblRack_usuario").html('');
				//     $("#lblRack_fechahora").html('');
				//     $("#lblRack_horno").html('');
				//     $("#lblRack_observacion").html('');
				//     document.getElementById('lblRack_observacion').title = '';

				// Quita los Checks de la lista de Racks
					let c = 1;

					while(c < Rack_TotalRows){
						f_UnColorSelectedRack(c);

						c +=1;
					}

					chkRack_Selected = '';

				// Grilla de Detalles de Rack
					$("#tbl_DetalleAnalisis").html('');
			}

			function f_HideListaRacks(_x){
				if (_x == 1){
					$("#div_listaracks").hide();
					$("#div_detalleanalisis").width('99%');
					f_CerrarDiv('C', 'div_TituloListaRacks');
					f_CerrarDiv('C', 'div_ContentListaRacks');
					f_CerrarDiv('C', 'div_ShowListaRacks');
					f_CerrarDiv('A', 'div_HideListaRacks');
				}
				else{
					$("#div_listaracks").show();
					$("#div_detalleanalisis").width('');
					f_CerrarDiv('A', 'div_TituloListaRacks');
					f_CerrarDiv('A', 'div_ContentListaRacks');
					f_CerrarDiv('A', 'div_ShowListaRacks');
					f_CerrarDiv('C', 'div_HideListaRacks');
				}
			}

			function f_DeseleccionarTodo(){
				let c = 1;

				while(c < Rack_TotalRows){
					document.getElementById('chkRack_Selected_' + c).checked = 0;

					c +=1;
				}

				f_Limpiar();
			}

			// Permite obtener el nombre de cada mes
			function nombre_meses(_num_mes){
				if (_num_mes == 1){
					return "ENERO";
				}
				if (_num_mes == 2){
					return "FEBRERO";
				}
				if (_num_mes == 3){
					return "MARZO";
				}
				if (_num_mes == 4){
					return "ABRIL";
				}
				if (_num_mes == 5){
					return "MAYO";
				}
				if (_num_mes == 6){
					return "JUNIO";
				}
				if (_num_mes == 7){
					return "JULIO";
				}
				if (_num_mes == 8){
					return "AGOSTO";
				}
				if (_num_mes == 9){
					return "SEPTIEMBRE";
				}
				if (_num_mes == 10){
					return "OCTUBRE";
				}
				if (_num_mes == 11){
					return "NOVIEMBRE";
				}
				if (_num_mes == 12){
					return "DICIEMBRE";
				}
			}

			// Detecta la tecla ESCAPE
			document.addEventListener('keyup', function(e) {
				if (e.keyCode == 27) {
					f_cerrarModal(1);
					f_cerrarModal(2);
				}
			});
		</script>

	</body>
</html>

<?php
	cerrarSesion($enlace);
?>