<?php
	
	session_start();

	include('../../php/conn.php');

	if(!isset($_SESSION["id"])){
		header('Location: index.php');
	}

	mysqli_query($enlace, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");

?>

<!DOCTYPE html>
<html lang="es">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<!-- Meta, title, CSS, favicons, etc. -->
		<meta charset="utf-8">
		<meta http-equiv="X-UA-Compatible" content="IE=edge">
		<meta name="viewport" content="width=device-width, initial-scale=1">

		<title>LIMS | Pre Cierre de Resultados por AAS</title>

		<!-- Bootstrap -->
		<link href="../vendors/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
		<!-- Font Awesome -->
		<link href="../vendors/font-awesome/css/font-awesome.min.css" rel="stylesheet">
		<!-- NProgress -->
		<link href="../vendors/nprogress/nprogress.css" rel="stylesheet">
		<!-- iCheck -->
		<link href="../vendors/iCheck/skins/flat/green.css" rel="stylesheet">
		<!-- bootstrap-progressbar -->
		<link href="../vendors/bootstrap-progressbar/css/bootstrap-progressbar-3.3.4.min.css" rel="stylesheet">
		<!-- JQVMap -->
		<link href="../vendors/jqvmap/dist/jqvmap.min.css" rel="stylesheet"/>
		<!-- bootstrap-daterangepicker -->
		<link href="../vendors/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
		<!-- Ion.RangeSlider -->
		<link href="../vendors/normalize-css/normalize.css" rel="stylesheet">
		<link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.css" rel="stylesheet">
		<link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.skinFlat.css" rel="stylesheet">
		<!-- Bootstrap Colorpicker -->
		<link href="../vendors/mjolnic-bootstrap-colorpicker/dist/css/bootstrap-colorpicker.min.css" rel="stylesheet">
		<link href="../vendors/cropper/dist/cropper.min.css" rel="stylesheet">
		<!-- Datatables -->
		<link href="../vendors/datatables.net-bs/css/dataTables.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-buttons-bs/css/buttons.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-fixedheader-bs/css/fixedHeader.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-responsive-bs/css/responsive.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-scroller-bs/css/scroller.bootstrap.min.css" rel="stylesheet">

		<!-- bootstrap-datetimepicker -->
		<link href="../vendors/bootstrap-datetimepicker/build/css/bootstrap-datetimepicker.css" rel="stylesheet">

		<!-- Switchery -->
		<link href="../vendors/switchery/dist/switchery.min.css" rel="stylesheet">

		<!-- Toggle Switch -->
			<link rel="stylesheet" type="text/css" href="bootstrap/css/bootstrap4-toggle.min.css">

		<!-- Custom Theme Style -->
		<link href="../build/css/custom.min.css" rel="stylesheet">

		<script type="text/javascript">
			var Id_Pedido = 0;
			var Id_DetallePedido = 0;
			var Estado_Cierre = 0;
					var campos_evaluados = 0;
		</script>

		<style type="text/css">
				th {
						position: sticky;
						top: 0px;
						background-color: #12537E;
				}
		</style>
	</head>

	<body class="nav-md" onload="f_LoadResultados()" style="zoom: 80%">
		<div class="container body">
			<div class="main_container">
				<?php include('partes/sidebar.php'); ?>

				<!-- page content -->
				<div class="right_col" role="main">
					<div class="">
						<!-- <div id="row_Titulo" class="row"> -->
							<div class="col-md-4 col-sm-4 col-xs-4">
								<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
									<div class="x_title">
										<h2>
											<font id="lbl_titulomodo" style="font-size: 14px"><b>Búsqueda por rango de fechas de Rack</b></font>
										</h2>

										<div class="clearfix">
										</div>
									</div>

									<div class="x_content" style="margin-bottom: -10px;">
										<div class="form-group col-md-6 col-sm-6 col-xs-12">
											<?php
												date_default_timezone_set("America/Lima"); 
										$time = date('Y-m-d');

												echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_inicio" value="'.$time.'"/>';
											?>
										</div>

										<div class="form-group col-md-6 col-sm-6 col-xs-12">
											<?php
												echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_fin" value="'.$time.'"/>';
											?>
										</div>
									</div>
								</div>
							</div>
						<!-- </div> -->

						<!-- <div id="row_Buscar" class="row" style="display: none;"> -->
							<div class="col-md-12 col-sm-12 col-xs-12">
								<button class="btn btn-success" type="button" onclick="f_LoadResultados(0)" style="width: 100%; background-color: #26B99A">
									<b>Ejecutar Búsqueda</b>
								</button>
							</div>
						<!-- </div> -->

						<div class="row" style="margin-top: 10px">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
									<div class="x_title">
										<!-- <div class="col-md-10 col-sm-10 col-xs-10"> -->
											<h2 id="titulo_detalle" style="margin-top: 11px;">
												<b>AAS</b> - Visualizando Muestras Pendientes de Pre Cierre
											</h2>
										<!-- </div> -->

										<!-- <div class="col-md-2 col-sm-2 col-xs-2" style="text-align: right;">
											<input id="_SwitchEstado" name="_SwitchEstado" type="checkbox" checked data-toggle="toggle" data-on="Pendientes de Pre Cierre" data-off="Pre Cerradas" data-onstyle="primary" data-offstyle="warning" data-width="200">
										</div> -->

										<div class="clearfix">
										</div>
									</div>

									<div class="x_content">
										<div class="col-md-10 col-sm-10 col-xs-10" style="margin-top: 15px;">
											<label>
												Total de Muestras:
											</label>
											<label id="lbl_TotalMuestras" style="color: #FF0005; font-size: 14px;">
												0
											</label>
										</div>

										<div class="col-md-2 col-sm-2 col-xs-2" style="margin-top: -5px;">
											<button class="btn btn-success" type="button" onclick="f_PreCierre()" style="width: 100%; background-color: #F25050">
												<b>Pre Cierre</b>
											</button>
										</div>

										<div class="table-box" style="height: 850px; width: 100%; overflow: scroll;">
											<table id="tbl_analisisresultados" class="table table-striped jambo_table bulk_action">

											</table>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Ventanas Modal -->
		<div id="divmodal_Cierre" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false">
			<div class="modal-dialog" style="width: 40%; margin-top: 12%; margin-left: 30%">
				<!-- Modal content-->
				<div class="modal-content">
					<div class="modal-header">
						<button type="button" class="close" data-dismiss="modal">
							&times;
						</button>

						<h4 class="modal-title"><b>
							Cierre de Análisis
						</b></h4>
					</div>

					<div class="modal-body">
						<div class="row"><center>
							<label id="cierre_mensaje" style="margin-left: 10px; margin-right: 10px; color: #A63D33; font-size: 14px;"><b>
								Prueba de mensaje
							</b></label>
						</center></div>

						<div class="ln_solid"></div>

						<div class="row" >
							<div class="col-md-4 col-sm-4 col-xs-4"><center>
								<button class="btn btn-success" type="button" onclick="f_ModalRevertirCierre()" style="width: 150px; background-color: #A63D33">
									Revertir
								</button>
							</center></div>

							<div class="col-md-4 col-sm-4 col-xs-4"><center>
								<button id="btn_cerrar" class="btn btn-success" type="button" onclick="f_ModalUpdateCierre()" style="width: 150px; background-color: #26B99A">
									Cerrar
								</button>
							</center></div>

							<div class="col-md-4 col-sm-4 col-xs-4"><center>
								<button class="btn btn-success" type="button" onclick="f_cerrarModal(1)" style="width: 150px; background-color: #807D80">
								Cancelar
								</button>
							</center></div>
						</div>

						<input id="id_pedido" type="hidden">
						<input id="id_detallepedido" type="hidden">
						<input id="estado_cierre" type="hidden">
						<input id="cierre_imageorden" type="hidden">
					</div>
				</div>
			</div>
		</div>

		<div id="divmodal_qr" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false">
			<div class="modal-dialog" style="width: 50%; margin-top: 12%; margin-left: 25%">
				<!-- Modal content-->
				<div class="modal-content">
					<div class="modal-header">
						<button type="button" class="close" data-dismiss="modal">
							&times;
						</button>

						<h4 class="modal-title"><b>
							Código QR - Informe de Ensayos
						</b></h4>
					</div>

					<div class="modal-body">
						<div class="row">
							<div class="form-group col-md-5 col-sm-5 col-xs-12">
								<label class="control-label col-md-6 col-sm-6 col-xs-12" style="margin-top: 6px">
									Nombre de Muestra
								</label>
								<div class="col-md-6 col-sm-6 col-xs-12"><b>
									<input type="text" class="form-control col-md-12 col-xs-12" id="qr_muestra" style="text-align: center; background-color: #F2A71B" disabled/>
								</b></div>
							</div>

							<div class="form-group col-md-7 col-sm-7 col-xs-12">
								<label class="control-label col-md-3 col-sm-3 col-xs-12" style="text-align: right; margin-top: 6px">
									Análisis
								</label>
								<div class="col-md-8 col-sm-8 col-xs-12"><b>
									<input type="text" class="form-control col-md-12 col-xs-12" id="qr_analisis" style="text-align: center; background-color: #0455BF; color: #ffffff" disabled/>
								</b></div>
							</div>
						</div>

						<div class="row">
							<div class="ln_solid"></div>
						</div>

						<input id="qr_id_pedido" type="hidden">
						<input id="qr_id_detallepedido" type="hidden">

						<div class="row"><center>
							<img id="img_qr" width="350px" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px; cursor: pointer;" onclick="f_DownloadImg()"/>
						</center></div>

						<div class="row">
							<div class="form-group col-md-12 col-sm-12 col-xs-12" style="text-align: center;">
								<label style="cursor: pointer;" onclick="f_DownloadImg()"><u>
									Descargar Imagen QR
								</u></label>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>

		<div id="divmodal_Loading" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false" style="margin-top: 300px;">
			<div class="modal-dialog" style="height: 200px; opacity: 0.5;"><center>
				<img src="images/loading.gif" width="200px" style="border: solid; border-width: 1px; border-color: #D9D9D9;  border-radius: 15px;"></img>
			</center></div>
		</div>

		<!-- jQuery -->
		<script src="../vendors/jquery/dist/jquery.min.js"></script>
		<!-- Bootstrap -->
		<script src="../vendors/bootstrap/dist/js/bootstrap.min.js"></script>
		<!-- FastClick -->
		<script src="../vendors/fastclick/lib/fastclick.js"></script>
		<!-- NProgress -->
		<script src="../vendors/nprogress/nprogress.js"></script>
		<!-- Ion.RangeSlider -->
		<script src="../vendors/ion.rangeSlider/js/ion.rangeSlider.min.js"></script>
		<!-- Bootstrap Colorpicker -->
		<script src="../vendors/mjolnic-bootstrap-colorpicker/dist/js/bootstrap-colorpicker.min.js"></script>
		<!-- Toggle Switch -->
			<script src="bootstrap/js/bootstrap4-toggle.min.js"></script>
		<!-- Custom Theme Scripts -->
		<script src="../build/js/custom.min.js"></script>

		<!-- bootstrap-daterangepicker -->
		<script src="../vendors/moment/min/moment.min.js"></script>
		<script src="../vendors/bootstrap-daterangepicker/daterangepicker.js"></script><!-- Datatables -->
		<script src="../vendors/datatables.net/js/jquery.dataTables.min.js"></script>
		<script src="../vendors/datatables.net-bs/js/dataTables.bootstrap.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/dataTables.buttons.min.js"></script>
		<script src="../vendors/datatables.net-buttons-bs/js/buttons.bootstrap.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/buttons.flash.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/buttons.html5.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/buttons.print.min.js"></script>
		<script src="../vendors/datatables.net-fixedheader/js/dataTables.fixedHeader.min.js"></script>
		<script src="../vendors/datatables.net-keytable/js/dataTables.keyTable.min.js"></script>
		<script src="../vendors/datatables.net-responsive/js/dataTables.responsive.min.js"></script>
		<script src="../vendors/datatables.net-responsive-bs/js/responsive.bootstrap.js"></script>
		<script src="../vendors/datatables.net-scroller/js/dataTables.scroller.min.js"></script>
		<script src="../vendors/jszip/dist/jszip.min.js"></script>
		<script src="../vendors/pdfmake/build/pdfmake.min.js"></script>
		<script src="../vendors/pdfmake/build/vfs_fonts.js"></script>

		<!-- Funciones Principales -->
		<script type="text/javascript">
			function f_LoadResultados(){
				let _html = '';
				let i = 1;
				let x = 1; // Ayudará a llevar el Id de inicio de cada grupo de muestras
				let t = 0; // Ayudará a llevar el Total de Muestras por cada grupo de muestras
				let is_PreCierreAg = 0; // Ayudará a reservar si es Pre Cierre Ag
				let is_PreCierreAu = 0; // Ayudará a reservar si es Pre Cierre Au
				let rowspan_analisis = 0;

				// Obteniendo parámetros
					// var _estado = (($("#_SwitchEstado").prop('checked')) ? 1 : 0);
					var _estado = 1;
					let fecha_inicio = $("#fecha_inicio").val();
					let fecha_fin = $("#fecha_fin").val();

					// if (_estado == 0){
						// Validando ingreso de fechas
							if (fecha_inicio == null){
								alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

								return;
							}
							if (fecha_inicio.length == 0){
								alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

								return;
							}

							if (fecha_fin == null){
								alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

								return;
							}
							if (fecha_fin.length == 0){
								alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

								return;
							}

							if (fecha_fin < fecha_inicio){
								alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

								return;
							}
					// }

				// Cargando detalle de Análisis
					$("#tbl_analisisresultados").html(_html);

				// Carga datos
					$.get( "../lims_api/index.php", { accion: "get_ResultadosAbsorcionAtomica_PreCierre", estado: _estado, fecha_inicio: fecha_inicio, fecha_fin: fecha_fin },
						function( data ) {
							if(data.estado == 1){
								$("#tbl_analisisresultados").html(data.html);

								f_VerificarMuestrasCompletas();
							}
							else{
								alert("No se encontraron resultados para la búsqueda solicitada");
							}

						}, "json");
			};

			function f_PreCierre(){
				var c = 1;
				var arr_iddetalle = '';

				// Armando cadena de Pre Cierres
					$('#tbl_PreCierre tr').each(function () {
						_checked = $("#chk_PreCierre_" + c).prop('checked');

						if (_checked){
							arr_iddetalle += $("#td_iddetalle_" + c).val() + '|';
						}

						c += 1;
					});

				// Validando Checks
					if (arr_iddetalle.length == 0){
						alert("Debe seleccionar al menos una muestra.");

						return;
					}

				// Guardando Pre Cierres
					$.get( "../lims_api/index.php", { accion: "grabar_AnalisisAbsorcionAtomica_PreCierre", arr_iddetalle: arr_iddetalle.substring(0, arr_iddetalle.length - 1) }, 
						function( data ) {
							if(data.estado == 1){
								f_LoadResultados();
							}
							else{
								alert("Ocurrió un error al momento de realizar el Pre Cierre.");

								return;
							}

						}, "json");
			};

			function f_ChkSelected(_elemento, _item){
				var c = 1;
				var _check = '';
				var _resultado = '';
				var promedio = 0;
				var _count = 0;

				while (c < 20){
					_check = $("#chk_" + _elemento + "_" + _item + "_" + c);
					_resultado = $("#lbl_" + _elemento + "_" + _item + "_" + c);

					if (_check.prop('checked') == undefined){
						break;
					}
					else{
						if (_check.prop('checked')){
							promedio += parseFloat(_resultado.html().trim());

							_count += 1;
						}
					}

					c += 1;
				}

				// Obteniendo promedio
					if (_count == 0){
						promedio = '';
					}
					else{
						promedio = parseFloat(promedio / _count).toFixed(3);
					}

				// Verifica el cierre del análisis
					if ($("#td_precierreusuario_" + _item).html().trim().length > 0){
						if ($("#txt_ismodificado_" + _elemento + '_' + _item).val() == 0){
							$("#txt_resultado_" + _elemento + '_' + _item).val(promedio);
						}

						// Comprueba los límites según el método
							if (_elemento == 'Cu' ||
								_elemento == 'Pb' ||
								_elemento == 'Zn'){
								if (promedio < $("#metodo_limitemin_" + _elemento + '_' + _item).val() ||
	                                promedio > $("#metodo_limitemax_" + _elemento + '_' + _item).val()){
	                            	$("#td_resultado_" + _elemento + '_' + _item).css('background-color', '#d9534f');
	                            }
								else{
									$("#td_resultado_" + _elemento + '_' + _item).css('background-color', '');
								}
							}
					}
					else{
						$("#txt_resultado_" + _elemento + '_' + _item).val(promedio);
						$("#txt_ismodificado_" + _elemento + '_' + _item).val(0);

						$("#td_resultado_" + _elemento + '_' + _item).css('background-color', '');
					}
			};

			function f_ChangePromedio(_elemento, _item){
				var resultado_old = $("#txt_resultado_" + _elemento + '_' + _item).val();

				if (resultado_old.trim().length > 0){
					// var resultado_new = prompt("Ingrese Nuevo Resultado", resultado_old.trim().substring(resultado_old.trim().indexOf('.') + 1));

					var resultado_new = prompt("Ingrese Nuevo Resultado", resultado_old.trim());

					// Validando que se haya ingresado un número correcto
						if (isNaN(resultado_new)){
							alert("El valor ingresado no es correcto.");

							return;
						}
						else{
							// Valida el límite de la modificación
								if (resultado_new != null) {
									$.get( "../lims_api/index.php", { accion: "get_AbsorcionAtomica_Limies", elemento: _elemento, resultado_old: resultado_old, resultado_new: resultado_new },
										function( data ) {
											if(data.estado == 1){
												if (data.limite_inferior == 1){
													alert("El valor ingresado está por debajo del límite Inferior.\n\nPor favor, verificar.");

													return;
												}

												if (data.limite_superior == 1){
													alert("El valor ingresado está por encima del límite Superior.\n\nPor favor, verificar.");

													return;
												}

												// Confirma la modificación
													$("#txt_resultado_" + _elemento + '_' + _item).val(resultado_new.toString());
													$("#txt_ismodificado_" + _elemento + '_' + _item).val(1);

												// Comprueba los límites según el método
													if (_elemento == 'Cu' ||
														_elemento == 'Pb' ||
														_elemento == 'Zn'){
														if (resultado_new.toString() < $("#metodo_limitemin_" + _elemento + '_' + _item).val() ||
							                                resultado_new.toString() > $("#metodo_limitemax_" + _elemento + '_' + _item).val()){
							                              $("#td_resultado_" + _elemento + '_' + _item).css('background-color', '#d9534f');
							                            }
														else{
															$("#td_resultado_" + _elemento + '_' + _item).css('background-color', '');
														}
													}
											}

										}, "json");
								}
						}
				}
			};

			function f_VerificarMuestrasCompletas(){
				var p = 1;
				var analisis = '';
				var analisis_O = '';
				var analisis_C = '';
				var arr_analisis = '';
				var e = 0;
				var promedio = 0;
				var is_completo = 1;
				var td_cierre = '';

				$('#tbl_PreCierre tr').each(function () {
					analisis_O = $("#tdanalisis_O_" + p).html().trim().replace(/ /g, '');
					analisis_C = $("#tdanalisis_C_" + p).html().trim().replace(/ /g, '');

					analisis = analisis_O + ((analisis_C.length > 0) ? '|' + analisis_C : '');

					// Verificando resultados por cada elemento
						e = 0;
						is_completo = 1
						td_cierre = '';

						arr_analisis = analisis.split('|');

						while (e < arr_analisis.length){
							promedio = $("#txt_resultado_" + f_ConvertElemento(arr_analisis[e]) + '_' + p).val();
							td_cierre = $("#td_Cierre_" + f_ConvertElemento(arr_analisis[e]) + '_' + p).html();

							if (promedio.length == 0 && td_cierre.indexOf('Reabrir') == -1){
								is_completo = 0;
							}

							e += 1;
						}

					// Si es completo habilita el Check de Pre Cierre
						if (is_completo == 1){
							// Verifica si está cerrado
								if ($("#td_precierreusuario_" + p).html().trim().length == 0){
									$("#td_precierre_" + p).html('<input id="chk_PreCierre_' + p + '" type="checkbox" style="transform: scale(1.5);">');
								}
						}

					p += 1;
				});

				$("#lbl_TotalMuestras").html(p - 1);
			};
		</script>

		<!-- Funciones para Grabar -->
		<script type="text/javascript">
			function f_ChkCierreElemento(_id_rack, _ci_muestra, _elemento, _item){
				// Obtiene el Promedio
					var _promedio = $("#txt_resultado_" + _elemento + "_" + _item).val();

					if (_promedio == null){
            alert("Debe seleccionar al menos un análisis.");

            $("#chk_Cierre_" + _elemento + '_' + _item).prop('checked', false);

            return;
          }
          if (_promedio.length == 0){
            alert("Debe seleccionar al menos un análisis.");

            $("#chk_Cierre_" + _elemento + '_' + _item).prop('checked', false);

            return;
          }

        // Cierra el elemento
        	var _html = '';

					$.get( "../lims_api/index.php", { accion: "precierre_AnalisisAbsorcionAtomica_Elementos", id_rack: _id_rack, ci_muestra: _ci_muestra, elemento: _elemento, promedio: _promedio },
						function( data ) {
							if (data.estado == 1){
								// Cambia el Check de Cierre de elemento
									_html = '<u style="color: #FF2F1E; cursor: pointer;" onclick="f_ReabrirCierreElemento(' + _id_rack + ", '" + _ci_muestra + "', '" + _elemento + "', " + _item + ')">Reabrir</u>';

									$("#td_Cierre_" + _elemento + '_' + _item).html(_html);

								// Quita la opción de cambiar el promedio
									$("#txt_resultado_" + _elemento + '_' + _item).attr('onclick', '');

								// Guarda los checks de cierre de los análisis
									var k = 1;
									var _checkbox = '';
									var _arr_analisis = '';

									while (k < 10){
										_checkbox = $("#chk_" + _elemento + '_' + _item + '_' + k).prop('checked');

										if (_checkbox == undefined){
											break;
										}

										// Arma cadena de análisis seleccionados
											if (_checkbox){
												_arr_analisis += $("#txt_idchk_" + _elemento + '_' + _item + '_' + k).val() + ', ';
											}

										k += 1;
									}

									_arr_analisis = _arr_analisis.substr(0, _arr_analisis.length - 2);

									// Guarda el cierre de los checks de análisis
										$.get( "../lims_api/index.php", { accion: "precierre_AnalisisAbsorcionAtomica_ElementosAnalisis", arr_analisis: _arr_analisis }, 
											function( data ) {
												if(data.estado == 1){
													// Desactiva el Check de análisis
														$(".chkanalisis_" + _elemento + '_' + _item).prop('disabled', true);
												}
												else{
													alert("Ocurrió un error al momento de realizar el Cierre de los Análisis.");
												}

											}, "json");

								// Verificar que las muestras estén completas
									f_VerificarMuestrasCompletas();
							}
							else{
								alert("Ocurrió un error al momento de realizar el Cierre del Elemento.");

								return;
							}

						}, "json");
			}

			function f_ReabrirCierreElemento(_id_rack, _ci_muestra, _elemento, _item){
				if (confirm("¿Está seguro de reabrir el Elemento?")){
					$.get( "../lims_api/index.php", { accion: "reabrir_AnalisisAbsorcionAtomica_Elementos", id_rack: _id_rack, ci_muestra: _ci_muestra, elemento: _elemento }, 
						function( data ) {
							if(data.estado == 1){
								// Cambia el Check de Cierre de elemento
									_html = '    <input id="chk_Cierre_' + _elemento + '_' + _item + '" type="checkbox" style="transform: scale(1.5);" onchange="f_ChkCierreElemento(' + _id_rack + ", '" + _ci_muestra + "', '" + _elemento + "', " + _item + ')">';

									$("#td_Cierre_" + _elemento + '_' + _item).html(_html);

								// Agrega la opción de cambiar el promedio
									$("#txt_resultado_" + _elemento + '_' + _item).attr('onclick', 'f_ChangePromedio(' + "'" + _elemento + "', "+ _item + ')');

								// Quita el Check de Pre Cierre
									$("#td_precierre_" + _item).html('');
									$("#td_precierreusuario_" + _item).html('');
									$("#td_precierrefechahora_" + _item).html('');

								// Obtiene el Id de los análisis cerrados
									var k = 1;
									var _checkbox = '';
									var _arr_analisis = '';

									while (k < 10){
										_checkbox = $("#chk_" + _elemento + '_' + _item + '_' + k).prop('checked');

										if (_checkbox == undefined){
											break;
										}

										// Arma cadena de análisis seleccionados
											if (_checkbox){
												_arr_analisis += $("#txt_idchk_" + _elemento + '_' + _item + '_' + k).val() + ', ';
											}

										k += 1;
									}

									_arr_analisis = _arr_analisis.substr(0, _arr_analisis.length - 2);

								// Reabre el cierre de los checks de análisis
									$.get( "../lims_api/index.php", { accion: "reabrir_AnalisisAbsorcionAtomica_ElementosAnalisis", arr_analisis: _arr_analisis }, 
										function( data ) {
											if(data.estado == 1){
												// Desactiva el Check de los análisis
													$(".chkanalisis_" + _elemento + '_' + _item).prop('disabled', false);
											}
											else{
												alert("Ocurrió un error al momento de realizar el Cierre de los Análisis.");
											}

										}, "json");

								// Reabre el Pre Cierre de la muestra
									var _id_detalle = $("#td_iddetalle_" + _item).val();

									$.get( "../lims_api/index.php", { accion: "reabrir_AnalisisAbsorcionAtomica_PreCierre", id_detalle: _id_detalle }, 
										function( data ) {
											if(data.estado == 0){
												alert("Ocurrió un error al momento de reabrir el Pre Cierre de la muestra.");

												return;
											}

										}, "json");
							}
							else{
								alert("Ocurrió un error al momento de realizar el Cierre del Elemento.");

								return;
							}

						}, "json");
				}
			}

			function f_ReabrirPreCierre(_id_detalle, _id_analisis){
				$.get( "../lims_api/index.php", { accion: "reabrir_ResultadosAbsorcionAtomica_PreCierre", id_detalle: _id_detalle, id_analisis: _id_analisis }, 
					function( data ) {
						if(data.estado == 1){
							f_LoadResultados();
						}
						else{
							alert("Ocurrió un error al momento de realizar el Pre Cierre.");

							return;
						}

					}, "json");
			};
		</script>

		<!-- Otras Funciones -->
		<script type="text/javascript">
			$(document).ajaxStart(function() {
				// Loading Modal
					var modal_loading = $("#divmodal_Loading");
					modal_loading.modal({backdrop: 'static', keyboard: false});
			});

			$(document).ajaxStop(function() {
				// Cerrando Modal
					$('#divmodal_Loading').modal('hide');
			});

			function f_CerrarDiv(accion, nom_div){
				var _div = document.getElementById(nom_div);

				if (accion == 'A'){
					_div.style.display = 'block'
				}
				else{
					_div.style.display = 'none';
				}
			};

			$('#_SwitchEstado').change(function() {
				$("#chk_x").prop('checked', false);

				if ($(this).prop('checked')){
					f_CerrarDiv('C', 'row_Titulo');
					f_CerrarDiv('C', 'row_Buscar');

					$("#titulo_detalle").html('<b>AAS</b> - Visualizando Muestras Pendientes de Pre Cierre');

					f_LoadResultados(1);
				}
				else{
					f_CerrarDiv('A', 'row_Titulo');
					f_CerrarDiv('A', 'row_Buscar');

					$("#titulo_detalle").html('<b>AAS</b> - Visualizando Muestras Pre Cerradas');

					f_LoadResultados(0);
				}
			});

			function f_cerrarModal(pantalla_modal){
				if (pantalla_modal == 1){
					$('#divmodal_Cierre').modal('hide');
				}

				if (pantalla_modal == 2){
					$('#divmodal_AddNewCliente').modal('hide');
				}
			};

			function f_ImagenCierre(_Estado_Cierre){
				var image_orden = $("#cierre_imageorden").val();
			};

			function f_ConvertElemento(_elemento){
				var _return = '';

				if (_elemento == 'CU'){
					_return = 'Cu';
				}

				if (_elemento == 'PB'){
					_return = 'Pb';
				}

				if (_elemento == 'ZN'){
					_return = 'Zn';
				}

				if (_elemento == 'AS'){
					_return = 'As';
				}

				if (_elemento == 'SB'){
					_return = 'Sb';
				}

				if (_elemento == 'S'){
					_return = 'S';
				}

				if (_elemento == 'FE'){
					_return = 'Fe';
				}

				return _return;
			}
		</script>

	</body>
</html>

<?php
	cerrarSesion($enlace);
?>