<?php
  
  session_start();

  include('../../php/conn.php');

  if(!isset($_SESSION["id"])){
    header('Location: index.php');
  }

  mysqli_query($enlace, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");

?>

<!DOCTYPE html>
<html lang="es">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <!-- Meta, title, CSS, favicons, etc. -->
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>LIMS | Pre Cierre Newmont</title>

    <!-- Bootstrap -->
    <link href="../vendors/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
    <!-- Font Awesome -->
    <link href="../vendors/font-awesome/css/font-awesome.min.css" rel="stylesheet">
    <!-- NProgress -->
    <link href="../vendors/nprogress/nprogress.css" rel="stylesheet">
    <!-- iCheck -->
    <link href="../vendors/iCheck/skins/flat/green.css" rel="stylesheet">
    <!-- bootstrap-progressbar -->
    <link href="../vendors/bootstrap-progressbar/css/bootstrap-progressbar-3.3.4.min.css" rel="stylesheet">
    <!-- JQVMap -->
    <link href="../vendors/jqvmap/dist/jqvmap.min.css" rel="stylesheet"/>
    <!-- bootstrap-daterangepicker -->
    <link href="../vendors/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
    <!-- Ion.RangeSlider -->
    <link href="../vendors/normalize-css/normalize.css" rel="stylesheet">
    <link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.css" rel="stylesheet">
    <link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.skinFlat.css" rel="stylesheet">
    <!-- Bootstrap Colorpicker -->
    <link href="../vendors/mjolnic-bootstrap-colorpicker/dist/css/bootstrap-colorpicker.min.css" rel="stylesheet">
    <link href="../vendors/cropper/dist/cropper.min.css" rel="stylesheet">
    <!-- Datatables -->
    <link href="../vendors/datatables.net-bs/css/dataTables.bootstrap.min.css" rel="stylesheet">
    <link href="../vendors/datatables.net-buttons-bs/css/buttons.bootstrap.min.css" rel="stylesheet">
    <link href="../vendors/datatables.net-fixedheader-bs/css/fixedHeader.bootstrap.min.css" rel="stylesheet">
    <link href="../vendors/datatables.net-responsive-bs/css/responsive.bootstrap.min.css" rel="stylesheet">
    <link href="../vendors/datatables.net-scroller-bs/css/scroller.bootstrap.min.css" rel="stylesheet">

    <!-- bootstrap-datetimepicker -->
  	<link href="../vendors/bootstrap-datetimepicker/build/css/bootstrap-datetimepicker.css" rel="stylesheet">

  	<!-- Switchery -->
  	<link href="../vendors/switchery/dist/switchery.min.css" rel="stylesheet">

    <!-- Toggle Switch -->
      <link rel="stylesheet" type="text/css" href="bootstrap/css/bootstrap4-toggle.min.css">

      <!-- Custom Theme Style -->
  	<link href="../build/css/custom.min.css" rel="stylesheet">

  	<script type="text/javascript">
  		let Rack_TotalRows = 0;
      let chkRack_Selected = '';
      let total_grupos = 0;
      let item_MuestraSelected = 0;
      let item_id_newmont_cabecera = 0;
      let item_total_grupos = 0;
      let is_cierre = 0;
  	</script>

    <style type="text/css">
      th {
        position: sticky;
        top: 0px;
        background-color: #12537E;
      }
    </style>
	</head>

	<body class="nav-md" onload="f_LoadResultados(1);" style="zoom: 80%">
		<div class="container body">
  		<div class="main_container">
  			<?php include('partes/sidebar.php'); ?>

  			<!-- page content -->
    		<div class="right_col" role="main">
    			<div class="">
            <div class="row">
              <div class="col-md-9 col-sm-9 col-xs-12">
                <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                  <div class="x_title">
                    <h2>
                      <font style="font-size: 14px"><b>Búsqueda por Fecha de Creación de Rack</b></font>
                    </h2>

                    <div class="clearfix">
                    </div>
                  </div>

                  <div class="x_content" style="margin-bottom: -10px;">
                    <div class="form-group col-md-6 col-sm-6 col-xs-12">
                      <?php
                        date_default_timezone_set("America/Lima"); 
                        $time = date('Y-m-d');

                        echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_inicio" value="'.$time.'"/>';
                      ?>
                    </div>

                    <div class="form-group col-md-6 col-sm-6 col-xs-12">
                      <?php
                        echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_fin" value="'.$time.'"/>';
                      ?>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-md-3 col-sm-3 col-xs-12">
                <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                  <div class="x_title">
                    <h2>
                      <font style="font-size: 14px"><b>por Estado</b></font>
                    </h2>

                    <div class="clearfix">
                    </div>
                  </div>
                  <div class="x_content">
                    <select id="lista_estados" class="form-control" required>
                      <option value="99"> Todos...</option>
                      <option value="0" selected> Pendientes</option>
                      <option value="1"> Cerrados</option>
                    </select>
                  </div>
                </div>
              </div>
            </div>

            <div class="row">
              <div class="col-md-12 col-sm-12 col-xs-12">
                <button class="btn btn-success" type="button" onclick="f_LoadResultados(0)" style="width: 100%; background-color: #26B99A">
                   <b>Ejecutar Búsqueda</b>
                </button>
              </div>
            </div>

    				<div class="row" style="margin-top: 10px">
              <div id="div_listaracks" class="col-md-4 col-sm-4 col-xs-12">
                <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                  <div class="x_title">
                    <div id="div_TituloListaRacks" class="col-md-12 col-sm-12 col-xs-12">
                      <h2>
                        Muestras Newmont
                      </h2>
                    </div>

                    <div class="clearfix">
                    </div>
                  </div>

                  <div class="x_content">
                    <div class="table-box" style="height: 800px; width: 100%; overflow: scroll;">
                      <table class="table table-striped jambo_table bulk_action">
                        <thead>
                          <tr>
                            <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; border-top-left-radius: 15px; width: 50px;"><center>
                                Item
                            </center></th>
                            <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 120px;"><center>
                                Muestra
                            </center></th>
                            <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                Malla
                            </center></th>
                            <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 90px;"><center>
                                Programa
                            </center></th>
                            <th colspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; border-top-right-radius: 15px;"><center>
                                Pre Cierre
                            </center></th>
                          </tr>
                          <tr>
                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                              Usuario
                            </center></th>
                            <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                              Fecha Hora
                            </center></th>
                          </tr>
                        </thead>

                        <tbody id="tbl_Muestras" style="overflow: scroll">
                            
                        </tbody>
                      </table>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-md-8 col-sm-8 col-xs-12">
                <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                  <div class="x_title">
                    <div class="col-md-7 col-sm-7 col-xs-7">
                      <h2 id="titulo_detalle" style="margin-top: 11px;">
                        Visualizando Muestras Newmont Pendientes de Pre Cierre
                      </h2>
                    </div>

                    <div class="form-group col-md-5 col-sm-5 col-xs-5" style="background-color: #D0D2F2; border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                      <label class="control-label col-md-3 col-sm-3 col-xs-12" style="margin-top: 9px; text-align: right; color: #FF0005;">
                        Reanálisis
                      </label>
                      <div id="div_tipoanalisis" class="col-md-7 col-sm-7 col-xs-7" style="margin-top: 19x;">

                      </div>
                    </div>

                    <div class="clearfix">
                    </div>
                  </div>

                  <div class="x_content">
                    <div class="table-box" style="width: 100%; margin-bottom: 20px;">
                      <table class="table table-striped jambo_table bulk_action">
                        <thead>
                          <tr>
                            <th colspan="14" style="text-align: center; border-top-left-radius: 15px; border-top-right-radius: 15px; background-color: #404040; border-color: #ffffff; border: solid; border-width: 1px; border-color: #ffffff;">
                              Muestra Común
                            </td>
                          </tr>

                          <tr>
                            <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 30px;"><center>
                                Item
                            </center></th>
                            <th colspan="3" style="background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                Pesos
                            </center></th>
                            <th colspan="4" style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                Leyes
                            </center></th>
                          </tr>

                          <tr>
                            <th style=" background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                Peso Muestra
                            </center></th>
                            <th style="background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                Peso Doré
                            </center></th>
                            <th style="background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                Peso Oro
                            </center></th>

                            <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                Ley Ag (g/tm)
                            </center></th>
                            <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                Ley Au (g/tm)
                            </center></th>
                            <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                Ley Ag (oz/tc)
                            </center></th>
                            <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                Ley Au (oz/tc)
                            </center></th>
                          </tr>
                        </thead>

                        <tbody id="tbl_MuestraComun" style="overflow: scroll">
                            
                        </tbody>
                      </table>
                    </div>

                    <div class="table-box" style="width: 100%;">
                      <table class="table table-striped jambo_table bulk_action">
                        <thead>
                          <tr>
                            <th id="th_titulo1" colspan="10" style="text-align: center; border-top-left-radius: 15px; border-top-right-radius: 15px; background-color: #404040; border-color: #ffffff; border: solid; border-width: 1px; border-color: #ffffff;">
                              Detalle de Grupos Newmont
                            </th>
                          </tr>

                          <tr>
                            <th rowspan="2" colspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 20px;"><center>
                              N° Grupo
                            </center></th>
                            <th rowspan="2" colspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 220px;"><center>
                              Pesos (g)
                            </center></th>
                            <th colspan="3" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                              Leyes Ag
                            </center></th>
                            <th colspan="3" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center;"><center>
                              Leyes Au
                            </center></th>
                          </tr>

                          <tr>
                            <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #8A75AA; min-width: 20px;"><center>
                              Sel.
                            </center></th>
                            <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #3EB595; min-width: 80px;"><center>
                              Ag (g/tm)
                            </center></th>
                            <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #3EB595; min-width: 80px;"><center>
                              Ag (oz/tc)
                            </center></th>

                            <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #8A75AA; width: 10px;"><center>
                              Sel.
                            </center></th>
                            <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #3EB595; min-width: 80px;"><center>
                              Au (g/tm)
                            </center></th>
                            <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #3EB595; min-width: 80px;"><center>
                              Au (oz/tc)
                            </center></th>
                          </tr>
                        </thead>

                        <tbody id="tbl_GruposNewmont" style="overflow: scroll">
                            
                        </tbody>
                      </table>
                    </div>
                  </div>
                </div>
              </div>
    				</div>
    			</div>
    		</div>
  		</div>
  	</div>

  	<!-- Ventanas Modal -->
  	<div id="divmodal_Loading" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false" style="margin-top: 300px;">
      <div class="modal-dialog" style="height: 200px; opacity: 0.5;"><center>
        <img src="images/loading.gif" width="200px" style="border: solid; border-width: 1px; border-color: #D9D9D9;  border-radius: 15px;"></img>
      </center></div>
    </div>

    <div id="divmodal_DetallesMuestra" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false">
        <div class="modal-dialog" style="width: 35%; margin-top: 12%; margin-left: 28%">
            <!-- Modal content-->
            <div class="modal-content" style="border: solid; border-width: 1px; border-color: #E6E9ED; border-radius: 7px;">
                <div class="modal-header" style="background-color: #282828; color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; border-radius: 7px;">
                    <button type="button" class="close" data-dismiss="modal" style="color: #ffffff;">
                        ×
                    </button>

                    <h4 class="modal-title" id="titulomodal_ClaveClientes"><b>
                        <div class="col-md-5 col-sm-5 col-xs-5" style="width: 200px;">
                            Información de Muestra: 
                        </div>
                        <div class="col-md-7 col-sm-7 col-xs-7" style="margin-left: -15px;">
                            <label id="lbl_TituloMuestra" style="color: #FAF566"> XXXXXX</label>
                        </div>
                    </b></h4>
                </div>

                <div class="modal-body">
                    <table class="table table-striped jambo_table bulk_action">
                        <thead>
                            <tr>
                                <th colspan="3" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; border-top-left-radius: 15px; border-top-right-radius: 15px;">
                                    Detalles de Nuevo Blanco
                                </th>
                            </tr>

                            <tr>
                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; width: 100px;">
                                    Tipo
                                </th>
                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center;">
                                    Factor Ag
                                </th>
                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center;">
                                    Facto Au
                                </th>
                            </tr>
                            <tr>
                                <th id="th_InfoTipoBlanco" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661;">

                                </th>
                                <th id="th_InfoFactorAg" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
                                    
                                </th>
                                <th id="th_InfoFactorAu" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
                                    
                                </th>
                            </tr>
                        </thead>
                    </table>
                </div>

                <div class="modal-footer" style="padding-bottom: 5px; padding-top: 10px; text-align: center; background-color: #565759; border: solid; border-width: 1px; border-color: #E6E9ED; border-radius: 7px;">
                    <div class="col-md-12 col-sm-12 col-xs-12">
                        <button class="btn btn-dark" type="button" onclick="f_cerrarModal(1)" style="background-color: #337ab7">
                            Cerrar
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>

  	<!-- jQuery -->
    <script src="../vendors/jquery/dist/jquery.min.js"></script>
    <!-- Bootstrap -->
    <script src="../vendors/bootstrap/dist/js/bootstrap.min.js"></script>
    <!-- FastClick -->
    <script src="../vendors/fastclick/lib/fastclick.js"></script>
    <!-- NProgress -->
    <script src="../vendors/nprogress/nprogress.js"></script>
    <!-- Ion.RangeSlider -->
  	<script src="../vendors/ion.rangeSlider/js/ion.rangeSlider.min.js"></script>
  	<!-- Bootstrap Colorpicker -->
  	<script src="../vendors/mjolnic-bootstrap-colorpicker/dist/js/bootstrap-colorpicker.min.js"></script>
    <!-- Toggle Switch -->
      <script src="bootstrap/js/bootstrap4-toggle.min.js"></script>
      <!-- Custom Theme Scripts -->
    <script src="../build/js/custom.min.js"></script>

    <!-- bootstrap-daterangepicker -->
    <script src="../vendors/moment/min/moment.min.js"></script>
    <script src="../vendors/bootstrap-daterangepicker/daterangepicker.js"></script><!-- Datatables -->
    <script src="../vendors/datatables.net/js/jquery.dataTables.min.js"></script>
    <script src="../vendors/datatables.net-bs/js/dataTables.bootstrap.min.js"></script>
    <script src="../vendors/datatables.net-buttons/js/dataTables.buttons.min.js"></script>
    <script src="../vendors/datatables.net-buttons-bs/js/buttons.bootstrap.min.js"></script>
    <script src="../vendors/datatables.net-buttons/js/buttons.flash.min.js"></script>
    <script src="../vendors/datatables.net-buttons/js/buttons.html5.min.js"></script>
    <script src="../vendors/datatables.net-buttons/js/buttons.print.min.js"></script>
    <script src="../vendors/datatables.net-fixedheader/js/dataTables.fixedHeader.min.js"></script>
    <script src="../vendors/datatables.net-keytable/js/dataTables.keyTable.min.js"></script>
    <script src="../vendors/datatables.net-responsive/js/dataTables.responsive.min.js"></script>
    <script src="../vendors/datatables.net-responsive-bs/js/responsive.bootstrap.js"></script>
    <script src="../vendors/datatables.net-scroller/js/dataTables.scroller.min.js"></script>
    <script src="../vendors/jszip/dist/jszip.min.js"></script>
    <script src="../vendors/pdfmake/build/pdfmake.min.js"></script>
    <script src="../vendors/pdfmake/build/vfs_fonts.js"></script>

    <!-- Funciones Principales -->
    <script type="text/javascript">
    	function f_LoadResultados(_x){
        let htmlContenido = '';
        let htmlContenido_Detalle = '';
        let i = 1;
        let x = 1; // Ayudará a llevar el Id de inicio de cada grupo de muestras
        let t = 0; // Ayudará a llevar el Total de Muestras por cada grupo de muestras
        let is_PreCierreAg = 0; // Ayudará a reservar si es Pre Cierre Ag
        let is_PreCierreAu = 0; // Ayudará a reservar si es Pre Cierre Au
        let rowspan_analisis = 0;

        // Obteniendo parámetros
          let fecha_inicio = $("#fecha_inicio").val();
          let fecha_fin = $("#fecha_fin").val();
          var cod_estado = $("#lista_estados").val();

          if (_x == 0){
            // Validando ingreso de fechas
              if (fecha_inicio == null){
                alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                return;
              }
              if (fecha_inicio.length == 0){
                alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                return;
              }

              if (fecha_fin == null){
                alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                return;
              }
              if (fecha_fin.length == 0){
                alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                return;
              }

              if (fecha_fin < fecha_inicio){
                alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

                return;
              }
          }

        // Cargando detalle de Análisis
          $("#tbl_Muestras").html(htmlContenido);

        // Loading Modal
          let modal_loading = $("#divmodal_Loading");
          modal_loading.modal({backdrop: 'static', keyboard: false});

        // Carga datos
          let tiene_datos = 0;
          let id_detallerack_x = 0;
          let id_newmont_cabecera = 0;
          let total_grupos_newmont = 0;
          let ci_muestra = '';

          $.get( "../lims_api/index.php", { accion: "get_MuestrasPreCierreNewmont", cod_estado: cod_estado, fecha_inicio: fecha_inicio, fecha_fin: fecha_fin },
            function( data ) {
              if(data.estado == 1){
                $.each( data.registros, function( key, val ) {
                  if (i == 1){
                    tiene_datos = 1;
                    id_detallerack_x = val.Id;
                    id_newmont_cabecera = val.ID_NEWMONT_CABECERA;
                    total_grupos_newmont = val.TOTAL_GRUPOS_NEWMONT;
                    ci_muestra = val.ci_muestra;
                  }

                  htmlContenido += '<tr id="tr_newmont_' + i + '" ' + ((i == 1) ? 'style="background-color: #FFF587;"' : '') + ' onclick="f_LoadMuestrasGruposNewmmont(' + i + ', ' + val.ID_NEWMONT_CABECERA + ', ' + val.TOTAL_GRUPOS_NEWMONT + ", '" + val.ci_muestra + "'" + ')">';

                  htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right; cursor: pointer; ' + ((val.TOTAL_GRUPOS_NEWMONT == val.NUM_POSITIVOS) ? 'background-color: #60BF81; color: #ffffff;' : '') + '">' + i + '</td>';

                  htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer;">' + val.ci_muestra + '</td>';

                  htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center;">' + val.num_malla + '</td>';

                  htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center;">' + val.PROGRAMA_DIARIO + '</td>';

                  // Colocando columnas de Cierre
                    if (val.is_CierreAg_Newmont == 1){
                      htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center;">' + val.cierreAg_NewmontUsuario + '</td>';

                      htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center;">' + val.cierreAg_NewmontFechaHora + '</td>';
                    }
                    else{
                      htmlContenido += '  <td colspan="2" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center; color: #d9534f;">Pendiente</td>';
                    }
                  

                  htmlContenido += "</tr>";

                  i += 1;
                });
              }
              else{
                alert("No se encontraron resultados para la búsqueda solicitada");
              }

              $("#tbl_Muestras").html(htmlContenido);

              // Obteniendo los grupos Newmont por muestra
                if (tiene_datos == 1){
                  f_LoadMuestrasGruposNewmmont(1, id_newmont_cabecera, total_grupos_newmont, ci_muestra);
                }
                else{
                  $("#tbl_GruposNewmont").html('');
                }

              // Cerrando Modal
                $('#divmodal_Loading').modal('hide');

            }, "json");
      };

      function f_LoadMuestrasGruposNewmmont(_item, _id_newmont_cabecera, _total_grupos_newmont, _ci_muestra){
          var htmlContenido = '';
          var htmlContenido_x = '';
          let is_PreCierreAg = 0;
          let is_PreCierreAu = 0;
          let c = 1;

          item_MuestraSelected = _item;
          item_id_newmont_cabecera = _id_newmont_cabecera;
          item_total_grupos = _total_grupos_newmont;

          // Loading Modal
              let modal_loading = $("#divmodal_Loading");
              modal_loading.modal({backdrop: 'static', keyboard: false});

          // Cambiando el Título
              $("#th_titulo1").html('Detalle de Grupos Newmont: <b style="font-size: 16px; color: #F2B705;">' + _ci_muestra + '</b>');

          // Pinta selección
              f_ColorSelected(_item);

          // Carga los datos de la Muestra Común
              $("#tbl_MuestraComun").html(htmlContenido_x);

              $.get( "../lims_api/index.php", { accion: "get_MuestraComunNewmont", id_newmont_cabecera: _id_newmont_cabecera, total_grupos_newmont: _total_grupos_newmont, item: _item },
                  function( data ) {
                      if(data.estado == 1){
                          $.each( data.registros, function( key, val ) {
                              htmlContenido_x += '<tr>';

                              // // Determinando el Color para los Blancos Óxidos
                              //     let color_bf = '';

                              //     if (val.Id_TipoBlancoFundente == 1){
                              //         color_bf = 'background-color: #F2B705; color: #ffffff;';
                              //     }

                              htmlContenido_x += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                              htmlContenido_x += '      ' + c;

                              if (val.ITEM == 2){
                                  htmlContenido_x += '<img src="images/R.png" width="16px;" style="margin-left: 5px;"></img>';
                              }

                              htmlContenido_x += '  </td>';

                              htmlContenido_x += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                              htmlContenido_x += '      ' + val.Peso_Muestra;
                              htmlContenido_x += '  </td>';
                              
                              htmlContenido_x += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                              htmlContenido_x += '      ' + val.Peso_Dore;
                              htmlContenido_x += '  </td>';
                              
                              htmlContenido_x += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                              htmlContenido_x += '      ' + val.Peso_Au;
                              htmlContenido_x += '  </td>';

                              htmlContenido_x += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; ' + ((val.Ley_Ag.length == 0) ? 'color: #FF0005' : '') + '">';
                              htmlContenido_x += '      ' + ((val.Ley_Ag.length == 0) ? 'Sin Ley' : val.Ley_Ag);
                              htmlContenido_x += '  </td>';

                              htmlContenido_x += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; ' + ((val.Ley_Au.length == 0) ? 'color: #FF0005' : '') + '">';
                              htmlContenido_x += '      ' + ((val.Ley_Au.length == 0) ? 'Sin Ley' : val.Ley_Au);
                              htmlContenido_x += '  </td>';
                              
                              htmlContenido_x += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; ' + ((val.Ley_Ag.length == 0) ? 'color: #FF0005' : '') + '">';
                              htmlContenido_x += '      ' + ((val.Ley_Ag.length == 0) ? 'Sin Ley' : val.Ley_Ag_oz);
                              htmlContenido_x += '  </td>';
                              
                              htmlContenido_x += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; ' + ((val.Ley_Au.length == 0) ? 'color: #FF0005' : '') + '">';
                              htmlContenido_x += '      ' + ((val.Ley_Au.length == 0) ? 'Sin Ley' : val.Ley_Au_oz);
                              htmlContenido_x += '  </td>';

                              c += 1;
                          });
                      }
                      else{
                          htmlContenido_x += '<tr>';
                          htmlContenido_x += '    <td colspan="8" style="text-align: center; background-color: #F25050; color: #ffffff;">';
                          htmlContenido_x += '        La Muestra Común aun no ha sido registrada en un Rack';
                          htmlContenido_x += '    </td>';
                          htmlContenido_x += '</tr>';
                      }

                      $("#tbl_MuestraComun").html(htmlContenido_x);

                      // Cerrando Modal
                          $('#divmodal_Loading').modal('hide');

                  }, "json");

          // Carga los datos de Grupos Newmont
              $("#tbl_GruposNewmont").html(htmlContenido);

              $.get( "../lims_api/index.php", { accion: "get_MuestrasGruposNewmont_New", id_newmont_cabecera: _id_newmont_cabecera, total_grupos_newmont: _total_grupos_newmont, item: _item },
                  function( data ) {
                      if(data.estado == 1){
                          is_cierre = data.is_cierre;

                          $("#tbl_GruposNewmont").html(data.html_contenido);
                      }
                      else{
                          alert("No se encontraron resultados para la muestra seleccionada");
                      }

                      // Obteniendo el promedio general por cada grupo de muestras
                        // if (is_cierre == 0){
                          f_CalculaAllNewmonts(_item, data.total_grupos_newmont, _id_newmont_cabecera);
                        // }

                      // Cerrando Modal
                          $('#divmodal_Loading').modal('hide');

                  }, "json");
      };

      function f_SetReanalisis(_id_grupo, _nom_muestra, _id_detallerack, _id_detallerackpesos){
          var _tipo_ensayo = $("#tdReanalisis_" + _id_grupo).val();
          var _nom_tipo_ensayo = $("#tdReanalisis_" + _id_grupo + ' option:selected').text();

          // Validando datos
              if (!confirm("¿Está seguro de realizar un reanálisis de tipo:" + _nom_tipo_ensayo + " para el grupo N° " + _id_grupo + "?")){
                  return;
              }

          // Generando reanálisis
              $.post( "ajax/encuesta.php", { accion: "PreCierreNewmont_ReanalisisNegativos", nom_muestra: _nom_muestra, id_detallerack: _id_detallerack, id_detallerackpesos: _id_detallerackpesos, num_grupo: _id_grupo, tipo_ensayo: _tipo_ensayo },
                  function( data ) {
                      if(data.estado == 1){
                          alert("El reanálisis fue generado satisfactoriamente.\n\nRecuerde que debe ingresar el reanálisis de esta muestra negativa como una muestra normal en el LIMS.");

                          f_LoadMuestrasGruposNewmmont(item_MuestraSelected, item_id_newmont_cabecera, item_total_grupos);
                      }
                      else{
                          alert("Ocurrió un error al momento de grabar los datos");
                      }

                      // Cerrando Modal
                          $('#divmodal_Loading').modal('hide');

                  }, "json");
      };
    </script>

    <!-- Funciones Secundarias -->
    <script type="text/javascript">
        $(function() {
            $('#_SwitchEstado').change(function() {
                if ($(this).prop('checked')){
                    f_CerrarDiv('C', 'row_Titulo');
                    f_CerrarDiv('C', 'row_Buscar');

                    $("#titulo_detalle").html('Visualizando Muestras Newmont Pendientes de Pre Cierre');

                    f_LoadResultados(1);
                }
                else{
                    f_CerrarDiv('A', 'row_Titulo');
                    f_CerrarDiv('A', 'row_Buscar');

                    $("#titulo_detalle").html('Visualizando Muestras Newmont Pre Cerradas');

                    f_LoadResultados(0);
                }
            });
        });

        function f_OpenDetalleMuestra(_nom_muestra, _tipo_blanco, _factor_ag, _factor_au){
            var modal_loading = $("#divmodal_DetallesMuestra");

            // Coloca el Título
                $("#lbl_TituloMuestra").html(_nom_muestra);

            // Agredando información al modal
                $("#th_InfoTipoBlanco").html(_tipo_blanco);
                $("#th_InfoFactorAg").html(_factor_ag);
                $("#th_InfoFactorAu").html(_factor_au);

            modal_loading.modal();
        };

        function f_RowSelected(_tipo, _idrow_inicio, _idrow_total, _id_detallerack, _is_enabled){
            let nomcampo_ley = 'chkRow_Ley';
            let nomcampo_chk = 'chkRow_Selected';
            let nomcampo_Prom = 'rowPromedio_';
            let nomcampo_leyConf = 'chkRow_Ley';
            let nomcampo_Conf = 'chkRow_Conf';
            let nomcampo_PreCierre = 'chkRow_PreCierre';
            let promedio = 0;
            let total = 0;
            let conteo = 0;

            // Setea el prefijo del campo de Ley
                if (_tipo == 1){// Para Ag
                    nomcampo_ley = nomcampo_ley + 'Ag_' + _id_detallerack + '_';
                    nomcampo_chk = nomcampo_chk + 'Ag_';
                    nomcampo_Prom = nomcampo_Prom + 'Ag_';
                    nomcampo_PreCierre = nomcampo_PreCierre + 'Ag_' + _id_detallerack;

                    nomcampo_leyConf = nomcampo_leyConf + 'AgOz_' + _id_detallerack + '_';
                    nomcampo_Conf = nomcampo_Conf + 'Ag_';
                }
                else{//Para Au
                    nomcampo_ley = nomcampo_ley + 'Au_' + _id_detallerack + '_';
                    nomcampo_chk = nomcampo_chk + 'Au_';
                    nomcampo_Prom = nomcampo_Prom + 'Au_';
                    nomcampo_PreCierre = nomcampo_PreCierre + 'Au_' + _id_detallerack;

                    nomcampo_leyConf = nomcampo_leyConf + 'Au_' + _id_detallerack + '_';
                    nomcampo_Conf = nomcampo_Conf + 'Au_';
                }

            // Realiza el bucle de búsqueda
                let x = 1;
                let nomcampo_ley_x = '';
                let nomcampo_chk_x = '';

                let arr_MuestrasConf = [];
                let prom_Conf = 0;

                while (x <= _idrow_total){
                    nomcampo_ley_x = nomcampo_ley + _idrow_inicio;
                    nomcampo_chk_x = nomcampo_chk + _idrow_inicio;
                    nomcampo_leyConf_x = nomcampo_leyConf + _idrow_inicio;

                    // Buscando campos con Check
                        if (document.getElementById(nomcampo_chk_x).checked){
                            total += parseFloat($('#' + nomcampo_ley_x).html());

                            arr_MuestrasConf.push(parseFloat($('#' + nomcampo_leyConf_x).html()));

                            conteo += 1;
                        }

                    x += 1;
                    _idrow_inicio += 1;
                }

            // Calcula el promedio
                promedio = ((conteo == 0) ? '' : total / conteo);

                if (_tipo == 1){// Para Ag
                    if (conteo > 0){
                        promedio = parseFloat(promedio).toFixed(0);
                    }
                }
                else{//Para Au
                    if (conteo > 0){
                        promedio = parseFloat(promedio).toFixed(2);
                    }
                }

                $("#" + nomcampo_Prom + _id_detallerack).html(promedio);

            // Colocando datos de Conf.
                prom_Conf = f_CalculaAllConf(arr_MuestrasConf);
                $("#" + nomcampo_Conf + _id_detallerack).html(prom_Conf);

            // Pintando Celdas de Conf.
                let color_bk = '';

                if (prom_Conf <= 0.5){
                    $("#" + nomcampo_Conf + _id_detallerack).css("background-color", "#00C756");
                }
                if (prom_Conf > 0.5 && prom_Conf < 1){
                    $("#" + nomcampo_Conf + _id_detallerack).css("background-color", "#FEB71B");
                }
                if (prom_Conf >= 1){
                    $("#" + nomcampo_Conf + _id_detallerack).css("background-color", "#FF2F1E");
                }

            // Inhabilitando Check de Cierre
                if (_is_enabled == 1){
                    if (conteo == 0){
                        $("#" + nomcampo_PreCierre).prop('checked', false);
                        $("#" + nomcampo_PreCierre).prop('disabled', 'true');
                    }
                    else{
                        $("#" + nomcampo_PreCierre).prop('disabled', '');
                    }
                }
        };

        function f_CalculaAllNewmonts(_item, _total_grupos, _id_newmont_cabecera){
            let x = 1;
            let g = 1;
            let _objectAg = '';
            let _objectAu = '';
            let _objectLeyAg = '';
            let _objectLeyAu = '';
            let _total_P_Ag = 0;
            let _total_N_Ag = 0;
            let _total_P_Au = 0;
            let _total_N_Au = 0;
            let _total_N_Temp = 0;
            let _count_Ag = 0;
            let _count_Au = 0;
            let _pesoP_Muestra = 0;
            let _pesoN_Muestra = 0;
            let _peso_Muestra = 0;
            let _newmont_Ag = 0;
            let _newmont_Au= 0;

            let _total_pesoP_Muestra = 0;
            let _total_pesoN_Muestra = 0;
            let _total_newmont_P_Ag = 0;
            let _total_newmont_N_Ag = 0;
            let _total_newmont_P_Au = 0;
            let _total_newmont_N_Au = 0;
            let _count_Group_P_Ag = 0;
            let _count_Group_N_Ag = 0;
            let _count_Group_P_Au = 0;
            let _count_Group_N_Au = 0;

            let _isChecked_P = 0;
            let _isChecked_N = 0;

            let _total_grupos_condatos = 0;

            if (_total_grupos == 0){
                _total_grupos = total_grupos;
            }
            else{
                total_grupos = _total_grupos;
            }

            while (g <= _total_grupos){
                x = 1;
                _total_P_Ag = 0;
                _total_N_Ag = 0;
                _total_P_Au = 0;
                _total_N_Au = 0;

                _count_Ag = 0;
                _count_Au = 0;

                // Buscando los Checks dentro de cada grupo
                while (x <= 100)
                {
                    // Verificando los datos de Ag
                        _objectAg = '#chkRow_SelectedAg_' + g + '_' + ((x == 1) ? 'P' : 'N') + '_' + x;
                        _objectLeyAg = '#tdLey_Ag_' + g + '_' + x;

                        if (x == 1){
                            _pesoP_Muestra = ((isNaN($('#tdPeso_P_' + g).html())) ? 0 : parseFloat($('#tdPeso_P_' + g).html()));
                            _pesoN_Muestra = ((isNaN($('#tdPeso_N_' + g).html())) ? 0 : parseFloat($('#tdPeso_N_' + g).html()));

                            // Acumulando los pesos para el cálculo general
                                _total_pesoP_Muestra += _pesoP_Muestra;
                                _total_pesoN_Muestra += _pesoN_Muestra;

                                if (_pesoP_Muestra > 0){
                                    _total_grupos_condatos += 1;
                                }                                    
                        }

                        if ($(_objectAg).html() == undefined){
                            break;
                        }
                        else{
                            if ($(_objectAg).prop('checked')){
                                if (x == 1){
                                    _total_P_Ag += parseFloat($(_objectLeyAg).html());

                                    // _pesoP_Muestra = parseFloat($('#tdPeso_P_' + g).html());

                                    _isChecked_P = 1;

                                    // Para el cálculo general
                                        _total_newmont_P_Ag += _total_P_Ag;
                                        _count_Group_P_Ag += 1;
                                }
                                else{
                                    if (x == 2){
                                        // _pesoN_Muestra = parseFloat($('#tdPeso_N_' + g).html());
                                    }

                                    _total_N_Temp = parseFloat($(_objectLeyAg).html());

                                    if (!isNaN(_total_N_Temp)){
                                        _total_N_Ag += _total_N_Temp;

                                        _count_Ag += 1;

                                        _isChecked_N = 1;

                                        // Para el cálculo general
                                            _total_newmont_N_Ag += _total_N_Temp;
                                            _count_Group_N_Ag += 1;
                                    }
                                }
                            }
                            else{
                                if (x == 1){
                                    _total_P_Ag = null;
                                }
                            }
                        }

                        if (_isChecked_P == 0){
                            _total_P_Ag = null;
                        }

                        if (_isChecked_N == 0){
                            _total_N_Ag = null;
                        }

                    // Verificando los datos de Au
                        _objectAu = '#chkRow_SelectedAu_' + g + '_' + ((x == 1) ? 'P' : 'N') + '_' + x;
                        _objectLeyAu = '#tdLey_Au_' + g + '_' + x;

                        if ($(_objectAu).html() == undefined){
                            break;
                        }
                        else{
                            if ($(_objectAu).prop('checked')){
                                if (x == 1){
                                    _total_P_Au += parseFloat($(_objectLeyAu).html());

                                    // _pesoP_Muestra = parseFloat($('#tdPeso_P_' + g).html());

                                    // Para el cálculo general
                                        _total_newmont_P_Au += _total_P_Au;
                                        _count_Group_P_Au += 1;
                                }
                                else{
                                    if (x == 2){
                                        // _pesoN_Muestra = parseFloat($('#tdPeso_N_' + g).html());
                                    }

                                    _total_N_Temp = parseFloat($(_objectLeyAu).html());

                                    if (!isNaN(_total_N_Temp)){
                                        _total_N_Au += _total_N_Temp;

                                        _count_Au += 1;

                                        // Para el cálculo general
                                            _total_newmont_N_Au += _total_N_Temp;
                                            _count_Group_N_Au += 1;
                                    }
                                }
                            }
                            else{
                                if (x == 1){
                                    _total_P_Au = null;
                                }
                            }
                        }
                        
                    x += 1;
                }

                // Calculando Ley Newmont
                    // 1. Obteniendo el peso Total de la muestra
                        _peso_Muestra = _pesoP_Muestra + _pesoN_Muestra;

                    // 2. Obteniendo el Promedio de los Negativos 
                        _total_N_Ag = (_total_N_Ag / (_count_Ag));
                        _total_N_Au = (_total_N_Au / (_count_Au));

                    // 3. Obteniendo la Ley Newmont
                        _newmont_Ag = ((_total_P_Ag == null) ? 'Error' : parseFloat(((_pesoP_Muestra * _total_P_Ag) + (_pesoN_Muestra * _total_N_Ag)) / _peso_Muestra).toFixed(0));
                        _newmont_Au = ((_total_P_Au == null) ? 'Error' : parseFloat(((_pesoP_Muestra * _total_P_Au) + (_pesoN_Muestra * _total_N_Au)) / _peso_Muestra).toFixed(2));

                        if (_newmont_Ag == 'Error' || _count_Ag == 0 || isNaN(_newmont_Ag)){
                            $("#newmont_Ag_" + g).html('Error');
                            $("#newmont_AgOz_" + g).html('Error');
                        }
                        else{
                            $("#newmont_Ag_" + g).html(_newmont_Ag);
                            $("#newmont_AgOz_" + g).html(parseFloat(_newmont_Ag / 34.285).toFixed(2));

                            $("#btn_CierreAg").show();
                        }

                        if (_newmont_Au == 'Error' || _count_Au == 0 || isNaN(_newmont_Au)){
                            $("#newmont_Au_" + g).html('Error');
                            $("#newmont_AuOz_" + g).html('Error');

                            $("#btn_CierreAg").hide();
                        }
                        else{
                            $("#newmont_Au_" + g).html(_newmont_Au);
                            $("#newmont_AuOz_" + g).html(parseFloat(_newmont_Au / 34.285).toFixed(2));
                        }

                g += 1;
            }

            // Setea los resultados generales del Newmont
              if (is_cierre == 0){
                if ($("#newmont_Peso_P").val().length == 0){
                    $("#newmont_Peso_P").val(parseFloat(_total_pesoP_Muestra / _total_grupos_condatos).toFixed(2));
                    $("#newmont_Peso_N").val(parseFloat(_total_pesoN_Muestra / _total_grupos_condatos).toFixed(2));
                    $("#newmont_Peso").val(parseFloat(parseFloat($("#newmont_Peso_P").val()) + parseFloat($("#newmont_Peso_N").val())).toFixed(2));
                }

                if (parseFloat(_total_newmont_P_Ag / _count_Group_P_Ag).toFixed() < 1){
                  $("#newmont_Ag_P").val(1);

                  $("#newmont_AgOz_P").val(parseFloat(1 / 34.285).toFixed(2));
                }
                else{
                  $("#newmont_Ag_P").val(parseFloat(_total_newmont_P_Ag / _count_Group_P_Ag).toFixed());

                  $("#newmont_AgOz_P").val(parseFloat((parseFloat(_total_newmont_P_Ag / _count_Group_P_Ag).toFixed()) / 34.285).toFixed(2));
                }
                // $("#newmont_Ag_P").val(parseFloat(_total_newmont_P_Ag / _count_Group_P_Ag).toFixed());
                // $("#newmont_AgOz_P").val(parseFloat((parseFloat(_total_newmont_P_Ag / _count_Group_P_Ag).toFixed()) / 34.285).toFixed(2));

                if (parseFloat(_total_newmont_N_Ag / _count_Group_N_Ag).toFixed() < 1){
                  $("#newmont_Ag_N").val(1);

                  $("#newmont_AgOz_N").val(parseFloat(1 / 34.285).toFixed(2));
                }
                else{
                  $("#newmont_Ag_N").val(parseFloat(_total_newmont_N_Ag / _count_Group_N_Ag).toFixed());

                  $("#newmont_AgOz_N").val(parseFloat((parseFloat(_total_newmont_N_Ag / _count_Group_N_Ag).toFixed()) / 34.285).toFixed(2));
                }
                // $("#newmont_Ag_N").val(parseFloat(_total_newmont_N_Ag / _count_Group_N_Ag).toFixed());
                // $("#newmont_AgOz_N").val(parseFloat((parseFloat(_total_newmont_N_Ag / _count_Group_N_Ag).toFixed()) / 34.285).toFixed(2));

                if (parseFloat(_total_newmont_P_Au / _count_Group_P_Au).toFixed() < 0.15){
                  $("#newmont_Au_P").val(0.15);

                  $("#newmont_AuOz_P").val(parseFloat(0.15 / 34.285).toFixed(2));
                }
                else{
                  $("#newmont_Au_P").val(parseFloat(_total_newmont_P_Au / _count_Group_P_Au).toFixed(2));

                  $("#newmont_AuOz_P").val(parseFloat((parseFloat(_total_newmont_P_Au / _count_Group_P_Au).toFixed()) / 34.285).toFixed(2));
                }
                // $("#newmont_Au_P").val(parseFloat(_total_newmont_P_Au / _count_Group_P_Au).toFixed(2));
                // $("#newmont_AuOz_P").val(parseFloat((parseFloat(_total_newmont_P_Au / _count_Group_P_Au).toFixed(2)) / 34.285).toFixed(2));

                if (parseFloat(_total_newmont_N_Au / _count_Group_N_Au).toFixed() < 0.15){
                  $("#newmont_Au_N").val(0.15);

                  $("#newmont_AuOz_N").val(parseFloat(0.15 / 34.285).toFixed(2));
                }
                else{
                  $("#newmont_Au_N").val(parseFloat(_total_newmont_N_Au / _count_Group_N_Au).toFixed(2));

                  $("#newmont_AuOz_N").val(parseFloat((parseFloat(_total_newmont_N_Au / _count_Group_N_Au).toFixed()) / 34.285).toFixed(2));
                }
                // $("#newmont_Au_N").val(parseFloat(_total_newmont_N_Au / _count_Group_N_Au).toFixed(2))
                // $("#newmont_AuOz_N").val(parseFloat((parseFloat(_total_newmont_N_Au / _count_Group_N_Au).toFixed(2)) / 34.285).toFixed(2));

                // Calculando Newmont
                    var _total_P_Peso = parseFloat(_total_pesoP_Muestra / _total_grupos_condatos).toFixed(2);
                    var _total_N_Peso = parseFloat(_total_pesoN_Muestra / _total_grupos_condatos).toFixed(2);
                    var _total_Peso = parseFloat(_total_P_Peso) + parseFloat(_total_N_Peso);

                    var _totalNewmont_P_Ag = $("#newmont_Ag_P").val();
                    var _totalNewmont_N_Ag = $("#newmont_Ag_N").val();
                    var _totalNewmont_P_Au = $("#newmont_Au_P").val();
                    var _totalNewmont_N_Au = $("#newmont_Au_N").val();

                    var _totalNewmont_Ag = parseFloat(((_totalNewmont_P_Ag * _total_P_Peso) + (_totalNewmont_N_Ag * _total_N_Peso)) / _total_Peso).toFixed();
                    var _totalNewmont_Au = parseFloat(((_totalNewmont_P_Au * _total_P_Peso) + (_totalNewmont_N_Au * _total_N_Peso)) / _total_Peso).toFixed(2);

                // Pintando Resultados Newmont
                    if (isNaN(_totalNewmont_Ag)){
                        $("#newmont_Ag").val('Error');

                        $("#btn_CierreAg").hide();
                    }
                    else{
                        $("#newmont_Ag").val(((_totalNewmont_Ag < 1) ? 1 : _totalNewmont_Ag));

                        $("#btn_CierreAg").show();

                        if (isNaN(_totalNewmont_Au)){
                            $("#newmont_Au").val('Error');

                            $("#btn_CierreAg").hide();
                        }
                        else{
                            $("#newmont_Au").val(((_totalNewmont_Au < 0.15) ? 0.15 : _totalNewmont_Au));

                            $("#btn_CierreAg").show();
                        }
                    }

                    // $("#newmont_Ag").val(((isNaN(_totalNewmont_Ag)) ? 'Error' : _totalNewmont_Ag));
                    // $("#newmont_Au").val(((isNaN(_totalNewmont_Au)) ? 'Error' : _totalNewmont_Au));
                    $("#newmont_AgOz").val(((isNaN(_totalNewmont_Ag)) ? 'Error' : parseFloat(((_totalNewmont_Ag < 1) ? 1 : _totalNewmont_Ag) / 34.285).toFixed(2)));
                    $("#newmont_AuOz").val(((isNaN(_totalNewmont_Au)) ? 'Error' : parseFloat(((_totalNewmont_Au < 0.15) ? 0.15 : _totalNewmont_Au) / 34.285).toFixed(2)));
              }

            // Setea la lista de Reanálisis
                $html_reanalisis = '<select id="lista_tipoanalisis" class="form-control" style="width: 100%;" onchange="f_EjecutaReanalisis(' + _item + ', ' + _id_newmont_cabecera + ')">';

                if (_total_grupos == 2){
                    $html_reanalisis += '   <option selected="true" value="0">Elija una opción...</option>';
                    $html_reanalisis += '   <option value="2">Lote (Duplicado)</option>';
                    $html_reanalisis += '   <option value="1">Reconocimiento (Simple)</option>';
                }
                if (_total_grupos == 3){
                    $html_reanalisis += '   <option selected="true" value="0">Elija una opción...</option>';
                    $html_reanalisis += '   <option value="1">Reconocimiento (Simple)</option>';
                }
                if (_total_grupos == 4){
                    $html_reanalisis += '    <option selected value="0">Esta muestra ya cuenta con 4 grupos Newmont</option>';
                }

                $html_reanalisis += '</select>';

                $("#div_tipoanalisis").html($html_reanalisis);

            // Validando si es un Análisis Cerrado
                if (is_cierre == 1){
                    $("#newmont_Peso_P").prop('disabled', true);
                    $("#newmont_Peso").prop('disabled', true);
                    $("#newmont_Ag_P").prop('disabled', true);
                    $("#newmont_Ag_N").prop('disabled', true);
                    $("#newmont_Au_P").prop('disabled', true);
                    $("#newmont_Au_N").prop('disabled', true);
                    $("#newmont_Comentarios").prop('disabled', true);

                    $("#tr_tituloresultado").css('background-color', '#d9534f');
                    $("#td_tituloresultado").html('ANALISIS CERRADO');
                }
        };

        function f_CalculaNewmont_Manual(){
            let _manual_PesoP = $("#newmont_Peso_P").val();
            let _manual_PesoN = $("#newmont_Peso_N").val();
            let _manual_Peso = $("#newmont_Peso").val();
            let _manual_P_LeyAg = $("#newmont_Ag_P").val();
            let _manual_P_LeyAu = $("#newmont_Au_P").val();
            let _manual_N_LeyAg = $("#newmont_Ag_N").val();
            let _manual_N_LeyAu = $("#newmont_Au_N").val();

            let _manual_NewmontAg = 0;
            let _manual_NewmontAu = 0;

            // Validando ingreso de datos
                if (_manual_PesoP.trim().length == 0){
                    _manual_NewmontAg = 'Error';
                    _manual_NewmontAu = 'Error';
                }
                if (_manual_PesoN.trim().length == 0){
                    _manual_NewmontAg = 'Error';
                    _manual_NewmontAu = 'Error';
                }
                if (_manual_Peso.trim().length == 0){
                    _manual_NewmontAg = 'Error';
                    _manual_NewmontAu = 'Error';
                }

                if (_manual_P_LeyAg.trim().length == 0){
                    $("#newmont_AgOz_P").val('');

                    _manual_NewmontAg = 'Error';
                }
                else{
                    $("#newmont_AgOz_P").val(parseFloat(_manual_P_LeyAg / 34.285).toFixed(2));
                }

                if (_manual_N_LeyAg.trim().length == 0){
                    $("#newmont_AgOz_N").val('Error');

                    _manual_NewmontAg = 'Error';
                }
                else{
                    $("#newmont_AgOz_N").val(parseFloat(_manual_N_LeyAg / 34.285).toFixed(2));
                }

                if (_manual_P_LeyAu.trim().length == 0){
                    $("#newmont_AuOz_P").val('');

                    _manual_NewmontAu = 'Error';
                }
                else{
                    $("#newmont_AuOz_P").val(parseFloat(_manual_P_LeyAu / 34.285).toFixed(2));
                }

                if (_manual_N_LeyAu.trim().length == 0){
                    $("#newmont_AuOz_N").val('Error');

                    _manual_NewmontAu = 'Error';
                }
                else{
                    $("#newmont_AuOz_N").val(parseFloat(_manual_N_LeyAu / 34.285).toFixed(2));
                }

            // Calculando Newmont
                // MAX (05/07/2021 13:6): Se cambió el cálculo, se dejó de calcular el Peso Total Newmont y ahora se calcula el Peso Negativo Newmont restando el Peso total con el Pedo Positivo.
                    // _manual_Peso = parseFloat(_manual_PesoP) + parseFloat(_manual_PesoN);
                    // $("#newmont_Peso").val(_manual_Peso);
                _manual_PesoN = parseFloat(_manual_Peso) - parseFloat(_manual_PesoP);
                $("#newmont_Peso_N").val(parseFloat(_manual_PesoN).toFixed(2));

                

                if (_manual_NewmontAg != 'Error'){
                    _manual_NewmontAg = parseFloat(((_manual_PesoP * _manual_P_LeyAg) + (_manual_PesoN * _manual_N_LeyAg)) / _manual_Peso).toFixed();

                    $("#newmont_AgOz").val(parseFloat(_manual_NewmontAg / 34.285).toFixed(2));
                }
                else{
                    $("#newmont_AgOz").val(_manual_NewmontAg);
                }

                if (_manual_NewmontAu != 'Error'){
                    _manual_NewmontAu = parseFloat(((_manual_PesoP * _manual_P_LeyAu) + (_manual_PesoN * _manual_N_LeyAu)) / _manual_Peso).toFixed(2);

                    $("#newmont_AuOz").val(parseFloat(_manual_NewmontAu / 34.285).toFixed(2));
                }
                else{
                    $("#newmont_AuOz").val(_manual_NewmontAu);
                }

                // Pintando Resultados Newmont
                    if (_manual_NewmontAg == 'Error'){
                        $("#newmont_Ag").val('Error');

                        $("#btn_CierreAg").hide();
                    }
                    else{
                        $("#newmont_Ag").val(_manual_NewmontAg);

                        $("#btn_CierreAg").show();

                        if (_manual_NewmontAu == 'Error'){
                            $("#newmont_Au").val('Error');

                            $("#btn_CierreAg").hide();
                        }
                        else{
                            $("#newmont_Au").val(_manual_NewmontAu);

                            $("#btn_CierreAg").show();
                        }
                    }
        };

        function f_CalculaAllConf(_arr_Muestras){
            let m = 0;
            let min = 0;
            let max = 0;

            _arr_Muestras.sort();

            min = _arr_Muestras[0];
            max = _arr_Muestras[_arr_Muestras.length - 1];

            return Math.abs(parseFloat(max - min).toFixed(2));
        };

        function f_ColorSelected(_item){
            var i = 1;

            // Recorre los Tr de la tabla y los limpia
                $("#tbl_Muestras tr").each(function () {
                    $("#tr_newmont_" + i).css('background-color', '');

                    i += 1;
                });

            // Seteando item seleccionado
                $("#tr_newmont_" + _item).css('background-color', '#FFF587');
        };
    </script>

    <!-- Funciones para Grabar -->
    <script type="text/javascript">
          function f_EjecutaReanalisis(_item, _id_newmont_cabecera){
              let _tipo_ensayo = $("#lista_tipoanalisis").val();
              let _tipo_ensayo_des = $("#lista_tipoanalisis option:selected").text();
              var _total_grupos = 0;

              if (_tipo_ensayo == 0){
                  return;
              }

              if (!confirm("¿Está seguro de realizar un reanálisis por: " + _tipo_ensayo_des + " a la Muestra seleccionada?")){
                  return;
              }

              // Loading Modal
                  let modal_loading = $("#divmodal_Loading");
                  modal_loading.modal({backdrop: 'static', keyboard: false});

              // Guarda los datos de Pre Cierre
                  $.get( "../lims_api/index.php", { accion: "grabar_ReanalisisNewmont", id_newmont_cabecera: _id_newmont_cabecera, tipo_ensayo: _tipo_ensayo },
                      function( data ) {
                          if(data.estado != 1){
                              alert("Ocurrió un error al momento de realizar el Reanálisis.");
                          }
                          else{
                              _total_grupos = parseFloat(parseFloat(total_grupos) + parseFloat(_tipo_ensayo));

                              f_LoadMuestrasGruposNewmmont(_item, _id_newmont_cabecera, _total_grupos);

                              // Cambiando el evento onClick del tr de Muestras Newmont
                                  $("#tr_newmont_" + _item).attr("onclick","f_LoadMuestrasGruposNewmmont(" + _item + ", " + _id_newmont_cabecera + ", " + _total_grupos + ")");
                          }

                          // Cerrando Modal
                              $('#divmodal_Loading').modal('hide');

                      }, "json");
          };

    	function f_PreCierre(){
              let i = 1;
              let precierreAg = 0;
              let precierreAu = 0;
              let nomcampo_PreCierreProm = 'rowPromedio_';
              let nomcampo_PreCierreConf = 'chkRow_Conf';
              let nomcampo_PreCierre = 'chkRow_PreCierre';
              let nomcampo_Selected = 'chkRow_Selected';
              let nomcampo_PreCierreProm_x = '';
              let nomcampo_PreCierreConf_x = '';
              let nomcampo_PreCierre_x = '';
              let nomcampo_Selected_x = '';
              var _id_detallerack_r = '';
              var _id_detallerack_r_x = '';
              let leyPromedio = 0;
              let Conf = 0;
              let finish = 0;
              let finish_x = 1;
              let arr_PreCierre = [];

              if (!confirm("¿Está seguro de iniciar con el Pre Cierre de las muestras seleccionadas?")){
                  return;
              }

              // Obtiene el total de filas
                  finish = $('#tbl_GruposNewmont tr').length;
                  finish = finish * 2;

              $('#tbl_GruposNewmont tr').each(function () {
                  _id_detallerack_r = $(this).attr('id');

                  // Si es Newmont Positivo le quita la "N" al Id
                      _id_detallerack_r = ((_id_detallerack_r.substring(0, 1) == 'N') ? _id_detallerack_r.substring(1) : _id_detallerack_r);

                  // Loading Modal
                      let modal_loading = $("#divmodal_Loading");
                      modal_loading.modal({backdrop: 'static', keyboard: false});

                  // Busca los Checks de Pre Cierres
                      if (_id_detallerack_r_x != _id_detallerack_r){
                          // Verifica los cierres para Ag y Au
                              var c = 1;

                              while (c <= 2){
                                  nomcampo_PreCierre_x = nomcampo_PreCierre + ((c == 1) ? 'Ag_' : 'Au_') + _id_detallerack_r;
                                  nomcampo_PreCierreProm_x = nomcampo_PreCierreProm + ((c == 1) ? 'Ag_' : 'Au_') + _id_detallerack_r;
                                  nomcampo_PreCierreConf_x = nomcampo_PreCierreConf + ((c == 1) ? 'Ag_' : 'Au_') + _id_detallerack_r;

                                  leyPromedio = $("#" + nomcampo_PreCierreProm_x).html().trim();
                                  Conf = $("#" + nomcampo_PreCierreConf_x).html().trim();

                                  if ($("#" + nomcampo_PreCierre_x).prop('checked')){
                                      arr_PreCierre.push($("#td_iddetallerackpesos_" + i).html().trim());

                                      // Guarda los datos de Pre Cierre
                                          $.get( "../lims_api/index.php", { accion: "grabar_PreCierre", id_detallerack: _id_detallerack_r, elemento: ((c == 1) ? 'Ag' : 'Au'), ley_promedio: leyPromedio, conf: Conf },
                                              function( data ) {
                                                  if(data.estado != 1){
                                                      alert("Ocurrió un error al momento de grabar el Pre Cierre.\n\nCódigo de error: " + _id_detallerack_r);
                                                  }

                                              }, "json");
                                  }

                                  c += 1;
                              }
                      }

                  i += 1;
              });

              // Valida que haya al menos un Check de Pre Cierre
                  if (arr_PreCierre.length == 0){
                      alert('No se encontraron registros con Check de Pre Cierre');

                      // Cerrando Modal
                          $('#divmodal_Loading').modal('hide');

                      return;
                  }

              // Busca los Checks para el cálculo de Promedios y Conf.
                  i = 1;

                  $('#tbl_GruposNewmont tr').each(function () {
                      var r = 1;
                      var is_Checked = 0;
                      let _id_detallerackpesos = $("#td_iddetallerackpesos_" + i).html().trim();

                      while (r <= 2){
                          is_Checked = 0;
                          nomcampo_Selected_x = nomcampo_Selected + ((r == 1) ? 'Ag_' : 'Au_') + i;

                          if ($("#" + nomcampo_Selected_x).prop('checked')){
                              is_Checked = 1;
                          }

                          // Guarda los datos de Checks
                              $.get( "../lims_api/index.php", { accion: "grabar_PreCierreItemSelected", id_detallerackpesos: _id_detallerackpesos, elemento: ((r == 1) ? 'Ag' : 'Au'), is_checked: is_Checked },
                                  function( data ) {
                                      if(data.estado != 1){
                                          alert("Ocurrió un error al momento de grabar el estado de Checks de los Item.\n\nCódigo de error: " + i + '|' + _id_detallerackpesos);
                                      }
                                      else{
                                          if (finish == finish_x){
                                              f_LoadResultados(1);
                                          }

                                          finish_x += 1;
                                      }

                                      // // Cerrando Modal
                                      //     $('#divmodal_Loading').modal('hide');

                                  }, "json");

                          r += 1;
                      }

                      _id_detallerack_r_x = _id_detallerack_r;

                      i += 1;
                  });
          };

          function f_ReabrirNewmont(_id_cabecera){
              if (!confirm("¿Está seguro de reabrir el Cierre?")){
                  return;
              }

              $.get( "../lims_api/index.php", { accion: "reabrir_Newmont", id_cabecera: _id_cabecera },
                  function( data ) {
                      if(data.estado != 1){
                          alert("Ocurrió un error al momento de Reabrir el cierre.");
                      }
                      else{
                          f_LoadMuestrasGruposNewmmont(item_MuestraSelected, item_id_newmont_cabecera, item_total_grupos);
                      }

                  }, "json");
          };

          function f_CierreNewmont(){
              // Obteniendo datos de Newmont
                  var _peso_total = $("#newmont_Peso").val();
                  var _peso_P = $("#newmont_Peso_P").val();
                  var _peso_N = $("#newmont_Peso_N").val();

                  var _ley_Ag_Newmont = $("#newmont_Ag").val();
                  var _ley_Ag_P = $("#newmont_Ag_P").val();
                  var _ley_Ag_N = $("#newmont_Ag_N").val();
                  var _ley_Ag_Newmont_oz = $("#newmont_AgOz").val();
                  var _ley_Ag_P_oz = $("#newmont_AgOz_P").val();
                  var _ley_Ag_N_oz = $("#newmont_AgOz_N").val();

                  var _ley_Au_Newmont = $("#newmont_Au").val();
                  var _ley_Au_P = $("#newmont_Au_P").val();
                  var _ley_Au_N = $("#newmont_Au_N").val();
                  var _ley_Au_Newmont_oz = $("#newmont_AuOz").val();
                  var _ley_Au_P_oz = $("#newmont_AuOz_P").val();
                  var _ley_Au_N_oz = $("#newmont_AuOz_N").val();

                  var _comentario = $("#newmont_Comentarios").val().trim();

              // Arma el Array de checks de Ag
                  var c = 1;
                  var n = 1;
                  var chk_positivoAg = '';
                  var chk_positivoAu = '';
                  var chk_negativoAg = '';
                  var chk_negativoAu = '';
                  var arr_Ag = '';
                  var arr_Au = '';

                  // 1. Busca check Positivo en Ag
                      while (c <= item_total_grupos){
                          // 2. Obtiene los valores de los Checks Positivos de Ag y Au
                              chk_positivoAg = $("#chkRow_SelectedAg_" + c + "_P_1").prop('checked');

                              chk_positivoAu = $("#chkRow_SelectedAu_" + c + "_P_1").prop('checked');

                          // 3. Armma los Arrays de Positivos
                              if (chk_positivoAg){
                                  arr_Ag += $("#idrow_" + c + "_P_1").html().trim() + ', ';
                              }

                              if (chk_positivoAu){
                                  arr_Au += $("#idrow_" + c + "_P_1").html().trim() + ', ';
                              }

                          // 4. Obtiene los valores de los Checks Negativos de Ag y Au
                              n = 1;

                              while (n <= 15){
                                  chk_negativoAg = $("#chkRow_SelectedAg_" + c + "_N_" + n).prop('checked');

                                  chk_negativoAu = $("#chkRow_SelectedAu_" + c + "_N_" + n).prop('checked');

                                  // 5. Armma los Arrays de Negativos
                                      if (chk_negativoAg){
                                          arr_Ag += $("#idrow_" + c + "_N_" + n).html().trim() + ', ';
                                      }

                                      if (chk_negativoAu){
                                          arr_Au += $("#idrow_" + c + "_N_" + n).html().trim() + ', ';
                                      }

                                  n += 1;
                              }
                              

                          c += 1;
                      }

                  // 6. Setea los Arrays
                      arr_Ag = arr_Ag.substr(0, arr_Ag.length - 2);
                      arr_Au = arr_Au.substr(0, arr_Au.length - 2);

              // Grabando datos
                  $.get( "../lims_api/index.php", { accion: "cierre_ResultadosNewmont", id_newmont_cabecera: item_id_newmont_cabecera,
                      peso_total: _peso_total,
                      peso_P: _peso_P,
                      peso_N: _peso_N,
                      ley_Ag_Newmont: _ley_Ag_Newmont,
                      ley_Ag_P: _ley_Ag_P,
                      ley_Ag_N: _ley_Ag_N,
                      ley_Ag_Newmont_oz: _ley_Ag_Newmont_oz,
                      ley_Ag_P_oz: _ley_Ag_P_oz,
                      ley_Ag_N_oz: _ley_Ag_N_oz,
                      ley_Au_Newmont: _ley_Au_Newmont,
                      ley_Au_P: _ley_Au_P,
                      ley_Au_N: _ley_Au_N,
                      ley_Au_Newmont_oz: _ley_Au_Newmont_oz,
                      ley_Au_P_oz: _ley_Au_P_oz,
                      ley_Au_N_oz: _ley_Au_N_oz,
                      comentario: _comentario,
                      arr_Ag: arr_Ag,
                      arr_Au: arr_Au },
                  function( data ) {
                      if(data.estado != 1){
                          alert("Ocurrió un error al momento de realizar el Cierre Newmont.");
                      }
                      else{
                          f_LoadResultados(1);
                      }

                  }, "json");
          }
    </script>

    <!-- Otras Funciones -->
    <script type="text/javascript">
          function f_cerrarModal(pantalla_modal){
              if (pantalla_modal == 1){
                  $('#divmodal_DetallesMuestra').modal('hide');
              }
              if (pantalla_modal == 2){
                  $('#divmodal_DetallesRack').modal('hide');
              }
          };

          function f_CerrarDiv(accion, nom_div){
              var _div = document.getElementById(nom_div);

              if (accion == 'A'){
                  _div.style.display = 'block'
              }
              else{
                   _div.style.display = 'none';
              }
          };

          // Limpia los datos al momento de Realizar la búsqueda de resultados
          function f_Limpiar(){
              // // Detalles del Rack
              //     $("#lblRack_totalmuestras").html('');
              //     $("#lblRack_usuario").html('');
              //     $("#lblRack_fechahora").html('');
              //     $("#lblRack_horno").html('');
              //     $("#lblRack_observacion").html('');
              //     document.getElementById('lblRack_observacion').title = '';

              // Grilla de Detalles de Rack
                  $("#tbl_DetalleMuestras").html('');
          }

          // Permite obtener el nombre de cada mes
          function nombre_meses(_num_mes){
              if (_num_mes == 1){
                  return "ENERO";
              }
              if (_num_mes == 2){
                  return "FEBRERO";
              }
              if (_num_mes == 3){
                  return "MARZO";
              }
              if (_num_mes == 4){
                  return "ABRIL";
              }
              if (_num_mes == 5){
                  return "MAYO";
              }
              if (_num_mes == 6){
                  return "JUNIO";
              }
              if (_num_mes == 7){
                  return "JULIO";
              }
              if (_num_mes == 8){
                  return "AGOSTO";
              }
              if (_num_mes == 9){
                  return "SEPTIEMBRE";
              }
              if (_num_mes == 10){
                  return "OCTUBRE";
              }
              if (_num_mes == 11){
                  return "NOVIEMBRE";
              }
              if (_num_mes == 12){
                  return "DICIEMBRE";
              }
          }

          // Detecta la tecla ESCAPE
          document.addEventListener('keyup', function(e) {
              if (e.keyCode == 27) {
                  f_cerrarModal(1);
                  f_cerrarModal(2);
              }
          });
    </script>

	</body>
</html>

<?php
	cerrarSesion($enlace);
?>