<?php
  
  session_start();

  include('../../php/conn.php');

  if(!isset($_SESSION["id"])){
    header('Location: index.php');
  }

  mysqli_query($enlace, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");

?>

<!DOCTYPE html>
<html lang="es">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	    <!-- Meta, title, CSS, favicons, etc. -->
	    <meta charset="utf-8">
	    <meta http-equiv="X-UA-Compatible" content="IE=edge">
	    <meta name="viewport" content="width=device-width, initial-scale=1">

	    <title>LIMS | Pre Cierre Au y Ag</title>

	    <!-- Bootstrap -->
	    <link href="../vendors/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
	    <!-- Font Awesome -->
	    <link href="../vendors/font-awesome/css/font-awesome.min.css" rel="stylesheet">
	    <!-- NProgress -->
	    <link href="../vendors/nprogress/nprogress.css" rel="stylesheet">
	    <!-- iCheck -->
	    <link href="../vendors/iCheck/skins/flat/green.css" rel="stylesheet">
	    <!-- bootstrap-progressbar -->
	    <link href="../vendors/bootstrap-progressbar/css/bootstrap-progressbar-3.3.4.min.css" rel="stylesheet">
	    <!-- JQVMap -->
	    <link href="../vendors/jqvmap/dist/jqvmap.min.css" rel="stylesheet"/>
	    <!-- bootstrap-daterangepicker -->
	    <link href="../vendors/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
	    <!-- Ion.RangeSlider -->
	    <link href="../vendors/normalize-css/normalize.css" rel="stylesheet">
	    <link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.css" rel="stylesheet">
	    <link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.skinFlat.css" rel="stylesheet">
	    <!-- Bootstrap Colorpicker -->
	    <link href="../vendors/mjolnic-bootstrap-colorpicker/dist/css/bootstrap-colorpicker.min.css" rel="stylesheet">
	    <link href="../vendors/cropper/dist/cropper.min.css" rel="stylesheet">
	    <!-- Datatables -->
	    <link href="../vendors/datatables.net-bs/css/dataTables.bootstrap.min.css" rel="stylesheet">
	    <link href="../vendors/datatables.net-buttons-bs/css/buttons.bootstrap.min.css" rel="stylesheet">
	    <link href="../vendors/datatables.net-fixedheader-bs/css/fixedHeader.bootstrap.min.css" rel="stylesheet">
	    <link href="../vendors/datatables.net-responsive-bs/css/responsive.bootstrap.min.css" rel="stylesheet">
	    <link href="../vendors/datatables.net-scroller-bs/css/scroller.bootstrap.min.css" rel="stylesheet">

	    <!-- bootstrap-datetimepicker -->
    	<link href="../vendors/bootstrap-datetimepicker/build/css/bootstrap-datetimepicker.css" rel="stylesheet">

    	<!-- Switchery -->
    	<link href="../vendors/switchery/dist/switchery.min.css" rel="stylesheet">

	    <!-- Toggle Switch -->
        <link rel="stylesheet" type="text/css" href="bootstrap/css/bootstrap4-toggle.min.css">

        <!-- Custom Theme Style -->
    	<link href="../build/css/custom.min.css" rel="stylesheet">

    	<script type="text/javascript">
    		let Rack_TotalRows = 0;
            let chkRack_Selected = '';
    	</script>

        <style type="text/css">
            th {
                position: sticky;
                top: 0px;
                background-color: #12537E;
            }
        </style>
	</head>

	<body class="nav-md" onload="f_LoadResultados(1); f_LoadFiltros();" style="zoom: 80%">
		<div class="container body">
  		<div class="main_container">
  			<?php include('partes/sidebar.php'); ?>

  			<!-- page content -->
    		<div class="right_col" role="main">
    			<div class="">
    				<div class="row">
    					<div class="col-md-3 col-sm-3 col-xs-12">
                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                <div class="x_title">
                                    <h2>
                                        <font style="font-size: 14px"><b>Búsqueda por Fecha de Creación de Rack</b></font>
                                    </h2>

                                    <div class="clearfix">
                                    </div>
                                </div>
                                <div class="x_content" style="margin-bottom: -10px;">
                                    <div class="form-group col-md-6 col-sm-6 col-xs-12">
                                        <?php
                                            date_default_timezone_set("America/Lima"); 
                                            $time = date('Y-m-d');

                                            echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_inicio" onchange="f_LoadFiltros();" value="'.$time.'"/>';
                                        ?>
                                    </div>

                                    <div class="form-group col-md-6 col-sm-6 col-xs-12">
                                        <?php
                                            echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_fin" onchange="f_LoadFiltros();" value="'.$time.'"/>';
                                        ?>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div class="col-md-3 col-sm-3 col-xs-12">
                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                <div class="x_title">
                                    <h2>
                                        <font style="font-size: 14px"><b>por Racks</b></font>
                                    </h2>
                                    <div class="clearfix">
                                    </div>
                                </div>
                                <div class="x_content">
                                    <select id="lista_racks" class="form-control" required>
                                        
                                    </select>
                                </div>
                            </div>
                        </div>

                        <div class="col-md-3 col-sm-3 col-xs-12">
                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                <div class="x_title">
                                    <h2>
                                        <font style="font-size: 14px"><b>por Fundidor</b></font>
                                    </h2>
                                    <div class="clearfix">
                                    </div>
                                </div>
                                <div class="x_content">
                                    <select id="lista_fundidor" class="form-control" required>
                                        
                                    </select>
                                </div>
                            </div>
                        </div>

                        <div class="col-md-3 col-sm-3 col-xs-12">
                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                <div class="x_title">
                                    <h2>
                                        <font style="font-size: 14px"><b>por Estado</b></font>
                                    </h2>
                                    <div class="clearfix">
                                    </div>
                                </div>
                                <div class="x_content">
                                    <select id="lista_estados" class="form-control" required>
                                        <option value="99"> Todos...</option>
                                        <option value="0" selected> Pendientes</option>
                                        <option value="1"> Cerrados</option>
                                    </select>
                                </div>
                            </div>
                        </div>
    				</div>

    				<div class="row">
    					<div class="col-md-12 col-sm-12 col-xs-12">
    						<button class="btn btn-success" type="button" onclick="f_LoadResultados(0)" style="width: 100%; background-color: #26B99A">
                                   <b>Ejecutar Búsqueda</b>
                              </button>
    					</div>
    				</div>

    				<div class="row" style="margin-top: 10px">
                        <div class="col-md-12 col-sm-12 col-xs-12">
                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                <div class="x_title">
                                    <h2 id="titulo_detalle" style="margin-top: 11px;">
                                        <b>Au y Ag</b> - Visualizando Muestras Pendientes de Pre Cierre
                                    </h2>

                                    <!-- <div class="col-md-8 col-sm-8 col-xs-8" style="text-align: right;">
                                        <input id="_SwitchEstado" name="_SwitchEstado" type="checkbox" checked data-toggle="toggle" data-on="Pendientes de Pre Cierre" data-off="Pre Cerradas" data-onstyle="primary" data-offstyle="warning" data-width="170">
                                    </div> -->

                                    <div class="clearfix">
                                    </div>
                                </div>

                                <div class="x_content">
                                    <div class="col-md-10 col-sm-10 col-xs-10" style="margin-top: 15px;">
                                        <label>
                                            Total de Muestras:
                                        </label>
                                        <label id="lbl_TotalMuestras" style="color: #FF0005; font-size: 14px;">
                                            0
                                        </label>
                                    </div>
                                    <div class="col-md-2 col-sm-2 col-xs-2" style="margin-top: -5px;">
                                        <button class="btn btn-success" type="button" onclick="f_PreCierre()" style="width: 100%; background-color: #F25050">
                                             <b>Pre Cierre</b>
                                        </button>
                                    </div>

                                    <div class="table-box" style="height: 1000px; width: 100%; overflow: scroll;">
                                        <table class="table table-striped jambo_table bulk_action">
                                            <thead>
                                              <tr>
                                                <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 30px; border-top-left-radius: 15px;"><center>
                                                    Item
                                                </center></th>
                                                <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 160px;"><center>
                                                    N° Crisol Porcelana
                                                </center></th>
                                                <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 160px;"><center>
                                                    Muestra
                                                </center></th>
                                                <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 140px;"><center>
                                                    Análisis
                                                </center></th>
                                                <th colspan="3" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; background-color: #2A2B24;">
                                                  Info. Blanco
                                                </th>
                                                <th colspan="4" style="background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                    Pesos
                                                </center></th>
                                                <th colspan="4" style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                    Leyes
                                                </center></th>
                                                <th colspan="4" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #3EB595;"><center>
                                                    Ley Promedio
                                                </center></th>
                                                <th colspan="2" style="background-color: #D97373; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                    Conf.
                                                </center></th>
                                                <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 250px;"><center>
                                                    Comentarios
                                                </center></th>
                                                <th colspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; border-top-right-radius: 15px;"><center>
                                                    Pre Cierre
                                                </center></th>
                                                <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; min-width: 30px; border-top-left-radius: 15px;" hidden><center>
                                                    Id Detalle Rack Pesos
                                                </center></th>
                                              </tr>

                                              <tr>
                                                <th style=" background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #2A2B24; min-width: 250px;"><center>
                                                    Detalle
                                                </center></th>
                                                <th style="background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #2A2B24; min-width: 80px;"><center>
                                                    Factor Ag
                                                </center></th>
                                                <th style="background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #2A2B24; min-width: 80px;"><center>
                                                    Factor Au
                                                </center></th>
                                                <th style=" background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                    Peso Muestra
                                                </center></th>
                                                <th style="background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                    Peso Régulo
                                                </center></th>
                                                <th style="background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                    Peso Doré
                                                </center></th>
                                                <th style="background-color: #4C5661; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                    Peso Oro
                                                </center></th>

                                                <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                    Ley Ag (g/tm)
                                                </center></th>
                                                <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                    Ley Au (g/tm)
                                                </center></th>
                                                <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                    Ley Ag (oz/tc)
                                                </center></th>
                                                <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                    Ley Au (oz/tc)
                                                </center></th>

                                                <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #8A75AA;"><center>
                                                    Sel.
                                                </center></th>
                                                <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #3EB595;"><center>
                                                    Ley Promedio Ag (g/tm)
                                                </center></th>

                                                <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #8A75AA;"><center>
                                                    Sel.
                                                </center></th>
                                                <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #3EB595;"><center>
                                                    Ley Promedio Au (g/tm)
                                                </center></th>

                                                <th style="background-color: #D97373; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                    Ag
                                                </center></th>
                                                <th style="background-color: #D97373; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                    Au
                                                </center></th>

                                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                    Ag
                                                </center></th>
                                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                    Au
                                                </center></th>
                                              </tr>
                                            </thead>

                                            <tbody id="tbl_MuestrasPreCierre" style="overflow: scroll">
                                                
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                        </div>
    				</div>
    			</div>
    		</div>
  		</div>
  	</div>

  	<!-- Ventanas Modal -->
  	<div id="divmodal_Loading" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false" style="margin-top: 300px;">
        <div class="modal-dialog" style="height: 200px; opacity: 0.5;"><center>
            <img src="images/loading.gif" width="200px" style="border: solid; border-width: 1px; border-color: #D9D9D9;  border-radius: 15px;"></img>
        </center></div>
    </div>

    <div id="divmodal_DetallesMuestra" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false">
        <div class="modal-dialog" style="width: 35%; margin-top: 12%; margin-left: 28%">
            <!-- Modal content-->
            <div class="modal-content" style="border: solid; border-width: 1px; border-color: #E6E9ED; border-radius: 7px;">
                <div class="modal-header" style="background-color: #282828; color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; border-radius: 7px;">
                    <button type="button" class="close" data-dismiss="modal" style="color: #ffffff;">
                        ×
                    </button>

                    <h4 class="modal-title" id="titulomodal_ClaveClientes"><b>
                        <div class="col-md-5 col-sm-5 col-xs-5" style="width: 200px;">
                            Información de Muestra: 
                        </div>
                        <div class="col-md-7 col-sm-7 col-xs-7" style="margin-left: -15px;">
                            <label id="lbl_TituloMuestra" style="color: #FAF566"> XXXXXX</label>
                        </div>
                    </b></h4>
                </div>

                <div class="modal-body">
                    <table class="table table-striped jambo_table bulk_action">
                        <thead>
                            <tr>
                                <th colspan="3" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; border-top-left-radius: 15px; border-top-right-radius: 15px;">
                                    Detalles de Nuevo Blanco
                                </th>
                            </tr>

                            <tr>
                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; width: 100px;">
                                    Tipo
                                </th>
                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center;">
                                    Factor Ag
                                </th>
                                <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center;">
                                    Factor Au
                                </th>
                            </tr>
                            <tr>
                                <th id="th_InfoTipoBlanco" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661;">

                                </th>
                                <th id="th_InfoFactorAg" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
                                    
                                </th>
                                <th id="th_InfoFactorAu" style="background-color: #ffffff; border: solid; border-width: 1px; border-color: #E6E9ED; color: #12537E; text-align: center;">
                                    
                                </th>
                            </tr>
                        </thead>
                    </table>
                </div>

                <div class="modal-footer" style="padding-bottom: 5px; padding-top: 10px; text-align: center; background-color: #565759; border: solid; border-width: 1px; border-color: #E6E9ED; border-radius: 7px;">
                    <div class="col-md-12 col-sm-12 col-xs-12">
                        <button class="btn btn-dark" type="button" onclick="f_cerrarModal(1)" style="background-color: #337ab7">
                            Cerrar
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>

  	<!-- jQuery -->
    <script src="../vendors/jquery/dist/jquery.min.js"></script>
    <!-- Bootstrap -->
    <script src="../vendors/bootstrap/dist/js/bootstrap.min.js"></script>
    <!-- FastClick -->
    <script src="../vendors/fastclick/lib/fastclick.js"></script>
    <!-- NProgress -->
    <script src="../vendors/nprogress/nprogress.js"></script>
    <!-- Ion.RangeSlider -->
  	<script src="../vendors/ion.rangeSlider/js/ion.rangeSlider.min.js"></script>
  	<!-- Bootstrap Colorpicker -->
  	<script src="../vendors/mjolnic-bootstrap-colorpicker/dist/js/bootstrap-colorpicker.min.js"></script>
    <!-- Toggle Switch -->
      <script src="bootstrap/js/bootstrap4-toggle.min.js"></script>
      <!-- Custom Theme Scripts -->
    <script src="../build/js/custom.min.js"></script>

    <!-- bootstrap-daterangepicker -->
    <script src="../vendors/moment/min/moment.min.js"></script>
    <script src="../vendors/bootstrap-daterangepicker/daterangepicker.js"></script><!-- Datatables -->
    <script src="../vendors/datatables.net/js/jquery.dataTables.min.js"></script>
    <script src="../vendors/datatables.net-bs/js/dataTables.bootstrap.min.js"></script>
    <script src="../vendors/datatables.net-buttons/js/dataTables.buttons.min.js"></script>
    <script src="../vendors/datatables.net-buttons-bs/js/buttons.bootstrap.min.js"></script>
    <script src="../vendors/datatables.net-buttons/js/buttons.flash.min.js"></script>
    <script src="../vendors/datatables.net-buttons/js/buttons.html5.min.js"></script>
    <script src="../vendors/datatables.net-buttons/js/buttons.print.min.js"></script>
    <script src="../vendors/datatables.net-fixedheader/js/dataTables.fixedHeader.min.js"></script>
    <script src="../vendors/datatables.net-keytable/js/dataTables.keyTable.min.js"></script>
    <script src="../vendors/datatables.net-responsive/js/dataTables.responsive.min.js"></script>
    <script src="../vendors/datatables.net-responsive-bs/js/responsive.bootstrap.js"></script>
    <script src="../vendors/datatables.net-scroller/js/dataTables.scroller.min.js"></script>
    <script src="../vendors/jszip/dist/jszip.min.js"></script>
    <script src="../vendors/pdfmake/build/pdfmake.min.js"></script>
    <script src="../vendors/pdfmake/build/vfs_fonts.js"></script>

    <!-- Funciones Principales -->
    <script type="text/javascript">
        function f_LoadFiltros(){
            var fecha_inicio = $("#fecha_inicio").val();
            var fecha_fin = $("#fecha_fin").val();

            // Validando datos
                if (fecha_inicio == null){
                    alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                    return;
                }
                if (fecha_inicio.length == 0){
                    alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                    return;
                }

                if (fecha_fin == null){
                    alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                    return;
                }
                if (fecha_fin.length == 0){
                    alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                    return;
                }

                if (fecha_fin < fecha_inicio){
                    alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

                    return;
                }

            // Cargando Racks
                $("#lista_racks").html('');

                $.get( "../lims_api/index.php", { accion: "get_Fundicion_CierreFiltros", fecha_inicio: fecha_inicio, fecha_fin: fecha_fin },
                    function( data ) {
                        if(data.estado == 1){
                            $("#lista_racks").html(data.html_rack);
                            $("#lista_fundidor").html(data.html_fundidor);
                        }

                    }, "json");
        }

    	function f_LoadResultados(_x){
            let _html = '';
            let i = 1;
            let x = 1; // Ayudará a llevar el Id de inicio de cada grupo de muestras
            let t = 0; // Ayudará a llevar el Total de Muestras por cada grupo de muestras
            let is_PreCierreAg = 0; // Ayudará a reservar si es Pre Cierre Ag
            let is_PreCierreAu = 0; // Ayudará a reservar si es Pre Cierre Au
            let rowspan_analisis = 0;

            // Obteniendo parámetros
              let fecha_inicio = $("#fecha_inicio").val();
              let fecha_fin = $("#fecha_fin").val();
              var cod_rack = $("#lista_racks").val();
              var cod_fundidor = $("#lista_fundidor").val();
              var cod_estado = $("#lista_estados").val();

            // Validando ingreso de fechas
              if (fecha_inicio == null){
                alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                return;
              }
              if (fecha_inicio.length == 0){
                alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                return;
              }

              if (fecha_fin == null){
                alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                return;
              }
              if (fecha_fin.length == 0){
                alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                return;
              }

              if (fecha_fin < fecha_inicio){
                alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

                return;
              }

            // Cargando detalle de Análisis
              $("#tbl_MuestrasPreCierre").html(_html);

            // Loading Modal
              let modal_loading = $("#divmodal_Loading");
              modal_loading.modal({backdrop: 'static', keyboard: false});

            // Carga datos
              $.get( "../lims_api/index.php", { accion: "get_MuestrasPreCierre_New", is_precierre: _x, fecha_inicio: fecha_inicio, fecha_fin: fecha_fin, cod_rack: cod_rack, cod_fundidor: cod_fundidor, cod_estado: cod_estado },
                function( data ) {
                  if(data.estado == 1){
                    $("#tbl_MuestrasPreCierre").html(data.html);

                    // MAX (13/07/2022 11:20): Este código quedó obsoleto y fue reemplazado por la línea de arriba.
                        // $.each( data.registros, function( key, val ) {
                        //   _html += '<tr>';

                        //   // Determinando el Color para los Blancos Óxidos
                        //     let color_bf = '';

                        //     if (val.Id_TipoBlancoFundente == 1){
                        //         color_bf = 'background-color: #F2B705; color: #ffffff;';
                        //     }

                        //   _html += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                        //   _html += '      ' + i;
                        //   _html += '  </td>';

                        //   _html += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; font-weight: bold; font-size: 15px; ' + color_bf + '" onclick="f_OpenDetalleMuestra(' + "'" + val.nom_muestra + "', '" + val.nom_tipoblanco + "', " + val.FactorBlanco_Ag + ", " + val.FactorBlanco_Au + ');">';
                        //   _html += '      <u>' + val.nom_muestra + '</u>';

                        //   if (val.ITEM == 2 || val.ITEM == 3){
                        //     _html += '<img src="images/R.png" width="16px;"></img>';
                        //   }

                        //   _html += '  </td>';

                        //   _html += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; ' + color_bf + '">';
                        //   _html += '      ' + ((val.is_Au == 1 && val.is_Ag == 1) ? 'Au - Ag' : ((val.isAu == 1) ? 'Au' : 'Ag'));
                        //   _html += '  </td>';

                        //   _html += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                        //   _html += '      ' + val.Peso_Muestra;
                        //   _html += '  </td>';
                          
                        //   _html += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                        //   _html += '      ' + val.Peso_Dore;
                        //   _html += '  </td>';
                          
                        //   _html += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                        //   _html += '      ' + val.Peso_Au;
                        //   _html += '  </td>';

                        //   _html += '  <td id="chkRow_LeyAg_' + ((val.is_Newmont_Positivo == 1) ? 'N' : '') + val.ID_DETALLERACK + '_' + i + '" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                        //   _html += '      ' + val.Ley_Ag;
                        //   _html += '  </td>';
                          
                        //   _html += '  <td id="chkRow_LeyAu_' + ((val.is_Newmont_Positivo == 1) ? 'N' : '') + val.ID_DETALLERACK + '_' + i + '" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                        //   _html += '      ' + val.Ley_Au;
                        //   _html += '  </td>';
                          
                        //   _html += '  <td id="chkRow_LeyAgOz_' + ((val.is_Newmont_Positivo == 1) ? 'N' : '') + val.ID_DETALLERACK + '_' + i + '" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                        //   _html += '      ' + val.Ley_Ag_oz;
                        //   _html += '  </td>';
                          
                        //   _html += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                        //   _html += '      ' + val.Ley_Au_oz;
                        //   _html += '  </td>';

                        //   // Determina si el Check de Precierre estará activo
                        //     var _is_enabled = 1;

                        //     if (val.tiene_gestion == 1 && val.gestion_atendida == 0){
                        //       _is_enabled = 0;
                        //     }

                        //     if (val.tiene_gestion == 1 && val.id_gestionatendida != null && val.is_cargadoennuevorack == 0){
                        //       _is_enabled = 0;
                        //     }

                        //   // Realiza el promedio de leyes para Ag
                        //     if (rowspan_analisis != val.ID_DETALLERACK){
                        //       x = i;
                        //       t = ((val.TOTAL_MUESTRAS == 0) ? 1 : val.TOTAL_MUESTRAS);
                        //       is_PreCierreAg = val.is_PreCierreAg;
                        //       is_PreCierreAu = val.is_PreCierreAu;
                        //     }

                        //     _html += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center;">';
                        //     _html += '      <input type="checkbox" id="chkRow_SelectedAg_' + i + '" onchange="f_RowSelected(1, ' + x + ', ' + t + ', ' + val.ID_DETALLERACK + ', ' + _is_enabled + ')" ' + ((is_PreCierreAg == 1) ? ((val.isPreCierre_Ag_Selected == 1) ? ' checked ' : '') : ' checked ') + ((val.is_Newmont_Positivo == 1) ? 'disabled' : ((_is_enabled == 0) ? 'disabled' : ((is_PreCierreAg == 1) ? 'disabled' : ''))) + '>';
                        //     _html += '  </td>';

                        //     if (rowspan_analisis != val.ID_DETALLERACK){
                        //       _html += '  <td rowspan="' + t + '" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; background-color: #DCEDC8; font-size: 16px;">';
                        //       // _html += '          <b id="rowPromedio_Ag_' + ((val.is_Newmont_Positivo == 1) ? 'N' : '') + val.ID_DETALLERACK + '" style="color: #8C8C8C;">' + parseFloat(val.PROM_LEYAG).toFixed() + '</b>';
                        //       _html += '          <b id="rowPromedio_Ag_' + ((val.is_Newmont_Positivo == 1) ? 'N' : '') + val.ID_DETALLERACK + '" style="color: #8C8C8C;">';
                        //       _html += '              ' + ((is_PreCierreAg == 1) ? val.is_PreCierreAg_Prom : '');
                        //       _html += '          </b>';
                        //       _html += '  </td>';
                        //     }
                        //     else{
                        //       if (val.is_Newmont_Positivo == 1){
                        //         _html += '  <td style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; background-color: #DCEDC8; font-size: 16px;">';
                        //         _html += '          <b style="color: #8C8C8C;">' + parseFloat(val.PROM_LEYAG).toFixed() + '</b>';
                        //         _html += '  </td>';
                        //       }
                        //     }

                        //   // Realiza el promedio de leyes para Au
                        //     _html += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center;">';
                        //     _html += '      <input type="checkbox" id="chkRow_SelectedAu_' + i + '" onchange="f_RowSelected(2, ' + x + ', ' + t + ', ' + val.ID_DETALLERACK + ', ' + _is_enabled + ')" ' + ((is_PreCierreAu == 1) ? ((val.isPreCierre_Au_Selected == 1) ? ' checked ' : '') : ' checked ') + ((val.is_Newmont_Positivo == 1) ? 'disabled' : ((_is_enabled == 0) ? 'disabled' : ((is_PreCierreAu == 1) ? 'disabled' : ''))) + '>';
                        //     _html += '  </td>';

                        //     if (rowspan_analisis != val.ID_DETALLERACK){
                        //       _html += '  <td rowspan="' + t + '" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; background-color: #DCEDC8; font-size: 16px;">';
                        //       // _html += '          <b id="rowPromedio_Au_' + ((val.is_Newmont_Positivo == 1) ? 'N' : '') + val.ID_DETALLERACK + '" style="color: #8C8C8C;">' + parseFloat(val.PROM_LEYAU).toFixed(2) + '</b>';
                        //       _html += '          <b id="rowPromedio_Au_' + ((val.is_Newmont_Positivo == 1) ? 'N' : '') + val.ID_DETALLERACK + '" style="color: #8C8C8C;">';
                        //       _html += '              ' + ((is_PreCierreAu == 1) ? val.is_PreCierreAu_Prom : '');
                        //       _html += '          </b>';
                        //       _html += '  </td>';
                        //     }
                        //     else{
                        //       if (val.is_Newmont_Positivo == 1){
                        //         _html += '  <td style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; text-align: center; background-color: #DCEDC8; font-size: 16px;">';
                        //         _html += '          <b style="color: #8C8C8C;">' + parseFloat(val.PROM_LEYAU).toFixed(2) + '</b>';
                        //         _html += '  </td>';
                        //       }
                        //     }

                        //   // Agrega la columna de reanálisis
                        //     if (rowspan_analisis != val.ID_DETALLERACK){
                        //       // Determina el Color para Conf.Ag
                        //         let color_confag = '';
                        //         let Conf_Ag = ((is_PreCierreAg == 1) ? val.is_PreCierreAg_Conf : val.Conf_Ag);

                        //         if (Conf_Ag.length > 0){
                        //           if (val.Rack_TipoMuestra == 2){
                        //             if (Conf_Ag <= 0.5){
                        //               color_confag = '#00C756';
                        //             }
                        //             else{
                        //               color_confag = '#FF2F1E';
                        //             }
                        //           }
                        //           else{
                        //             if (Conf_Ag <= 0.5){
                        //               color_confag = '#00C756';
                        //             }

                        //             if (Conf_Ag > 0.5 && Conf_Ag < 1){
                        //               color_confag = '#FEB71B';
                        //             }
                        //             if (Conf_Ag >= 1){
                        //               color_confag = '#FF2F1E';
                        //             }
                        //           }
                        //         }
                                
                        //       _html += '  <td id="chkRow_ConfAg_' + ((val.is_Newmont_Positivo == 1) ? 'N' : '') + val.ID_DETALLERACK + '" rowspan="' + ((val.is_Newmont == 1) ? (1 + parseInt(t)) : t) + '"' + ' style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center; color: #ffffff; background-color: ' + color_confag + ';">';
                        //       _html += '              ' + Conf_Ag;
                        //       _html += '  </td>';

                        //       // Determina el Color para Conf.Au
                        //         let color_confau = '';
                        //         let Conf_Au = ((is_PreCierreAu == 1) ? val.is_PreCierreAu_Conf : val.Conf_Au);

                        //         if (Conf_Au.length > 0){
                        //           if (val.Rack_TipoMuestra == 2){
                        //             if (Conf_Au <= 0.5){
                        //               color_confau = '#00C756';
                        //             }
                        //             else{
                        //               color_confau = '#FF2F1E';
                        //             }
                        //           }
                        //           else{
                        //             if (Conf_Au <= 0.5){
                        //               color_confau = '#00C756';
                        //             }

                        //             if (Conf_Au > 0.5 && Conf_Au < 1){
                        //               color_confau = '#FEB71B';
                        //             }
                        //             if (Conf_Au >= 1){
                        //               color_confau = '#FF2F1E';
                        //             }
                        //           }
                        //         }

                        //       _html += '  <td id="chkRow_ConfAu_' + ((val.is_Newmont_Positivo == 1) ? 'N' : '') + val.ID_DETALLERACK + '" rowspan="' + ((val.is_Newmont == 1) ? (1 + parseInt(t)) : t) + '"' + ' style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center; color: #ffffff; background-color: ' + color_confau + ';">';
                        //       _html += '              ' + Conf_Au;
                        //       _html += '  </td>';

                        //       _html += '  <td rowspan="' + ((val.is_Newmont == 1) ? (1 + parseInt(t)) : t) + '"' + ' style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;">';
                        //       _html += '     <select id="reanalisis_' + i + '" class="form-control" onblur="f_SendReanalisis(' + i + ', ' + val.ID_DETALLERACK + ')" ' + ((_is_enabled == 0) ? 'disabled' : '') + '>';
                        //       _html += '         <option value="99" selected> Elija una opción...</option>';
                        //       // _html += '         <option value="0"> Reanálisis Rechazado</option>';

                        //       if (val.is_Newmont_Positivo == 0){
                        //         _html += '         <option value="2"> Lote (Duplicado)</option>';
                        //         _html += '         <option value="3"> Dirimencia (Triplicado)</option>';
                        //         _html += '         <option value="1"> Reconocimiento (Simple)</option>';
                        //       }
                        //       else{
                        //         _html += '         <option value="4"> Desactivar grupo y crear nuevo</option>';
                        //       }

                        //       _html += '     </select>';
                        //       _html += '  </td>';

                        //       // Columna que indica si la muestra tuvo un reanálisis durante el proceso
                        //         if (val.tiene_gestion == 1 && val.id_gestionatendida != null){
                        //           _html += '  <td rowspan="' + ((val.is_Newmont == 1) ? (1 + parseInt(t)) : t) + '"' + ' rowspan style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center;">';
                        //           _html += '      SÍ';
                        //           _html += '  </td>';
                        //         }
                        //         else{
                        //           _html += '  <td rowspan="' + ((val.is_Newmont == 1) ? (1 + parseInt(t)) : t) + '">';
                        //           _html += '  </td>';
                        //         }

                        //       // Agregando Observaciones
                        //         let _observacion = '';

                        //         if (val.tiene_gestion == 1 && val.gestion_atendida == 0){
                        //           _observacion = 'Solicitud de Reanálisis pendiente de atender.';
                        //         }

                        //         if (val.tiene_gestion == 1 && val.gestion_atendida == 1 && val.is_Rechazo == 1){
                        //           _observacion = 'Solicitud de Reanálisis Rechazada.';
                        //         }

                        //         if (val.tiene_gestion == 1 && val.id_gestionatendida != null && val.is_cargadoennuevorack == 0){
                        //           _observacion = 'El reanálisis aun no ha sido ingresado en un nuevo Rack.';
                        //         }

                        //         _html += '  <td rowspan="' + ((val.is_Newmont == 1) ? (1 + parseInt(t)) : t) + '"' + ' rowspan style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center; color: #FF2F1E;">';
                        //         _html += '      ' + _observacion;
                        //         _html += '  </td>';

                        //       // Agregando Comentarios
                        //         _html += '  <td rowspan="' + ((val.is_Newmont == 1) ? (1 + parseInt(t)) : t) + '"' + ' rowspan style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center; color: #FF2F1E;">';
                        //         _html += '      <input id="row_Comentario_' + ((val.is_Newmont_Positivo == 1) ? 'N' : '') + val.ID_DETALLERACK + '" type="text" class="form-control" style="text-transform: uppercase;" ' + ((val.precierre_Comentario == null) ? '' : 'value="' + val.precierre_Comentario + '"') + ((_is_enabled == 1) ? '' : 'disabled') + '>';
                        //         _html += '  </td>';

                        //       // Colocando la columna de Pre Cierre para Ag
                        //         _html += '  <td rowspan="' + ((val.is_Newmont == 1) ? (1 + parseInt(t)) : t) + '"' + ' rowspan style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center;">';

                        //         if (is_PreCierreAg == 1){
                        //           _html += '      <u style="color: #FF2F1E;" onclick="f_Reabrir(1, ' + val.ID_DETALLERACK + ')">Reabrir<u>';
                        //         }
                        //         else{
                        //           //_html += '      <input type="checkbox" id="chkRow_PreCierreAg_' + ((val.is_Newmont_Positivo == 1) ? 'N' : '') + val.ID_DETALLERACK + '" ' + ((_is_enabled == 1) ? 'checked' : 'disabled') + '>';

                        //           // MAX (02/07/2022 07:26)
                        //           _html += '      <input type="checkbox" id="chkRow_PreCierreAg_' + ((val.is_Newmont_Positivo == 1) ? 'N' : '') + val.ID_DETALLERACK + '" ' + ((_is_enabled == 1) ? '' : 'disabled') + '>';
                        //         }

                        //         _html += '  </td>';

                        //       // Colocando la columna de Pre Cierre para Au
                        //         _html += '  <td rowspan="' + ((val.is_Newmont == 1) ? (1 + parseInt(t)) : t) + '"' + ' rowspan style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center;">';

                        //         if (is_PreCierreAu == 1){
                        //           _html += '      <u style="color: #FF2F1E;" onclick="f_Reabrir(2, ' + val.ID_DETALLERACK + ')">Reabrir<u>';
                        //         }
                        //         else{
                        //           // _html += '      <input type="checkbox" id="chkRow_PreCierreAu_' + ((val.is_Newmont_Positivo == 1) ? 'N' : '') + val.ID_DETALLERACK + '" ' + ((_is_enabled == 1) ? 'checked' : 'disabled') + '>';

                        //           // MAX (02/07/2022 07:26)
                        //           _html += '      <input type="checkbox" id="chkRow_PreCierreAu_' + ((val.is_Newmont_Positivo == 1) ? 'N' : '') + val.ID_DETALLERACK + '" ' + ((_is_enabled == 1) ? '' : 'disabled') + '>';
                        //         }

                        //         _html += '  </td>';
                        //     }

                        //   _html += '  <td id="td_iddetallerackpesos_' + i + '" style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center;">';
                        //   _html += '      ' + val.ID_DETALLERACKPESOS;
                        //   _html += '  </td>';

                        //   _html += "</tr>";

                        //   rowspan_analisis = val.ID_DETALLERACK;

                        //   i += 1;
                        // });
                  }
                  else{
                    alert("No se encontraron resultados para la búsqueda solicitada");

                    // Cerrando Modal
                      $('#divmodal_Loading').modal('hide');
                  }

                  $("#lbl_TotalMuestras").html(data.total_muestras);

                  // Obteniendo el promedio general por cada grupo de muestras
                    // f_CalculaAllPromedios(); // MAX

                  // Cerrando Modal
                      $('#divmodal_Loading').modal('hide');

                }, "json");
        };

    </script>

    <!-- Funciones Secundarias -->
    <script type="text/javascript">
        // $(function() {
        //     $('#_SwitchEstado').change(function() {
        //         if ($(this).prop('checked')){
        //             f_CerrarDiv('C', 'row_Titulo');
        //             f_CerrarDiv('C', 'row_Buscar');

        //             $("#titulo_detalle").html('<b>Au y Ag</b> - Visualizando Muestras Pendientes de Pre Cierre');

        //             f_LoadResultados(1);
        //         }
        //         else{
        //             f_CerrarDiv('A', 'row_Titulo');
        //             f_CerrarDiv('A', 'row_Buscar');

        //             $("#titulo_detalle").html('<b>Au y Ag</b> - Visualizando Muestras Pre Cerradas');

        //             f_LoadResultados(0);
        //         }
        //     });
        // });

        function f_OpenDetalleMuestra(_nom_muestra, _tipo_blanco, _factor_ag, _factor_au){
            var modal_loading = $("#divmodal_DetallesMuestra");

            // Coloca el Título
                $("#lbl_TituloMuestra").html(_nom_muestra);

            // Agredando información al modal
                $("#th_InfoTipoBlanco").html(_tipo_blanco);
                $("#th_InfoFactorAg").html(_factor_ag);
                $("#th_InfoFactorAu").html(_factor_au);

            modal_loading.modal();
        };

        function f_RowSelected(_tipo, _idrow_inicio, _idrow_total, _id_detallerack, _is_enabled, _id_tipomuestra){
            let nomcampo_ley = 'chkRow_Ley';
            let nomcampo_chk = 'chkRow_Selected';
            let nomcampo_Prom = 'rowPromedio_';
            let nomcampo_leyConf = 'chkRow_Ley';
            let nomcampo_Conf = 'chkRow_Conf';
            let nomcampo_PreCierre = 'chkRow_PreCierre';
            let promedio = 0;
            let total = 0;
            let conteo = 0;

            // Setea el prefijo del campo de Ley
                if (_tipo == 1){// Para Ag
                    nomcampo_ley = nomcampo_ley + 'Ag_' + _id_detallerack + '_';
                    nomcampo_chk = nomcampo_chk + 'Ag_';
                    nomcampo_Prom = nomcampo_Prom + 'Ag_';
                    nomcampo_PreCierre = nomcampo_PreCierre + 'Ag_' + _id_detallerack;

                    nomcampo_leyConf = nomcampo_leyConf + 'AgOz_' + _id_detallerack + '_';
                    nomcampo_Conf = nomcampo_Conf + 'Ag_';
                }
                else{//Para Au
                    nomcampo_ley = nomcampo_ley + 'Au_' + _id_detallerack + '_';
                    nomcampo_chk = nomcampo_chk + 'Au_';
                    nomcampo_Prom = nomcampo_Prom + 'Au_';
                    nomcampo_PreCierre = nomcampo_PreCierre + 'Au_' + _id_detallerack;

                    nomcampo_leyConf = nomcampo_leyConf + 'Au_' + _id_detallerack + '_';
                    nomcampo_Conf = nomcampo_Conf + 'Au_';
                }

            // Realiza el bucle de búsqueda
                let x = 1;
                let nomcampo_ley_x = '';
                let nomcampo_chk_x = '';

                let arr_MuestrasConf = [];
                let prom_Conf = 0;

                while (x <= _idrow_total){
                    nomcampo_ley_x = nomcampo_ley + _idrow_inicio;
                    nomcampo_chk_x = nomcampo_chk + _idrow_inicio;
                    nomcampo_leyConf_x = nomcampo_leyConf + _idrow_inicio;

                    // Buscando campos con Check
                        if (document.getElementById(nomcampo_chk_x).checked){
                            total += parseFloat($('#' + nomcampo_ley_x).html());

                            arr_MuestrasConf.push(parseFloat($('#' + nomcampo_leyConf_x).html()));

                            conteo += 1;
                        }

                    x += 1;
                    _idrow_inicio += 1;
                }

            // Calcula el promedio
                promedio = ((conteo == 0) ? '' : total / conteo);

                if (_tipo == 1){// Para Ag
                    if (conteo > 0){
                        if (_id_tipomuestra == 3){
                            promedio = parseFloat(promedio).toFixed(2);
                        }
                        else{
                            promedio = parseFloat(promedio).toFixed(0);
                        }
                    }
                }
                else{//Para Au
                    if (conteo > 0){
                        promedio = parseFloat(promedio).toFixed(2);
                    }
                }

                $("#" + nomcampo_Prom + _id_detallerack).html(promedio);

            // Colocando datos de Conf.
                prom_Conf = f_CalculaAllConf(arr_MuestrasConf);
                $("#" + nomcampo_Conf + _id_detallerack).html(prom_Conf);

            // Pintando Celdas de Conf.
                let color_bk = '';

                if (prom_Conf <= 0.5){
                    $("#" + nomcampo_Conf + _id_detallerack).css("background-color", "#00C756");
                }
                if (prom_Conf > 0.5 && prom_Conf < 1){
                    $("#" + nomcampo_Conf + _id_detallerack).css("background-color", "#FEB71B");
                }
                if (prom_Conf >= 1){
                    $("#" + nomcampo_Conf + _id_detallerack).css("background-color", "#FF2F1E");
                }

            // Inhabilitando Check de Cierre
                if (_is_enabled == 1){
                    if (conteo == 0){
                        $("#" + nomcampo_PreCierre).prop('checked', false);
                        $("#" + nomcampo_PreCierre).prop('disabled', 'true');
                    }
                    else{
                        $("#" + nomcampo_PreCierre).prop('disabled', '');
                    }
                }
        };

        function f_CalculaAllPromedios(){
            let r = 1;
            let _id_detallerackAg = '';
            let _id_detallerackAg_r = '';
            let _id_detallerackAu = '';
            let _id_detallerackAu_r = '';

            let _sumAg = 0;
            let _countAg = 0;
            let _promAg = 0;

            let _sumAu = 0;
            let _countAu = 0;
            let _promAu = 0;

            let arr_MuestrasConfAu = [];
            let arr_MuestrasConfAg = [];

            let Conf_AgX = 0;
            let Conf_AuX = 0;

            $('#tbl_MuestrasPreCierre tr').each(function () {
                _id_detallerackAg_r = $(this).attr('id');

                // Comprueba si trae Promedio por Pre Cierre para Ag
                    if (_id_detallerackAg_r.substring(0, 1) != 'N'){
                        if ($("#rowPromedio_Ag_" + _id_detallerackAg_r).html().trim().length == 0){
                            if (_id_detallerackAg != _id_detallerackAg_r){
                                if (r != 1){
                                    _promAg = parseFloat(_sumAg / _countAg).toFixed();

                                    if (!isNaN(_promAg)){
                                        $("#rowPromedio_Ag_" + _id_detallerackAg).html(_promAg);

                                        // Para obtener los Conf
                                            Conf_AgX = f_CalculaAllConf(arr_MuestrasConfAg);

                                            $("#chkRow_ConfAg_" + _id_detallerackAg).html(Conf_AgX);

                                            arr_MuestrasConfAg = [];

                                        // Pintando Celdas de Conf.
                                            if (Conf_AgX <= 0.5){
                                                $("#chkRow_ConfAg_" + _id_detallerackAg).css("background-color", "#00C756");
                                            }
                                            if (Conf_AgX > 0.5 && Conf_AgX < 1){
                                                $("#chkRow_ConfAg_" + _id_detallerackAg).css("background-color", "#FEB71B");
                                            }
                                            if (Conf_AgX >= 1){
                                                $("#chkRow_ConfAg_" + _id_detallerackAg).css("background-color", "#FF2F1E");
                                            }
                                    }
                                }

                                if ($(this).find("td").eq(6).html().trim().length == 0){
                                    $("#chkRow_SelectedAg_" + r).prop('checked', false);
                                    $("#chkRow_SelectedAg_" + r).prop('disabled', true);

                                    _sumAg = 0;
                                    _countAg = 0;
                                }
                                else{
                                    _sumAg = parseFloat($(this).find("td").eq(6).html());

                                    _countAg = 1;
                                }

                                _id_detallerackAg = _id_detallerackAg_r;
                            }
                            else{
                                if ($(this).find("td").eq(6).html().trim().length == 0){
                                    $("#chkRow_SelectedAg_" + r).prop('checked', false);
                                    $("#chkRow_SelectedAg_" + r).prop('disabled', true);
                                }
                                else{
                                    _sumAg += parseFloat($(this).find("td").eq(6).html());

                                    _countAg += 1;
                                }
                            }

                            if ($(this).find("td").eq(6).html().trim().length > 0){
                                arr_MuestrasConfAg.push(parseFloat($(this).find("td").eq(8).html()));
                            }
                        }
                    }

                // Comprueba si trae Promedio por Pre Cierre para Au
                    _id_detallerackAu_r = $(this).attr('id');

                    if (_id_detallerackAu_r.substring(0, 1) != 'N'){
                        if ($("#rowPromedio_Au_" + _id_detallerackAu_r).html().trim().length == 0){
                            if (_id_detallerackAu != _id_detallerackAu_r){
                                if (r != 1){
                                    _promAu = parseFloat(_sumAu / _countAu).toFixed(2);

                                    if (!isNaN(_promAu)){
                                        $("#rowPromedio_Au_" + _id_detallerackAu).html(_promAu);

                                        // Para obtener los Conf
                                            Conf_AuX = f_CalculaAllConf(arr_MuestrasConfAu);

                                            $("#chkRow_ConfAu_" + _id_detallerackAu).html(Conf_AuX);

                                            arr_MuestrasConfAu = [];

                                        // Pintando Celdas de Conf.
                                            if (Conf_AuX <= 0.5){
                                                $("#chkRow_ConfAu_" + _id_detallerackAu).css("background-color", "#00C756");
                                            }
                                            if (Conf_AuX > 0.5 && Conf_AuX < 1){
                                                $("#chkRow_ConfAu_" + _id_detallerackAu).css("background-color", "#FEB71B");
                                            }
                                            if (Conf_AuX >= 1){
                                                $("#chkRow_ConfAu_" + _id_detallerackAu).css("background-color", "#FF2F1E");
                                            }
                                    }
                                }

                                if ($(this).find("td").eq(7).html().trim().length == 0){
                                    $("#chkRow_SelectedAu_" + r).prop('checked', false);
                                    $("#chkRow_SelectedAu_" + r).prop('disabled', true);

                                    _sumAu = 0;
                                    _countAu = 0;
                                }
                                else{
                                    _sumAu = parseFloat($(this).find("td").eq(7).html());

                                    _countAu = 1;
                                }

                                _id_detallerackAu = _id_detallerackAu_r;
                            }
                            else{
                                if ($(this).find("td").eq(7).html().trim().length == 0){
                                    $("#chkRow_SelectedAu_" + r).prop('checked', false);
                                    $("#chkRow_SelectedAu_" + r).prop('disabled', true);
                                }
                                else{
                                    _sumAu += parseFloat($(this).find("td").eq(7).html());

                                    _countAu += 1;
                                }
                            }

                            if ($(this).find("td").eq(7).html().trim().length > 0){
                                arr_MuestrasConfAu.push(parseFloat($(this).find("td").eq(7).html()));
                            }
                        }
                    }

                r += 1;
            });

            // Pinta el último promedio para Ag
                if (_id_detallerackAg_r.substring(1, 1) != 'N'){

                    if ($("#rowPromedio_Ag_" + _id_detallerackAg_r).html().trim().length == 0){
                        _promAg = parseFloat(_sumAg / _countAg).toFixed();

                        $("#rowPromedio_Ag_" + _id_detallerackAg).html(_promAg);
                        $("#chkRow_ConfAg_" + _id_detallerackAg).html(f_CalculaAllConf(arr_MuestrasConfAg));
                    }
                }

            // Pinta el último promedio para Au
                if (_id_detallerackAu_r.substring(1, 1) != 'N'){
                    if ($("#rowPromedio_Au_" + _id_detallerackAu_r).html().trim().length == 0){
                        _promAu = parseFloat(_sumAu / _countAu).toFixed(2);

                        $("#rowPromedio_Au_" + _id_detallerackAu).html(_promAu);
                        $("#chkRow_ConfAu_" + _id_detallerackAu).html(f_CalculaAllConf(arr_MuestrasConfAu));
                    }
                }


        };

        function f_CalculaAllConf(_arr_Muestras){
            let m = 0;
            let min = 0;
            let max = 0;

            _arr_Muestras.sort();

            min = _arr_Muestras[0];
            max = _arr_Muestras[_arr_Muestras.length - 1];

            return Math.abs(parseFloat(max - min).toFixed(2));
        };
    </script>

    <!-- Funciones para Grabar -->
    <script type="text/javascript">
    	function f_PreCierre(){
              let i = 1;
              let precierreAg = 0;
              let precierreAu = 0;
              let nomcampo_PreCierreProm = 'rowPromedio_';
              let nomcampo_PreCierreConf = 'chkRow_Conf';
              let nomcampo_PreCierre = 'chkRow_PreCierre';
              let nomcampo_Selected = 'chkRow_Selected';
              let nomcampo_PreCierreProm_x = '';
              let nomcampo_PreCierreConf_x = '';
              let nomcampo_PreCierre_x = '';
              let nomcampo_Selected_x = '';
              var _id_detallerack_r = '';
              var _id_detallerack_r_x = '';
              let leyPromedio = 0;
              let Conf = 0;
              let finish = 0;
              let finish_x = 1;
              let arr_PreCierre = [];
              var _comentario = '';

              if (!confirm("¿Está seguro de iniciar con el Pre Cierre de las muestras seleccionadas?")){
                  return;
              }

              // Obtiene el total de filas
                  finish = $('#tbl_MuestrasPreCierre tr').length;
                  finish = finish * 2;

              $('#tbl_MuestrasPreCierre tr').each(function () {
                  _id_detallerack_r = $(this).attr('id');

                  if ($("#row_Comentario_" + _id_detallerack_r).val() != undefined){
                    _comentario = $("#row_Comentario_" + _id_detallerack_r).val().trim();

                    // Si es Newmont Positivo le quita la "N" al Id
                      _id_detallerack_r = ((_id_detallerack_r.substring(0, 1) == 'N') ? _id_detallerack_r.substring(1) : _id_detallerack_r);

                    // Loading Modal
                      let modal_loading = $("#divmodal_Loading");
                      modal_loading.modal({backdrop: 'static', keyboard: false});

                    // Busca los Checks de Pre Cierres
                      if (_id_detallerack_r_x != _id_detallerack_r){
                          // Verifica los cierres para Ag y Au
                              var c = 1;

                              while (c <= 2){
                                  nomcampo_PreCierre_x = nomcampo_PreCierre + ((c == 1) ? 'Ag_' : 'Au_') + _id_detallerack_r;
                                  nomcampo_PreCierreProm_x = nomcampo_PreCierreProm + ((c == 1) ? 'Ag_' : 'Au_') + _id_detallerack_r;
                                  nomcampo_PreCierreConf_x = nomcampo_PreCierreConf + ((c == 1) ? 'Ag_' : 'Au_') + _id_detallerack_r;

                                  leyPromedio = $("#" + nomcampo_PreCierreProm_x).html().trim();
                                  Conf = $("#" + nomcampo_PreCierreConf_x).html().trim();

                                  if ($("#" + nomcampo_PreCierre_x).prop('checked')){
                                      arr_PreCierre.push($("#td_iddetallerackpesos_" + i).html().trim());

                                      // Guarda los datos de Pre Cierre
                                          $.get( "../lims_api/index.php", { accion: "grabar_PreCierre", id_detallerack: _id_detallerack_r, elemento: ((c == 1) ? 'Ag' : 'Au'), ley_promedio: leyPromedio, conf: Conf, comentario: _comentario },
                                              function( data ) {
                                                  if(data.estado != 1){
                                                      alert("Ocurrió un error al momento de grabar el Pre Cierre.\n\nCódigo de error: " + _id_detallerack_r);
                                                  }

                                              }, "json");
                                  }

                                  c += 1;
                              }
                      }

                  }

                  i += 1;
              });

              // Valida que haya al menos un Check de Pre Cierre
                  if (arr_PreCierre.length == 0){
                      alert('No se encontraron registros con Check de Pre Cierre');

                      // Cerrando Modal
                          $('#divmodal_Loading').modal('hide');

                      return;
                  }

              // Busca los Checks para el cálculo de Promedios y Conf.
                  i = 1;

                  $('#tbl_MuestrasPreCierre tr').each(function () {
                      var r = 1;
                      var is_Checked = 0;
                      let _id_detallerackpesos = $("#td_iddetallerackpesos_" + i).html().trim();

                      while (r <= 2){
                          is_Checked = 0;
                          nomcampo_Selected_x = nomcampo_Selected + ((r == 1) ? 'Ag_' : 'Au_') + i;

                          if ($("#" + nomcampo_Selected_x).prop('checked')){
                              is_Checked = 1;
                          }

                          // Guarda los datos de Checks
                              $.get( "../lims_api/index.php", { accion: "grabar_PreCierreItemSelected", id_detallerackpesos: _id_detallerackpesos, elemento: ((r == 1) ? 'Ag' : 'Au'), is_checked: is_Checked },
                                  function( data ) {
                                      if(data.estado != 1){
                                          alert("Ocurrió un error al momento de grabar el estado de Checks de los Item.\n\nCódigo de error: " + i + '|' + _id_detallerackpesos);
                                      }
                                      else{
                                          if (finish == finish_x){
                                              f_LoadResultados(1);
                                          }

                                          finish_x += 1;
                                      }

                                      // // Cerrando Modal
                                      //     $('#divmodal_Loading').modal('hide');

                                  }, "json");

                          r += 1;
                      }

                      _id_detallerack_r_x = _id_detallerack_r;

                      i += 1;
                  });
          };

          function f_Reabrir(_elemento, _id_detallerack, _ci_muestra){
              if (!confirm("¿Está seguro de reabrir el Pre Cierre de la muestra seleccionada?")){
                  return;
              }

              $.get( "../lims_api/index.php", { accion: "reabrir_PreCierre", elemento: ((_elemento == 1) ? 'Ag' : 'Au'), id_detallerack: _id_detallerack, ci_muestra: _ci_muestra },
                  function( data ) {
                      if(data.estado != 1){
                          alert("Ocurrió un error al momento de grabar el Reabrir el Pre Cierre.\n\nCódigo de error: " + _elemento + '|' + _id_detallerack);
                      }
                      else{
                          f_LoadResultados(1);
                      }

                  }, "json");
          };
    </script>

    <!-- Otras Funciones -->
    <script type="text/javascript">
          function f_cerrarModal(pantalla_modal){
              if (pantalla_modal == 1){
                  $('#divmodal_DetallesMuestra').modal('hide');
              }
              if (pantalla_modal == 2){
                  $('#divmodal_DetallesRack').modal('hide');
              }
          };

          function f_CerrarDiv(accion, nom_div){
              var _div = document.getElementById(nom_div);

              if (accion == 'A'){
                  _div.style.display = 'block'
              }
              else{
                   _div.style.display = 'none';
              }
          };

          // Limpia los datos al momento de Realizar la búsqueda de resultados
          function f_Limpiar(){
              // // Detalles del Rack
              //     $("#lblRack_totalmuestras").html('');
              //     $("#lblRack_usuario").html('');
              //     $("#lblRack_fechahora").html('');
              //     $("#lblRack_horno").html('');
              //     $("#lblRack_observacion").html('');
              //     document.getElementById('lblRack_observacion').title = '';

              // Grilla de Detalles de Rack
                  $("#tbl_DetalleMuestras").html('');
          }

          // Permite obtener el nombre de cada mes
          function nombre_meses(_num_mes){
              if (_num_mes == 1){
                  return "ENERO";
              }
              if (_num_mes == 2){
                  return "FEBRERO";
              }
              if (_num_mes == 3){
                  return "MARZO";
              }
              if (_num_mes == 4){
                  return "ABRIL";
              }
              if (_num_mes == 5){
                  return "MAYO";
              }
              if (_num_mes == 6){
                  return "JUNIO";
              }
              if (_num_mes == 7){
                  return "JULIO";
              }
              if (_num_mes == 8){
                  return "AGOSTO";
              }
              if (_num_mes == 9){
                  return "SEPTIEMBRE";
              }
              if (_num_mes == 10){
                  return "OCTUBRE";
              }
              if (_num_mes == 11){
                  return "NOVIEMBRE";
              }
              if (_num_mes == 12){
                  return "DICIEMBRE";
              }
          }

          // Detecta la tecla ESCAPE
          document.addEventListener('keyup', function(e) {
              if (e.keyCode == 27) {
                  f_cerrarModal(1);
                  f_cerrarModal(2);
              }
          });
    </script>

	</body>
</html>

<?php
	cerrarSesion($enlace);
?>