<?php

	include('../../php/conn.php');

	require_once 'dompdf/autoload.inc.php';

	use Dompdf\Dompdf;

  	// Verificando si es "-", "<" o ">"
	 	function f_VerificaSimbolo($_tipo, $_resultado){
	        $resultado = 0;

	        // Verifica si es: "-"
	            if ($_tipo == 1){
	                if ($_resultado == 99999.99999){
	                    $resultado = 1;
	                }
	            }

	        // Verifica si es: "<" ó ">"
	            if ($_tipo == 2){
	                $num_ceros = 0;

	                // Comprobando el total de nueves
	                    // $num_ceros = $_resultado.toString().substr($_resultado.toString().length - 10);
	                    $num_ceros = substr(trim($_resultado), strlen(trim($_resultado)) - 10);

	                    if ($num_ceros != '9999999999'){
	                        // $num_ceros = $_resultado.toString().substr($_resultado.toString().length - 9);
	                        $num_ceros = substr(trim($_resultado), strlen(trim($_resultado)) - 9);

	                        if ($num_ceros != '999999999'){
	                            // $num_ceros = $_resultado.toString().substr($_resultado.toString().length - 8);
	                            $num_ceros = substr(trim($_resultado), strlen(trim($_resultado)) - 8);

	                            if ($num_ceros != '99999999'){
	                                // $num_ceros = $_resultado.toString().substr($_resultado.toString().length - 7);
	                                $num_ceros = substr(trim($_resultado), strlen(trim($_resultado)) - 7);

	                                if ($num_ceros != '9999999'){
	                                    $num_ceros = 0;
	                                }
	                            }
	                        }
	                    }

	                // $resultado = $num_ceros.length;
					$resultado = strlen($num_ceros);
	            }

	        return $resultado;
	    };

	// Obtiene resultado final
	    function f_GetResultadoSimbolo($_num_ceros, $_resultado){
	        $simbolo = '';
	        $is_entero = 0;
	        $num_left = '';
	        $decimal = '';
	        $num_entero = '';
	        $c = 0;
	        $num_ceros = '';

	        // Determinando el símbolo
	            if ($_num_ceros >= 7 && $_num_ceros <= 8){
	                $simbolo = '<';
	                $is_entero = (($_num_ceros == 7) ? 1 : 0);
	            }

	            if ($_num_ceros >= 9 && $_num_ceros <= 10){
	                $simbolo = '>';
	                $is_entero = (($_num_ceros == 9) ? 1 : 0);
	            }

	        // Obteniendo resultados
	            // $num_left = $_resultado.toString().substr(0, $_resultado.toString().indexOf('.'));
	            $num_left = substr($_resultado, 0, strpos($_resultado, '.'));

	            if ($is_entero == 1){
	                // $_resultado = $simbolo + ' ' + (parseInt($num_left) + 1);
	                $_resultado = $simbolo.' '.($num_left + 1);
	            }
	            else{
	                // Obtiene la parte decimal
	                    // $decimal = $_resultado.toString().substr($_resultado.toString().indexOf('.') + 1);
						$decimal = substr($_resultado, strpos($_resultado, '.') + 1);

	                // Obteniene el número entero de los decimales
	                    $menos_un_cero = 0;

	                    // $num_entero = $decimal.substr(0, $decimal.length - $_num_ceros);
	                    $num_entero = substr($decimal, 0, strlen($decimal) - $_num_ceros);

	                    $menos_un_cero = ((intval($num_entero) == 0) ? 1 : 0);

	                    $num_entero = intval($num_entero) + 1;

	                // 2. Obteniendo la cantidad de CEROS de la parte decimal
	                    // while ($c < ($decimal.substr(0, $decimal.length - $_num_ceros).length - $menos_un_cero)){
	                    while ($c < (strlen(substr($decimal, 0, strlen($decimal) - $_num_ceros)) - $menos_un_cero)){
	                      // if ($decimal.substr($c, 1) == 0){
	                      if (substr($decimal, $c, 1) == 0){
	                        $num_ceros .= '0';
	                      }

	                      $c += 1;
	                    }

	                $_resultado = $simbolo.' '.$num_left.'.'.$num_ceros.$num_entero;
	            }

	        return $_resultado;
	    };

	// Actualiza a Onzas si es Au y/o Ag
	    function f_GetResultadoOnzas($_Resultado, $_Elemento){
	        $resultado = $_Resultado;
	        $elemento = $_Elemento;

	        $_resultado = '';
	        $factor = 34.285;

	        if ($elemento == 'au' || $elemento == 'ag'){
	            if (trim($resultado) == '-'){
	                $_resultado = '-';
	            }
	            else{
	                $simbolo = substr(trim($resultado), 0, 1);

	                if ($simbolo == '<' || $simbolo == '>'){
	                    if ($simbolo == '<'){
	                        $_resultado = '-';
	                    }
	                    else{
	                        // $_resultado = $resultado.trim().substr(1);
	                        $_resultado = substr(trim($resultado), 1);

	                        $_resultado = '> '.round(($_resultado / $factor), 2);
	                    }
	                }
	                else{
	                    // if ($resultado.trim().length == 0){
	                    if (strlen(trim($resultado)) == 0){
	                        $_resultado = '';
	                    }
	                    else{
	                        $_resultado = round(($resultado / $factor), 2);
	                    }
	                }
	            }

	            return $_resultado;
	        }
	    };

	// Recuperando Id
	    $q_IdPedido = "SELECT	CP.Id_Pedido,
								DP.Id AS Id_Detalle,
								MC.cRazonSocial,
								TM.Nombre_TipoMuestra,
								DP.Nom_Muestra,
								DP.Peso_Muestra,
								DE.Nombre_DetalleEnvase,
								CONVERT(VARCHAR, CP.FechaHora_Recepcion, 103) AS FechaHora_Recepcion2,
								CONVERT(VARCHAR, DAR.Fecha_Registro, 103) AS FechaHora_Entrega2,
								DP.Elemento_Analisis,
								
								DAR.Ley_Au_gt,
								DAR.Ley_Au_ot,
								DAR.Ley_Ag_gt,
								DAR.Ley_Ag_ot,
								DAR.Porc_CU,
								DAR.Porc_PB,
								DAR.Porc_ZN,
								DAR.Porc_AS,
								DAR.Porc_SB,
								DAR.Porc_S,
								DAR.Porc_FE,
								DAR.Porc_H2O,
								
								CONVERT(VARCHAR, CIE.Fecha_Creacion, 103) AS Fecha_Informe,
								DAR.Observacion_Reporte,
								CP.Documento_Cliente,
								MC.cNumeroTelefono + CASE WHEN LEN(cSegundoNumeroTelefono) > 0 THEN ' - ' + cSegundoNumeroTelefono ELSE '' END AS TELEFONO_CLIENTE,
								MC.cEmail,
								CP.Sucursal,
								_CP.cNombreCliente AS NOMBRE_EMPRESA,
								DP.Tipo_Muestra,
								TA.Des_TipoAnalisis,
								CONVERT(VARCHAR, DAR.Fecha_PreCierre, 103) AS Fecha_CierreInforme,
								CP.Observacion AS Referencia_Cliente,
								CONVERT(VARCHAR, COALESCE(DAR.Fecha_InicioEnsayo, CP.FechaHora_Recepcion), 103) AS Fecha_InicioEnsayo,
								CONVERT(VARCHAR, COALESCE(DAR.Fecha_InicioEnsayo, CP.FechaHora_Recepcion), 23) AS Fecha_InicioEnsayo_New,
								DP.Cod_Interno,
								CP.Mostrar_Contacto
						  FROM  _max_labperu_CabeceraPedido CP
								LEFT JOIN _max_labperu_DetallePedido DP ON CP.Id_Pedido = DP.Id_Pedido
								LEFT JOIN _max_labperu_DetalleAnalisisResultados DAR ON DP.Id_Pedido = DAR.Id_Pedido
						          AND DP.Id = DAR.Id_Detalle_Pedido
								INNER JOIN maestroCliente MC ON CP.iIdCliente = MC.iIdCliente
								INNER JOIN _max_labperu_TiposMuestra TM ON DP.Tipo_Muestra = TM.Id
								INNER JOIN _max_labperu_DetalleEnvase DE ON DP.Detalle_Envase = DE.Id
								LEFT JOIN _max_labperu_CorrelativoInformeEnsayos CIE ON DAR.Id_Pedido = CIE.Id_Pedido
						          AND DAR.Id_Detalle_Pedido = CIE.Id_Detalle_Pedido
								INNER JOIN _max_labperu_Sucursales S ON CP.Sucursal = S.Id
								INNER JOIN Cabecera_Pedido _CP ON CP.Id_Pedido = _CP.iId_Cabecera_Pedido
								INNER JOIN _max_labperu_TipoAnalisis TA ON DP.Tipo_Analisis = TA.Id
						 WHERE  SUBSTRING(master.dbo.fn_varbintohexstr(HashBytes('MD5', CONVERT(VARCHAR, DP.Id))), 3, 32) = '".$_GET["x"]."'";

		if ($res_IdPedido = sqlsrv_query($enlacehost, $q_IdPedido)) {
          while($row_IdPedido = sqlsrv_fetch_array($res_IdPedido)) {
          	// Datos generales
	            $Id_Pedido = $row_IdPedido["Id_Pedido"];
				$Id_PedidoDetalle = $row_IdPedido["Id_Detalle"];
				$cliente = str_replace('*', ' ', $row_IdPedido["cRazonSocial"]);
				$tipo_muestra = str_replace('*', ' ', $row_IdPedido["Nombre_TipoMuestra"]);
				$nom_muestra = str_replace('*', ' ', $row_IdPedido["Nom_Muestra"]);
				$peso_muestra = $row_IdPedido["Peso_Muestra"];
				$detalle_envase = str_replace('*', ' ', $row_IdPedido["Nombre_DetalleEnvase"]);
				$fecha_recepcion = $row_IdPedido["FechaHora_Recepcion2"];
				$fecha_entrega = $row_IdPedido["FechaHora_Entrega2"];
				$elemento_analisis = str_replace('*', ' ', $row_IdPedido["Elemento_Analisis"]);
				$fecha_informe = $row_IdPedido["Fecha_Informe"];
				$obs_reporte = $row_IdPedido["Observacion_Reporte"];
				$cliente_documento = $row_IdPedido["Documento_Cliente"];
				$cliente_telefono = $row_IdPedido["TELEFONO_CLIENTE"];
				$cliente_email = $row_IdPedido["cEmail"];
				$nombre_empresa = $row_IdPedido["NOMBRE_EMPRESA"];
				$cod_tipomuestra = $row_IdPedido["Tipo_Muestra"];
				$tipo_ensayo = $row_IdPedido["Des_TipoAnalisis"];
				$fecha_cierreinforme = $row_IdPedido["Fecha_CierreInforme"];
				$referencia_cliente = $row_IdPedido["Referencia_Cliente"];
				// $fecha_inicioensayo = explode('-', $row_IdPedido["Fecha_InicioEnsayo"]);
				// $fecha_inicioensayo = strval($fecha_inicioensayo[2]).'/'.strval($fecha_inicioensayo[1]).'/'.strval($fecha_inicioensayo[0]);
				$fecha_inicioensayo = $row_IdPedido["Fecha_InicioEnsayo"];
				$Fecha_InicioEnsayo_New = $row_IdPedido["Fecha_InicioEnsayo_New"];
				$codigo_interno = $row_IdPedido["Cod_Interno"];
				$mostrar_contacto = $row_IdPedido["Mostrar_Contacto"];

			// Leyes
				$augt = $row_IdPedido["Ley_Au_gt"];
				$auot =$row_IdPedido["Ley_Au_ot"];
				$aggt =$row_IdPedido["Ley_Ag_gt"];
				$agot =$row_IdPedido["Ley_Ag_ot"];
				$cu =$row_IdPedido["Porc_CU"];
				$pb =$row_IdPedido["Porc_PB"];
				$zn = $row_IdPedido["Porc_ZN"];
				$as =$row_IdPedido["Porc_AS"];
				$sb =$row_IdPedido["Porc_SB"];
				$s =$row_IdPedido["Porc_S"];
				$fe =$row_IdPedido["Porc_FE"];
				$ho = $row_IdPedido["Porc_H2O"];
          }
        }

	// // Parámetros principales
	// 	$Id_Pedido = $_GET["Id"];
	// 	$Id_PedidoDetalle = $_GET["Id_Detalle"];
	// 	$cliente = str_replace('*', ' ', $_GET["Cli"]);
	// 	$tipo_muestra = str_replace('*', ' ', $_GET["TM"]);
	// 	$nom_muestra = str_replace('*', ' ', $_GET["M"]);
	// 	$peso_muestra = $_GET["PM"];
	// 	$detalle_envase = str_replace('*', ' ', $_GET["DE"]);
	// 	$fecha_recepcion = $_GET["FR"];
	// 	$fecha_entrega = $_GET["FE"];
	// 	$elemento_analisis = str_replace('*', ' ', $_GET["EA"]);
	// 	$fecha_informe = $_GET["FI"];
	// 	$obs_reporte = $_GET["Obs"];
	// 	$cliente_documento = $_GET["DC"];
	// 	$cliente_telefono = $_GET["TC"];
	// 	$cliente_email = $_GET["CEM"];
	// 	$nombre_empresa = $_GET["NE"];
	// 	$cod_tipomuestra = $_GET["CTM"];
	// 	$tipo_ensayo = $_GET["TE"];
	// 	$fecha_cierreinforme = $_GET["FCI"];
	// 	$referencia_cliente = $_GET["RC"];
	// 	$fecha_inicioensayo = explode('-', $_GET["FIE"]);
	// 	$fecha_inicioensayo = strval($fecha_inicioensayo[2]).'/'.strval($fecha_inicioensayo[1]).'/'.strval($fecha_inicioensayo[0]);
	// 	$codigo_interno = $_GET["CI"];
	// 	$mostrar_contacto = $_GET["MC"];

	// Determina si es Newmont y obtiene resultados
		$is_newmont = 0;
		$au_x = 0;
		$ag_x = 0;

		if (strpos(strtolower($elemento_analisis), 'newmont') !== false){
			$is_newmont = 1;

			// Obtiene Malla
				$malla = '';

				$q_pesototal = "SELECT	M.num_malla
								  FROM	_max_labperu_DetallePedido_Newmont DPN
										INNER JOIN _max_labperu_Mallas M ON DPN.cod_malla = M.Id
								 WHERE	cod_detallepedido = ".$Id_PedidoDetalle."
                                   AND pesos_titulo = 'Peso +'";

                if ($res_pesototal = sqlsrv_query($enlacehost, $q_pesototal)) {
                  while($row_pesototal = sqlsrv_fetch_array($res_pesototal)) {
                    $malla = $row_pesototal["num_malla"];
                  }
                }

			// Peso Total
                $peso_total = 0;

                $q_pesototal = "SELECT COALESCE(pesos, 0) AS PESOS
                                  FROM _max_labperu_DetallePedido_Newmont
                                 WHERE cod_detallepedido = ".$Id_PedidoDetalle."
                                   AND pesos_titulo = 'Peso Total'";

                if ($res_pesototal = sqlsrv_query($enlacehost, $q_pesototal)) {
                  while($row_pesototal = sqlsrv_fetch_array($res_pesototal)) {
                    $peso_total = $row_pesototal["PESOS"];
                  }
                }

            // Pesos Positivo
                $peso_positivo = 0;

                if ($peso_total > 0){
                  $q_pesopositivo = "SELECT COALESCE(pesos, 0) AS PESOS
                                       FROM _max_labperu_DetallePedido_Newmont
                                      WHERE cod_detallepedido = ".$Id_PedidoDetalle."
                                        AND pesos_titulo = 'Peso +'";

                  if ($res_pesopositivo = sqlsrv_query($enlacehost, $q_pesopositivo)) {
                    while($row_pesopositivo = sqlsrv_fetch_array($res_pesopositivo)) {
                      $peso_positivo = $row_pesopositivo["PESOS"];
                    }
                  }
                }

            // Peso Negativo
                $peso_negativo = ($peso_total - $peso_positivo);

            // Identifica los elementos disponibles
                $leyau_positivo = 0;
	            $leyau_negativo = 0;
	            $leyag_positivo = 0;
	            $leyag_negativo = 0;
	            $leyau_newmont = 0;
	            $leyag_newmont = 0;
	            $leyau_newmont2 = 0;
	            $leyag_newmont2 = 0;

            	if (strpos(strtolower($elemento_analisis), 'au') !== false){
            		// Busca la Ley Positiva de Oro
						$q_leyoro = "SELECT COALESCE(Ley_Au_gt, 0) AS LEY
						               FROM _max_labperu_DetallePedido_Newmont
						              WHERE cod_detallepedido = ".$Id_PedidoDetalle."
						                AND pesos_titulo = 'Peso +'";

						if ($res_leyoro = sqlsrv_query($enlacehost, $q_leyoro)) {
							while($row_leyoro = sqlsrv_fetch_array($res_leyoro)) {
								$leyau_positivo = $row_leyoro["LEY"];
							}
						}

					// Busca la Ley Negativa de Oro
						$q_leyoro = "SELECT COALESCE(Ley_Au_gt, 0) AS LEY
						               FROM _max_labperu_DetallePedido_Newmont
						              WHERE cod_detallepedido = ".$Id_PedidoDetalle."
						                AND pesos_titulo = 'Peso -'";

						if ($res_leyoro = sqlsrv_query($enlacehost, $q_leyoro)) {
							while($row_leyoro = sqlsrv_fetch_array($res_leyoro)) {
								$leyau_negativo = $row_leyoro["LEY"];
							}
						}

					// Busca la Ley de Au Newmont
						$q_newmont = "SELECT COALESCE(Ley_Au_gt, 0) AS LEY,
											 COALESCE(Ley_Au_ot, 0) AS LEY2
										FROM _max_labperu_DetallePedido_Newmont
									   WHERE cod_detallepedido = ".$Id_PedidoDetalle."
										 AND pesos_titulo = 'Newmont'";

			            if ($res_newmont = sqlsrv_query($enlacehost, $q_newmont)) {
							while($row_newmont = sqlsrv_fetch_array($res_newmont)) {
								$leyau_newmont = $row_newmont["LEY"];
								$leyau_newmont2 = $row_newmont["LEY2"];
							}
			            }

					$au_x = 1;
            	}

            	if (strpos(strtolower($elemento_analisis), 'ag') !== false){
					// Busca la Ley Positiva de Plata
						$q_leyplata = "SELECT COALESCE(Ley_Ag_gt, 0) AS LEY
										 FROM _max_labperu_DetallePedido_Newmont
										WHERE cod_detallepedido = ".$Id_PedidoDetalle."
										  AND pesos_titulo = 'Peso +'";

						if ($res_leyplata = sqlsrv_query($enlacehost, $q_leyplata)) {
							while($row_leyplata = sqlsrv_fetch_array($res_leyplata)) {
								$leyag_positivo = $row_leyplata["LEY"];
							}
						}

					// Busca la Ley Negativa de Plata
						$q_leyplata = "SELECT COALESCE(Ley_Ag_gt, 0) AS LEY
										 FROM _max_labperu_DetallePedido_Newmont
										WHERE cod_detallepedido = ".$Id_PedidoDetalle."
										  AND pesos_titulo = 'Peso -'";

						if ($res_leyplata = sqlsrv_query($enlacehost, $q_leyplata)) {
							while($row_leyplata = sqlsrv_fetch_array($res_leyplata)) {
								$leyag_negativo = $row_leyplata["LEY"];
							}
						}

					// Busca la Ley de Ag Newmont
						$q_newmont = "SELECT COALESCE(Ley_Ag_gt, 0) AS LEY,
											 COALESCE(Ley_Ag_ot, 0) AS LEY2
			                           FROM _max_labperu_DetallePedido_Newmont
			                          WHERE cod_detallepedido = ".$Id_PedidoDetalle."
			                            AND pesos_titulo = 'Newmont'";

			            if ($res_newmont = sqlsrv_query($enlacehost, $q_newmont)) {
							while($row_newmont = sqlsrv_fetch_array($res_newmont)) {
								$leyag_newmont = $row_newmont["LEY"];
								$leyag_newmont2 = $row_newmont["LEY2"];
							}
			            }

					$ag_x = 1;
            	}
		}

	// // Leyes
	// 	$augt = $_GET["augt"];
	// 	$auot =$_GET["auot"];
	// 	$aggt =$_GET["aggt"];
	// 	$agot =$_GET["agot"];
	// 	$cu =$_GET["cu"];
	// 	$pb =$_GET["pb"];
	// 	$zn = $_GET["zn"];
	// 	$as =$_GET["as"];
	// 	$sb =$_GET["sb"];
	// 	$s =$_GET["s"];
	// 	$fe =$_GET["fe"];
	// 	$ho = $_GET["ho"];

	// Número de Código
		$q_codigoinforme = "SELECT  Correlativo
                              FROM  _max_labperu_CorrelativoInformeEnsayos
                             WHERE  Id_Pedido = ".$Id_Pedido."
                               AND  Id_Detalle_Pedido = ".$Id_PedidoDetalle;

		if ($res_codigoinforme = sqlsrv_query($enlacehost, $q_codigoinforme)) {
			while($row_codigoinforme = sqlsrv_fetch_array($res_codigoinforme)) {
				$correlativo = $row_codigoinforme["Correlativo"];
			}
		}

	// Cantidad de Muestras
		$q_count = "SELECT	COUNT(Id) AS _COUNT
					  FROM	_max_labperu_DetallePedido
					 WHERE	Id_Pedido = ".$Id_Pedido."
					   AND 	Id = ".$Id_PedidoDetalle;

		if ($res_count = sqlsrv_query($enlacehost, $q_count)) {
			while($row_count = sqlsrv_fetch_array($res_count)) {
				$total_muestras = $row_count["_COUNT"];
			}
		}

	// $html = '<!DOCTYPE html>
	// 		 <html lang="es">
	// 			<head>
	// 				<title>Informe de Ensayo - '.$correlativo.'</title>
	// 		    </head>

	// 			<div>
	// 				<img src="images/logos/logo_nuevo.png" width="140px"/>
	// 			</div>

	// 			<div style="margin-left: 20px">
	// 				<div style="margin-top: -40px; text-align: center; font-weight: 900; font-size: 20px">
	// 					INFORME DE ENSAYO N° '.$correlativo.'
	// 				</div>

	// 				<table style="margin-top: 15px">
	// 					<tr style="font-size: 11px">
	// 						<td style="width: 180px">
	// 							Cliente
	// 						</td>

	// 						<td>
	// 							<b>: '.strtoupper($nombre_empresa).'</b>
	// 						</td>
	// 					</tr>';

	// Para el código QR (MAX - QUEDA RESERVADO HASTA QUE DECIDAN)
		// <div style="position: absolute; margin-left: 800px; padding: 20px;">
		// 	<img width="200px" style="margin-top: -50px; border: solid; border-width: 0.5px; border-color: #000000: border-radius: 7px;" src="tmp_files/tmp_qr_'.$Id_Pedido.$Id_PedidoDetalle.'.png"></img>
		// </div>

	$html = '<!DOCTYPE html>
			 <html lang="es">
				<head>
					<title>Informe de Ensayo - '.$correlativo.'</title>
			    </head>

				<div style="margin-top: -35px;">
					<img src="images/logos/logo_nuevo.png" width="120px"/>
				</div>

				<div style="margin-top: -35px; position: absolute; z-index: -1;">
					<img src="images/logos/logo_nuevo.png" width="650px" style="margin-top: 120px; margin-left: 200px; opacity: 0.2"/>
				</div>

				<div style="margin-left: 20px">
					<div style="margin-top: -80px; text-align: center; font-weight: 900; font-size: 20px">
						INFORME DE ENSAYO N° '.$correlativo.'
					</div>

					<table style="margin-top: 15px">
						<tr style="font-size: 11px">
							<td style="width: 180px">
								Cliente
							</td>

							<td>
								<b>: '.strtoupper($cliente).'</b>
							</td>
						</tr>';

						if ($mostrar_contacto == 1){
							$html .= '	<tr style="font-size: 11px">
											<td style="width: 180px">
												Contacto
											</td>

											<td>
												: '.strtoupper($cliente)."&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;&nbsp;DNI / RUC:".$cliente_documento."&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;&nbsp;Teléfono: ".$cliente_telefono.'&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;&nbsp;EMail: '.((strlen($cliente_email) == 0) ? '-' : $cliente_email).'</b>
											</td>
										</tr>';
						}

	$html .=			'<tr style="font-size: 11px">
							<td style="width: 180px">
								Referencia del Cliente
							</td>

							<td>
								<b>: '.$referencia_cliente.'</b>
							</td>
						</tr>

						<tr style="font-size: 11px">
							<td style="width: 180px">
								Cantidad de Muestras
							</td>

							<td>
								<b>: '.$total_muestras.'</b>
							</td>
						</tr>

						<tr style="font-size: 11px">
							<td style="width: 180px">
								Fecha de Recepción
							</td>

							<td>
								<b>: '.$fecha_recepcion.'</b>
							</td>
						</tr>

						<tr style="font-size: 11px">
							<td style="width: 180px">
								Fecha de Inicio de Ensayo
							</td>

							<td>
								<b>: '.$fecha_inicioensayo.'</b>
							</td>
						</tr>

						<tr style="font-size: 11px">
							<td style="width: 180px">
								Fecha de Término de Ensayo
							</td>

							<td>
								<b>: '.$fecha_cierreinforme.'</b>
							</td>
						</tr>

						<tr style="font-size: 11px">
							<td style="width: 180px">
								Lugar de ejecución del ensayo
							</td>

							<td>
								<b>: Lab Perú Minerals S.R.L., Mz. N19, Lote 1C, Parque Industrial, La Esperanza, La Libertad, Perú</b>
							</td>
						</tr>
					</table>

					<table style="margin-top: 15px; border-spacing: 0px;">
						<tr style="font-size: 11px;">
							<td style="width: 180px; text-align: center; border: solid; border-width: 0.5px; border-color: #000000">
								Código de Método
							</td>
							<td style="width: 100%; text-align: center; border: solid; border-width: 0.5px; border-color: #000000">
								Descripción
							</td>
						</tr>';

	// Determinando Métodos de Ensayo y resultados por elemento
		$e = 0;
		$arr_metodos = '';
		$arr_metodos2 = '';
		$elementos = explode('-', $elemento_analisis);
		$q_resultados = '';

		// Verificando si existe un solo elemento
			if (count($elementos) == 0){
				$elementos = explode('', $elemento_analisis);
			}

		while ($e < count($elementos)){
			$elemento = trim(strtolower($elementos[$e]));

			if ($elemento != 'carbon act. (au)' && $elemento != 'carbon act. (au-ag)' && $elemento != 'metalurgica' && $elemento != 'newmont (au - ag)' && $elemento != 'newmont (au)' && $elemento != 'newmont (au' && $elemento != 'ag)'){

				// Obteniendo resultados por cada elemento
					if ($elemento == 'au'){
						$resultado = $augt;
					}

					if ($elemento == 'ag'){
						$resultado = $aggt;
					}

					if ($elemento == 'cu'){
						$resultado = $cu;
					}

					if ($elemento == 'pb'){
						$resultado = $pb;
					}

					if ($elemento == 'zn'){
						$resultado = $zn;
					}

					if ($elemento == 'as'){
						$resultado = $as;
					}

					if ($elemento == 'sb'){
						$resultado = $sb;
					}

					if ($elemento == 's'){
						$resultado = $s;
					}

					if ($elemento == 'fe'){
						$resultado = $fe;
					}

					if ($elemento == 'h2o'){
						$resultado = $ho;
					}

				// Determina el método
					if ($resultado != 99999.99999){
						// $q_metodos = "	SELECT	CONVERT(VARCHAR, ME.orden_metodo) + '**' +
						// 						ME.cod_metodo + '**' +
						// 						ME.nom_metodo + '**' + C.version + '**' + '".$elemento."' + '**' + D.unidad_elemento AS METODOS,
						// 						ME.orden_metodo,
						// 						ME.cod_metodo, D.cod_elemento, D.unidad_elemento, D.cant_decimales,
						// 						'".$resultado."' AS RESULTADO
						// 				  FROM	_max_labperu_MetodosEnsayo_Detalle D
						// 						INNER JOIN _max_labperu_MetodosEnsayo_Cabecera C ON D.metodo_cabecera = C.Id
						// 						INNER JOIN _max_labperu_MetodosEnsayo ME ON D.cod_metodo = ME.Id
						// 				 WHERE	LOWER(D.cod_elemento) = '".$elemento."'
						// 				   AND	CONVERT(FLOAT, ".$resultado.") BETWEEN D.resultado_minimo AND D.resultado_maximo
						// 				   AND	ME.tipo_muestra = ".$cod_tipomuestra."
						// 				   AND	D.estado_metodo = 'A'

						// 				UNION

						// 				SELECT	CONVERT(VARCHAR, ME.orden_metodo) + '**' +
						// 						ME.cod_metodo + '**' +
						// 						ME.nom_metodo + '**' + C.version + '**' + '".$elemento."' + '**' + D.unidad_elemento AS METODOS,
						// 						ME.orden_metodo,
						// 						ME.cod_metodo, D.cod_elemento, D.unidad_elemento, D.cant_decimales,
						// 						'> ' + CONVERT(VARCHAR, D.resultado_maximo) AS RESULTADO
						// 				  FROM	_max_labperu_MetodosEnsayo_Detalle D
						// 						INNER JOIN _max_labperu_MetodosEnsayo_Cabecera C ON D.metodo_cabecera = C.Id
						// 						INNER JOIN _max_labperu_MetodosEnsayo ME ON D.cod_metodo = ME.Id
						// 				 WHERE	LOWER(D.cod_elemento) = '".$elemento."'
						// 				   AND	CONVERT(FLOAT, ".$resultado.") > D.resultado_maximo
						// 				   AND	ME.tipo_muestra = ".$cod_tipomuestra."
						// 				   AND	D.estado_metodo = 'A'";

						// MAX (06/08/2021 17:55): Se comentó este query debido a que la versión ahora se obtiene por rango de fechas
							// $q_metodos = "	SELECT	CONVERT(VARCHAR, E.orden2_elemento) + '**' +
							// 						ME.cod_metodo + '**' +
							// 						ME.nom_metodo + '**' + C.version + '**' + '".$elemento."' + '**' + D.unidad_elemento AS METODOS,
							// 						ME.orden_metodo,
							// 						ME.cod_metodo, D.cod_elemento, D.unidad_elemento, D.cant_decimales,
							// 						'".$resultado."' AS RESULTADO
							// 				  FROM	_max_labperu_MetodosEnsayo_Detalle D
							// 						INNER JOIN _max_labperu_MetodosEnsayo_Cabecera C ON D.metodo_cabecera = C.Id
							// 						INNER JOIN _max_labperu_MetodosEnsayo ME ON D.cod_metodo = ME.Id
							// 						INNER JOIN _max_labperu_Elementos E ON D.cod_elemento = E.cod_elemento
							// 				 WHERE	LOWER(D.cod_elemento) = '".$elemento."'
							// 				   AND	CONVERT(FLOAT, ".$resultado.") BETWEEN D.resultado_minimo AND D.resultado_maximo
							// 				   AND	ME.tipo_muestra = ".(($cod_tipomuestra == 3 || $cod_tipomuestra == 7) ? (($elemento == 'au' || $elemento == 'ag') ? (($cod_tipomuestra == 7) ? 5 : $cod_tipomuestra) : 5) : (($cod_tipomuestra == 7) ? 5 : $cod_tipomuestra))."
							// 				   AND	D.estado_metodo = 'A'";

						// MAX (06/08/2021 17:55): Nuevo query para obtner la versión del Método de Ensayo
							$q_metodos = "	SELECT	CONVERT(VARCHAR, E.orden2_elemento) + '**' +
													ME.cod_metodo + '**' +
													ME.nom_metodo + '**' +

													(SELECT V.version
													   FROM _max_labperu_MetodosEnsayo_Cabecera V
													  WHERE V.cod_metodo = ME.Id
													    AND '".$Fecha_InicioEnsayo_New."' BETWEEN V.fecha_inicio AND ISNULL(V.fech_fin, '".$g_date."'))

													 + '**' + '".$elemento."' + '**' + D.unidad_elemento AS METODOS,
													ME.orden_metodo,
													ME.cod_metodo, D.cod_elemento, D.unidad_elemento, D.cant_decimales,
													'".$resultado."' AS RESULTADO
											  FROM	_max_labperu_MetodosEnsayo_Detalle D
													INNER JOIN _max_labperu_MetodosEnsayo_Cabecera C ON D.metodo_cabecera = C.Id
													INNER JOIN _max_labperu_MetodosEnsayo ME ON D.cod_metodo = ME.Id
													INNER JOIN _max_labperu_Elementos E ON D.cod_elemento = E.cod_elemento
											 WHERE	LOWER(D.cod_elemento) = '".$elemento."'
											   AND	CONVERT(FLOAT, ".$resultado.") BETWEEN D.resultado_minimo AND D.resultado_maximo
											   AND	ME.tipo_muestra = ".(($cod_tipomuestra == 3 || $cod_tipomuestra == 7) ? (($elemento == 'au' || $elemento == 'ag') ? (($cod_tipomuestra == 7) ? 5 : $cod_tipomuestra) : 5) : (($cod_tipomuestra == 7) ? 5 : $cod_tipomuestra))."
											   AND	D.estado_metodo = 'A'";

						$q_resultados .= $q_metodos.' UNION ';

						if ($res_metodos = sqlsrv_query($enlacehost, $q_metodos)) {
		    				$num_rows = 0;

		    				while($row_metodos = sqlsrv_fetch_array($res_metodos)) {

		    					if (strpos($arr_metodos, $row_metodos["orden_metodo"].'**') === false){

		    						$arr_metodos .= $row_metodos["METODOS"].'|';
		    					}

		    					$num_rows += 1;
		    				}

		    				if ($num_rows == 0){
		    					$q_metodos = "	SELECT	CONVERT(VARCHAR, E.orden2_elemento) + '**' +
												ME.cod_metodo + '**' +
												ME.nom_metodo + '**' +

												(SELECT V.version
												   FROM _max_labperu_MetodosEnsayo_Cabecera V
												  WHERE V.cod_metodo = ME.Id
												    AND '".$Fecha_InicioEnsayo_New."' BETWEEN V.fecha_inicio AND ISNULL(V.fech_fin, '".$g_date."'))

												+ '**' + '".$elemento."' + '**' + D.unidad_elemento AS METODOS,
												ME.orden_metodo,
												ME.cod_metodo, D.cod_elemento, D.unidad_elemento, D.cant_decimales,
												'< ' + CONVERT(VARCHAR, D.resultado_minimo) AS RESULTADO
										  FROM	_max_labperu_MetodosEnsayo_Detalle D
												INNER JOIN _max_labperu_MetodosEnsayo_Cabecera C ON D.metodo_cabecera = C.Id
												INNER JOIN _max_labperu_MetodosEnsayo ME ON D.cod_metodo = ME.Id
												INNER JOIN _max_labperu_Elementos E ON D.cod_elemento = E.cod_elemento
										 WHERE	LOWER(D.cod_elemento) = '".$elemento."'
										   AND	CONVERT(FLOAT, ".$resultado.") < D.resultado_minimo
										   AND	ME.tipo_muestra = ".(($cod_tipomuestra == 3 || $cod_tipomuestra == 7) ? (($elemento == 'au' || $elemento == 'ag') ? (($cod_tipomuestra == 7) ? 5 : $cod_tipomuestra) : 5) : (($cod_tipomuestra == 7) ? 5 : $cod_tipomuestra))."
										   AND	D.estado_metodo = 'A'";

								$q_resultados .= $q_metodos.' UNION ';

								if ($res_metodos = sqlsrv_query($enlacehost, $q_metodos)) {
				    				while($_row_metodos = sqlsrv_fetch_array($res_metodos)) {
				    					if (strpos($arr_metodos, $_row_metodos["orden_metodo"].'**') === false){
				    						$arr_metodos .= $_row_metodos["METODOS"].'|';
				    					}
				    				}
				    			}
		    				}
		    			}

		    			// Para el cuadro de resumen de métodos
		    				$q_metodos2 = "	SELECT	CONVERT(VARCHAR, ME.orden_metodo) + '**' +
													ME.cod_metodo + '**' +
													ME.nom_metodo + '**' +

													(SELECT V.version
													   FROM _max_labperu_MetodosEnsayo_Cabecera V
													  WHERE V.cod_metodo = ME.Id
													    AND '".$Fecha_InicioEnsayo_New."' BETWEEN V.fecha_inicio AND ISNULL(V.fech_fin, '".$g_date."'))

													+ '**' + '".$elemento."' + '**' + D.unidad_elemento AS METODOS,
													ME.orden_metodo,
													ME.cod_metodo, D.cod_elemento, D.unidad_elemento, D.cant_decimales,
													'".$resultado."' AS RESULTADO
											  FROM	_max_labperu_MetodosEnsayo_Detalle D
													INNER JOIN _max_labperu_MetodosEnsayo_Cabecera C ON D.metodo_cabecera = C.Id
													INNER JOIN _max_labperu_MetodosEnsayo ME ON D.cod_metodo = ME.Id
													INNER JOIN _max_labperu_Elementos E ON D.cod_elemento = E.cod_elemento
											 WHERE	LOWER(D.cod_elemento) = '".$elemento."'
											   AND	CONVERT(FLOAT, ".$resultado.") BETWEEN D.resultado_minimo AND D.resultado_maximo
											   AND	ME.tipo_muestra = ".(($cod_tipomuestra == 3 || $cod_tipomuestra == 7) ? (($elemento == 'au' || $elemento == 'ag') ? (($cod_tipomuestra == 7) ? 5 : $cod_tipomuestra) : 5) : (($cod_tipomuestra == 7) ? 5 : $cod_tipomuestra))."
											   AND	D.estado_metodo = 'A'";

							if ($res_metodos2 = sqlsrv_query($enlacehost, $q_metodos2)) {
			    				$num_rows = 0;

			    				while($row_metodos2 = sqlsrv_fetch_array($res_metodos2)) {
			    					if (strpos($arr_metodos2, $row_metodos2["orden_metodo"].'**') === false){
			    						$arr_metodos2 .= $row_metodos2["METODOS"].'|';
			    					}

			    					$num_rows += 1;
			    				}

			    				if ($num_rows == 0){
			    					$q_metodos2 = "	SELECT	CONVERT(VARCHAR, ME.orden_metodo) + '**' +
													ME.cod_metodo + '**' +
													ME.nom_metodo + '**' +

													(SELECT V.version
													   FROM _max_labperu_MetodosEnsayo_Cabecera V
													  WHERE V.cod_metodo = ME.Id
													    AND '".$Fecha_InicioEnsayo_New."' BETWEEN V.fecha_inicio AND ISNULL(V.fech_fin, '".$g_date."')) +

													+ '**' + '".$elemento."' + '**' + D.unidad_elemento AS METODOS,
													ME.orden_metodo,
													ME.cod_metodo, D.cod_elemento, D.unidad_elemento, D.cant_decimales,
													'< ' + CONVERT(VARCHAR, D.resultado_minimo) AS RESULTADO
											  FROM	_max_labperu_MetodosEnsayo_Detalle D
													INNER JOIN _max_labperu_MetodosEnsayo_Cabecera C ON D.metodo_cabecera = C.Id
													INNER JOIN _max_labperu_MetodosEnsayo ME ON D.cod_metodo = ME.Id
													INNER JOIN _max_labperu_Elementos E ON D.cod_elemento = E.cod_elemento
											 WHERE	LOWER(D.cod_elemento) = '".$elemento."'
											   AND	CONVERT(FLOAT, ".$resultado.") < D.resultado_minimo
											   AND	ME.tipo_muestra = ".(($cod_tipomuestra == 3 || $cod_tipomuestra == 7) ? (($elemento == 'au' || $elemento == 'ag') ? (($cod_tipomuestra == 7) ? 5 : $cod_tipomuestra) : 5) : (($cod_tipomuestra == 7) ? 5 : $cod_tipomuestra))."
											   AND	D.estado_metodo = 'A'";

									if ($res_metodos2 = sqlsrv_query($enlacehost, $q_metodos2)) {
					    				while($_row_metodos2 = sqlsrv_fetch_array($res_metodos2)) {
					    					if (strpos($arr_metodos2, $_row_metodos2["orden_metodo"].'**') === false){
					    						$arr_metodos2 .= $_row_metodos2["METODOS"].'|';
					    					}
					    				}
					    			}
			    				}
			    			}
// echo '$q_metodos2: '.$q_metodos2;
					}
			}

			$e += 1;
		}

		// Agrega Método para Newmont
			if ($is_newmont == 1){
				$q_metodo_newmont = "SELECT	CONVERT(VARCHAR, E.orden2_elemento) + '**' +
											ME.cod_metodo + '**' +
											ME.nom_metodo + '**' +

											(SELECT V.version
											   FROM _max_labperu_MetodosEnsayo_Cabecera V
											  WHERE V.cod_metodo = ME.Id
											    AND '".$Fecha_InicioEnsayo_New."' BETWEEN V.fecha_inicio AND ISNULL(V.fech_fin, '".$g_date."'))

											+ '**' + 'au' + '**' + D.unidad_elemento AS METODOS,
											ME.orden_metodo,
											ME.cod_metodo, D.cod_elemento, D.unidad_elemento, D.cant_decimales,
											'0' AS RESULTADO
									  FROM	_max_labperu_MetodosEnsayo_Detalle D
											INNER JOIN _max_labperu_MetodosEnsayo_Cabecera C ON D.metodo_cabecera = C.Id
											INNER JOIN _max_labperu_MetodosEnsayo ME ON D.cod_metodo = ME.Id
											INNER JOIN _max_labperu_Elementos E ON D.cod_elemento = E.cod_elemento
									 WHERE	LOWER(D.cod_elemento) = 'au'
									   AND	ME.tipo_muestra = 0
									   AND	D.estado_metodo = 'A'";

				if ($res_metodos2 = sqlsrv_query($enlacehost, $q_metodo_newmont)) {
    				while($row_metodos2 = sqlsrv_fetch_array($res_metodos2)) {
    					$arr_metodos2 .= $row_metodos2["METODOS"].'|';
    				}
    			}
			}

		$arr_metodos = substr($arr_metodos, 0, -1);
		$arr_metodos2 = substr($arr_metodos2, 0, -1);

		$metodos = explode('|', $arr_metodos);
		$metodos2 = explode('|', $arr_metodos2);

		sort($metodos);
		sort($metodos2);

		// Colocando Métodos
			$m = 0;

			// while($m < count($metodos)){
			while($m < count($metodos2)){
				$html .= '		<tr style="font-size: 11px;">';

				$detalle = explode('**', $metodos2[$m]);
				// $detalle = explode('**', $metodos[$m]);

				$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center">';
				$html .= '					'.$detalle[1]. ' / Ver. '.$detalle[3];
				$html .= '				</td>';

				$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000">';
				$html .= '					'.$detalle[2];
				$html .= '				</td>';

				$html .= '			</tr>';

				$m += 1;
			}

			$html .= '			</tr>
					</table>';

	// Recuperando los resultados con cabeceras
		$r = array();
		$q_resultados = substr($q_resultados, 0, -6);

		if ($res_resultados = sqlsrv_query($enlacehost, $q_resultados)) {
			while($row_resultados = sqlsrv_fetch_array($res_resultados)) {
				array_push($r, $row_resultados);
			}
		}

		$html .= '		<table style="margin_top: 40px; border-spacing: 0px; margin-left: -20px; margin_top: 30px; text-align: center;">';

	// Cabeceras Fijas
		$html .= '			<tr style="font-size: 11px;">';

		$html .= '				<td colspan='.(($is_newmont == 1) ? 7 : 6).'>';
		$html .= '				</td>';

		$html .= '				<td '.(($is_newmont == 1) ? 'colspan="2"' : '').' style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; background-color: rgb(229, 255, 255, 0.5);">';
		$html .= '					Método Elemento';
		$html .= '				</td>';

	// Agrega Columnas para Newmont
		if ($is_newmont == 1){
			if ($au_x == 1){
				$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; background-color: rgb(229, 255, 255, 0.5);">';
				$html .= '					<p><font style="font-size: 10px">MLP-005</p>';
				$html .= '				</td>';

				$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; background-color: rgb(229, 255, 255, 0.5);">';
				$html .= '					<p><font style="font-size: 10px">MLP-005</p>';
				$html .= '				</td>';
			}

			if ($ag_x == 1){
				$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; background-color: rgb(229, 255, 255, 0.5);">';
				$html .= '					<p><font style="font-size: 10px">MLP-005</p>';
				$html .= '				</td>';

				$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; background-color: rgb(229, 255, 255, 0.5);">';
				$html .= '					<p><font style="font-size: 10px">MLP-005</p>';
				$html .= '				</td>';
			}
		}

	// Cabeceras Dinámicas (Fijas) - Primeras Cabeceras
		$m = 0;

		while($m < count($r)){
			$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; background-color: rgb(229, 255, 255, 0.5);">';
			// $html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px;">';
			$html .= '					<p><font style="font-size: 10px">'.$r[$m][2].'</p>';
			$html .= '				</td>';

			// // Determinando si es MLP-003 y Au o Ag
			// 	if (($r[$m][2] == 'MLP-003' || $r[$m][2] == 'MLP-001' || $r[$m][2] == 'MLP-010') && (trim(strtolower(strtoupper($r[$m][3]))) == 'au' || trim(strtolower(strtoupper($r[$m][3]))) == 'ag')){
			// 		$html .= '				<td rowspan="2" style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px">';
			// 		$html .= '					<p><font style="font-size: 10px">'.$r[$m][2].'</p></font><p>'.strtoupper($r[$m][3]).'</p>'.'<p>oz/tc<p>';
			// 		$html .= '				</td>';
			// 	}

			// Determinando si es MLP-003 y Au o Ag
				if (($r[$m][2] == 'MLP-003' || $r[$m][2] == 'MLP-001' || $r[$m][2] == 'MLP-010') && (trim(strtolower(strtoupper($r[$m][3]))) == 'au' || trim(strtolower(strtoupper($r[$m][3]))) == 'ag')){
					$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; background-color: rgb(229, 255, 255, 0.5);">';
					// $html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px;">';
					$html .= '					<p><font style="font-size: 10px">'.$r[$m][2].'</p>';
					$html .= '				</td>';
				}

			$m += 1;
		}

		$html .= '			</tr>';

	// Segundas Cabeceras
		$html .= '			<tr style="font-size: 10px;">';

		$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 5% !important;">';
		$html .= '					N°';
		$html .= '				</td>';

		$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 10% !important;">';
		$html .= '					Cód. Cliente';
		$html .= '				</td>';

		$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle">';
		$html .= '					Tipo Ensayo';
		$html .= '				</td>';

		$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle">';
		$html .= '					Tipo Muestra';
		$html .= '				</td>';

		$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle">';
		$html .= '					Presentación Muestra';
		$html .= '				</td>';

		$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle">';
		$html .= '					Cód. Laboratorio';
		$html .= '				</td>';

		$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; background-color: rgb(229, 255, 255, 0.5);">';
		// $html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 10%">';
		$html .= '					Observación';
		$html .= '				</td>';

		// Agrega Columnas para Newmont
			if ($is_newmont == 1){
				$html .= '				<td colspan="2" style="width: 70px; text-align: center; border: solid; border-width: 0.5px; border-color: #000000; background-color: rgb(229, 255, 255, 0.5);">';
				$html .= '					Pesos (g)';
				$html .= '				</td>';

				if ($au_x == 1){
					$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; background-color: rgb(229, 255, 255, 0.5);">';
					$html .= '					<b><p style="margin-top: 5px">Au</p>'.'<p style="margin-top: -15px">g/tm<p></b>';
					$html .= '				</td>';

					$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; background-color: rgb(229, 255, 255, 0.5);">';
					$html .= '					<b><p style="margin-top: 5px">Au</p>'.'<p style="margin-top: -15px">oz/tc<p></b>';
					$html .= '				</td>';
				}

				if ($ag_x == 1){
					$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; background-color: rgb(229, 255, 255, 0.5);">';
					$html .= '					<b><p style="margin-top: 5px">Ag</p>'.'<p style="margin-top: -15px">g/tm<p></b>';
					$html .= '				</td>';

					$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; background-color: rgb(229, 255, 255, 0.5);">';
					$html .= '					<b><p style="margin-top: 5px">Ag</p>'.'<p style="margin-top: -15px">oz/tc<p></b>';
					$html .= '				</td>';
				}
			}

		// Agregando elementos
			$m_x = 0;

		while($m_x < count($r)){
			$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; background-color: rgb(229, 255, 255, 0.5);">';
			// $html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px;">';
			$html .= '					<b><p style="margin-top: 5px">'.$r[$m_x][3].'</p>'.'<p style="margin-top: -15px">'.strtolower($r[$m_x][4]).'<p></b>';
			$html .= '				</td>';

			// Determinando si es MLP-003 y Au o Ag
				if (($r[$m_x][2] == 'MLP-003' || $r[$m_x][2] == 'MLP-001' || $r[$m_x][2] == 'MLP-010') && (trim(strtolower(strtoupper($r[$m_x][3]))) == 'au' || trim(strtolower(strtoupper($r[$m_x][3]))) == 'ag')){
					$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; background-color: rgb(229, 255, 255, 0.5);">';
					// $html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px;">';
					$html .= '					<b><p style="margin-top: 5px">'.$r[$m_x][3].'</p><p style="margin-top: -15px">oz/tc<p></b>';
					$html .= '				</td>';
				}

			$m_x += 1;
		}

		$html .= '			</tr>';

	// Agregando resultados
		$html .= '			<tr style="font-size: 10px;">';

		$html .= '				<td '.(($is_newmont == 1) ? 'rowspan="4"' : '').' style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle;">';
		$html .= '					1';
		$html .= '				</td>';

		$html .= '				<td '.(($is_newmont == 1) ? 'rowspan="4"' : '').' style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle;">';
		$html .= '					'.$nom_muestra;
		$html .= '				</td>';

		$html .= '				<td '.(($is_newmont == 1) ? 'rowspan="4"' : '').' style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 60px">';
		$html .= '					'.$tipo_ensayo;
		$html .= '				</td>';

		$html .= '				<td '.(($is_newmont == 1) ? 'rowspan="4"' : '').' style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 60px">';
		$html .= '					'.$tipo_muestra;
		$html .= '				</td>';

		$html .= '				<td '.(($is_newmont == 1) ? 'rowspan="4"' : '').' style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 60px">';
		$html .= '					'.$detalle_envase;
		$html .= '				</td>';

		$html .= '				<td '.(($is_newmont == 1) ? 'rowspan="4"' : '').' style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 40px">';
		$html .= '					'.$codigo_interno;
		$html .= '				</td>';

		$html .= '				<td '.(($is_newmont == 1) ? 'rowspan="4"' : '').' style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 40px">';
		$html .= '					'.$obs_reporte;
		$html .= '				</td>';

		// Agregando primera fila de pesos y Malla para los Newmont
			if ($is_newmont == 1){
				$html .= '				<td style="width: 70px; text-align: center; border: solid; border-width: 0.5px; border-color: #000000; background-color: rgb(229, 255, 255, 0.5);">';
				$html .= '					Peso Total';
				$html .= '				</td>';

				$html .= '				<td style="width: 70px; text-align: center; border: solid; border-width: 0.5px; border-color: #000000">';

				// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
				// $html .= '						Lab Perú Minerals S.R.L.';
				// $html .= '					</label></div>';

				$html .= '					'.$peso_total;
				$html .= '				</td>';

				$html .= '				<td colspan="'.(($au_x == 1 && $ag_x == 1) ? 4 : 2).'" style="width: 70px; text-align: center; border: solid; border-width: 0.5px; border-color: #000000">';

				// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
				// $html .= '						Lab Perú Minerals S.R.L.';
				// $html .= '					</label></div>';

				$html .= '					Malla: '.$malla;
				$html .= '				</td>';
			}

		// Agregando resultados por elemento
			$m = 0;

			while($m < count($r)){
				$html .= '				<td '.(($is_newmont == 1) ? 'rowspan="4"' : '').' style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; font-size: 12px;">';

				// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
				// $html .= '						Lab Perú Minerals S.R.L.';
				// $html .= '					</label></div>';

				// Determinando el resultado
					$simbolo_1 = 0;
                    $simbolo_2 = 0;
                    $resultado = '';
                    $menor_que = 0;

					// Verifica si es: "-"
                        if (f_VerificaSimbolo(1, $r[$m][6]) == 1){
                            $simbolo_1 = 1;
                        }

                        if (substr(trim($r[$m][6]), 0, 1) == '<' || substr(trim($r[$m][6]), 0, 1) == '>'){
                            $simbolo_2 = 1;

                            if (substr(trim($r[$m][6]), 0, 1) == '<'){
                            	$menor_que = 1;
                            }

                            $resultado = str_replace('<', '&lt;', $r[$m][6]);
                        }

                   	// // Verifica si es: "<" ó ">"
                    //     $total_CEROS = f_VerificaSimbolo(2, $r[$m][6]);

                    //     if ($total_CEROS >= 7){
                    //         $simbolo_2 = 1;

                    //         $resultado = f_GetResultadoSimbolo($total_CEROS, $r[$m][6]);

                    //         if (substr(trim($resultado), 0, 1) == '<'){
                    //         	$menor_que = 1;
                    //         }

                    //         $resultado = str_replace('<', '&lt;', $resultado);
                    //     }

					// Resultado final
                        $resultado = (($simbolo_1 == 1) ? '-' : (($simbolo_2 == 1) ? $resultado : number_format($r[$m][6], $r[$m][5], '.', ',')));

				// $html .= '					'.number_format($r[$m][6], $r[$m][5], '.', ',');
				$html .= '					<label style="margin-top: -10px;">';
				$html .= '						'.$resultado;
				$html .= '					</label>';
				// $html .= "					&lt; 25.3";
				$html .= '				</td>';

				// Determinando si es MLP-003 y Au o Ag
					if (($r[$m][2] == 'MLP-003' || $r[$m][2] == 'MLP-001' || $r[$m][2] == 'MLP-010') && (trim(strtolower(strtoupper($r[$m][3]))) == 'au' || trim(strtolower(strtoupper($r[$m][3]))) == 'ag')){

						if ($menor_que == 1){
							$resultado = '--';
						}
						else{
							$resultado = (($resultado == null) ? '' : f_GetResultadoOnzas($resultado, trim(strtolower(strtoupper($r[$m][3])))));
							// $resultado = (($simbolo_1 == 1) ? '-' : (($simbolo_2 == 1) ? $resultado : number_format(($r[$m][6] / 34.285), $r[$m][5], '.', ',')));
							$resultado = (($simbolo_1 == 1) ? '-' : (($simbolo_2 == 1) ? $resultado : number_format(($r[$m][6] / 34.285), 2, '.', ',')));
						}

						$html .= '				<td '.(($is_newmont == 1) ? 'rowspan="4"' : '').' style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; font-size: 12px;">';

						// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
						// $html .= '						Lab Perú Minerals S.R.L.';
						// $html .= '					</label></div>';

						// $html .= '					'.number_format(($r[$m][6] / 34.285), $r[$m][5], '.', ',');
						$html .= '					<label style="margin-top: -10px;">';
						$html .= '						'.$resultado;
						$html .= '					</label>';
						$html .= '				</td>';
					}

				$m += 1;
			}

		$html .= '			</tr>';

		// Agregando las demás filas de Newmont
			if ($is_newmont == 1){
				// Resultado para el Positivo
					$html .= '			<tr style="font-size: 10px;">';

					$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; font-size: 9px; background-color: rgb(229, 255, 255, 0.5);">';
					$html .= '					Peso +';
					$html .= '				</td>';
					$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; font-size: 9px;">';

					// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
					// $html .= '						Lab Perú Minerals S.R.L.';
					// $html .= '					</label></div>';

					$html .= '					'.$peso_positivo;
					$html .= '				</td>';

					if ($au_x == 1){
						$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px;">';

						// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
						// $html .= '						Lab Perú Minerals S.R.L.';
						// $html .= '					</label></div>';

						$html .= '					'.$leyau_positivo;
						$html .= '				</td>';

						$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px;">';

						// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
						// $html .= '						Lab Perú Minerals S.R.L.';
						// $html .= '					</label></div>';

						$html .= '					'.f_GetResultadoOnzas($leyau_positivo, 'au');
						$html .= '				</td>';
					}

					if ($ag_x == 1){
						$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px;">';

						// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
						// $html .= '						Lab Perú Minerals S.R.L.';
						// $html .= '					</label></div>';

						$html .= '					'.$leyag_positivo;
						$html .= '				</td>';

						$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px;">';

						// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
						// $html .= '						Lab Perú Minerals S.R.L.';
						// $html .= '					</label></div>';

						$html .= '					'.f_GetResultadoOnzas($leyag_positivo, 'au');
						$html .= '				</td>';
					}

					$html .= '			</tr>';

				// Resultados para el Negativo
					$html .= '			<tr style="font-size: 10px;">';

					$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; font-size: 9px; background-color: rgb(229, 255, 255, 0.5);">';
					$html .= '					Peso -';
					$html .= '				</td>';
					$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; font-size: 9px;">';

					// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
					// $html .= '						Lab Perú Minerals S.R.L.';
					// $html .= '					</label></div>';

					$html .= '					'.$peso_negativo;
					$html .= '				</td>';

					if ($au_x == 1){
						$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px;">';

						// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
						// $html .= '						Lab Perú Minerals S.R.L.';
						// $html .= '					</label></div>';

						$html .= '					'.$leyau_negativo;
						$html .= '				</td>';

						$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px;">';

						// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
						// $html .= '						Lab Perú Minerals S.R.L.';
						// $html .= '					</label></div>';

						$html .= '					'.f_GetResultadoOnzas($leyau_negativo, 'au');
						$html .= '				</td>';
					}

					if ($ag_x == 1){
						$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px;">';

						// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
						// $html .= '						Lab Perú Minerals S.R.L.';
						// $html .= '					</label></div>';

						$html .= '					'.$leyag_negativo;
						$html .= '				</td>';

						$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px;">';

						// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
						// $html .= '						Lab Perú Minerals S.R.L.';
						// $html .= '					</label></div>';

						$html .= '					'.f_GetResultadoOnzas($leyag_negativo, 'au');
						$html .= '				</td>';
					}

					$html .= '			</tr>';

				// Resultados Newmont
					$html .= '			<tr style="font-size: 10px;">';

					$html .= '				<td colspan="2" style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px; font-size: 9px; background-color: rgb(229, 255, 255, 0.5);">';
					$html .= '					Resultados Newmont';
					$html .= '				</td>';

					if ($au_x == 1){
						$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px;">';

						// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
						// $html .= '						Lab Perú Minerals S.R.L.';
						// $html .= '					</label></div>';

						$html .= '					'.round($leyau_newmont, 2);
						$html .= '				</td>';

						$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px;">';

						// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
						// $html .= '						Lab Perú Minerals S.R.L.';
						// $html .= '					</label></div>';

						$html .= '					'.number_format(f_GetResultadoOnzas($leyau_newmont, 'au'), 2, '.', ',');
						$html .= '				</td>';
					}

					if ($ag_x == 1){
						$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px;">';

						// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
						// $html .= '						Lab Perú Minerals S.R.L.';
						// $html .= '					</label></div>';

						$html .= '					'.round($leyag_newmont);
						$html .= '				</td>';

						$html .= '				<td style="border: solid; border-width: 0.5px; border-color: #000000; text-align: center; vertical-align: middle; width: 45px;">';

						// $html .= '					<div style="margin-top: 3px;"><label style="font-size: 4px; display: flex; color: #737373; margin-top: -15px;">';
						// $html .= '						Lab Perú Minerals S.R.L.';
						// $html .= '					</label></div>';

						$html .= '					'.number_format(f_GetResultadoOnzas($leyag_newmont, 'ag'), 2, '.', ',');
													  // number_format($row_detalle["dPrecio_Neto"], 2, '.', ',');
						$html .= '				</td>';
					}

					$html .= '			</tr>';
			}
// return;
		$html .= '		</table>
					</div>';

	// Agregando Pie de Página
		$html .= '	<div style="vertical-align: bottom; font-size: 11px; position: absolute; margin-top: 20px">';

		// $html .= '		<b>Notas de almacenaje: </b>Las muestras podrán ser retiradas por los interesados transcurrido el tiempo de almacenamiento que es de 20 días calendario para Contramuestras y 30 días para rechazos o gruesos, caso contrario se procederá a desecharlas.';

		$html .= '		<b>"Las muestras podrán ser retiradas por los interesados transcurrido el tiempo de almacenamiento que es de 20 días calendario a partir de la fecha de recepción para Contramuestras, rechazos o gruesos, caso contrario se procederá a desecharlas".<b>';

		$html .= '	</div>';
		
	// Obteniendo fecha de emisión
		$fecha = explode('/', $fecha_cierreinforme);

		$html .= '	<div style="vertical-align: bottom; font-size: 11px; position: absolute; margin-top: 50px">';

		$html .= '		Emitido en Trujillo - Perú, '.$fecha[0].' de '.strtolower(nombre_meses($fecha[1])). ' del '.$fecha[2];

		$html .= '	</div>';

	// Firma
		'tmp_qr_' + _Id_Pedido + _Id_DetallePedido + '.png';

		$html .= '<table>';
		$html .= '	<tr>';
		$html .= '		<td style="width: 380px; text-align: right;">';
		$html .= '			<img width="100px" style="margin-top: 50px; border: solid; border-width: 0.5px; border-color: #000000: border-radius: 7px;" src="tmp_files/tmp_qr_'.$Id_Pedido.$Id_PedidoDetalle.'.png"></img>';
		$html .= '		</td>';
		
		$html .= '		<td>';
		$html .= '			<div style="vertical-align: bottom; font-size: 11px; position: absolute; margin-top: 110px; text-align: center; width: 300px; margin-left: -30px; margin-top: 100px; ">';

		$html .= '				<div style="position: absolute; margin-left: 100px; margin-top: -40px;">';
		$html .= '					<img src="images/firmas/diana.jpg"></img><font color="#ffffff">................</font>';
		$html .= '				</div>';
		$html .= '				<div>';
		$html .= '				--------------------------------------------------';
		$html .= '				</div>';
		$html .= '				<div style="margin-left: 40px;">';
		$html .= '					Ing. Diana Silvestre<font color="#ffffff">.............</font>';
		$html .= '				</div>';
		$html .= '				<div style="margin-left: 20px;">';
		$html .= '					Jefe de Laboratorio Químico<font color="#ffffff">.......</font>';
		$html .= '				</div>';
		$html .= '				<div style="margin-left: 50px;">';
		$html .= '					CIP : 185141<font color="#ffffff">..................</font>';
		$html .= '				</div>';

		$html .= '			</div>';
		$html .= '		</td>';

		$html .= '		<td style="width: 200px;">';

		$html .= '		</td>';
		$html .= '	</tr>';
		$html .= '</table>';

		

	// Finalizando html
		$html .= '</html>';

	$document = new Dompdf();

	$document -> loadHtml($html,'UTF-8');
	$document -> setPaper('A4', 'landscape');
	$document -> render();
	$document -> stream("Informe de Ensayos - ".$correlativo, array('Attachment' => 0));

?>
