<?php
  
  session_start();

  include('../../php/conn.php');

  if(!isset($_SESSION["id"])){
    header('Location: index.php');
  }

  mysqli_query($enlace, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");
  mysqli_query($enlacehost, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");

?>

<!DOCTYPE html>
<html lang="es">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <!-- Meta, title, CSS, favicons, etc. -->
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <title>LIMS | Programa Diario</title>

        <!-- Bootstrap -->
        <link href="../vendors/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
        <!-- Font Awesome -->
        <link href="../vendors/font-awesome/css/font-awesome.min.css" rel="stylesheet">
        <!-- NProgress -->
        <link href="../vendors/nprogress/nprogress.css" rel="stylesheet">
        <!-- iCheck -->
        <link href="../vendors/iCheck/skins/flat/green.css" rel="stylesheet">
        <!-- bootstrap-progressbar -->
        <link href="../vendors/bootstrap-progressbar/css/bootstrap-progressbar-3.3.4.min.css" rel="stylesheet">
        <!-- JQVMap -->
        <link href="../vendors/jqvmap/dist/jqvmap.min.css" rel="stylesheet"/>
        <!-- bootstrap-daterangepicker -->
        <link href="../vendors/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
        <!-- Ion.RangeSlider -->
        <link href="../vendors/normalize-css/normalize.css" rel="stylesheet">
        <link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.css" rel="stylesheet">
        <link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.skinFlat.css" rel="stylesheet">
        <!-- Bootstrap Colorpicker -->
        <link href="../vendors/mjolnic-bootstrap-colorpicker/dist/css/bootstrap-colorpicker.min.css" rel="stylesheet">
        <link href="../vendors/cropper/dist/cropper.min.css" rel="stylesheet">
        <!-- Datatables -->
        <link href="../vendors/datatables.net-bs/css/dataTables.bootstrap.min.css" rel="stylesheet">
        <link href="../vendors/datatables.net-buttons-bs/css/buttons.bootstrap.min.css" rel="stylesheet">
        <link href="../vendors/datatables.net-fixedheader-bs/css/fixedHeader.bootstrap.min.css" rel="stylesheet">
        <link href="../vendors/datatables.net-responsive-bs/css/responsive.bootstrap.min.css" rel="stylesheet">
        <link href="../vendors/datatables.net-scroller-bs/css/scroller.bootstrap.min.css" rel="stylesheet">

        <!-- bootstrap-datetimepicker -->
        <link href="../vendors/bootstrap-datetimepicker/build/css/bootstrap-datetimepicker.css" rel="stylesheet">

        <!-- Switchery -->
        <link href="../vendors/switchery/dist/switchery.min.css" rel="stylesheet">

        <!-- Custom Theme Style -->
        <link href="../build/css/custom.min.css" rel="stylesheet">

        <script type="text/javascript">
            var total = 0;
            var _selectedCI = '';
        </script>

        <style type="text/css">
            th {
                position: sticky;
                top: 0px;
                background-color: #12537E;
            }
        </style>
    </head>

    <body class="nav-md" onload="f_LoadResultados(1); f_LoadElementos();" style="zoom: 80%">
        <div class="container body">
            <div class="main_container">
                <?php include('partes/sidebar.php'); ?>

                <!-- page content -->
                <div class="right_col" role="main">
                    <div class="">
                        <div class="row">
                            <div class="col-md-12 col-sm-12 col-xs-12">
                                <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                    <div class="x_title">
                                        <h2>
                                            Programa Diario de Producción
                                        </h2>
                                        <div class="clearfix">
                                        </div>
                                    </div>

                                    <div class="x_content">
                                        <!-- Filtros -->
                                        <div class="col-md-5 col-sm-5 col-xs-12">
                                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                                <div class="x_title">
                                                    <h2>
                                                        <font style="font-size: 14px"><b>Por fecha de recepción</b></font>
                                                    </h2>
                                                    <div class="clearfix">
                                                    </div>
                                                </div>
                                                <div class="x_content">
                                                    <div class="form-group col-md-6 col-sm-6 col-xs-12" style="margin-top: 9px;">
                                                        <div class="col-md-12 col-sm-12 col-xs-12">
                                                            <?php
                                                                date_default_timezone_set("America/Lima"); 
                                                                $time = date('Y-m-d');

                                                                echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_inicio" value="'.$time.'"/>';
                                                            ?>
                                                        </div>
                                                    </div>

                                                    <div class="form-group col-md-6 col-sm-6 col-xs-12" style="margin-top: 9px;">
                                                        <div class="col-md-12 col-sm-12 col-xs-12">
                                                            <?php
                                                                echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_fin" value="'.$time.'"/>';
                                                            ?>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="col-md-3 col-sm-3 col-xs-12">
                                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                                <div class="x_title">
                                                    <h2>
                                                        <font style="font-size: 14px"><b>Por Clientes</b></font>
                                                    </h2>
                                                    <div class="clearfix">
                                                    </div>
                                                </div>
                                                <div class="x_content">
                                                    <div class="row" style="margin-top: 8px">
                                                        <div class="form-group col-md-5 col-sm-5 col-xs-12" style="text-align: right;">
                                                            <div class="col-md-12 col-sm-12 col-xs-12">
                                                                <input type="number" id="dni_cliente" placeholder="DNI / RUC" class="form-control col-md-12 col-xs-12" onkeyup="f_BuscarClientes(1)" style="width: 140px;">
                                                            </div>
                                                        </div>

                                                        <div class="form-group col-md-7 col-sm-7 col-xs-12" style="text-align: left;">
                                                            <div class="col-md-12 col-sm-12 col-xs-12">
                                                                <input type="text" id="nom_cliente" placeholder="Nombre de Cliente" class="form-control col-md-12 col-xs-12" onkeyup="f_BuscarClientes(2)">
                                                            </div>
                                                        </div>
                                                    </div>

                                                    <div class="row" id="div_buscarclientes" style="display: none;">
                                                        <div class="row" style="background-color: #9CB6D9; height: 30px; border: solid; border-width: 1px; border-color: #829BCD; border-radius: 7px; text-align: center;">
                                                            <label style="margin-top: -5px"><h2><b><font color="#ffffff" style="font-size: 15px">
                                                                Búsqueda de Clientes
                                                            </font></b></h2></label>
                                                        </div>

                                                        <div class="row" id="div_sinclientes" style="border: solid; border-width: 1px; border-color: #D9D9D9; background-color: #F22727; color: #ffffff"><center>
                                                            No se encontraron resultados
                                                        </center></div>

                                                        <div class="row" style="overflow: auto; height: 150px">
                                                            <table class="table table-striped jambo_table bulk_action">
                                                                <thead>
                                                                    <tr>
                                                                        <th style="width: 2%"><center>
                                                                            Item
                                                                        </center></th>
                                                                        <th style="width: 18%"><center>
                                                                            DNI / RUC
                                                                        </center></th>
                                                                        <th style="width: 80%"><center>
                                                                            Nombres
                                                                        </center></th>
                                                                    </tr>
                                                                </thead>

                                                                <tbody id="tabla_busquedaclientes">
                                                                    
                                                                </tbody>
                                                            </table>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="col-md-2 col-sm-2 col-xs-12">
                                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                                <div class="x_title">
                                                    <h2>
                                                        <font style="font-size: 14px"><b>Por Sucursal</b></font>
                                                    </h2>
                                                    <div class="clearfix">
                                                    </div>
                                                </div>

                                                <div class="x_content">
                                                    <div class="row" style="margin-top: 8px">
                                                        <div class="form-group col-md-12 col-sm-12 col-xs-12">
                                                            <div class="col-md-12 col-sm-12 col-xs-12">
                                                                <select id="lista_sucursal" class="form-control col-md-12 col-sm-12 col-xs-12" style="margin-top: 2px; text-align: left;" required>
                                                                    <option selected value="">Elija una opción...</option>

                                                                    <?php
                                                                        $s = 1;

                                                                        $q_sucursal = "SELECT   Id,
                                                                                                des_sucursal
                                                                                         FROM   _max_labperu_Sucursales
                                                                                        WHERE   estado_sucursal = 'A'";

                                                                        if ($res_sucursal = sqlsrv_query($enlacehost, $q_sucursal)) {
                                                                            while($row_sucursal = sqlsrv_fetch_array($res_sucursal)) {
                                                                                echo '<option value="'.$row_sucursal["Id"].'">'.$row_sucursal["des_sucursal"].'</option>';

                                                                                 $s += 1;
                                                                            }
                                                                        }
                                                                    ?>

                                                                </select>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="col-md-2 col-sm-2 col-xs-12">
                                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                                <div class="x_title">
                                                    <h2>
                                                        <font style="font-size: 14px"><b>Por Nombre Muestra</b></font>
                                                    </h2>
                                                    <div class="clearfix">
                                                    </div>
                                                </div>

                                                <div class="x_content">
                                                    <div class="row" style="margin-top: 8px">
                                                        <div class="form-group col-md-12 col-sm-12 col-xs-12" style="text-align: left;">
                                                            <div class="col-md-12 col-sm-12 col-xs-12">
                                                                <input type="text" id="nom_muestra" placeholder="Nombre Muestra" class="form-control col-md-12 col-xs-12">
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="col-md-6 col-sm-6 col-xs-12">
                                            <button class="btn btn-success" type="button" onclick="f_LoadResultados(1)" style="width: 100%; background-color: #26B99A">
                                                 <b>Ejecutar Búsqueda</b>
                                            </button>
                                        </div>

                                        <div class="col-md-2 col-sm-2 col-xs-6">
                                            <button class="btn btn-success" type="button" onclick="f_ClearBusqueda()" style="width: 100%; background-color: #3D3D3D;">
                                                 <b>Limpiar Búsqueda</b>
                                            </button>
                                        </div>

                                        <div class="col-md-2 col-sm-2 col-xs-6">
                                            <button class="btn btn-success" type="button" onclick="f_ExportToExcel()" style="width: 100%;">
                                                <b>Descargar a Excel</b>
                                            </button>
                                        </div>

                                        <div class="col-md-2 col-sm-2 col-xs-6">
                                            <button class="btn btn-success" type="button" onclick="f_ExportToExcelLQ()" style="width: 100%;">
                                                <b>Descarga L.Q.</b>
                                            </button>
                                        </div>

                                        <div class="col-md-12 col-sm-12 col-xs-12">
                                            <div id="div_elementos" class="col-md-1 col-sm-1 col-xs-12" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px; padding-top: 15px; padding-left: 15px; padding-bottom: 8px; text-align: center;">
                                            </div>

                                            <div id="div_chart" class="col-md-11 col-sm-11 col-xs-11" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px; height: 250px;">

                                            </div>
                                        </div>

                                        <div class="col-md-12 col-sm-12 col-xs-12" style="margin-top: 5px">
                                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                                <div class="x_title">
                                                    <div class="col-md-6 col-sm-6 col-xs-6">
                                                        <h2>
                                                            Detalle de Muestras Recepcionadas
                                                        </h2>
                                                    </div>

                                                    <div class="col-md-6 col-sm-6 col-xs-6">
                                                        <div class="col-md-4 col-sm-4 col-xs-4">
                                                            <div class="col-md-7 col-sm-7 col-xs-7" style=" border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; background-color: #3EB595; color: #ffffff;">
                                                                Cumplidos
                                                            </div>
                                                            <div id="th_cumplidos" class="col-md-5 col-sm-5 col-xs-5" style=" border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold;">

                                                            </div>
                                                        </div>

                                                        <div class="col-md-4 col-sm-4 col-xs-4">
                                                            <div class="col-md-7 col-sm-7 col-xs-7" style=" border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; background-color: #D95252; color: #ffffff;">
                                                                No Cumplidos
                                                            </div>
                                                            <div id="th_nocumplidos" class="col-md-5 col-sm-5 col-xs-5" style=" border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold;">

                                                            </div>
                                                        </div>

                                                        <div class="col-md-4 col-sm-4 col-xs-4">
                                                            <div class="col-md-7 col-sm-7 col-xs-7" style=" border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; background-color: #ffffff; color: #D95252;">
                                                                Pendientes
                                                            </div>
                                                            <div id="th_pendientes" class="col-md-5 col-sm-5 col-xs-5" style=" border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: bold;">

                                                            </div>
                                                        </div>
                                                    </div>

                                                    <div class="clearfix">
                                                    </div>
                                                </div>

                                                <div class="x_content">
                                                    <div class="col-md-5 col-sm-5 col-xs-12">
                                                        <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px; background-color: #C1D5DA;">
                                                            <div class="x_title">
                                                                <h2>
                                                                    <font style="font-size: 14px"><b>Buscar Programados</b></font>
                                                                </h2>
                                                                <div class="clearfix">
                                                                </div>
                                                            </div>

                                                            <div class="x_content">
                                                                <div class="col-md-12 col-sm-12 col-xs-12">
                                                                    <label class="control-label col-md-3 col-sm-3 col-xs-3" style="margin-top: 6px; text-align: right;">
                                                                        Fecha Hora
                                                                    </label>
                                                                    <div class="col-md-5 col-sm-5 col-xs-5">
                                                                        <select id="lista_Programados" class="form-control" required>
                                                                        </select>
                                                                    </div>
                                                                    <button class="btn btn-info col-md-2 col-sm-2 col-xs-2" type="button" onclick="f_LoadResultados(0)" style="border-color: #ffffff;">
                                                                         <b>Buscar</b>
                                                                    </button>
                                                                    <button class="btn btn-info col-md-1 col-sm-1 col-xs-1" type="button" onclick="f_ClearProgramados(1)" style="text-align: center; background-color: #3D3D3D; border-color: #ffffff;">
                                                                         <b>X</b>
                                                                    </button>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>

                                                    <div class="col-md-7 col-sm-7 col-xs-12">
                                                        <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px; background-color: #D95252; color: #ffffff;">
                                                            <div class="x_title">
                                                                <h2>
                                                                    <font style="font-size: 14px"><b>Realizar Programa</b></font>
                                                                        <label style="font-size: 13px; color: #FFEB4D;">
                                                                            (Estos campos de horas están relacionados con los campos de fechas del filtro superior respectivamente)
                                                                        </label>
                                                                </h2>
                                                                <div class="clearfix">
                                                                </div>
                                                            </div>

                                                            <div class="x_content">
                                                                <div class="col-md-12 col-sm-12 col-xs-12">
                                                                    <div class="col-md-3 col-sm-3 col-xs-3">
                                                                        <input type="time" class="form-control col-md-12 col-xs-12" id="hora_inicio"/>
                                                                    </div>
                                                                    <div class="col-md-3 col-sm-3 col-xs-3">
                                                                        <input type="time" class="form-control col-md-12 col-xs-12" id="hora_fin"/>
                                                                    </div>
                                                                    <button class="btn btn-info col-md-2 col-sm-2 col-xs-2" type="button" onclick="f_BuscarIntervaloHoras()" style="border-color: #ffffff;">
                                                                         <b>Buscar</b>
                                                                    </button>
                                                                    <button class="btn btn-info col-md-1 col-sm-1 col-xs-1" type="button" onclick="f_ClearProgramados(2)" style="text-align: center; background-color: #3D3D3D; border-color: #ffffff;">
                                                                         <b>X</b>
                                                                    </button>
                                                                    <div class="col-md-1 col-sm-1 col-xs-1" style="border-left: solid; border-width: 1px; border-color: #ffffff; height: 35px; margin-left: 15px;">
                                                                    </div>
                                                                    <button class="btn btn-warning col-md-2 col-sm-2 col-xs-2" type="button" style="margin-left: -30px; border-color: #ffffff;" onclick="f_OpenPrograma()">
                                                                         <b>Programar</b>
                                                                    </button>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>

                                                    <div class="col-md-12 col-sm-12 col-xs-12">
                                                        <div class="table-box" style="height: 1000px; overflow-y: scroll;">
                                                            <table class="table table-striped jambo_table bulk_action">
                                                                <thead>
                                                                    <tr>
                                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; border-top-left-radius: 15px;"><center>
                                                                            Item
                                                                        </center></th>
                                                                        <th rowspan="2" style=" border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                                            Oficina
                                                                        </center></th>
                                                                        <!-- <th style=" border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                                            N° Recibo
                                                                        </center></th> -->
                                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                                            Cliente
                                                                        </center></th>
                                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 120px;"><center>
                                                                            Fecha Hora Registro en Recepción
                                                                        </center></th>
                                                                        <!-- <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 120px;"><center>
                                                                            Fecha Hora Programada en Recepción
                                                                        </center></th> -->
                                                                        <!-- <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                                            Fecha Hora Reporte
                                                                        </center></th> -->
                                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                                            Medio Pago
                                                                        </center></th>
                                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 120px; background-color: #049DBF;"><center>
                                                                            Muestra
                                                                        </center></th>
                                                                        <!-- <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #7B62D9;"><center>
                                                                            N° Informe Ensayos
                                                                        </center></th> -->
                                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                                            Elementos Análisis
                                                                        </center></th>
                                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                                            Peso Muestra (Kg)
                                                                        </center></th>
                                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                                            Estado Muestra
                                                                        </center></th>
                                                                        <!-- <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                                            Detalle Envase
                                                                        </center></th> -->
                                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                                            Tipo Muestra
                                                                        </center></th>
                                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                                            Tipo Análisis
                                                                        </center></th>
                                                                        <!-- <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                                            Precio Exceso
                                                                        </center></th>
                                                                        <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                                            Total Venta
                                                                        </center></th>
                                                                        <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #F25050"><center>
                                                                            Anulada
                                                                        </center></th>
                                                                        <th colspan="2" style="width: 7%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                                            Informe de Ensayos
                                                                        </center></th>
                                                                        <th colspan="2" style="width: 7%;  border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                                            N° Comprobante
                                                                        </center></th> -->
                                                                        <th colspan="3" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; border-top-right-radius: 15px; background-color: #3EB595;"><center>
                                                                            Datos de Programa
                                                                        </center></th>
                                                                    </tr>

                                                                    <tr>
                                                                        <!-- <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #C2E0F2; color: #595959; width: 220px;"><center>
                                                                            Nombres
                                                                        </center></th>
                                                                        <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #C2E0F2; color: #595959"><center>
                                                                            DNI / RUC
                                                                        </center></th> -->
                                                                        <!-- <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #C2E0F2; color: #595959"><center>
                                                                            Teléfonos
                                                                        </center></th>
                                                                        <th style="border: solid; border-width: 1px; border-color: #ffffff; background-color: #C2E0F2; vertical-align: middle; color: #595959"><center>
                                                                            Cód. Interno
                                                                        </center></th>
                                                                        <th style="border: solid; border-width: 1px; border-color: #ffffff; background-color: #C2E0F2; vertical-align: middle; color: #595959"><center>
                                                                            Nombre
                                                                        </center></th> -->
                                                                        <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #8A75AA;"><center>
                                                                            <label for="chek_All">Sel.</label><br>
                                                                            <input type="checkbox" id="chek_All" value="chek_All" class="chek_All" onchange="f_CheckAll();">
                                                                        </center></th>
                                                                        <!-- <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #3EB595;"><center>
                                                                            Programado
                                                                        </center></th> -->
                                                                        <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #3EB595; width: 120px;"><center>
                                                                            Fecha Hora Programado
                                                                        </center></th>

                                                                        <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #3D3D3D; width: 120px;"><center>
                                                                            Fecha Hora Reporte
                                                                        </center></th>
                                                                    </tr>
                                                                </thead>

                                                                <tbody id="tbl_VentasProgramados">
                                                                    
                                                                </tbody>
                                                            </table>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- Ventanas modal -->
        <div id="divmodal_programa" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false">
            <div class="modal-dialog" style="width: 40%; margin-top: 12%; margin-left: 30%">
                <!-- Modal content-->
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal">
                            &times;
                        </button>

                        <h4 class="modal-title"><b>
                            Configuración de Programa
                        </b></h4>
                    </div>

                    <div class="modal-body">
                        <div class="row" style="text-align: center;">
                            <label class="control-label" style="margin-top: 6px">
                                Usted a seleccionado: <b><span id="count_selected" style="margin-left: 5px; font-size: 16px; color: #D95252;"></span></b> registros
                            </label>
                        </div>

                        <div class="row" style="margin-top: 15px; border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px; background-color: #D95252; color: #ffffff;">
                            <div class="form-group col-md-12 col-sm-12 col-xs-12" style="margin-top: 10px;">
                                <label class="control-label col-md-4 col-sm-4 col-xs-4" style="text-align: right; margin-top: 6px">
                                    Ingrese el periodo a programar
                                </label>
                                <div class="col-md-4 col-sm-4 col-xs-4"><b>
                                    <?php
                                        date_default_timezone_set("America/Lima"); 
                                        $fecha = date('Y-m-d');
                                    ?>
                                    <input type="date" class="form-control col-md-12 col-xs-12" id="fecha_programa" value="<?php echo $fecha; ?>"/>
                                </b></div>
                                <div class="col-md-4 col-sm-4 col-xs-4"><b>
                                    <input type="time" class="form-control col-md-12 col-xs-12" id="hora_programa"/>
                                </b></div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="ln_solid"></div>
                        </div>

                        <div class="row">
                            <div class="form-group"><center>
                                <div class="col-md-12 col-sm-12 col-xs-12">
                                    <button class="btn btn-dark" type="button" onclick="f_cerrarModal(1)">
                                        Cancelar
                                    </button>
                                    <button class="btn btn-success" type="button" onclick="f_GrabarPrograma()">
                                        Grabar
                                    </button>
                                </div>
                            </center></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div id="divmodal_Loading" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false" style="margin-top: 300px;">
            <div class="modal-dialog" style="height: 200px; opacity: 0.5;"><center>
                <img src="images/loading.gif" width="200px" style="border: solid; border-width: 1px; border-color: #D9D9D9;  border-radius: 15px;"></img>
            </center></div>
        </div>

        <!-- jQuery -->
        <script src="../vendors/jquery/dist/jquery.min.js"></script>
        <!-- Bootstrap -->
        <script src="../vendors/bootstrap/dist/js/bootstrap.min.js"></script>
        <!-- FastClick -->
        <script src="../vendors/fastclick/lib/fastclick.js"></script>
        <!-- NProgress -->
        <script src="../vendors/nprogress/nprogress.js"></script>
        <!-- Ion.RangeSlider -->
        <script src="../vendors/ion.rangeSlider/js/ion.rangeSlider.min.js"></script>
        <!-- Bootstrap Colorpicker -->
        <script src="../vendors/mjolnic-bootstrap-colorpicker/dist/js/bootstrap-colorpicker.min.js"></script>
        <!-- Custom Theme Scripts -->
        <script src="../build/js/custom.min.js"></script>

        <!-- bootstrap-daterangepicker -->
        <script src="../vendors/moment/min/moment.min.js"></script>
        <script src="../vendors/bootstrap-daterangepicker/daterangepicker.js"></script><!-- Datatables -->
        <script src="../vendors/datatables.net/js/jquery.dataTables.min.js"></script>
        <script src="../vendors/datatables.net-bs/js/dataTables.bootstrap.min.js"></script>
        <script src="../vendors/datatables.net-buttons/js/dataTables.buttons.min.js"></script>
        <script src="../vendors/datatables.net-buttons-bs/js/buttons.bootstrap.min.js"></script>
        <script src="../vendors/datatables.net-buttons/js/buttons.flash.min.js"></script>
        <script src="../vendors/datatables.net-buttons/js/buttons.html5.min.js"></script>
        <script src="../vendors/datatables.net-buttons/js/buttons.print.min.js"></script>
        <script src="../vendors/datatables.net-fixedheader/js/dataTables.fixedHeader.min.js"></script>
        <script src="../vendors/datatables.net-keytable/js/dataTables.keyTable.min.js"></script>
        <script src="../vendors/datatables.net-responsive/js/dataTables.responsive.min.js"></script>
        <script src="../vendors/datatables.net-responsive-bs/js/responsive.bootstrap.js"></script>
        <script src="../vendors/datatables.net-scroller/js/dataTables.scroller.min.js"></script>
        <script src="../vendors/jszip/dist/jszip.min.js"></script>
        <script src="../vendors/pdfmake/build/pdfmake.min.js"></script>
        <script src="../vendors/pdfmake/build/vfs_fonts.js"></script>

        <!-- ECharts -->
        <script src="../vendors/echarts/dist/echarts.min.js"></script>
        <script src="../vendors/echarts/map/js/world.js"></script>

        <!-- Ventanas modales -->

        <!-- Funciones de Búsqueda -->
        <script type="text/javascript">
            // Buscando Clientes
                function f_BuscarClientes(tipo_busqueda){
                    var compania = <?php echo $_SESSION["bdOmar_Compania"]; ?>;
                    var htmlContenido = '';

                    if (tipo_busqueda == 1 || tipo_busqueda == 2){
                        var str_busqueda = ((tipo_busqueda == 1) ? $("#dni_cliente").val() : $("#nom_cliente").val());

                        $("#tabla_busquedaclientes").html(htmlContenido);
                    }
                    else{
                        var str_busqueda = ((tipo_busqueda == 3) ? $("#cliente_dni").val() : $("#cliente_nombre").val());

                        $("#tabla_busquedaclientes2").html(htmlContenido);
                    }

                    var c = 1;

                    $.post( "ajax/encuesta.php", { accion: "Get_Clientes", idCompany: compania, tipo_filtro: tipo_busqueda, filtro: str_busqueda }, 
                        function( data ) {
                            if(data.estado == 1){
                                $.each( data.registros, function( key, val ) {
                                    htmlContenido += '<tr style="cursor: pointer" onclick="f_AddCliente(' + tipo_busqueda + ', ' + val.iIdCliente + ', ' + val.cNumeroRuc + ", '" + val.cRazonSocial + "', " + val.id_Tipo_Documento + ", " + val.id_doc_sunat + ')">';

                                    htmlContenido += "  <td>" + c + "</td>";
                                    htmlContenido += "  <td><center>" + val.cNumeroRuc + "</center></td>";
                                    htmlContenido += "  <td>" + val.cRazonSocial + "</td>";

                                    htmlContenido += "</tr>";

                                    c += 1;
                                });
                            }

                            if (tipo_busqueda == 1 || tipo_busqueda == 2){
                                $("#tabla_busquedaclientes").html(htmlContenido);

                                 if (c == 1){
                                    f_CerrarDiv('A', 'div_sinclientes');
                                }
                                else{
                                    f_CerrarDiv('C', 'div_sinclientes');
                                }
                            }
                            else{
                                $("#tabla_busquedaclientes2").html(htmlContenido);

                                 if (c == 1){
                                    f_CerrarDiv('A', 'div_sinclientes2');
                                }
                                else{
                                    f_CerrarDiv('C', 'div_sinclientes2');
                                }
                            }

                        }, "json");

                    if (tipo_busqueda == 1 || tipo_busqueda == 2){
                        f_CerrarDiv('A', 'div_buscarclientes');
                    }
                    else{
                        f_CerrarDiv('A', 'div_buscarclientes2');
                    }
                };

            // Cargando Resultados
                function f_LoadResultados(_x, _filtroelementos){
                    var htmlContenido = '';

                    // Obteniendo filtros
                        var fecha_inicio = $("#fecha_inicio").val();
                        var fecha_fin = $("#fecha_fin").val();
                        var dni_cliente = $("#dni_cliente").val();
                        var nom_cliente = $("#nom_cliente").val();
                        var sucursal = $("#lista_sucursal").val();
                        var nom_muestra = $("#nom_muestra").val();
                        var num_informe = $("#num_informe").val();

                    // Validando ingreso de filtros
                        if (fecha_inicio == null){
                            alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                            return;
                        }
                        if (fecha_inicio.length == 0){
                            alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                            return;
                        }

                        if (fecha_fin == null){
                            alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                            return;
                        }
                        if (fecha_fin.length == 0){
                            alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                            return;
                        }

                        if (fecha_fin < fecha_inicio){
                            alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

                            return;
                        }

                    // Obteniendo filtros principales
                        var filtro_programados = '';

                        if ($("#lista_Programados").val() != null){
                            filtro_programados = (($("#lista_Programados").val().length == 0) ? '' : $("#lista_Programados").val());
                        }

                        var hora_inicio = $("#hora_inicio").val();
                        var hora_fin = $("#hora_fin").val();

                        if (_x == 2){
                            fecha_inicio = fecha_inicio + ' ' + hora_inicio;
                            fecha_fin = fecha_fin + ' ' + hora_fin;
                        }

                    // Obteniendo filtro de Elementos
                      var arr_elementos = '';

                      if (_x != 99){
                        var e = 1;

                        while (e <= 13){
                          if ($("#lbl_" + e).css('background-color') == 'rgb(0, 146, 178)'){
                            arr_elementos += $("#filtro_idelemento_" + e).val() + "|";
                          }

                          e += 1;
                        }

                        if (arr_elementos.length > 0){
                          arr_elementos = arr_elementos.substring(0, arr_elementos.length - 1);
                        }
                      }

                    // Loading Modal
                        var modal_loading = $("#divmodal_Loading");
                        modal_loading.modal({backdrop: 'static', keyboard: false});

                    // Carga resultados
                        var c = 1;
                        var _visible = 0;
                        var _hoy = '<?php echo $g_date; ?>';
                        var _fecha_entrega = '';
                        var _fecha_programa = '';
                        var _fecha_entrega = '';
                        var _fecha_reporte = '';
                        var _bg_color = '';
                        var _verdes = 0;
                        var _rojos = 0;
                        var _pendientes = 0;

                        $("#tbl_VentasProgramados").html(htmlContenido);

                        $.post( "ajax/encuesta.php", { accion: "Get_ListaVentasProgramados", fecha_inicio: fecha_inicio, fecha_fin: fecha_fin, dni_cliente: dni_cliente, nom_cliente: nom_cliente, Sucursal: sucursal, nom_muestra: nom_muestra, num_informe: num_informe, filtro_programados: filtro_programados, arr_elementos: arr_elementos }, 
                            function( data ) {
                                if(data.estado == 1){
                                    $.each( data.registros, function( key, val ) {
                                        _fecha_entrega = val.FechaHora_Entrega.substr(6, 4);
                                        _fecha_entrega += '-' + val.FechaHora_Entrega.substr(3, 2);
                                        _fecha_entrega += '-' + val.FechaHora_Entrega.substr(0, 2);

                                        htmlContenido += '<tr>';

                                        htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right">' + c + '</td>';

                                        htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; color: #3F4242; background-color: ' + ((val.Sucursal == 1) ? '#D1DBBD' : '#D89196') + '"><center><b>' + val.des_sucursal + '</b></center></td>';

                                        // htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.NUM_RECIBO + '</center></td>';

                                        htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;">' + val.Nombre_Cliente.replace(/[*]/g, '').replace(/[&]/g, 'y') + '</td>';

                                        // htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; color: #3F4242; text-align: center;">' + val.Documento_Cliente + '</td>';

                                        // htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; color: #3F4242;">' + val.TELEFONO_CLIENTE + '</td>';

                                        htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.FechaHora_Recepcion + '</center></td>';

                                        // htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.FechaHora_Entrega + '</center></td>';

                                        // htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + ((val.Fecha_Reporte == null) ? 'PENDIENTE' : val.Fecha_Reporte) + '</center></td>';

                                        htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.des_mediopago + '</center></td>';

                                        htmlContenido += '  <b><td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; color: #3F4242; text-align: center; font-weight: 700">' + val.Cod_Interno + '</td></b>';

                                        // htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; color: #3F4242;"><center>' + val.Nom_Muestra + '</center></td>';

                                        // htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.Correlativo + '</center></td>';

                                        htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.Elemento_Analisis + '</center></td>';

                                        htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.Peso_Muestra + '</center></td>';

                                        htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.Nombre_EstadoMuestra + '</center></td>';

                                        // htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.Nombre_DetalleEnvase + '</center></td>';

                                        htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.Nombre_TipoMuestra + '</center></td>';

                                        htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.Des_TipoAnalisis + '</center></td>';

                                        // htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + parseFloat(val.Precio_Exceso).toFixed(2) + '</center></td>';

                                        // htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + parseFloat(val.Total_Venta).toFixed(2) + '</center></td>';

                                        // htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; ' + ((val.es_anulada == 1) ? 'background-color: #F25050; color: #ffffff' : '') + '"><center>' + ((val.es_anulada == 1) ? 'SÍ' : '') + '</center></td>';

                                        // if (val.Cod_EstadoResultadosCliente == 2){
                                        //     htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;" onclick="f_PrintDocumentosCliente(1, ' + val.Id_Pedido + ', ' + val.Id_Detalle + ", '" + val.Nombre_Cliente + "', '" + val.Nombre_TipoMuestra + "', '" + val.Nom_Muestra + "', " + val.Peso_Muestra + ", '" + val.Nombre_DetalleEnvase + "', '" + val.FechaHora_Recepcion2 + "', '" + val.FechaHora_Entrega2 + "', '" + val.Elemento_Analisis + "', " + val.Ley_Au_gt + ', ' + val.Ley_Au_ot + ', ' + val.Ley_Ag_gt + ', ' + val.Ley_Ag_ot + ', ' + val.Porc_CU + ', ' + val.Porc_PB + ', ' + val.Porc_ZN + ', ' + val.Porc_AS + ', ' + val.Porc_SB + ', ' + val.Porc_S + ', ' + val.Porc_FE + ', ' + val.Porc_H2O + ", '" + val.Fecha_Informe + "', '" + ((val.Observacion_Reporte == null) ? '' : val.Observacion_Reporte) + "', " + val.Documento_Cliente + ", '" + val.TELEFONO_CLIENTE + "', '" + val.cEmail + "', " + val.Sucursal + ", '" + val.NOMBRE_EMPRESA + "', " + val.Tipo_Muestra + ", '" + val.Des_TipoAnalisis + "', '" + val.Fecha_CierreInforme + "', '" + val.Referencia_Cliente + "', '" + val.Fecha_InicioEnsayo.substr(0, 10) + "', '" + val.Cod_Interno + "', " + val.Mostrar_Contacto + ", '" + val.X_PEDIDO + "'" + ')"><center>';
                                        //     htmlContenido += '      <img src="images/qr.png" width="30px"></img>';
                                        //     htmlContenido += '      <label style="cursor: pointer">QR</label>';
                                        //     htmlContenido += '</center></td>';

                                        //     htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;" onclick="f_PrintDocumentosCliente(2, ' + val.Id_Pedido + ', ' + val.Id_Detalle + ", '" + val.Nombre_Cliente + "', '" + val.Nombre_TipoMuestra + "', '" + val.Nom_Muestra + "', " + val.Peso_Muestra + ", '" + val.Nombre_DetalleEnvase + "', '" + val.FechaHora_Recepcion2 + "', '" + val.FechaHora_Entrega2 + "', '" + val.Elemento_Analisis + "', " + val.Ley_Au_gt + ', ' + val.Ley_Au_ot + ', ' + val.Ley_Ag_gt + ', ' + val.Ley_Ag_ot + ', ' + val.Porc_CU + ', ' + val.Porc_PB + ', ' + val.Porc_ZN + ', ' + val.Porc_AS + ', ' + val.Porc_SB + ', ' + val.Porc_S + ', ' + val.Porc_FE + ', ' + val.Porc_H2O + ", '" + val.Fecha_Informe + "', '" + ((val.Observacion_Reporte == null) ? '' : val.Observacion_Reporte) + "', " + val.Documento_Cliente + ", '" + val.TELEFONO_CLIENTE + "', '" + val.cEmail + "', " + val.Sucursal + ", '" + val.NOMBRE_EMPRESA + "', " + val.Tipo_Muestra + ", '" + val.Des_TipoAnalisis + "', '" + val.Fecha_CierreInforme + "', '" + val.Referencia_Cliente + "', '" + val.Fecha_InicioEnsayo.substr(0, 10) + "', '" + val.Cod_Interno + "', " + val.Mostrar_Contacto + ", '" + val.X_PEDIDO + "'" + ')"><center>';
                                        //     htmlContenido += '      <img src="images/certificacion.png" width="25px"></img>';
                                        //     htmlContenido += '      <label style="cursor: pointer">' + val.Correlativo + '</label>';
                                        //     htmlContenido += '</center></td>';
                                        // }
                                        // else{
                                        //     htmlContenido += '<td></td>';
                                        //     htmlContenido += '<td></td>';
                                        // }

                                        // htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle;"><center>' + val.COMPROBANTE + '</center></td>';

                                        if (val.PROGRAMA.length == 0){
                                            htmlContenido += '  <td style="border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; cursor: pointer; text-align: center;"><input id="chk_Programa_' + c + '" type="checkbox" ' + ((_fecha_entrega == _hoy) ? 'checked' : '') + '></td>';
                                        }
                                        else{
                                            htmlContenido += '  <td id="th_eliminarA_' + c + '" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; color: #D95252; text-align: center;"><u onclick="f_EliminarPrograma(' + c + ", '" + val.Cod_Interno + "'" + ')">Eliminar Programa</u></td>';
                                        }

                                        htmlContenido += '  <td id="th_eliminarB_' + c + '" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; color: #D95252"><center>' + val.PROGRAMA + '</center></td>';

                                        // Comparando Fecha de Programa y Reporte
                                            _fecha_programa = val.PROGRAMA.trim();
                                            _fecha_reporte = val.FECHAHORA_REPORTE;

                                            if (_fecha_programa.length == 0){
                                                _bg_color = '';

                                                _pendientes += 1;
                                            }
                                            else{
                                                if (_fecha_reporte == '1900-01-01 00:00'){
                                                    _bg_color = '; color: #D95252; ';

                                                    _pendientes += 1;
                                                }
                                                else{
                                                    if (_fecha_programa < _fecha_reporte){
                                                        _bg_color = '#D95252';

                                                        _rojos += 1;
                                                    }
                                                    else{
                                                        _bg_color = '#3EB595';

                                                        _verdes += 1;
                                                    }
                                                }
                                            }

                                        htmlContenido += '  <td id="th_eliminarB_' + c + '" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; color: ' + ((_fecha_programa.length == 0) ? '#D95252' : '#ffffff; background-color: ' + _bg_color) + '"><center>' + ((val.FECHAHORA_REPORTE == '1900-01-01 00:00') ? 'PENDIENTE' : val.FECHAHORA_REPORTE) + '</center></td>';

                                        htmlContenido += "</tr>";

                                        c += 1;
                                    });
                                }
                                else{
                                    alert("No se encontraron resultados para la búsqueda solicitada");
                                }

                                // Pintando Cumplimiento
                                    $("#th_cumplidos").html(_verdes);
                                    $("#th_nocumplidos").html(_rojos);
                                    $("#th_pendientes").html(_pendientes);

                                // Cerrando Modal
                                    $('#divmodal_Loading').modal('hide');

                                $("#tbl_VentasProgramados").html(htmlContenido);
                            }, "json");

                    if (_filtroelementos != 1){
                        if (_x == 1){
                            // Cargando Filtro de Programados
                                var html_programados = '<option selected value="">Elija una opción...</option>';

                                $("#lista_Programados").html(html_programados);

                                $.post( "ajax/encuesta.php", { accion: "Get_ListaVentasProgramados_Programados", fecha_inicio: fecha_inicio, fecha_fin: fecha_fin, dni_cliente: dni_cliente, nom_cliente: nom_cliente, Sucursal: sucursal, nom_muestra: nom_muestra, num_informe: num_informe }, 
                                    function( data2 ) {
                                        if(data2.estado == 1){
                                            $.each( data2.registros, function( key, val2 ) {
                                                html_programados += '<option value="' + val2.FECHA_PROGRAMA + '">' + val2.FECHA_PROGRAMA + '</option>';

                                            });
                                        }
                                        // else{
                                        //     alert("No se encontraron resultados para la búsqueda solicitada");
                                        // }

                                        // Cerrando Modal
                                            $('#divmodal_Loading').modal('hide');

                                        $("#lista_Programados").html(html_programados);
                                    }, "json");
                        }

                        // Cargando Charts
                            filtro_programados = filtro_programados.replace(/ /g, 'e');

                            $("#div_chart").load("partes/chart_programadiario_resumen.php?fi=" + fecha_inicio + "&ff=" + fecha_fin + "&dni=" + dni_cliente + "&nom=" + nom_cliente + "&s=" + sucursal + "&m=" + nom_muestra + "&fp=" + filtro_programados);
                    }
                };

            // Filtrando por intervalo de horas
                function f_BuscarIntervaloHoras(){
                    var hora_inicio = $("#hora_inicio").val();
                    var hora_fin = $("#hora_fin").val();

                    // Validando datos
                        if (hora_inicio == null){
                            alert('Debe ingresar la Hora de Inicio');

                            return;
                        }
                        if (hora_inicio.length == 0){
                            alert('Debe ingresar la Hora de Inicio');

                            return;
                        }

                        if (hora_fin == null){
                            alert('Debe ingresar la Hora de Fin');

                            return;
                        }
                        if (hora_fin.length == 0){
                            alert('Debe ingresar la Hora de Fin');

                            return;
                        }

                        hora_inicio = '1981-02-12 ' + hora_inicio;
                        hora_fin = '1981-02-12 ' + hora_fin;

                        if (hora_fin < hora_inicio){
                            alert('La Hora de Fin no puede ser menor a la Hora de Inicio.\nPor favor, verificar.');

                            return;
                        }

                    f_LoadResultados(2);
                };

            function f_ExportToExcel(){
                // Obteniendo filtros
                    var fecha_inicio = $("#fecha_inicio").val();
                    var fecha_fin = $("#fecha_fin").val();
                    var dni_cliente = $("#dni_cliente").val();
                    var nom_cliente = $("#nom_cliente").val();
                    var sucursal = $("#lista_sucursal").val();
                    var nom_muestra = $("#nom_muestra").val();
                    var num_informe = $("#num_informe").val();

                // Validando ingreso de filtros
                    if (fecha_inicio == null){
                        alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                        return;
                    }
                    if (fecha_inicio.length == 0){
                        alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                        return;
                    }

                    if (fecha_fin == null){
                        alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                        return;
                    }
                    if (fecha_fin.length == 0){
                        alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                        return;
                    }

                    if (fecha_fin < fecha_inicio){
                        alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

                        return;
                    }

                // Obteniendo filtros principales
                  var filtro_programados = '';
                  var hora_inicio = $("#hora_inicio").val();
                  var hora_fin = $("#hora_fin").val();

                  if ($("#lista_Programados").val().length > 0){
                      filtro_programados = (($("#lista_Programados").val().length == 0) ? '' : $("#lista_Programados").val());
                      filtro_programados = filtro_programados.replace(/ /g, 'e');

                      // fecha_inicio = fecha_inicio + ' ' + hora_inicio;
                      // fecha_fin = fecha_fin + ' ' + hora_fin;
                  }

                // Obteniendo filtro de Elementos
                  var arr_elementos = '';
                  var e = 1;

                  while (e <= 10){
                    if ($("#lbl_" + e).css('background-color') == 'rgb(0, 146, 178)'){
                      arr_elementos += $("#filtro_idelemento_" + e).val() + "|";
                    }

                    e += 1;
                  }

                  if (arr_elementos.length > 0){
                    arr_elementos = arr_elementos.substring(0, arr_elementos.length - 1);
                  }

                window.location.href = "send_to_excel/export_to_excel_programadiario.php?fi=" + fecha_inicio + "&ff=" + fecha_fin + "&dni=" + dni_cliente + "&nom=" + nom_cliente + "&s=" + sucursal + "&m=" + nom_muestra + "&fp=" + filtro_programados + "&e=" + arr_elementos;
            };

            function f_ExportToExcelLQ(){
                // Obteniendo filtros
                    var fecha_inicio = $("#fecha_inicio").val();
                    var fecha_fin = $("#fecha_fin").val();
                    var dni_cliente = $("#dni_cliente").val();
                    var nom_cliente = $("#nom_cliente").val();
                    var sucursal = $("#lista_sucursal").val();
                    var nom_muestra = $("#nom_muestra").val();
                    var num_informe = $("#num_informe").val();

                // Validando ingreso de filtros
                    if (fecha_inicio == null){
                        alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                        return;
                    }
                    if (fecha_inicio.length == 0){
                        alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                        return;
                    }

                    if (fecha_fin == null){
                        alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                        return;
                    }
                    if (fecha_fin.length == 0){
                        alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                        return;
                    }

                    if (fecha_fin < fecha_inicio){
                        alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

                        return;
                    }

                // Obteniendo filtros principales
                  var filtro_programados = '';
                  var hora_inicio = $("#hora_inicio").val();
                  var hora_fin = $("#hora_fin").val();

                  if ($("#lista_Programados").val().length > 0){
                      filtro_programados = (($("#lista_Programados").val().length == 0) ? '' : $("#lista_Programados").val());
                      filtro_programados = filtro_programados.replace(/ /g, 'e');

                      // fecha_inicio = fecha_inicio + ' ' + hora_inicio;
                      // fecha_fin = fecha_fin + ' ' + hora_fin;
                  }

                // Obteniendo filtro de Elementos
                  var arr_elementos = '';
                  var e = 1;

                  while (e <= 10){
                    if ($("#lbl_" + e).css('background-color') == 'rgb(0, 146, 178)'){
                      arr_elementos += $("#filtro_idelemento_" + e).val() + "|";
                    }

                    e += 1;
                  }

                  if (arr_elementos.length > 0){
                    arr_elementos = arr_elementos.substring(0, arr_elementos.length - 1);
                  }

                window.location.href = "send_to_excel/export_to_excel_programadiario_lq.php?fi=" + fecha_inicio + "&ff=" + fecha_fin + "&dni=" + dni_cliente + "&nom=" + nom_cliente + "&s=" + sucursal + "&m=" + nom_muestra + "&fp=" + filtro_programados + "&e=" + arr_elementos;
            };
        </script>

        <!-- Funciones Principales -->
        <script type="text/javascript">
            function f_OpenPrograma(){
                // Validando datos
                    var _selected = 0;
                    var d = 1;
                    _selectedCI = '';

                    $('#tbl_VentasProgramados tr').each(function () {
                        if ($("#chk_Programa_" + d).prop('checked')){
                            _selectedCI += "'" + $(this).find("td").eq(6).html() + "', ";

                            _selected += 1;
                        }

                        d += 1;
                    });

                    if (_selected == 0){
                        alert("Debe seleccionar al menos un registro.");

                        return;
                    }
                    else{
                        _selectedCI = _selectedCI.substring(0, _selectedCI.length - 2);
                    }

                // Abriendo pantalla
                    var modal = $("#divmodal_programa");

                    $("#count_selected").html(_selected);

                    modal.modal({backdrop: 'static', keyboard: false});
            };

            function f_GrabarPrograma(){
                var _fecha_programa = $("#fecha_programa").val();
                var _hora_programa = $("#hora_programa").val();

                // Validando datos
                    if (_fecha_programa == null){
                        alert("Debe seleccionar la Fecha del Programa");

                        return;
                    }
                    if (_fecha_programa.length == 0){
                        alert("Debe seleccionar la Fecha del Programa");

                        return;
                    }

                    if (_hora_programa == null){
                        alert("Debe seleccionar la hora del Programa");

                        return;
                    }
                    if (_hora_programa.length == 0){
                        alert("Debe seleccionar la hora del Programa");

                        return;
                    }

                    var fechaX = _fecha_programa + ' ' + _hora_programa;
                    var fechaZ = '<?php echo $g_fecha ?>';

                    if (fechaX < fechaZ){
                        // alert("La Fecha y Hora de Programa no puede ser menor a la Fecha y Hora actual.");

                        // return;

                        // MAX (05/08/2021 00:07): Se cambió por el siguiente mensjae
                        if (!confirm("La Fecha y Hora de Programa es menor a la Fecha y Hora actual.n\n¿Está seguro de continuar?")){
                            return;
                        }
                    }

                // Loading Modal
                    var modal_loading = $("#divmodal_Loading");
                    modal_loading.modal({backdrop: 'static', keyboard: false});

                // Grabando datos
                    $.post( "ajax/encuesta.php", { accion: "Grabar_ProgramaDiario", fecha_programa: _fecha_programa, hora_programa: _hora_programa, selected_CI: _selectedCI },
                        function( data ) {
                            if(data.estado == 1){
                                f_LoadResultados(1);

                                f_cerrarModal(1);
                            }
                            else{
                                alert("Ocurrió un error al momento de grabar el nuevo Cliente");
                            }

                            // Cerrando Modal
                                $('#divmodal_Loading').modal('hide');

                        }, "json");
            };

            function f_EliminarPrograma(_item, _ci_muestra){
                if (!confirm("¿ Está seguro de eliminar el Programa para la muestra: " + _ci_muestra + " ?")){
                    return;
                }

                $.post( "ajax/encuesta.php", { accion: "Eliminar_ProgramaDiario", ci_muestra: _ci_muestra },
                    function( data ) {
                        if(data.estado == 1){
                            $("#th_eliminarA_" + _item).html('<input id="chk_Programa_' + _item + '" type="checkbox">');
                            $("#th_eliminarB_" + _item).html('');
                        }
                        else{
                            alert("Ocurrió un error al momento de eliminar el programa de la muestra seleccionada.");
                        }

                        // Cerrando Modal
                            $('#divmodal_Loading').modal('hide');

                    }, "json");
            };

            function f_LoadElementos(){
              var _html = '';

              $("#div_elementos").html('');

              $.post( "ajax/encuesta.php", { accion: "get_ElementosFiltro_All", add_newmont: 1 }, 
                function( data ) {
                  if(data.estado == 1){
                    $("#div_elementos").html(data.html_elementos);
                  }

                }, "json");
            };

            function f_FiltroElementos(_item, _elemento){
              if (_item != 0){
                if ($("#lbl_" + _item).css('background-color') == 'rgb(191, 191, 191)'){
                  $("#lbl_0").css('background-color', '#8C8C8C');
                  $("#lbl_" + _item).css('background-color', '#0092B2');

                  // $(".elemento_" + _elemento).show();
                }
                else{
                  $("#lbl_" + _item).css('background-color', '#BFBFBF');

                  // $(".elemento_" + _elemento).hide();
                }
              }
              else{
                $("#lbl_0").css('background-color', '#FF8600');
                $(".cls_filtroselementos").css('background-color', '#BFBFBF');
              }

              f_LoadResultados(1, 1);
            }
        </script>

        <!-- Funciones Secundarias -->
        <script type="text/javascript">
            function f_CheckAll(){
                var _check = false;
                var d = 1;

                if ($("#chek_All").prop('checked')){
                    _check = true;
                }

                $('#tbl_VentasProgramados tr').each(function () {
                    $("#chk_Programa_" + d).prop('checked', _check);

                    d += 1;
                });
            };

            function f_ClearProgramados(_x){
                if (_x == 1){
                    $("#lista_Programados").val('');
                }
                else{
                    $("#hora_inicio").val('');
                    $("#hora_fin").val('');
                }
            }
        </script>

        <!-- Otras Funciones -->
        <script type="text/javascript">
            // Cerrar Div's
                function f_CerrarDiv(accion, nom_div){
                    var _div = document.getElementById(nom_div);

                    if (accion == 'A'){
                        _div.style.display = 'block'
                    }
                    else{
                         _div.style.display = 'none';
                    }
                };
            // Cerrar ventanas modales
                function f_cerrarModal(pantalla_modal){
                    if (pantalla_modal == 1){
                        $('#divmodal_programa').modal('hide');
                    }
                };

            // Limpiar controles de búsqueda
                function f_ClearBusqueda(){
                    // var fecha = new Date();

                    // fecha = fecha.getFullYear() + '-' + (((fecha.getMonth() + 1).toString().length == 1) ? '0' + (fecha.getMonth() + 1) : (fecha.getMonth() + 1)) + '-' + fecha.getDate();

                    // $("#fecha_inicio").val(fecha);
                    // $("#fecha_fin").val(fecha);
                    $("#dni_cliente").val('');
                    $("#nom_cliente").val('');
                    $("#lista_sucursal").val('');
                    $("#nom_muestra").val('');
                    $("#num_informe").val('');
                }

            window.addEventListener("keyup",function(e){
                if(e.keyCode==27) {
                    f_CerrarDiv('C', 'div_buscarclientes');
                    f_CerrarDiv('C', 'div_buscarclientes2');
                    f_CerrarDiv('C', 'div_RowAddElementos');
                }
            });
        </script>
    </body>
</html>

<?php
    cerrarSesion($enlace);
?>