<?php
  
  session_start();

  include('../../php/conn.php');

  if(!isset($_SESSION["id"])){
    header('Location: index.php');
  }

  mysqli_query($enlace, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");

?>

<!DOCTYPE html>
<html lang="es">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <!-- Meta, title, CSS, favicons, etc. -->
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <title>LIMS | Programa Diario</title>

        <!-- Bootstrap -->
        <link href="../vendors/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
        <!-- Font Awesome -->
        <link href="../vendors/font-awesome/css/font-awesome.min.css" rel="stylesheet">
        <!-- NProgress -->
        <link href="../vendors/nprogress/nprogress.css" rel="stylesheet">
        <!-- iCheck -->
        <link href="../vendors/iCheck/skins/flat/green.css" rel="stylesheet">
        <!-- bootstrap-progressbar -->
        <link href="../vendors/bootstrap-progressbar/css/bootstrap-progressbar-3.3.4.min.css" rel="stylesheet">
        <!-- JQVMap -->
        <link href="../vendors/jqvmap/dist/jqvmap.min.css" rel="stylesheet"/>
        <!-- bootstrap-daterangepicker -->
        <link href="../vendors/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
        <!-- Ion.RangeSlider -->
        <link href="../vendors/normalize-css/normalize.css" rel="stylesheet">
        <link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.css" rel="stylesheet">
        <link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.skinFlat.css" rel="stylesheet">
        <!-- Bootstrap Colorpicker -->
        <link href="../vendors/mjolnic-bootstrap-colorpicker/dist/css/bootstrap-colorpicker.min.css" rel="stylesheet">
        <link href="../vendors/cropper/dist/cropper.min.css" rel="stylesheet">
        <!-- Datatables -->
        <link href="../vendors/datatables.net-bs/css/dataTables.bootstrap.min.css" rel="stylesheet">
        <link href="../vendors/datatables.net-buttons-bs/css/buttons.bootstrap.min.css" rel="stylesheet">
        <link href="../vendors/datatables.net-fixedheader-bs/css/fixedHeader.bootstrap.min.css" rel="stylesheet">
        <link href="../vendors/datatables.net-responsive-bs/css/responsive.bootstrap.min.css" rel="stylesheet">
        <link href="../vendors/datatables.net-scroller-bs/css/scroller.bootstrap.min.css" rel="stylesheet">

        <!-- bootstrap-datetimepicker -->
        <link href="../vendors/bootstrap-datetimepicker/build/css/bootstrap-datetimepicker.css" rel="stylesheet">

        <!-- Switchery -->
        <link href="../vendors/switchery/dist/switchery.min.css" rel="stylesheet">

        <!-- Custom Theme Style -->
        <link href="../build/css/custom.min.css" rel="stylesheet">

        <script type="text/javascript">
            var total = 0;
            var _selectedCI = '';
        </script>

        <style type="text/css">
            th {
                position: sticky;
                top: 0px;
                background-color: #12537E;
            }
        </style>
    </head>

    <body class="nav-md" onload="f_LoadResultados('chk', 1)" style="zoom: 80%">
        <div class="container body">
            <div class="main_container">
                <?php include('partes/sidebar.php'); ?>

                <!-- page content -->
                <div class="right_col" role="main">
                    <div class="">
                        <div class="row">
                            <div class="col-md-12 col-sm-12 col-xs-12">
                                <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                    <div class="x_title">
                                        <h2>
                                            Programa Diario de Producción
                                        </h2>

                                        <div class="clearfix">
                                        </div>
                                    </div>

                                    <div class="x_content">
                                        <!-- Filtros -->
                                        <div class="col-md-4 col-sm-4 col-xs-12">
                                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                                <div class="x_title">
                                                    <h2>
                                                        <font style="font-size: 14px"><b>Por fecha de recepción</b></font>
                                                    </h2>
                                                    <div class="clearfix">
                                                    </div>
                                                </div>
                                                <div class="x_content">
                                                    <div class="form-group col-md-6 col-sm-6 col-xs-12" style="margin-top: 9px;">
                                                        <?php
                                                            date_default_timezone_set("America/Lima"); 
                                                            $time = date('Y-m-d');

                                                            echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_inicio" value="'.$time.'" onchange="f_CargaFechasProgramadas();"/>';
                                                        ?>
                                                    </div>

                                                    <div class="form-group col-md-6 col-sm-6 col-xs-12" style="margin-top: 9px;">
                                                        <?php
                                                            echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_fin" value="'.$time.'" onchange="f_CargaFechasProgramadas();"/>';
                                                        ?>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="col-md-2 col-sm-2 col-xs-12">
                                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                                <div class="x_title">
                                                    <h2>
                                                        <font style="font-size: 14px"><b>Por Fecha y Hora Prometidas</b></font>
                                                    </h2>
                                                    <div class="clearfix">
                                                    </div>
                                                </div>

                                                <div class="x_content">
                                                    <div class="row" style="margin-top: 8px">
                                                        <div class="form-group col-md-12 col-sm-12 col-xs-12">
                                                            <div class="col-md-12 col-sm-12 col-xs-12">
                                                                <select id="lista_Programados" class="form-control col-md-12 col-sm-12 col-xs-12" style="margin-top: 2px; text-align: left;" required>
                                                                    <option selected value="">Elija una opción...</option>
                                                                </select>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="col-md-2 col-sm-2 col-xs-12">
                                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                                <div class="x_title">
                                                    <h2>
                                                        <font style="font-size: 14px"><b>Por Clientes</b></font>
                                                    </h2>
                                                    <div class="clearfix">
                                                    </div>
                                                </div>
                                                <div class="x_content">
                                                    <div class="row" style="margin-top: 8px">
                                                        <div class="form-group col-md-5 col-sm-5 col-xs-12" style="text-align: right;">
                                                            <div class="col-md-12 col-sm-12 col-xs-12">
                                                                <input type="number" id="dni_cliente" placeholder="DNI / RUC" class="form-control col-md-12 col-xs-12" onkeyup="f_BuscarClientes(1)" style="width: 140px;">
                                                            </div>
                                                        </div>

                                                        <div class="form-group col-md-7 col-sm-7 col-xs-12" style="text-align: left;">
                                                            <div class="col-md-12 col-sm-12 col-xs-12">
                                                                <input type="text" id="nom_cliente" placeholder="Nombre de Cliente" class="form-control col-md-12 col-xs-12" onkeyup="f_BuscarClientes(2)">
                                                            </div>
                                                        </div>
                                                    </div>

                                                    <div class="row" id="div_buscarclientes" style="display: none;">
                                                        <div class="row" style="background-color: #9CB6D9; height: 30px; border: solid; border-width: 1px; border-color: #829BCD; border-radius: 7px; text-align: center;">
                                                            <label style="margin-top: -5px"><h2><b><font color="#ffffff" style="font-size: 15px">
                                                                Búsqueda de Clientes
                                                            </font></b></h2></label>
                                                        </div>

                                                        <div class="row" id="div_sinclientes" style="border: solid; border-width: 1px; border-color: #D9D9D9; background-color: #F22727; color: #ffffff"><center>
                                                            No se encontraron resultados
                                                        </center></div>

                                                        <div class="row" style="overflow: auto; height: 150px">
                                                            <table class="table table-striped jambo_table bulk_action">
                                                                <thead>
                                                                    <tr>
                                                                        <th style="width: 2%"><center>
                                                                            Item
                                                                        </center></th>
                                                                        <th style="width: 18%"><center>
                                                                            DNI / RUC
                                                                        </center></th>
                                                                        <th style="width: 80%"><center>
                                                                            Nombres
                                                                        </center></th>
                                                                    </tr>
                                                                </thead>

                                                                <tbody id="tabla_busquedaclientes">
                                                                    
                                                                </tbody>
                                                            </table>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="col-md-2 col-sm-2 col-xs-12">
                                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                                <div class="x_title">
                                                    <h2>
                                                        <font style="font-size: 14px"><b>Por Sucursal</b></font>
                                                    </h2>
                                                    <div class="clearfix">
                                                    </div>
                                                </div>

                                                <div class="x_content">
                                                    <div class="row" style="margin-top: 8px">
                                                        <div class="form-group col-md-12 col-sm-12 col-xs-12">
                                                            <div class="col-md-12 col-sm-12 col-xs-12">
                                                                <select id="lista_sucursal" class="form-control col-md-12 col-sm-12 col-xs-12" style="margin-top: 2px; text-align: left;" required>
                                                                    <option selected value="">Elija una opción...</option>

                                                                    <?php
                                                                        $s = 1;

                                                                        $q_sucursal = "SELECT   Id,
                                                                                                des_sucursal
                                                                                         FROM   _max_labperu_Sucursales
                                                                                        WHERE   estado_sucursal = 'A'";

                                                                        if ($res_sucursal = sqlsrv_query($enlacehost, $q_sucursal)) {
                                                                            while($row_sucursal = sqlsrv_fetch_array($res_sucursal)) {
                                                                                echo '<option value="'.$row_sucursal["Id"].'">'.$row_sucursal["des_sucursal"].'</option>';

                                                                                 $s += 1;
                                                                            }
                                                                        }
                                                                    ?>

                                                                </select>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="col-md-2 col-sm-2 col-xs-12">
                                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                                <div class="x_title">
                                                    <h2>
                                                        <font style="font-size: 14px"><b>Por Nombre Muestra</b></font>
                                                    </h2>
                                                    <div class="clearfix">
                                                    </div>
                                                </div>

                                                <div class="x_content">
                                                    <div class="row" style="margin-top: 8px">
                                                        <div class="form-group col-md-12 col-sm-12 col-xs-12" style="text-align: left;">
                                                            <div class="col-md-12 col-sm-12 col-xs-12">
                                                                <input type="text" id="nom_muestra" placeholder="Nombre Muestra" class="form-control col-md-12 col-xs-12">
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="col-md-10 col-sm-10 col-xs-10">
                                            <button class="btn btn-success" type="button" onclick="f_LoadResultados()" style="width: 100%; background-color: #26B99A">
                                                 <b>Ejecutar Búsqueda</b>
                                            </button>
                                        </div>

                                        <div class="col-md-2 col-sm-2 col-xs-2">
                                            <button class="btn btn-success" type="button" onclick="f_ClearBusqueda()" style="width: 100%; background-color: #3D3D3D;">
                                                 <b>Limpiar Búsqueda</b>
                                            </button>
                                        </div>

                                        <div class="col-md-12 col-sm-12 col-xs-12" style="margin-top: 10px">
                                            <div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
                                                <div class="x_title">
                                                    <div class="col-md-8 col-sm-8 col-xs-8">
                                                        <h2>
                                                            Seguimiento de Programados vs. Análisis
                                                        </h2>
                                                    </div>

                                                    <div class="col-md-4 col-sm-4 col-xs-4">
                                                        <div class="col-md-4 col-sm-4 col-xs-12">
                                                            <label>
                                                              <input id="chk_radio1" type="radio" name="iCheck" checked onclick="f_LoadResultados('chk', 1)"> Programados
                                                            </label>
                                                        </div>
                                                        <div class="col-md-4 col-sm-4 col-xs-12">
                                                            <label>
                                                              <input id="chk_radio2" type="radio" name="iCheck" onclick="f_LoadResultados('chk', 2)"> No Programados
                                                            </label>
                                                        </div>
                                                        <div class="col-md-4 col-sm-4 col-xs-12">
                                                            <label>
                                                              <input id="chk_radio3" type="radio" name="iCheck" onclick="f_LoadResultados()"> Todos
                                                            </label>
                                                        </div>
                                                    </div>

                                                    <div class="clearfix">
                                                    </div>
                                                </div>

                                                <div class="x_content">
                                                    <div class="col-md-12 col-sm-12 col-xs-12">
                                                        <div class="table-box" style="height: 1000px; overflow-y: scroll;">
                                                            <table class="table table-striped jambo_table bulk_action">
                                                                <thead>
                                                                    <tr>
                                                                        <th rowspan="2" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; border-top-left-radius: 15px;"><center>
                                                                            Item
                                                                        </center></th>
                                                                        <th rowspan="2" style=" border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle;"><center>
                                                                            Muestra
                                                                        </center></th>
                                                                        <th rowspan="2" style=" border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #4C5661;"><center>
                                                                            Programa
                                                                        </center></th>
                                                                        <th colspan="5" style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; background-color: #049DBF;"><center>
                                                                            Fundición
                                                                        </center></th>
                                                                    </tr>

                                                                    <tr>
                                                                        <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 230px; background-color: #12537E;"><center>
                                                                            Rack
                                                                        </center></th>
                                                                        <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 80px;"><center>
                                                                            Régulo
                                                                        </center></th>
                                                                        <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 80px;"><center>
                                                                            Doré
                                                                        </center></th>
                                                                        <th style="background-color: #049DBF; border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 80px;"><center>
                                                                            Oro
                                                                        </center></th>
                                                                        <th style="border: solid; border-width: 1px; border-color: #ffffff; vertical-align: middle; width: 80px; background-color: #D95252;"><center>
                                                                            Reanálisis
                                                                        </center></th>
                                                                    </tr>
                                                                </thead>

                                                                <tbody id="tbl_Seguimiento">
                                                                    
                                                                </tbody>
                                                            </table>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- Ventanas modal -->
        <div id="divmodal_programa" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false">
            <div class="modal-dialog" style="width: 40%; margin-top: 12%; margin-left: 30%">
                <!-- Modal content-->
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal">
                            &times;
                        </button>

                        <h4 class="modal-title"><b>
                            Configuración de Programa
                        </b></h4>
                    </div>

                    <div class="modal-body">
                        <div class="row" style="text-align: center;">
                            <label class="control-label" style="margin-top: 6px">
                                Usted a seleccionado: <b><span id="count_selected" style="margin-left: 5px; font-size: 16px; color: #D95252;"></span></b> registros
                            </label>
                        </div>

                        <div class="row" style="margin-top: 15px; border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px; background-color: #D95252; color: #ffffff;">
                            <div class="form-group col-md-12 col-sm-12 col-xs-12" style="margin-top: 10px;">
                                <label class="control-label col-md-4 col-sm-4 col-xs-4" style="text-align: right; margin-top: 6px">
                                    Ingrese el periodo a programar
                                </label>
                                <div class="col-md-4 col-sm-4 col-xs-4"><b>
                                    <?php
                                        date_default_timezone_set("America/Lima"); 
                                        $fecha = date('Y-m-d');
                                    ?>
                                    <input type="date" class="form-control col-md-12 col-xs-12" id="fecha_programa" value="<?php echo $fecha; ?>"/>
                                </b></div>
                                <div class="col-md-4 col-sm-4 col-xs-4"><b>
                                    <input type="time" class="form-control col-md-12 col-xs-12" id="hora_programa"/>
                                </b></div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="ln_solid"></div>
                        </div>

                        <div class="row">
                            <div class="form-group"><center>
                                <div class="col-md-12 col-sm-12 col-xs-12">
                                    <button class="btn btn-dark" type="button" onclick="f_cerrarModal(1)">
                                        Cancelar
                                    </button>
                                    <button class="btn btn-success" type="button" onclick="f_GrabarPrograma()">
                                        Grabar
                                    </button>
                                </div>
                            </center></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div id="divmodal_Loading" class="modal fade" role="dialog" data-backgrop="static" data-keyboard="false" style="margin-top: 300px;">
            <div class="modal-dialog" style="height: 200px; opacity: 0.5;"><center>
                <img src="images/loading.gif" width="200px" style="border: solid; border-width: 1px; border-color: #D9D9D9;  border-radius: 15px;"></img>
            </center></div>
        </div>

        <!-- jQuery -->
        <script src="../vendors/jquery/dist/jquery.min.js"></script>
        <!-- Bootstrap -->
        <script src="../vendors/bootstrap/dist/js/bootstrap.min.js"></script>
        <!-- FastClick -->
        <script src="../vendors/fastclick/lib/fastclick.js"></script>
        <!-- NProgress -->
        <script src="../vendors/nprogress/nprogress.js"></script>
        <!-- Ion.RangeSlider -->
        <script src="../vendors/ion.rangeSlider/js/ion.rangeSlider.min.js"></script>
        <!-- Bootstrap Colorpicker -->
        <script src="../vendors/mjolnic-bootstrap-colorpicker/dist/js/bootstrap-colorpicker.min.js"></script>
        <!-- Custom Theme Scripts -->
        <script src="../build/js/custom.min.js"></script>

        <!-- bootstrap-daterangepicker -->
        <script src="../vendors/moment/min/moment.min.js"></script>
        <script src="../vendors/bootstrap-daterangepicker/daterangepicker.js"></script><!-- Datatables -->
        <script src="../vendors/datatables.net/js/jquery.dataTables.min.js"></script>
        <script src="../vendors/datatables.net-bs/js/dataTables.bootstrap.min.js"></script>
        <script src="../vendors/datatables.net-buttons/js/dataTables.buttons.min.js"></script>
        <script src="../vendors/datatables.net-buttons-bs/js/buttons.bootstrap.min.js"></script>
        <script src="../vendors/datatables.net-buttons/js/buttons.flash.min.js"></script>
        <script src="../vendors/datatables.net-buttons/js/buttons.html5.min.js"></script>
        <script src="../vendors/datatables.net-buttons/js/buttons.print.min.js"></script>
        <script src="../vendors/datatables.net-fixedheader/js/dataTables.fixedHeader.min.js"></script>
        <script src="../vendors/datatables.net-keytable/js/dataTables.keyTable.min.js"></script>
        <script src="../vendors/datatables.net-responsive/js/dataTables.responsive.min.js"></script>
        <script src="../vendors/datatables.net-responsive-bs/js/responsive.bootstrap.js"></script>
        <script src="../vendors/datatables.net-scroller/js/dataTables.scroller.min.js"></script>
        <script src="../vendors/jszip/dist/jszip.min.js"></script>
        <script src="../vendors/pdfmake/build/pdfmake.min.js"></script>
        <script src="../vendors/pdfmake/build/vfs_fonts.js"></script>

        <!-- Ventanas modales -->

        <!-- Funciones de Búsqueda -->
        <script type="text/javascript">
            // Buscando Clientes
                function f_BuscarClientes(tipo_busqueda){
                    var compania = <?php echo $_SESSION["bdOmar_Compania"]; ?>;
                    var htmlContenido = '';

                    if (tipo_busqueda == 1 || tipo_busqueda == 2){
                        var str_busqueda = ((tipo_busqueda == 1) ? $("#dni_cliente").val() : $("#nom_cliente").val());

                        $("#tabla_busquedaclientes").html(htmlContenido);
                    }
                    else{
                        var str_busqueda = ((tipo_busqueda == 3) ? $("#cliente_dni").val() : $("#cliente_nombre").val());

                        $("#tabla_busquedaclientes2").html(htmlContenido);
                    }

                    var c = 1;

                    $.post( "ajax/encuesta.php", { accion: "Get_Clientes", idCompany: compania, tipo_filtro: tipo_busqueda, filtro: str_busqueda }, 
                        function( data ) {
                            if(data.estado == 1){
                                $.each( data.registros, function( key, val ) {
                                    htmlContenido += '<tr style="cursor: pointer" onclick="f_AddCliente(' + tipo_busqueda + ', ' + val.iIdCliente + ', ' + val.cNumeroRuc + ", '" + val.cRazonSocial + "', " + val.id_Tipo_Documento + ", " + val.id_doc_sunat + ')">';

                                    htmlContenido += "  <td>" + c + "</td>";
                                    htmlContenido += "  <td><center>" + val.cNumeroRuc + "</center></td>";
                                    htmlContenido += "  <td>" + val.cRazonSocial + "</td>";

                                    htmlContenido += "</tr>";

                                    c += 1;
                                });
                            }

                            if (tipo_busqueda == 1 || tipo_busqueda == 2){
                                $("#tabla_busquedaclientes").html(htmlContenido);

                                 if (c == 1){
                                    f_CerrarDiv('A', 'div_sinclientes');
                                }
                                else{
                                    f_CerrarDiv('C', 'div_sinclientes');
                                }
                            }
                            else{
                                $("#tabla_busquedaclientes2").html(htmlContenido);

                                 if (c == 1){
                                    f_CerrarDiv('A', 'div_sinclientes2');
                                }
                                else{
                                    f_CerrarDiv('C', 'div_sinclientes2');
                                }
                            }

                        }, "json");

                    if (tipo_busqueda == 1 || tipo_busqueda == 2){
                        f_CerrarDiv('A', 'div_buscarclientes');
                    }
                    else{
                        f_CerrarDiv('A', 'div_buscarclientes2');
                    }
                };

            // Cargando Resultados
                function f_LoadResultados(_type = '', _item){
                    var htmlContenido = '';

                    if (_type != 'chk'){
                        if ($("#chk_radio1").prop('checked')){
                            _type = 'chk';
                            _item = 1;
                        }

                        if ($("#chk_radio2").prop('checked')){
                            _type = 'chk';
                            _item = 2;
                        }
                    }

                    // Obteniendo filtros
                        var fecha_inicio = $("#fecha_inicio").val();
                        var fecha_fin = $("#fecha_fin").val();
                        var dni_cliente = $("#dni_cliente").val();
                        var nom_cliente = $("#nom_cliente").val();
                        var sucursal = $("#lista_sucursal").val();
                        var nom_muestra = $("#nom_muestra").val();
                        var num_informe = $("#num_informe").val();

                    // Validando ingreso de filtros
                        if (fecha_inicio == null){
                            alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                            return;
                        }
                        if (fecha_inicio.length == 0){
                            alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                            return;
                        }

                        if (fecha_fin == null){
                            alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                            return;
                        }
                        if (fecha_fin.length == 0){
                            alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                            return;
                        }

                        if (fecha_fin < fecha_inicio){
                            alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

                            return;
                        }

                    // Obteniendo filtros principales
                        var filtro_programados = $("#lista_Programados").val();

                        var hora_inicio = $("#hora_inicio").val();
                        var hora_fin = $("#hora_fin").val();

                    // Loading Modal
                        var modal_loading = $("#divmodal_Loading");
                        modal_loading.modal({backdrop: 'static', keyboard: false});

                    // Carga resultados
                        var c = 1;
                        var _visible = 0;
                        var _id_rack = 0;

                        $("#tbl_Seguimiento").html(htmlContenido);

                        $.post( "ajax/encuesta.php", { accion: "Get_ListaProgramaDiario_Seguimiento", fecha_inicio: fecha_inicio, fecha_fin: fecha_fin, dni_cliente: dni_cliente, nom_cliente: nom_cliente, Sucursal: sucursal, nom_muestra: nom_muestra, num_informe: num_informe, filtro_programados: filtro_programados, type: _type, item: _item }, 
                            function( data ) {
                                if(data.estado == 1){
                                    $.each( data.registros, function( key, val ) {
                                        htmlContenido += '<tr>';

                                        htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: right">' + c + '</td>';

                                        if (val.ID_RACK == '999.999'){
                                            htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; color: #3F4242; text-align: center; font-weight: 700">' + val.Nom_Muestra + '</td>';
                                        }
                                        else{
                                            // if ((_id_rack != val.ID_RACK) && val.is_Newmont == 0){
                                            //     htmlContenido += '  <td rowspan="' + val._COUNT + '" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; color: #3F4242; text-align: center; font-weight: 700">' + val.Nom_Muestra + '</td>';
                                            // }
                                            // else{
                                            //     if (val.is_Newmont == 1){
                                                    htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; color: #3F4242; text-align: center; font-weight: 700">' + val.Nom_Muestra + '</td>';
                                                // }
                                            // }
                                        }

                                        // if (val.ID_RACK == '999.999'){
                                        //     htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; color: #3F4242; text-align: center; font-weight: 700"></td>';
                                        // }
                                        // else{
                                            // if (_id_rack != val.ID_RACK){
                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; font-weight: 700; ' + ((val.PROGRAMA == null) ? 'color: #D95252' : '') + '">' + ((val.PROGRAMA == null) ? 'Sin Programa' : val.PROGRAMA) + '</td>';
                                            // }
                                        // }

                                        if (val.ID_RACK == '999.999'){
                                            htmlContenido += '  <td colspan="5" style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-align: center; background-color: #D95252; color: #ffffff;">Muestra pendiente de ser registrada en un Rack</td>';
                                        }
                                        else{
                                            // if (_id_rack != val.ID_RACK){
                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-transform: uppercase;">';
                                                htmlContenido += '      Nombre: <b>' + val.nom_rack + '</b><br>';
                                                htmlContenido += '      Usuario Creación: <b>' + val.usuario_rack + '</b><br>';
                                                htmlContenido += '      Fecha Creación: <b>' + val.fecha_rack + '</b><br>';
                                                htmlContenido += '  </td>';

                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-transform: uppercase; text-align: center;">';
                                                htmlContenido += '      <input type="checkbox" ' + ((val.cierre_pesoregulo == 1) ? 'checked' : '') + ' disabled style="transform: scale(1.5);">';
                                                htmlContenido += '  </td>';

                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-transform: uppercase; text-align: center;">';
                                                htmlContenido += '      <input type="checkbox" ' + ((val.cierre_pesodore == 1) ? 'checked' : '') + ' disabled style="transform: scale(1.5);">';
                                                htmlContenido += '  </td>';

                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-transform: uppercase; text-align: center;">';
                                                htmlContenido += '      <input type="checkbox" ' + ((val.cierre_pesoau == 1) ? 'checked' : '') + ' disabled style="transform: scale(1.5);">';
                                                htmlContenido += '  </td>';

                                                htmlContenido += '  <td style="cursor: pointer; border: solid; border-width: 1px; border-color: #D9D9D9; vertical-align: middle; text-transform: uppercase; text-align: center;">';
                                                htmlContenido += '      <input type="checkbox" ' + ((val.is_Reanalisis == 1) ? 'checked' : '') + ' disabled style="transform: scale(1.5);">';
                                                htmlContenido += '  </td>';
                                            // }
                                        }

                                        htmlContenido += "</tr>";

                                        _id_rack = val.ID_RACK;

                                        c += 1;
                                    });
                                }
                                else{
                                    alert("No se encontraron resultados para la búsqueda solicitada");
                                }

                                // Cerrando Modal
                                    $('#divmodal_Loading').modal('hide');

                                $("#tbl_Seguimiento").html(htmlContenido);
                            }, "json");
                };

            // Cargando Lista de Fechas Programadas
                function f_CargaFechasProgramadas(){
                    var fecha_inicio = $("#fecha_inicio").val();
                    var fecha_fin = $("#fecha_fin").val();
                    var dni_cliente = $("#dni_cliente").val();
                    var nom_cliente = $("#nom_cliente").val();
                    var sucursal = $("#lista_sucursal").val();
                    var nom_muestra = $("#nom_muestra").val();
                    var num_informe = $("#num_informe").val();

                    var html_programados = '<option selected value="">Elija una opción...</option>';

                    $("#lista_Programados").html(html_programados);

                    // Validando ingreso de filtros
                        if (fecha_inicio == null){
                            alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                            return;
                        }
                        if (fecha_inicio.length == 0){
                            alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

                            return;
                        }

                        if (fecha_fin == null){
                            alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                            return;
                        }
                        if (fecha_fin.length == 0){
                            alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

                            return;
                        }

                        if (fecha_fin < fecha_inicio){
                            alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

                            return;
                        }

                    $.post( "ajax/encuesta.php", { accion: "Get_ListaVentasProgramados_Programados", fecha_inicio: fecha_inicio, fecha_fin: fecha_fin, dni_cliente: dni_cliente, nom_cliente: nom_cliente, Sucursal: sucursal, nom_muestra: nom_muestra, num_informe: num_informe }, 
                        function( data2 ) {
                            if(data2.estado == 1){
                                $.each( data2.registros, function( key, val2 ) {
                                    html_programados += '<option value="' + val2.FECHA_PROGRAMA + '">' + val2.FECHA_PROGRAMA + '</option>';

                                });
                            }
                            // else{
                            //     alert("No se encontraron resultados para la búsqueda solicitada");
                            // }

                            // Cerrando Modal
                                $('#divmodal_Loading').modal('hide');

                            $("#lista_Programados").html(html_programados);
                        }, "json");
                }

            // Filtrando por intervalo de horas
                function f_BuscarIntervaloHoras(){
                    var hora_inicio = $("#hora_inicio").val();
                    var hora_fin = $("#hora_fin").val();

                    // Validando datos
                        if (hora_inicio == null){
                            alert('Debe ingresar la Hora de Inicio');

                            return;
                        }
                        if (hora_inicio.length == 0){
                            alert('Debe ingresar la Hora de Inicio');

                            return;
                        }

                        if (hora_fin == null){
                            alert('Debe ingresar la Hora de Fin');

                            return;
                        }
                        if (hora_fin.length == 0){
                            alert('Debe ingresar la Hora de Fin');

                            return;
                        }

                        hora_inicio = '1981-02-12 ' + hora_inicio;
                        hora_fin = '1981-02-12 ' + hora_fin;

                        if (hora_fin < hora_inicio){
                            alert('La Hora de Fin no puede ser menor a la Hora de Inicio.\nPor favor, verificar.');

                            return;
                        }

                    f_LoadResultados();
                };
        </script>

        <!-- Funciones Principales -->
        <script type="text/javascript">
            function f_OpenPrograma(){
                // Validando datos
                    var _selected = 0;
                    var d = 1;
                    _selectedCI = '';

                    $('#tbl_Seguimiento tr').each(function () {
                        if ($("#chk_Programa_" + d).prop('checked')){
                            _selectedCI += "'" + $(this).find("td").eq(6).html() + "', ";

                            _selected += 1;
                        }

                        d += 1;
                    });

                    if (_selected == 0){
                        alert("Debe seleccionar al menos un registro.");

                        return;
                    }
                    else{
                        _selectedCI = _selectedCI.substring(0, _selectedCI.length - 2);
                    }

                // Abriendo pantalla
                    var modal = $("#divmodal_programa");

                    $("#count_selected").html(_selected);

                    modal.modal({backdrop: 'static', keyboard: false});
            };

            function f_GrabarPrograma(){
                var _fecha_programa = $("#fecha_programa").val();
                var _hora_programa = $("#hora_programa").val();

                // Validando datos
                    if (_fecha_programa == null){
                        alert("Debe seleccionar la Fecha del Programa");

                        return;
                    }
                    if (_fecha_programa.length == 0){
                        alert("Debe seleccionar la Fecha del Programa");

                        return;
                    }

                    if (_hora_programa == null){
                        alert("Debe seleccionar la hora del Programa");

                        return;
                    }
                    if (_hora_programa.length == 0){
                        alert("Debe seleccionar la hora del Programa");

                        return;
                    }

                    var fechaX = _fecha_programa + ' ' + _hora_programa;
                    var fechaZ = '<?php echo $g_fecha ?>';

                    if (fechaX < fechaZ){
                        alert("La Fecha y Hora de Programa no puede ser menor a la Fecha y Hora actual.");

                        return;
                    }

                // Loading Modal
                    var modal_loading = $("#divmodal_Loading");
                    modal_loading.modal({backdrop: 'static', keyboard: false});

                // Grabando datos
                    $.post( "ajax/encuesta.php", { accion: "Grabar_ProgramaDiario", fecha_programa: _fecha_programa, hora_programa: _hora_programa, selected_CI: _selectedCI },
                        function( data ) {
                            if(data.estado == 1){
                                f_LoadResultados();

                                f_cerrarModal(1);
                            }
                            else{
                                alert("Ocurrió un error al momento de grabar el nuevo Cliente");
                            }

                            // Cerrando Modal
                                $('#divmodal_Loading').modal('hide');

                        }, "json");
            };
        </script>

        <!-- Funciones Secundarias -->
        <script type="text/javascript">
            function f_CheckAll(){
                var _check = false;
                var d = 1;

                if ($("#chek_All").prop('checked')){
                    _check = true;
                }

                $('#tbl_Seguimiento tr').each(function () {
                    $("#chk_Programa_" + d).prop('checked', _check);

                    d += 1;
                });
            };

        // Clear Programados
            function f_ClearProgramados(_x){
                if (_x == 1){
                    $("#lista_Programados").val('');
                }
                else{
                    $("#hora_inicio").val('');
                    $("#hora_fin").val('');
                }
            }
        </script>

        <!-- Otras Funciones -->
        <script type="text/javascript">
            // Cerrar Div's
                function f_CerrarDiv(accion, nom_div){
                    var _div = document.getElementById(nom_div);

                    if (accion == 'A'){
                        _div.style.display = 'block'
                    }
                    else{
                         _div.style.display = 'none';
                    }
                };
            // Cerrar ventanas modales
                function f_cerrarModal(pantalla_modal){
                    if (pantalla_modal == 1){
                        $('#divmodal_programa').modal('hide');
                    }
                };

            // Limpiar controles de búsqueda
                function f_ClearBusqueda(){
                    // var fecha = new Date();

                    // fecha = fecha.getFullYear() + '-' + (((fecha.getMonth() + 1).toString().length == 1) ? '0' + (fecha.getMonth() + 1) : (fecha.getMonth() + 1)) + '-' + fecha.getDate();

                    // $("#fecha_inicio").val(fecha);
                    // $("#fecha_fin").val(fecha);
                    $("#dni_cliente").val('');
                    $("#nom_cliente").val('');
                    $("#lista_sucursal").val('');
                    $("#nom_muestra").val('');
                    $("#num_informe").val('');
                }

            window.addEventListener("keyup",function(e){
                if(e.keyCode==27) {
                    f_CerrarDiv('C', 'div_buscarclientes');
                    f_CerrarDiv('C', 'div_buscarclientes2');
                    f_CerrarDiv('C', 'div_RowAddElementos');
                }
            });
        </script>
    </body>
</html>

<?php
    cerrarSesion($enlace);
?>