<?php
	
	session_start();

	include('../../php/conn.php');

	if(!isset($_SESSION["id"])){
		header('Location: index.php');
	}

	mysqli_query($enlace, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");
	mysqli_query($enlacehost, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");

?>

<!DOCTYPE html>
<html lang="es">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<!-- Meta, title, CSS, favicons, etc. -->
		<meta charset="utf-8">
		<meta http-equiv="X-UA-Compatible" content="IE=edge">
		<meta name="viewport" content="width=device-width, initial-scale=1">

		<title>LIMS | Resumen de Pesos AAS</title>

		<!-- Bootstrap -->
		<link href="../vendors/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet">
		<!-- Font Awesome -->
		<link href="../vendors/font-awesome/css/font-awesome.min.css" rel="stylesheet">
		<!-- NProgress -->
		<link href="../vendors/nprogress/nprogress.css" rel="stylesheet">
		<!-- iCheck -->
		<link href="../vendors/iCheck/skins/flat/green.css" rel="stylesheet">
		<!-- bootstrap-progressbar -->
		<link href="../vendors/bootstrap-progressbar/css/bootstrap-progressbar-3.3.4.min.css" rel="stylesheet">
		<!-- JQVMap -->
		<link href="../vendors/jqvmap/dist/jqvmap.min.css" rel="stylesheet"/>
		<!-- bootstrap-daterangepicker -->
		<link href="../vendors/bootstrap-daterangepicker/daterangepicker.css" rel="stylesheet">
		<!-- Ion.RangeSlider -->
		<link href="../vendors/normalize-css/normalize.css" rel="stylesheet">
		<link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.css" rel="stylesheet">
		<link href="../vendors/ion.rangeSlider/css/ion.rangeSlider.skinFlat.css" rel="stylesheet">
		<!-- Bootstrap Colorpicker -->
		<link href="../vendors/mjolnic-bootstrap-colorpicker/dist/css/bootstrap-colorpicker.min.css" rel="stylesheet">
		<link href="../vendors/cropper/dist/cropper.min.css" rel="stylesheet">
		<!-- Datatables -->
		<link href="../vendors/datatables.net-bs/css/dataTables.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-buttons-bs/css/buttons.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-fixedheader-bs/css/fixedHeader.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-responsive-bs/css/responsive.bootstrap.min.css" rel="stylesheet">
		<link href="../vendors/datatables.net-scroller-bs/css/scroller.bootstrap.min.css" rel="stylesheet">

		<!-- bootstrap-datetimepicker -->
		<link href="../vendors/bootstrap-datetimepicker/build/css/bootstrap-datetimepicker.css" rel="stylesheet">

		<!-- Switchery -->
		<link href="../vendors/switchery/dist/switchery.min.css" rel="stylesheet">

		<!-- Toggle Switch -->
		<link rel="stylesheet" type="text/css" href="bootstrap/css/bootstrap4-toggle.min.css">

		<!-- Custom Theme Style -->
		<link href="../build/css/custom.min.css" rel="stylesheet">

		<script type="text/javascript">
				let Rack_TotalRows = 0;
				let chkRack_Selected = '';
		</script>

		<style type="text/css">
				th {
						position: sticky;
						top: 0px;
						background-color: #12537E;
				}
		</style>
	</head>

	<body class="nav-md" onload="f_LoadResultados(1)" style="zoom: 80%">
		<div class="container body">
			<div class="main_container">
				<?php include('partes/sidebar.php'); ?>

				<!-- page content -->
				<div class="right_col" role="main">
					<div class="">
						<div id="row_Titulo" class="row">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
									<div class="x_title">
										<h2><b>
											Resumen de Pesos Newmont Preparación
										</b></h2>

										<div class="clearfix">
										</div>
									</div>

									<div class="x_content" style="margin-bottom: -10px;">
										<!-- Filtros -->
										<div class="col-md-12 col-sm-12 col-xs-12">
											<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
												<div class="x_title">
													<h2>
														<font style="font-size: 14px"><b>Búsqueda por rango de fechas</b></font>
													</h2>

													<div class="clearfix">
													</div>
												</div>
												<div class="x_content" style="margin-bottom: -10px;">
													<div class="form-group col-md-6 col-sm-6 col-xs-12">
														<label class="control-label col-md-5 col-sm-5 col-xs-12" style="margin-top: 6px; text-align: right;">
																Desde
														</label>
														<div class="col-md-7 col-sm-7 col-xs-12">
															<?php
																date_default_timezone_set("America/Lima"); 
																$time = date('Y-m-d');

																echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_inicio" value="'.$time.'"/>';
															?>
														</div>
													</div>

													<div class="form-group col-md-6 col-sm-6 col-xs-12">
														<label class="control-label col-md-3 col-sm-3 col-xs-12" style="margin-top: 6px; text-align: right;">
															Hasta
														</label>
														<div class="col-md-7 col-sm-7 col-xs-12">
															<?php
																echo '<input type="date" class="form-control col-md-12 col-xs-12" id="fecha_fin" value="'.$time.'"/>';
															?>
														</div>
													</div>
												</div>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>

						<div class="row">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<button class="btn btn-success" type="button" onclick="f_LoadResultados(0)" style="width: 100%; background-color: #26B99A">
									<b>Ejecutar Búsqueda</b>
								</button>
							</div>
						</div>

						<div class="row" style="margin-top: 10px">
							<div class="col-md-12 col-sm-12 col-xs-12">
								<div class="x_panel" style="border: solid; border-width: 1px; border-color: #D9D9D9; border-radius: 7px;">
									<div class="x_title">
										<h2 id="titulo_detalle" style="margin-top: 11px;">
											<b>Resumen</b>
										</h2>

										<div class="clearfix">
										</div>
									</div>

									<div class="x_content">
										<div class="col-md-10 col-sm-10 col-xs-10" style="margin-top: 15px;">
											<label>
												Total de Muestras:
											</label>
											<label id="lbl_TotalMuestras" style="color: #FF0005; font-size: 14px;">
												0
											</label>

											<label style="border-left: solid; border-left-color: #D9D9D9; border-left-width: 1px; padding-left: 5px;">
												Muestras Pendientes:
											</label>
											<label id="lbl_MuestrasPendientes" style="color: #FF0005; font-size: 14px;">
												0
											</label>
										</div>

										<div class="col-md-2 col-sm-2 col-xs-2" style="margin-top: -5px;">
											<button class="btn btn-success exportToExcel" type="button" style="width: 100%;" onclick="f_ExportToExcel()">
												<b>Descargar a Excel</b>
											</button>
										</div>

										<div id="div_tblresumen" class="table-box" style="height: 850px; width: 100%; overflow: scroll;">
											
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- jQuery -->
		<!-- <script src="../vendors/jquery/dist/jquery.min.js"></script> -->
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/2.2.4/jquery.min.js"></script>
		<!-- Bootstrap -->
		<script src="../vendors/bootstrap/dist/js/bootstrap.min.js"></script>
		<!-- Export 2 Excel -->
		<script src="libs/table2excel/jquery.table2excel.js"></script>
		<!-- FastClick -->
		<script src="../vendors/fastclick/lib/fastclick.js"></script>
		<!-- NProgress -->
		<script src="../vendors/nprogress/nprogress.js"></script>
		<!-- Ion.RangeSlider -->
		<script src="../vendors/ion.rangeSlider/js/ion.rangeSlider.min.js"></script>
		<!-- Bootstrap Colorpicker -->
		<script src="../vendors/mjolnic-bootstrap-colorpicker/dist/js/bootstrap-colorpicker.min.js"></script>
		<!-- Toggle Switch -->
		<script src="bootstrap/js/bootstrap4-toggle.min.js"></script>
		<!-- Custom Theme Scripts -->
		<script src="../build/js/custom.min.js"></script>

		<!-- bootstrap-daterangepicker -->
		<script src="../vendors/moment/min/moment.min.js"></script>
		<script src="../vendors/bootstrap-daterangepicker/daterangepicker.js"></script><!-- Datatables -->
		<script src="../vendors/datatables.net/js/jquery.dataTables.min.js"></script>
		<script src="../vendors/datatables.net-bs/js/dataTables.bootstrap.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/dataTables.buttons.min.js"></script>
		<script src="../vendors/datatables.net-buttons-bs/js/buttons.bootstrap.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/buttons.flash.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/buttons.html5.min.js"></script>
		<script src="../vendors/datatables.net-buttons/js/buttons.print.min.js"></script>
		<script src="../vendors/datatables.net-fixedheader/js/dataTables.fixedHeader.min.js"></script>
		<script src="../vendors/datatables.net-keytable/js/dataTables.keyTable.min.js"></script>
		<script src="../vendors/datatables.net-responsive/js/dataTables.responsive.min.js"></script>
		<script src="../vendors/datatables.net-responsive-bs/js/responsive.bootstrap.js"></script>
		<script src="../vendors/datatables.net-scroller/js/dataTables.scroller.min.js"></script>
		<script src="../vendors/jszip/dist/jszip.min.js"></script>
		<script src="../vendors/pdfmake/build/pdfmake.min.js"></script>
		<script src="../vendors/pdfmake/build/vfs_fonts.js"></script>

		<!-- Funciones Principales -->
		<script type="text/javascript">
			function f_LoadResultados(){
				var fecha_inicio = $("#fecha_inicio").val();
				var fecha_fin = $("#fecha_fin").val();

				// Validando ingreso de fechas
					if (fecha_inicio == null){
						alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

						return;
					}
					if (fecha_inicio.length == 0){
						alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

						return;
					}

					if (fecha_fin == null){
						alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

						return;
					}
					if (fecha_fin.length == 0){
						alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

						return;
					}

					if (fecha_fin < fecha_inicio){
						alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

						return;
					}

					// Cargando detalle de Análisis
						$("#div_tblresumen").html('');

					// Carga datos
						$.get( "../lims_api/index.php", { accion: "get_Newmont_PreparacionPesosResumen", fecha_inicio: fecha_inicio, fecha_fin: fecha_fin },
								function( data ) {
										if(data.estado == 1){
												$("#div_tblresumen").html(data.html);
												$("#lbl_TotalMuestras").html(data.total_detalle);
												$("#lbl_MuestrasPendientes").html(data.muestras_pendientes);
										}
										else{
												alert("No se encontraron resultados para la búsqueda solicitada");
										}

								}, "json");
			};

			function f_ExportToExcel(){
				// Validando la existencia de información
					var _html = $("#tbl_resumen").html().trim();

					if (_html.length == 0){
							return;
					}

				// Obteniendo filtros
					var fecha_inicio = $("#fecha_inicio").val();
					var fecha_fin = $("#fecha_fin").val();

				// Validar datos
					if (fecha_inicio == null){
						alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

						return;
					}
					if (fecha_inicio.length == 0){
						alert('La fecha "Desde" ingresada no es correcta.\nPor favor, verificar.');

						return;
					}

					if (fecha_fin == null){
						alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

						return;
					}
					if (fecha_fin.length == 0){
						alert('La fecha "Hasta" ingresada no es correcta.\nPor favor, verificar.');

						return;
					}

					if (fecha_fin < fecha_inicio){
						alert('La fecha "Desde" no puede ser mayor a la fecha "Hasta".\nPor favor, verificar.');

						return;
					}

				window.location.href = "send_to_excel/export_to_excel_resumennewmontpreparacion.php?fi="+fecha_inicio+"&ff="+fecha_fin;
			};
		</script>

		<!-- Funciones Secundarias -->
		<script type="text/javascript">

		</script>

		<!-- Funciones para Grabar -->
		<script type="text/javascript">

		</script>

		<!-- Otras Funciones -->
		<script type="text/javascript">
			$(document).ajaxStart(function() {
				// Loading Modal
				var modal_loading = $("#divmodal_Loading");
				modal_loading.modal({backdrop: 'static', keyboard: false});
			});

			$(document).ajaxStop(function() {
				// Cerrando Modal
				$('#divmodal_Loading').modal('hide');
			});

			function f_cerrarModal(pantalla_modal){
				if (pantalla_modal == 1){
					$('#divmodal_DetallesMuestra').modal('hide');
				}
				if (pantalla_modal == 2){
					$('#divmodal_DetallesRack').modal('hide');
				}
				if (pantalla_modal == 3){
					$('#divmodal_DetallesMuestra').modal('hide');
				}
			};

			function f_CerrarDiv(accion, nom_div){
				var _div = document.getElementById(nom_div);

				if (accion == 'A'){
					_div.style.display = 'block'
				}
				else{
					_div.style.display = 'none';
				}
			};

			// Limpia los datos al momento de Realizar la búsqueda de resultados
			function f_Limpiar(){
				// // Detalles del Rack
				//     $("#lblRack_totalmuestras").html('');
				//     $("#lblRack_usuario").html('');
				//     $("#lblRack_fechahora").html('');
				//     $("#lblRack_horno").html('');
				//     $("#lblRack_observacion").html('');
				//     document.getElementById('lblRack_observacion').title = '';

				// Grilla de Detalles de Rack
						$("#tbl_DetalleMuestras").html('');
			}

			// Permite obtener el nombre de cada mes
			function nombre_meses(_num_mes){
				if (_num_mes == 1){
					return "ENERO";
				}
				if (_num_mes == 2){
					return "FEBRERO";
				}
				if (_num_mes == 3){
					return "MARZO";
				}
				if (_num_mes == 4){
					return "ABRIL";
				}
				if (_num_mes == 5){
					return "MAYO";
				}
				if (_num_mes == 6){
					return "JUNIO";
				}
				if (_num_mes == 7){
					return "JULIO";
				}
				if (_num_mes == 8){
					return "AGOSTO";
				}
				if (_num_mes == 9){
					return "SEPTIEMBRE";
				}
				if (_num_mes == 10){
					return "OCTUBRE";
				}
				if (_num_mes == 11){
					return "NOVIEMBRE";
				}
				if (_num_mes == 12){
					return "DICIEMBRE";
				}
			}

			// Detecta la tecla ESCAPE
			document.addEventListener('keyup', function(e) {
				if (e.keyCode == 27) {
					f_cerrarModal(1);
					f_cerrarModal(2);
					f_cerrarModal(3);
				}
			});
		</script>
	</body>
</html>

<?php
	cerrarSesion($enlace);
?>